/**************************
	This file is copyrighted, but license is hereby granted for personal,
	academic, and non-profit use.
	Commercial users should contact Xin Zhou xzhou82@gmail.com for permission.
 **************************/

/***
unified track object for any types: registration / display objects
***/

/****    DOM objects that are frequently used
   need a clean up
 ****/
var browser=null; // the "main panel" browser object, as a global variable

var scalebar = {};
var geneplot={};
var msgconsole; // message console (but not text area anymore)
var floatingtoolbox;
var minichrcanvasdiv; // holding minichr canvas
var minichrrulerdiv; // holding minichr canvas
var minichrindicator; // blue box over minichr canvas indicating dsp
//var moveTrackCanvas; // rightmost canvas for moving individual tracks
var vrearrangeUtil = {which:0}; // vertical rearrange utils
var fadeinmode={}; // about fade-ins
var fadeoutmode={}; // about fade-ins

var appbutt;


/* key: gf name
val: {}
  label: 'print name'
  parent: might be undefined, use 'parent' in decorInfo to check
  grp: group id (-1 for custom track)
  ft:
  hasStruct: 0/1
  queryUrl: directly append gene name after it
  mode: M_mode
  tksentry: used as a hook to this track's <td> element in track selection panel

serves as registry for all decor tracks (bigbed and bigwig)
when a custom bigbed is uploaded, it will be in there
even if the track is closed, it shall not be removed
only if it is explicitly removed by user, shall its record be removed from here
 */


var stickynote = {'number':0};


/***  flags   ***/
var helpmsgshowing = false;
var sortTrackIdx = 0;
var currentPathway; // kegg pathway ID currently been displayed
var mdnotooltip = false; // don't pop up tooltip when dragging metadata color block



// Obsolete variables used for placing tooltip...
var iiX = 0; // for hm canvas
var iiiX; // for track attribute canvas
var iiY = 0;


var urlparamhelp='<a href=http://washugb.blogspot.com/2012/05/v2-code-release-url-parsing-and.html target=_blank>help&#8599;</a>';



function sumHmtkHeight() {
/* return variable argument
if no argument, will return sum of height for all tracks
else, the argument should be index of a track,
and sum of height for tracks before this one will be given
*/
	var stop;
	if(arguments[0] == undefined)
		stop = browser.gmlst.length;
	else
		stop = arguments[0];
	var h = 0;
	for(var i=0; i<stop; i++) {
		h+=browser.gmlst[i].hmC.height;
	}
	return h;
}
function sumTkheight_nonehmtk() {
/* all decors in main panel, with htest and pwc */
    return document.getElementById('tgt_decorCanvas').clientHeight +
	(pwc.inuse ? pwc.canvas.height : 0) +
	(htest.inuse ? htest.canvas.height : 0);
}





/* age-old, generic operations on DOM elements */
function checkChildRadio(event) { // not used?
    event.target.childNodes[0].checked = true;
}
function copylst_childnodes(domobj) {
    var lst = [];
    for(var i=0; i<domobj.childNodes.length; i++)
        lst.push(domobj.childNodes[i]);
    return lst;
}
function getClass_by_radioName(what) {
    var lst = document.getElementsByName(what);
    for(var i=0; i<lst.length; i++) {
	if(lst[i].checked) return lst[i].className;
    }
    fatalError("None of the options were checked for radio button "+what);
}


/***************************
  small targeted functions 
 ***************************/
function closeappPanel() {
    document.getElementById('appPanel').style.display = 'none';
    document.body.removeEventListener('mouseup', closeappPanel, false);
}
function launchappPanel(event) {
/* no way to get width/height of panel
use fixed value: width 250
update when entries are added/removed
*/
	if(apps.bev.style.display!='none'||
	apps.custtk.style.display!='none'||
	apps.gplot.style.display!='none'||
	apps.gsv.style.display!='none'||
	apps.hmtk.style.display!='none'||
	apps.session.style.display!='none'||
	apps.svg.style.display!='none') return;
	menu_shutup();
	menu.apppanel.style.display='block';
	menu.style.display='block';
	var pos=absolutePosition(event.target);
	menu.style.left=Math.min(pos[0], document.body.scrollWidth-250);
	menu.style.top=pos[1]+event.target.clientHeight;
	menu_show(17);
}
function panelFadeout(bigdom) {
// bigdom disappears at the given point
	var x1=parseInt(bigdom.style.left),y1=parseInt(bigdom.style.top);
	fadeoutmode={counter:96, dom:bigdom, };
	panelFadeout_do();
}
function panelFadeout_do() {
	if(fadeoutmode.counter<=0) {
		fadeoutmode.dom.style.display='none';
		return;
	}
	var pc=(100-(96-fadeoutmode.counter)/4)/100;
	var dom=fadeoutmode.dom;
	dom.style.webkitTransform=
	dom.style.transform=
	dom.style.mozTransform='scale('+pc+','+pc+')';
	dom.style.opacity=fadeoutmode.counter/100;
	fadeoutmode.counter-=8;
	setTimeout(panelFadeout_do,1);
	return;
}
function panelFadein(smalldom, x1,y1) {
	fadeinmode={counter:4,dom:smalldom,};
	smalldom.style.display='block';
	smalldom.style.left=x1;
	smalldom.style.top=y1;
	panelFadein_do();
}
function panelFadein_do() {
	var pc=(100-(96-fadeinmode.counter)/4)/100;
	var dom=fadeinmode.dom;
	dom.style.webkitTransform=
	dom.style.transform=
	dom.style.mozTransform='scale('+pc+','+pc+')';
	dom.style.opacity=fadeinmode.counter/100;
	if(fadeinmode.counter>=100) {
		dom.style.opacity=1;
		dom.style.webkitTransform=
		dom.style.transform=
		dom.style.mozTransform='scale(1,1)';
		return;
	}
	fadeinmode.counter+=8;
	setTimeout(panelFadein_do,1);
	return;
}

function getOnetrackdetails() {
/* display detail of one hmtk track in floating toolbox
variable argument
- by clicking on track label div on left of genome heatmap
arg is event object
- hmtk track name
 */
	if(arguments[0] == undefined)
		return;
	var tkname;
	if(typeof(arguments[0]) == "string")
		tkname = arguments[0];
	else
		tkname = arguments[0].target.tkname;
	getTrackdetail(tkname, dbInfo.name);
}

function toggleNextSibling(event) {
    var bait=event.target.nextSibling;
    bait.style.display= bait.style.display=='none' ? 'block' : 'none';
}
function toggleNextSibling2(event) {
    var bait=event.target.nextSibling.firstChild;
    bait.style.display= bait.style.display=='none' ? 'block' : 'none';
}
function toggle3(event) {
// show/hide species menu by clicking on <td> on banner
	if(event.target.id=='genomeinfobutt') return;
    var holder = document.getElementById('bait3');
    holder.style.display = 'block';
    var pos = absolutePosition(document.getElementById('genomelogoartholder'));
    holder.style.left = pos[0];
    document.body.addEventListener('mousedown', toggle3_2, false);
}
function toggle3_2() {document.getElementById('bait3').style.display='none';}
function toggle4()
{
/* toggle geneplot panel display */
if(apps.gplot.style.display == 'block') {
	pagecloak.style.display = 'none';
	panelFadeout(apps.gplot);
	return;
}
cloakPage();
panelFadein(apps.gplot, 100+document.body.scrollLeft, 100+document.body.scrollTop);
apps.gplot.style.display = "block";
gp_back2control();
}
function toggle4_gpStandalone() {
// for invoking geneplot panel in standalone mode
	geneplot.for=2;
	document.getElementById("geneplotforwhat").innerHTML = "for custom gene set";
	document.getElementById('gpStandalone_holder').style.display = 'block';
	document.getElementById("genesetfyi").style.display = 'none';
	menu_hide();
}
function toggle5() {
// use server metadata to annotate custom bigwig
    var bait = document.getElementById("bait5");
    var hook = document.getElementById("hook5");
    if(bait.style.display == "none") {
        bait.style.display = "block";
	hook.innerHTML = "&uarr; hide";
    } else {
        bait.style.display = "none";
	hook.innerHTML = "&darr; use metadata vocabulary provided here";
    }
}
function toggle16() {
    var bait = document.getElementById("bait16");
    if(bait.style.display == "none") {
        bait.style.display = "table";
    } else {
        bait.style.display = "none";
    }
}
function toggle17(event) {
// tabpage in bev genome panel
    var w = event.target.getAttribute('which');
	var old=document.getElementById('tabpage_bevg_tab'+w).className;
	document.getElementById('tabpage_bevg_content1').style.display='none';
	document.getElementById('tabpage_bevg_content2').style.display='none';
	document.getElementById('tabpage_bevg_content3').style.display='none';
	document.getElementById('tabpage_bevg_tab1').className='tabpageOff';
	document.getElementById('tabpage_bevg_tab2').className='tabpageOff';
	document.getElementById('tabpage_bevg_tab3').className='tabpageOff';
	if(old=='tabpageOff') {
		document.getElementById('tabpage_bevg_tab'+w).className='tabpageOn';
		document.getElementById('tabpage_bevg_content'+w).style.display='block';
	}
}
function toggle19(event) {
    var p = document.getElementById("bait19");
    if(p.style.display == 'none') {
        p.style.display = "block";
	event.target.innerHTML = "&#10005;";
    } else {
        p.style.display = "none";
	event.target.innerHTML = "help";
    }
}
function toggle21(event) {
    var butt = event.target;
    var ul = document.getElementById("geneplothelpmsg");
    if(ul.style.display == "none") {
        butt.innerHTML = "&#10005;";
	ul.style.display = "block";
    } else {
        butt.innerHTML = "having trouble?";
	ul.style.display = "none";
    }
}
function toggle23(event) {
    var d = document.getElementById("zerosdgeneholder");
    if(d.style.display == 'none') {
        event.target.innerHTML = "hide";
	d.style.display = "block";
    } else {
        event.target.innerHTML = "show";
	d.style.display = "none";
    }
}
function toggle24(event) {
    var s1 = document.getElementById("geneplot_s4_h_span");
    var s2 = document.getElementById("geneplot_s4_k_span");
    if(event.target.selectedIndex == 0) {
        s1.style.display = 'inline'
	s2.style.display = 'none'
    } else {
        s1.style.display = 'none'
	s2.style.display = 'inline'
    }
}
function toggle25()
{
// bigbed generator
var hook = document.getElementById('hook25');
var bait = document.getElementById('bait25');
if(bait.style.display == 'none') {
	cloakPage();
	hook.style.display = 'none';
	panelFadein(bait, 100+document.body.scrollLeft, 100+document.body.scrollTop);
} else {
	hook.style.display = 'inline-block';
	pagecloak.style.display = "none";
	panelFadeout(bait);
}
}
function toggle27() {
// show/hide message console
    var hook = document.getElementById('hook27');
    var bait = document.getElementById('bait27');
    if(bait.style.display == 'none') {
        bait.style.display = 'block';
	hook.style.display = 'none';
        msgconsole.scrollTop = 9999; // dummy
    } else {
        bait.style.display = 'none';
	hook.style.display = 'inline-block';
    }
}
function toggle28(event) {
// called by clicking the checkbox controling ideogram display
    var bait = event.target.nextSibling;
    if(event.target.selectedIndex == 0) {
        bait.style.display = "inline";
	for(var cn in bev.scfd.hash)
	    document.getElementById("bevideogram_"+cn).style.display = "block";
    } else {
        bait.style.display = "none";
	for(var cn in bev.scfd.hash)
	    document.getElementById("bevideogram_"+cn).style.display = "none";
    }
}
function toggle31(event) {
/* push button of scaffold sequences to mark for removal
in case of a to-be-added one, simply remove it
need to tell which scaffold holder is using
*/
    var tr = event.target.parentNode.parentNode;
    var holderid = parseInt(tr.parentNode.parentNode.getAttribute('holderid'));
    if(holderid!=1 && holderid!=2)
        fatalError('toggle31: unknown holderid');

    if(tr.marked) {
        tr.style.backgroundColor = 'white';
	event.target.innerHTML = '&#10005;';
	event.target.title = 'mark for removal';
	tr.marked = false;
    } else {
        if(holderid == 1) {
	    if(tr.seq in scaffold.toadd) {
	        // this seq is pending for adding, just remove it
		scaffold.cpholder.firstChild.removeChild(tr);
		delete scaffold.seq2tr[tr.seq];
		delete scaffold.toadd[tr.seq];
		return;
	    }
	} else {
	    if(tr.seq in bev.scfd.toadd) {
		bev.scfd.holder.firstChild.removeChild(tr);
		delete bev.scfd.seq2tr[tr.seq];
		delete bev.scfd.toadd[tr.seq];
		return;
	    }
	}
        tr.style.backgroundColor = '#e0e0e0';
	event.target.innerHTML = '&#10004;';
	event.target.title = 'unmark';
	tr.marked = true;
    }
    if(holderid == 1) {
	scaffold.updatebutt.style.display = 'inline';
	scaffold.updatebutt.style.backgroundColor = '#e0e0e0';
	document.getElementById('scaffold_cancelbutt').style.display = 'inline';
    } else {
        bev.scfd.updatebutt.style.display = 'inline';
	bev.scfd.updatebutt.style.backgroundColor = '#e0e0e0';
	document.getElementById('genomebevscfd_cancelbutt').style.display = 'inline';
    }
}
function toggle33(which) {
/* show svg output panel
which: 1 - main panel
2 - bev
3 - long-range small panel
*/
	var b1=document.getElementById('bait33_1');
	var b2=document.getElementById('bait33_2');
	var b3=document.getElementById('bait33_3');
	b1.style.display=b2.style.display=b3.style.display='none';
	if(which==1)
		b1.style.display='table';
	else
		fatalError('toggle33: unknown which');
}



/* associated with Information table */
function resize_informationTable() {
// call after stuffing things into trackdetailtable
    var table = document.getElementById('trackdetailtable');
    var d = table.parentNode;
    if(table.clientHeight > 250) {
        d.style.height = 250;
	d.style.overflowY = "scroll";
    } else {
        d.style.height = "auto";
	d.style.overflowY = "auto";
    }
}
function displayGenomeInfo() {
// called by clicking button, display info about this genome
	browser.ajax('getgenomeinfo=on&dbName='+browser.genome.name,function(data){
		document.getElementById('simpleinfowrapper').style.display='block';
		var table = document.getElementById('simpleinfotable');
		stripChild(table.firstChild, 0);
		var lst = data.info.split('|');
		var color = '#ededed';
		for(var i=0; i<lst.length; i+=2) {
			var tr = table.insertRow(-1);
			tr.style.backgroundColor = color;
			color = color=='transparent' ? '#ededed' : 'transparent';
			tr.insertCell(0).innerHTML = lst[i];
			tr.insertCell(1).innerHTML = lst[i+1];
		}
		//resize_informationTable();
	});
}


/* open manual functions and wrappers */
function openManual(what) {
    // called by clicking question mark sign
    window.open(window.location.href.split('?')[0]+"manual/#"+what);
}
function openManual_customtrack(event) {
    /* jumps to a chapter about one custom track file type
       event.target is ? button, .what is which chapter (cust track type) to go to
     */
    var what = event.target.what;
    if(what == undefined)
        what = "a"; // default is first one whatsoever
    window.open(window.location.href.split('?')[0]+"manual/#b-c-"+what);
}
function openManual_config(event) {
    /* jumps to a chapter, either config or misc functions
       event.target is ? button, .what is which chapter (cust track type) to go to
     */
    var what = event.target.what;
    if(what == undefined)
        what = "a"; // default is first one whatsoever
    window.open(window.location.href.split('?')[0]+"manual/#g-"+what);
}


function tabclick_geneset(what) {
    // what kind of geneset to submit
    document.getElementById("genesetwrapper_custom").style.display = "none";
    document.getElementById("genesettab_custom").className = "cptaboff";
    document.getElementById("genesetwrapper_kegg").style.display = "none";
    document.getElementById("genesettab_kegg").className = "cptaboff";
    document.getElementById("genesetwrapper_"+what).style.display = "block";
    document.getElementById("genesettab_"+what).className = "cptabon";
}
function tabclick_geneset2(what) {
    // available operations after submitting geneset
    document.getElementById("geneset2wrapper_addremove").style.display = "none";
    document.getElementById("geneset2tab_addremove").className = "cptaboff";
    document.getElementById("geneset2wrapper_changepart").style.display = "none";
    document.getElementById("geneset2tab_changepart").className = "cptaboff";
    document.getElementById("geneset2wrapper_sort").style.display = "none";
    document.getElementById("geneset2tab_sort").className = "cptaboff";
    //document.getElementById("geneset2wrapper_geneplot").style.display = "none";
    //document.getElementById("geneset2tab_geneplot").className = "cptaboff";
    document.getElementById("geneset2wrapper_"+what).style.display = "block";
    document.getElementById("geneset2tab_"+what).className = "cptabon";
    if(what == 'sort') {
        document.getElementById('genesetsortby0').checked = true;
	genesetsortbyChangeoption();
    }
}





/*********************************
      operations on
      positions & coordinates
 *********************************/
function leftwingAtborder() {
    // if left wing is at left border
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        return (regionLst[dspBoundary.lwr][6]==border.lname) && (regionLst[dspBoundary.lwr][3]<=border.lpos);
    } else {
        return (regionLst[dspBoundary.lwr][0]==border.lname) && (regionLst[dspBoundary.lwr][3]<=border.lpos);
    }
}
function rightwingAtborder() {
    // if right wing is at right border
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        return (regionLst[dspBoundary.rwr][6]==border.rname) && (regionLst[dspBoundary.rwr][4]>=border.rpos);
    } else {
        return (regionLst[dspBoundary.rwr][0]==border.rname) && (regionLst[dspBoundary.rwr][4]>=border.rpos);
    }
}


/*** _private_ functions ***/

function __jsonPageinit(data)
{
/* private stuff to do after json data is returned
*/
//document.getElementById("greetingmsg").innerHTML = data.greeting;
if('dblist' in data) {
	// stuff species menu
	var bait3 = document.getElementById('bait3');
	stripChild(bait3.firstChild, 0);
	for(var i=0; i<data.dblist.length; i++) {
		var v=data.dblist[i];
		if(v[0] == browser.genome.name) {
			document.getElementById('hook3').style.color=v[3];
			document.getElementById('hook3').innerHTML = v[1]+'&nbsp;&nbsp;&#9662;';
			document.getElementById('genomelogoartholder').style.backgroundImage="url('images/"+v[2]+".png')";
			continue;
		}
		var td = bait3.insertRow(-1).insertCell(0);
		td.className = 'headerTd2';
		td.style.backgroundImage = "url('images/"+v[2]+".png')";
		td.style.width='257px';
		td.style.color=v[3];
		td.innerHTML=v[1];
		td.dbname=v[0];
		td.addEventListener('click', changedb, false);
	}
}
if('serverload' in data) {
	var lst = data.serverload.split(' ');
	print2console(data.hostname+' load: '+lst[lst.length-3]+' '+lst[lst.length-2]+' '+lst[lst.length-1],1);
}

/*** highlight any new changes
bubble.says.innerHTML='<div style="padding:10px;padding-bottom:0px;color:white;font-size:18px;">Click here for Apps</div>';
bubble.sayajax.innerHTML='';
bubble.style.display='block';
var pos=absolutePosition(appbutt);
bubble.style.left=pos[0];
bubble.style.top=pos[1]+appbutt.clientHeight+5;
setTimeout("bubbleHide()",1300);
simulateEvent(appbutt,'mouseover');
setTimeout("simulateEvent(appbutt,'mouseout')", 300);
setTimeout("simulateEvent(appbutt,'mouseover')", 600);
setTimeout("simulateEvent(appbutt,'mouseout')", 900);
***/
/* over */
}


/*** _private_ ends ***/



function mayUpdateBorder(data) {
    if('border' in data) mustUpdateBorder(data);
}

function moveMergeNumericaldata(source, sink) {
    var oldlen = sink.length;
    var newlen = source.length;
    if(move.direction == null) {
        // replace old sink data with new data
	for(var i=0; i<newlen; i++)
	    sink[i] = source[i];
	if(oldlen > newlen) {
	    for(i=0; i<newlen-oldlen; i++)
	        sink.pop();
	}
    } else if(move.direction == 'l') {
	if(move.merge) {
	    var lastr = source[newlen-1];
	    sink[0] = lastr.concat(sink[0]);
	    source.pop();
	}
	for(var i=newlen-2; i>=0; i--)
	    sink.unshift(source[i]);
    } else {
	if(move.merge) {
	    sink[oldlen-1] = sink[oldlen-1].concat(source[0]);
	    source.shift();
	}
	for(var i=0; i<source.length; i++)
	    sink.push(source[i]);
    }
}




/*******************************
     CGI parameter composing
     these functions must return something, 
     or else "undefined" will show up in param string...
 *******************************/

function chiapetRegionParam() {
    // chrom, start, stop, spnum, joined by comma
    if(!chiapet.inuse) return '';
    var lst = [];
    for(var i=0; i<chiapet.viewlst.length; i++) {
        if(chiapet.viewlst[i]==undefined || chiapet.viewlst[i].type!=1) continue;
        var d = chiapet.datalst[i];
        lst.push(d.chrom+','+d.actualcoord[0]+','+d.actualcoord[1]+','+d.spnum);
    }
    if(lst.length==0) return '';
    return '&chiapetregion='+lst.join(',');
}
function hmtkChoice_htest() {
// categorical tracks are not involved in htest
	var alltk = [];
	for(var i=1; i<=htest.grpnum; i++) {
		alltk = alltk.concat(htest["gtn"+i]);
	}
	var ft2=[], ft3=[], ft14=[], ft15=[];
	for(var i=0; i<alltk.length; i++) {
		var obj = browser.findHmtk(alltk[i]);
		if(obj.ft==FT_bedgraph_c) {
			ft3.push(obj.url);
			ft3.push(obj.name);
		} else if(obj.ft==FT_bigwighmtk_c) {
			ft15.push(obj.url);
			ft15.push(obj.name);
		} else if(obj.ft==FT_bedgraph_n) {
			ft2.push(obj.name);
		} else if(obj.ft==FT_bigwighmtk_n) {
			ft14.push(obj.name);
		}
	}
	return (ft2.length>0 ? "&hmtk2="+ft2.join(",") : "") +
		   (ft3.length>0 ? "&hmtk3="+ft3.join(",") : "")+
		   (ft14.length>0 ? "&hmtk14="+ft14.join(",") : "")+
		   (ft15.length>0 ? "&hmtk15="+ft15.join(",") : "");
}

function cloak2(holder) {
    // only add the roller image
    var img = document.createElement("img");
    img.src = "images/loading.gif";
    img.name = "cloak";
    img.style.position = "absolute";
    if(holder.clientHeight > 128)
        img.style.top = (holder.clientHeight-128)/2;
    else
        img.style.top = 0;
    img.style.left = (holder.clientWidth-128)/2;
    img.style.opacity = 0.4;
    holder.appendChild(img);
}
function unveil(holder) {
    var c = holder.lastChild;
    if(c!=null && c.id!=undefined && c.name=='cloak')
	holder.removeChild(c);
}






function customtkregistry_click(event) {
	var d=event.target;
	if(d.tagName!='TD') d=d.parentNode;
	var p=d.parentNode.nextSibling;
	p.style.display=(p.style.display=='none') ? 'table-row' : 'none';
}




/*******************************
      JSON + trigger name
 ******************************/
function jsonHmtk(data) {
/* process hmtk, native and custom, add to display list
if display object is missing, create new one
registry object must exist!

!! add one new custom track is not done here
*/
	if(data.hmtkData==undefined) return;
	for(var i=0; i<data.hmtkData.length; i++) {
		var t=data.hmtkData[i];
		var obj=browser.findHmtk(t.name);
		if(obj==null) {
			obj=createDisplayobject_hmtk(t.name);
			browser.gmlst.push(obj);
		}
		if(move.direction == null) {
			// not moving
			obj.data = t.data;
		} else if(move.direction == 'l') {
			// moving to 'l'
			var newlst = t.data;
			if(move.merge) {
				var lastr = newlst[newlst.length-1];
				obj.data[0] = lastr.concat(obj.data[0]);
				newlst.pop();
			}
			obj.data = newlst.concat(obj.data);
		} else {
			// moving to 'r'
			var newlst = t.data;
			if(move.merge) {
				obj.data[obj.data.length-1] = obj.data[obj.data.length-1].concat(newlst[0]);
				newlst.shift();
			}
			obj.data = obj.data.concat(newlst);
		}

		/* in case of restoring session, need to restore .qtc before rendering tracks
		*/
		if(data.qtc!=undefined && (obj.name in data.qtc))
			qtc_paramCopy(data.qtc.hmtk[obj.name], obj.qtc);

    	drawHmCanvas_onetrack(obj,false);
	}
}
function mergeStackData4moving(gf, newdata) {
    /* newdata is list of newly coming items from server-json
       they will be added to decorCanvasHash[gf].data,
       and items with same id will be merged in old/new holders.
       see "trigger dependency.dia" for description on item array
     */
    var od = decorCanvasHash[gf].data; // old data
    if(move.direction == 'l') {
        // moving left, need to shift plotting coord of old data by leftnewlen
        for(var i=0; i<od.length; i++) 
	    od[i][0] += leftnewlen; // box start
    } else {
        // moving right, shift new data coord by leftoldlen
        for(var i=0; i<newdata.length; i++)
	    newdata[i][0] += leftoldlen;
    }
    // with new data, merge items already exists in old
    var lk = decorCanvasHash[gf].lookup;
    for(var i=0; i<newdata.length; i++) {
        var jack = newdata[i];
        if(jack[2] in lk) {
            var jill = lk[jack[2]];
            if(move.direction == 'l') {
	        // jack placed before jill, modify box start and width
		jill[0] = jack[0];
		jill[1] += jack[1];
	    } else {
	        // jack appended to jill, only modify box width
		jill[1] += jack[1];
	    }
	} else {
	    od.push(jack);
	}
    }
}




/*** similar as decor item info system, click on metadata color block also generates tooltip
     still uses decor item tooltip
 ***/




function ajaxShowCustomtracks(tklst) {
/* for tracks that are already registered
arg: [[ft, tkname], ...]
TODO categorical
TODO store cutoff params in registry object
*/
	var p1=[], p3=[], p5=[], p10=[], p15=[];
	for(var i=0; i<tklst.length; i++) {
		switch(tklst[i][0]) {
		case FT_bed_c: p1.push(tklst[i][1]); break;
		case FT_bedgraph_c: p3.push(tklst[i][1]); break;
		case FT_sam_c: p5.push(tklst[i][1]); break;
		case FT_lr_c: p10.push(tklst[i][1]); break;
		case FT_bigwighmtk_c: p15.push(tklst[i][1]); break;
		default: fatalError('ajaxShowCustomtracks: unsupported ft');
		}
	}
	var param=[];
	if(p1.length > 0) {
		var lst=[];
		for(var i=0; i<p1.length; i++) {
			var o=decorInfo[p1[i]];
			lst.push(p1[i]+','+o.label+','+o.url+','+o.mode);
		}
		param.push('&decor1='+lst.join(','));
	}
	if(p5.length > 0) {
		var lst=[];
		for(var i=0; i<p5.length; i++) {
			var o=decorInfo[p5[i]];
			lst.push(p5[i]+','+o.label+','+o.url+','+o.mode);
		}
		param.push('&decor5='+lst.join(','));
	}
	if(p10.length > 0) {
		var lst=[];
		for(var i=0; i<p10.length; i++) {
			var o=decorInfo[p10[i]];
			lst.push(p10[i]+','+o.label+','+o.url+','+o.mode+',2,-2');
		}
		param.push('&decor10='+lst.join(','));
	}
	if(p3.length > 0) {
		var lst=[];
		for(var i=0; i<p3.length; i++)
			lst.push(hmtk[p3[i]].url+','+p3[i]);
		param.push('&hmtk3='+lst.join(','));
	}
	if(p15.length > 0) {
		var lst=[];
		for(var i=0; i<p15.length; i++)
			lst.push(hmtk[p15[i]].url+','+p15[i]);
		param.push('&hmtk15='+lst.join(','));
	}
	ajax('showcustomtk=on&'+displayedRegionParamPrecise()+chiapetRegionParam()+param.join(''),function(data){
		if(data.decorData!=undefined) {
			jsonDecor(data);
			for(var i=0; i<data.decorData.length; i++)
				decorInfo[data.decorData[i][0]].showbutt.innerHTML='hide';
		}
		if(data.hmtkData!=undefined) {
			jsonHmtk(data);
			for(var i=0; i<data.hmtkData.length; i++)
				hmtk[data.hmtkData[i].name].showbutt.innerHTML='hide';
		}
		browser.makeTrackAttrAll();
		browser.mcm_sorthmtk(sortTrackIdx);
		drawTrackAttrCanvas(browser);
		stuffTrackCanvas2holder();

		custmd_makegrid();
	});
}



/*******************************
     HMTK heatmap tracks
 ******************************/
/*** HMTK ends ***/







function makeTrackCheckboxHtml(tkname) {
    // make a checkbox for a track, with the label, return html
    return "<input type=checkbox id="+tkname+" onchange=trackcheckboxOnchange(event)> <label for="+tkname+">"+hmtk[tkname].label+"</label>";
}
function track2addCancel() {
	stripChild(document.getElementById("track2addtable"), 0);
	document.getElementById("track2addwrapper").style.display = "none";
	trackselectionCancel();
}
function trackcheckboxOnchange(event) {
	track2addAddRemoverow(event.target.id, event.target.checked);
}
function updateAfterRemovetrack(nativeRemoved) {
	updateDsp();
    trackHeightChanged(false);
	if(chiapet.inuse) {
		// uses number "i"
		for(var j=0; j<chiapet.viewlst.length; j++) {
			if(chiapet.viewlst[j]==undefined || chiapet.viewlst[j].type!=1) continue;
			// remove those that are not found in main browser object
			var lst = chiapet.datalst[j].hmtk;
			var idx=0;
			while(true) {
				if(idx>=lst.length-1) break;
				if(browser.findHmtk(lst[idx].name)==null) {
					chiapet.viewlst[j].hmdiv.removeChild(lst[idx].hmC);
					lst.splice(i,1);
				} else {
					idx++;
				}
			}
		}
	}
}
function removeHmtk_iconchange(event) {
/* tracks on display will have a cross icon in track selection panel,
clicking them will remove this track from display,
and change the cross icon into a checkbox in case user regrets what he's done
event.target is the icon, sits in an identifiable <div>
*/
	var d = event.target.parentNode;
	var td = d.parentNode; // <td>
	var tkn = d.title;
	td.innerHTML = makeTrackCheckboxHtml(tkn);
	browser.removeHmtk(tkn);
	updateAfterRemovetrack(tkn in hmtk);
}
function removeAlltracks() {
// called by pusing button, remove all hmtks
	var l = browser.gmlst.length;
	var hasnative=false;
	for(i=0; i<l; i++) {
		if(!isCustom(browser.gmlst[0].ft))
			hasnative=true;
		browser.removeHmtk(browser.gmlst[0].name);
	}
	updateAfterRemovetrack(hasnative);
}
function toggleDecor(tkname) {
/* turn on a decor by simulating change of <select>
mode has to be already set in decorInfo
<select>.selectedIndex will have no use
*/
    if(!(tkname in decorInfo))
        fatalError('turnonDecor: '+tkname+' not found in decorInfo');
    var obj = decorInfo[tkname];
    changeSelectByValue(obj.selectdom, obj.mode);
    simulateEvent(obj.selectdom,'change');
}
function ajaxAddOneServerbam(event) {
/* called by clicking button
add one bam track given its file name
TODO instead of using thin as default, allow user to choose mode
TODO chiapet
*/
    if(entire.length >= 1000000) {
        print2console('For security purpose, please zoom in to narrower region to display read alignment data', 2);
	return;
    }
    var fname = event.target.getAttribute('tkname');
    if(fname in decorInfo) {
        if(decorInfo[fname].mode == M_hide) {
	    decorInfo[fname].mode = M_den;
	    toggleDecor(fname);
	    return;
	}
        print2console('This track is already in display', 2);
	return;
    }
    ajax(displayedRegionParamPrecise()+'&addserverbam='+fname+',thin',function(data){
        if(!('serverbamdata' in data))
	    fatalError('ajaxAddOneServerbam: serverbamdata missing');
	jsonAddoneserverbam(data.serverbamdata[0]);

        unveil(viewbox);
        print2console("read alignment track added", 1);
        document.body.style.cursor = 'auto';
    });
}
function jsonAddoneserverbam(data) {
// data is an array [name, label, mode, [data] ]
// TODO should be incorporated into jsonDecor
    var name = data[0];
    var label = data[1];
    makeNewDecorCanvas(name, data[3], data[2], 4, null, 0, label);
    drawDecorCanvas(name);
    decorCanvasHash[name].canvas.style.left = move.styleLeft;
    decoruserlist_insert(name);
    // register this track
    tkselect.decor.grptab_nativebam.style.display = 'block';
    var tr = tkselect.decor.tkholder_nativebam.insertRow(-1);
    decorInfo[name].tksregistrytr = tr;
    var td = tr.insertCell(0);
    // TODO add information link for user to obtain information about this track
    td.innerHTML = label;
    td.className = 'tkentry';
    td.setAttribute('tkname', name);
    td.setAttribute('name', 'decortkentry');
    td.style.backgroundColor = 'transparent';
    td.addEventListener('click', decortkentry_click, false);
    decorInfo[name].tksentry = td;
}





/********************
   HTEST related functions
 ********************/
function pvcutoff_selectchange() {
    // the <select> in qtc panel, works for normal/bev htest
    if(qtc.which == 9) {
        // normal htest
	htest.qtc.pvcutoff = parseFloat(getSelectValueById('pvcutoff'));
	drawHtestCanvas(false);
    } else if(qtc.which == 8) {
        // bev htest
	bev.data[bev.ongoing].qtc.pvcutoff = parseFloat(getSelectValueById('pvcutoff'));
	bev_plot(bev.ongoing);
    } else {
        fatalError('pvcutoff_selectchange: unknown qtc.which '+qtc.which);
    }
}
function drawHtestHeadercanvas() {
    htest.header.width = leftColumnWidth;
    htest.header.height = htest.canvas.height;
    htest.header.ctx = htest.header.getContext('2d');
    var ctx = htest.header.ctx;
    ctx.fillStyle = 'black';
    ctx.font = 'bold 8pt Sans-serif';
    ctx.fillText('log10 P value', 1, 20);
    ctx.fillText('cutoff: '+getSelectValueById('pvcutoff'), 1, 36);
    drawVerticalAxis(htest.qtc,htest.header, 0, htest.minlogpv, true, 'black');
}
function drawHtestCanvas(tosvg,data) {
/* call this when pvalue is available
pvalue cutoff is always read from pvcutoff <select>
if 2nd argument is provided, it is pvalue newly generated by cgi
*/
    if(!htest.inuse) {return;}
    if(data != undefined) {
        if(move.direction == null) {
            htest.pvalue = data;
        } else if(move.direction == 'l') {
	    if(move.merge) {
		htest.pvalue[0] = data[data.length-1].concat(htest.pvalue[0]);
		data.pop();
	    }
            htest.pvalue = data.concat(htest.pvalue);
        } else {
	    if(move.merge) {
	        var lastr = htest.pvalue[htest.pvalue.length-1];
		htest.pvalue[htest.pvalue.length-1] = lastr.concat(data[0]);
		data.shift();
	    }
            htest.pvalue = htest.pvalue.concat(data);
	}
    }

    /* header will have 4 ticks: 0.0005 0.005 0.05 1
       so zero pvalue will be replaced by to 0.0005
     */
    htest.canvas.width = entire.spnum;
    htest.canvas.height = htest.qtc.height+densitydecorpaddingtop*2;
    htest.holder.style.height = htest.canvas.height;
    htest.header.height = htest.canvas.height;
    htest.canvas.style.left = move.styleLeft;
    var ctx = htest.canvas.ctx;
    var unitwidth = entire.atbplevel ? entire.bpwidth : 1;
    var logpv = qtrack_logtransform(htest.pvalue, htest.qtc, dspBoundary.lwr,dspBoundary.rwr,dspBoundary.lws,dspBoundary.rws);
    var thv = qtrack_getthreshold(logpv, htest.qtc, dspBoundary.vstartr, dspBoundary.vstopr, dspBoundary.vstarts, dspBoundary.vstops);
    htest.minlogpv = thv[1];
    drawHtestHeadercanvas();
    var svgdata=qtrack_plotwiggle(logpv, ctx, htest.qtc, 0, thv[1], unitwidth, false, true, tosvg);

    // draw cutoff line
    var lcv = Math.log(htest.qtc.pvcutoff) * Math.LOG10E;
    var liney=null;
    if(lcv > htest.minlogpv) {
	ctx.fillStyle = htest.qtc.pvccolor;
	liney=densitydecorpaddingtop+htest.qtc.height*lcv/htest.minlogpv;
	ctx.fillRect(0,liney,htest.canvas.width,1);
    }
    if(tosvg) return [svgdata[0], thv, liney];
}
function turnoffHtest() {
    htest.holder.style.display = 'none';
    htest.header.style.display = 'none';
    htest.inuse = false;
    document.getElementById("htestsaysno").style.display = "block";
    document.getElementById("htestsaysyes").style.display = "none";
}
function htest_grpbuttOn(grpnumber) {
    document.getElementById('htestgroupdiv_'+grpnumber).firstChild.firstChild.style.display = "block";
}
function pwc_grpbuttOn(grpnumber) {
    document.getElementById('htestgroupdiv_'+grpnumber).firstChild.firstChild.style.display = "none";
}
function htest_grpbuttOff(grpnumber) {
    document.getElementById('pairwisecompgroup'+grpnumber).firstChild.firstChild.style.display = "block";
}
function pwc_grpbuttOff(grpnumber) {
    document.getElementById('pairwisecompgroup'+grpnumber).firstChild.firstChild.style.display = "none";
}
function addhmtkgroupholder(grpnumber,height,type) {
    /* make hmtk group holder for htest and pwc
       return list of two dom objects: wrapper to be inserted in place, holder to add ID
       arg is number of group
     */
    var holderid;
    if(type == 'htest') {
        holderid = 'htestgroupdiv_'+grpnumber;
    } else if(type == 'pwc') {
        holderid = 'pairwisecompgroup'+grpnumber;
    } else {
        fatalError('addhmtkgroupholder: unknown type');
    }
    var color = colorCentral.longlst[grpnumber];
    color = lightencolor(colorstr2int(color),0.4);
    var table = document.createElement("table");
    table.cellSpacing = 0;
    table.style.backgroundColor = '#fcf8ee';
    table.style.border = "solid 1px "+color;
    table.style.marginBottom = "10px";
    var tr = table.insertRow(0);
    var td = tr.insertCell(0);
    td.style.backgroundColor = color;
    td.align = 'center';
    td.innerHTML = 'GROUP '+grpnumber;
    td = tr.insertCell(-1);
    td.align='right';
    td.innerHTML = '<button class=s holderid='+holderid+' onclick=hmtkgrp_clear(event)>&#10005; clear</button> <button class=s ttype='+type+' grp='+grpnumber+' holderid='+holderid+' onmousedown=tkspanel_close() onclick=hmtkgrp_invoketksp(event)>add &#187;</button>';
    // track holder
    tr = table.insertRow(-1);
    td = tr.insertCell(0);
    td.style.width = 360;
    td.style.height= height;
    td.vAlign = "top";
    td.colSpan = 2;
    td.id = holderid;
    return table;
}
function addhtestgroup() {
// can be called by pushing add group button
	if(browser.htest.inuse) turnoffHtest();
	browser.htest.grpnum++;
	document.getElementById("htestgroupholder").appendChild(addhmtkgroupholder(browser.htest.grpnum,10,'htest'));
	document.getElementById("htestremovegrpbutton").disabled = (browser.htest.grpnum > 2) ? false : true;
}
function addpwcgroups() {
    /* just called once during page load up */
    document.getElementById("pwcgroupholder").appendChild(addhmtkgroupholder(1,10, 'pwc'));
    document.getElementById("pwcgroupholder").appendChild(addhmtkgroupholder(2,10,'pwc'));
}
function removehtestgroup() {
    if(htest.inuse) turnoffHtest();
    htest.grpnum--;
    var h = document.getElementById("htestgroupholder");
    h.removeChild(h.lastChild);
    document.getElementById("htestremovegrpbutton").disabled = (htest.grpnum > 2) ? false : true;
    // remove last option of <select> 
    for(var i=0; i<tkLst.length; i++) {
        var s = document.getElementById(tkLst[i].name+"htestgrpselect");
	s.removeChild(s.lastChild);
    }
}
function htestgroupclearcontent() {
    // called by pushing button, will clear all groups
    if(htest.inuse) turnoffHtest();
    for(var i=1; i<=htest.grpnum; i++) {
        stripChild(document.getElementById("htestgroupdiv_"+i), 0);
    }
}
function menuHtesttkassigngrp(event) {
    // called on clicking grp box on context menu
    // decide if to change single/multiple track
    if(menu.context == 1) {
        // single track
        if(menu.iY >= tkLst.length) 
	    fatalError("menuHtesttkassigngrp: wrong tkLst index");
	htest_assigngrp(tkLst[menu.iY].name, event.target.grpid);
    } else if(menu.context == 2) {
        // multiple tracks
	for(var i=0; i<menu.trackIdxLst.length; i++) {
	    if(menu.trackIdxLst[i] >= tkLst.length)
	        fatalError("menuHtesttkassigngrp: wrong tkLst index");
	    htest_assigngrp(tkLst[menu.trackIdxLst[i]].name, event.target.grpid);
	}
    }
    if(htest.inuse) turnoffHtest();
}
function menuPairwisecomptkassigngrp(grpid) {
    // similar as htest counterpart, argument is group id 1/2
    if(menu.context == 1) {
        // single track
        if(menu.iY >= tkLst.length) 
	    fatalError("menuHtesttkassigngrp: wrong tkLst index");
	pwc_assigngrp(tkLst[menu.iY].name, grpid);
    } else if(menu.context == 2) {
        // multiple tracks
	for(var i=0; i<menu.trackIdxLst.length; i++) {
	    if(menu.trackIdxLst[i] >= tkLst.length)
	        fatalError("menuHtesttkassigngrp: wrong tkLst index");
	    pwc_assigngrp(tkLst[menu.trackIdxLst[i]].name, grpid);
	}
    }
    if(pwc.inuse)
        turnoffPairwisecomp();
}
function htest_assigngrp(tkname, grp) {
    /* assign a track to a htest group
       1. track name
       2. group number, 0 means this track does not belong to any group
     */
    //if(htest.inuse) turnoffHtest();
    // remove this track from its old group, if any
    var d = document.getElementById(tkname+"inhtestgrp");
    if(d!=null && d.parentNode!=null) {
	d.parentNode.removeChild(d);
    }
    if(grp == 0) {
        if(tkselect.main.style.display=='block') {tkspanel_hmtoggle(tkname);}
	return;
    }
    // assign track to that group
    d = document.createElement("div");
    d.id = tkname+"inhtestgrp";
    d.setAttribute('tkname', tkname);
    // in case track is custom
    var tkobj = browser.findHmtk(tkname);
    d.innerHTML = "<span style=\"cursor:pointer;color:#c00;\" onclick=\"htest_assigngrp('"+tkname+"',0)\">&#10005;</span> "+(tkobj==null ? hmtk[tkname].label : tkobj.label);
    document.getElementById("htestgroupdiv_"+grp).appendChild(d);
}
function cgiHtest() {
/* called upon pushing "run test" button
or restoring session?
verify at least two htest groups are there with children
*/
	var good = 0;
	for(var i=1; i<=htest.grpnum; i++) {
		if(document.getElementById("htestgroupdiv_"+i).childNodes.length > 0)
			good++;
	}
	if(good < 2) {
		print2console("make at least 2 track groups", 2);
		turnoffHtest();
		return;
	}
	for(i=1; i<=htest.grpnum; i++) {
		htest["gtn"+i] = [];
		var lst = document.getElementById("htestgroupdiv_"+i).childNodes;
		for(var j=0; j<lst.length; j++) {
			htest["gtn"+i].push(lst[j].getAttribute('tkname'));
		}
	}
	ajaxHtest();
}
function ajaxHtest() {
	htest.holder.style.display = 'block';
	htest.header.style.display = 'block';
	htest.inuse = true; // need to set to true before calling htestParams()
	document.getElementById("htestsaysno").style.display = "none";
	document.getElementById("htestsaysyes").style.display = "block";
	cloak(viewbox);
	print2console("running hypothesis test...", 0);
	ajax(displayedRegionParamPrecise()+hmtkChoice_htest()+htestParams(), function(data) {
		drawHtestCanvas(false,data.htestData);
		unveil(viewbox);
		done();
	});
}
function addHtestgrp2menu() {
    // add group options to context menu
    var holder = document.getElementById("menuHtestgrpholder");
    stripChild(holder, 0);
    for(var i=1; i<=htest.grpnum; i++) {
        var d = document.createElement("div");
	d.grpid = i;
	d.className = "groupselector";
	d.style.display = "inline-block";
	d.style.backgroundColor = colorCentral.longlst[i];
	d.style.marginLeft = 5;
	d.innerHTML = '&nbsp;'+i+'&nbsp;';
	d.addEventListener("click", menuHtesttkassigngrp, false)
	holder.appendChild(d);
    }
}





function setDisplaywhichgf() {
    /* display brief info on top of heatmap panel
       also on collation on/off indicator
       juxtaposition.type has to be set to proper value before calling this
     */
    //var sp = document.getElementById("displaywhichgf");
    var sp2 = document.getElementById("juxtaposewhat");
    if(juxtaposition.type == 0) {
	//sp.innerHTML = juxtaposition.note;
    } else if(juxtaposition.type==1 || juxtaposition.type==2 || juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
	//sp.innerHTML = 
	sp2.innerHTML = juxtaposition.note;
    } else {
	fatalError("setDisplaywhichgf: unknown juxtaposition.type");
    }
}

function cgiJuxtapose(event) {
/* this is supposedly only called by hand-selection on radio buttons
deals with server/custom bigbed
use event.target.className to tell
*/

    var c = event.target.className;
    if(c!="server" && c!="custom")
        fatalError("cgiJuxtapose: wrong event.target.className");

    if(c == "server") {
        juxtaposition.type = 1;
	juxtaposition.note = event.target.alt;
	juxtaposition.what = event.target.value;
    } else {
        juxtaposition.type = 2;
	juxtaposition.note = "custom bigBed track";
	juxtaposition.what = event.target.value;
    }
    setDisplaywhichgf();
    juxtaposeAddBlinders();

    cloak(viewbox);
    print2console("juxtaposing "+juxtaposition.note+"...", 0);
    ajaxX(displayedRegionParam()+"&changeGF=on");
}


function cgiJumpchr(seq) {
    if(juxtaposition.type==3 || juxtaposition.type==4) {
        print2console('Not jumping because in gene set view mode', 2);
		return;
    }
    cloak(viewbox);
    print2console("displaying entire "+seq+"...",0);
    ajaxX("jump=on&jumpchr="+seq+"&gftype="+juxtaposition.what);
}
function cgiGetData() {
/* get data underlining genome heatmap
called by pushing button, one of those misc function
what if there's no track on?
*/
	document.getElementById("getdatawriteshere").innerHTML = "working...";
	ajax(displayedRegionParamPrecise()+hmtkChoice(browser.gmlst)+"&sptotalnum="+hmSpan+"&getdata=on",function(data){
		document.getElementById("getdatawriteshere").innerHTML = "right click on link and save: <a style='text-decoration:underline' href=t/"+sessionId+".txt target=_blank>tabular</a> <a style='text-decoration:underline' href=t/"+sessionId+".wig target=_blank>wiggle</a>";
	});
}
function cgiGetSeq() {
	// called by pushing button, one of those misc function
	var yellat = document.getElementById("getseqwriteshere");
	yellat.innerHTML = "working...";
	var v = document.getElementById("getseqcoord").value;
	if(v == "enter coordinate") {
		// fetch seq for currently displayed region
		var el = entire.atbplevel ? hmSpan/entire.bpwidth : hmSpan*entire.summarySize;
		if(el > 1000000) {
			yellat.innerHTML = "length of currently displayed region exceeds 1 mega bp, try zoom in to a shorter range";
			return;
		}
		// make region coords over dsp
		var lst = [];
		var tt = getViewRangeCoord();
		for(var i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
			lst.push(regionLst[i][0]+':'+
				(i==dspBoundary.vstartr ? tt[0] : regionLst[i][3]) +':'+
				(i==dspBoundary.vstopr ? tt[1] : regionLst[i][4]));
		}
		v = lst.join(':');
	}
	ajax2("hmspan=1&getChromseqtemp=on&regionlst="+v+"&dbName="+dbInfo.name+'&session='+sessionId, function(data){
		document.getElementById("getseqwriteshere").innerHTML = "<a style='text-decoration:underline' href=t/"+sessionId+"."+data+".fa target=_blank>right click on link and save</a>";
		document.getElementById("getseqcoord").value = "enter coordinate";
	});
}



/**********************************
   CORRelation function has 4 layers 

   cgiCorrelation -- called by user clicking radio buttons
   jsonCorr
   computeCorr
   drawCorr
 *********************************/
function drawCorrscalecanvas() {
    // re-draw correlation scale canvas
    // usually width will change, but height won't be changed
    var c = document.getElementById('corrscalecanvas');
    c.width = leftColumnWidth;
    c.height = 27;
    var sp = 5; // spacing
    var w = leftColumnWidth - sp*2;
    ctx = c.getContext('2d');
    ctx.font = "10pt Sans-serif";
    ctx.fillStyle = "black";
    var x = 0;
    ctx.fillRect(x+sp,24,w,1); // horizontal backbone
    ctx.fillText("-1", x+1,15);
    ctx.fillRect(x+sp,19,1,5); // tick
    x = w/2+sp;
    ctx.fillText("0", x-2,15);
    ctx.fillRect(x,19,1,5); // tick
    x = sp+w;
    ctx.fillText("1", x-4,15);
    ctx.fillRect(x-1,19,1,5); // tick
}
function jsCorrelation(data) {
    /* only do stuff on client side
       argument is numerical data to compute correlation against,
       like tkLst[i].data or decorCanvasHash[gf].data
     */
    correlation.rawdata = data;
    computeCorr();
    for(var i=0; i<tkLst.length; i++)
        corrHolder.appendChild(tkLst[i].coC);
}
function hmtkRadioClickCorrelation(event) {
    /* calling correlation by clicking on radio button
       ** only for hm tracks **
     */
    var dn = event.target.value;
    var ft = parseInt(event.target.getAttribute('filetype'));
    correlation.targetft = ft;
    correlation.targetname = dn;
    correlation.where = 0;
    correlation.inuse = true;
    runCorrelation();
}

function runCorrelation() {
/* used to initiate correlation
- menu option selection
- checking radio buttons
- restore session

if decor is not displayed or not in show/density mode, run ajax and compute data!!

but not to be called when moving
*/
	if(!correlation.inuse)
		return;
	var tft = correlation.targetft;
	var tname = correlation.targetname;
	switch(tft) {
	case FT_bedgraph_c:
	case FT_bedgraph_n:
	case FT_bigwighmtk_c:
	case FT_bigwighmtk_n:
		// quantitative hmtk
		var tk = browser.findHmtk(tname);
		if(tk == null) {
			fatalError("runCorrelation: heatmap track not found");
		}
		jsCorrelation(tk.data);
		corrStageOpen(tk.label);
		return;
	case FT_qdecor_n:
		// ASSume decor bigwig can only be 8
		// just see if bigwig is displayed, no need to check mode...
		if(tname in decorCanvasHash) {
			jsCorrelation(decorCanvasHash[tname].data);
		} else {
			ajax(displayedRegionParamPrecise()+"&decor8="+tname+","+M_show, function(data){
				jsCorrelation(data["decorData"][0][4]);
			});
		}
		corrStageOpen(decorInfo[tname].label);
		return;
	case FT_bed_c:
	case FT_bed_n:
		/* decor bigbed density */
		if(tname in decorCanvasHash && decorInfo[tname].mode==M_den) {
			// this decor is been displayed in density mode
			jsCorrelation(decorCanvasHash[tname].data);
		} else {
			// not in correct mood, ajax kicks in
			var param;
			if(tft == FT_bed_n)
				param = displayedRegionParamPrecise()+"&decor0="+tname+",density";
			else
				param = displayedRegionParamPrecise()+"&decor1="+tname+","+escape(decorInfo[tname].url)+",density";
			ajax(param, function(data){
				jsCorrelation(data["decorData"][0][4]);
			});
		}
		corrStageOpen(decorInfo[tname].label);
		return;
	case FT_sam_c:
	case FT_sam_n:
		if(!(tname in decorCanvasHash)) {
			print2console("BAM track not in display", 2);
			correlation.inuse = false;
			return;
		}
		jsCorrelation(decorCanvasHash[tname].data);
		corrStageOpen(decorInfo[tname].label);
		return;
	default:
		fatalError("runCorrelation: unknown target type");
	}
}
function corrStageOpen(saywhat) {
    // set up stage and print out some words. opposite is turnoffCorrelation()
    document.getElementById('corrwhich').innerHTML = saywhat;
    document.getElementById('corrscalecanvas').style.display = 'block';
    document.getElementById('corrnotinuse').style.display = 'none';
    document.getElementById('corrinuse').style.display = 'block';
}
function jsonCorr(data) {
// argument is wholesome json object retrieved by ajax
	if(!correlation.inuse)
		return;
	var tft = correlation.targetft;
	var tname = correlation.targetname;
	if(isHmtk(tft)) {
		// hm bigwig
		var tk = browser.findHmtk(tname);
		if(tk == null) {
			print2console("jsonCorr: heatmap track not found", 2);
			correlation.inuse = false;
			return;
		}
		jsCorrelation(tk.data);
	} else if(tft == FT_qdecor_n) {
		// ASSume decor bigwig can only be 8
		if(tname in decorCanvasHash) {
			// is been displayed
			jsCorrelation(decorCanvasHash[tname].data);
		} else {
			if(!("corrData" in data))
			fatalError("jsonCorr: corrData missing");
			moveMergeNumericaldata(data["corrData"], correlation.rawdata);
			jsCorrelation(correlation.rawdata);
		}
	} else if(tft==FT_bed_c || tft==FT_bed_n) {
		// bigbed
		if(tname in decorCanvasHash && decorInfo[tname].mode==M_den) {
			// this decor is been displayed in density mode
			jsCorrelation(decorCanvasHash[tname].data);
		} else {
			if(!("corrData" in data))
			fatalError("jsonCorr: corrData missing");
			moveMergeNumericaldata(data["corrData"], correlation.rawdata);
			jsCorrelation(correlation.rawdata);
		}
	} else if(tft==FT_sam_c || tft==FT_sam_n) {
		// bam, same treatment as bigbed
		if(tname in decorCanvasHash && decorInfo[tname].mode==M_den) {
			// this decor is been displayed in density mode
			jsCorrelation(decorCanvasHash[tname].data);
		} else {
			if(!("corrData" in data))
			fatalError("jsonCorr: corrData missing");
			moveMergeNumericaldata(data["corrData"], correlation.rawdata);
			jsCorrelation(correlation.rawdata);
		}
	} else {
		fatalError("jsonCorr: unknown target type");
	}
}
function initiateCorrCanvasCtx(ctx) {
    // add color gradient for correlation coefficient plot
    var lingrad = ctx.createLinearGradient(0,0,leftColumnWidth,0);
    var tq = correlation.qtc;
    lingrad.addColorStop(0,'rgb('+tq.nr+','+tq.ng+','+tq.nb+')');
    lingrad.addColorStop(0.5,lightencolor([tq.nr,tq.ng,tq.nb],0.7));
    lingrad.addColorStop(0.5,lightencolor([tq.pr,tq.pg,tq.pb],0.7));
    lingrad.addColorStop(1,'rgb('+tq.pr+','+tq.pg+','+tq.pb+')');
    ctx.fillStyle = lingrad;
}
function viewingRegionData2array(data) {
    /* "data" is 2d array for numerical data on regions: [[v1,v2,v3,...], [], ...]
       for data between viewed regions, compress into to one array, 
       doesn't include spacing between regions

       - track score
       - decor density
       - corrData.raw
     */
    var tmp = [];
    for(var i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
	var start = (i==dspBoundary.vstartr) ? dspBoundary.vstarts : 0;
	var stop = (i==dspBoundary.vstopr) ? dspBoundary.vstops : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	for(var j=start; j<stop; j++)
	    tmp.push(data[i][j]);
    }
    return tmp;
}
function spearmanRankCorr(v1, v2) {
    // works for arrays of any length
    var rho = 0;
    var L = v1.length;
    for(var i=0; i<L; i++)
        rho += (v1[i]-v2[i]) * (v1[i]-v2[i]);
    rho = 1 - 6*rho/(L*(L*L-1));
    return rho;
}
function computeCorr_onetrack(tk) {
    // compute correlation for one track
    var tmp = viewingRegionData2array(tk.data);
    var rk = correlation.rankeddata;
    if(tmp.length != rk.length) 
        fatalError('Track '+tk.name+' has different vector length to compute correlation: '+tmp.length+' '+rk.length);
    var tkrank = array2rank(tmp);
    tk.corr = spearmanRankCorr(tkrank, rk);
    //if(Math.abs(rho) > 1) alert(tk.label+' '+rho);
    drawCorr_onetrack(tk);
}
function computeCorr() {
    // gf density data is in corrData, might be dsp+wings
    // for each track, compute its correlation with corrData
    // store result in tk.corr
    var tmp = viewingRegionData2array(correlation.rawdata);
    correlation.rankeddata = array2rank(tmp);
    for(i=0; i<tkLst.length; i++) 
        computeCorr_onetrack(tkLst[i]);
}
function array2rank(data) {
    // fractional ranking (1, 2.5, 2.5, 4)
    var valueCount = {};
    // key: value, val: # of items having this value
    var sortdata = []; // the "keys" of valueCount...
    for(var i=0; i<data.length; i++) {
        if(data[i] in valueCount) {
	    valueCount[data[i]]++;
	} else {
	    valueCount[data[i]] = 1;
	    sortdata.push(data[i]);
	}
    }
    sortdata.sort(numSort);
    var cumulativeRank = 1;
    var value2rank = {}; // key: value, val: rank
    for(i=0; i<sortdata.length; i++) {
        if(valueCount[sortdata[i]] == 1) {
	    value2rank[sortdata[i]] = cumulativeRank++;
	} else {
	    var xx = 0;
	    for(var j=0; j<valueCount[sortdata[i]]; j++)
	        xx += cumulativeRank+j;
            value2rank[sortdata[i]] = xx/valueCount[sortdata[i]];
	    cumulativeRank += valueCount[sortdata[i]];
	}
    }
    var rank = [];
    for(i=0; i<data.length; i++)
        rank.push(value2rank[data[i]]);
    return rank;
}
function drawCorr() {
    for(var i=0; i<tkLst.length; i++) drawCorr_onetrack(tkLst[i]);
}
function drawCorr_onetrack(tk) {
    // argument is element in tkLst
    tk.coC.ctx.clearRect(0,0,leftColumnWidth,tk.hmC.height);
    var spacing = 5;
    var middle = leftColumnWidth/2;
    var w = (middle-spacing)*tk.corr;
    if(tk.corr > 0) {
	tk.coC.ctx.fillRect(middle, 0, w, tk.hmC.height);
    } else if(tk.corr < 0) {
	tk.coC.ctx.fillRect(middle+w, 0, -w, tk.hmC.height);
    }
}
function turnoffCorrelation() {
    correlation.inuse = false;
    stripChild(corrHolder, 0);
    document.getElementById('corrscalecanvas').style.display = 'none';
    document.getElementById('corrnotinuse').style.display = 'block';
    document.getElementById('corrinuse').style.display = 'none';
}
function generictrackdiv_mouseoout(event) {
    indicator.style.display = "none";
    var obj = event.target;
    while(obj.tk == undefined) {
        obj = obj.parentNode;
	if(obj == null) return;
    }
    obj.style.backgroundColor = "transparent";
}



/***********************
   DRAWing functions 
 ***********************/
function sortNumber(a,b) {
    return a-b;
}


function drawOnehmtk(obj) {
/* draw all associated canvases for one hmtk global_browser
argument is tkLst[] element
*/
    drawHmCanvas_onetrack(obj,false);
    drawTrackAttrCanvas_onetrack(obj, browser.mcm.lst, false);
    obj.coC.height = obj.hmC.height;
    obj.labeldiv.style.height = obj.hmC.height;
    initiateCorrCanvasCtx(obj.coC.ctx);
    if(correlation.inuse)
		drawCorr_onetrack(obj);
}
function qtcpanel_close() {
    // close quantitative track config panel in ftb
    if(document.getElementById("ftb_qtCfgdiv").style.display == "none") return;
    document.getElementById("ftb_qtCfgdiv").style.display = "none";
    indicator3.style.display = "none";
    indicator5.style.display = "none";
    // task type-specific cleanup
    if(qtc.which == 8) {
        // configuring bev vector
	if(document.getElementById("qtc_alltrackcheckbox").checked) {
	    for(var vn in bev.data) {
	        if(bev.data[vn].onshow) {
	            bev.data[vn].tr.childNodes[3].style.backgroundColor = "transparent";
		}
	    }
	} else {
	    bev.data[bev.ongoing].tr.childNodes[3].style.backgroundColor = "transparent";
	}
    } else if(qtc.which==3 || qtc.which==8) {
        // toggle the wrench icon background color in user list table
        if(menu.decorname != undefined)
	    decoruserlist_togglewrench(menu.decorname);
    }
}








/*** PWC pairwise comparison ***/
function pwc_assigngrp(tkname,grp) {
/* similar as htest_assigngrp()
grp is 0/1
*/
    var d = document.getElementById(tkname+'inpwcgrp');
    if(d!=null && d.parentNode!=null) {
	d.parentNode.removeChild(d);
    }
    if(grp == 0) {
        if(tkselect.main.style.display=='block') {tkspanel_hmtoggle(tkname);}
	return;
    }
    // assign track to desired group
    d = document.createElement("div");
    d.id = tkname+"inpwcgrp";
    d.setAttribute('tkname',tkname);
    // to work with custom bigwig tracks, as their name do not exist in hmtk
    var tkobj = browser.findHmtk(tkname);
    d.innerHTML = "<span style=\"cursor:pointer;color:#c00;\" onclick=\"pwc_assigngrp('"+tkname+"',0)\">&#10005;</span> "+(tkobj!=null ? tkobj.label : hmtk[tkname].label);
    document.getElementById("pairwisecompgroup"+grp).appendChild(d);
}
function turnonPairwisecomp() {
    pwc.inuse = true;
    pwc.viewbox.style.display = "block";
    pwc.header.style.display = "block";
    document.getElementById("pairwisecompsaysno").style.display = "none";
    document.getElementById("pairwisecompsaysyes").style.display = "block";
}
function turnoffPairwisecomp() {
    pwc.inuse = false;
    pwc.viewbox.style.display = "none";
    pwc.header.style.display = "none";
    document.getElementById("pairwisecompsaysno").style.display = "block";
    document.getElementById("pairwisecompsaysyes").style.display = "none";

    if(chiapet.inuse) {
	for(i=0; i<chiapet.viewlst.length; i++) {
	    if(chiapet.viewlst[i]==undefined  || chiapet.viewlst[i].type!=1) continue;
	    chiapet.viewlst[i].pwccanvas.style.display = 'none';
	}
    }
}
function pairwisecompClear() {
    turnoffPairwisecomp();
    stripChild(pwc.grp1, 1);
    stripChild(pwc.grp2, 1);
    pwc.gtn1 = [];
    pwc.gtn2 = [];
    for(var i=0; i<tkLst.length; i++) {
        document.getElementById(tkLst[i].name+"pairwisecompgrpselect").selectedIndex = 0;
    }
}
function pwc_run() {
/* called by pushing run button
or during restoring session
will initialize .gtn1, .gtn2
and call compute routine
*/
    var lst = pwc.grp1.childNodes;
    if(lst.length == 0) {
        print2console("group 1 has no tracks", 2);
	return;
    }
    pwc.gtn1 = [];
    pwc.gtn2 = [];
    for(var i=0; i<lst.length; i++) {
        pwc.gtn1.push(lst[i].getAttribute('tkname'));
    }
    lst = pwc.grp2.childNodes;
    if(lst.length == 0) {
        print2console("group 2 has no tracks", 2);
	return;
    }
    print2console("running pairwise comparison...", 0);
    for(var i=0; i<lst.length; i++) {
        pwc.gtn2.push(lst[i].getAttribute('tkname'));
    }
    turnonPairwisecomp();
    pwc_compute();
    tkspanel_close();
}
function pwc_compute() {
/* called when pwc.gtn1/2 are ready
compute log ratio from track score, them call drawing routine

track name are converted to tkLst index each time calling,
but the index is not saved as track order could be changed
*/

    // gti: tkLst index of tracks in each group
    var gti1=[]; var gti2=[];
    for(var i=0; i<pwc.gtn1.length; i++) {
        gti1.push(getTkidxByname(pwc.gtn1[i]));
    }
    for(i=0; i<pwc.gtn2.length; i++) {
        gti2.push(getTkidxByname(pwc.gtn2[i]));
    }

    var logratio = []; // simulate array of array from first region to dspBoundary.lwr
    for(var i=0; i<=dspBoundary.rwr; i++) {
        logratio.push([]);
    }
    for(i=0; i<dspBoundary.lws; i++) {
        logratio[dspBoundary.lwr].push(0);
    }

    for(i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
        var start = (i==dspBoundary.lwr) ? dspBoundary.lws : 0;
	var stop = (i==dspBoundary.rwr) ? dspBoundary.rws : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	for(var j=start; j<stop; j++) {
	    var grp1value = [];
	    var grp2value = [];
	    for(var k=0; k<gti1.length; k++) {
	        grp1value.push(tkLst[gti1[k]].data[i][j]);
	    }
	    for(k=0; k<gti2.length; k++) {
	        grp2value.push(tkLst[gti2[k]].data[i][j]);
	    }
	    logratio[i][j] = Math.log(arrayMean(grp1value)/arrayMean(grp2value)) * Math.LOG2E;
	}
    }
    pwc.logratio = logratio;
    pwc_draw(false);
    
    if(chiapet.inuse) {
	for(i=0; i<chiapet.viewlst.length; i++) {
	    if(chiapet.viewlst[i]==undefined || chiapet.viewlst[i].type!=1) continue;
	    chiapet_pwc(i);
	}
    }
	done();
}
function pwc_draw(tosvg) {
/* set canvas height, viewbox height, draw track, draw header
cannot draw chiapet here, or will result in error
*/
    var tmp = qtrack_getthreshold(pwc.logratio, pwc.qtc, dspBoundary.vstartr, dspBoundary.vstopr, dspBoundary.vstarts, dspBoundary.vstops);
    pwc.max = tmp[0];
    pwc.min = tmp[1];

    var c = pwc.canvas;
    c.width = entire.spnum;
    c.height = pwc.qtc.height + densitydecorpaddingtop*2;
    pwc.viewbox.style.height = c.height;
    pwc.header.height = c.height;

    c.style.left = move.styleLeft;
    var unitwidth = entire.atbplevel ? entire.bpwidth : 1;
    var svgdata=qtrack_plotwiggle(
    	pwc.logratio, c.getContext('2d'),
	pwc.qtc, pwc.max, pwc.min,
	unitwidth, false, true,
	tosvg);
    drawPairwiseHeadercanvas();

    if(tosvg) return [svgdata[0],tmp];
}
function drawPairwiseHeadercanvas() {
    pwc.header.width = leftColumnWidth;
    var ctx = pwc.header.getContext('2d');
    ctx.font = "8pt Sans-serif";
    ctx.fillText("Pairwise log ratio", 1, 20);
    ctx.fillText("log2(grp1/grp2)", 1, 30);
    drawVerticalAxis(pwc.qtc,pwc.header, pwc.max, pwc.min, true, 'black');
}




function changedb(event) {
/* called by clicking <td> on species menu (bait3)
as many html components will be reloaded
*/
	// remove previous genome, and all tentacles
	delete genome[browser.genome.name];

	if(browser.correlation.inuse)
		turnoffCorrelation();
	if(browser.pwc.inuse)
		turnoffPairwisecomp();
	browser.cleanuphtmlholder();
	stripChild(browser.genome.mdselect.nativeholder,0);
	/*
	stripChild(document.getElementById("bev_chrgraphtable").firstChild, 0);
	document.getElementById('bait33').style.display='none';
	document.getElementById('svgfilelink_1').innerHTML='';
	stripChild(tkselect.decor.grpholder, 0);
	stripChild(tkselect.decor.tkholder, 1);
	while(htest.grpnum > 0)
		removehtestgroup(); // turnoffHtest() will be called
	ideogram.cytoband = {};
	trackselectionCancel();
	track2addCancel();
	pairwisecompClear();
	document.getElementById("geneplotcanvasdiv").style.display = "none";
	document.getElementById("geneplotimage").style.display = "none";
	document.getElementById("googlechartdiv").style.display = "none";
	document.getElementById("googleimagechartdiv").style.display = "none";
	*/

	// reload database
	toggle3_2();
	//readygo({dbname:dbInfo.name}, true);
	browser.loadgenome_initbrowser(event.target.dbname);
}


/*** CONFIG
 ***/
function config_leftcolumnwidth(change) {
    var v;
    if(change == 999) {
        v = 300;
	change = v - leftColumnWidth;
    } else if(change == -999){
        v = 100;
	change = v - leftColumnWidth;
    } else {
       v = leftColumnWidth + change;
       if(v<100 || v>300)
	   return;
    }
    leftColumnWidth = v;
    document.getElementById("corrCanvasholder").style.width = v;

    var l = parseInt(mdcholder.style.left);
    mdcholder.style.left = l+change;

    for(var dn in decorCanvasHash)
        drawDecorHeadercanvas(dn);

    // corr: scale canvas, holder, corr coef canvas for each track
    drawCorrscalecanvas();
    corrHolder.style.width = leftColumnWidth;
    for(var i=0; i<tkLst.length; i++) {
        tkLst[i].coC.width = v;
	initiateCorrCanvasCtx(tkLst[i].coC.ctx);
    }
    if(correlation.inuse)
        drawCorr();

    drawHtestHeadercanvas();

    if(pwc.inuse)
        drawPairwiseHeadercanvas();

    if(ideogram.wiggle1.name != null)
	draw_ideogramWiggleHeader(1);
    if(ideogram.wiggle2.name != null)
	draw_ideogramWiggleHeader(2);

}
function config_tracklabelshow() {
    var onshow = document.getElementById("tracklabelshow").checked;
    onshow = !onshow;
    document.getElementById("tracklabelshow").checked = onshow;
    document.getElementById("tracklabelshowsaysno").style.display = onshow ? "none" : "block";
    document.getElementById("tracklabelshowsaysyes").style.display = onshow ? "block" : "none";
    tracklabelholder.style.display = onshow ? "block" : "none";
    viewbox.tknameshow = onshow;
}
function config_todefault() {
    leftColumnWidth = 110;
    config_leftcolumnwidth(0);
}








/*** config decor ***/
function stcpanel_hide() {
    document.getElementById("ftb_stcdiv").style.display = "none";
    indicator3.style.display = "none";
    indicator5.style.display = "none";
    decoruserlist_togglewrench(document.getElementById("ftb_stcdiv").target);
}
function stc_precaution() {
// in case the decor track got removed when the stc panel is still on
    var decorname = document.getElementById('ftb_stcdiv').target;
    if(decorname==undefined || !(decorname in decorCanvasHash)) {
        stcpanel_hide();
	print2console("track has been removed", 2);
	return null;
    }
    return decorname;
}
function stc_longrange_pcolor2_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    document.getElementById("ftb_stcdiv").target = dn;
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 7;
    document.body.addEventListener("mousedown", palettehide, false);
}
function stc_longrange_pcolor2(event) {
    var decorname = stc_precaution(); if(decorname == null) return;
    decorCanvasHash[decorname].pcolor = palette.output;
    document.getElementById(decorname+7).style.backgroundColor = palette.output;
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function stc_longrange_ncolor2_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    document.getElementById("ftb_stcdiv").target = dn;
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 9;
    document.body.addEventListener("mousedown", palettehide, false);
}
function stc_longrange_ncolor2(event) {
    var decorname = stc_precaution(); if(decorname == null) return;
    decorCanvasHash[decorname].ncolor = palette.output;
    document.getElementById(decorname+9).style.backgroundColor = palette.output;
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}


function stc_textcolor2_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 36;
    document.body.addEventListener("mousedown", palettehide, false);
    document.getElementById("ftb_stcdiv").target = dn;
}
function stc_textcolor2() {
    var decorname = stc_precaution(); if(decorname == null) return;
    decorCanvasHash[decorname].textcolor = palette.output;
    document.getElementById(decorname+36).style.backgroundColor = palette.output;
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function stc_bedcolor2_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 35;
    document.body.addEventListener("mousedown", palettehide, false);
    document.getElementById("ftb_stcdiv").target = dn;
}
function stc_bedcolor2(event) {
	var decorname = stc_precaution(); if(decorname == null) return;
	decorCanvasHash[decorname].bedcolor = palette.output;
	document.getElementById(decorname+35).style.backgroundColor = palette.output;
	drawDecorCanvas(decorname);
	if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function stc_beddensitycolor_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 37;
    document.body.addEventListener("mousedown", palettehide, false);
    document.getElementById("ftb_stcdiv").target = dn;
}
function stc_beddensitycolor(event) {
    var decorname = stc_precaution(); if(decorname == null) return;
    document.getElementById(decorname+37).style.backgroundColor = palette.output;
    var c = colorstr2int(palette.output);
    decorCanvasHash[decorname].qtc.pr=c[0];
    decorCanvasHash[decorname].qtc.pg=c[1];
    decorCanvasHash[decorname].qtc.pb=c[2];
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function decor8_pcolor_initiator(event) {
// short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 38;
    document.body.addEventListener("mousedown", palettehide, false);
    document.getElementById("ftb_stcdiv").target = dn;
}
function decor8_pcolor(event) {
    var decorname = stc_precaution(); if(decorname == null) return;
    document.getElementById(decorname+38).style.backgroundColor = palette.output;
    var c = colorstr2int(palette.output);
    decorCanvasHash[decorname].qtc.pr=c[0];
    decorCanvasHash[decorname].qtc.pg=c[1];
    decorCanvasHash[decorname].qtc.pb=c[2];
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function decor8_ncolor_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 39;
    document.body.addEventListener("mousedown", palettehide, false);
    document.getElementById("ftb_stcdiv").target = dn;
}
function decor8_ncolor(event) {
    var decorname = stc_precaution(); if(decorname == null) return;
    document.getElementById(decorname+39).style.backgroundColor = palette.output;
    var c = colorstr2int(palette.output);
    decorCanvasHash[decorname].qtc.nr=c[0];
    decorCanvasHash[decorname].qtc.ng=c[1];
    decorCanvasHash[decorname].qtc.nb=c[2];
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function chiapetvp_pcolor_initiator(event) {
// chiapetvp chr henge plot positive color
    var vidx = parseInt(event.target.viewidx);
    if(chiapet.viewlst[vidx].type!=2) return;
    document.getElementById("ftb_stcdiv").target = vidx;
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.color);
    palette.which = 10;
    document.body.addEventListener("mousedown", palettehide, false);
}
function chiapetvp_pcolor() {
    var vidx = document.getElementById("ftb_stcdiv").target;
    chiapet.datalst[vidx].decor.pcolor = colorstr2int(palette.output).join(',');
    chiapetvp_chrhenge(vidx);
}
function chiapetvp_ncolor_initiator(event) {
// chiapetvp chr henge plot negative color
    var vidx = parseInt(event.target.viewidx);
    if(chiapet.viewlst[vidx].type!=2) return;
    document.getElementById("ftb_stcdiv").target = vidx;
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.color);
    palette.which = 11;
    document.body.addEventListener("mousedown", palettehide, false);
}
function chiapetvp_ncolor() {
    var vidx = document.getElementById("ftb_stcdiv").target;
    chiapet.datalst[vidx].decor.ncolor = colorstr2int(palette.output).join(',');
    chiapetvp_chrhenge(vidx);
}




// htest cutoff line color
function htest_clc_initiator(event) { // htest cutoff line color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById('htest_clc').style.backgroundColor);
    palette.which = 34;
    document.body.addEventListener("mousedown", palettehide, false);
}
function htest_clc() {
    var c = palette.output;
    document.getElementById('htest_clc').style.backgroundColor = c;
    if(qtc.which == 9) {
	htest.qtc.pvccolor = c;
	drawHtestCanvas(false);
    } else if(qtc.which == 8) {
	bev.data[bev.ongoing].qtc.pvccolor = c;
	bev_plot(bev.ongoing);
    } else {fatalError('htest_clc: unknown qtc.which');}
}




/*** bigBed generator 
     via textarea input
 ***/
function bbgsubmit() {
	var t = document.getElementById('bbgtextarea').value;
	if(t.length == 0) {
		print2console("no gene list found in text area", 2);
		return;
	}
	t = t.replace(/\t/g, ' ');
	if(ensureNonezerolengthregion(4)) {
		print2console("custom region selector defined zero length", 2);
		return;
	}
	document.getElementById("bbgwriteshere").innerHTML = "working...";
	ajax("new=on&generatebigbed=on&gss_says=xx&itemlist="+escape(t)+gss_param(4)+"&statusId="+statusId+"&dbName="+dbInfo.name, function(data){
		if('abort' in data) {
			document.getElementById("bbgwriteshere").innerHTML = data.abort;
			print2console(data.abort, 3);
			unveil(viewbox);
			return;
		}
		document.getElementById("bbgwriteshere").innerHTML = '<a href=t/'+sessionId+'.'+data.rand+'.s.gz target=_blank>.gz file</a>, '+
		'<a href=t/'+sessionId+'.'+data.rand+'.s.gz.tbi target=_blank>index file</a><br>This file contains '+data.itemnum+' items '+
		'<button type=button onclick=bbg2custombigbedtrack("'+sessionId+'.'+data.rand+'.s.gz")>put it up as custom bigBed track</button>';
	});
}
function bbg2custombigbedtrack(filename) {
/* called by pushing button
the newly generated bigbed file always has same file name and location, so...
try use session ID + a number as custom track name
*/
	document.getElementById('newcustombigbedfileurl').value = window.location.href.split('?')[0]+'t/'+filename;
	document.getElementById("newcustombigbedtkname").value = newcustomtrackname();
	changeSelectByValue("newcustombigbedmode", M_full);
	submitCustomtk_1();
}




/*** GP gene plot
 ***/
function enableGooglechart(event) {
	event.target.disabled=true;
	event.target.innerHTML = 'Importing library, please wait....';
	var h = document.getElementsByTagName('HEAD')[0];
	var s = document.createElement('script');
	s.type = 'text/javascript';
	s.src = 'https://www.google.com/jsapi';
	h.appendChild(s);
	setTimeout(enableGooglechart2, 500);
}
function enableGooglechart2(event) {
// for google chart tools
	var b=document.getElementById('enablegooglecharbutt');
	if(typeof(google) == "undefined") {
		b.innerHTML='Failed to enable Google Chart, click to try again';
		b.disabled=false;
	} else {
		b.style.display='none';
		document.getElementById('googlechartopt').disabled = false;
		document.getElementById('geneplotrender').selectedIndex=0;
		simulateEvent(document.getElementById('geneplotrender'),'change');
		document.getElementById('geneplot_googletablebutton').style.display='inline';
		google.load('visualization', '1', {packages:['corechart', 'table'], callback:function(){}});
	}
}
function geneplot_invoketkselect(event) {
/* called by clicking button */
	menu_shutup();
	menu_show(13,event.clientX,event.clientY);
	gflag.browser.showcurrenttrack4select();
}
function invokegeneplot_geneset()
{
/* called by pushing big button, to invoke gene plot panel
toggle on geneplotdiv for geneset view
genesetview panel should already been displayed
*/
apps.gsv.style.display='none';
toggle4();
geneplot.for = 0;
document.getElementById("geneplotforwhat").innerHTML = "following Gene Set View";
document.getElementById('gpStandalone_holder').style.display = 'none';
var n = browser.genesetview.lst.length;
d = document.getElementById("genesetfyi");
d.firstChild.nextSibling.innerHTML = "There are "+n+" items in gene set";
d.style.display='block';
if(n < 150) {
	d.firstChild.style.color = "#66B266";
	d.firstChild.innerHTML = "&#10004;";
	d.firstChild.nextSibling.innerHTML += " and you're good to go";
} else {
	d.firstChild.style.color = "#FFC266";
	d.firstChild.innerHTML = "&#9888;";
	d.firstChild.nextSibling.innerHTML += ", if you run into \"URL too long\" problem when using <b>second</b> plot type, please use R rendering method instead";
}
gp_back2control();
}
function invokegeneplot_custombigbed(tkname) {
    // called by pushing button to invoke geneplot panel
    if(!(tkname in decorCanvasHash)) {
        print2console("custom bigBed track not found by name: "+tkname, 3);
	return;
    }
    if(decorInfo[tkname].ft!= 1) {
        print2console("invokegeneplot_custombigbed: wrong file type");
	return;
    }
    var d = apps.gplot;
    d.style.display = "block";
    d.style.paddingLeft = 15;
    d.style.paddingTop = 15;
    document.getElementById("tgt_customTrack").appendChild(d);
    d.style.left = 0; d.style.top = 35;
    geneplot.for = 1;
    geneplot.forTkname = tkname;
    document.getElementById("geneplotforwhat").innerHTML = 'for custom bigBed track '+tkname;
    document.getElementById('gpStandalone_holder').style.display = 'none';
    d = document.getElementById("genesetfyi");
    d.style.display = 'block';
    var n = decorCanvasHash[tkname].totalitemnumber;
    d.firstChild.nextSibling.innerHTML = "There are "+n+" items in this custom bigBed track";
    if(n > geneplot.maxbigbeditemnumber) {
        d.firstChild.style.color = '#FF6666';
	d.firstChild.innerHTML = "Nope";
	d.firstChild.nextSibling.innerHTML += ", only first "+geneplot.maxbigbeditemnumber+" items will be used for plotting, and it would be dangerous to run <b>second</b> plot type as server will be sending huge amount of data that might halt your computer";
    } else {
        if(n < 150) {
            d.firstChild.style.color = "#66B266";
	    d.firstChild.innerHTML = "Yep";
	    d.firstChild.nextSibling.innerHTML += " and you're safe to go";
        } else {
            d.firstChild.style.color = "#FFC266";
	    d.firstChild.innerHTML = "Hmm";
	    d.firstChild.nextSibling.innerHTML += ", but be careful with second plot type, as the server might send too much data and that will cause trouble to your computer";
	}
    }
    document.getElementById('geneplot_tklabel').innerHTML = 'NONE';
    gp_back2control();
}
function geneplotchoosestyle(event) {
    /* called by clicking div
       first child node is <radio>
     */
    var lst = document.getElementsByName("geneplotdiv");
    for(var i=0; i<lst.length; i++)
        lst[i].className = "geneplotdiv";
    var tt = event.target;
    if(event.target.tagName == "IMG")
        tt = event.target.parentNode;
    tt.className = "geneplotdiv2";
    tt.firstChild.checked = true;
    lst = document.getElementsByName("geneplottable");
    for(i=0; i<lst.length; i++)
        lst[i].style.display = "none";
    document.getElementById("geneplot_"+tt.firstChild.value).style.display = "block";
    if(tt.firstChild.value == "s4") {
        document.getElementById("geneplotchooserender").style.display = "none";
        document.getElementById("geneplotnotchooserender").style.display = "inline";
    } else {
        document.getElementById("geneplotchooserender").style.display = "inline";
        document.getElementById("geneplotnotchooserender").style.display = "none";
    }
}
function geneplot_s1_lc_initiator(event) {
    // s1 line color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s1_lc").style.backgroundColor);
    palette.which = 22;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s2_lc_initiator(event) {
    // s2 spagetti color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s2_lc").style.backgroundColor);
    palette.which = 23;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s3_promoterc_initiator(event) {
    // s3 promoter
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s3_promoterc").style.backgroundColor);
    palette.addEventListener("mousedown", geneplot_s3_promoterc, false);
    palette.which = 24;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s3_utr5c_initiator(event) {
    // s3 5' utr
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s3_utr5c").style.backgroundColor);
    palette.which = 25;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s3_utr3c_initiator(event) {
    // s3 3' utr
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s3_utr3c").style.backgroundColor);
    palette.which = 26;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s3_exonsc_initiator(event) {
    // s3 exon color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s3_exonsc").style.backgroundColor);
    palette.which = 27;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s3_intronsc_initiator(event) {
    // s3 intron color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s3_intronsc").style.backgroundColor);
    palette.which = 28;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s4_pc_initiator(event) {
    // s4 positive value color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s4_pc").style.backgroundColor);
    palette.which = 20;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s4_nc_initiator(event) {
    // s4 negative value color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s4_nc").style.backgroundColor);
    palette.which = 21;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplotrenderselectchange(event) {
    // called by changing <select> to choose between google or R
    var isgoogle = event.target.selectedIndex == 0;
    document.getElementById('geneplot_s1_lc').innerHTML = isgoogle ? 'median curve' : 'box color';
    document.getElementById('geneplot_s1_googlesays').style.display = isgoogle ? 'inline' : 'none';
    document.getElementById('geneplot_s1_useR').style.display = isgoogle ? 'none' : 'inline';
    document.getElementById('geneplot_s3_googlesays').style.display = isgoogle ? 'inline' : 'none';
    document.getElementById('geneplot_s3_useR').style.display = isgoogle ? 'none' : 'inline';
    var d1 = document.getElementById('geneplot_s1_biglogo');
    var d3 = document.getElementById('geneplot_s3_biglogo');
    if(isgoogle) {
        d1.innerHTML = '<img src=images/geneplot_s1_g.png height=160 width=160>';
        d3.innerHTML = '<img src=images/geneplot_s3_g.png height=160 width=160>';
    } else {
        d1.innerHTML = '<img src=images/geneplot_s1_b.png height=160 width=160>';
        d3.innerHTML = '<img src=images/geneplot_s3_b.png height=160 width=160>';
    }
}

function makeGeneplot()
{
/* called by pushing button
geneplot.for should have already been set to indicate running mode
TODO use trackParam()
*/
var type = getValue_by_radioName("geneplotstyle");
var rendering = getSelectValueById("geneplotrender");

/* running Google Chart (s2) with many items will be problematic
need to exclude that
*/
if(type=='s2' && (rendering=='gc' || rendering=='gic')) {
	var itemnumlimit = 500;
	if(geneplot.for == 0) {
		if(genesetview.lst.length > itemnumlimit) {
			print2console("Too many items to plot via Google service, use R instead", 2);
			return;
		}
	} else if(geneplot.for == 1) {
		fatalError('not there yet');
	}
}

// but first, let's hide everybody
document.getElementById("haszerosdgene").style.display = "none";
document.getElementById("geneplot_selectedgenediv").style.display = "none";
stripChild(document.getElementById("geneplot_kmeansclusterbuttonholder"), 0);
document.getElementById("geneplotdendrogram").style.display = "none";
document.getElementById("geneplotcanvasdiv").style.display = "none";
document.getElementById("googleimagechartdiv").style.display = "none";
document.getElementById("googlechartdiv").style.display = "none";
document.getElementById("geneplotimage").style.display = "none";
document.getElementById("googletablediv").style.display = "none";
document.getElementById("geneplot_dataplaintext").style.display = "none";
document.getElementById("geneplotgetdatabuttons").style.display = "none";

// data track
if(gflag.gplot.tk==undefined) {
	print2console('You haven\'t selected a track for GenePlot',2);
	return;
}
var datatk = gflag.gplot.tk.name;
var datatkft = gflag.gplot.tk.ft;
if(isCustom(datatkft)) 
	datatk=gflag.gplot.tk.url;

// plot-type specific params
var param = '';
if(type == "s4") {
	param = "&clustmethod="+getSelectValueById("geneplot_s4_m")+"&kmeanscnum="+getSelectValueById("geneplot_s4_cnum")+"&clustdist="+getSelectValueById("geneplot_s4_dist")+"&clustaglm="+getSelectValueById("geneplot_s4_aglm");
} else if(rendering=='r') {
	// R rendering params
	param = "&usingR=on&width="+getSelectValueById("geneplot_"+type+"_iw")+"&height="+getSelectValueById("geneplot_"+type+"_ih")+"&lw="+getSelectValueById("geneplot_"+type+"_lw");
	if(type == 's1') {
		// s1 specific R params
		var c = document.getElementById("geneplot_"+type+"_lc").style.backgroundColor;
		param += '&range='+getSelectValueById('geneplot_s1_wrange')+
			'&lc='+c+
		'&averagelc='+darkencolor(colorstr2int(c), 0.4)+
		'&outlier='+getSelectValueById('geneplot_s1_outlier')+
		(document.getElementById('geneplot_s1_average').checked?'&average=on':'');
	} else if(type=='s2') {
		// s2 specific R params
		//param += "&lc="+document.getElementById("geneplot_s2_lc").style.backgroundColor;
	} else if(type=='s3') {
		// s3 specific R params
		var pc = document.getElementById("geneplot_"+type+"_promoterc").style.backgroundColor;
		var uc5 = document.getElementById("geneplot_"+type+"_utr5c").style.backgroundColor;
		var uc3 = document.getElementById("geneplot_"+type+"_utr3c").style.backgroundColor;
		var ec = document.getElementById("geneplot_"+type+"_exonsc").style.backgroundColor;
		var ic = document.getElementById("geneplot_"+type+"_intronsc").style.backgroundColor;
		param += "&promoterc="+pc+
				  "&utr5c="+uc5+
				  "&utr3c="+uc3+
				  "&exonsc="+ec+
				  "&intronsc="+ic+
			  '&average_promoterc='+darkencolor(colorstr2int(pc), 0.4)+
			  '&average_utr5c='+darkencolor(colorstr2int(uc5), 0.4)+
			  '&average_utr3c='+darkencolor(colorstr2int(uc3), 0.4)+
			  '&average_exonsc='+darkencolor(colorstr2int(ec), 0.4)+
			  '&average_intronsc='+darkencolor(colorstr2int(ic), 0.4)+
				  '&range='+getSelectValueById('geneplot_s3_wrange')+
			  '&outlier='+getSelectValueById('geneplot_s3_outlier')+
			  (document.getElementById('geneplot_s3_average').checked?'&average=on':'');
	}
}

// positional data
if(geneplot.for == 0) {
	/* four fields for each: itemname (gene or coord), chr, start, stop */
	param += '&session='+browser.sessionId+'&statusid='+browser.statusId;
} else if(geneplot.for == 2) {
	/* textarea input items joined by comma 
	   notice gss param is supplied!
	 */
	var inputvalue = document.getElementById('gpStandalone_textarea').value;
	if(inputvalue.length == 0) {
		print2console('Please enter gene names or genomic coordinates', 2);
		return;
	}
	param += '&tainput='+inputvalue.replace(/,/g,'').replace(/\t/g,' ').split('\n').join(',')+gss_param(5);
} else if(geneplot.for == 1) {
	fatalError('not there yet');
	//param += "&forurl="+escape(decorInfo[geneplot.forTkname].url);
}

document.body.style.cursor = 'wait';
document.getElementById('geneplot_butt').innerHTML = 'Running...';
document.getElementById('geneplot_butt').removeEventListener('click', makeGeneplot, false);

browser.ajax("makegeneplot=on&context="+geneplot.for+"&plottype="+type+"&spnum="+getSelectValueById("geneplot_"+type+"_spnum")+"&datatk="+datatk+"&datatkft="+datatkft+'&dbName='+browser.genome.name+param, function(data){
	document.getElementById('geneplot_butt').innerHTML = 'Make gene plot';
	document.getElementById('geneplot_butt').addEventListener('click', makeGeneplot, false);
	if('alert' in data) {
		print2console(data.alert, 2);
	}
	if('gpabort' in data) {
		document.body.style.cursor = 'auto';
		return;
	}
	document.getElementById("geneplotgetdatabuttons").style.display = "block";

	document.getElementById('gp_figure_div').style.display = 'block';
	document.getElementById('gp_option_div').style.display = 'none';

	var rendering = getSelectValueById("geneplotrender");
	var type = getValue_by_radioName("geneplotstyle");
	geneplot.type = type;
	geneplot.data = data['data'];
	var spnum = parseInt(getSelectValueById("geneplot_"+type+"_spnum"));

	var canvasdiv = document.getElementById("geneplotcanvasdiv"); // plot as canvas
	var gcimagediv = document.getElementById("googleimagechartdiv"); // google image chart
	var gcdiv = document.getElementById("googlechartdiv"); // google chart tool, fancier
	var Rimage = document.getElementById("geneplotimage"); // R-generated image

	var imageframe; // for image chart only

	if(type == "s4") {
		canvasdiv.style.display = "table";
	} else if(rendering == "r") {
		Rimage.style.display = "block";
	} else if(rendering == "gc") {
		gcdiv.style.display = "block";
	} else if(rendering == "gic") {
		gcimagediv.style.display = "block";
		stripChild(gcimagediv, 0);
		imageframe = document.createElement("iframe");
		imageframe.frameBorder = 0;
		gcimagediv.appendChild(imageframe);
	}

	if(type == "s1") {
		if(rendering == "gc") {
			var showaverage = document.getElementById('geneplot_s1_average').checked;
			var Gdata = new google.visualization.DataTable();
			Gdata.addColumn('number', 'POS'); // X axis index
			Gdata.addColumn('number', 'minimum');
			Gdata.addColumn('number', 'lower quartile');
			Gdata.addColumn('number', 'median');
			if(showaverage)
				Gdata.addColumn('number', 'average');
			Gdata.addColumn('number', 'upper quartile');
			Gdata.addColumn('number', 'maximum');
			Gdata.addRows(spnum);

			var tmpi;
			for(var i=0; i<spnum; i++) {
				Gdata.setValue(i, 0, i); // X axis index value
				var v = data['data'][i];
				Gdata.setValue(i, 1, v[0]);
				Gdata.setValue(i, 2, v[1]);
				Gdata.setValue(i, 3, v[2]);
				tmpi = 4;
				if(showaverage)
					Gdata.setValue(i, tmpi++, v[3]);
				Gdata.setValue(i, tmpi++, v[4]);
				Gdata.setValue(i, tmpi++, v[5]);
			}

			// line color
			var lc = document.getElementById("geneplot_s1_lc").style.backgroundColor;
			var clst = colorstr2int(lc);
			var colorlst = [lightencolor(clst, .8), lightencolor(clst, .5), lc];
			if(showaverage)
				colorlst.push(darkencolor(clst, .4));
				colorlst.push(lightencolor(clst, .5));
				colorlst.push(lightencolor(clst, .8));

			new google.visualization.LineChart(gcdiv).draw(Gdata, 
				{width:parseInt(getSelectValueById("geneplot_s1_iw")),
				 height:parseInt(getSelectValueById("geneplot_s1_ih")),
				 lineWidth:parseInt(getSelectValueById("geneplot_s1_lw")),
				 colors:colorlst,
				 hAxis:{'title':"Genomic positions from 5' to 3'"},
				 vAxis:{'title':"Data value distribution"},
				 });
					document.body.style.cursor = "auto";
			print2console("Gene Plot ready", 1);
			return;
		}
		if(rendering == "r") {
			var ll = data["image"].split('/');
		Rimage.src = 't/'+ll[ll.length-1];
				document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
		return;
		}
	}
	if(type == "s2") {
		if(rendering == "gc") {
			var Gdata = new google.visualization.DataTable();
		Gdata.addColumn('number', 'POS'); // x axis index
		for(var i=0; i<data['data'].length; i++) {
			Gdata.addColumn('number', data['data'][i][0]);
		}
		Gdata.addRows(spnum);
		// set x axis index
		for(i=0; i<spnum; i++) {
			Gdata.setValue(i, 0, i);
		}
		// set data value
		for(i=0; i<data['data'].length; i++) { // for each vector (or column in DataTable)
			var v = data['data'][i];
			for(var j=0; j<spnum; j++) {
				Gdata.setValue(j, i+1, v[j+1]);
			}
		}
		new google.visualization.LineChart(gcdiv).draw(Gdata, 
			{width:parseInt(getSelectValueById("geneplot_s2_iw")),
			 height:parseInt(getSelectValueById("geneplot_s2_ih")),
			 lineWidth:parseInt(getSelectValueById("geneplot_s2_lw")),
			 colors:[document.getElementById("geneplot_s2_lc").style.backgroundColor],
			 legend:"none",
			 hAxis:{'title':"Genomic positions from 5' to 3'"},
			 vAxis:{'title':"Data point values"},
			 });
				document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
			return;
		}
		if(rendering == "r") {
			var ll = data["image"].split('/');
		Rimage.src = 't/'+ll[ll.length-1];
				document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
		return;
		}
	}
	if(type == "s3") {
		// hard-coded info about gene parts
		if(rendering == "gc") {
			var showaverage = document.getElementById('geneplot_s3_average').checked;
			var Gdata = new google.visualization.DataTable();
		Gdata.addColumn('string', 'POS'); // string index, "promoter 1"
		for(var k=0; k<5; k++) {
			Gdata.addColumn('number', "minimum");
			Gdata.addColumn('number', "lower quartile");
			Gdata.addColumn('number', "median");
			if(showaverage)
				Gdata.addColumn('number', 'average');
			Gdata.addColumn('number', "upper quartile");
			Gdata.addColumn('number', "maximum");
		}
		var totalNum = spnum*5;
		Gdata.addRows(totalNum);
		// set value for each gene part
		var lst = ['promoter','5\' UTR', 'exons', 'introns', '3\' UTR'];
		var tmpi;
		var m = showaverage ? 6 : 5; // |o|
		for(k=0; k<5; k++) {
			for(i=0; i<spnum; i++) {
				var j = i+spnum*k;
				Gdata.setValue(j, 0, lst[k]+' '+(i+1));
			var v = data['data'][j];
			Gdata.setValue(j, k*m+1, v[0]);
			Gdata.setValue(j, k*m+2, v[1]);
			Gdata.setValue(j, k*m+3, v[2]);
			tmpi = k*m+4;
			if(showaverage)
				Gdata.setValue(j, tmpi++, v[3]);
			Gdata.setValue(j, tmpi++, v[4]);
			Gdata.setValue(j, tmpi, v[5]);
			}
		}
		var collst = []; // list of color for all lines
		var col = document.getElementById("geneplot_s3_promoterc").style.backgroundColor;
		var lst = colorstr2int(col);
		collst.push(lightencolor(lst,.8));
		collst.push(lightencolor(lst,.5));
		collst.push(col);
		if(showaverage) collst.push(darkencolor(lst, .4));
		collst.push(lightencolor(lst,.5));
		collst.push(lightencolor(lst,.8));
		col = document.getElementById("geneplot_s3_utr5c").style.backgroundColor;
		lst = colorstr2int(col);
		collst.push(lightencolor(lst,.8));
		collst.push(lightencolor(lst,.5));
		collst.push(col);
		if(showaverage) collst.push(darkencolor(lst, .4));
		collst.push(lightencolor(lst,.5));
		collst.push(lightencolor(lst,.8));
		col = document.getElementById("geneplot_s3_exonsc").style.backgroundColor;
		lst = colorstr2int(col);
		collst.push(lightencolor(lst,.8));
		collst.push(lightencolor(lst,.5));
		collst.push(col);
		if(showaverage) collst.push(darkencolor(lst, .4));
		collst.push(lightencolor(lst,.5));
		collst.push(lightencolor(lst,.8));
		col = document.getElementById("geneplot_s3_intronsc").style.backgroundColor;
		lst = colorstr2int(col);
		collst.push(lightencolor(lst,.8));
		collst.push(lightencolor(lst,.5));
		collst.push(col);
		if(showaverage) collst.push(darkencolor(lst, .4));
		collst.push(lightencolor(lst,.5));
		collst.push(lightencolor(lst,.8));
		col = document.getElementById("geneplot_s3_utr3c").style.backgroundColor;
		lst = colorstr2int(col);
		collst.push(lightencolor(lst,.8));
		collst.push(lightencolor(lst,.5));
		collst.push(col);
		if(showaverage) collst.push(darkencolor(lst, .4));
		collst.push(lightencolor(lst,.5));
		collst.push(lightencolor(lst,.8));
		new google.visualization.LineChart(gcdiv).draw(Gdata, 
			{width:parseInt(getSelectValueById("geneplot_s3_iw")),
			 height:parseInt(getSelectValueById("geneplot_s3_ih")),
			 lineWidth:parseInt(getSelectValueById("geneplot_s3_lw")),
			 colors:collst,
			 legend:'none',
			 hAxis:{'title':"Genomic positions from 5' to 3'"},
			 vAxis:{'title':"Data value distribution"},
			 });
				document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
			return;
		}
		if(rendering == "r") {
			var ll = data["image"].split('/');
		Rimage.src = 't/'+ll[ll.length-1];
				document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
		return;
		}
	}
	if(type == "s4") {
		var clustmethod = getSelectValueById("geneplot_s4_m");
		var is_hclust = clustmethod == 'h';
		var is_kmeans = clustmethod == 'k';
		var rheight = parseInt(getSelectValueById("geneplot_s4_rh")); // row height
		var pwidth = parseInt(getSelectValueById("geneplot_s4_dpw")); // data point width
		geneplot.canvasrheight = rheight;
		geneplot.canvaspwidth = pwidth;
		var canvas = document.getElementById("geneplotheatmap");
		canvas.width = spnum * pwidth;
		var genenum = 0;
		var safe2real = {}; // key: safe name, val: real name
		for(var gname in data.data) {
			genenum++;
		safe2real[gname] = data.data[gname][0];
		}
		geneplot.safe2real = safe2real;
		if('zerosdgene' in data) {
		var lst = data['zerosdgene'];
		document.getElementById("zerosdgeneholder").innerHTML = lst.join('<br>');
		document.getElementById("zerosdgenenum").innerHTML = lst.length;
		document.getElementById("haszerosdgene").style.display = "block";
		}
		canvas.height = genenum * rheight;

		// use global min/max to render heatmap?
		var globalth = document.getElementById("geneplot_s4_global").checked;
		var pth=0; // max of positive
		var nth=0; // min of negative
		if(globalth) {
			max = 0;
			for(gname in data.data) {
			var v = data.data[gname].slice(1);
			for(i=0; i<spnum; i++) {
				if(v[i] > 0) {
				if(v[i] > pth)
					pth = v[i];
			} else {
				if(v[i] < nth)
					nth = v[i];
			}
			}
		}
		}

		/* list of integers (0-xx) representing genes
		   or safe names??
		   determines vertical order of appearance of genes in heatmap
		 */
		var genelst = [];
		// genenum is just length of genelst

		if(is_kmeans) {
			/* assign genes to kmeans clusters, reorder geneplot.genelst for tooltip */
		genelst = data.kmnames;
			geneplot.kmeansclusters = []; // [0] is undefined, cluster id start from 1
		for(i=0; i<data.kmnamecluster.length; i++) {
			var cid = data.kmnamecluster[i];
			if(geneplot.kmeansclusters[cid] == undefined)
				geneplot.kmeansclusters[cid] = [];
			geneplot.kmeansclusters[cid].push(genelst[i]);
		}
		// reorder genelst according to cluster order
		genelst = [];
		for(i=1; i<geneplot.kmeansclusters.length; i++)
			genelst = genelst.concat(geneplot.kmeansclusters[i]);
		} else {
			genelst = data.hclustgenelst;
		}
		geneplot.genelst = genelst;

		// render heatmap!
		var pclst = colorstr2int(document.getElementById("geneplot_s4_pc").style.backgroundColor);
		var nclst = colorstr2int(document.getElementById("geneplot_s4_nc").style.backgroundColor);
		var ctx = canvas.getContext("2d");
		ctx.fillStyle = 'white'; // paint canvas with white, the baseline color
		ctx.fillRect(0,0, canvas.width, canvas.height);
		var yoffset = 0;
		for(var row=0; row<genelst.length; row++) {
		var v = data.data[genelst[row]].slice(1);
		if(!globalth) {
			// figure out threshold value for each data vector
			pth = 0;
			nth = 0;
			for(i=0; i<v.length; i++) {
				if(v[i] > 0) {
				if(v[i] > pth)
					pth = v[i];
			} else {
				if(v[i] < nth)
					nth = v[i];
			}
			}
		}
		for(i=0; i<spnum; i++) {
			if(v[i] > 0) {
				ctx.fillStyle = lightencolor(pclst, 1-v[i]/pth);
				ctx.fillRect(i*pwidth, yoffset, pwidth, rheight);
			} else if(v[i] < 0) {
				ctx.fillStyle = lightencolor(nclst, 1-v[i]/nth);
				ctx.fillRect(i*pwidth, yoffset, pwidth, rheight);
			}
		}
			yoffset += rheight;
		}

		if(is_kmeans) {
			// make buttons for clusters
		var holder = document.getElementById("geneplot_kmeansclusterbuttonholder");
		stripChild(holder, 0);
		for(i=1; i<geneplot.kmeansclusters.length; i++) {
			var d = document.createElement("div");
			var h = geneplot.kmeansclusters[i].length*rheight;
			if(h > 10)
				d.innerHTML = "<div style='font-size:10px;margin-top:"+((h-10)/2)+";'>cluster "+i+"</div>";
			else
				d.innerHTML = "cluster "+i;
			d.style.height = h;
			d.className = "kmeansclusterbutton";
			d.cluster = i;
			d.addEventListener("click", geneplotkmeansclusterbuttonclick, false);
			holder.appendChild(d);
		}
			lst = absolutePosition(canvas);
			geneplot.canvasX = lst[0];
			geneplot.canvasY = lst[1];
		document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
		/*** done for kmeans ***/
		return;
		}


		/*** dendrogram 
			 layed horizontally, hc$height will be X positions, y need to be determined
		 hc$labels contain R's stubborn list of safe names

		 in hc$merge:
			 - negative integers, negate of which are array index in stubburn list
			 - negative int need to be converted into array index of genelst
			   by the actual safe name
			   but it still need to be kept negative to be different with cluster id
			 - positive integers are cluster id
			 - the array index (start from 1) are cluster id in it
		 in hc$height:
			 array index (start from 1) are cluster id
			 value is height of that cluster
			 here it is horizontal distance of branching point to left border of heatmap

		 genelst array idx (start from 1) is cluster id
		 ***/
		var hclabels = data.hclustlabels; // stubborn list
		hclabels.unshift(undefined);
		var merge = data.hclustmerge;
		merge.unshift([]);
		/* convert stubborn array index into genelst array index for hc$merge */
		for(i=1; i<genenum; i++) {
			var v = merge[i][0];
			if(v <0) merge[i][0] = -(getArrIdx(hclabels[-v], genelst)+1);
			v = merge[i][1];
			if(v <0) merge[i][1] = -(getArrIdx(hclabels[-v], genelst)+1);
		}
		var clusterxraw = data.hclustheight;
		clusterxraw.unshift(0);
		var clusterx = []; // array index is cluster id, to hold real plotting x coord
		var maxX = 0;
		for(i=1; i<genenum; i++) {
			if(clusterxraw[i] > maxX)
			maxX = clusterxraw[i];
		}
		// clusterx values will be updated to x plotting coord on canvas
		var canvaswidth = 200;
		// scale the canvas width somewhat with genenumber
		if(genenum > 70)
			canvaswidth = canvaswidth + genenum-70;
		if(canvaswidth > 400) canvaswidth = 400;
		var sc = canvaswidth/maxX; // scaling factor, from hc$height to plotting width

		/* layout and determine y position of clusters */
		var clustery = []; // array index is cluster id, to hold raw y plotting coord of clusters
		for(i=1; i<genenum; i++) {
			// i is cluster id
		clusterx[i] = canvaswidth - clusterxraw[i]*sc;
		if(clusterx[i] >= canvaswidth) clusterx[i] = canvaswidth-1;
		var c1v = merge[i][0]; // value of child 1
		var c2v = merge[i][1]; // value of child 2
		if(c1v < 0) {
			// first child is gene
			if(c2v < 0) {
				// both children are gene
			clustery[i] = c1v<c2v ? -c2v : -c1v;
			} else {
				// second child is cluster
				clustery[i] = (clustery[c2v]-c1v)/2;
			}
		} else {
			// first child is cluster
			if(c2v < 0) {
				// second child is gene
			clustery[i] = (clustery[c1v]-c2v)/2;
			} else {
				// both children are clusters
			clustery[i] = (clustery[c1v]+clustery[c2v])/2;
			}
		}
		}
		// convert clustery from row index to actual plotting coord
		for(i=1; i<genenum; i++)
			clustery[i] *= rheight;

		geneplot.merge = merge;
		geneplot.clusterx = clusterx;
		geneplot.clustery = clustery;
		geneplot.genenum = genenum;
		geneplot.highlightcluster = {};
		geneplot.rheight = rheight;

		// render dendrogram
		canvas = document.getElementById("geneplotdendrogram");
		canvas.style.display = "block";
		canvas.width = canvaswidth;
		canvas.height = genenum * rheight;
		ctx = canvas.getContext("2d");
		ctx.fillStyle = "black";
		renderGeneplotDendrogram();

			lst = absolutePosition(canvas);
		geneplot.dendroX = lst[0];
		geneplot.dendroY = lst[1];

		// cache cluster plotting coordinate for clicking
			var ccrd = {}; // see geneplot.ccrd
		geneplot.ccrd = ccrd;
		for(i=1; i<genenum; i++) {
			// use four-pixel square to denote cluster
			var x=[],y=[];
		if(Math.floor(clusterx[i]) != Math.ceil(clusterx[i])) {
			x[1] = Math.floor(clusterx[i]);
			x[0] = x[1]-1;
			x[2] = x[1]+1;
			x[3] = x[1]+2;
		} else {
			x[1] = clusterx[i];
			x[0] = x[1]-1;
			x[2] = x[1]+1;
		}
		if(Math.floor(clustery[i]) != Math.ceil(clustery[i])) {
			y[1] = Math.floor(clustery[i]);
			y[0] = y[1]-1;
			y[2] = y[1]+1;
			y[3] = y[1]+2;
		} else {
			y[1] = clustery[i];
			y[0] = y[1]-1;
			y[2] = y[1]+1;
		}
		//var x0 = parseInt(clusterx[i]), y0 = parseInt(clustery[i]);
		//x = [x0-1, x0, x0+1]; y = [y0-1, y0, y0+1];
		for(j=0; j<x.length; j++) {
			for(k=0; k<y.length; k++) {
				if(!(x[j] in ccrd)) ccrd[x[j]]={};
			ccrd[x[j]][y[k]] = i;
			}
		}
		}

		// only do this after dendrogram canvas is made (affects position of heatmap)
		lst = absolutePosition(document.getElementById("geneplotheatmap"));
		geneplot.canvasX = lst[0];
		geneplot.canvasY = lst[1];
			document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
		return;
	}
});
}

function gp_back2control() {
    document.getElementById('gp_option_div').style.display = 'block';
    document.getElementById('gp_figure_div').style.display = 'none';
}
function renderGeneplotDendrogram() {
    var canvas = document.getElementById("geneplotdendrogram");
    var canvaswidth = canvas.width;
    var ctx = canvas.getContext("2d");
    ctx.clearRect(0,0,canvas.width, canvas.height);
    var rheight = geneplot.rheight;
    var clusterx = geneplot.clusterx;
    for(var i=1; i<geneplot.genenum; i++) {
        ctx.fillStyle = (i in geneplot.highlightcluster) ? "red" : "black";
	var y1,y2;
	// plot horizontal line of first child
        var c = geneplot.merge[i][0];
	if(c < 0) {
	    y1 = (-c-0.5) * rheight;
	    ctx.fillRect(clusterx[i], y1, canvaswidth-clusterx[i], 1);
	} else {
	    y1 = geneplot.clustery[c];
	    ctx.fillRect(clusterx[i], y1, clusterx[c]-clusterx[i], 1);
	}
	// plot horizontal line for second child
	c = geneplot.merge[i][1];
	if(c < 0) {
	    y2 = (-c-0.5) * rheight;
	    ctx.fillRect(clusterx[i], y2, canvaswidth-clusterx[i], 1);
	} else {
	    y2 = geneplot.clustery[c];
	    ctx.fillRect(clusterx[i], y2, clusterx[c]-clusterx[i], 1);
	}
	// vertical line between two children
	if(y1 < y2)
	    ctx.fillRect(clusterx[i], y1, 1, y2-y1);
	else
	    ctx.fillRect(clusterx[i], y2, 1, y1-y2);
    }
}
function geneplotdendrogramclick(event) {
    // called by clicking on geneplot dendrogram, detect cluster
    var x = event.clientX+document.body.scrollLeft-geneplot.dendroX;
    var y = event.clientY+document.body.scrollTop-geneplot.dendroY-1;
    //print2console(x+' '+y,0);
    if(x in geneplot.ccrd) {
        if(y in geneplot.ccrd[x]) {
	    var targetcluster = geneplot.ccrd[x][y];
	    geneplot.highlightcluster = {};
	    geneplot.highlightgenes = [];
	    geneplot_getchild_recursive(targetcluster);
	    renderGeneplotDendrogram();
	    geneplot_getselectedgenedef_gotoholder();
	}
    }
}
function geneplotkmeansclusterbuttonclick(event) {
    var cluster = event.target.cluster;
    if(cluster == undefined)
        cluster = event.target.parentNode.cluster;
    // called by clicking on kmeans cluster button
    geneplot.highlightgenes = geneplot.kmeansclusters[cluster];
    geneplot_getselectedgenedef_gotoholder();
}
function geneplot_getchild_recursive(i) {
    geneplot.highlightcluster[i] = 1;
    var c = geneplot.merge[i][0];
    if(c > 0)
        geneplot_getchild_recursive(c);
    else
        geneplot.highlightgenes.push(geneplot.genelst[-c-1]);
    c = geneplot.merge[i][1];
    if(c > 0)
        geneplot_getchild_recursive(c);
    else
        geneplot.highlightgenes.push(geneplot.genelst[-c-1]);
}
function geneplot_getselectedgenedef_gotoholder() {
    if(geneplot.highlightgenes.length == 0) {
        document.getElementById("geneplot_selectedgenediv").style.display = "none";
        return;
    }
    var tmplst = [];
    for(var i=0; i<geneplot.highlightgenes.length; i++) {
        tmplst.push(geneplot.data[geneplot.highlightgenes[i]][0]);
	tmplst.push(0);
	tmplst.push(0);
	tmplst.push(0);
    }
    /* genes are selected by clicking on dendrogram or kmeans cluster
       get their info and display in table
     */
    ajax("getitemlistgenedef=on&lst="+tmplst.join(',')+"&dbName="+dbInfo.name,function(data){
        if(!("lst" in data))
	    fatalError("geneplot_getselectedgenedef_gotoholder: lst missing");
	var lst = data['lst'];
	// elements in this array: [name, desc, genetype]
        var holder = document.getElementById("geneplot_selectedgenediv");
	holder.style.display = "block";
	// table is first child of holder
	stripChild(holder.firstChild.firstChild, 0);
        for(var i=0; i<lst.length; i++) {
	    // content in a row: button, symbol, refseq name, desc, link
            var tr = holder.firstChild.insertRow(-1);
	    //tr.style.backgroundColor = "white";
	    var td = tr.insertCell(0); // name
	    td.innerHTML = lst[i][0];
	    td = tr.insertCell(-1);
	    if(lst[i][1] != undefined) // desc
	        td.innerHTML = lst[i][1];
	    td.style.fontSize = "12px";
	    td = tr.insertCell(-1); // link
	    if(lst[i][2] != undefined)
	        td.innerHTML = "<a href="+decorInfo[lst[i][2]].queryUrl+lst[i][0]+" target=_blank>&#8599;</a>";
        }
    });
}
function geneplot_getdata(tabletype) {
    // called by clicking button
    var plottype = geneplot.type;

    if(tabletype == 1) {
        // use Google Chart to make interactive table
	var holder = document.getElementById("googletablediv");
	holder.style.display = "block";
	document.getElementById("geneplot_dataplaintext").style.display = "none";
	var data = new google.visualization.DataTable();
	if(plottype == "s1") {
	    var nrow = geneplot.data.length;
	    data.addColumn("number", "data point #");
	    data.addColumn("number", "minimum");
	    data.addColumn("number", "lower quartile");
	    data.addColumn("number", "median");
	    data.addColumn("number", "average");
	    data.addColumn("number", "upper quartile");
	    data.addColumn("number", "maximum");
	    data.addRows(nrow);
	    for(var i=0; i<nrow; i++) {
	        data.setCell(i, 0, i+1);
		var v = geneplot.data[i];
	        data.setCell(i, 1, v[0]);
	        data.setCell(i, 2, v[1]);
	        data.setCell(i, 3, v[2]);
	        data.setCell(i, 4, v[3]);
	        data.setCell(i, 5, v[4]);
	        data.setCell(i, 6, v[5]);
	    }
	    new google.visualization.Table(holder).draw(data, {showRowNumber:false,});
	} else if(plottype == "s2") {
	    var nrow = geneplot.data.length;
	    var ncol = geneplot.data[0].length-1;
	    data.addColumn("string", "gene name");
	    for(var i=0; i<ncol; i++)
	        data.addColumn("number", i+1);
	    data.addRows(nrow);
	    for(i=0; i<nrow; i++) {
	        data.setCell(i, 0, geneplot.data[i][0]);
		for(var j=0; j<ncol; j++)
		    data.setCell(i, j+1, geneplot.data[i][j+1]);
	    }
	    new google.visualization.Table(holder).draw(data);
	} else if(plottype == "s3") {
	    data.addColumn("string", "data point");
	    data.addColumn('number', 'minimum');
	    data.addColumn('number', 'lower quartile');
	    data.addColumn('number', 'median');
	    data.addColumn('number', 'average');
	    data.addColumn('number', 'upper quartile');
	    data.addColumn('number', 'maximum');
	    var total = geneplot.data.length;
	    data.addRows(total);
	    var spnum = total/5;
	    var lst = ['promoter', '5\' UTR', 'exons', 'introns', '3\' UTR'];
	    for(var k=0; k<5; k++) {
	        for(var i=0; i<spnum; i++) {
		    var j = k*spnum + i;
		    data.setCell(j, 0, lst[k]+' '+(i+1));
		    var v = geneplot.data[j];
		    data.setCell(j, 1, v[0]);
		    data.setCell(j, 2, v[1]);
		    data.setCell(j, 3, v[2]);
		    data.setCell(j, 4, v[3]);
		    data.setCell(j, 5, v[4]);
		    data.setCell(j, 6, v[5]);
		}
	    }
	    new google.visualization.Table(holder).draw(data);
	} else if(plottype == "s4") {
	    var genes = [];
	    for(var g in geneplot.data)
	        genes.push(g);
	    var ncol = geneplot.data[genes[0]].length-1;
	    data.addColumn("string", "gene name");
	    for(var i=0; i<ncol; i++)
	        data.addColumn("number", i+1);
	    data.addRows(genes.length);
	    for(i=0; i<genes.length; i++) {
	        data.setCell(i, 0, geneplot.safe2real[genes[i]]);
		var v = geneplot.data[genes[i]];
		for(var j=0; j<ncol; j++)
		    data.setCell(i, j+1, v[j+1]);
	    }
	    new google.visualization.Table(holder).draw(data);
	}
	return;
    }
    
    // doing text output
    var holder = document.getElementById("geneplot_dataplaintext");
    holder.style.display = "block";
    document.getElementById("googletablediv").style.display = "none";
    var table = holder.firstChild;
    stripChild(table.firstChild, 0);
    var tr = table.insertRow(0);
    var td = tr.insertCell(0);

    if(plottype == 's1') {
	td.innerHTML = "data point #";
	tr.insertCell(-1).innerHTML = "minimum";
	tr.insertCell(-1).innerHTML = "lower quartile";
	tr.insertCell(-1).innerHTML = "median";
	tr.insertCell(-1).innerHTML = "average";
	tr.insertCell(-1).innerHTML = "upper quartile";
	tr.insertCell(-1).innerHTML = "maximum";
	for(var i=0; i<geneplot.data.length; i++) {
	    tr = table.insertRow(-1);
	    tr.insertCell(0).innerHTML = i+1;
	    var v = geneplot.data[i];
	    tr.insertCell(-1).innerHTML = v[0];
	    tr.insertCell(-1).innerHTML = v[1];
	    tr.insertCell(-1).innerHTML = v[2];
	    tr.insertCell(-1).innerHTML = v[3];
	    tr.insertCell(-1).innerHTML = v[4];
	    tr.insertCell(-1).innerHTML = v[5];
	}
	return;
    }
    if(plottype == 's2') {
        td.innerHTML = "gene name";
	var num = geneplot.data[0].length-1;
	for(i=0; i<num; i++) {
	    td = tr.insertCell(-1);
	    td.innerHTML = i+1;
	}
	for(i=0; i<geneplot.data.length; i++) {
	    tr = table.insertRow(-1);
	    td = tr.insertCell(0); td.innerHTML = geneplot.data[i][0];
	    for(var j=0; j<num; j++) {
	        td = tr.insertCell(-1); td.innerHTML = geneplot.data[i][j+1];
	    }
	}
	return;
    }
    if(plottype == "s3") {
        td.innerHTML = "data point";
	tr.insertCell(-1).innerHTML = "minimum";
	tr.insertCell(-1).innerHTML = "lower quartile";
	tr.insertCell(-1).innerHTML = "median";
	tr.insertCell(-1).innerHTML = "average";
	tr.insertCell(-1).innerHTML = "upper quartile";
	tr.insertCell(-1).innerHTML = "maximum";
	var total = geneplot.data.length;
	var spnum = total/5;
	var lst = ['promoter', '5\' UTR', 'exons', 'introns', '3\' UTR'];
	for(var k=0; k<5; k++) {
	    for(var i=0; i<spnum; i++) {
	        tr = table.insertRow(-1);
		var j = k*spnum + i;
		tr.insertCell(0).innerHTML = lst[k]+' '+(i+1);
		var v = geneplot.data[j];
		tr.insertCell(-1).innerHTML = v[0];
		tr.insertCell(-1).innerHTML = v[1];
		tr.insertCell(-1).innerHTML = v[2];
		tr.insertCell(-1).innerHTML = v[3];
		tr.insertCell(-1).innerHTML = v[4];
		tr.insertCell(-1).innerHTML = v[5];
	    }
	}
        return;
    }
    if(plottype == "s4") {
        td.innerHTML = "gene name";
	var genes = [];
	for(var g in geneplot.data)
	    genes.push(g);
	var num = geneplot.data[genes[0]].length-1;
	for(i=0; i<num; i++) {
	    tr.insertCell(-1).innerHTML = i+1;
	}
	for(i=0; i<genes.length; i++) {
	    tr = table.insertRow(-1);
	    tr.insertCell(0).innerHTML = geneplot.safe2real[genes[i]];
	    var v = geneplot.data[genes[i]];
	    for(var j=0; j<num; j++) {
	        tr.insertCell(-1).innerHTML = v[j+1];
	    }
	}
	return;
    }
}

/* gene plot functions finish here */



function done() {print2console('done', 1);}

function print2console(what, msgtype) {
	switch(msgtype) {
	case 0:
		// normal
		msgconsole.innerHTML+='<br>'+what;
		break;
	case 1:
		// done
		msgconsole.innerHTML+='<div style="font-size:12px;color:#2A9242;">'+what+'</div>';
		break;
	case 2:
		// reminder or warning
		msgconsole.innerHTML+='<div style="font-size:12px;color:#E4273A;">'+what+'</div>';
		var c='#FFcccc';
		msgconsole.style.backgroundColor=c;
		setTimeout('msgconsole.style.backgroundColor="transparent"',300);
		setTimeout('msgconsole.style.backgroundColor="'+c+'"',600);
		setTimeout('msgconsole.style.backgroundColor="transparent"',900);
		break;
	case 3:
		// fatal error
		msgconsole.innerHTML+='<div style="font-size:12px;color:white;background-color:#E3394A;">'+what+'</div>';
		break;
	default: return;
	}
	msgconsole.scrollTop = 9999; // dummy
}
function msgconsoleMD(event) { // clumsy
	event.preventDefault();
	msgconsole.x = event.clientX;
	msgconsole.y = event.clientY;
	document.body.addEventListener('mousemove', msgconsoleM, false);
	document.body.addEventListener('mouseup', msgconsoleMU, false);
}
function msgconsoleM(event) {
	var a = parseInt(msgconsole.style.width);
	if(event.clientX < msgconsole.x) {
		if(a + event.clientX - msgconsole.x < 244) {
			msgconsole.style.width = 244;
			return;
		}
	}
	msgconsole.style.width = a + event.clientX - msgconsole.x;
	msgconsole.x = event.clientX;
	a = parseInt(msgconsole.style.height);
	if(event.clientY < msgconsole.y) {
		if(a + event.clientY - msgconsole.y < 20) {
			msgconsole.style.height = 20;
			return;
		}
	}
	msgconsole.style.height = a + event.clientY - msgconsole.y;
	msgconsole.y = event.clientY;
}
function msgconsoleMU(event) {
    document.body.removeEventListener('mousemove', msgconsoleM, false);
    document.body.removeEventListener('mouseup', msgconsoleMU, false);
}
function fatalError(brick) { print2console(brick, 3); throw(brick); }





/* __sticky__ note */
function menu_stickynote() {
// called by selecting sticknote option from app list
	menu_shutup();
	menu.stickynote.style.display='block';
}

function makestickynote() {
// return dom object of the note for further handling
	var note = document.createElement("div");
	document.body.appendChild(note);
	var ta = document.createElement("textarea");
	ta.readOnly = true;
	ta.cols = 15;
	ta.rows = 3;
	note.appendChild(ta);
	note.className = "stickynote";
	note.style.left = Math.random()*800;
	note.style.top = Math.random()*600;
	stickynote.number++;
	note.id = stickynote.number+"stickynote";
	note.addEventListener("mousedown", stickynoteMD, false);
	note.addEventListener("mouseover", stickynoteMOV, false);
	note.addEventListener("mouseout", stickynoteMOT, false);
	// edit and delete buttons
	var but = document.createElement("div");
	note.appendChild(but);
	but.innerHTML = "<span style='cursor:pointer;' onclick=stickynote_edit(event)>&#9998;</span> <span style='cursor:pointer;' onclick=stickynote_remove(event)>&#10006;</span>";
	// "done with edit" button
	but = document.createElement("div");
	note.appendChild(but);
	but.innerHTML = "<span style='cursor:pointer;' onclick=stickynote_doneedit(event)>&#10004;</span>";
	return note;
}
function stickynote_remove(event) {
// delete a note
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	document.body.removeChild(note);
}
function stickynote_edit(event) {
// open textarea and edit, hide pencil button and disable moving
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	note.childNodes[1].style.display = "none"; // hide pencil buttons
	note.childNodes[2].style.display = "block"; // show "done edit" button
	var ta = note.firstChild;
	ta.readOnly = false;
	ta.style.backgroundColor = "#F0E8B7";
	ta.focus();
	note.removeEventListener("mousedown", stickynoteMD, false);
	note.removeEventListener("mouseover", stickynoteMOV, false);
	note.removeEventListener("mouseout", stickynoteMOT, false);
}
function stickynote_doneedit(event) {
// done with textarea editing
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	var ta = note.firstChild;
	ta.readOnly = true;
	ta.style.backgroundColor = "transparent";
	note.childNodes[1].style.display = "block"; // show pencil buttons
	note.childNodes[2].style.display = "none"; // hide "done edit" button
	note.addEventListener("mousedown", stickynoteMD, false);
	note.addEventListener("mouseover", stickynoteMOV, false);
	note.addEventListener("mouseout", stickynoteMOT, false);
}
function stickynoteMOV(event) {
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	note.childNodes[1].style.display = "block";
}
function stickynoteMOT(event) {
// on mouse out
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	note.childNodes[1].style.display = "none";
}
function stickynoteMD(event) {
	event.preventDefault();
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	stickynote.onfocus = note;
	document.body.addEventListener("mousemove", stickynoteM, false);
	document.body.addEventListener("mouseup", stickynoteMU, false);
	note.oldX = event.clientX;
	note.oldY = event.clientY;
}
function stickynoteM(event) {
	var n = stickynote.onfocus;
	n.style.left = parseInt(n.style.left) + event.clientX - n.oldX;
	n.style.top = parseInt(n.style.top) + event.clientY - n.oldY;
	n.oldX = event.clientX;
	n.oldY = event.clientY;
}
function stickynoteMU(event) {
	document.body.removeEventListener("mousemove", stickynoteM, false);
	document.body.removeEventListener("mouseup", stickynoteMU, false);
}
/* __sticky__ note ends */











function oneshot(event)
{
/* called by clicking a logo to select a genome from oneshot panel
genome dbname is given by .title
*/
var d=event.target;
while(!d.dbname) d=d.parentNode;
document.getElementById('oneshot').style.display='none';
pagecloak.style.display = 'none';
if(event.target.fastload)
	browser.loadgenome_initbrowser(d.dbname,{nohmtk:true});
else
	browser.loadgenome_initbrowser(d.dbname);
setTimeout("floatingtoolbox.style.display='block'",500);
}
function oneshot_mover(event)
{
var d=event.target;
while(d.className!='oneshot') d=d.parentNode;
d.firstChild.style.opacity=0.7;
d.childNodes[2].style.display='block';
}
function oneshot_mout(event)
{
var d=event.target;
while(d.className!='oneshot') d=d.parentNode;
d.firstChild.style.opacity=0.4;
d.childNodes[2].style.display='none';
}
function oneshotDialog(which,msg)
{
/* this is one shot, 
fires up the oneshot dialog when the browser needs user to make some choice to start properly
args: which
  1: show list of genome
  2: show saved status under a session
msg: an additional message to be printed on oneshot panel, warning or further instruction
*/
cloakPage();
var d = document.getElementById('oneshot');
d.style.display = 'block';
d.style.left = 200;
d.style.top = 100;
var d2 = document.getElementById('oneshotmsg');
if(msg == null) {
	d2.style.display = 'none';
} else {
	d2.style.display = 'block';
	d2.innerHTML = msg;
}
floatingtoolbox.style.display='none';
var header = document.getElementById('oneshotheader');
switch(which) {
case 1: // show list of genome
	header.innerHTML='Select a genome';
	browser.ajax('oneshot=on', function(data){
		var holder = document.getElementById('oneshotbelly');
		holder.style.backgroundColor='';
		stripChild(holder.firstChild, 0);
		var organism2td={}; // for putting minor genomes following their major guys
		for(var i=0; i<data.dblst.length; i++) {
			// the .title is used to provide dbname when clicked
			var v=data.dblst[i];
			if(v.ismajor!=1) continue;
			var d = document.createElement('div');
			d.dbname=v.dbname;
			d.className = 'oneshot';
			d.addEventListener('click', oneshot, false);
			d.addEventListener('mouseover',oneshot_mover,false);
			d.addEventListener('mouseout',oneshot_mout,false);
			var img=document.createElement('img');
			img.src='images/'+v.organism+'.png';
			d.appendChild(img);
			var d3 = document.createElement('div');
			d3.innerHTML=v.label;
			d.appendChild(d3);
			var tr=holder.insertRow(-1);
			tr.insertCell(0).appendChild(d);
			organism2td[v.organism]=tr.insertCell(1);
			var d4=document.createElement('div');
			d.appendChild(d4);
			d4.innerHTML='Quick';
			d4.title='Do not load default experimental assay tracks';
			d4.fastload=true; // for event
		}
		for(i=0; i<data.dblst.length; i++) {
			var v=data.dblst[i];
			if(v.ismajor!=1) {
				var d=document.createElement('div');
				d.className='header_gr';
				d.innerHTML=v.dbname;
				d.dbname=v.dbname;
				d.addEventListener('click',oneshot,false);
				organism2td[v.organism].appendChild(d);
			}
		}
				
		var d = document.getElementById('oneshot');
		d.style.left = (document.body.clientWidth-d.clientWidth)/2;
		d.style.top = (document.body.clientHeight-d.clientHeight)/2;
	});
	return;
case 2: // list status under a session
	header.innerHTML = 'Click <span class=header_g>name</span> to restore past browsing status';
	document.getElementById('oneshotbelly').style.backgroundColor='rgba(255,255,255,0.5)';
	var d = document.getElementById('oneshot');
	d.style.left = (document.body.clientWidth-d.clientWidth)/2;
	d.style.top = (document.body.clientHeight-d.clientHeight)/2;
	return;
default: fatalError('oneshotDialog: unknown which');
}
}



function makeUrl()
{
/* sukn only for the moment
TODO: FT_sam_n, FT_cat_c

custom md term in mcm not supported
dataset not supported
*/
var urlarr=[window.location.protocol+'//'+window.location.host+window.location.pathname+'?genome='+browser.genome.name];
var hmtk=[], gftk=[], custombed=[], custombedgraph=[], custombigwig=[], customlongrange=[], customsam=[];
for(var i=0; i<browser.tklst.length; i++) {
	/* custom tk label might contain space
	but escape() to %20 cannot be decoded..
	must be converted to +
	*/
	var t=browser.tklst[i];
	var m=('mode' in t) ? mode2str[t.mode] : '';
	var label=t.label.replace(/\s/g, '+'); // space must be converted to +
	switch(t.ft) {
	case FT_bed_n:
		gftk.push(t.name+','+m);break;
	case FT_bed_c:
		custombed.push(label+','+t.url+','+m);break;
	case FT_bedgraph_n:
		hmtk.push(t.name);break;
	case FT_bedgraph_c:
		custombedgraph.push(label+','+t.url);break;
	case FT_sam_c:
		customsam.push(label+','+t.url+','+m);break;
	case FT_lr_n:
		gftk.push(t.name+','+mode2str[t.mode]);break;
	case FT_lr_c:
		customlongrange.push(label+','+t.url+','+m);break;
	case FT_cat_n:
		hmtk.push(t.name);break;
	case FT_bigwighmtk_n:
		hmtk.push(t.name);break;
	case FT_bigwighmtk_c:
		custombigwig.push(label+','+t.url);break;
	};
	// don't die on unknown ft
}
if(hmtk.length>0) urlarr.push('&hmtk='+hmtk.join(','));
if(gftk.length>0) urlarr.push('&gftk='+gftk.join(','));
if(custombed.length>0) urlarr.push('&custombed='+custombed.join(','));
if(custombedgraph.length>0) urlarr.push('&custombedgraph='+custombedgraph.join(','));
if(custombigwig.length>0) urlarr.push('&custombigwig='+custombigwig.join(','));
if(customsam.length>0) urlarr.push('&customsam='+customsam.join(','));
if(customlongrange.length>0) urlarr.push('&customlongrange='+customlongrange.join(','));

if(browser.mcm.lst.length>0) {
	// only use native terms...
	var lst=[];
	for(var i=0; i<browser.mcm.lst.length; i++) {
		var s=browser.mcm.lst[i];
		if(!s[1]) lst.push(s[0]);
	}
	if(lst.length>0)
		urlarr.push('&metadata='+lst.join(','));
}

var jt=browser.juxtaposition.type;
if(jt==RM_gsv_c || jt==RM_gsv_kegg) {
	var lst=[];
	for(var i=0; i<browser.genesetview.lst.length; i++)
		lst.push(browser.genesetview.lst[i].name);
	urlarr.push('&geneset='+lst.join(','));
} else {
	var tmp=browser.getDspStat();
	if(tmp[0]==tmp[2]) {
		urlarr.push('&coordinate='+tmp[0]+':'+tmp[1]+'-'+tmp[3]);
	} else {
		urlarr.push('&coordinate='+tmp[0]+':'+tmp[1]+'-'+browser.genome.scaffold.len[tmp[0]]);
	}
	if(jt==RM_jux_n) {
		urlarr.push('&juxtapose='+browser.juxtaposition.what);
	} else if(jt==RM_jux_c) {
		urlarr.push('&juxtaposecustom=on&juxtapose='+browser.juxtaposition.what);
	}
}

var spt=[];
for(var tag in browser.splinters) {
	var c=browser.splinters[tag].splinterCoord;
	spt.push(c[0]+':'+c[1]+'-'+c[2]);
}
if(spt.length>0)
	urlarr.push('&splitview='+spt.join(','));

var d=document.getElementById('urlHolder');
d.style.display='block';
var u=urlarr.join('');
d.innerHTML='<p style="color:#858585">Share this URL ('+u.length+' characters) so that others can see the same content as you\'re seeing now</p>'+
'<a href="'+u+'" target=_blank>'+u+'</a>';
}

function sukn_initializeGenome(obj)
{
// sukn specific
obj.newcustmd_setattrvalue();
// called when urlparam, load default db, change db
var m=obj.mdselect;
m.custpriortable3=document.getElementById('custpriortable3');
m.custpriortable1=document.getElementById('custpriortable1');
m.custpriortable10=document.getElementById('custpriortable10');
m.custpriortable5=document.getElementById('custpriortable5');
m.custpriortable15=document.getElementById('custpriortable15');
/* cust tk interface
but custtk facet belongs to browser */
obj.custtk={
	wrapper_bed:document.getElementById("customtrackwrapper_1"),
	wrapper_bedgraph:document.getElementById("customtrackwrapper_3"),
	wrapper_sam:document.getElementById("customtrackwrapper_5"),
	wrapper_lr:document.getElementById("customtrackwrapper_10"),
	wrapper_bigwig:document.getElementById("customtrackwrapper_15"),
	wrapper_hub:document.getElementById("customtrackwrapper_100"),
	wrapper_registry:document.getElementById("customtrackwrapper_101"),
	wrapper_launch:document.getElementById('custtkpanel_launchdiv'),
	wrapper_goback:document.getElementById('custtkpanel_goback'),
	totalcount:document.getElementById('custtrackhowmany'),
	totalcount2:document.getElementById('custtrackhowmany2'),
};
/*
obj.tkselect={
	main:document.getElementById('tkspanel'),
	smallmenu:document.getElementById('tkspanelSmallmenu'),
	hmdiv:document.getElementById('hmtksp_div'),
	hmholder:document.getElementById('hmtksp_holder'),
	decor:{
		main:document.getElementById('decorsp_div'),
		grpholder:document.getElementById('decorgrp_holder'),
		tkholder:document.getElementById('decortk_holder'),
	},
};
*/
obj.scaffold.cpholder = document.getElementById('scaffold_cpholder');
obj.scaffold.spanel = document.getElementById('scfspanel');
obj.scaffold.updatebutt = document.getElementById('scaffold_updatebutt');
}



function urlparam_handleTriggers()
{
/* handle track-related triggers in recursive fashion
because loading datahub cannot be done with other processes
but won't call readygo again, so need to print errors to console

when doing ajax calls to process triggers,
must return and exit current function so to let ajax work
need to delete trigger from urlparam.hash before or during the call
because the ajax will call this function again to process remaining trigger,
lazy and recursive, but simple

only call once, separated from calling routine to reduce indent
*/
if('datahub' in gflag.urlparam.hash) {
	// try to load up the hub
	document.getElementById('datahuburl').value = gflag.urlparam.hash.datahub;
	delete gflag.urlparam.hash.datahub;
	gflag.tsp.bbj=browser; // patch, so that loaddatahub() can run
	loaddatahub();
	return;
}
if('datahubtext' in gflag.urlparam.hash) {
	// url-encoded datahub text
	var text=gflag.urlparam.hash.datahubtext;
	delete gflag.urlparam.hash.datahubtext;
	gflag.tsp.bbj=browser; // patch, so that loaddatahub() can run
	loaddatahub(text);
	return;
}

/* each type of tracks are specified with given parameters
fetch all tracks with a single ajax query

notice:
native longrange tracks are still supplied from "gftk", but they are registered in genome.hmtk

notice:
before parsing native assay tracks, dataset must be loaded, or else the track won't be recognized

TODO custom categorical tracks, native sam
*/
var _tklst=[];
var nativehmtkparam='';

if('hmtk' in gflag.urlparam.hash) {
	// native bedgraph/bigwig/categorical
	// all must be found in genome.hmtk as corresponding datasets should have been loaded
	var lst = gflag.urlparam.hash.hmtk.split(',');
	for(var i=0; i<lst.length; i++) {
		var o=browser.genome.hmtk[lst[i]];
		if(o!=undefined)
			_tklst.push({name:lst[i],ft:o.ft,mode:M_show});
	}
	delete gflag.urlparam.hash.hmtk;
}

// as cgi won't keep label for custom hmtk (not sent by hmtkChoice()), need to keep in global variable


if('custombedgraph' in gflag.urlparam.hash) {
	// custom bedgraph: label, url
	var lst = gflag.urlparam.hash.custombedgraph.split(',');
	var sthwrong = false;
	var param = [];
	for(var i=0; i<lst.length; i+=2) {
		if(lst[i].length==0 || lst[i+1]==undefined || lst[i+1].length==0) {
			sthwrong=true;
			break;
		}
		if(!browser.genome.tkurlInUse(lst[i+1])) {
			_tklst.push({name:browser.genome.newcustomtrackname(),label:unescape(lst[i]),url:lst[i+1],ft:FT_bedgraph_c,mode:M_show});
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid "custombedgraph" parameter value '+urlparamhelp, 2);
	delete gflag.urlparam.hash.custombedgraph;
}
if('custombigwig' in gflag.urlparam.hash) {
	// custom bigwig: label, url
	var lst = gflag.urlparam.hash.custombigwig.split(',');
	var sthwrong = false;
	var param = [];
	for(var i=0; i<lst.length; i+=2) {
		if(lst[i].length==0 || lst[i+1]==undefined || lst[i+1].length==0) {
			sthwrong=true;
			break;
		}
		if(!browser.genome.tkurlInUse(lst[i+1])) {
			_tklst.push({name:browser.genome.newcustomtrackname(),label:unescape(lst[i]),url:lst[i+1],ft:FT_bigwighmtk_c,mode:M_show});
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid "custombigwig" parameter value '+urlparamhelp, 2);
	delete gflag.urlparam.hash.custombigwig;
}
if('gftk' in gflag.urlparam.hash) {
	/* native bed/qdecor/longrange: name, mode
	notice: longrange has been deemed as assay track and registered in genome.hmtk
	but native longrange are still supplied from "gftk"
	TODO native sam?
	*/
	var lst = gflag.urlparam.hash.gftk.split(',');
	var sthwrong = false;
	for(var i=0; i<lst.length; i+=2) {
		var o=browser.genome.decorInfo[lst[i]];
		if(o==undefined) o=browser.genome.hmtk[lst[i]];
		if(o==undefined) {
			print2console('unknown native decor track name "'+lst[i]+'"',2);
			continue;
		}
		if(lst[i].length>0 && lst[i+1]!=undefined && browser.findTrack(lst[i])==null) {
			if(o.ft== FT_bed_n) {
				var m = decormodestr2num(lst[i+1]);
				if(m==undefined || (m!=M_thin && m!=M_full && m!=M_den)) m=M_den;
				_tklst.push({name:lst[i],ft:o.ft,mode:m});
			} else if(o.ft==FT_qdecor_n || o.ft==FT_bigwighmtk_n) {
				_tklst.push({name:lst[i],ft:o.ft,mode:M_show});
			} else if(o.ft== FT_lr_n) {
				var m = decormodestr2num(lst[i+1]);
				if(m==undefined || (m!=M_thin && m!=M_full && m!=M_den && m!=M_arc && m!=M_trihm)) m=M_den;
				var style=browser.genome.trackDefaultparam[lst[i]];
				_tklst.push({name:lst[i],ft:o.ft,mode:m,
					qtc:{pfilterscore:(style==undefined?2:style.pfilterscore),
						nfilterscore:(style==undefined?-2:style.nfilterscore)}});
			} else if(o.ft==FT_cat_n) {
				_tklst.push({name:lst[i],ft:o.ft,mode:M_show});
			} else {
				fatalError('urlparam_handleTriggers: ft error with gftk param');
			}
		} else { 
			sthwrong=true;
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid value for "gftk" parameter '+urlparamhelp, 2);
	delete gflag.urlparam.hash.gftk;
}
if(browser.juxtaposition.type == RM_jux_n) {
	// juxtaposing with native bed track, bring it up if it isn't there yet
	// the track should be valid, already dealt with in dsp making
	var dn = browser.juxtaposition.what;
	if(browser.findTrack(dn)==null) {
		// this is because this track might have been added in previous iteration
		var found=false;
		for(var i=0; i<_tklst.length; i++) {
			if(_tklst[i].name==dn) {
				found=true; break;
			}
		}
		if(!found) {
			_tklst.push({name:dn, ft:browser.genome.decorInfo[dn].ft, mode:M_full});
		}
	}
}
if('custombed' in gflag.urlparam.hash) {
	// custom bed, not including longrange: label, url, mode
	var sthwrong = false;
	var lst = gflag.urlparam.hash.custombed.split(',');
	for(var i=0; i<lst.length; i+=3) {
		if(lst[i].length>0 && lst[i+1]!=undefined && lst[i+1].length>0 && lst[i+2]!=undefined && lst[i+2].length>0) {
			if(!browser.genome.tkurlInUse(lst[i+1])) {
				var m = decormodestr2num(lst[i+2]);
				if(m==undefined || (m!=M_thin && m!=M_full && m!=M_den)) m=M_den;
				_tklst.push({name:browser.genome.newcustomtrackname(),label:unescape(lst[i]),url:lst[i+1],mode:m,ft:FT_bed_c});
			}
		} else {
			sthwrong=true;
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid value for "custombed" parameter '+urlparamhelp, 2);
	delete gflag.urlparam.hash.custombed;
}
if('customlongrange' in gflag.urlparam.hash) {
	// custom longrange: label, url, mode
	var lst = gflag.urlparam.hash.customlongrange.split(',');
	var sthwrong = false;
	for(var i=0; i<lst.length; i+=3) {
		if(lst[i].length>0 && lst[i+1]!=undefined && lst[i+1].length>0 && lst[i+2]!=undefined) {
			if(!browser.genome.tkurlInUse(lst[i+1])) {
				var m = decormodestr2num(lst[i+2]);
				if(m==undefined || (m!=M_thin && m!=M_full && m!=M_den && m!=M_arc && m!=M_trihm)) m=M_den;
				var v1 = parseFloat(document.getElementById('stc_longrange_pfilterscore').value);
				if(v1<0) v1=0-v1;
				var v2 = parseFloat(document.getElementById('stc_longrange_nfilterscore').value);
				if(v2>0) v2=0-v2;
				_tklst.push({name:browser.genome.newcustomtrackname(),label:unescape(lst[i]),url:lst[i+1],mode:m,
					ft:FT_lr_c, qtc:{pfilterscore:v1,nfilterscore:v2}});
			}
		} else {
			sthwrong=true;
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid value for "customlongrange" parameter '+urlparamhelp, 2);
	delete gflag.urlparam.hash.customlongrange;
}
/* juxtaposing custom bed, add it if it's missing
*/
if(browser.juxtaposition.type == RM_jux_c) {
	var url = browser.juxtaposition.what;
	if(!browser.genome.tkurlInUse(url)) {
		var notthere=true;
		for(var i=0; i<_tklst.length; i++) {
			if(isCustom(_tklst[i].ft)) {
				if(_tklst[i].url==url) {
					notthere=false; break;
				}
			}
		}
		if(notthere) {
			_tklst.push({name:browser.genome.newcustomtrackname(),
				ft:FT_bed_c,label:'Juxtaposition',url:url,mode:M_full});
		}
	}
}

/* TODO native sam
if('bam' in gflag.urlparam.hash) { // native bam files
if(gflag.urlparam.hash.bam.length == 0) {
	print2console('URL parameter error: "bam" parameter got 0 length value', 2);
} else {
	var lst = gflag.urlparam.hash.bam.split(',');
	var sthwrong = false;
	for(var i=0; i<lst.length; i+=2) {
		if(lst[i].length>0 && lst[i+1]!=undefined && decormodestr2num(lst[i+1])!=undefined) {
		decor4lst.push(lst[i]); decor4lst.push(decormodestr2num(lst[i+1]));
	} else {sthwrong=true;}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid value for "bam" parameter', 2);
}
delete gflag.urlparam.hash.bam;
}
*/
if('customsam' in gflag.urlparam.hash) {
	// custom sam: label, url, mode
	var lst = gflag.urlparam.hash.customsam.split(',');
	var sthwrong = false;
	for(var i=0; i<lst.length; i+=3) {
		if(lst[i].length>0 && lst[i+1]!=undefined && lst[i+1].length>0 && lst[i+2]!=undefined && lst[i+2].length>0) {
			if(!browser.genome.tkurlInUse(lst[i+1])) {
				var m = decormodestr2num(lst[i+2]);
				if(m == undefined || (m!=M_thin && m!=M_full && m!=M_den)) m=M_den;
				_tklst.push({name:browser.genome.newcustomtrackname(),label:unescape(lst[i]),url:lst[i+1],mode:m,ft:FT_sam_c});
			}
		} else {
			sthwrong=true;
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid value for "customsam" parameter', 2);
	delete gflag.urlparam.hash.customsam;
}

// ajax
if(_tklst.length > 0) {
	print2console('loading tracks...',0);
	browser.ajax(browser.displayedRegionParamPrecise()+'&addtracks=on'+trackParam(_tklst)+'&dbName='+browser.genome.name,function(data){
		gflag.tsp.bbj=browser;
		var custtknames=[]; // for flipping their showbutt later
		if('decorData' in data) {
			for(var i=0; i<data.decorData.length; i++) {
				var dt = data.decorData[i];
				if(isCustom(dt.ft)) {
					dt.md=[];
					dt.custmd={};
					registerCustomtrack(dt);
					custtknames.push(dt.name);
				}
			}
		}
		if('hmtkData' in data) {
			for(var i=0; i<data.hmtkData.length; i++) {
				var t=data.hmtkData[i];
				if(isCustom(t.ft)) {
					registerCustomtrack({
						name:t.name, 
						ft:t.ft,
						url:t.url,
						label:t.label,
						md:[],
						custmd:{}});
					custtknames.push(t.name);
				}
			}
		}
		browser.jsonTrackdata(data);

		for(var i=0; i<custtknames.length; i++)
			browser.genome.hmtk[custtknames[i]].showbutt.innerHTML='hide';

		/* just in case, just in case..
		when native and custom track are mixed together */


		// don't do cfacet, no custom term
		browser.mcm_sort();
		browser.prepareMcm();
		browser.trackHeightChanged();
		urlparam_handleTriggers(); // go on
	});
	return;
}

/** do not handle no track case
no matter whether urlparam has track or not
it will always reach here by recursion
**/
browser.initiateMdcOnshowCanvas();
browser.render_browser(false);
browser.generateTrackselectionLayout();


if('splitview' in gflag.urlparam.hash) {
	browser.splinterFromcoordlst(gflag.urlparam.hash.splitview.split(','));
	delete gflag.urlparam.hash.splitview;
}

done();
gflag.urlparam.willcontinue = false;
}


function longrange_shortcut()
{
var gn=browser.genome.name;
if(gn!='hg19' && gn!='mm9' && gn!='dm3') {
	print2console('This genome currently does not contain public long-range interaction data sets.',2);
	return;
}
gflag.tsp.bbj=browser;
if(apps.hmtk.style.display=='none') {
	toggle1();
}
simulateEvent(browser.facet.tab_facet,'click');
gflag.menu.termname='Long Range Interaction';
gflag.menu.currentaspect='vertical';
facet_subtable('0');
}



function toggle10()
{
var bait = document.getElementById('genesetviewpanel');
if(bait.style.display=='none') {
	cloakPage();
	document.getElementById('gsv_uiholder').appendChild(browser.genesetview.main);
	panelFadein(bait, 100+document.body.scrollLeft, 100+document.body.scrollTop);
	menu_hide();
	gflag.gsv.bbj=browser;
} else {
	pagecloak.style.display='none';
	panelFadeout(bait);
}
}

function __tklst() {
	var lst=[];
	for(var i=0; i<browser.tklst.length; i++) lst.push(browser.tklst[i].name);
	return lst.join(',');
}


function sukn_keyup(event)
{
if(event.keyCode!==27) return;
for(var appname in apps) {
	if(apps[appname].style.display!='none') {
		pagecloak.style.display='none';
		panelFadeout(apps[appname]);
		return;
	}
}
}


// READY
function readygo()
{
/* no argument, will be called only once upon loading browser for first time

handles url parameter
if there's no proper url parameter, will pop up oneshot dialog for choosing genome
*/

document.getElementById('washucuddle').innerHTML=washUtag;
document.getElementById('oneshot_washugb').innerHTML=washUtag;

document.body.addEventListener('keyup',sukn_keyup,false);

browser=new Browser();

gflag.browser=browser;
document.getElementById('sessionId').innerHTML=browser.sessionId;

/* decide hmSpan
the  is a guess of default width of mdcholder.holder,
will be determined by # terms shown on default
 */
browser.leftColumnWidth=110;
browser.init_hmSpan();
browser.browser_makeDoms({
	centralholder:document.getElementById('sukn_main'),
	browser_stat:true,
	navigator:true,
	navigator_ruler:true,
	hmdivbg:'white',
	ghm_scale:true,
	ghm_ruler:true,
	tkheader:true,
	mcm:true,
	gsselect:true,
	// gsv
	gsv:true,
	gsv_geneplot:true,
	// hmtk facet
	nativefacet:true,
	tab_facet:true,
	tab_dataset:true,
	body_class:'tabpageBody',
	});
// sukn-specific tweaks
browser.hmdiv.style.backgroundColor='white';
browser.ideogram.canvas.oncontextmenu=menu_coordnote;
browser.mcm.holder.attop = true; // tells if holder be placed on top or bottom of mcm

browser.applyHmspan2holders();

// custom facet
bf=browser.cfacet;
bf.md1=document.getElementById('custmdselect_row');
bf.md1.which='md1';
bf.md2=document.getElementById('custmdselect_col');
bf.md2.which='md2';
bf.holder=document.getElementById('custtkfacetholder');



/*
addhtestgroup();
addhtestgroup();
var bp=browser.pwc;
bp.canvas = document.getElementById('pwccanvas');
bp.canvas.height = bp.qtc.height + densitydecorpaddingtop*2;
bp.viewbox = document.getElementById('pwcviewbox');
bp.viewbox.style.height = bp.canvas.height;
bp.header = document.getElementById("pairwisecompHeaderCanvas");
bp.header.height = bp.canvas.height;
addpwcgroups();
bp.grp1 = document.getElementById("pairwisecompgroup1");
bp.grp2 = document.getElementById("pairwisecompgroup2");
*/

/* following are stuff belonging to "page", shared by all browser instances */



appbutt=document.getElementById('appbutt');

hengeview.panel=document.getElementById('hengeviewpanel');
hengeview.holder=document.getElementById('hengeview_mainholder');
hengeview.handleholder=document.getElementById('hengeview_handleholder');


scalebarbeam=document.getElementById('scalebarbeam');
scalebarMout();

page_makeDoms({gsselect:true,});

document.getElementById('geneplot_butt').addEventListener('click', makeGeneplot, false);

//drawCorrscalecanvas();

floatingtoolbox = document.getElementById("floatingtoolbox");
msgconsole = document.getElementById("msgconsole");
floatingtoolbox.style.left=browser.leftColumnWidth+browser.hmSpan-300;

simulateEvent(document.getElementById('geneplotrender'),'change');

apps={
gsv:document.getElementById('genesetviewpanel'),
bev:document.getElementById('bait18'),
hengeview:document.getElementById('hengeviewpanel'),
svg:document.getElementById('bait33'),
gplot:document.getElementById('geneplotpanel'),
custtk:document.getElementById('customtkpanel'),
hmtk:document.getElementById('nativehmtkpanel'),
session:document.getElementById('session_panel')
};
apps.gsv.firstChild.firstChild.style.backgroundColor=
apps.bev.firstChild.firstChild.style.backgroundColor=
apps.svg.firstChild.firstChild.style.backgroundColor=
apps.gplot.firstChild.firstChild.style.backgroundColor=
apps.custtk.firstChild.firstChild.style.backgroundColor=
apps.hmtk.firstChild.firstChild.style.backgroundColor=
apps.session.firstChild.firstChild.style.backgroundColor=
colorCentral.pagebg;
apps.hengeview.firstChild.firstChild.style.backgroundColor='#f8ffeb';

if(window.location.href.indexOf('?') == '-1') {
	// no url parameter, show dialog to prompt user to select db to use
	oneshotDialog(1,null);
	return;
}

/*** processing url parameter
***/
var garbledUrl=false;
var lst = window.location.href.split('?')[1].split('&');
var pmhash = {};
for(var i=0; i<lst.length; i++) {
	var t = lst[i].split('=');
	if(t.length==2 && t[0].length>0 && t[1].length>0) {
		pmhash[t[0].toLowerCase()] = t[1];
	} else {
		garbledUrl=true;
	}
}
if(garbledUrl) {
	oneshotDialog(1,'Garbled URL parameter '+urlparamhelp);
	return;
}
if(!('genome' in pmhash)) {
	oneshotDialog(1,'URL parameter error:<br>missing essential parameter "genome" '+urlparamhelp);
	return;
}
gflag.urlparam.hash = pmhash;

/* which datasets to load 
so that native assay tracks from parameter can be recognized
*/
var nativetk={};
if('hmtk' in gflag.urlparam.hash) {
	var lst=gflag.urlparam.hash.hmtk.split(',');
	for(var i=0; i<lst.length; i++)
		nativetk[lst[i]]=1;
}
if('gftk' in gflag.urlparam.hash) {
	var lst=gflag.urlparam.hash.gftk.split(',');
	for(var i=0; i<lst.length; i+=2)
		nativetk[lst[i]]=1;
}
var lst=[];
for(var tk in nativetk) lst.push(tk);

// genome is essential parameter, validate dbname
browser.ajax('first=on&loadgenome=on&validateurlparam_genome='+gflag.urlparam.hash.genome+(lst.length>0?'&hmtk4dataset='+lst.join(','):''), function(data){
	if('genome_not_found' in data) {
		// invalid dbname
		oneshotDialog(1, 'URL parameter error:<br>invalid value for "genome" parameter '+urlparamhelp);
		return;
	}
	/* correct dbname, make genome object */
	print2console('genome name is valid', 1);
	var genomeobj=new Genome({custom_md:true});
	sukn_initializeGenome(genomeobj);
	genomeobj.jsonGenome(data);
	genome[genomeobj.name]=genomeobj;
	browser.genome=genomeobj;
	browser.migratedatafromgenome();
	__jsonPageinit(data);

	/*** fillup browser contents by url parameter ***/

	if('session' in gflag.urlparam.hash) {
		/*** trigger - session ***
		session content overrides everything else
		*/
		gflag.urlparam.willcontinue=false;
		browser.sessionId=gflag.urlparam.hash.session;
		if('statusid' in gflag.urlparam.hash) {
			// statusid is provided
			browser.statusId=parseInt(gflag.urlparam.hash.statusid);
			browser.ajax('validateurlparam_sessionstatus=on&dbName='+browser.genome.name,function(data) {
				if(data.error) {
					oneshotDialog(1, 'URL parameter error:<br>session not found '+urlparamhelp);
					return;
				}
				// session/status is valid
				browser.restoreStatus(browser.statusId);
			});
		} else {
			browser.ajax('validateurlparam_session=on&dbName='+browser.genome.name,function(data) {
				if(data.statusLst==undefined) {
					oneshotDialog(1, 'URL parameter error:<br>session not found '+urlparamhelp);
					return;
				}
				// session is valid
				print2console('valid session id', 1);
				var holder = document.getElementById('oneshotbelly');
				stripChild(holder, 0);
				for(var i=1; i<data.statusLst.length; i++) {
					var v=data.statusLst[i];
					addRow4newStatus(holder,v[0],v[1],v[2], v[3], v[4], false);
				}
				oneshotDialog(2, null);
			});
		}
		return;
	}

	/*** no session ***/
	gflag.urlparam.willcontinue=true;
	// add metadata
	if('metadata' in gflag.urlparam.hash) {
		// native terms only
		var lst = gflag.urlparam.hash.metadata.split(',');
		var toadd = [];
		for(var i=0; i<lst.length; i++) {
			if(lst[i].length==0) continue;
			var v=unescape(lst[i]);
			if(v in browser.genome.mdvp2c) {
				// non-leaf term
				toadd.push(v);
			} else {
				// potential leaf term
				if(v in browser.genome.mdvidx2attr) toadd.push(v);
			}
		}
		browser.mdcFromNativeTerms(toadd);
		delete gflag.urlparam.hash.metadata;
	}
	/* X axis contents can be determined in following ways 
	* genome or juxtaposition
	  - coordinate param is optional, if missing, will use default position
	* gene set view
	*/
	if('geneset' in gflag.urlparam.hash) {
		var s = gflag.urlparam.hash.geneset;
		if(s.length==0 || s.indexOf(',')==-1) {
			print2console('URL parameter error: "geneset" parameter got invalid value', 2);
			// won't quit but will go on to process remaining params
		} else {
			gflag.gsv.bbj=browser; // must do this
			// must update state before calling routine
			var j=browser.juxtaposition;
			j.type=RM_gsv_c;
			j.what=j.note='custom gene set';

			browser.genesetview.submit_textarea.value = s.split(',').join('\n');
			browser.submitGeneset_custom();
			// must quit here due to ajax
			return;
		}
	} else {
		// either with 'coordinate' and 'juxtapose', or none of them
		var lst=browser.genome.defaultStuff.coord.split(',');
		var startchr=lst[0];
		var stopchr=lst[2];
		var startcoord=parseInt(lst[1]);
		var stopcoord=parseInt(lst[3]);
		if('coordinate' in gflag.urlparam.hash) {
			var s = gflag.urlparam.hash.coordinate;
			var pos = [null, NaN, NaN];
			if(s.length == 0) {
				print2console('URL parameter error: "coordinate" parameter got 0 length value '+urlparamhelp, 2);
			} else {
				// parse user provided coord string, must be in form of chr1:300-400
				if(s.indexOf(':') == -1) {
					print2console('URL parameter error: irregular "coordinate" parameter value '+urlparamhelp, 2);
				} else {
					var t1 = s.split(':');
					pos[0] = t1[0];
					if(t1[1].indexOf('-') == -1) {
						print2console('URL parameter error: irregular "coordinate" parameter value '+urlparamhelp, 2);
					} else {
						var t2 = t1[1].split('-');
						pos[1] = parseInt(t2[0]);
						pos[2] = parseInt(t2[1]);
					}
				}
			}
			if(pos[0]!=null && !isNaN(pos[1]) && !isNaN(pos[2])) {
				startchr = stopchr = pos[0];
				startcoord = pos[1];
				stopcoord = pos[2];
			}
		}
		var param = 'changeGF=on&dbName='+browser.genome.name+'&startChr='+startchr+'&startCoord='+startcoord+'&stopChr='+stopchr+'&stopCoord='+stopcoord;
		browser.juxtaposition.type = RM_genome;
		browser.juxtaposition.note = 'genome';
		browser.juxtaposition.what = 'genome';

		if('juxtapose' in gflag.urlparam.hash) {
			var bbf = gflag.urlparam.hash.juxtapose;
			if(bbf.length == 0) {
				print2console('URL parameter error: "juxtapose" parameter got 0 length value', 2);
				param += '&gftype=genome';
			} else {
				if('juxtaposecustom' in gflag.urlparam.hash) {
					// custom bed
					browser.juxtaposition.type = RM_jux_c;
					browser.juxtaposition.note = "custom bed track";
					browser.juxtaposition.what = bbf;
					param += '&gftype='+bbf+'&gfiscustom=on';
				} else {
					var tk=browser.genome.decorInfo[bbf];
					if(tk!=undefined && tk.ft==FT_bed_n) {
						// native bed
						browser.juxtaposition.type = RM_jux_n;
						browser.juxtaposition.note = tk.label;
						browser.juxtaposition.what = bbf;
						param += '&gftype='+bbf;
					} else {
						print2console('URL parameter error: invalid native annotation track name provided for "juxtapose" '+urlparamhelp, 2);
						param += '&gftype=genome';
					}
				}
			}
		}

		print2console("adjusting range of display ...", 0);
		// duplicative with ajaxX
		browser.ajax(param, function(data){
			if('newscaffold' in data) {
				browser.genome.addnewscaffold([data.newscaffold[0]]);
			}
			browser.jsonDsp(data);
			urlparam_handleTriggers();
		});
		return; // must quit here
	}
	return;
});
}
