/***  global variables ***/
horcrux={}; // as expected


var washUtag='\
<span style="color:#99B3FF;">W<span style="font-size:70%;">ASH</span>U</span> \
<span style="color:#FFDF80;">E<span style="font-size:70%;">PI</span></span>\
<span style="color:#80FF9F;">G<span style="font-size:70%;">ENOME</span></span> \
<span style="color:#FF809F;">B<span style="font-size:70%;">ROWSER</span>';

var gflag = {
browser:undefined,
minichrjumping:false,
hasgene:true, // TODO move to genome
allowjuxtaposition:true,
cpmove:{dom:null,oldx:0,oldy:0},
movebbj:null,
mcmtermmove:{},
headerMove:{inuse:false}, // press on tk header and move vertically
arrowpan:{}, // animated panning by clicking arrow
hmtkunderfocus:null, // for getting info on a track
// for custom track to be submitted [name, label, url]
customtmp:{name:null,label:null,url:null,mode:null,md:[],custmd:{}},
// for processing urlparam when loading the page
urlparam:{usingsession:false,willcontinue:false},
// for categorical track configuration
cateTk:{which:-1, // see doc
	itemidx:null, // category idx
	item:null, // the color blob for the itemidx in config panel
	}, 
// drawing ideogram bar at bp level
ideogram:{},
// querying sam read info when clicking on a sam track
samread:{},
// moving terms horizontally in mcm metadata colormap
zoomin:{}, // for zoom in
zoomout:{}, // for zoom out
mdp:{}, // invoking metadata vocabular panel
tsp:{invoke:{type:-1},}, // invoking track selection panel, for purpose of submission
/* type -1: not applicable
1 native, clicking cell in big grid or sub-table
2 native, clicking cell in the single criterion tree
3 native, clicking "select all" option when mouse over a term in the big grid
4 native, keyword search
5 custom, clicking a cell in custom track grid
*/
menu:{ // context menu
	catetk:{}, // categorical track
	},
gsvreorder:{}, // drag item to recorder in gsv
ctmae:{}, // custom track md anno editing
splinter:null, // set to not null for splintering
splinter_todolst:[], // fill content to indicate splinters come from restoring session or urlparam
bev:{}, // mainly to know which browser is calling bev
gplot:{}, // for geneplot
gsv:{}, // for gene set view
sess:{}, // for session
jump:{}, // context for jumping ui
};

var apps={};

/*** string literals ***/
var literal_hic='Hi-C'; // to recognize and turn hi-c track to trihm mode
var literal_sample='Sample';
var literal_assay='Assay';


var ordinaryTrackHeight = 50;
var densitydecorpaddingtop = 3; // density decor track padding top...
var tkAttrColumnWidth = 18;
var regionSpacing = {width:1,color:'#ccc'};
/* related to decor track plotting */
var thinStackHeight = 2;
var fullStackHeight = 9;
var chiapetdecorLabelheight = fullStackHeight;
var instack_padding = 2;
var instack_arrowwidth = 3;
var instack_arrowspacing = 5;
var tooltiptmpgene_width = 280;
var tooltiptmpgene_height = 19;

var svg_tklabelheight=16;

// file types macro, use them for good virtue
var FT_bed_n = 0;
var FT_bed_c = 1;
var FT_bedgraph_n = 2; // numerical hmtk
var FT_bedgraph_c = 3;
var FT_sam_n = 4;
var FT_sam_c = 5;
var FT_pwc = 6;
var FT_htest = 7;
var FT_qdecor_n = 8; // bedgraph
var FT_lr_n = 9;
var FT_lr_c = 10;
var FT_tkgrp = 11;
var FT_cat_n=12; // categorical hmtk
var FT_cat_c=13;
var FT_bigwighmtk_n=14;
var FT_bigwighmtk_c=15;
var FT_huburl=100;
var FT2verbal = ['annotation', 'custom annotation', 
'numerical', 'custom numerical',
'read aln', 'custom read aln',
'pwc log ratio', 'htest pvalues',
'numerical annotation',
'long-range &#8914;','custom long-range &#8914;',
'track group mysql table',
'categorical', 'custom categorical',
'numerical', 'custom numerical',
];

// decor track display mode
var M_hide=0,
	M_show=1,
	M_thin=2,
	M_full=3,
	M_arc=4,
	M_trihm=5,
	M_den=6,
	M_invalid=-1;
var mode2str=['hide', 'show', 'thin', 'full', 'arc', 'trihm', 'density'];

// running mode
var RM_genome=0,
	RM_jux_n=1, // juxtaposing over native bed
	RM_jux_c=2, // custom bed
	RM_gsv_c=3, // gene set, soft!
	RM_gsv_kegg=4, // grumpy
	RM_rpbr_beam=5; // similar as gsv_c but rigid and brutal

var ideoHeight = 14; // for plotting ideogram
var cbarHeight = 9;

var MAXbpwidth=6;
var MAXbpwidth_bold=10;

var gsselect = {which:0}; // gene struct selection stuff

// aligators, aligators, more aligators
var colorCentral = {
// the longlst can be altered by user, a copy will be made for default setting
longlst:["rgb(255,255,0)",
    "rgb(255,153,0)","rgb(51,102,255)","rgb(255,102,255)","rgb(51,153,0)",
    "rgb(255,204,0)","rgb(0,153,255)","rgb(255,153,255)","rgb(0,204,0)",
    "rgb(255,102,0)","rgb(0,51,255)","rgb(255,51,255)","rgb(51,102,0)",
    "rgb(255,0,0)","rgb(0,204,255)","rgb(255,204,255)","rgb(51,255,0)",
    "rgb(51,153,153)","rgb(153,0,102)","rgb(153,204,51)","rgb(204,102,102)",
    "rgb(143,143,255)","rgb(82,82,255)","rgb(255,82,171)","rgb(214,0,111)",
    "rgb(162,82,255)","rgb(134,20,255)","rgb(214,104,0)","rgb(0,11,214)",
    "rgb(102,51,51)","rgb(176,99,176)","rgb(102,51,102)","rgb(184,46,0)",
    "rgb(245,61,0)","rgb(184,138,0)","rgb(0,138,184)","rgb(100,61,255)",
    "rgb(153,0,0)","rgb(153,77,0)","rgb(214,107,0)","rgb(153,153,0)"
    ],
    foreground:'#000000',
	fg_r:0, fg_g:0, fg_b:0,
    foregroundDim:'#ccc',
    background:'#ffffff',
    pagebg:'#fff9d2',
    iconbackground: "#AA839C", // light purple, manual button bg color
	iconfill:'#956584',
	tkentryfill:'rgba(204,204,255,0.5)',
	hl:'#EBDBB3',
	hl2:'#336600',
	graybanner:'#8CA1B6',
    };
// cytoband, monotonic color
var cytoBandColor = [
	255, // gneg
	180, // gpos25
	120, // gpos50
	60, // gpos75
	0, // gpos100
	0, // gvar
	180, // stalk
	142, // gpos33
	57 // gpos66
	];
var cytoWordColor = [0,0,255,255,255,255,0,255,255];
var centromereColor = "rgb(141,64,52)";
var BLUE = "rgb(52,84,141)";
var GREEN = "rgb(0,153,0)";
var GREEN2 = "rgb(0,128,85)";
var YELLOW = "#FFF9D2";
var GRAY = "#aaa";
var SRED = "#9e004f"; // soft red
var BLUE2 = "#004f9e"; // soft blue
var ntbcolor = {g:'#3899c7', c:'#e05144', t:'#9238c7', a:'#89c738', n:'#858585'};



/* quantitative track configuration
   a little bit redundant...
   once user made changes in the ftb control panel,
   corresponding attribute will be updated in qtc,
   as well as attribute name be set to qtc.changed,
   then qtc values will be copied over to the qtc object of target component
 */
var qtc = {
    which:0, // look at qtc_update() for values
    slider:'',
    changed:'', // attribute name that has been changed
    pr:255,pg:0,pb:0, // positive color
    nr:0,ng:0,nb:230, // negative color
    pth:'#800000', // positive threshold color
    nth:'#000099', // negative threshold color
    thtype:0, // 0/1/2
    thmin:0,thmax:10,thpercentile:95,
    uselog:false,
    logtype:1, // 1/2/3
    height:20,
    };
/* default quantitative track style, will be copied over to their instances
   note height is for **plot height** not including top/bottom padding!
 */
var defaultQtcStyle = {
	// native hmtk of filetype 2 and 14
	heatmap:{pr:255,pg:0,pb:0,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099', thtype:0,thmin:0,thmax:10,thpercentile:90,uselog:false,logtype:1,height:10},
	// custom hmtk of filetype 3
	ft3:{pr:0,pg:0,pb:230,nr:255,ng:0,nb:0,pth:'#ffff00',nth:'#800000', thtype:0,thmin:0,thmax:10,thpercentile:90,uselog:false,logtype:1,height:10},
	ft8:{pr:115,pg:0,pb:230,nr:179,ng:0,nb:179,pth:'#400080',nth:'#4d004d', thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:50},
	ft1:{ textcolor:'#000000',
		fontsize:'7pt',
		fontfamily:'sans-serif',
		fontbold:false,
		bedcolor:'#008000'
	},
	ft5:{ textcolor:'#000000',
		fontsize:'7pt',
		fontfamily:'sans-serif',
		fontbold:false,
		forwardcolor:'rgb(0,0,153)',
		reversecolor:'rgb(153,0,0)',
		mismatchcolor:'rgb(255,255,0)',
	},
	ft10:{ textcolor:'#000000',
		fontsize:'7pt',
		fontfamily:'sans-serif',
		fontbold:false,
		pcolor:'rgb(184,0,138)',
		pcolorscore:10,
		ncolor:'rgb(0,99,133)',
		ncolorscore:-10,
	},
	// categorical
	ft12:{height:15},
	ft13:{height:15},
	// bev tracks (bigwig or bigbed)
	bev:{pr:115,pg:0,pb:230,nr:179,ng:0,nb:179,pth:'#4d0099',nth:'#4D004d', thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:30},
	density:{pr:0,pg:77,pb:0,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099', thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:50},
}

var urllenlimit = 4000; // url string length limit


/*** dom objects shared by all browser panels ***/
var pica;
var menu;
var menu2;
var picasays;
var bubble;
var invisibleBlanket;
var indicator2;
var scalebarbeam;
var pagecloak;
var pagecloak2;
var hengeview={
	panel:null,
	holder:null,
	hash:{},
};



function Browser()
{
var s=[];
var i=0;
while(i<10) {
	var j=48+parseInt(75*Math.random());
	if(j<=57) {
		s.push(j); i++;
	} else if(j>=65 && j<=90) {
		s.push(j); i++;
	} else if(j>=97) {
		s.push(j); i++;
	}
	if(i==10) break;
}
var s2=[];
for(var i=0; i<10; i++) s2.push(String.fromCharCode(s[i]));
this.sessionId=s2.join('');


this.statusId=1;
this.urloffset=0;

this.horcrux=Math.random().toString();
horcrux[this.horcrux]=this;

this.hmSpan=1;
this.regionLst=[];
this.genome=null; // (pointer to the) genome object

this.tklst=[];

this.facet={};

// custom track facet interface
this.cfacet={};

/* doms */
this.main=null;
this.hmdiv=null;
this.decordiv=null;
this.hmheaderdiv=null;
this.rulercanvas=null;
this.scalebar={};

// md terms on rows/columns of track selection grid
this.tsmdc_rows=[]; // each element: [attr name, padding, img src]
this.tsmdc_cols=[];
this.mcm={lst:[],
	/* .mcm.lst array index, must be aware about:
	- .mcm.lst could be empty
	- terms might be inserted and rearranged
	*/
	sortidx:0,
	holder:null, // holder of vertical term names
	tkholder:null, // holder of mcm canvas for tracks in ghm
	hhtop:null,
	hhbottom:null,
	};

this.move={
	direction:null, // l/r, null for indicating not moving
	merge:false, // if new data should be merged with old data for the same region
	offsetShift:0, // use when merge is true, only for stack decor
	styleLeft:0, // .style.left for movables
	oldpos:0,
	moved:false,
	mousex:0};
this.entire={length:0, 
	spnum:0, 
	summarySize:0, 
	atbplevel:false,
	bpwidth:0};
this.dspBoundary={lwrlpx:0,lwidx:0,
	lwr:0,lws:0,
	vstartr:0,vstarts:0,
	vstopr:0,vstops:0,
	rwr:0,rws:0};
this.juxtaposition={type:RM_genome, what:'genome', note:'genome'};
this.ideogram = {
	basepairlegendcanvas:null,
	canvas:null,
	band:[], 
	chr:null, 
	minihash:{},
	minirulerhash:{},
	longhash:{},
	minicanvaswidth:0,
	minicanvasheight:14,
	minirulerheight:15,
	wiggle1:{ // the wiggle plot with same width as minicanvas and on the top
		name:null,filetype:-1,url:null,label:null,
		qtc:{pr:136,pg:163,pb:137,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099',
		thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:20}
	},
	wiggle2:{ // the wiggle plot on the bottom
		name:null,filetype:-1,url:null,label:null,
		qtc:{pr:148,pg:176,pb:176,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099',
		thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:20}
	},
	previous:[],
	cross:{sf:0,lenlst:[],namelst:[],}
	};
this.navigator={canvas:null,
	chrbarheight:14,
	rulerheight:20, // set to 0 for not drawing, including spacing
	hlspacing:2,
	};
this.correlation = {targetft:-1, // target track file type, universal
	where:0, // in case of bigwig, it need to know whether is 0 heatmap or 1 decor it belongs to
	targetname:'', // target track name
	rawdata:[],
	rankeddata:[],
	qtc:{pr:255,pg:50,pb:50,nr:50,ng:50,nb:255,pth:'#800000',nth:'#000099'},
	inuse:false,
	holder:null
	};
// left wing, start, stop, right wing
this.htest = {pvalue:[],
	inuse:false,
	grpnum:0,
	// only pcolor, ncolor are effective
	qtc:{pr:255,pg:77,pb:77,
	nr:255,ng:77,nb:77,
	pth:'#b30000',nth:'#b30000',thtype:0,uselog:true,logtype:3,height:50}, };
/* pairwise comparison central object */
this.pwc = {
	inuse:false, 
	qtc:{pr:230,pg:0,pb:0, nr:0,ng:204,nb:0,
	pth:'#800000',nth:'#008000',
	thtype:0,thmin:-3,thmax:3,thpercentile:95,
	uselog:false,logtype:1,
	height:50},
	gtn1:[], gtn2:[],
	};
this.geneplot = {type:'',data:[], genenum:0,
		canvasX:0, canvasY:0, // absolute position of clustering heatmap
		dendroX:0, dendroY:0, // ... of clustering dendrogram
		ccrd:{}, // cluster coord hash {x:{y:id}}, for clicking on dendrogram
		'for':0, // determines where the panel should go to 0: gene set view, 1: custom bigbed
		forTkname:'', // the custom bigbed track name
	}; // for gene plot following gene set view

this.notes=[];

// a list of splinters
this.splinters={};
this.trunk=null;
this.splinterTag=null; // set to null to tell this is not a splinter
this.splinterCoord=[]; // the coord issued over this splinter

this.ajax_phrase=''; // any short param to be passed to all ajax queries, used in alethiometer

this.animate_zoom_stat=0;
/* 0 for not zooming, or data ready for rendering
1 for doing animated zooming, or ajax data not ready yet
*/

return this;
}



var genome={}; // key: genome name (dbName), val: Genome object

function Genome(param)
{
// constructor
/* each genome has its own:
- track selection panel
- metadata selection panel
*/

/* each genome has its own metadata selector panel
*/
this.mdselect={};
var d=document.createElement('div');
document.body.appendChild(d);
this.mdselect.main=d;
d.style.display='none';
d.style.position='absolute';
d.className='spanel';
d.style.zIndex=102;
d.id='mdspanel'; // for moving
d.addEventListener('mouseout', mdspanel_mout, false);
d.addEventListener('mouseover', mdspanel_mover, false);
var d2=document.createElement('div');
d.appendChild(d2);
var d3=document.createElement('div');
d3.className='spanelheader';
d3.setAttribute('active',1);
d3.setAttribute('holderid','mdspanel');
d3.addEventListener('mousedown',cpmoveMD,false);
d3.innerHTML='Choose metadata terms';
d2.appendChild(d3);
var ul=document.createElement('ul');
ul.style.paddingLeft=ul.style.paddingRight=10;
ul.style.whiteSpace='nowrap';
d2.appendChild(ul);
this.mdselect.nativeholder=ul;
if(param.custom_md) {
	var ul=document.createElement('ul');
	ul.style.paddingLeft=ul.style.paddingRight=10;
	ul.style.margin=0;
	ul.style.border='1px solid #C9ADC9';
	ul.style.borderLeftWidth=ul.style.borderRightWidth=0;
	ul.style.backgroundColor='#EEE1EE';
	ul.style.whiteSpace='nowrap';
	d2.appendChild(ul);
	this.mdselect.cust=ul;
	this.mdselect.newcust={};
	d3=document.createElement('div');
	d3.style.backgroundColor='#FEFEEE';
	d3.style.padding=10;
	d2.appendChild(d3);
	var b=document.createElement('button');
	b.type='button';
	b.innerHTML='Create custom term';
	b.addEventListener('click', custmdinput_show, false);
	d3.appendChild(b);
	var d4=document.createElement('div');
	d4.style.display='none';
	d4.style.position='relative';
	d3.appendChild(d4);
	var d5=document.createElement('div');
	d5.className='rclosebut';
	d5.style.top=d5.style.right=0;
	d5.innerHTML='&#10005;';
	d5.addEventListener('click', custmdinput_hide,false);
	d4.appendChild(d5);
	d5=document.createElement('div');
    d5.innerHTML='<span class=example onclick="gflag.mdp.bbj.genome.custmd_example()">example</span><br>';
	d4.appendChild(d5);
	d5=document.createElement('div'); // actual custmd ui
	d5.style.margin=10;
	d5.style.whiteSpace='nowrap';
	d4.appendChild(d5);
	dom_addtext(d5,'Term name&nbsp;');
	var input=document.createElement('input');
	input.type='text';
	input.size=6;
	this.mdselect.newcust.name_input=input;
	d5.appendChild(input);
	dom_addtext(d5,'&nbsp;# of attributes&nbsp;');
	s=document.createElement('select');
	this.mdselect.newcust.vnum_select=s;
	s.addEventListener('change', custmdinput_selectchange,false);
	var o=document.createElement('option'); o.value=o.text=2; s.add(o);
	o=document.createElement('option'); o.value=o.text=3; o.selected=true; s.add(o);
	o=document.createElement('option'); o.value=o.text=4; s.add(o);
	o=document.createElement('option'); o.value=o.text=5; s.add(o);
	o=document.createElement('option'); o.value=o.text=6; s.add(o);
	o=document.createElement('option'); o.value=o.text=7; s.add(o);
	o=document.createElement('option'); o.value=o.text=8; s.add(o);
	o=document.createElement('option'); o.value=o.text=9; s.add(o);
	o=document.createElement('option'); o.value=o.text=10; s.add(o);
	d5.appendChild(s);
	var d6=document.createElement('div');
	d6.style.textAlign='center';
	this.mdselect.newcust.inputdiv=d6;
	d5.appendChild(d6);
	d6=document.createElement('div');
	d6.style.margin=5;
	d6.innerHTML='<button type=button onclick="gflag.mdp.bbj.genome.submitCustommdterm()">submit</button>'+
		'<button type=button onclick="gflag.mdp.bbj.genome.resetCustommdterm()">reset</button>';
	d5.appendChild(d6);
}

this.scaffold={};
this.defaultStuff={};
this.mdv2checkbox={}; // key: term name or idx, val: <input>, only native
this.mdv2checkbox_custom={}; // only custom, segregated!
/* each custom term:
term_name : [ <input>, { v1:<input>, v2:<input>, ...} ]
*/
// border position are absolute (chromosome name, not region index)
this.border = {lname:'', lpos:0, rname:0, rpos:0};

/*** bird's eye view
track canvas's height will be .qtc.height, with no padding
but will have 4px top margin

"data" points to a hash of tracks
   key: track name
   value: {}
	'data': the data vector, addressed by chr name
	'tr': <tr> in bev_dataregistry
	'min', 'max': threshold values
	'minspan', 'maxspan': place to write threshold values in <tr>
	'canvas':{'chr1':<canvas>,...}
"ongoing" indicates the track that's been computed
    could be undefined, to indicate that all vectors are under focus...
"pressedChr" the chr name that is used for zoom in
'scfd' is a partial replicate of global object scaffold
***/
this.bev={};
return this;
}

Genome.prototype.jsonGenome=function(data)
{
/* establish all necessary data for a genome database from cgi
*/
this.name=data.dbname;
this.hasGene=data.hasGene;

this.defaultStuff={
	coord:data.defaultPosition,
	mdtermlst:data.defaultMdcategory.split(','),
	hmtk:data.defaultHmtk.split(','),
	gsvlst:data.defaultGenelist,
	decor:data.defaultDecor.split(','),
	custtk:{},
	};
var lst=data.defaultCustomtracks.split(',');
for(var i=0; i<lst.length; i+=2)
	this.defaultStuff.custtk[lst[i]]=lst[i+1];

this.keggSpeciesCode=data.keggSpeciesCode;
// metadata
this.mdvidx2attr={};
this.mdvidx2desc={};
for(var idx in data.mdvidx2attrdesc) {
	var t=data.mdvidx2attrdesc[idx];
	this.mdvidx2attr[idx]=t[0];
	this.mdvidx2desc[idx]=t[1];
}
this.mdvattr2idx = {};
for(var idx in this.mdvidx2attr)
	this.mdvattr2idx[this.mdvidx2attr[idx]] = idx;
this.mdvc2p = data.mdvc2p;
this.mdvp2c = {};
for(var c in this.mdvc2p) {
	var p = this.mdvc2p[c];
	if(p in this.mdvp2c) {
		this.mdvp2c[p].push(c);
	} else {
		this.mdvp2c[p] = [c];
	}
}
this.mdvroot = [];
for(var p in this.mdvp2c) {
	if(!(p in this.mdvc2p))
		this.mdvroot.push(p);
}

if(this.mdselect.main)
	this.makeMetadataSelectorPanel();

this.custmdhash = {};

this.hmtk=data.hmtkinfo;
this.trackDefaultparam=data.trackDefaultparam;
/* some tracks are associated with specific regions
assume these tracks are all assay datasets
*/
if('track2Regions' in data) {
	for(var n in data.track2Regions) {
		var tk=this.hmtk[n];
		if(tk!=undefined) {
			var o=data.track2Regions[n];
			tk.regions=[o[0],o[1].split(',')];
		}
	}
}


/* decor tracks
FIXME must think about a way to remove distinction between assay/decor tracks
*/
this.decorGrouping=data.gfGrouping; // [group id, group name], ...
this.decorInfo=data.decorInfo;
// append cateinfo to decor tk objects
for(var tkn in this.decorInfo) {
	var tk=this.decorInfo[tkn];
	if(tk.ft==FT_cat_n) {
		tk.cateInfo={};
		cateInfo_copy(data.decor2cateInfo[tkn], tk.cateInfo);
	}
}
		
this.decorcatalog=[];
// TODO allow multiple levels of parent/child relationship in organizing decor track
for(var i=0; i<this.decorGrouping.length; i++) {
	// add one tab for each decor group
	var grpid = this.decorGrouping[i][0];
	this.registerDecorGroup(this.decorGrouping[i][1], this.decorGrouping[i][1]);
	var table=this.decorcatalog[i][1];

	// iterate over decor tracks, each parent track will occupy one row
	for(var dn in this.decorInfo) {
		if(this.decorInfo[dn].grp != grpid) continue;
		if('parent' in this.decorInfo[dn])
			continue;
		var parenttr = table.insertRow(-1);
		var pname = parenttr.insertCell(0);
		pname.innerHTML = this.decorInfo[dn].label;
		pname.className = 'tkentry';
		pname.style.backgroundColor = 'transparent';
		pname.addEventListener('click', decortkentry_click, false);
		pname.tkname=dn;
		pname.setAttribute('name', 'decortkentry');
		// add hook to this <td> in decorInfo
		this.decorInfo[dn].tksentry = pname;
		var arrowtd = parenttr.insertCell(-1);
		// children tracks of this parent, might be empty
		var clst = [];
		for(var dn2 in this.decorInfo) {
			if("parent" in this.decorInfo[dn2]) {
				if(this.decorInfo[dn2]["parent"] == dn)
					clst.push(dn2);
			}
		}
		if(clst.length > 0) {
			// this decor has child
			var s = document.createElement("div");
			s.innerHTML = '&#10140;';
			//s.className = "shortcutbut";
			s.style.fontSize = "18px";
			s.style.color= colorCentral.iconbackground;
			s.style.cursor='pointer';
			s.style.transform=
			s.style.webkitTransform=
			s.style.mozTransform='rotate(90deg)';
			s.addEventListener("click", toggle20, false);
			arrowtd.appendChild(s);
			var ctr = table.insertRow(-1);
			ctr.style.display = "none";
			var ctd = ctr.insertCell(0);
			ctd.colSpan = 2;
			ctd.align = 'right';
			ctd.style.paddingLeft = '15px';
			for(var j=0; j<clst.length; j++) {
				var childentry = document.createElement('div');
				childentry.innerHTML = this.decorInfo[clst[j]].label;
				childentry.className = 'tkentry';
				childentry.style.backgroundColor = 'transparent';
				childentry.addEventListener('click', decortkentry_click, false);
				childentry.tkname=clst[j];
				childentry.setAttribute('name', 'decortkentry');
				this.decorInfo[clst[j]].tksentry = childentry;
				ctd.appendChild(childentry);
			}
		}
	}
}
this.cytoband={};
if('cytoband' in data) {
	for(var i=0; i<data.cytoband.length; i++) {
		if(data.cytoband[i][0] in this.cytoband)
			this.cytoband[data.cytoband[i][0]].push(data.cytoband[i].slice(1,5));
		else
			this.cytoband[data.cytoband[i][0]] = [data.cytoband[i].slice(1,5)];
	}
}

/* scaffold */
this.scaffold={p2c:{}, c2p:{}, len:{}, current:[], toadd:[], move:{}};
for(var i=0; i<data.scaffoldInfo.length; i++) {
	var lst = data.scaffoldInfo[i];
	this.scaffold.c2p[lst[1]] = lst[0];
	if(!(lst[0] in this.scaffold.p2c))
		this.scaffold.p2c[lst[0]] = {};
	this.scaffold.p2c[lst[0]][lst[1]] = 1;
	if(lst[2] > 0) {
		// child is sequence
		this.scaffold.len[lst[1]] = lst[2];
	}
}
this.scaffold.current=data.defaultScaffold.split(',');
var t=document.createElement('table');
t.cellSpacing=0; t.cellPadding=2;
this.scaffold.overview={
	holder:t,
	trlst:[],
	maxw:800,
	pwidth:{},
	barheight:14,
};
this.scfdoverview_makepanel();

/* all datasets */
this.datasetLst=[];
this.datasetStat={};
if(data.datasetInfo) {
	this.datasetHolder=document.createElement('div');
	for(var i=0; i<data.datasetInfo.length; i++) {
		var v=data.datasetInfo[i];
		// name, logo, label, url, desc, tk #
		var url=v[3];
		this.datasetLst.push(v[0]);
		var d=document.createElement('div');
		d.className='container';
		d.style.margin=10;
		d.style.padding=10;
		var table=document.createElement('table');
		var tr=table.insertRow(0);
		var td=tr.insertCell(0);
		td.vAlign='middle';
		td.style.width=150; td.style.paddingRight=15;
		td.innerHTML='<img src=/browser/'+v[1]+' width=150>'; // logo
		td=tr.insertCell(1);
		td.style.width=550;
		td.vAlign='top';
		td.innerHTML=v[2]+' '+ // name
			(v[3]=='(null)'?'':"<a href="+v[3]+" target=_blank style='font-size:16px;'>&#10138;</a>")+ // url
			'<div style="font-size:12px;color:#707070;margin-top:8px;">'+v[4]+'</div>'; // desc
		tr=table.insertRow(1);
		td=tr.insertCell(0);
		td.align='center';
		td.innerHTML= v[5]+' tracks'; // # tk
		td=tr.insertCell(1);
		this.datasetStat[v[0]]=td;
		d.appendChild(table);
		this.datasetHolder.appendChild(d);
	}
	this.currentDatasets=data.dataset2show;
	this.toggleDataset();
}

/* prepare bev panel */
this.bev.main=document.createElement('div');
this.bev.main.style.borderBottom='solid 1px '+colorCentral.graybanner;
var d=document.createElement('div');
d.style.backgroundColor=colorCentral.graybanner;
d.style.paddingLeft=20;
d.style.color='white';
d.innerHTML='<button type=button onclick=bev_addtrack_invoketkselect(event)>Add tracks</button>\
&nbsp;width: <select onchange=bev_setchrmaxwidth(event) onmouseover=bev_chrwidthselectmouseover(event) onmouseout=pica_hide()><option value=500>500 px</option>\
<option value=600>600 px</option><option value=700>700 px</option>\
<option value=800 selected>800 px</option><option value=900>900 px</option>\
<option value=1000>1000 px</option><option value=1200>1200 px</option>\
<option value=1400>1400 px</option><option value=1600>1600 px</option>\
<option value=1800>1800 px</option><option value=2000>2000 px</option></select>\
&nbsp;panel height: <select onchange=bev_setpanelheight(event)>\
<option value=500>*</option>\
<option value=600 selected>**</option>\
<option value=700>***</option>\
<option value=800>****</option>\
<option value=900>*****</option>\
<option value=1000>******</option>\
</select>';
this.bev.main.appendChild(d);
d=document.createElement('div');
d.style.height=600;
d.style.overflowY='scroll';
this.bev.main.appendChild(d);
var table=document.createElement('table');
table.style.backgroundColor='white';
this.bev.viewtable=table;
d.appendChild(table);
this.bev.chrlst=[];
var lst=this.scaffold.current;
for(var i=0; i<lst.length; i++) {
	/* each ele:
	0. chr name
	1. canvas size, spnum
	2. ideogram <canvas>
	3. <td> to hold track canvas
	*/
	this.bev.chrlst.push([lst[i],0,null]);
}
this.bev.config={
	maxpxwidth:800,
	chrbarheight:14,
	};
this.bev.tklst=[];
this.bev_prepare();
this.bev_draw();
/* over */
}


Genome.prototype.registerDecorGroup=function(name,label)
{
/* inserts group place holder into track selection panel
args:
- name is used by code
- label is to be read by human, but they could be the same
returns a list of two elements:
1. div dom of group tab name
2. table dom of track holder of this group (identified by name, but not label)
*/
var d = document.createElement('div');
d.innerHTML = label;
d.setAttribute('grpname', name);
d.className = 'degrpt';
d.addEventListener('click', decorgrp_click, false);

// make panel for decor tracks in this group
var table = document.createElement('table');
table.setAttribute('grpname', name);
this.decorcatalog.push([d, table]);
}


Genome.prototype.getcytoband4region2plot=function(chrom, start, stop, plotwidth)
{
/* given a query region, find cytoband data in it
for each band returns [name, plot length (pixel), coloridx, athead(bool), attail(bool)]
plotwidth: on screen width of this interval
 */
if(!(chrom in this.cytoband)) return null;
var sf=plotwidth/(stop-start);
var result = [];
var elen=this.scaffold.len[chrom];
for(var i=0; i<this.cytoband[chrom].length; i++) {
	var b = this.cytoband[chrom][i];
	if(Math.max(start, b[0]) < Math.min(stop, b[1])) {
		var thisstart = Math.max(start, b[0]);
		var thisstop = Math.min(stop, b[1]);
		result.push([b[3], (thisstop-thisstart)*sf, b[2], thisstart==0, thisstop==elen]);
	}
}
return result;
}

function drawIdeogramSegment_simple(data, ctx, x, y, plotwidth, plotheight, tosvg)
{
/* only draws data within one so called region, at least within one chr
args:
data: getcytoband4region2plot() output
x/y: starting plot position on canvas, must be integer
plotwidth: entire plotting width, only used to draw the blank rectangle
 */
ctx.font = "bold 8pt Sans-serif";
if(data == null) {
	// no cytoband data
	var svgrectdata=[];
	ctx.strokeStyle = colorCentral.foreground;
	ctx.strokeRect(x,y+0.5,plotwidth,plotheight);
	if(tosvg) svgrectdata=[x,y+0.5,plotwidth,plotheight,'transparent',colorCentral.foreground];
	ctx.fillStyle = colorCentral.foreground;
	var w = ctx.measureText('No karyotype data').width;
	if(w<=plotwidth) {
		ctx.fillText('No karyotype data', x+(plotwidth-w)/2, 11+y);
		if(tosvg) {
			svgrectdata[6]=x+(plotwidth-w)/2;
			svgrectdata[7]=11+y;
			svgrectdata[8]='No karyotype data';
			svgrectdata[9]=colorCentral.foreground;
		}
	}
	return [svgrectdata];
}
var svgdata=[];
var previousIsCentromere = null;
for(var i=0; i<data.length; i++) {
	var band = data[i];
	if(band[2] >= 0) {
		var svgrectdata=[];
		ctx.fillStyle = 'rgb('+cytoBandColor[band[2]]+','+cytoBandColor[band[2]]+','+cytoBandColor[band[2]]+')';
		ctx.fillRect(x, y, band[1], plotheight);
		if(tosvg) svgrectdata=[x,y,band[1],plotheight,ctx.fillStyle,colorCentral.foreground];
		ctx.strokeStyle = colorCentral.foreground;
		ctx.beginPath();
		ctx.moveTo(x,0.5+y);
		ctx.lineTo(x+band[1],0.5+y);
		ctx.moveTo(x,plotheight-0.5+y);
		ctx.lineTo(x+band[1],plotheight-0.5+y);
		ctx.stroke();
		var w = ctx.measureText(band[0]).width;
		if(w < band[1]) {
			ctx.fillStyle = 'rgb('+cytoWordColor[band[2]]+','+cytoWordColor[band[2]]+','+cytoWordColor[band[2]]+')';
			ctx.fillText(band[0], x+(band[1]-w)/2, 10+y);
			if(tosvg) {
				svgrectdata[6]=x+(band[1]-w)/2;
				svgrectdata[7]=10+y;
				svgrectdata[8]=band[0];
				svgrectdata[9]=ctx.fillStyle;
			}
		}
		if(tosvg) svgdata.push(svgrectdata);
		if(previousIsCentromere==true) {
			ctx.fillStyle = colorCentral.foreground;
			ctx.fillRect(x, y, 1, plotheight);
			if(tosvg) svgdata.push([x,y,1,plotheight,colorCentral.foreground,colorCentral.foreground]);
		}
		previousIsCentromere=false;
	} else {
		ctx.fillStyle = centromereColor;
		ctx.fillRect(x, 3+y, band[1], plotheight-5);
		if(tosvg) 
			svgdata.push([x,3+y,band[1],plotheight-5,centromereColor,centromereColor]);
		var w = ctx.measureText('centromere').width;
		if(w < band[1]) {
			ctx.fillStyle = 'white';
			ctx.fillText('centromere', x+(band[1]-w)/2, 10+y);
		}
		if(previousIsCentromere==false) {
			ctx.fillStyle = colorCentral.foreground;
			ctx.fillRect(x-1, y, 1, plotheight);
			if(tosvg) svgdata.push([x-1,y,1,plotheight,colorCentral.foreground,colorCentral.foreground]);
		}
		previousIsCentromere=true;
	}
	if(band[3]) {
		// enclose head
		ctx.fillStyle = colorCentral.foreground;
		ctx.fillRect(x, y, 1, plotheight);
		if(tosvg) svgdata.push([x,y,1,plotheight,colorCentral.foreground,colorCentral.foreground]);
	}
	if(band[4]) {
		// enclose tail
		ctx.fillStyle = colorCentral.foreground;
		ctx.fillRect(x+band[1], y, 1, plotheight);
		if(tosvg) svgdata.push([x+band[1],y,1,plotheight,colorCentral.foreground,colorCentral.foreground]);
	}
	x += band[1];
}
return svgdata;
}


Genome.prototype.decorIsGene=function(decorname)
{
// more robust methods needed to tell decor group, but instead of following hard-coded stuff
// see if decor belongs to "Genes" group
var genegrpid = undefined;
for(var i=0; i<this.decorGrouping.length; i++) {
	if(this.decorGrouping[i][1] == "Genes") {
		genegrpid = this.decorGrouping[i][0];
		break;
	}
}
// don't die here!!
if(genegrpid == undefined)
	return false;
if(decorname in this.decorInfo) {
	if(this.decorInfo[decorname].grp == genegrpid)
		return true;
}
return false;
}

/*** __genome__ ends ***/






/*** __tiny__ ***/

function foregroundcolor(opacity) {
return 'rgba('+colorCentral.fg_r+','+colorCentral.fg_g+','+colorCentral.fg_b+','+opacity+')';
}

function isHmtk(ft) {
	switch(ft) {
	case FT_bedgraph_c: return true;
	case FT_bedgraph_n: return true;
	case FT_cat_c: return true;
	case FT_cat_n: return true;
	case FT_bigwighmtk_c: return true;
	case FT_bigwighmtk_n: return true;
	default: return false;
	}
}
function isCustom(ft) {
	switch(ft) {
	case FT_cat_c: return true;
	case FT_bedgraph_c: return true;
	case FT_bigwighmtk_c: return true;
	case FT_bed_c: return true;
	case FT_sam_c: return true;
	case FT_lr_c: return true;
	default: return false;
	}
}
function isNumerical(tkobj)
{
// including density mode
var ft=tkobj.ft;
if(ft==FT_bedgraph_c||ft==FT_bedgraph_n||ft==FT_bigwighmtk_c||ft==FT_bigwighmtk_n||ft==FT_qdecor_n) return true;
if(tkobj.mode==M_den) return true;
return false;
}

function decormodestr2num(s) {
var m = s.toLowerCase();
if(m=='hide') return M_hide;
if(m=='show') return M_show;
if(m=='thin') return M_thin;
if(m=='full') return M_full;
if(m=='arc') return M_arc;
if(m=='trihm') return M_trihm;
if(m=='density') return M_den;
return undefined;
}

function simulateEvent(dom, action) {
// action: click, change, mouseover,
	var e = document.createEvent('MouseEvents');
	e.initMouseEvent(action, true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
	dom.dispatchEvent(e);
}
function int2strcomma(num) {
// integer to string with comma
}
function absolutePosition(obj) {
	var c = [0,0];
	if(obj.offsetParent) {
		var o2 = obj;
		do {
			var b=parseInt(o2.style.borderLeftWidth);
			c[0] += o2.offsetLeft+(isNaN(b)?0:b);
			b=parseInt(o2.style.borderTopWidth);
			c[1] += o2.offsetTop+(isNaN(b)?0:b);
		} while(o2 = o2.offsetParent);
	}
	return c;
}
function stripChild(holder, what) {
// if what==0, strip all children
	var L = holder.childNodes.length;
	if(what == 0) {
		while(holder.hasChildNodes())
			holder.removeChild(holder.lastChild);
	} else {
		for(var i=what; i<L; i++) 
			holder.removeChild(holder.lastChild);
	}
}


function neatstr(num) {
// float number to neat string
    var s = num.toFixed(2);
    var lst = s.split('.');
    if(lst[1] == '00') {
        return lst[0];
    } else {
        return s;
    }
}
function lightencolor(rgb,perc) {
// lighten color, higher percentage means lighter color
    return "rgb("+(rgb[0]+parseInt((255-rgb[0])*perc))+","+(rgb[1]+parseInt((255-rgb[1])*perc))+","+(rgb[2]+parseInt((255-rgb[2])*perc))+")";
}
function darkencolor(rgb,perc) {
// darken color, higher percentage means darker color
    var p = 1-perc;
    return "rgb("+parseInt(rgb[0]*p)+","+parseInt(rgb[1]*p)+","+parseInt(rgb[2]*p)+")";
}
function colorstr2int(what) {
// accepts #aabbcc or rgb(12,23,34)
    var c = [0,0,0];
    if(what.charAt(0) == "#") {
    	if(what.length == 4) {
	    c[0] = parseInt(what.charAt(1)+what.charAt(1), 16);
	    c[1] = parseInt(what.charAt(2)+what.charAt(2), 16);
	    c[2] = parseInt(what.charAt(3)+what.charAt(3), 16);
	} else {
	    c[0] = parseInt(what.substr(1,2), 16);
	    c[1] = parseInt(what.substr(3,2), 16);
	    c[2] = parseInt(what.substr(5,2), 16);
	}
    } else {
        var lst = what.split(',');
	c[0] = parseInt(lst[0].split('(')[1]);
	c[1] = parseInt(lst[1]);
	c[2] = parseInt(lst[2]);
    }
    return c;
}
function arrayMin(arr) {
    if(arr.length == 0) fatalError('arrayMin: zero length array');
    var s = arr[0];
    for(var i=1; i<arr.length; i++) {
        if(s > arr[i]) s = arr[i];
    }
    return s;
}
function arrayMean(arr) {
    if(arr.length == 0) fatalError("arrayMean: zero length array");
    var s = 0;
    for(var i=0; i<arr.length; i++)
        s += arr[i];
    return s/arr.length;
}
function arrayMax(arr) {
    if(arr.length == 0) fatalError("arrayMax: zero length array");
    var s = 0;
    for(var i=0; i<arr.length; i++) {
        if(s < arr[i])
	    s = arr[i];
    }
    return s;
}
function getArrIdx(thing, lst) {
    // return -1 if thing is not found
    if(lst.length == 0) return -1;
    for(var i=0; i<lst.length; i++) {
        if(lst[i] == thing) return i;
    }
    return -1;
}
function stringLstIsIdentical(lst1, lst2) {
    if(lst1.length != lst2.length)
        return false;
    for(var i=0; i<lst1.length; i++) {
        if(lst1[i] != lst2[i])
	    return false;
    }
    return true;
}
function hashisempty(h) {
    for(var k in h)
        return false;
    return true;
}
function thinginlist(thing, lst) {
    for(var i=0; i<lst.length; i++) {
        if(lst[i] == thing) return true;
    }
    return false;
}
function placePanel(panel, x, y)
{
/* x/y can be missing for panel that is already shown
will adjust if it goes beyond the window
*/
var x0;
if(x==undefined) {
	x0=parseInt(panel.style.left);
} else {
	panel.style.left=x0=x;
}
var w=document.body.clientWidth+document.body.scrollLeft;
if(x0+panel.clientWidth>w)
	panel.style.left=Math.max(0,w-panel.clientWidth);
var y0;
if(y==undefined) {
	y0=parseInt(panel.style.top);
} else {
	panel.style.top=y0=y;
}
var h=document.body.clientHeight+document.body.scrollTop;
if(y0+panel.clientHeight>h)
	panel.style.top=Math.max(0,h-panel.clientHeight);
}
/*
function adjustPos(dom) {
	if(parseInt(dom.style.left)+dom.clientWidth>document.body.clientWidth)
		dom.style.left=document.body.clientWidth-dom.clientWidth;
	if(parseInt(dom.style.top)+dom.clientHeight>document.body.clientHeight)
		dom.style.top=document.body.clientHeight-dom.clientHeight;
}
*/
function tkdefaultMode(o, mdlookup)
{
/* args: 1. tk obj, 2. mdvattr2idx
only for decors
don't die when called upon hmtks
*/
switch(o.ft) {
case FT_bed_c:
case FT_bed_n:
	return M_full;
case FT_qdecor_n:
	return M_show;
case FT_lr_c:
	return M_arc;
case FT_lr_n:
	// check metadata, trihm for hi-c, arc for rest
	if(o.md!=undefined && (literal_hic in mdlookup) && thinginlist(mdlookup[literal_hic], o.md))
		return M_trihm;
	return M_arc;
case FT_sam_c:
case FT_sam_n:
	return M_den;
default:
	return M_show;
}
}


Browser.prototype.cloak=function()
{
// images/loading.gif size: 128x128
// browser instance has their own cloak
var pos=absolutePosition(this.hmdiv.parentNode);
pagecloak2.style.display='block';
pagecloak2.style.left=pos[0];
pagecloak2.style.top=pos[1];
var w=this.hmSpan;
var h=this.tkpanelheight();
pagecloak2.style.width=w;
pagecloak2.style.height=h;
// roller
pagecloak2.firstChild.style.display='block';
pagecloak2.firstChild.style.marginTop = h>128 ? (h-128)/2 : 0;
pagecloak2.firstChild.style.marginLeft = w>128 ? (w-128)/2 : 0;
}
Browser.prototype.unveil=function() { pagecloak2.style.display='none'; }

Browser.prototype.pixelwidth2bp=function(pxw)
{
// argument: pixel width
return this.entire.atbplevel ? pxw/this.entire.bpwidth : pxw*this.entire.summarySize;
}

function gfSort2(a,b) {
// using actual genomic coord
    if(a[8] == b[8])
        return a[9]-b[9];
    return a[8]-b[8];
}
function numSort(a,b) { return a-b; } // ascending
function numSort2(a,b) { return b-a; } // descending
function getSelectValueById(what) {
	var tag = document.getElementById(what);
	if(tag == null) fatalError(what+' not found as select');
	if(tag.type != 'select-one')
		fatalError(what+' not found for a select tag');
	return tag.options[tag.selectedIndex].value;
}
function changeSelectByValue(arg, value) {
/* change .selectedIndex of a <select> by given value
return 1 for success, -1 for failure
first argument could be string (<select> id), or dom object
*/
	var s = arg;
	if(typeof(s) == "string") {
		s = document.getElementById(arg);
		if(s == undefined)
			return -1;
	}
	if(s.tagName != 'SELECT') {
		print2console('changeSelectByValue: target object is not <select>',2);
		return -1;
	}
	var lst = s.options;
	for(var i=0; i<lst.length; i++) {
		if(lst[i].value == value) {
			s.selectedIndex = i;
			return 1;
		}
	}
	return -1;
}
function checkInputByvalue(radioName, value) {
// works for both radio and checkbox
	var lst = document.getElementsByName(radioName);
	if(lst.length == 0)
		fatalError("checkInputByvalue: unknown <input> name");
	for(var i=0; i<lst.length; i++) {
		if(lst[i].value == value) {
			lst[i].checked = true;
			return;
		}
	}
	fatalError("checkInputByvalue: unknown value '"+value+"' for "+radioName);
}
function getValue_by_radioName(what) {
// a set of radio button sharing same name
	var tag_lst = document.getElementsByName(what);
	if(tag_lst.length == 0) fatalError("radio button with name "+what+" not found.");
	for(var i=0; i<tag_lst.length; i++) {
		if(tag_lst[i].checked) return tag_lst[i].value;
	}
	return null;
}
function getAlt_by_radioName(what) {
	var tag_lst = document.getElementsByName(what);
	if(tag_lst.length == 0) fatalError("radio button with name "+what+" not found.");
	for(var i=0; i<tag_lst.length; i++) {
		if(tag_lst[i].checked) return tag_lst[i].alt;
	}
	fatalError("None of the options were checked for radio button "+what);
}

function makecanvas_verticalstring(plottext, color, bgFill, bottomstart) {
/* make canvas with string plotted vertically
args:
- plottext: string
- color:
- bgFill: boolean whether to fill background (#fff9d2)
- bottomstart: boolean if string start from bottom
*/
	var c = document.createElement("canvas");
	var ctx = c.getContext('2d');
	ctx.font = "10pt Sans-serif";
	var w = ctx.measureText(plottext).width;
	c.width = tkAttrColumnWidth-2; // FIXME
	var truncate = false;
	if(w+10 > 200) {
		c.height = 200;
		truncate = true;
	} else {
		c.height = w+10;
	}
	if(bgFill) {
		ctx.fillStyle = "#fff9d2";
		ctx.fillRect(0,0,c.width,c.height);
	}
	ctx.font = "10pt Sans-serif";
	ctx.fillStyle = color;
	if(bottomstart) {
		ctx.rotate(Math.PI*1.5);
		ctx.fillText(plottext, -c.height+2, 12);
	} else {
		ctx.rotate(Math.PI*0.5);
		ctx.fillText(plottext, 0, 0);
	}
	if(truncate) {
		ctx.clearRect(-14,0,14,12);
		ctx.font = "bold 11pt Georgia";
		ctx.fillText('...', -14, 12);
	}
	return c;
}

function indicator4fly(fromdom, todom, toIsFixed)
{
/* if to app shortcut button in ftb, need to add body scrolling offset
args:
fromdom/todom: from/to dom object, used to get coord on page
toIsFixed: whether todom is position:fixed attribute, if so, need to add body scrolling offset

TODO not supports fromdom position:fixed
*/
var pos1 = absolutePosition(fromdom);
var pos2 = absolutePosition(todom);
if(toIsFixed) {
	pos2[0] += document.body.scrollLeft;
	pos2[1] += document.body.scrollTop;
}
var w1 = fromdom.clientWidth;
var h1 = fromdom.clientHeight;
var w2 = todom.clientWidth;
var h2 = todom.clientHeight;
// animate 20 frames
indicator4.style.display = 'block';
indicator4.style.width = w1;
indicator4.style.height = h1;
indicator4.style.left = pos1[0];
indicator4.style.top = pos1[1];
indicator4.count = 0;
indicator4.xincrement = (pos2[0]-pos1[0])/20;
indicator4.yincrement = (pos2[1]-pos1[1])/20;
indicator4.wshrink = (w2-w1)/20;
indicator4.hshrink = (h2-h1)/20;
indicator4actuallyfly();
}
function indicator4actuallyfly() {
    if(indicator4.count == 20) {
        indicator4.style.display = 'none';
	return;
    }
    indicator4.count++;
    indicator4.style.width = parseInt(indicator4.style.width)+indicator4.wshrink;
    indicator4.style.height = parseInt(indicator4.style.height)+indicator4.hshrink;
    indicator4.style.left = parseInt(indicator4.style.left)+indicator4.xincrement;
    indicator4.style.top = parseInt(indicator4.style.top)+indicator4.yincrement;
    setTimeout(indicator4actuallyfly, 10);
}
function toggle7()
{
if(apps.custtk.style.display == "none") {
	if(apps.bev.style.display!='none'||
	apps.custtk.style.display!='none'||
	apps.gplot.style.display!='none'||
	apps.gsv.style.display!='none'||
	apps.hmtk.style.display!='none'||
	apps.session.style.display!='none'||
	apps.svg.style.display!='none') return;
	cloakPage();
	panelFadein(apps.custtk, 100+document.body.scrollLeft, 100+document.body.scrollTop);
	gflag.tsp.bbj=browser; // custom track goes with tsp
} else {
	pagecloak.style.display = "none";
	panelFadeout(apps.custtk);
}
menu_hide();
}

Genome.prototype.parseCoordinate=function(input)
{
// input can be [chr, start, stop] or a string 'chr:start-stop', separated by \W
var c=[];
if(typeof(input)=='string') {
	var t=input.split(/\W/);
	if(t.length!=3) return null;
	c[0]=t[0];
	c[1]=parseInt(t[1]);
	c[2]=parseInt(t[2]);
} else {
	c=input;
}
if(c.length!=3) return null;
if(isNaN(c[1])) return null;
if(isNaN(c[2])) return null;
var len=this.scaffold.len[c[0]];
if(len==undefined) return null;
if(c[1]<0 || c[2]<=0) return null;
if(c[1]>c[2]) return null;
if(c[1]>=len) return null;
if(c[2]>len) return null;
return c;
}

function pica_go(x,y)
{
// x/y does not contain scroll offset
// if is null, won't change x/y
pica.style.display='block';
if(x!=null) {
	x+=document.body.scrollLeft;
	var xx=document.body.clientWidth+document.body.scrollLeft;
	if(x>xx-pica.clientWidth) {
		pica.style.left='';
		pica.style.right=xx-x+10-document.body.scrollLeft;
	} else {
		pica.style.right='';
		pica.style.left=x+10;
	}
}
if(y!=null) {
	y+=document.body.scrollTop;
	var yy=document.body.clientHeight+document.body.scrollTop;
	if(y>yy-pica.clientHeight) {
		pica.style.top='';
		pica.style.bottom=document.body.clientHeight-y;
	} else {
		pica.style.bottom='';
		pica.style.top=y+10;
	}
}
}

function htmltext_colorscale(minv,maxv,bg,nr,ng,nb,pr,pg,pb,nth,pth) {
/* minv,maxv
bg: background color
nr,ng,nb, pr,pg,pb,
nth,pth: color beyond p/n threshold, optional
*/
if(maxv<=0) {
	// only show negative bar
	return (nth==undefined?'':'<div style="width:10px;height:12px;display:inline-block;background-color:'+nth+';"></div> ')+
	neatstr(minv)+
	' <div style="width:50px;height:12px;display:inline-block;'+
	'background:-webkit-gradient(linear,left top,right top,from(rgb('+nr+','+ng+','+nb+')),to('+bg+'));'+
	'background:-moz-linear-gradient(left,rgb('+nr+','+ng+','+nb+'),'+bg+');"></div> '+
	neatstr(maxv);
}
if(minv>=0) {
	// only show positive bar
	return neatstr(minv)+
	' <div style="width:50px;height:12px;display:inline-block;'+
	'background:-webkit-gradient(linear,left top,right top,from('+bg+'),to(rgb('+pr+','+pg+','+pb+')));'+
	'background:-moz-linear-gradient(left,'+bg+',rgb('+pr+','+pg+','+pb+'));"></div> '+
	neatstr(maxv)+
	(pth==undefined?'':' <div style="width:10px;height:12px;display:inline-block;background-color:'+pth+';"></div>');
}
// show both bars
return (nth==undefined?'':'<div style="width:10px;height:12px;display:inline-block;background-color:'+nth+';"></div> ')+
neatstr(minv)+
' <div style="width:50px;height:12px;display:inline-block;'+
'background:-webkit-gradient(linear,left top,right top,from(rgb('+nr+','+ng+','+nb+')),to('+bg+'));'+
'background:-moz-linear-gradient(left,rgb('+nr+','+ng+','+nb+'),'+bg+');'+
'"></div> 0 <div style="width:50px;height:12px;display:inline-block;'+
'background:-webkit-gradient(linear,left top,right top,from('+bg+'),to(rgb('+pr+','+pg+','+pb+')));'+
'background:-moz-linear-gradient(left,'+bg+',rgb('+pr+','+pg+','+pb+'));'+
'"></div> '+neatstr(maxv)+
(pth==undefined?'':' <div style="width:10px;height:12px;display:inline-block;background-color:'+pth+';"></div>');
}

function pica_hide() {pica.style.display='none';}

function cloakPage()
{
pagecloak.style.display = 'block';
pagecloak.style.height = document.body.offsetHeight;
pagecloak.style.width = document.body.offsetWidth;
}

function toggle1(event)
{
// show hmtk facet panel
if(apps.hmtk.style.display == "none") {
	cloakPage();
	document.getElementById('nativefacet_holder').appendChild(browser.facet.main);
	panelFadein(apps.hmtk, 100+document.body.scrollLeft, 100+document.body.scrollTop);
	gflag.tsp.bbj=browser; // facet goes with tsp
} else {
	pagecloak.style.display = "none";
	panelFadeout(apps.hmtk);
}
menu_hide();
}

function toggle13() {gflag.browser.decor_invoketksp(event);}

/*** __tiny__ ends ***/

/*** __dom__ ***/
function make_nullgif(holder,width)
{
var i=document.createElement('img');
i.style.display='block';
i.src='/browser/images/null.gif';
i.width=width; i.height=1;
holder.appendChild(i);
}

function make_radiobutton(holder,pp)
{
var ip=document.createElement('input');
ip.type='radio';
ip.setAttribute('name',pp.name);
ip.setAttribute('id',pp.id);
ip.setAttribute('value',pp.value);
ip.addEventListener('change',pp.call,false);
holder.appendChild(ip);
var lb=document.createElement('label');
lb.style.marginLeft=5;
lb.innerHTML=pp.label;
lb.setAttribute('for',pp.id);
holder.appendChild(lb);
if(pp.linebreak)
	holder.appendChild(document.createElement('br'));
}
function dom_addbutt(holder,text,call)
{
var b=document.createElement('button');
b.type='button';
b.innerHTML=text;
b.addEventListener('click',call,false);
holder.appendChild(b);
return b;
}

function dom_addtext(holder,text,color,cls)
{
var s=document.createElement('span');
if(text)
	s.innerHTML=text;
if(color)
	s.style.color=color;
if(cls)
	s.className=cls;
holder.appendChild(s);
return s;
}

/*** __dom__ ends ***/


/*** __base__ ***/

function ajaxSvg(data2post, callback) {
    xmlhttp = new XMLHttpRequest();
    xmlhttp.onreadystatechange = function() {
	if(xmlhttp.readyState==4 && xmlhttp.status==200) {
	    callback(xmlhttp.responseText);
	}
    }
    xmlhttp.open('POST', '/cgi-bin/svg', true);
    xmlhttp.setRequestHeader("Content-type","application/x-www-form-urlencoded");
    xmlhttp.send(data2post);
}

Browser.prototype.ajaxSaveUrlpiece=function(url, callback)
{
if(this.urloffset >= url.length) {
	// entire URL has been saved, run it with callback
	this.ajax('reviveURL=on&dbName='+this.genome.name, callback);
	return;
}
gflag.saveurlbbj=this;
var xmlhttp;
if(window.XMLHttpRequest)
	xmlhttp = new XMLHttpRequest();
else
	xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
xmlhttp.onreadystatechange = function() {
	if(xmlhttp.readyState==4 && xmlhttp.status==200) {
		gflag.saveurlbbj.urloffset += urllenlimit;
		gflag.saveurlbbj.ajaxSaveUrlpiece(url, callback);
	}
}
xmlhttp.open("POST", "/cgi-bin/subtleKnife?NODECODE=on&offset="+this.urloffset+"&saveURLpiece="+escape(url.substr(this.urloffset, urllenlimit))+"&session="+this.sessionId+"&dbName="+this.genome.name, true);
xmlhttp.send();
}

Browser.prototype.ajax=function(queryUrl, callback)
{
/* in case of too long url, need to send it in small pieces one at a time
to get rid of "Request Entity Too Large" error on server

in case of saving status, don't run ajaxSaveUrlpiece(), 
as the already-escaped url will be escaped again,
and there's no good way to unescape on server-side

won't process abort directive from returned json packet

tell from the head of queryUrl if it is saving status
*/
if(queryUrl.length > urllenlimit) {
	this.urloffset = 0;
	this.ajaxSaveUrlpiece(queryUrl, callback);
	return;
}
var xmlhttp;
if(window.XMLHttpRequest)
	xmlhttp = new XMLHttpRequest();
else
	xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");

gflag.__ajax_bbj=this;
xmlhttp.onreadystatechange = function() {
	if(xmlhttp.readyState==4) {
		if(xmlhttp.status==200) {
			// ok status
			try {var data = eval('('+xmlhttp.responseText+')');}
			catch(err) {
				// try to salvage this session
				print2console('Failed to carry out this operation<br>but you can continue',3);
				gflag.__ajax_bbj.unveil();
				document.body.style.cursor='auto';
				return;
			}
			callback(data);
		} else if(xmlhttp.status==500){
			// server error
			print2console('Internal Server Error: please refresh the page and start over',3);
			gflag.__ajax_bbj.unveil();
			document.body.style.cursor='auto';
			return;
		}
	}
}
xmlhttp.open("GET", '/cgi-bin/subtleKnife?'+escape(queryUrl)+'&horcrux='+this.horcrux+'&session='+this.sessionId+'&statusId='+this.statusId+'&hmspan='+this.hmSpan+this.ajax_phrase, true);
xmlhttp.send();
}

Browser.prototype.loadgenome_initbrowser=function(genomename, contentparam)
{
/* given genome name, load up browser object
browser doms and tentacles must be ready
args:
- genomename: string
- contentparam: optional, {}

actually not too much use as in other applications
usually need to do specific stuff within ajax call
*/
if(genomename in genome) {
	browser.genome=genomeobj;
	browser.migratedatafromgenome();
	browser.fill_initialData(contentparam);
	return;
}
// genome is not there, load it first
if(contentparam)
	gflag.contentparam=contentparam;
print2console('loading genome information...',0);
this.ajax('loadgenome=on&dbName='+genomename,function(data){
	var bbj=horcrux[data.horcrux];
	var genomeobj=new Genome({custom_md:true});
	sukn_initializeGenome(genomeobj);
	genomeobj.jsonGenome(data);
	genome[genomeobj.name]=genomeobj;
	bbj.genome=genomeobj;
	bbj.migratedatafromgenome();
	bbj.fill_initialData(gflag.contentparam);
	delete gflag.contentparam;
});
}


Browser.prototype.displayedRegionParamMove=function()
{
var r1=this.regionLst[0];
var r2=this.regionLst[this.regionLst.length-1];
var jt = this.juxtaposition.type;
if(this.is_gsv()) {
	var samestring = "itemlist=on&startChr="+r1[6]+
		"&startCoord="+r1[3]+
		"&stopChr="+r2[6]+
		"&stopCoord="+r2[4]+
		"&sptotalnum="+(this.entire.spnum-this.regionLst.length+1);
	return samestring+(jt==RM_gsv_c ? gss_param(1) : gss_param(2));
}
var gfparam = 'gftype='+this.juxtaposition.what;
if(jt == RM_jux_c) 
	gfparam += '&gfiscustom=on';
return gfparam +
"&startChr=" + r1[0] +
"&startCoord=" + r1[3] +
"&stopChr=" + r2[0] +
"&stopCoord=" + r2[4] +
"&sptotalnum="+ (this.entire.spnum-this.regionLst.length+1);
}

Browser.prototype.displayedRegionParam=function()
{
/* only boundary within viewbox will be returned:
start: .vstartr .vstarts
stop:  .vstopr  .vstops
will be used in case of dsp zoom in level is changed:

variable arg: start coord of first region, stop coord of last region
to cope with zoom in

- zoom out
- zoom in (image area select)
- change collation type

total number of summary points will not be provided
 */
var r1 = this.regionLst[this.dspBoundary.vstartr];
var r2 = this.regionLst[this.dspBoundary.vstopr];
var param='';
var jt=this.juxtaposition.type;
if(this.is_gsv()) {
	if(jt==RM_gsv_c) {
		param += "&itemlist=on"+gss_param(1)+'&startChr='+r1[6]+'&stopChr='+r2[6];
	} else {
		param += "&itemlist=on"+gss_param(2)+'&startChr='+r1[6]+'&stopChr='+r2[6];
	}
} else {
	param += '&gftype='+this.juxtaposition.what+'&startChr='+r1[0]+'&stopChr='+r2[0];
	if(jt==RM_jux_c) 
		param += '&gfiscustom=on';
}

if(arguments[0]!=undefined && arguments[1]!=undefined) {
	return param + "&startCoord=" + arguments[0] + "&stopCoord=" + arguments[1];
} else {
	return param + "&startCoord="+
		(r1[3]+parseInt(this.dspBoundary.vstarts*(this.entire.atbplevel?1:this.entire.summarySize)))+
		"&stopCoord="+
		(r2[3]+parseInt(this.dspBoundary.vstops*(this.entire.atbplevel?1:this.entire.summarySize)));
}
}


Browser.prototype.displayedRegionParamPrecise=function()
{
/* use in operations that doesn't change dsp
- add tracks
- htest
- ajax correlation
- get data
 */
var jt = this.juxtaposition.type;
if(this.is_gsv()) {
	// only need to pass spnum of each item, but no need to pass item name, start/stop
	// as that's already in database
	var sizelst = []; // spnum in each item
	for(var i=0; i<this.regionLst.length; i++) 
		sizelst.push(this.regionLst[i][5]);
	var lastr = this.regionLst[this.regionLst.length - 1];
	var samestring = "itemlist=on&startChr="+this.regionLst[0][6]+
		"&startCoord="+this.regionLst[0][3]+
		"&stopChr="+lastr[6]+
		"&stopCoord="+lastr[4]+
		"&sptotalnum="+ (this.entire.atbplevel?this.entire.length:(this.entire.spnum-i)) +
		"&allrss=" + sizelst.join(',');
	if(jt==RM_gsv_c)
		return samestring+gss_param(1);
	else
		return samestring+gss_param(2);
}
// by passing exact information on each region in collation mode (chr, start/stop, spnum)
// it saves a lot of computing on server side, so it's necessary
var gf = this.juxtaposition.what;
var gfparam = 'gftype='+gf;
if(jt== RM_jux_c) gfparam += '&gfiscustom=on';
var lst = [];
for(var i=0; i<this.regionLst.length; i++) {
	var r = this.regionLst[i];
	lst.push(r[0]+','+r[1]+','+r[2]+','+(this.entire.atbplevel ? (r[4]-r[3]) : r[5]));
}
return gfparam +
   "&regionLst=" + lst.join(',') +
   "&startCoord=" + this.regionLst[0][3] +
   "&stopCoord=" + this.regionLst[this.regionLst.length-1][4];
}

Browser.prototype.displayedRegionParam_narrow=function()
{
var lst=[];
var start0, stop0;
for(var i=this.dspBoundary.vstartr;i<=this.dspBoundary.vstopr;i++) {
	var start=i==this.dspBoundary.vstartr ? getPointCoord(this.regionLst, this.entire, i, this.dspBoundary.vstarts) : this.regionLst[i][3];
	var stop=i==this.dspBoundary.vstopr ? getPointCoord(this.regionLst, this.entire, i, this.dspBoundary.vstops) : this.regionLst[i][4];
	lst.push(this.regionLst[i][0]);
	lst.push(start);
	lst.push(stop);
	lst.push(10); // fictional spnum
	if(i==this.dspBoundary.vstartr) start0=start;
	if(i==this.dspBoundary.vstopr) stop0=stop;
}
return '&gftype=genome&regionLst='+lst.join(',')+
	'&startCoord='+start0+
	'&stopCoord='+stop0;
}



/*
Browser.prototype.ajax2=function(queryUrl, callback)
{
// only take responseText, won't parse as json
var xmlhttp;
if(window.XMLHttpRequest)
	xmlhttp = new XMLHttpRequest();
else
	xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
xmlhttp.onreadystatechange = function() {
	if(xmlhttp.readyState==4 && xmlhttp.status==200) {
		callback(xmlhttp.responseText);
	}
}
xmlhttp.open("GET", "/cgi-bin/subtleKnife?"+queryUrl, true);
xmlhttp.send();
}
*/

Browser.prototype.houseParam=function()
{
// house keeping
return trackParam(this.tklst)+this.htestParams()+this.corrParam();
}
Browser.prototype.htestParams=function()
{
if(!this.htest.inuse) return '';
var lst = [];
for(var i=1; i<=this.htest.grpnum; i++) {
	lst.push("&htestgrp"+i+"="+this.htest["gtn"+i].join(","));
}
var v = getSelectValueById("htestc"); // correction
return "&htest=on&htestgrpnum="+this.htest.grpnum+lst.join("")+(v=="no" ? "" : "&htestc="+v);
}
Browser.prototype.corrParam=function()
{
/* if doing inter-track correlation, no need to interact with CGI,
and will return empty string
*/
if(!this.correlation.inuse) return "";
var tname = this.correlation.targetname;
var obj=this.findtkobj_display(tname);
switch(this.correlation.targetft) {
case FT_bed_n: // bigbed
	if(obj!=null && obj.mode==M_den)
		return "";
	return "&corrft=0&correlation="+tname;
case FT_bed_n: // bigbed (c)
	if(obj!=null && obj.mode==M_den)
		return "";
	return "&corrft=1&correlation="+obj.url;
case FT_bedgraph_c:
case FT_bedgraph_n:
case FT_bigwighmtk_c:
case FT_bigwighmtk_n:
	return "";
case FT_qdecor_n:
	// decor
	if(obj!=null)
		return "";
	return "&corrft=8&correlation="+tname;
default:
	fatalError("corrParam: unknown file type");
}
}
Browser.prototype.fill_initialData=function(param)
{
/* fill initial data for a browser
genome object must already been built
param is optional
- selecting a genome from oneshot panel
- change genome
*/
this.juxtaposition={type:RM_genome, note:'genome', what:'genome'};
var dfstuff=this.genome.defaultStuff;
this.mdcFromNativeTerms(dfstuff.mdtermlst);
var _tklst=[];
if(param && param.nohmtk) {
} else {
	for(var i=0; i<dfstuff.hmtk.length; i++) {
		var n=dfstuff.hmtk[i];
		if(n.length==0) continue;
		_tklst.push({name:n, ft:this.genome.hmtk[n].ft, mode:M_show});
	}
}
for(i=0; i<dfstuff.decor.length; i++) {
	// each ele is a tk name
	var nn=dfstuff.decor[i];
	var o=this.genome.decorInfo[nn];
	if(o==undefined) {
		fatalError('unknown default decor: '+nn);
	} else {
		_tklst.push({name:nn, ft:o.ft, mode:(o.ft==FT_bed_n?M_full:M_show)});
	}
}
this.ajax('first=on&addtracks=on&dbName='+this.genome.name+'&jump=on&jumppos2='+dfstuff.coord+trackParam(_tklst),function(data){
	var bbj=horcrux[data.horcrux];
	bbj.jsonDsp(data);
	bbj.jsonTrackdata(data);
	bbj.prepareMcm();
	bbj.render_browser();
	bbj.mcm_sort();
	bbj.generateTrackselectionLayout();
	__jsonPageinit(data);
});
}

Browser.prototype.ajaxX=function(param)
{
/* special treatmet for following conditions
- jumping to a gene but got multiple hits
- gsv itemlist updating
- generate a splinter
*/
this.ajax(param+'&dbName='+this.genome.name+this.houseParam(),function(data){
	var bbj=horcrux[data.horcrux];
	if('abort' in data) {
		print2console(data.abort, 3);
	} else if(data.jumpgenehitlst) {
		/* flow interrupted here
		showing list of hits/genes matching user input
		also add all new chroms that got there!!
		*/
		var table=document.getElementById('jumplstholder');
		table.style.display='block';
		genelist2selectiontable(data.jumpgenehitlst, table, menu_lstholder_jump);
		if('newscaffold' in data)
			bbj.ajax_scfdruntimesync();
	} else {
		menu_hide();
		menu2.style.display='none';
		if('newscaffold' in data) {
			bbj.ajax_scfdruntimesync();
		}
		bbj.jsonDsp(data);
		bbj.jsonTrackdata(data);
		bbj.move.direction=null;
		if(bbj.is_gsv() && data.ajaxXtrigger_gsvupdate) {
			/* gsv updating existing list
			always loses original dsp info
			returned regionLst always contains updated itemlist
			*/
			if(data.entirelst==undefined || data.entirelst.length==0)
				fatalError('gsv update: entirelst missing');
			bbj.genesetview.lst=data.entirelst;
			bbj.drawNavigator();
			bbj.genesetSubmitted(data);
		}
		if(bbj.animate_zoom_stat==1) {
			/* browser shows the animated zoom effect
			now tk data is ready, quit, browser render will be done once animation is over
			*/
			bbj.animate_zoom_stat=0;
			return;
		}
		bbj.drawRuler_browser(false);
		bbj.drawTrack_browser_all();
		bbj.drawIdeogram_browser(false);
	}
	bbj.unveil();
	print2console('done',1);

	if(gflag.splinter!=null) {
		/** __splinter__ produce splinter
		either from manual splinting
		or session restore to produce a bunch of splinters
		**/
		var tag=Math.random().toString();
		var td=bbj.splinterHolder.firstChild.firstChild.insertCell(-1);
		td.vAlign='top';
		var d=document.createElement('div');
		d.className='titlebox';
		td.appendChild(d);
		var d2=document.createElement('div'); // content
		d2.style.margin=(bbj.scalebar?'13px':'0px')+' 0px 0px 1px';
		d2.style.padding='13px 0px 0px 0px';
		d.appendChild(d2);
		d3=document.createElement('div'); // title
		d3.style.backgroundColor='#fff9d2';
		d3.style.left=20;
		d3.innerHTML= '<span class=clb title="zoom in" onclick=splinter_zoomin("'+tag+'")><img src=images/zoomin.png height=14 style="opacity:0.5;"></span>'+
		'<span class=clb title="zoom out" onclick=splinter_zoomout("'+tag+'")><img src=images/zoomout.png height=14 style="opacity:0.5;padding-left:10px;padding-right:10px;"></span>'+
		'<span class=clb title="pan to left" onclick=splinter_pan("'+tag+'","l") style="vertical-align:2px;padding-left:5px;padding-right:5px;">&#9664;</span>'+
		'<span class=clb title="pan to right" onclick=splinter_pan("'+tag+'","r") style="vertical-align:2px;padding-left:5px;padding-right:5px;">&#9654;</span>'+
		'<span class=header_b splinterTag='+tag+' onclick=menu_relocate_scfd(event)>location</span>'+
		'<span class=clb onclick=splinter_delete("'+tag+'") style="color:#89586E">&nbsp;&#10006;&nbsp;</span>';
		d.appendChild(d3);
		var chip=new Browser();
		chip.hmSpan=gflag.splinter[0];
		chip.splinterTag=tag;
		var coordstr=gflag.splinter[1];
		chip.splinterCoord=bbj.genome.parseCoordinate(coordstr);
		if(chip.splinterCoord==null) fatalError('wrong splinter coord');
		chip.leftColumnWidth=0;
		chip.browser_makeDoms({
			centralholder:d2,
			ghm_ruler:true,
			hmdivbg:'white'
			}
		);
		chip.ideogram.canvas.oncontextmenu=menu_coordnote;
		chip.genome=bbj.genome;
		chip.juxtaposition.type=RM_genome;
		chip.juxtaposition.note=chip.juxtaposition.what='genome';
		/* set following to null to disable corresponding actions */
		chip.facet=
		chip.cfacet=null;
		chip.applyHmspan2holders();
		chip.notes=bbj.notes;
		chip.trunk=bbj;
		// can only update trunk when splinter is ready
		bbj.splinters[tag]=chip;
		bbj.applyHmspan2holders();
		bbj.drawNavigator();
		gflag.splinter=null;
		chip.ajax('addtracks=on&dbName='+bbj.genome.name+'&jump=on&jumppos='+coordstr+trackParam(bbj.tklst),function(data){
			var chip=horcrux[data.horcrux];
			chip.jsonDsp(data);
			chip.jsonTrackdata(data);
			// point track qtc to trunk tracks so they are in sync
			for(var i=0; i<chip.tklst.length; i++)
				chip.tklst[i].qtc=chip.trunk.findTrack(chip.tklst[i].name).qtc;
			chip.drawRuler_browser(false);
			chip.drawTrack_browser_all();
			chip.drawIdeogram_browser(false);
			chip.trunk.splinterSynctkorder();
			if(gflag.splinter_todolst.length>0) {
				chip.trunk.splinter(gflag.splinter_todolst[0]);
				gflag.splinter_todolst.splice(0,1);
			}
		});
	}
});
}


function genelist2selectiontable(genelst,table,callback)
{
gflag.genelst=genelst;
stripChild(table,0);
var total=genelst.length;
var showcount=Math.min(total,20);
if(showcount<total) {
	var tr=table.insertRow(0);
	var td=tr.insertCell(0);
	td.colSpan=4;
	td.align='center';
	td.innerHTML='Showing first 20 hits, '+(total-showcount)+' not shown';
}
// see if genes are in same chr, if so, use better graphic
var chr=genelst[0].chrom;
var insamechr=true;
for(var i=1; i<showcount; i++) {
	if(genelst[i].chrom!=chr) {
		insamechr=false; break;
	}
}
var w=200, h=11; // canvas size
if(insamechr) {
	// get left/right most coord
	var start=genelst[0].start, stop=genelst[0].stop;
	for(i=1; i<showcount; i++) {
		start=Math.min(start,genelst[i].start);
		stop=Math.max(stop,genelst[i].stop);
	}
	var sf=w/(stop-start);
	// first row is header
	var tr=table.insertRow(-1);
	var td=tr.insertCell(0);
	td.align='center';
	td.innerHTML=chr;
	var c=document.createElement('canvas');
	c.width=w;
	c.height=10;
	var ctx=c.getContext('2d');
	ctx.fillStyle=colorCentral.foreground;
	ctx.fillRect(0,0,1,10);
	ctx.fillRect(w-1,0,1,10);
	ctx.fillRect(0,9,w,1);
	ctx.fillText(start, 3,8);
	var w2=ctx.measureText(stop.toString()).width;
	ctx.fillText(stop,w-w2-3,8);
	tr.insertCell(-1).appendChild(c);
	tr.insertCell(-1);
	tr.insertCell(-1);
	for(i=0; i<showcount; i++) {
		var g=genelst[i];
		var tr=table.insertRow(-1);
		tr.className='clb_o';
		tr.addEventListener('click', callback, false);
		tr.idx=i;
		var td=tr.insertCell(0)
		td.align='right';
		td.innerHTML=g.type;
		//td=tr.insertCell(-1); td.innerHTML=g.name; td.style.fontSize=12;
		var c=document.createElement('canvas');
		c.width=w;
		c.height=h;
		var ctx=c.getContext('2d');
		plotGene(ctx,'#956584',g.struct,g.strand=='+'?'>':'<',
			(g.start-start)*sf,
			0,
			sf*(g.stop-g.start),
			h,g.start,g.stop,false);
		td=tr.insertCell(-1);
		td.appendChild(c);
		td=tr.insertCell(-1);
		td.innerHTML=g.start+'-'+g.stop;
		td=tr.insertCell(-1);
		td.style.fontSize=10;
		td.innerHTML=g.desc.length>100?(g.desc.substr(0,100)+'...'):g.desc;
	}
} else {
	// get max width of these genes for plotting
	var maxbp=0;
	for(var i=0; i<showcount; i++)
		maxbp=Math.max(maxbp,genelst[i].stop-genelst[i].start);
	var sf=w/maxbp;
	for(i=0; i<showcount; i++) {
		var g=genelst[i];
		var tr=table.insertRow(-1);
		tr.className='clb_o';
		tr.addEventListener('click', callback, false);
		tr.idx=i;
		var td=tr.insertCell(0)
		td.align='right';
		td.innerHTML=g.type;
		//td=tr.insertCell(-1); td.innerHTML=g.name; td.style.fontSize=12;
		var c=document.createElement('canvas');
		c.width=w;
		c.height=h;
		var ctx=c.getContext('2d');
		plotGene(ctx,'#956584',g.struct,g.strand=='+'?'>':'<',0,0,sf*(g.stop-g.start),h,g.start,g.stop,false);
		td=tr.insertCell(-1);
		td.appendChild(c);
		td=tr.insertCell(-1);
		td.innerHTML=g.chrom+':'+g.start+'-'+g.stop;
		td=tr.insertCell(-1);
		td.innerHTML=g.desc.length>100?(g.desc.substr(0,100)+'...'):g.desc;
	}
}
}

Browser.prototype.tkpanelheight=function()
{
return this.hmdiv.clientHeight+this.ideogram.canvas.height+this.decordiv.clientHeight;
}

Browser.prototype.migratedatafromgenome=function()
{
/* migrate data from genome to browser
genome must be already built
supposed to be called after genome object is built
*/
if(this.genesetview && this.genesetview.submit_textarea)
	this.genesetview.submit_textarea.value=this.genome.defaultStuff.gsvlst;
// fill track facet criteria <select> with root terms
var lst=this.genome.mdvroot;
var o=document.createElement('option');
o.value=this.facet._no_term;
o.innerHTML="don't use";
this.facet.md2.appendChild(o);
for(var i=0; i<lst.length; i++) {
	o=document.createElement('option');
	o.value=o.innerHTML=lst[i];
	this.facet.md1.appendChild(o);
	o.selected=lst[i]==this.facet.defaultTerm1;
	o=document.createElement('option');
	o.value=o.innerHTML=lst[i];
	this.facet.md2.appendChild(o);
	o.disabled=lst[i]==this.facet.defaultTerm1;
	if(this.facet.defaultTerm2!=null)
		o.selected=lst[i]==this.facet.defaultTerm2;
}
// allow kegg query?
if(this.genesetview) {
	var kegg=this.genome.keggSpeciesCode!=null;
	this.genesetview.wrapper_buttons_nokegg.style.display=kegg?'none':'block';
	this.genesetview.wrapper_buttons_withkegg.style.display=kegg?'block':'none';
	this.genesetview.wrapper_custom.style.display=kegg?'none':'block';
}
}

Browser.prototype.cleanuphtmlholder=function()
{
/* do this before restoring status or changing genome */
// hmtk
this.tklst=[];
stripChild(this.hmheaderdiv, 0);
stripChild(this.hmdiv, 0);
//stripChild(this.pwc.grp1, 0);
//stripChild(this.pwc.grp2, 0);
this.pwc.gtn1 = [];
this.pwc.gtn2 = [];
// facet
stripChild(this.facet.md1,0);
stripChild(this.facet.md2,0);
stripChild(this.facet.div1,0);
if(this.facet.div2.firstChild)
	stripChild(this.facet.div2.firstChild,0);

// decor
stripChild(this.decordiv,0);
stripChild(this.decorheaderdiv,0);

// mcm
this.mcm.lst=[];
stripChild(this.mcm.holder.firstChild.firstChild, 0);
stripChild(this.mcm.tkholder, 0);

// metadata selection panel TODO
stripChild(this.genome.mdselect.cust, 0);
stripChild(this.cfacet.md1,0);
stripChild(this.cfacet.md2,1);

// custom tracks
this.genome.custtk.totalcount.innerHTML=this.genome.custtk.totalcount2.innerHTML = 0;
document.getElementById('cust1howmany').innerHTML = 0;
document.getElementById('custHmtkhowmany').innerHTML = 0;
document.getElementById('cust5howmany').innerHTML = 0;
document.getElementById('cust10howmany').innerHTML = 0;
stripChild(document.getElementById('custHolder1').firstChild, 0);
stripChild(document.getElementById('custHolderHmtk').firstChild, 0);
stripChild(document.getElementById('custHolder5').firstChild, 0);
stripChild(document.getElementById('custHolder10').firstChild, 0);
stripChild(this.cfacet.holder.firstChild, 0);

// session
document.getElementById('oldSessionId').value='enter session ID';
document.getElementById('statusNote').value='make a note';
document.getElementById('urlHolder').style.display='none';
stripChild(document.getElementById('statusHolder').firstChild,0);

// splinters
this.splinters={};
stripChild(this.splinterHolder.firstChild.firstChild,0);
this.init_hmSpan();
this.applyHmspan2holders();


// misc
document.getElementById('simpleinfowrapper').style.display='none';
//document.getElementById('hmtkorderRevertButton').style.display = 'none';
//document.getElementById('geolist4hmtk').value='';
this.notes=[];

/* bev cleanup
var lst = document.getElementById("bev_dataregistry").firstChild.childNodes;
for(var i=0; i<lst.length; i++)
	delete bev.data[lst[i].vectorname];
stripChild(document.getElementById("bev_dataregistry").firstChild, 0);
for(var cn in bev.genomeCanvasTd)
	stripChild(bev.genomeCanvasTd[cn], 0);
	*/

this.turnoffJuxtapose(false);
}

Browser.prototype.browser_makeDoms=function(param)
{
/* arg is a hash, with various configs and holders
make the original complicated table
leftColumnWidth must be set prior to this
*/
var table=document.createElement('table');
table.cellPadding=table.cellSpacing=0;
param.centralholder.appendChild(table);
this.main=table;
/***** row 1 ******/
var tr=table.insertRow(0);
var td=tr.insertCell(0); // 1-1
td=tr.insertCell(-1); // 1-2
td.colSpan=2; // for the splinter holder
if(param.browser_stat) {
	td.align='center';
	td.vAlign='top';
	td.style.color='#858585';
	td.style.paddingBottom=10;
	dom_addtext(td,'View range');
	s=dom_addtext(td);
	this.dspstatsays=s;
	s.style.marginLeft=10;
	s.style.marginRight=20;
	this.resolutionsays=dom_addtext(td);
} else {
	this.dspstatsays=this.resolutionsays=null;
}
td=tr.insertCell(-1); // 1-3
td.vAlign='bottom'; // mcm header holder here??
/***** row 2 ******/
tr=table.insertRow(-1);
td=tr.insertCell(0); // 2-1
if(param.navigator && this.leftColumnWidth>0) {
	td.align='center';
	td.vAlign='top';
	var s=dom_addtext(td,'GSV OFF',null,'header_r');
	s.title='Turn off Gene Set View';
	s.style.display='none';
	s.addEventListener('click',gsv_turnoff,false);
	this.__gsv_offbutt=s;
}
td=tr.insertCell(-1); // 2-2
td.colSpan=2; // for the splinter holder
if(param.navigator) {
	var c=document.createElement('canvas');
	c.className='opacity5';
	c.width=0;
	c.height=this.navigator.chrbarheight+2*this.navigator.hlspacing+2+this.navigator.rulerheight;
	this.navigator.canvas=c;
	this.navigator.show_ruler=param.navigator_ruler;
	c.addEventListener('mousemove',navigator_mm,false);
	c.addEventListener('mouseout',pica_hide,false);
	c.addEventListener('mousedown',navigatorMD,false);
	td.appendChild(c);
} else {
	this.navigator=null;
}
/***** row 3 ******/
tr=table.insertRow(-1);
td=tr.insertCell(0); // 3-1
td=tr.insertCell(1); // 3-2
td.vAlign='bottom';
if(param.ghm_scale) {
	var d=document.createElement('div');
	d.style.height=27;
	d.style.position='relative';
	this.scalebar.holder=d;
	td.appendChild(d);
	var d2=document.createElement('div');
	d2.style.position='absolute';
	d2.style.bottom=0;
	d2.style.left=352;
	d2.innerHTML='80mpg';
	d2.addEventListener('mousedown',scalebarSliderMD,false);
	this.scalebar.says=d2;
	d.appendChild(d2);
	var c=document.createElement('canvas');
	c.style.display='block';
	c.style.position='absolute';
	c.style.left=400;
	c.style.bottom=0;
	c.width=20;
	c.height=16;
	c.addEventListener('mousedown',scalebarSliderMD,false);
	c.addEventListener('mouseover',scalebarMover,false);
	c.addEventListener('mouseout',scalebarMout,false);
	this.scalebar.slider=c;
		{
		var ctx = c.getContext('2d');
		ctx.fillStyle = 'black';
		ctx.fillRect(0,3,1,c.height-5);
		ctx.fillRect(0,8,c.width,1);
		}
	d.appendChild(c);
	c=document.createElement('canvas');
	c.style.display='block';
	c.style.position='absolute';
	c.style.bottom=0;
	c.style.left=413;
	c.width=20;
	c.height=16;
	c.addEventListener('mousedown',scalebarArrowMD,false);
	c.addEventListener('mouseover',scalebarMover,false);
	c.addEventListener('mouseout',scalebarMout,false);
	this.scalebar.arrow=c;
	d.appendChild(c);
	this.drawScalebarSlider();
} else {
	this.scalebar=null;
}
if(param.ghm_ruler) {
	var d=document.createElement('div');
	d.className='scholder';
	d.style.height=11;
	td.appendChild(d);
	var c=document.createElement('canvas');
	c.height=11; c.width=0;
	c.style.position='absolute';
	c.addEventListener('mousedown',zoomin_MD,false);
	this.rulercanvas=c;
	d.appendChild(c);
} else {
	this.rulercanvas=null;
}
td=tr.insertCell(-1); // 3-3 the splinter holder!!
td.rowSpan=7;
td.vAlign='top';
	{
	var stb=document.createElement('table');
	stb.cellSpacing=stb.cellPadding=0;
	stb.insertRow(0);
	td.appendChild(stb);
	this.splinterHolder=stb;
	}
/***** row 4 ******/
tr=table.insertRow(-1);
td=tr.insertCell(0); // 4-1
if(param.tkheader) {
	this.hmheaderdiv=td;
} else {
	this.hmheaderdiv=null;
}
td=tr.insertCell(-1); // 4-2
var d=document.createElement('div');
d.className='scholder';
td.appendChild(d);
var d2=document.createElement('div');
d2.style.position='absolute';
d2.style.backgroundColor=param.hmdivbg;
d2.addEventListener('mousedown',viewboxMD,false);
d.appendChild(d2);
this.hmdiv=d2;
td=tr.insertCell(-1); // 4-3
if(param.mcm) {
	this.mcm.tkholder=td;
	var t=document.createElement('table');
	document.body.appendChild(t);
	this.mcm.holder=t;
	t.cellPadding=t.cellSpacing=0;
	t.insertRow(0);
	if(!param.mcmfixposition)
		t.style.position='absolute';
} else {
	this.mcm=null;
}
/***** row 5 ******/
tr=table.insertRow(-1);
td=tr.insertCell(0); // 5-1
td.align='center';
td.vAlign='top';
var c=document.createElement('canvas');
c.width=
td.style.width=this.leftColumnWidth;
c.height=12;
c.style.marginTop=2;
c.style.display='none';
td.appendChild(c);
this.basepairlegendcanvas=c;
td=tr.insertCell(-1); // 5-2
d=document.createElement('div');
d.className='scholder';
d.style.marginBottom=2;
td.appendChild(d);
var d2=document.createElement('div');
d2.style.position='absolute';
d.appendChild(d2);
var d3=document.createElement('div');
d3.style.position='relative';
d2.appendChild(d3);
c=document.createElement('canvas');
c.style.marginBottom=3;
c.width=c.height=0;
c.addEventListener('mousedown', zoomin_MD,false);
this.ideogram.canvas=c;
d3.appendChild(c);
td=tr.insertCell(-1); // 5-3
td.rowSpan=5;
if(this.mcm!=null && param.mcmfixposition) {
	td.appendChild(this.mcm.holder);
	td.vAlign='top';
}
/***** row 6 ******/
tr=table.insertRow(-1);
td=tr.insertCell(0); // 6-1
c=document.createElement('canvas');
c.style.display='none';
this.htest.header=c;
td.appendChild(c);
td=tr.insertCell(-1); // 6-2
d=document.createElement('div');
d.className='scholder';
d.style.display='none';
this.htest.holder=d;
td.appendChild(d);
c=document.createElement('canvas');
c.style.position='absolute';
this.htest.canvas=c;
d.appendChild(c);
/***** row 7 ******/
tr=table.insertRow(-1);
td=tr.insertCell(0); // 7-1
c=document.createElement('canvas');
c.style.display='none';
this.pwc.header=c;
td.appendChild(c);
td=tr.insertCell(-1); // 7-2
d=document.createElement('div');
d.className='scholder';
d.style.display='none';
this.pwc.holder=d;
td.appendChild(d);
c=document.createElement('canvas');
c.style.position='absolute';
this.pwc.canvas=c;
d.appendChild(c);
/***** row 8 ******/
tr=table.insertRow(-1);
td=tr.insertCell(0); // 8-1
if(param.tkheader) {
	td.vAlign='top';
	this.decorheaderdiv=td;
} else {
	this.decorheaderdiv=null;
}
td=tr.insertCell(-1); // 8-2
td.vAlign='top';
d=document.createElement('div');
d.className='scholder';
td.appendChild(d);
d2=document.createElement('div');
d2.style.position='absolute';
d2.addEventListener('mousedown',viewboxMD,false);
d.appendChild(d2);
this.decordiv=d2;
if(this.splinterTag!=null) {
	this.rulercanvas.splinterTag=
	this.ideogram.canvas.splinterTag=
	this.hmdiv.splinterTag=
	this.decordiv.splinterTag=this.splinterTag;
}

if(param.nativefacet)
	this.nativefacet_makeDoms(param);
else
	this.facet=null;

if(param.gsv)
	this.gsv_makeDoms(param);
else
	this.genesetview=null;
/* over */
}

Browser.prototype.gsv_makeDoms=function(param)
{
this.genesetview = {
	flanking:{},
	ideogram_stroke:'#1F3D7A',
	ideogram_fill5:'#85E094', // 5' upstream
	ideogram_fill3:'#E39F91', // 3' downstream
	minichr_filla:'#a3a3a3',
	minichr_fillb:'#c96',
	minichr_text:'white',
	lst:[], // item region [name, chr, start, stop, plotlen], this is ALL of them not merely in dsp
	lstsf:0, // scaling factor from bplen to plot len
	lstholder:'', // item list holder table
	gss_down:2500,
	gss_down_ghost:2500,
	gss_opt:'genebody',
	gss_opt_ghost:'genebody',
	gss_origin:'txstart',
	gss_origin_ghost:'txstart',
	gss_says:'gene body or entire interval',
	gss_says_ghost:'gene body or entire interval',
	gss_up:2500,
	gss_up_ghost:2500,
	};
var main=document.createElement('div');
this.genesetview.main=main;

// row 1
var d1=document.createElement('div');
d1.className='gplot_header';
d1.style.padding=0;
main.appendChild(d1);
var d2=document.createElement('div');
d2.style.fontSize='inherit';
d2.style.color='inherit';
d2.style.margin=5;
d2.style.textAlign='center';
d2.style.borderWidth=0;
d2.style.display='none';
//d2.addEventListener('click',gsv_turnoff);
dom_addtext(d2,'Running on ');
this.genesetview.runningonwhat=dom_addtext(d2,'');
var closebutt=dom_addtext(d2,'Turn off',null,'button_warning');
closebutt.addEventListener('click',gsv_turnoff,false);
closebutt.style.display='inline-block';
closebutt.style.marginLeft=20;

this.genesetview.wrapper_cancel=d2;
d1.appendChild(d2);
d2=document.createElement('div');
d2.style.marginLeft=60;
d2.style.width=600;
this.genesetview.wrapper_buttons=d2;
d1.appendChild(d2);
var d3=document.createElement('div');
d3.style.fontSize=20;
d3.style.color='#D8B164';
d3.style.padding=10;
d3.innerHTML='Submit custom gene set <span style="font-size:50%;">KEGG pathway search is unavailable for the moment</span>';
this.genesetview.wrapper_buttons_nokegg=d3;
d2.appendChild(d3);
d3=document.createElement('div');
d3.innerHTML='<div class=largebutt2 onclick="gflag.gsv.bbj.toggle9(1)">\
<div style="font-size:80px;color:white;bottom:-30px;">&#10034;</div>\
<div>Custom gene set</div>\
</div>\
<div class=largebutt2 onclick="gflag.gsv.bbj.toggle9(2)">\
<img src=/browser/images/kegg2_menu.gif style="bottom:-10px;right:-10px;">\
<div>KEGG pathways</div>\
</div>';
this.genesetview.wrapper_buttons_withkegg=d3;
d2.appendChild(d3);

// row 2
d1=document.createElement('div'); // contains all the rest
d1.style.borderBottom='1px solid #e0da85';
main.appendChild(d1);
make_nullgif(d1,700);
d2=document.createElement('div');
this.genesetview.wrapper_custom=d2;
d1.appendChild(d2);
var table=document.createElement('table');
table.cellPadding=5;
d2.appendChild(table);
var tr=table.insertRow(0);
var td=tr.insertCell(0);
td.vAlign='top';
td.rowSpan=2;
var ta=document.createElement('textarea');
ta.rows=12;
ta.cols=25;
td.appendChild(ta);
this.genesetview.submit_textarea=ta;
td=tr.insertCell(1);
td.vAlign='top';
td.style.width=400;
var p=document.createElement('p');
p.innerHTML='Enter a list of genes or intervals to run Gene Set View<br>'+
'<span style="color:#858585;">Use one item per line, '+
'gene names and interval coordinates can be mixed together for input.</span>';
td.appendChild(p);

p=document.createElement('p');
p.style.backgroundColor='white';
var cb=document.createElement('input');
cb.type='checkbox';
cb.id=this.horcrux+'gsvallinterval';
this.genesetview.custgsv_allinterval=cb;
p.appendChild(cb);
var label=document.createElement('label');
label.innerHTML='input contains genomic intervals, <b>no gene name</b>';
label.setAttribute('for', cb.id);
p.appendChild(label);
p.appendChild(document.createElement('br'));
dom_addtext(p,'will greatly speed up processing your input','#858585');
td.appendChild(p);


dom_addtext(td,'Display&nbsp;');
var s=dom_addtext(td,this.genesetview.gss_says);
s.style.textDecoration='underline';
this.genesetview.gss_submitcust_uisays=s;
td.appendChild(document.createElement('br'));
dom_addbutt(td,'change &#187;',custgsv_invokegss);
tr=table.insertRow(1);
td=tr.insertCell(0);
td.vAlign='bottom';
this.genesetview.submitbutt_cust=dom_addbutt(td,'SUBMIT',customgsv_submit_pushbutt);
dom_addbutt(td,'Clear',customgsv_clear_pushbutt);
/*
<table class=tipbottom style='margin-top:28px;'>
  <tr><td style='padding-left:20px;color:#91B995;font-size:200%'>&#9834;</td>
  <td style='color:#91B995;padding-left:20px;padding-right:20px;'>
  Gene Set View is suitable for exploring detailed data pattern<br>
  over a small set of items, usually less than 200.<br>
  If you have more than that, please use <a href=http://washugb.blogspot.com/2012/09/generate-tabix-files-from-bigbed-files.html target=_blank style='color:inherit'>custom bed track</a>.
  </td></tr>
</table>
*/

d2=document.createElement('div');
d2.style.display='none';
this.genesetview.wrapper_kegg=d2;
d1.appendChild(d2);
d2.style.position='relative';
d2.style.overflow='hidden';
/*
var img=document.createElement('img');
img.src='/browser/images/kegg2_menu.gif';
img.width=100;
img.style.position='absolute';
img.style.right=img.style.bottom=0;
img.style.opacity=0.15;
d2.appendChild(img);
*/
table=document.createElement('table');
d2.appendChild(table);
table.cellSpacing=10;
tr=table.insertRow(0);
td=tr.insertCell(0);
td.style.paddingRight=40;
var input=document.createElement('input');
input.type='text';
input.size=15;
input.value='enter keywords';
input.addEventListener('focus',gsvkegg_input_focus,false);
input.addEventListener('blur',gsvkegg_input_blur,false);
input.addEventListener('keyup',keggpathwaykeywordlookup_ku,false);
this.genesetview.keggkwinput=input;
td.appendChild(input);
this.genesetview.keggkwsearchbutt=dom_addbutt(td,'Search pathway',keggpathwaykeywordlookup);
td.appendChild(document.createElement('br'));
td=tr.insertCell(-1);
dom_addtext(td,'Display&nbsp;');
var s=dom_addtext(td,'gene body');
s.style.textDecoration='underline';
this.genesetview.gss_submitkegg_uisays=s;
dom_addbutt(td,'change &#187;',kegg_invokegss);
d3=document.createElement('div');
d3.className='container';
d3.style.display='none';
d2.appendChild(d3);
this.genesetview.wrapper_pathwaytable=d3;
d3.style.margin='10px 10px 30px 10px';
var table=document.createElement('table');
table.style.width='100%';
table.cellSpacing=2;
table.cellPadding=0;
this.genesetview.pathwaytable=table;
d3.appendChild(table);
dom_addtext(d2,'<br>Service depends on availability of <a href=http://www.kegg.jp target=_blank>KEGG database</a>','#858585');

d2=document.createElement('div');
d2.style.position='relative';
d2.style.display='none';
d1.appendChild(d2);
this.genesetview.wrapper_operation=d2;
d3=document.createElement('div');
d3.className='alertmsg';
d3.style.display='none';
d3.style.marginBottom=20;
this.genesetview.gsv_says_toomany=d3;
d2.appendChild(d3);

table=document.createElement('table'); // gsv edit ui
d2.appendChild(table);
tr=table.insertRow(0);
td=tr.insertCell(0);
td.colSpan=3;
d3=document.createElement('div');
d3.innerHTML='<span style="color:#858585">Drag <span class=header_b2>&nbsp;item&nbsp;</span> vertically to reorder; click <span class=header_r>&#10005;</span> to mark for removal</span>'+
'<button type=button style="display:inline;" onclick="gflag.browser.gsv_updatefromlstholder()">Update</button>';
td.appendChild(d3);
d3=document.createElement('div');
d3.className='container';
d3.style.backgroundColor='white';
td.appendChild(d3);
var table2=document.createElement('table');
table2.insertRow(0);
this.genesetview.lstholder=table2;
d3.appendChild(table2);
tr=table.insertRow(-1);

td=tr.insertCell(0); // td 1: add new
td.vAlign='top';
d3=document.createElement('div');
d3.className='titlebox';
td.appendChild(d3);
var d4=document.createElement('div');
d4.style.marginLeft=0;
d3.appendChild(d4);
ta=document.createElement('textarea');
ta.style.display='block';
ta.rows=5;
ta.cols=18;
this.genesetview.edit_textarea=ta;
d4.appendChild(ta);
dom_addbutt(d4,'Submit',gsvedit_addnew_pushbutt);
d4=document.createElement('div');
d4.style.backgroundColor='#fefae0';
d4.innerHTML='Add new items';
d3.appendChild(d4);

td=tr.insertCell(-1); // td 2: sort
td.vAlign='top';
d3=document.createElement('div');
d3.className='titlebox';
td.appendChild(d3);
d4=document.createElement('div');
d3.appendChild(d4);
make_radiobutton(d4,{name:'genesetsortby',label:'genome location',id:'genesetsortby1',value:'coord',call:genesetsortbyChangeoption,linebreak:true});
make_radiobutton(d4,{name:'genesetsortby',label:'length &#11014;',id:'genesetsortby2',value:'lenAsc',call:genesetsortbyChangeoption,linebreak:true});
make_radiobutton(d4,{name:'genesetsortby',label:'length &#11015;',id:'genesetsortby3',value:'lenDesc',call:genesetsortbyChangeoption,linebreak:true});
make_radiobutton(d4,{name:'genesetsortby',label:'track score &#11014;',id:'genesetsortby4',value:'tkmeanAsc',call:genesetsortbyChangeoption,linebreak:true});
make_radiobutton(d4,{name:'genesetsortby',label:'track score &#11015;',id:'genesetsortby5',value:'tkmeanDesc',call:genesetsortbyChangeoption,linebreak:true});
var d5=document.createElement('div');
d5.className='container';
this.genesetview.tksortselectdiv=d5;
d4.appendChild(d5);
d5.style.display='none';
d5.style.margin=d5.style.padding=15;
var b=dom_addbutt(d5,'Select a track...',genesetsort_invoketkselect);
b.style.display='block';
var s=dom_addtext(d5,'NONE');
this.genesetview.sort_tklabel=s;
dom_addtext(d5,'&nbsp;selected');
var d6=document.createElement('div');
d6.style.margin=5;
d6.style.color='silver';
d6.innerHTML='<button type=button onclick="gflag.gsv.bbj.gsv_update_sort()">Apply</button> to override current order';
d4.appendChild(d6);
d6=document.createElement('div');
d6.style.backgroundColor='#fefae0';
d6.innerHTML='Sort and rank';
d3.appendChild(d6);

td=tr.insertCell(-1); // td 3: change part
td.vAlign='top';
var d1=document.createElement('div');
d1.className='titlebox';
td.appendChild(d1);
var d2=document.createElement('div');
d2.style.marginLeft=0;
d2.style.width=240;
d1.appendChild(d2);
dom_addtext(d2,'Display&nbsp;');
var s=dom_addtext(d2);
s.style.textDecoration='underline';
this.genesetview.gss_edit_uisays=s;
d2.appendChild(document.createElement('br'));
dom_addbutt(d2,'change &#187;',gsedit_invokegss);
d2.appendChild(document.createElement('br'));
dom_addtext(d2,'*gene-related choices have no effect on genomic intervals','silver');
d2.appendChild(document.createElement('br'));
dom_addbutt(d2,'Update',gsedit_changepart_pushbutt);
d2=document.createElement('div');
d2.innerHTML='Choose flanking';
d2.style.backgroundColor='#fefae0';
d1.appendChild(d2);
if(param.gsv_geneplot) {
	var b=dom_addbutt(td,'Gene Plot',invokegeneplot_geneset);
	b.style.margin=10;
	b.className='big';
}
}


Browser.prototype.nativefacet_makeDoms=function(param)
{
this.facet={
	_no_term:'no',
	defaultTerm1:literal_sample,
	defaultTerm2:literal_assay,
	v1:null,
	v2:null,
	rowlst:[],
	collst:[],
	rowlst_td:[],
	collst_td:[],
	pending:{}, // a hash of tk names
};
this.facet.main=document.createElement('div');
var d1=document.createElement('div');
d1.style.position='relative';
this.facet.main.appendChild(d1);
var d2=document.createElement('div');
d2.className='tabpageSpacer';
d2.style.width=50;
d1.appendChild(d2);
if(param.tab_facet) {
	d2=document.createElement('div');
	d2.className='tabpageOn';
	d2.innerHTML='Track';
	d2.which='facet';
	this.facet.tab_facet=d2;
	d2.addEventListener('click',nativefacet_tabclick,false);
	d1.appendChild(d2);
	d2=document.createElement('div');
	d2.className='tabpageSpacer';
	d1.appendChild(d2);
}
if(param.tab_dataset) {
	d2=document.createElement('div');
	d2.innerHTML='Data set';
	d2.className='tabpageOff';
	d2.which='dataset';
	this.facet.tab_dataset=d2;
	d2.addEventListener('click',nativefacet_tabclick,false);
	d1.appendChild(d2);
}
// keyword search is always shown
d2=document.createElement('div');
d2.className='tabpageSpacer';
d1.appendChild(d2);
d2.style.paddingLeft=30;
d2.style.width='auto';
var ip=document.createElement('input');
ip.type='text';
ip.size=20;
ip.addEventListener('keyup', nativetk_kwsearch_ku,false);
this.facet.kwsearch_input=ip;
d2.appendChild(ip);
dom_addbutt(d2,'Find',nativetk_kwsearch);
var s=dom_addtext(d2,'&nbsp;&#8505;&nbsp;');
s.addEventListener('mouseover',kwsearch_tipover,false);
s.addEventListener('mouseout',pica_hide,false);

// body
var d3=document.createElement('div');
if(param.body_class)
	d3.className=param.body_class;
d3.style.padding=20;
this.facet.main.appendChild(d3);
make_nullgif(d3,600);
var d4=document.createElement('div');
d3.appendChild(d4);
this.facet.content_facet=d4;

var tt=document.createElement('table');
d4.appendChild(tt);
this.facet.banner=tt;
tt.style.marginBottom=20;
var tr=tt.insertRow(0);
var td=tr.insertCell(0);
dom_addtext(td,'1<sup>st</sup> criterion');
s=document.createElement('select');
td.appendChild(s);
s.which='md1';
s.addEventListener('change', facet_selectchange, false);
this.facet.md1=s;
td=tr.insertCell(1);
td.style.padding='0px 15px 0px 15px';
dom_addtext(td,'2<sup>nd</sup> criterion');
s=document.createElement('select');
td.appendChild(s);
s.which='md2';
s.addEventListener('change', facet_selectchange, false);
this.facet.md2=s;
td=tr.insertCell(2);
var s=dom_addtext(td,'Remove all',null,'button_warning');
s.addEventListener('click', removeallnativehmtk,false);
var d5=document.createElement('div');
this.facet.div1=d5;
d4.appendChild(d5);
d5=document.createElement('table');
d5.cellSpacing=3;
d5.cellPadding=1;
this.facet.div2=d5;
d4.appendChild(d5);

d5=document.createElement('div');
d4.appendChild(d5);
this.facet.div3=d5;
d5.style.borderStyle='solid';
d5.style.borderWidth='0px 1px 1px';
d5.style.borderColor='rgb(224,218,133)';
var d6=document.createElement('div');
d6.className='gplot_header_clb';
d6.addEventListener('click',facet_subtable_cancel,false);
d6.innerHTML='Go Back';
d5.appendChild(d6);
d6=document.createElement('table');
d6.style.margin=10;
d6.insertRow(0);
d5.appendChild(d6);

if(param.tab_dataset) {
	d4=document.createElement('div');
	d4.style.width=680;
	d3.appendChild(d4);
	this.facet.content_dataset=d4;
}

if(this.facet.tab_facet) {
	gflag.tsp.bbj=this;
	simulateEvent(this.facet.tab_facet,'click');
	gflag.tsp.bbj=null;
}
/* over */
}



Browser.prototype.splinterSynctkorder=function()
{
for(var tag in this.splinters) {
	var spt=this.splinters[tag];
	var newlst=[];
	for(var j=0; j<this.tklst.length; j++) {
		var tk=spt.findTrack(this.tklst[j].name);
		tk.where=this.tklst[j].where;
		newlst.push(tk);
	}
	spt.tklst=newlst;
	spt.trackdom2holder();
}
}


/*** __base__ ends ***/





/*** __render__ ***/

Browser.prototype.init_hmSpan=function()
{
var tobe = document.body.clientWidth-this.leftColumnWidth-200;
if(tobe < 800)
	this.hmSpan=800;
else
	this.hmSpan=parseInt(tobe/10) * 10; // well, just to cope with letter display
}

Browser.prototype.applyHmspan2holders=function()
{
if(this.navigator!=null) {
	// in case of using splinters, need to sum up splinter width
	var s=this.hmSpan;
	for(var tag in this.splinters)
		s+=this.splinters[tag].hmSpan;
	this.navigator.canvas.width=s-30;
}
if(this.scalebar!=null)
	this.scalebar.holder.style.width=this.hmSpan;
if(this.rulercanvas!=null)
	this.rulercanvas.parentNode.style.width=this.hmSpan;
this.hmdiv.parentNode.style.width=
this.decordiv.parentNode.style.width=
this.ideogram.canvas.parentNode.parentNode.style.width=this.hmSpan;
}

Browser.prototype.render_browser=function(tosvg)
{
/* render browser panel, all tracks and all the stuff must be ready
not including bev, hengeview, ...
called for:
- initiating browser panel
- changedb
- restoring status
- change ghm width
*/

this.drawRuler_browser(tosvg);
this.drawTrack_browser_all();
this.drawMcm(tosvg);
this.mcmPlaceheader();
this.drawIdeogram_browser(tosvg);
this.scalebarSlider_fill();
this.drawNavigator();
}

Browser.prototype.drawTrack_browser_all=function()
{
for(var i=0; i<this.tklst.length; i++)
	this.drawTrack_browser(this.tklst[i],false);
this.trackHeightChanged();
this.placeMovable(this.move.styleLeft);
// track moving pillar
}

Browser.prototype.drawTrack_browser=function(tkobj, tosvg)
{
/* draw one regular track in browser panel
not for bev or hengeview
will draw main canvas and header, but not mcm
*/
var svgdata;

if(isHmtk(tkobj.ft) || tkobj.ft==FT_qdecor_n || tkobj.mode==M_den) {
	/* numerical or categorical */
	svgdata={};
	tkobj.canvas.width = this.entire.spnum;
	var unitwidth = this.entire.atbplevel ? this.entire.bpwidth : 1;
	var ctx = tkobj.canvas.getContext("2d");

	if(tkobj.ft==FT_cat_c || tkobj.ft==FT_cat_n) {
		/* categorical */
		tkobj.canvas.height=tkobj.qtc.height;
		var ploth = tkobj.qtc.height;
		var xoffset = this.dspBoundary.lwidx;
		var svgdata2=[]; // one element for each cell
		for(var i=this.dspBoundary.lwr; i<=this.dspBoundary.rwr; i++) {
			var start = (i==this.dspBoundary.lwr) ? this.dspBoundary.lws : 0;
			var stop = (i==this.dspBoundary.rwr) ? this.dspBoundary.rws : (this.entire.atbplevel?(this.regionLst[i][4]-this.regionLst[i][3]):this.regionLst[i][5]);
			var sd2=categoricalTk_plot_base(tkobj.data[i], tkobj.cateInfo, start, stop, ctx, qtc, xoffset, 0, unitwidth, ploth,tosvg);
			if(tosvg) {
				svgdata2=svgdata2.concat(sd2);
				svgdata2.push([regionSpacing.color,true]);
			}
			xoffset += unitwidth*(stop-start);
			ctx.fillStyle = regionSpacing.color;
			ctx.fillRect(xoffset, 0, regionSpacing.width, ploth);
			xoffset += regionSpacing.width;
		}
		svgdata.hm=svgdata2;
	} else {
		/* numerical */
		tkobj.canvas.height = tkobj.qtc.height + (tkobj.qtc.height>=20 ? densitydecorpaddingtop : 0);
		var data2 = tkobj.qtc.uselog ? qtrack_logtransform(tkobj.data, tkobj.qtc, this.dspBoundary.lwr, this.dspBoundary.rwr, this.dspBoundary.lws, this.dspBoundary.rws) : tkobj.data;
		var thv = qtrack_getthreshold(data2, tkobj.qtc, this.dspBoundary.vstartr, this.dspBoundary.vstopr, this.dspBoundary.vstarts, this.dspBoundary.vstops);
		tkobj.maxv=thv[0]; // for header plotting
		tkobj.minv=thv[1];
		var xoffset = this.dspBoundary.lwidx;
		var svgbardata=[];
		var ploth = tkobj.qtc.height;
		for(var i=this.dspBoundary.lwr; i<=this.dspBoundary.rwr; i++) {
			var start = (i==this.dspBoundary.lwr) ? this.dspBoundary.lws : 0;
			var stop = (i==this.dspBoundary.rwr) ? this.dspBoundary.rws : (this.entire.atbplevel?(this.regionLst[i][4]-this.regionLst[i][3]):this.regionLst[i][5]);
			if(tkobj.qtc.height>=20) {
				var sd1=qtrack_plotwiggle_base(data2[i], start, stop, ctx, tkobj.qtc, thv[0], thv[1], xoffset, densitydecorpaddingtop, unitwidth, ploth, true, tosvg);
				if(tosvg) {
					svgbardata=svgbardata.concat(sd1);
					svgbardata.push([,,,true]);
				}
			} else {
				var sd2=qtrack_plotheatmap_base(data2[i], start, stop, ctx, tkobj.qtc, thv[0], thv[1], xoffset, 0, unitwidth, ploth, tosvg);
				if(tosvg) {
					svgbardata=svgbardata.concat(sd2);
					svgbardata.push([regionSpacing.color,true]);
				}

			}
			xoffset += unitwidth*(stop-start);
			ctx.fillStyle = regionSpacing.color;
			ctx.fillRect(xoffset, 0, regionSpacing.width, tkobj.canvas.height);
			xoffset += regionSpacing.width;
		}
		if(tkobj.qtc.height >= 20) {
			svgdata.wig=[svgbardata, thv];
		} else {
			svgdata.hm=svgbardata;
		}
		/* in case of splinter track
		always draw a in-track scale as its scale is usually different with trunk
		*/
		if(this.splinterTag!=null && tkobj.qtc.height>=20) {
			drawVerticalAxis(
				tkobj.qtc,
				tkobj.canvas,
				this.hmSpan-this.move.styleLeft-10,
				densitydecorpaddingtop,
				tkobj.qtc.height,
				tkobj.maxv, tkobj.minv, true, colorCentral.foreground);
		}
	}
} else {
	// stack or longrange
	svgdata=this.drawDecor_variousmode(tkobj, 0,tosvg);
}

this.drawTrack_header(tkobj);

if(this.splinterTag==null) {
	// is trunk
	for(var tag in this.splinters) {
		var b=this.splinters[tag];
		var o=b.findTrack(tkobj.name);
		/* in case of splinting
		unfinished chip is inserted into trunk.splinters
		and resizing trunk will re-draw all tracks in trunk
		but the splinter tracks are not ready
		*/
		if(o!=null) b.drawTrack_browser(o,false);
	}
}
return svgdata;
/* over */
}


Browser.prototype.countMaxstackUnderView=function(data)
{
// cout max stack number for items within dspBoundary.vstarts and dspBoundary.vstops
var maxStack = 0;
for(var i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
	var start, stop; // coordinate of current region
if(entire.atbplevel) {
	start = (i==dspBoundary.vstartr) ? dspBoundary.vstarts+regionLst[i][3] : regionLst[i][3];
	stop = (i==dspBoundary.vstopr) ? dspBoundary.vstops+regionLst[i][3] : regionLst[i][4];
} else {
	start = (i==dspBoundary.vstartr) ? getPointCoord(regionLst, entire, i,dspBoundary.vstarts) : regionLst[i][3];
	stop = (i==dspBoundary.vstopr) ? getPointCoord(regionLst, entire, i,dspBoundary.vstops) : regionLst[i][4];
}
	for(var j=0; j<data[i].length; j++) {
	if(data[i][j][5] == undefined) continue;
		var item = data[i][j];
	if(Math.max(item[8], start) < Math.min(item[9], stop)) {
		if(maxStack < item[5]) 
		maxStack = item[5];
	}
}
}
return maxStack;
}

Browser.prototype.drawTrack_header=function(tkobj)
{
/* isolates header drawing code from main track drawing
for purpose of changing left column width
TODO overlay correlation plot
*/
tkobj.header.width=this.leftColumnWidth;
tkobj.header.height=tkobj.canvas.height;
var ctx = tkobj.header.getContext('2d'); // for header
ctx.fillStyle=colorCentral.foreground_faint_1;
ctx.fillRect(0,0,tkobj.header.width,1);
if(isNumerical(tkobj) && tkobj.qtc.height>=20) {
	drawVerticalAxis(
		tkobj.qtc,
		tkobj.header,
		tkobj.header.width-2,
		densitydecorpaddingtop,
		tkobj.qtc.height,
		tkobj.maxv, tkobj.minv, true, colorCentral.foreground);
}
if(ctx.measureText(tkobj.label).width>=this.leftColumnWidth-7) {
	// clear things in the path, digit 0 is usually there when track height is not big
	ctx.clearRect(0,10,this.leftColumnWidth-7,13);
}
ctx.font = "8pt Sans-serif";
ctx.fillStyle = colorCentral.foreground;
ctx.fillText(tkobj.label, 1, isNumerical(tkobj) ? (tkobj.qtc.height<20 ? 8 : 20) : 10);
if(tkobj.qtc.uselog) {
	if(tkobj.qtc.logtype == 1) {
		ctx.fillText("(log2 scale)", 1, 36);
	} else if(tkobj.qtc.logtype==2) {
		ctx.fillText("(logE scale)", 1, 36);
	} else {
		ctx.fillText("(log10 scale)", 1, 36);
	}
}
}

Browser.prototype.drawMcm=function()
{
for(var i=0; i<this.tklst.length; i++) {
	var t=this.tklst[i];
	this.drawMcm_onetrack(t, false);
	t.atC.style.display= t.where==1 ? 'block' : 'none';
}
}


function qtrack_plotwiggle_base(data,startidx,stopidx,ctx,thisqtc,pthvalue,nthvalue,x,y,w,plotheight,pointup,tosvg)
{
/* args:
data: single array, not nested
startidx/stopidx: array index of data, not including last point
x/y: initial plot position offset on canvas
w: stroke width
plotheight: max allowed plot height
pointup: boolean, if true positive bars will point up
tosvg: boolean

if using baseline, will figure out baseliney, this offset from y (not including y)
or, baseliney remains within plotheight, if used for plotting need to include y

for svg plotting:
only each bar's y start position and height is needed, x and width are not needed
*/
// baseline y position on canvas from offset point, baseline value is always zero
// a portion of plotheight, not including yoffset
var baseliney = 0;
var usebaseline = false;
var svgdata=[]; // each ele is for one bar: [y,height,color]
if(nthvalue<=0 && pthvalue>=0) {
	usebaseline = true;
	if(nthvalue == 0) {
		baseliney = pointup ? plotheight : 0;
	} else if(pthvalue == 0) {
		baseliney = pointup ? 0 : plotheight;
	} else {
		baseliney = (pointup ? pthvalue/(pthvalue-nthvalue) : (0-nthvalue)/(pthvalue-nthvalue)) * plotheight;
	}
}
var pcolor = "rgb("+thisqtc.pr+","+thisqtc.pg+","+thisqtc.pb+")";
var ncolor = "rgb("+thisqtc.nr+","+thisqtc.ng+","+thisqtc.nb+")";
var infinitycolor='#b5b5b5';
var usethreshold = (thisqtc.thtype != 0);
for(var i=startidx; i<stopidx; i++) {
	var v = data[i];
	var barh;
	if(isNaN(v)) {
		// do nothing
		if(tosvg) svgdata.push([,,,false]);
	} else if(v == Infinity) {
		ctx.fillStyle = infinitycolor;
		if(usebaseline) {
			if(pointup) {
			ctx.fillRect(x, y, w, baseliney);
			if(tosvg) svgdata.push([y,baseliney,infinitycolor,false]);
		} else {
			ctx.fillRect(x, y+baseliney, w, plotheight-baseliney);
			if(tosvg) svgdata.push([y+baseliney,plotheight-baseliney,infinitycolor,false]);
		}
		} else {
			if(pthvalue > 0) {
			ctx.fillRect(x, y, w, plotheight);
			if(tosvg) svgdata.push([y,plotheight,infinitycolor,false]);
		} else {
			// else won't plot as both pth and nth are negative
			if(tosvg) svgdata.push([,,,false]);
		}
		}
	} else if(v == -Infinity) {
		ctx.fillStyle = infinitycolor;
		if(usebaseline) {
			if(pointup) {
			ctx.fillRect(x, y+baseliney, w, plotheight-baseliney);
			if(tosvg) svgdata.push([y+baseliney, plotheight-baseliney, infinitycolor,false]);
		} else {
			ctx.fillRect(x, y, w, baseliney);
			if(tosvg) svgdata.push([y,baseliney, infinitycolor,false]);
		}
		} else {
			if(nthvalue < 0) {
			ctx.fillRect(x, y, w, plotheight);
			if(tosvg) svgdata.push([y,plotheight, infinitycolor,false]);
		} else {
			// else won't plot as both pth and nth are positive
			if(tosvg) svgdata.push([,,,false]);
		}
		}
	} else if(usebaseline) {
		// valid value and baseline
		if(v > 0) {
			barh = Math.min(v,pthvalue)*plotheight/(pthvalue-nthvalue);
		ctx.fillStyle = (usethreshold && v>=pthvalue) ? thisqtc.pth : pcolor;
		if(pointup) {
			ctx.fillRect(x, y+baseliney-barh, w, barh);
			if(tosvg) svgdata.push([y+baseliney-barh, barh, ctx.fillStyle,false]);
		} else {
			ctx.fillRect(x, y+baseliney, w, barh);
			if(tosvg) svgdata.push([y+baseliney, barh, ctx.fillStyle,false]);
		}
		} else if(v < 0) {
			barh = Math.max(v,nthvalue)*plotheight/(nthvalue-pthvalue);
		ctx.fillStyle = (usethreshold && v<=nthvalue) ? thisqtc.nth : ncolor;
		if(pointup) {
			ctx.fillRect(x, y+baseliney, w, barh);
			if(tosvg) svgdata.push([y+baseliney,barh, ctx.fillStyle,false]);
		} else {
			ctx.fillRect(x, y+baseliney-barh, w, barh);
			if(tosvg) svgdata.push([y+baseliney-barh, barh, ctx.fillStyle,false]);
		}
		} else {
			if(tosvg) svgdata.push([,,,false]);
		}
	} else {
		// valid value but no baseline
		if(v > 0 && v > nthvalue) {
		if(v >= pthvalue) {
			// full fill
			ctx.fillStyle = thisqtc.pth;
			ctx.fillRect(x, y, w, plotheight);
			if(tosvg) svgdata.push([y,plotheight, thisqtc.pth,false]);
		} else {
			// partial fill
			barh = plotheight*(v-nthvalue)/(pthvalue-nthvalue);
			ctx.fillStyle = pcolor;
			if(pointup) {
			ctx.fillRect(x, y+plotheight-barh, w, barh);
			if(tosvg) svgdata.push([y+plotheight-barh, barh, pcolor,false]);
			} else {
			ctx.fillRect(x, y, w, barh);
			if(tosvg) svgdata.push([y,barh, pcolor,false]);
			}
		}
		} else if(v<0 && v<pthvalue) {
		if(v <= nthvalue) {
			// full fill
			ctx.fillStyle = thisqtc.nth;
			ctx.fillRect(x, y, w, plotheight);
			if(tosvg) svgdata.push([y,plotheight,thisqtc.nth,false]);
		} else {
			// partial fill
			barh = plotheight*(pthvalue-v)/(pthvalue-nthvalue);
			ctx.fillStyle = ncolor;
			if(pointup) {
			ctx.fillRect(x, y, w, barh);
			if(tosvg) svgdata.push([y,barh,ncolor,false]);
			} else {
			ctx.fillRect(x, y+plotheight-barh, w, barh);
			if(tosvg) svgdata.push([y+plotheight-barh,barh,ncolor,false]);
			}
		}
		} else {
			if(tosvg) svgdata.push([,,,false]);
		}
	}
	x += w;
}
if(tosvg) return svgdata;
}


function drawVerticalAxis(qtconfig, canvas, Lx, Ly, Lh, maxv, minv, pointup, plotcolor) {
/* scale opens to left
not for htest, and hmtk track in wiggle mode

params:
  qtconfig: qtc object
  canvas: dom object
  Lx/Ly/Lh: start position and height of long vertical line
  maxv, minv: max/min values to be plotted, if spans 0, 0 will be plotted if enough space is there
  pointup: boolean, if true, bigger value is on top
  plotcolor: plot color
TODO scale opens to left or right
*/
	var ctx = canvas.getContext('2d');
	ctx.font = "bold 8pt Sans-serif";
	ctx.fillStyle = plotcolor;
	// max,min labels
	var maxlabel, minlabel;
	if(qtconfig.uselog) {
		var tmp = (qtconfig.logtype==1)?Math.pow(2,maxv):((qtconfig.logtype==2)?Math.exp(maxv):Math.pow(10,maxv));
		maxlabel = tmp.toExponential(2);
		tmp = (qtconfig.logtype==1)?Math.pow(2,minv):((qtconfig.logtype==2)?Math.exp(minv):Math.pow(10,minv));
		minlabel = tmp.toExponential(2);
	} else {
		maxlabel = neatstr(maxv);
		minlabel = neatstr(minv);
	}
	var ticksize=5;
	var fontheight=8;
	// max label
	ctx.fillText(maxlabel, Lx-ticksize-2-ctx.measureText(maxlabel).width, pointup?Ly+fontheight-2:Ly+Lh);
	// min label
	ctx.fillText(minlabel, Lx-ticksize-2-ctx.measureText(minlabel).width, pointup?Ly+Lh:Ly+fontheight-2);
	// tick on top
	ctx.fillRect(Lx-ticksize,Ly,ticksize,1);
	// tick on bottom
	ctx.fillRect(Lx-ticksize,Ly+Lh-1,ticksize,1);
	// vertical line
	ctx.fillRect(Lx,Ly,1,Lh+1);
	if(maxv>0 && minv<0) {
		// need to mark out where's zero
		var zeroh = Lh * (pointup ? maxv/(maxv-minv) : (-minv)/(maxv-minv));
		// zero tick
		ctx.fillRect(Lx-ticksize,Ly+zeroh,ticksize,1);
		/*
		// see if zero can be printed
		zeroh += 4; // now it's y position of digit 0
		// avoid top/bottom string, string height is 10px?
		if(zeroh <= 20)
			ctx.fillText(0, canvasw-18, 20);
		else if(zeroh >= canvash-10)
			ctx.fillText(0, canvasw-18, canvash-10);
		else
			ctx.fillText(0, canvasw-18, zeroh);
			*/
	}
}


Browser.prototype.drawIdeogram_browser=function(tosvg)
{
this.ideogram.canvas.width=this.entire.spnum;
if(this.entire.atbplevel) {
	/*** query and display chromosomal sequence */
	var lst = [];
	// querying seq for all regions, instead of those within wings
	for(var i=0; i<this.regionLst.length; i++) {
		var r=this.regionLst[i];
		lst.push(r[0]);
		lst.push(r[3]);
		lst.push(r[4]);
	}
	/* pass a random number to cgi, cgi will spit back and 
	it will be checked with the copy stored in gflag
	because getseq via fastacmd is kind of slow... */
	if(this.basepairlegendcanvas!=undefined) {
		this.basepairlegendcanvas.style.display = "block";
		this.drawATCGlegend(true);
	}
	gflag.ideogram.seqrid=Math.random().toString();
	this.ajax("getChromseq=on&regionlst="+lst.join(',')+'&dbName='+this.genome.name+'&rid='+gflag.ideogram.seqrid, function(data) {
		if(gflag.ideogram.seqrid!=data.rid) return;
		var bbj=horcrux[data.horcrux];

		var svgrect=[],svgtext=[]; // always fill this, no matter drawing svg or not
		gflag.chrideobarsvg=[svgrect,svgtext];

		if(!('lst' in data)) {
			print2console('error fetching chromosome sequence (but you can go on)',2);
			return;
		}
		var seqlst = data.lst;
		for(var i=0; i<seqlst.length; i++) {
			if(seqlst[i]=='ERROR') {
				print2console('error fetching chromosome sequence (but you can go on)',2);
				return;
			}
		}
		var canvas=bbj.ideogram.canvas;
		canvas.height=canvas.parentNode.parentNode.parentNode.style.height = ideoHeight + cbarHeight;
		var ctx = canvas.getContext('2d');
		var xoffset = 0;
		var bpw=bbj.entire.bpwidth;
		for(var i=0; i<seqlst.length; i++) {
			var s = seqlst[i].toLowerCase();
			for(var j=0; j<s.length; j++) {
				ctx.fillStyle = ntbcolor[s.charAt(j)];
				ctx.fillRect(xoffset, 0, bpw, ideoHeight);
				svgrect.push([xoffset, ctx.fillStyle]);
				xoffset += bpw;
			}
			xoffset+=regionSpacing.width;
		}
		if(bpw >= MAXbpwidth) {
			// add ATCG
			if(bpw>=MAXbpwidth_bold)
				ctx.font = "bold 10pt Sans-serif";
			else
				ctx.font = "8pt Sans-serif";
			xoffset=0;
			for(var i=0; i<seqlst.length; i++) {
				var s = seqlst[i].toUpperCase();
				ctx.fillStyle = 'white';
				for(var j=0; j<s.length; j++) {
					var tc=s.charAt(j);
					ctx.fillText(tc, xoffset, 12);
					svgtext.push([xoffset,tc]);
					xoffset += bpw;
				}
				ctx.fillStyle = colorCentral.foreground;
				ctx.fillRect(xoffset, 0, 1, ideoHeight);
				xoffset += regionSpacing.width;
			}
		}
		if(bbj.basepairlegendcanvas!=undefined) {
			bbj.basepairlegendcanvas.style.display='block';
			bbj.drawATCGlegend(false);
		}
		bbj.draw_coordnote();
	});
	return;
}
if(this.basepairlegendcanvas!=undefined)
	this.basepairlegendcanvas.style.display = "none";

if(this.is_gsv()) {
	/* gsv, drawing stack of boxes to indicate items
	stack and plot
	must draw all items, but not only those within dsp
	TODO
	item names are hidden if they are wider than the box
	stacking has been disabled
	should enable user to configure this
	*/
	var svgdata=[];
	var ctx = this.ideogram.canvas.getContext('2d');
	ctx.font = "8pt Sans-serif";
	/* temporary data structure for region stacking:
	   0 box start
	   1 name width
	   2 stack idx
	   3 name start
	*/
	var regionStack = []; // same length as regionLst
	var stack = [0];
	var xoffset = 0;
	for(var i=0; i<this.regionLst.length; i++) {
		var thisr=this.regionLst[i];
		var nw = ctx.measureText(thisr[6]).width;
		var stackstart = xoffset;
		var namestart = -1;
		if(nw < thisr[5]) {
			// name in box
			namestart = xoffset+(thisr[5]-nw)/2;
			/* if name is wider, won't show
		} else {
			// enough space on left?
			if(nw < xoffset) {
				stackstart = xoffset-nw;
				namestart = stackstart;
			} else {
				// name take entire left space
				stackstart = 0;
				namestart = 0;
			}
			*/
		}
		var idx = 0;
		/*
		stacking is disabled for the moment
		while(stack[idx]!=0 && stack[idx]>stackstart) {
			idx++;
			if(idx == stack.length) {
				stack.push(0);
				break;
			}
		}
		*/
		// determine stack stop
		if(namestart+nw > xoffset+thisr[5])
			stack[idx] = Math.max(0,namestart) + nw;
		else
			stack[idx] = xoffset + thisr[5];
		regionStack.push([xoffset, nw, idx, namestart]);
		xoffset += thisr[5]+regionSpacing.width;
	}
	var stackHeight = fullStackHeight+3;
	this.ideogram.canvas.height = Math.max((stackHeight+1)*stack.length, ideoHeight+cbarHeight);
	this.ideogram.canvas.parentNode.parentNode.parentNode.style.height = this.ideogram.canvas.height;
	ctx.font = "8pt Sans-serif";

	for(i=0; i<regionStack.length; i++) {
		var r = regionStack[i];
		var r2 = this.regionLst[i];
		var y = (stackHeight+1)*r[2];
		// check if to paint flank
		var scf = null; // scaling factor
		var fcoord = this.genesetview.flanking[r2[6]];
		var svgentry=[,,,]; // 5flank, 3flank, bigbox, text
		if(fcoord[0] != -1) {
			// has 5' flank
			scf = r2[5]/(r2[4]-r2[3]);
			ctx.fillStyle = this.genesetview.ideogram_fill5;
			ctx.fillRect(r[0]+0.5+(fcoord[0]-r2[3])*scf, y+0.5, (fcoord[1]-fcoord[0])*scf, stackHeight);
			if(tosvg)
				svgentry[0]=[r[0]+0.5+(fcoord[0]-r2[3])*scf, y+0.5, (fcoord[1]-fcoord[0])*scf, stackHeight];
		}
		if(fcoord[2] != -1) {
			// has 3' flank
			if(scf == null) scf = r2[5]/(r2[4]-r2[3]);
			ctx.fillStyle = this.genesetview.ideogram_fill3;
			ctx.fillRect(r[0]+0.5+(fcoord[2]-r2[3])*scf, y+0.5, (fcoord[3]-fcoord[2])*scf, stackHeight);
			if(tosvg)
				svgentry[1]=[r[0]+0.5+(fcoord[2]-r2[3])*scf, y+0.5, (fcoord[3]-fcoord[2])*scf, stackHeight];
		}
		// bigbox
		ctx.strokeStyle = this.genesetview.ideogram_stroke;
		ctx.strokeRect(r[0]+0.5, y+0.5, r2[5]-1, stackHeight);
		if(r[3]!=-1) {
			ctx.fillStyle = this.genesetview.ideogram_stroke;
			ctx.fillText(r2[6], r[3], y+10);
		}
		if(tosvg) {
			svgentry[2]=[r[0]+0.5, y+0.5, r2[5]-1, stackHeight];
			if(r[3]!=-1)
				svgentry[3]=[r[3],y+10,r2[6]];
			svgdata.push(svgentry);
		}
	}
	this.draw_coordnote();
	return svgdata;
}

/*** drawing regular cytoband for genome/juxtaposition */

this.ideogram.canvas.width=this.entire.spnum;
this.ideogram.canvas.height=this.ideogram.canvas.parentNode.parentNode.parentNode.style.height=ideoHeight+cbarHeight;
var svgdata=[];
/* each ele is an array
0,1,2,3 - x,y,w,h defines the box
4 - box fill color
5 - box stroke color
6,7 - x,y of text, if undefined, no text will be drawn
8 - actual text
9 - text color
*/
var ctx = this.ideogram.canvas.getContext('2d');
var xoffset = 0; // offset in canvas
ctx.font = "bold 8pt Sans-serif";
for(var i=0; i<this.regionLst.length; i++) {
	var thisr=this.regionLst[i];
	var thisdata=drawIdeogramSegment_simple(
		this.genome.getcytoband4region2plot(thisr[0], thisr[3], thisr[4], thisr[5]),
		ctx, xoffset, 0, thisr[5], ideoHeight, tosvg);
	if(tosvg)
		svgdata=svgdata.concat(thisdata);

	// vertical region borders
	ctx.fillStyle = colorCentral.foreground;
	ctx.fillRect(xoffset, 0, 1, ideoHeight);
	if(tosvg) svgdata.push([xoffset,1,1,ideoHeight-2,colorCentral.foreground,colorCentral.foreground]);
	var rw=thisr[5]*(this.entire.atbplevel?this.entire.bpwidth:1); // region width
	ctx.fillRect(xoffset+rw-1, 0, 1, ideoHeight);
	if(tosvg) svgdata.push([xoffset+rw-1,1,1,ideoHeight-2,colorCentral.foreground,colorCentral.foreground]);
	// spacing after this region
	ctx.fillStyle = colorCentral.background;
	ctx.fillRect(xoffset+rw, 0, 1, ideoHeight);
	xoffset += rw+regionSpacing.width;
}

// plot chr name on second row, merging same chr names for adjacent regions
ctx.fillStyle = colorCentral.foreground;
// chr of first region
var previouschrname = this.regionLst[0][0];
var previouschrstart = 0;
xoffset = this.regionLst[0][5];
var y = ideoHeight + 2;
for(i=1; i<this.regionLst.length; i++) {
	var thisr=this.regionLst[i];
	if(previouschrname != thisr[0]) {
		// plot previous chr name
		var w = ctx.measureText(previouschrname).width;
		if(w < xoffset-previouschrstart) {
			ctx.fillText(previouschrname, previouschrstart+(xoffset-previouschrstart-w)/2, y+7);
			if(tosvg)
				svgdata.push([previouschrstart+(xoffset-previouschrstart-w)/2,0,1,1,'transparent','transparent',previouschrstart+(xoffset-previouschrstart-w)/2,y+7,previouschrname,colorCentral.foreground]);
		}
		ctx.fillRect(xoffset+1, ideoHeight+2, 1, ideoHeight+cbarHeight-2);
		previouschrname = thisr[0];
		previouschrstart = xoffset;
	}
	xoffset += thisr[5] +regionSpacing.width;
}
// last chr
ctx.fillRect(xoffset-1, ideoHeight+2, 1, ideoHeight+cbarHeight-2);
var w = ctx.measureText(previouschrname).width;
if(w < xoffset-previouschrstart) {
	ctx.fillText(previouschrname, previouschrstart+(xoffset-previouschrstart-w)/2, y+7);
	if(tosvg)
		svgdata.push([previouschrstart+(xoffset-previouschrstart-w)/2,0,1,1,'transparent','transparent',previouschrstart+(xoffset-previouschrstart-w)/2,y+7,previouschrname,colorCentral.foreground]);
}
this.draw_coordnote();
return svgdata;
/* over */
}



/*
function mainIdeogram_mm(event) {
// cursor moving upon ideogram canvas in main panel
var bbj=gflag.browser;
}
*/


Browser.prototype.drawATCGlegend=function(waiting)
{
var c=this.basepairlegendcanvas;
var ctx=c.getContext('2d');
ctx.clearRect(0,0,c.width,c.height);
if(waiting) {
	ctx.fillStyle=GRAY;
	ctx.font = "8pt Sans-serif";
	ctx.fillText('Loading sequence...',0,10);
	return;
}
ctx.fillStyle = ntbcolor.a;
ctx.fillRect(0,0,15,c.height);
ctx.fillStyle = ntbcolor.t;
ctx.fillRect(16,0,15,c.height);
ctx.fillStyle = ntbcolor.c;
ctx.fillRect(32,0,15,c.height);
ctx.fillStyle = ntbcolor.g;
ctx.fillRect(48,0,15,c.height);
ctx.fillStyle = ntbcolor.n;
ctx.fillRect(64,0,15,c.height);
ctx.fillStyle = "white";
ctx.font = "bold 10pt Sans-serif";
ctx.fillText("A", 3,10);
ctx.fillText("T", 19,10);
ctx.fillText("C", 35,10);
ctx.fillText("G", 51,10);
ctx.fillText("N", 67,10);
}

Browser.prototype.drawRuler_browser=function(tosvg)
{
/* ruler bar above genome heatmap, height is fixed

in case of drawing for splinter, need to highlight the splinterCoord
and splinter is assumed to be always in genome mode
*/
if(this.rulercanvas==null) return [];
this.rulercanvas.width=this.entire.spnum;
var ctx = this.rulercanvas.getContext('2d');
ctx.font = "8pt Sans-serif";

if(this.is_gsv()){
	// only draw hollow boxes in one row
	var x = 0;
	ctx.fillStyle = '#858585';
	for(var i=0; i<this.regionLst.length; i++) {
		var w= this.entire.atbplevel ? this.regionLst[i][5]*this.entire.bpwidth : this.regionLst[i][5];
		ctx.fillRect(x+w, 0, 1, this.rulercanvas.height);
		x += w+regionSpacing.width;
	}
	return [];
}

var previousplotstop = 0;
var xoffset=0;

if(this.rulercanvas.splinterTag!=undefined && this.splinterCoord!=null) {
	// this is splinter, draw highligh first
	var cc=this.splinterCoord;
	xoffset=0;
	for(var i=0; i<this.regionLst.length; i++) {
		var thisr=this.regionLst[i];
		if(thisr[0]==cc[0]) {
			var start=Math.max(thisr[3],cc[1]);
			var stop=Math.min(thisr[4],cc[2]);
			var x=this.entire.atbplevel ? (start-thisr[3])*this.entire.bpwidth : (start-thisr[3])/thisr[7];
			var w=this.entire.atbplevel ? (stop-start)*this.entire.bpwidth : (stop-start)/thisr[7];
			ctx.fillStyle='yellow';
			ctx.fillRect(xoffset+x, 1, w, 8);
			break;
		}
		xoffset += thisr[5] + regionSpacing.width;
	}
}

ctx.fillStyle = colorCentral.foreground;
var svgdata=[];
if(this.entire.atbplevel) {
	for(var i=0; i<this.regionLst.length; i++) {
		var thisr=this.regionLst[i];
		for(var j=thisr[3]; j<thisr[4]; j++) {
			var w = ctx.measureText(j).width;
			var bpos = xoffset+(j-thisr[3])*this.entire.bpwidth; // bar plot pos
			if(w <= bpos-previousplotstop-40) {
				ctx.fillText(j, bpos-10-w, 10);
				ctx.fillRect(bpos, 2, 1, 8);
				if(tosvg) svgdata.push([bpos,j]);
				previousplotstop = bpos;
			}
		}
		xoffset += thisr[5] + regionSpacing.width;
	}
} else {
	for(var i=0; i<this.regionLst.length; i++) {
		var thisr=this.regionLst[i];
		for(var j=0; j<thisr[5]; j++) {
			var coord = getPointCoord(this.regionLst, this.entire, i,j);
			var w = ctx.measureText(coord).width;
			var bpos = xoffset + j;
			if(w <= bpos-previousplotstop-40) {
				ctx.fillText(coord, bpos-10-w, 10);
				ctx.fillRect(bpos, 2, 1, 8);
				if(tosvg) svgdata.push([bpos,coord]);
				previousplotstop = bpos;
				j+=80;
			}
		}
		xoffset += thisr[5] + regionSpacing.width;
	}
}
if(tosvg) return svgdata;
}




function page_makeDoms(param)
{
/* prepare colors */
colorCentral.foreground_faint_1='rgba('+colorstr2int(colorCentral.foreground).join(',')+',0.1)';
// make copy of long color lst
var lst=[];
for(var i=0; i<colorCentral.longlst.length; i++) lst.push(colorCentral.longlst[i]);
colorCentral.longlst_bk=lst;

bubble=document.createElement('table');
document.body.appendChild(bubble);
bubble.cellSpacing=bubble.cellPadding=0;
bubble.style.position='absolute';
bubble.style.zIndex=102;
bubble.addEventListener('mouseover',bubbleMover,false);
bubble.addEventListener('mouseout',bubbleMout,false);
var tr=bubble.insertRow(0);
var td=tr.insertCell(0);
var c=document.createElement('canvas');
c.width=c.height=15;
c.style.marginLeft=4;
td.appendChild(c);
	{
	var ctx=c.getContext("2d");
	ctx.fillStyle="#850063";
	ctx.beginPath();
	ctx.moveTo(0, 15);
	ctx.lineTo(8,0);
	ctx.lineTo(15,15);
	ctx.fill();
	/*
	ctx.strokeStyle = "white";
	ctx.beginPath();
	ctx.moveTo(0, 15);
	ctx.lineTo(8,0);
	ctx.lineTo(15,15);
	ctx.closePath();
	ctx.stroke();
	*/
	}
tr=bubble.insertRow(-1);
td=tr.insertCell(0);
td.className='bubbleCls';
d=document.createElement('div');
d.style.color='white';
d.style.fontSize='12px';
td.appendChild(d);
bubble.says=d;
d=document.createElement('div');
d.style.color='white';
d.style.margin=10;
d.style.fontSize='12px';
td.appendChild(d);
bubble.sayajax=d;

indicator2=document.createElement('div');
document.body.appendChild(indicator2);
indicator2.style.position='absolute';
indicator2.style.border='1px dashed #80a6ff';
indicator2.style.zIndex=102;
var t=document.createElement('table');
t.style.backgroundColor='blue';
t.style.opacity=0.16;
t.style.width=t.style.height='100%';
td=t.insertRow(0).insertCell(0);
td.align='center';
td.vAlign='middle';
td.style.color='white';
td.style.fontSize='30px';
indicator2.appendChild(t);
indicator2.veil=t;
var c1=document.createElement('canvas');
c1.width=c1.height=30;
c1.style.position='absolute';
c1.style.left='-30px';
c1.style.opacity=.5;
indicator2.appendChild(c1);
indicator2.leftarrow=c1;
var c2=document.createElement('canvas');
c2.width=c2.height=30;
c2.style.position='absolute';
c2.style.right='-30px';
c2.style.opacity=.5;
indicator2.appendChild(c2);
indicator2.rightarrow=c2;
	{
	var ctx=c1.getContext("2d");
	var lg=ctx.createLinearGradient(0,0,0,c1.height);
	lg.addColorStop(0, "#aaf");
	lg.addColorStop(1, "#003");
	ctx.fillStyle=lg;
	ctx.beginPath();
	var ychi = 7;
	var w=c1.width;
	ctx.moveTo(0,ychi);ctx.lineTo(w/2,ychi);ctx.lineTo(w/2,0);ctx.lineTo(w,w/2);ctx.lineTo(w/2,w);ctx.lineTo(w/2,w-ychi);ctx.lineTo(0,w-ychi);ctx.lineTo(0,w-ychi);ctx.fill();
	ctx = c2.getContext("2d");
	lg = ctx.createLinearGradient(0,0,0,c2.height);
	lg.addColorStop(0, "#aaf");
	lg.addColorStop(1, "#003");
	ctx.fillStyle = lg;
	ctx.moveTo(0,w/2);ctx.lineTo(w/2,0);ctx.lineTo(w/2,ychi);ctx.lineTo(w,ychi);ctx.lineTo(w,w-ychi);ctx.lineTo(w/2,w-ychi);ctx.lineTo(w/2,w);ctx.lineTo(0,w/2);ctx.fill();
	}

indicator=document.createElement('div');
indicator.style.position='absolute';
document.body.appendChild(indicator);
indicator.style.border='1px solid #80A6FF';
indicator.style.zIndex=104;
d=document.createElement('div');
d.style.backgroundColor='blue';
d.style.opacity=0.1;
d.style.width=d.style.height='100%';
indicator.appendChild(d);

invisibleBlanket=document.createElement('div');
document.body.appendChild(invisibleBlanket);
invisibleBlanket.style.position='absolute';
invisibleBlanket.style.zIndex=101;

indicator3=document.createElement('div');
document.body.appendChild(indicator3);
indicator3.style.position='absolute';
indicator3.style.zIndex=102;
d=document.createElement('div');
d.style.position='relative';
indicator3.appendChild(d);
d2=document.createElement('div');
d2.style.position='absolute';
d2.style.backgroundImage='url(/browser/images/border-anim-v.gif)';
d2.style.backgroundPosition='0% 0%';
d2.style.backgroundRepeat='no-repeat repeat';
d.appendChild(d2);
d2=document.createElement('div');
d2.style.position='absolute';
d2.style.backgroundImage='url(/browser/images/border-anim-h.gif)';
d2.style.backgroundPosition='0% 0%';
d2.style.backgroundRepeat='repeat no-repeat';
d.appendChild(d2);
d2=document.createElement('div');
d2.style.position='absolute';
d2.style.backgroundImage='url(/browser/images/border-anim-v.gif)';
d2.style.backgroundPosition='100% 0%';
d2.style.backgroundRepeat='no-repeat repeat';
d.appendChild(d2);
d2=document.createElement('div');
d2.style.position='absolute';
d2.style.backgroundImage='url(/browser/images/border-anim-h.gif)';
d2.style.backgroundPosition='0% 100%';
d2.style.backgroundRepeat='repeat no-repeat';
d.appendChild(d2);

indicator4=document.createElement('div');
document.body.appendChild(indicator4);
indicator4.style.position='absolute';
indicator4.style.border='1px solid black';
indicator4.style.zIndex=102;

indicator6=document.createElement('div');
indicator6.style.position='absolute';
document.body.appendChild(indicator6);
indicator6.style.border='1px solid rgb(255,133,92)';
indicator6.style.zIndex=102;
d=document.createElement('div');
d.style.backgroundColor='#f53d00';
d.style.opacity=0.1;
d.style.width=d.style.height='100%';
indicator6.appendChild(d);

indicator7=document.createElement('div');
document.body.appendChild(indicator7);
indicator7.style.position='absolute';
indicator7.style.borderStyle='solid';
indicator7.style.borderWidth='0px 1px 1px 0px';
indicator7.style.borderColor='#ccc';

pagecloak=document.createElement('div');
document.body.appendChild(pagecloak);
pagecloak.style.position='absolute';
pagecloak.style.left=pagecloak.style.top=0;
pagecloak.style.backgroundColor='black';
pagecloak.style.opacity=0.55;

pagecloak2=document.createElement('div');
document.body.appendChild(pagecloak2);
pagecloak2.style.position='absolute';
pagecloak2.style.opacity=0.5;
pagecloak2.style.zIndex=200;
var img=document.createElement('img');
img.src='/browser/images/loading.gif';
pagecloak2.appendChild(img);


if(param.gsselect) {
var d=document.createElement('div');
d.id='gsspanel'; // for moving
document.body.appendChild(d);
gsselect.main=d;
d.className='spanel';
d.style.display='none';
d.style.zIndex=104;
d.addEventListener('mouseover',gssp_mover,false);
d.addEventListener('mouseout',gssp_mout,false);
d.innerHTML= '<div>\
    <div class=spanelheader active=1 holderid=gsspanel onmousedown="cpmoveMD(event)">Select one type</div>\
    <table cellpadding=4>\
      <tr>\
        <td colspan=2><input type=radio name=gss_opt id=genestruct3 value=genebodypromoter alt="3 kb promoter and gene body*" onchange="gsr_change()"> <label for=genestruct3>3 kb promoter and gene body</label></td>\
      </tr><tr>\
        <td><input type=radio name=gss_opt id=genestruct1 value=promoter alt="3 kb promoter*" onchange="gsr_change()"> <label for=genestruct1>3 kb promoter</label></td>\
        <td><input type=radio name=gss_opt id=genestruct2 value=genebody alt="gene body or entire interval" onchange="gsr_change()"> <label for=genestruct2>gene body</label></td>\
      </tr>\
	  <!--<tr>\
        <td><input type=radio name=gss_opt id=genestruct4 value=utr5 alt="5\' UTR*" onchange="gsr_change()"> <label for=genestruct4>5\' UTR</label></td>\
        <td><input type=radio name=gss_opt id=genestruct5 value=utr3 alt="3\' UTR*" onchange="gsr_change()"> <label for=genestruct5>3\' UTR</label></td>\
      </tr>-->\
	  <tr>\
        <td colspan=2>\
		  <div class=titlebox><div style="margin:5px;padding:8px;">\
		  	<table id=gss_sliderpanel cellpadding=0 cellspacing=0 style="display:none;">\
			  <tr>\
			<td width=150 align=right><div style="margin-top:7px;position:relative;">\
			  <hr style="position:absolute;top:8px;right:0px;width:129px;height:3px;background-color:#B3FFB3;">\
			  <canvas id=gss_upslider width=20 height=40 style="position:absolute;left:65px;" onmousedown="gss_us_MD(event)"></canvas>\
			  <div id=gss_upslider_trail style="height:40px;border-bottom:solid 3px green;width:65px;"></div>\
			</div></td>\
			<td width=150 align=left><div style="margin-top:7px;position:relative;">\
			  <hr style="position:absolute;top:8px;left:0px;width:129px;height:3px;background-color:#FFB3B3;">\
			  <canvas id=gss_downslider width=20 height=40 style="position:absolute;left:0px;" onmousedown="gss_ds_MD(event)"></canvas>\
			  <div id=gss_downslider_trail style="height:40px;border-bottom:solid 3px #bd0000;width:0px;"></div>\
			</div></td>\
			  </tr><tr>\
			<td colspan=2 align=center>\
			  <canvas id=coordgliderruler width=300 height=30></canvas>\
			</td>\
			  </tr><tr>\
			<td align=center style="font-weight:bold;font-size:12px;color:green;">upstream: <span id=leftgliderlength>2500</span> bp</td>\
			<td align=center style="font-weight:bold;font-size:12px;color:#bd0000;">downstream: <span id=rightgliderlength>0</span> bp</td>\
			  </tr><tr>\
			<td colspan=2 align=left style="padding:5px;padding-left:40px;">\
			Surrounds:<br>\
			<input type=radio name=gss_origin id=cgotr_txstart value=txstart alt="transcription start site*" onchange="gsr_change()"> <label for=cgotr_txstart>transcription start site*</label><br>\
			<input type=radio name=gss_origin id=cgotr_txstop value=txstop alt="transcription stop site*" onchange="gsr_change()"> <label for=cgotr_txstop>transcription stop site*</label><br>\
			<input type=radio name=gss_origin id=cgotr_gb value=genebody alt="gene body or entire interval" onchange="gsr_change()"> <label for=cgotr_gb>entire gene or interval</label>\
			</td>\
			  </tr>\
			</table>\
		  </div><div style="background-color:white;color:black;left:25px;"><input type=radio name=gss_opt id=genestruct6 value=custom alt=noshow onchange="gsr_change()"> <label for=genestruct6>5\' and 3\' flanking</label>\
		  </div>\
		</div>\
		</td>\
      </tr>\
    </table>\
  </div>';
gsselect.sliderpanel = document.getElementById('gss_sliderpanel');
gsselect.upslider = document.getElementById('gss_upslider');
gsselect.uptrail = document.getElementById('gss_upslider_trail');
gsselect.downslider = document.getElementById('gss_downslider');
gsselect.downtrail = document.getElementById('gss_downslider_trail');

// coordinate selector (upstream slider)
var ctx = gsselect.upslider.getContext("2d");
var lg = ctx.createLinearGradient(0,0,0,c.height);
lg.addColorStop(0, "#7DFA00");
lg.addColorStop(1, "#306100");
ctx.fillStyle = lg;
var w = 20; // glider width
ctx.moveTo(0,0);ctx.lineTo(w,0);ctx.lineTo(w,w*2);ctx.lineTo(0,w+5);ctx.lineTo(0,0);ctx.fill();
// coordinate selector (downstream slider)
ctx = gsselect.downslider.getContext("2d");
lg = ctx.createLinearGradient(0,0,0,c.height);
lg.addColorStop(0, "#FF8A8A");
lg.addColorStop(1, "#9E0000");
ctx.fillStyle = lg;
ctx.moveTo(0,0);ctx.lineTo(w,0);ctx.lineTo(w,w+5);ctx.lineTo(0,w*2);ctx.lineTo(0,0);ctx.fill();
// coordinate selector ruler
c = document.getElementById("coordgliderruler");
ctx = c.getContext("2d");
ctx.fillStyle = "black";
ctx.font = "10pt Sans-serif";
ctx.fillRect(w, 0, c.width-w*2-1, 1);
ctx.fillRect(w, 0, 1, 8); ctx.fillText("5 KB", 8, 20);
var u = (c.width-w*2)/10; // unit length for each kb
ctx.fillRect(w+u,0,1,5);ctx.fillRect(w+u*2,0,1,5);ctx.fillRect(w+u*3,0,1,5);ctx.fillRect(w+u*4,0,1,5); // upstream ticks
ctx.fillRect(c.width/2, 0, 1, 8);
ctx.fillText("Center", c.width/2-20, 20);
ctx.fillRect(c.width/2+u-1,0,1,5);ctx.fillRect(c.width/2+u*2-1,0,1,5);ctx.fillRect(c.width/2+u*3-1,0,1,5);ctx.fillRect(c.width/2+u*4-1,0,1,5); // downstream ticks
ctx.fillRect(c.width-w-1, 0, 1, 8); ctx.fillText("5 KB", c.width-32, 20);
}


/*
ctx=document.getElementById('chrhengeicon').getContext('2d');
ctx.strokeStyle='#036';
ctx.lineWidth=2;
ctx.beginPath();ctx.arc(10,10,8,0,Math.PI*2/3-0.3,false);ctx.stroke();
ctx.beginPath();ctx.arc(10,10,8,Math.PI*2/3,Math.PI*4/3-0.3,false);ctx.stroke();
ctx.beginPath();ctx.arc(10,10,8,Math.PI*4/3,Math.PI*2-0.3,false);ctx.stroke();
*/



/**** menu components that are shared by applications
will make all options and panels despite application, won't hurt
*/

menu=menu_addoption(3,document.body);
menu.style.borderStyle='solid';
menu.style.borderWidth='2px 1px 2px 1px';
menu.style.borderColor='#4D9799 rgba(133,133,133,0.2) #994D96 rgba(133,133,133,0.2)';
menu.style.display='none';
menu.style.backgroundColor='white';
menu.style.position='absolute';
menu.style.mozBoxShadow='2px 2px 2px #c2c2c2';
menu.style.webkitBoxShadow='2px 2px 2px #c2c2c2';
menu.style.boxShadow='2px 2px 2px #c2c2c2';
menu.style.zIndex=103;
menu.addEventListener('mouseover',menu_mover,false);
menu.addEventListener('mouseout',menu_mout,false);


var d=menu_addoption(2,menu);
menu.c1=d;
d.style.color='#858585';
d.style.fontWeight='bold';
d.style.textAlign='center';
d.style.padding=2;

menu.tk2region_showlst=menu_addoption(1,'&#9733;','',menu_showtk2region,menu);
dom_addtext(menu.tk2region_showlst);

var d=menu_addoption(2,menu);
d.style.lineHeight=1.8; // the actual region list holder

menu.c5=menu_addoption(1,'<img src=images/wrench.png height=20 style="vertical-align:-5px;">','Configure',menuConfig,menu);


// decor track mode
menu.decorwrapper=menu_addoption(3,menu);
var d=document.createElement('div');
d.style.width=180;
d.className='menuchoice2';
menu.decorwrapper.appendChild(d);
menu.c10=dom_addbutt(d,'&#10070; Heatmap',menuDecorChangemode);
menu.c10.mode=M_trihm;
menu.c11=dom_addbutt(d,'&#8915; Arc',menuDecorChangemode);
menu.c11.mode=M_arc;
menu.c7=dom_addbutt(d,'&#9635; Full',menuDecorChangemode);
menu.c7.mode=M_full;
menu.c6=dom_addbutt(d,'&#9783; Thin',menuDecorChangemode);
menu.c6.mode=M_thin;
menu.c8=dom_addbutt(d,'&#9729; Density',menuDecorChangemode);
menu.c8.mode=M_den;
menu.c12=menu_addoption(1,'&#9986;','Juxtapose', menuDecorJuxtapose,menu.decorwrapper);
menu.c2=menu_addoption(1,null,'Undo juxtaposition',menuTurnoffJuxtapose,menu.decorwrapper);
menu.c3=menu_addoption(1,'&#10047;','Circlet view',menu_circletview,menu.decorwrapper);


menu.c16=menu_addoption(1,'&#9432;','Information',menuGetonetrackdetails,menu);
menu.c19=menu_addoption(1,'&#9998;','Edit metadata',menuCusttkmdedit,menu);
menu.c23=menu_addoption(1,'&#11021;','Flip',menuMcmflip,menu);
menu.c25=menu_addoption(1,'&#10010;','Add metadata terms',menu_mcm_invokemds,menu);
menu.c20=menu_addoption(1,'<img src=images/horus.png style="vertical-align:-5px;opacity:0.7;" width=20 height=20>','Genome snapshot',menuBirdeyeview,menu);

menu.facetm=menu_addoption(3,menu);
menu_addoption(1,null,'Select all',facet_term_selectall,menu.facetm);
menu_addoption(1,null,'Remove all',facet_term_removeall,menu.facetm);
menu_addoption(1,null,'Show sub table',facet_subtable,menu.facetm);



// menu - categorical track config
menu.c13=menu_addoption(3,menu);
menu.c13.style.position='relative';
menu.c13.style.overflow='hidden';
menu.c13.innerHTML='<img src=images/wrench.png style="opacity:0.2;position:absolute;right:0px;bottom:-35px;z-index:0;"><div id=cateCfgfill style="padding:10px;"></div>';

// menu - bed/sam/lr track config
menu.tkcfg_bed=menu_addoption(2,menu);
menu.tkcfg_bed.innerHTML='<table id=stc_font style="margin-bottom:10px;border-bottom:dashed 1px rgba(133,133,133,0.3);">\
  <tr><td>Font</td>\
    <td>family: <select id=stc_fontfamily onchange="stc_fontfamily(event)">\
		<option value="sans-serif">sans-serif</option>\
		<option value="serif">serif</option>\
		<option value="times">times</option>\
		<option value="arial">arial</option>\
		<option value="courier">courier</option>\
		<option value="monospace">monospace</option>\
	  </select>\
      <input type=checkbox id=stc_fontbold onchange="stc_fontbold(event)" /> <label for=stc_fontbold>bold</label>\
     </td></tr>\
  <tr><td></td>\
    <td>size: <select id=stc_fontsize onchange="stc_fontsize(event)">\
	<option value="5pt">*</option>\
	<option value="6pt">**</option>\
	<option value="7pt" selected>***</option>\
	<option value="8pt">****</option>\
	<option value="9pt">*****</option>\
	<option value="10pt">******</option>\
	</select>\
    <span id=stc_textcolor class=coloroval onclick="stc_textcolor_initiator(event)" style="width:80px;background-color:#000000;">text color</span>\
	</td></tr>\
</table>\
<div id=stc_bed style="font-size:14px;padding:6px;">\
  <span id=stc_bedcolor class=coloroval onclick="stc_bedcolor_initiator(event)" style="width:120px;background-color:#004D99;">item color</span>\
</div>\
<div id=stc_longrange style="font-size:14px;padding:6px;">\
  <div id=stc_longrange_autoscale_div style="margin-bottom:20px;">\
	<input type=checkbox id=stc_longrange_autoscale onchange="stc_longrange_autoscale()">\
	<label for=stc_longrange_autoscale>automatic color threshold</label>\
  </div>\
  <div class=titlebox><div style="margin:10px 0px 20px 0px;color:silver;"> 0\
	<canvas id=stc_longrange_pcolor onclick=stc_longrange_pcolor_initiator(event) width=80 height=15 style="cursor:pointer;"></canvas>\
	threshold\
	<div style="margin-top:5px;">\
	  <div id=longrange_pfilterscore_div style="margin-top:5px;">\
		<input type=text id=stc_longrange_pfilterscore size=3 value=2 onkeyup=stc_longrange_pfilterscore_KU(event)>\
		<button type=button onclick=stc_longrange_pfilterscore()>set filter threshold</button>\
	  </div>\
	  <div id=stc_longrange_pcolorscore_div>\
	    <input type=text id=stc_longrange_pcolorscore size=3 value=10 onkeyup=stc_longrange_pcolorscore_KU(event)>\
	    <button type=button onclick=stc_longrange_pcolorscore()>set color threshold</button>\
	  </div>\
    </div>\
  </div>\
  <div style="background-color:white;">Positive score</div>\
</div>\
<div class=titlebox><div style="margin:0px;color:silver;">\
	0\
	<canvas id=stc_longrange_ncolor onclick=stc_longrange_ncolor_initiator(event) width=80 height=15 style="cursor:pointer;"></canvas>\
	threshold\
	<div style="margin-top:5px;">\
	  <div id=longrange_nfilterscore_div style="margin-top:5px;">\
		<input type=text id=stc_longrange_nfilterscore size=3 value=-2 onkeyup=stc_longrange_nfilterscore_KU(event)>\
			<button type=button onclick=stc_longrange_nfilterscore()>set filter threshold</button>\
	  </div>\
	  <div id=stc_longrange_ncolorscore_div>\
		<input type=text id=stc_longrange_ncolorscore size=3 value=-10 onkeyup=stc_longrange_ncolorscore_KU(event)>\
		<button type=button onclick=stc_longrange_ncolorscore()>set color threshold</button>\
	  </div>\
	</div>\
  </div><div style="background-color:white;">Negative score</div>\
</div>\
</div>\
<div id=stc_sam style="font-size:14px;padding:6px;">\
	Item color:<br>\
	<span id=stc_forwardcolor class=coloroval onclick=stc_forwardcolor_initiator(event) style="margin-left:31px;width:70px;background-color:#000099;">forward</span>\
	<span id=stc_reversecolor class=coloroval onclick=stc_reversecolor_initiator(event) style="width:70px;background-color:#990000;">reverse</span>\
	<span id=stc_mismatchcolor class=coloroval onclick="stc_mismatchcolor_initiator(event)" style="margin-top:3px;width:70px;color:black;background-color:#ffff00;">mismatch</span>\
  </div>';


// menu - quantitative track config
menu.tkcfg_qual=menu_addoption(3,menu);
menu.tkcfg_qual.style.position='relative';
menu.tkcfg_qual.style.overflow='hidden';
menu.tkcfg_qual.innerHTML='<table cellspacing=0 cellpadding=0 style="margin-left:auto;margin-right:auto;position:relative;z-index:1;">\
  <tr>\
    <td style="padding:10px;border-bottom:dashed 1px rgba(133,133,133,0.3);">\
	  <div id=qtc_pcolordiv style="display:inline-block;padding:3px;padding-left:6px;padding-right:6px;background-color:#ff0000;border-radius:3px;-moz-border-radius:3px;overflow:hidden;text-align:center;">\
	    <span id=qtc_pcolor class=coloroval style="background-color:#ff0000;" onclick=qtc_pcolor_initiator(event)>positive value</span>\
	    <span id=qtc_pth class=coloroval style="margin-top:3px;background-color:#800000;border:solid 1px white;overflow:hidden;display:none;" onclick=qtc_pth_initiator(event)>&ge; threshold</span>\
	  </div>\
	</td><td style="padding:10px;border-bottom:dashed 1px rgba(133,133,133,0.3);">\
	  <div id=qtc_ncolordiv style="display:inline-block;padding:3px;padding-left:6px;padding-right:6px;background-color:#0000e6;border-radius:3px;-moz-border-radius:3px;overflow:hidden;text-align:center;">\
	    <span id=qtc_ncolor class=coloroval style="background-color:#0000e6;" onclick=qtc_ncolor_initiator(event)>negative value</span>\
	    <span id=qtc_nth class=coloroval style="margin-top:3px;background-color:#000099;border:solid 1px white;overflow:hidden;display:none;" onclick=qtc_nth_initiator(event)>&le; threshold</span>\
	  </div>\
	</td>\
  </tr><tr>\
    <td colspan=2>\
	  <div id=qtc_scalediv style="padding:10px;border-bottom:dashed 1px rgba(133,133,133,0.3);">\
	  <table>\
	    <tr>\
	      <td valign=top><input type=radio name=qtc_thresholdradio value=0 id=qtc_threshold_no onchange="toggle26(true)" checked></td>\
	      <td><label for=qtc_threshold_no>automatic scale</label></td>\
	    </tr><tr>\
	      <td valign=top>\
	        <input type=radio name=qtc_thresholdradio value=1 id=qtc_threshold_fix onchange="toggle26(true)"></td>\
	      <td><label for=qtc_threshold_fix>fixed scale</label></td>\
	    </tr><tr>\
	      <td></td>\
	      <td>\
	        <div style="border:solid 1px #E6E2D6;background-color:#F3EEE1;padding:2px;">\
	          <div id=qtc_thresholdradio_fixdiv style="display:none;">min: <input type=text style="width:35px;" value=0 id=qtc_fix_min> max: <input type=text style="width:35px;" value=10 id=qtc_fix_max> <button type=button onclick=qtc_setfixscale()>&#10004;</button></div>\
		</div>\
	      </td>\
	    </tr><tr>\
	      <td valign=top>\
	        <input type=radio name=qtc_thresholdradio value=2 id=qtc_threshold_percentile onchange="toggle26(true)">\
	      </td><td>\
	        <label for=qtc_threshold_percentile>percentile threshold</label><span id=qtc_percentile_span style="display:none;">: <span id=qtc_percentile>90</span></span><br>\
	        <span style="font-size:10px;color:#858585;">in case outlier values screw up the view</span>\
	      </td>\
	    </tr><tr>\
	      <td></td><td>\
	        <div style="border:solid 1px #E6E2D6;background-color:#F3EEE1;padding:2px;">\
		      <div id=qtc_rulerdiv style="display:none;">\
		      <span style="display:inline-block;font-size:large;color:#B5B5B5;" class=olinebut onmousedown="this.style.verticalAlign=-1;" onmouseup="this.style.verticalAlign=0;" onclick=qtc_slider_moveleft(5) title="decrease threshold percentile by 5">&#171;</span>\
		      <span style="display:inline-block;font-size:large;color:#B5B5B5;margin-right:3px;" class=olinebut onmousedown="this.style.verticalAlign=-1;" onmouseup="this.style.verticalAlign=0;" onclick=qtc_slider_moveleft(2) title="decrease threshold percentile by 2">&#8249;</span>\
		      <div style="display:inline-block;position:relative;"><div style="display:inline-block;width:6px;height:28px;"></div><div style="display:inline-block;width:100px;height:28px;"><canvas id=qtc_rulercanvas style="vertical-align:-16px;" width=101 height=16></canvas></div><div style="display:inline-block;width:6px;height:28px;"></div>\
			<div style="position:absolute;width:12px;height:28px;text-align:center;top:10px;left:90px;cursor:pointer;" id=qtc_slider onmousedown=qtc_sliderMD(event)>&darr;</div>\
		      </div>\
		      <span style="display:inline-block;font-size:large;color:#B5B5B5;margin-left:3px;" class=olinebut onmousedown="this.style.verticalAlign=-1;" onmouseup="this.style.verticalAlign=0;" onclick=qtc_slider_moveright(2) title="increase threshold percentile by 2">&#8250;</span>\
		      <span style="display:inline-block;font-size:large;color:#B5B5B5;" class=olinebut onmousedown="this.style.verticalAlign=-1;" onmouseup="this.style.verticalAlign=0;" onclick=qtc_slider_moveright(5) title="increase threshold percentile by 5">&#187;</span>\
		</div>\
	    </td>\
	    </tr>\
	  </table></div>\
	  <div id=qtc_logdiv style="padding:10px;border-bottom:dashed 1px rgba(133,133,133,0.3);">\
	  <table>\
	    <tr><td><input type=checkbox id=hook29 onchange="toggle29(true)"></td>\
	      <td><label for=hook29>log transform</label></td>\
	    </tr><tr>\
	      <td></td>\
	      <td>\
	        <div style="border:solid 1px #E6E2D6;background-color:#F3EEE1;padding:2px;">\
	          <div id=bait29 style="display:none;">\
		      <input type=radio name=qtc_log id=qtc_log_2 value=1 onchange=toggle30() checked> <label for=qtc_log_2>log2</label>\
		    <input type=radio name=qtc_log id=qtc_log_n value=2 onchange=toggle30()> <label for=qtc_log_n>ln</label>\
		    <input type=radio name=qtc_log id=qtc_log_10 value=3 onchange=toggle30()> <label for=qtc_log_10>log10</label>\
		  </div>\
	        </div>\
	      </td>\
	    </tr>\
	  </table>\
	  </div>\
	  <div id=qtc_pvcutoff style="padding:10px;border-bottom:dashed 1px rgba(133,133,133,0.3);">\
	    P-value cutoff:\
	    <select id=pvcutoff onchange=pvcutoff_selectchange() style="margin-right:10px;">\
	      <option value=0.1>0.1</option>\
	      <option value=0.05 selected>0.05</option>\
	      <option value=0.01>0.01</option>\
	      <option value=0.005>0.005</option>\
	      <option value=0.001>0.001</option>\
	      <option value=0.0005>0.0005</option>\
	    </select><br>\
	    <span class=coloroval id=htest_clc onclick=htest_clc_initiator(event) style="width:125px;background-color:#08298A;color:white;">cutoff line color</span>\
	    <hr style="border:dashed 1px rgba(133,133,133,0.3);">\
	  </div>\
	  <div id=qtc_alltrackdiv style="margin:10px;">\
        <input type=checkbox id=qtc_alltrackcheckbox onchange="toggle15(event)">\
        <label for=qtc_alltrackcheckbox>apply to all tracks</label>\
	  </div>\
     </td></tr>\
   </table>';
qtc.slider = document.getElementById("qtc_slider");

menu.c14=menu_addoption(2,menu);
menu.c14.innerHTML='Height: \
<button type=button changetype=1 amount=5 onclick=menu_tkh_change(event)>&#10010;</button> \
<button type=button changetype=1 amount=-5 onclick=menu_tkh_change(event)>&#9473;</button> \
<button type=button changetype=1 amount=1 onclick=menu_tkh_change(event) style="font-size:60%;">&#10010;</button> \
<button type=button changetype=1 amount=-1 onclick=menu_tkh_change(event) style="font-size:60%;">&#9473;</button> \
<button type=button id=menu_tkh_unifybutt changetype=2 onclick=menu_tkh_change(event)>Unify</button>';
menu.c14.style.whiteSpace='nowrap';

menu.c4=menu_addoption(1,'&#10005;','Remove',menuRemove,menu);
menu.c4.firstChild.style.color='red';

	{
	var c = document.getElementById("qtc_rulercanvas");
	var ctx = c.getContext("2d");
	ctx.fillStyle = "black";
	ctx.fillRect(0,0,1,6);
	ctx.fillRect(10,0,1,3);
	ctx.fillRect(20,0,1,3);
	ctx.fillRect(30,0,1,3);
	ctx.fillRect(40,0,1,3);
	ctx.fillRect(50,0,1,6);
	ctx.fillRect(60,0,1,3);
	ctx.fillRect(70,0,1,3);
	ctx.fillRect(80,0,1,3);
	ctx.fillRect(90,0,1,3);
	ctx.fillRect(100,0,1,6);
	ctx.fillText("0", 0,16);
	ctx.fillText("100", c.width-ctx.measureText("100").width,16);
	}

/* menu - select tk to add, small panel in menu */
var d=menu_addoption(2,menu);
menu.facettklstdiv=d;
var d2=document.createElement('div');
d.appendChild(d2);
d2.style.borderStyle='solid';
d2.style.borderWidth='1px 0px';
d2.style.borderColor='#ccc';
d2.style.margin=10;
var table=document.createElement('table');
d2.appendChild(table);
menu.facettklsttable=table;
d2=document.createElement('div');
d2.style.margin=10;
d.appendChild(d2);
var d3=document.createElement('div');
d2.appendChild(d3);
d3.style.display='inline-block';
d3.style.width=150;
var d4=document.createElement('div');
d3.appendChild(d4);
d4.style.display='inline';
menu.selecttk4add_butt=d4;
d4.addEventListener('click',facet_tklst_addSelected,false);
d4.style.backgroundColor='white';
d4.style.color='white';
d4.style.cursor='default';
d4.style.padding=5;
d4.style.borderRadius=d3.style.mozBorderRadius=5;
dom_addtext(d4,'add selected (');
var s=dom_addtext(d4,'0');
menu.selecttk4add_count=s;
dom_addtext(d4,')');
dom_addbutt(d2,'select all',facet_tklst_toggleall).tofill=true;
dom_addbutt(d2,'unselect all',facet_tklst_toggleall).tofill=false;
menu.facetremovebutt=dom_addbutt(d2,'remove all',facet_tklst_removeall);


menu.tkdetailwrapper=menu_addoption(4,menu);
menu.tkdetailwrapper.innerHTML='<tr><td class=header onclick=hmtkdetailheader_click(event) foo=general>General</td></tr>\
<tr id=hmtkdetailtr_general><td valign=middle align=center style="width:320px;height:200px;"></td></tr>\
<tr><td class=header onclick=hmtkdetailheader_click(event) foo=processing>Data processing</td></tr>\
<tr id=hmtkdetailtr_processing style="display:none;"><td valign=middle align=center style="width:320px;height:200px;"></td></tr>\
<tr><td class=header onclick=hmtkdetailheader_click(event) foo=other>Other versions</td></tr>\
<tr id=hmtkdetailtr_other style="display:none;"><td valign=middle align=center style="width:320px;height:200px;"></td></tr>\
<tr><td class=header onclick=hmtkdetailheader_click(event) foo=geo>GEO</td></tr>\
<tr id=hmtkdetailtr_geo style="display:none;"><td valign=middle align=center style="width:320px;height:200px;"></td></tr>\
<tr><td class=header onclick=hmtkdetailheader_click(event) foo=bam>Read alignment</td></tr>\
<tr id=hmtkdetailtr_bam style="display:none;"><td valign=middle align=center style="width:320px;height:200px;"></td></tr>';


menu.relocatediv=menu_addoption(3,menu);
menu.relocatediv.innerHTML='<div id=bait6_1>\
<canvas id=menu_splinternavigator width=360 height=24 style="display:block;margin:5px 0px 0px 20px;"></canvas>\
<table cellpadding=10><tr>\
<td><input class=jumpposinput type=text id=jumppos size=16 style="font:12px sans-serif;" value="enter coordinate" onfocus="if(this.value==\'enter coordinate\') this.value=\'\';" onblur="if(this.value.length==0) this.value=\'enter coordinate\';" onkeyup=menuJump_coord_KU(event)></td>\
<td><input class=jumpgeneinput type=text id=jumpgene size=16 style="font:12px sans-serif;" value="enter gene name" onfocus="if(this.value==\'enter gene name\') this.value=\'\';" onblur="if(this.value.length==0) this.value=\'enter gene name\';" onkeyup=menuJump_gene_KU(event)></td>\
<td><button type=button id=jumpbutton onclick=menuJump()>&nbsp;Go&nbsp;</button></td>\
<td><button type=button id=jumpresetbutton onclick="document.getElementById(\'jumppos\').value=\'enter coordinate\';document.getElementById(\'jumpgene\').value=\'enter gene name\';">Clear</button></td>\
</tr></table>\
<table id=jumplstholder cellspacing=0 cellpadding=2 style="font-size:12px;color:#545454;"><tbody></tbody></table>\
<div class=menuactivechoice onclick=toggle6() style=text-align:center;>Or zoom into a chromosome</div>\
</div>\
<div id=bait6_2>\
<div style="background-color:#ededed;">\
<div id=scfd_foo style="color:#006699;text-align:center;">\
<button type=button onclick=toggle6()>hide</button>\
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Select a location from one of the chromosomes\
<button type=button onclick="scfd_invokeconfigure()">Customize</button>\
</div>\
<div id=scfd_bar style="color:#858585;text-align:center;">\
drag <span class=header_b>chr1</span> vertically to reorder |\
click <span class=header_r>&#10005;</span> to hide\
<button type=button onclick=scfd_updateconfigure()>Update</button>\
<button type=button onclick=scfd_cancelconfigure()>Cancel</button>\
</div>\
</div>\
<div class=menuchoice2 id=menu_scfd_showholder></div>\
</div>';
menu.scfd_holder=document.getElementById('menu_scfd_showholder');

menu.decorcatalog=menu_addoption(4,menu);
menu.decorcatalog.cellSpacing=0;
menu.decorcatalog.innerHTML='<tr>\
<td style="padding:5px;padding-right:0px;" valign=top>\
<div id=decorcatalog_grpholder style="border-top:solid 1px #d9d9d9;margin:10px;margin-right:0px;"></div>\
</td><td id=decorcatalog_tkholder valign=top style="border-left:solid 1px #B48EB4;padding:10px;"><img src=images/null.gif width=150 height=1></td>\
</tr>';

menu.grandadd=menu_addoption(3,menu);
menu_addoption(1,null,'Experimental assay tracks',toggle1,menu.grandadd);
menu_addoption(1,null,'Genomic annotation tracks',toggle13,menu.grandadd);

menu.ctkselectpanel=menu_addoption(2,menu);
menu.ctkselectpanel.innerHTML='<div><table><tbody></tbody></table></div>';

menu.hengeviewoptions=menu_addoption(3,menu);
menu.hengeviewoptions.innerHTML='<div style="padding:10px;color:#858585;line-height:2;">\
Graph size <select id=hengeview_z_2 onchange=hengeview_setradius(event)><option value=-1 selected>choose</option>\
<option value=190>*</option>\
<option value=220>**</option>\
<option value=250>***</option>\
<option value=280>****</option>\
<option value=310>*****</option>\
<option value=340>******</option>\
<option value=370>*******</option></select>\
<br>\
Chromosome band size <select id=hengeview_z_3 onchange=hengeview_chrbarsize(event)><option value=-1 selected>choose</option>\
<option value=8>*</option>\
<option value=9>**</option>\
<option value=10>***</option>\
<option value=11>****</option>\
<option value=12>*****</option>\
<option value=13>******</option>\
<option value=14>*******</option></select>\
<br>\
<label for=hengeview_z_1>Draw scale bar?</label> <input id=hengeview_z_1 type=checkbox onchange=hengeview_showhidescale(event)>\
</div><div style="padding:10px;color:#858585;">\
<button type=button turnon=1 onclick=hengeview_regiontoggleall(event)>show all</button>\
<button type=button turnon=0 onclick=hengeview_regiontoggleall(event)>hide all</button>\
<table class=container id=hengeview_chrholder style="margin:5px;"><tbody></tbody></table>\
Uncheck to hide a chromosome;<br>\
drag <span class=header_b>&nbsp;</span> to reorder if more than 1\
</div>';


menu.apppanel=menu_addoption(3,menu);
menu.apppanel.innerHTML='<div class=menuactivechoice onclick=toggle10()>\
<table style="color:inherit;white-space:nowrap;"><tr><td align=center style="font-size:26px;width:33px;">&#10034;</td>\
<td style="padding-left:10px;">Gene set view (GSV)<br>\
<span style="font-size:10px;color:#ccc;">View track data about gene sets</span></td>\
</tr></table>\
</div>\
<div class=menuactivechoice onclick=toggle18()>\
<table style="color:inherit;white-space:nowrap;"><tr><td><img src=images/shorus.png style="opacity:0.7;"></td>\
<td style="padding-left:10px;">Genome snapshot<br>\
<span style="font-size:10px;color:#ccc;">View track at whole-genome scale</span></td>\
</tr></table>\
</div>\
<div class=menuactivechoice onclick="toggle4();toggle4_gpStandalone();">\
<table style="color:inherit;white-space:nowrap;"><tr><td><img src=images/geneplot_icon2.png></td>\
<td style="padding-left:10px;">Gene plot<br>\
<span style="font-size:10px;color:#ccc;">Data distribution inside gene sets</span></td>\
</tr></table>\
</div>\
<div class=menuactivechoice onclick=app_splinter()>\
<table style="color:inherit;white-space:nowrap;"><tr><td align=center style="font-size:30px;width:30px;">&#9707;</td>\
<td style="padding-left:10px;">Split browser panel<br>\
<span style="font-size:10px;color:#ccc;">Browse two regions simultaneously</span></td>\
</tr></table>\
</div>\
<div class=menuactivechoice onclick=toggle12()>\
<table style="color:inherit;white-space:nowrap;"><tr><td align=center style="font-size:30px;width:30px;">&hearts;</td>\
<td style="padding-left:10px;">Session &amp; URL<br>\
<span style="font-size:10px;color:#ccc;">Save &amp; share favorite views</span></td>\
</tr></table>\
</div>\
<div class=menuactivechoice onclick=svgpanelshow(1)>\
<table style="color:inherit;white-space:nowrap;"><tr><td align=center style="font-size:25px;width:30px;">&#9113;</td>\
<td style="padding-left:10px;">Screen shot<br>\
<span style="font-size:10px;color:#ccc;" which=1>Make high quality images for publication</span></td>\
</tr></table>\
</div>';
//<div class=menuactivechoice onclick='menu_overallconfig()'><img src=images/wrench.png height=20 style="vertical-align:-5px;"> Customize page style</div>


menu.zoomoutwarning=menu_addoption(2,menu);
menu.zoomoutwarning.innerHTML='<p style="color:#858585;"><span id=zoomout_warning_itemcount></span> items has been loaded.</p>\
<span class=button_warning onclick=risky_zoomout()>Click here to zoom out \
<span id=zoomout_warning_fold style="font-weight:bold;font-size:150%;vertical-align:-1px;"></span> fold</span>\
<p style="font-size:12px;width:200px;color:#ccc;">Zoom out to such scale might take long time to load new items and might even halt your web browser.</p>\
<div class=header_gr onclick=menu_hide()>Cancel</div>';


menu.stickynote=menu_addoption(3,menu);
menu.stickynote.innerHTML='<div>\
<div class=menuactivechoice onclick=coordnote_showinputpanel(false)><img src=images/stickyNote.png height=20 style="vertical-align:-5px;"> New note</div>\
</div>\
<div style="margin:10px;color:#858585;">\
At <span id=coordnote_says></span>:<br>\
<textarea rows=5 cols=20 id=coordnote_textarea></textarea>\
<br>\
<button type=button onclick=coordnote_submit()>Submit</button>\
</div>\
<div>\
<div class=menuactivechoice onclick=coordnote_showinputpanel(true)><div class=iconholder>&#9998;</div> Edit</div>\
<div class=menuactivechoice onclick=coordnote_delete()><div class=iconholder style="color:red;">&#10005;</div> Delete</div>\
</div>';

var t=menu_addoption(4,menu);
menu.gsv_genemodellstholder=t;
t.style.cellSpacing=0;
t.style.cellPadding=2;
t.style.color='#545454';
t.style.whiteSpace='nowrap';

menu.c9=menu_addoption(1,'&#10140;','Change color',show_mcmColorConfig,menu);
var d=menu_addoption(4,menu); // next sibling of c9
d.style.margin=10;
d.cellSpacing=10;


/* menu ends */


// pica is on top of menu
pica=document.createElement('div');
document.body.appendChild(pica);
pica.style.position='absolute';
pica.style.border='1px solid white';
pica.style.overflow='hidden';
pica.style.zIndex=103;
var d=document.createElement('div');
d.style.position='relative';
pica.appendChild(d);
var dbg=document.createElement('div');
dbg.style.position='absolute';
dbg.style.left=dbg.style.top=0;
dbg.style.backgroundColor='#003552';
dbg.style.opacity=0.8;
dbg.style.width=dbg.style.height='100%';
d.appendChild(dbg);
var d2=document.createElement('div');
d2.style.position='relative';
d2.style.color='#e0e0e0';
d2.style.padding=3;
d.appendChild(d2);
picasays=d2;


menu.style.display=
pica.style.display=
bubble.style.display=
indicator.style.display=
indicator2.style.display=
indicator3.style.display=
indicator4.style.display=
indicator6.style.display=
indicator7.style.display=
pagecloak.style.display=
pagecloak2.style.display=
invisibleBlanket.style.display= 'none';


palette=document.createElement('div');
document.body.appendChild(palette);
palette.style.display='none';
palette.style.position='fixed';
palette.style.zIndex=104;
palette.addEventListener('mouseover',paletteMover,false);
palette.addEventListener('mouseout',paletteMout,false);
palette.innerHTML='<div style="position:relative;width:170px;height:200px;">\
<canvas id=palettepointer width=35 height=15 style="position:absolute;left:62px;top:0px;opacity:0.7;"></canvas>\
<div style="position:absolute;left:0px;top:15px;background-color:black;opacity:0.7;width:170px;height:150px;border-top-left-radius:5px;border-top-right-radius:5px;-moz-border-radius-topleft:5px;-moz-border-radius-topright:5px;border-bottom:solid 1px #404040;"></div>\
<div style="position:absolute;left:0px;top:166px;background-color:black;opacity:0.6;width:170px;height:60px;border-bottom-left-radius:5px;border-bottom-right-radius:5px;-moz-border-radius-bottomleft:5px;-moz-border-radius-bottomright:5px;"></div>\
<table style="position:absolute;left:0px;top:15px;width:170px;height:150px;"><tr><td align=center valign=middle style="width:170px:height:150px;">\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#ff0000;">red</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#008000;">green</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#0000ff;">blue</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#ffff00;color:#858585;">yellow</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#008080;">teal</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#808000;">olive</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#ffa500;">orange</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#800000;">maroon</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#ff00ff;">fuchsia</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#6a5acd;">slateblue</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#4b0082;">indigo</div>\
<div class=palettedye onclick=palettedyeclick(event) style="background-color:#696969;">dimgray</div>\
</td></tr></table>\
<div style="position:absolute;left:20px;top:172px;">\
<div style="position:relative;width:110px;">\
<canvas id=palettegrove width=100 height=20 style="position:absolute;left:13px;top:18px;" onclick=palettegrove_click(event)></canvas>\
<canvas id=paletteslider width=26 height=26 style="position:absolute;left:50px;top:0px;cursor:pointer;" onmousedown=palettesliderMD(event)></canvas>\
</div>\
</div>\
</div>';
palette.grove = document.getElementById('palettegrove');
palette.slider = document.getElementById('paletteslider');
var c = document.getElementById("palettepointer");
var ctx = c.getContext("2d");
ctx.fillStyle = "black";
ctx.beginPath();
ctx.moveTo(0, 15);
ctx.lineTo(18,0);
ctx.lineTo(35,15);
ctx.fill();
c = document.getElementById('paletteslider');
ctx = c.getContext("2d");
lg = ctx.createLinearGradient(0,0,0,30);
lg.addColorStop(0, "#c3c3c3");
lg.addColorStop(1, "#707070");
ctx.fillStyle = lg;
ctx.moveTo(0,0);ctx.lineTo(26,0);ctx.lineTo(26,13);ctx.lineTo(13,23);ctx.lineTo(0,13);ctx.lineTo(0,0);ctx.fill();


menu2=document.createElement('div');
document.body.appendChild(menu2);
menu2.style.position='absolute';
menu2.style.backgroundColor='#ededed';
menu2.style.zIndex=104;
menu2.addEventListener('mouseover',menu2_mover,false);
menu2.addEventListener('mouseout',menu2_mout,false);

}

function menu2_show() {
menu2.style.display='block';
document.body.addEventListener('mousedown',menu2_hide,false);
}
function menu2_hide() {
menu2.style.display='none';
document.body.removeEventListener('mousedown',menu2_hide,false);
}
function menu2_mover(event) {
document.body.removeEventListener('mousedown',menu_hide,false);
document.body.removeEventListener('mousedown',menu2_hide,false);
}
function menu2_mout(event) {
document.body.addEventListener('mousedown',menu_hide,false);
document.body.addEventListener('mousedown',menu2_hide,false);
}
function menu2ele_click(event)
{
menu2_hide();
document.getElementById('jumpgene').value=event.target.genename;
simulateEvent(document.getElementById('jumpbutton'),'click');
}






function qtrack_plotheatmap_base(data, startidx, stopidx, ctx, thisqtc, pthvalue, nthvalue, x,y,w,h, tosvg) {
/* arguments:
data: single array
startidx/stopidx: array index of data [start, stop)
ctx:
thisqtc:
pthvalue/nthvalue:
x,y,w,h: x/y plotting position, w/h width and height of each stroke
tosvg: boolean
*/
	var svgdata=[];
	var usethreshold = thisqtc.thtype!=0;
	for(var i=startidx; i<stopidx; i++) {
		var v = data[i];
		if(!isNaN(v) && v!=Infinity && v!=-Infinity) {
			if(v > 0) {
				if(usethreshold && v>=pthvalue) {
					ctx.fillStyle = thisqtc.pth;
				} else {
					ctx.fillStyle = 'rgba('+thisqtc.pr+','+thisqtc.pg+','+thisqtc.pb+','+(v/pthvalue)+')';
				}
				ctx.fillRect(x, y, w, h);
				if(tosvg) svgdata.push([ctx.fillStyle,false]);
			} else if(v < 0) {
				if(usethreshold && v<=nthvalue) {
					ctx.fillStyle = thisqtc.nth;
				} else {
					ctx.fillStyle = 'rgba('+thisqtc.nr+','+thisqtc.ng+','+thisqtc.nb+','+(v/nthvalue)+')';
				}
				ctx.fillRect(x, y, w, h);
				if(tosvg) svgdata.push([ctx.fillStyle,false]);
			} else {
				if(tosvg) svgdata.push(['transparent',false]);
			}
		} else {
			if(tosvg) svgdata.push(['transparent',false]);
		}
		x += w;
	}
	return svgdata;
}
function qtrack_logtransform(data,qtconfig,startRidx,stopRidx,startDidx,stopDidx) {
/* data is nested array
returns new vector same as data
*/
	var nd = [];
	for(var i=0; i<=stopRidx; i++) nd.push([]);
	for(i=0; i<startDidx; i++) nd[startRidx].push(0);
	for(i=startRidx; i<=stopRidx; i++) {
		var start = i==startRidx ? startDidx : 0;
		var stop = i==stopRidx ? stopDidx : data[i].length;
		for(var j=start; j<stop; j++) {
		//if(nd[i]==undefined) throw(startRidx+' '+stopRidx+' '+startDidx+' '+stopDidx+' '+i);
			if(qtconfig.logtype == 1) {
				nd[i][j] = Math.log(data[i][j]) * Math.LOG2E;
			} else if(qtconfig.logtype==2) {
				nd[i][j] = Math.log(data[i][j]);
			} else {
				nd[i][j] = Math.log(data[i][j]) * Math.LOG10E;
			}
		}
	}
	return nd;
}
function qtrack_getthreshold(data, qtconfig, startRidx, stopRidx, startDidx, stopDidx) {
/* figure out threshold for a quantitative track for plotting
compute for positive/negative data separately
if not using threshold, use max value

args:
data: nested array
qtconfig is qtc object of the track
startRidx/stopRidx: data array index
startDidx/stopDidx: data[x] array index
*/
	if(qtconfig.thtype == 1) {
		return [qtconfig.thmax, qtconfig.thmin];
	}
	var pth; // positive threshold value
	var nth; // negative
	if(qtconfig.thtype == 2) {
		/*** fixed percentile ***/
		var plst = []; var nlst = [];
		for(var i=startRidx; i<=stopRidx; i++) {
			var start = (i==startRidx) ? startDidx : 0;
			var stop = (i==stopRidx) ? stopDidx : data[i].length;
			for(var j=start; j<stop; j++) {
				var v = data[i][j];
			if(isNaN(v) || v==Infinity || v==-Infinity) {
			} else if(v > 0) {
				plst.push(v);
			} else if(v < 0) {
				nlst.push(v);
			}
			}
		}
		if(plst.length > 0) {
			plst.sort(numSort);
			var n = parseInt(plst.length*qtconfig.thpercentile/100);
			if(n >= plst.length)
				n = plst.length - 1;
			pth = plst[n];
		} else {
			pth = 0;
		}
		if(nlst.length > 0) {
			nlst.sort(numSort);
			var n = parseInt(nlst.length * (100-qtconfig.thpercentile)/100);
			if(n < 0) n = 0;
			nth = nlst[n];
		} else {
			nth = 0;
		}
	} else if(qtconfig.thtype == 0){
		/*** auto scale ***/
		pth=0; nth=0;
		for(var i=startRidx; i<=stopRidx; i++) {
		var start = (i==startRidx) ? startDidx : 0;
		var stop = (i==stopRidx) ? stopDidx : data[i].length;
		for(var j=start; j<stop; j++) {
			var v = data[i][j];
		if(isNaN(v) || v==Infinity || v==-Infinity) {
		} else if(v > 0) {
			if(v > pth) pth = v;
			} else {
			if(v < nth) nth = v;
		}
		}
	}
	} else {
		fatalError("qtrack_getthreshold: unknown threshold type");
	}
	return [pth, nth];
}
function qtcpanel_setdisplay(pm)
{
/* turn on qtrack config panel and set appearance by values in pm.qtc
a bunch of boolean args
*/
if(pm.which==undefined) fatalError('qtcpanel_setdisplay: pm.which not set');
qtc.which=pm.which;
menu_shutup();
menu.tkcfg_qual.style.display = "block";
if(pm.tkh) {
	menu.c14.style.display='block';
	document.getElementById('menu_tkh_unifybutt').style.display=gflag.menu.tklst.length>1?'inline':'none';
} else {
	menu.c14.style.display='none';
}
document.getElementById("qtc_pcolordiv").style.display = pm.pcolor ? "inline-block" : "none";
document.getElementById("qtc_ncolordiv").style.display = pm.ncolor ? "inline-block" : "none";
if(pm.pcname)
	document.getElementById('qtc_pcolor').innerHTML=pm.pcname;
if(pm.ncname)
	document.getElementById('qtc_ncolor').innerHTML=pm.ncname;
document.getElementById("qtc_logdiv").style.display = pm.log ? "block" : "none";
document.getElementById("qtc_pvcutoff").style.display = pm.pvcut ? "block" : "none";
document.getElementById("qtc_alltrackdiv").style.display = pm.alltk ? "block" : "none";
document.getElementById("qtc_alltrackcheckbox").checked = false;

if(!pm.qtc) {
	/* qtc object not supplied, called by right clicking on mcm
	to control more than one track
	*/
	document.getElementById("qtc_scalediv").style.display = "block";
	checkInputByvalue('qtc_thresholdradio', '0');
	toggle26(false);
	return;
}
if(pm.pvcut) {
	// pvalue cutoff
	changeSelectByValue('pvcutoff', pm.qtc.pvcutoff.toString());
	document.getElementById('htest_clc').style.backgroundColor = pm.qtc.pvccolor;
}
if(pm.scale) {
	// allow configuring y-scale and threshold
	document.getElementById("qtc_scalediv").style.display = "block";
	checkInputByvalue('qtc_thresholdradio', pm.qtc.thtype.toString());
	toggle26(false);
	document.getElementById('qtc_fix_min').value = pm.qtc.thmin;
	document.getElementById('qtc_fix_max').value = pm.qtc.thmax;
	document.getElementById('qtc_percentile').innerHTML = pm.qtc.thpercentile;
	document.getElementById('qtc_slider').style.left = pm.qtc.thpercentile;
} else {
	document.getElementById("qtc_scalediv").style.display = "none";
	checkInputByvalue('qtc_thresholdradio', '0');
	toggle26(false);
}
if(pm.pcolor) {
	// positive color
	var c = "rgb("+pm.qtc.pr+","+pm.qtc.pg+","+pm.qtc.pb+")";
	document.getElementById("qtc_pcolor").style.backgroundColor = c;
	document.getElementById("qtc_pcolordiv").style.backgroundColor = c;
	document.getElementById("qtc_pth").style.backgroundColor = pm.qtc.pth;
}
if(pm.ncolor) {
	// negative color
	var c = "rgb("+pm.qtc.nr+","+pm.qtc.ng+","+pm.qtc.nb+")";
	document.getElementById("qtc_ncolor").style.backgroundColor = c;
	document.getElementById("qtc_ncolordiv").style.backgroundColor = c;
	document.getElementById("qtc_nth").style.backgroundColor = pm.qtc.nth;
}
if(pm.log) {
	document.getElementById('hook29').checked = pm.qtc.uselog;
	toggle29(false);
	checkInputByvalue('qtc_log', pm.qtc.logtype.toString());
}
/*over*/
}

function categoricalTk_plot_base(data, cateInfo, startidx, stopidx, ctx, thisqtc, x,y,w,h,tosvg) {
/* args
data: single array
startidx/stopidx: array index of data [start, stop)
x,y: plot offset on canvas
w,h: width/height of each stroke
*/
	var svgdata=[];
	for(var i=startidx; i<stopidx; i++) {
		var v = data[i];
		if(v==-1) {
			if(tosvg) svgdata.push(['transparent',false]);
		} else {
			if(v in cateInfo) {
				ctx.fillStyle=cateInfo[v][1];
				ctx.fillRect(x, y, w, h);
				if(tosvg) svgdata.push([ctx.fillStyle,false]);
			} else {
				if(tosvg) svgdata.push(['transparent',false]);
			}
		}
		x+=w;
	}
	return svgdata;
}
function qtc_paramCopy(from,to) {
/* 'from' 'to' are qtc objects (or equipped with same attributes)
copy values from one to the other */
	for(var p in from) to[p] = from[p];
}

function plotReadmismatch(ctx, samstr, readlen, readseq, x, y, w, h, isThin, miscolor, tosvg) {
/* args:
- ctx:
- samstr: md tag of sam format
- readlen: read length in bp
- readseq: read sequence for printing mismatch
- x,y,w,h: on-canvas dimension of the read (to restrain or provide resolution)
- isThin: boolean
- miscolor: mismatch line/letter color
- tosvg: boolean
*/
	if(w<10) return [];
	if(samstr.indexOf('MD:Z:')!=0) return [];
	var str=samstr.substr(5);
	var sf = w/readlen; // plot width of 1 bp
	var plotlineonly = isThin ? true : (sf < 8);
	ctx.fillStyle = miscolor;
	ctx.font = "bold 8pt Sans-serif"
	var svgdata=[];
	var stroffset=0;
	var bpoffset=0;
	var tmpstr=str;
	while(stroffset<str.length-1) {
		var n=parseInt(tmpstr);
		if(isNaN(n)) {
			var ch=readseq.charAt(stroffset);
			if(ch.toLowerCase() in ntbcolor) {
				if(plotlineonly) {
					ctx.fillRect(x+bpoffset*sf,y, Math.max(1,sf), h);
					if(tosvg) svgdata.push([1,x+bpoffset*sf,y,Math.max(1,sf),h,miscolor]);
				} else {
					ctx.fillText(readseq.charAt(bpoffset), x+bpoffset*sf, y+8);
					if(tosvg) svgdata.push([2,x+bpoffset*sf,y+8,ch,miscolor]);
				}
				bpoffset++;
			}
			stroffset++;
		} else {
			bpoffset+=n;
			stroffset+=n.toString().length;
		}
		tmpstr=str.substr(stroffset);
	}
	if(tosvg) return svgdata;
}

Browser.prototype.trackHeightChanged=function()
{
/* call this whenever track height is changed, any one of them
*/
this.hmdiv.parentNode.style.height=this.hmdiv.clientHeight;
if(this.decordiv!=null)
	this.decordiv.parentNode.style.height=this.decordiv.clientHeight;
}


/*** __render__ ends ***/



/*** __navi__ navigator ***/

Browser.prototype.drawNavigator=function()
{
if(this.navigator==null) return;
this.navigator.blockwidth=[];
this.navigator.blocks=[]; // don't use during gsv
var ctx=this.navigator.canvas.getContext('2d');
ctx.clearRect(0,0,this.navigator.canvas.width, this.navigator.canvas.height);
if(this.is_gsv()) {
	/* see if all gsv items are in same chr, if so, draw the chr ideogram and mark items out as boxes
	var same_chr=true;
	if(same_chr) {
		return;
	}
	*/
	// not in same chr, draw all the gsv items
	var lst=this.genesetview.lst;
	var x=0;
	var totalbp=0;
	for(var i=0; i<lst.length; i++)
		totalbp+=lst[i].stop-lst[i].start;
	this.genesetview.lstsf=totalbp/this.navigator.canvas.width;
	for(var i=0; i<lst.length; i++) {
		var tlen=lst[i].stop-lst[i].start;
		ctx.fillStyle = (i%2==0) ? this.genesetview.minichr_filla : this.genesetview.minichr_fillb;
		var w=tlen/this.genesetview.lstsf;
		this.navigator.blockwidth.push(w);
		ctx.fillRect(x, this.navigator.hlspacing+1, w, this.navigator.chrbarheight);
		var w2=ctx.measureText(lst[i].name).width;
		if(w2<=w) {
			ctx.fillStyle=this.genesetview.minichr_text;
			ctx.fillText(lst[i].name,x+(w-w2)/2, this.navigator.hlspacing+12);
		}
		x+=w;
	}
	// highlight
	var vstartr_coord, vstopr_coord;
	x=0;
	var r=this.regionLst[this.dspBoundary.vstartr];
	for(i=0; i<lst.length; i++) {
		if(lst[i].name==r[6]) {
			vstartr_coord=lst[i].start;
			break;
		}
		x+=this.navigator.blockwidth[i];
	}
	// here must use r[7] but not this.entire.summarySize, why??
	x+=(r[3]+this.dspBoundary.vstarts*(this.entire.atbplevel?1:r[7])-vstartr_coord)/this.genesetview.lstsf;
	var x2=0;
	r=this.regionLst[this.dspBoundary.vstopr];
	for(i=0; i<lst.length; i++) {
		if(lst[i].name==r[6]) {
			vstopr_coord=lst[i].start;
			break;
		}
		x2+=this.navigator.blockwidth[i];
	}
	x2+=(r[3]+this.dspBoundary.vstops*(this.entire.atbplevel?1:r[7])-vstopr_coord)/this.genesetview.lstsf;

	ctx.strokeStyle='blue';
	ctx.strokeRect(x==0?0:x-.5, .5, x2-x, this.navigator.chrbarheight+2*this.navigator.hlspacing+1);
	return;
}
var chrlst=[this.regionLst[this.dspBoundary.vstartr][0]];
for(var i=this.dspBoundary.vstartr+1; i<=this.dspBoundary.vstopr; i++) {
	if(!thinginlist(this.regionLst[i][0],chrlst))
		chrlst.push(this.regionLst[i][0]);
}
var totalbp=0;
for(i=0; i<chrlst.length; i++)
	totalbp+=this.genome.scaffold.len[chrlst[i]];
var x=0;
var lastchrxoffset=0, firstchrwidth=0, lastchrwidth=0;
var imagewidth=this.navigator.canvas.width;
for(i=0; i<chrlst.length; i++) {
	var chrlen=this.genome.scaffold.len[chrlst[i]];
	var w=chrlen*(imagewidth-chrlst.length-1)/totalbp;
	this.navigator.blockwidth.push(w);
	this.navigator.blocks.push([chrlst[i],0,chrlen]);
	if(i==0) firstchrwidth=w;
	if(i==chrlst.length-1) lastchrwidth=w;
	lastchrxoffset=x+1;
	drawIdeogramSegment_simple(
		this.genome.getcytoband4region2plot(chrlst[i], 0, this.genome.scaffold.len[chrlst[i]], w),
		ctx, x, this.navigator.hlspacing+1, w, ideoHeight, false);
	x+=w+1;
}
// highlight currently viewed region
var r=this.regionLst[this.dspBoundary.vstartr];
var coord=r[3]+this.dspBoundary.vstarts*(this.entire.atbplevel?1:this.entire.summarySize);
var hlstart=parseInt(coord*firstchrwidth/this.genome.scaffold.len[r[0]]);
r=this.regionLst[this.dspBoundary.vstopr];
coord=r[3]+this.dspBoundary.vstops*(this.entire.atbplevel?1:this.entire.summarySize);
var hlstop=Math.max(hlstart+1,parseInt(lastchrxoffset+coord*lastchrwidth/this.genome.scaffold.len[r[0]]));
ctx.strokeStyle='blue';
ctx.strokeRect(hlstart-.5, .5, hlstop-hlstart, this.navigator.chrbarheight+2*this.navigator.hlspacing+1);
// ruler
if(this.navigator.show_ruler && chrlst.length==1 && this.navigator.rulerheight>0) {
	var chrlen=this.genome.scaffold.len[chrlst[0]];
	ctx.fillStyle='rgba('+colorstr2int(colorCentral.foreground).join(',')+',0.3)';
	drawRuler_basepair(ctx, chrlen, imagewidth, 0, this.navigator.chrbarheight+2*this.navigator.hlspacing+4);
}
/* over */
}

function drawRuler_basepair(ctx, bplen, plotwidth, x, y)
{
/* draw horizontal basepair ruler
canvas height is fixed to 20px
color must already been set
*/
var sf = plotwidth / bplen;
var ulst = ['','0','00','K','0K','00K','M','0M','00M'];
var k = -1;
for(var i=ulst.length-1; i>=0; i--) {
	if(Math.pow(10,i)*2 < bplen) {
		k = i;
		break;
	}
}
if(k == -1) {
	print2console('cannot draw ideogram ruler', 2);
	return;
}
var ulen = Math.pow(10,k); // unit bp length
var unum = parseInt(bplen / ulen);
var uplot = ulen * sf; // unit plot width
ctx.fillRect(0,y,uplot*unum,1);
ctx.fillRect(0,y,1,5);
ctx.fillText(0,0,y+15);
var x = 0;
var lasttextpos=0;
for(i=1; i<=unum; i++) {
	ctx.fillRect(x+uplot/4,y,1,4); // 1st quarter
	ctx.fillRect(x+uplot/2,y,1,4); // half
	ctx.fillRect(x+uplot*3/4,y,1,4); // 3rd quarter
	ctx.fillRect(x+uplot, y, 1, 5);
	var w = i.toString()+ulst[k];
	var ww = ctx.measureText(w).width;
	x += uplot;
	if(x>lasttextpos+ww+3) {
		ctx.fillText(w, i==unum ? x-ww+1 : x-ww/2,15+y);
		lasttextpos=x;
	}
}
}

Browser.prototype.navigatorSeek=function(x)
{
// return [chr/item name, coord]
if(this.is_gsv()) {
	var cx=0;
	for(var i=0; i<this.navigator.blockwidth.length; i++) {
		var thisx=this.navigator.blockwidth[i];
		if(cx+thisx>=x) {
			var b=this.genesetview.lst[i];
			return [b.name, b.start+parseInt((b.stop-b.start)*(x-cx)/thisx)];
		}
		cx+=thisx;
	}
	return [this.genesetview.lst[i-1].name, this.genesetview.lst[i-1].stop];
}
var cx=0;
for(var i=0; i<this.navigator.blockwidth.length; i++) {
	var thisx=this.navigator.blockwidth[i];
	if(cx+thisx>=x) {
		var b=this.navigator.blocks[i];
		return [b[0], parseInt((b[2]-b[1])*(x-cx)/thisx)];
	}
	cx+=thisx;
}
return [this.navigator.blocks[i-1][0], this.navigator.blocks[i-1][2]];
}
function navigator_mm(event) {
// show pica over navigator canvas
	var bbj=gflag.browser;
	var pos=absolutePosition(event.target);
	pica_go(event.clientX,pos[1]+event.target.clientHeight-document.body.scrollTop-13);
	var x=event.clientX+document.body.scrollLeft-pos[0]; // offset on canvas
	var re=bbj.navigatorSeek(x);
	picasays.innerHTML=re[0]+', '+re[1];
}

function navigatorMD(event)
{
/* both on trunk and spliter
*/
if(event.button != 0) return; // only process left click
event.preventDefault();
var pos = absolutePosition(event.target);
indicator.style.display = "block";
indicator.style.left = event.clientX + document.body.scrollLeft;
indicator.style.top = pos[1];
indicator.style.width = 1;
indicator.style.height = event.target.clientHeight;
gflag.navigator={
	bbj:gflag.browser,
	canvas:event.target,
	x:event.clientX+document.body.scrollLeft,
	xcurb:pos[0]};
document.body.addEventListener("mousemove", navigatorM, false);
document.body.addEventListener("mouseup", navigatorMU, false);
}
function navigatorM(event)
{
var currx = event.clientX + document.body.scrollLeft;
var n=gflag.navigator;
if(currx > n.x) {
	if(currx < n.xcurb+n.canvas.width) {
		indicator.style.width = currx - n.x;
	}
} else {
	if(currx >= n.xcurb) {
		indicator.style.width = n.x - currx;
		indicator.style.left = currx;
	}
}
}

function navigatorMU(event)
{
document.body.removeEventListener("mousemove", navigatorM, false);
document.body.removeEventListener("mouseup", navigatorMU, false);
indicator.style.display = "none";
var n=gflag.navigator;
var x = parseInt(indicator.style.left)-n.xcurb; // relative to minichr canvas div
var w = parseInt(indicator.style.width);
if(w==0) return;
var jt = n.bbj.juxtaposition.type;
var coord1=n.bbj.navigatorSeek(x);
var coord2=n.bbj.navigatorSeek(x+w);
if(coord1[0]==coord2[0] && coord1[1]==coord2[1]) return;

if(n.bbj.is_gsv()) {
	// gene set view
	/* if selected region is too small to fit in the entire genomeheatmap,
	   need to expand it so it won't yield "truncated" hmtks
	 */
	var hmbp = n.bbj.hmSpan/MAXbpwidth_bold;
	var wbp = w*n.bbj.genesetview.lstsf; // bp spanned by indicator box
	if(wbp < hmbp) {
		var neww = Math.ceil(hmbp*this.genesetview.lstsf);
		x -= Math.ceil((neww-w)/2);
		w = neww;
		if(x < 0) {
			x = 0;
		} else if(x+w > this.navigator.canvas.width) {
			x = this.navigator.canvas.width-w;
		}
	}
	n.bbj.cloak();
	var samestring = "itemlist=on&imgAreaSelect=on&statusId="+n.bbj.statusId+
		"&startChr="+coord1[0]+"&startCoord="+coord1[1]+
		"&stopChr="+coord2[0]+"&stopCoord="+coord2[1]+
		(n.bbj.entire.atbplevel?'&atbplevel=on':'');
	if(jt==RM_gsv_c) {
		n.bbj.ajaxX(samestring+gss_param(1));
	} else {
		n.bbj.ajaxX(samestring+gss_param(2));
	}
	return;
}
n.bbj.cloak();
n.bbj.ajaxX('imgAreaSelect=on&'+n.bbj.gftype_param()+'&startChr='+coord1[0]+'&startCoord='+coord1[1]+'&stopChr='+coord2[0]+'&stopCoord='+coord2[1]);
}

Browser.prototype.gftype_param=function() {
// only for RM_genome, RM_jux_c, RM_jux_n
if(this.juxtaposition.type==RM_genome)
	return 'gftype=genome';
return 'gftype='+this.juxtaposition.what+(this.juxtaposition.type==RM_jux_c?'&gfiscustom=on':'');
}

/*** __navi__ ends ***/







Browser.prototype.drawDecor_variousmode=function(tkobj,yoffset,tosvg)
{
/* args:
tkobj: decorCanvasHash[gf] or chiapet.datalst[x].decor[gf], to supply data
	(chiapet obj doesn't carry styles...)
yoffset: plot coord x/y offset on canvas, will be used and changed for multiple times
    none-zero yoffset indicates top padding

steps:
- compute box start/width for each item using genomic coord of item and region
- sort items
- stack items
- plot those stacked
- separate treatment for BAM and bigBed files

about name/strand:
first try fitting name+strand into box
else, if enough width on left of box, plot name
else, don't plot name

for long-range tracks:
- special treatment/rendering style
- score filtering has been done in C, no need to do it here

for stack tracks (not arc or trihm),
set canvas height by max # of stacks within dspBoundary.vstarts and dspBoundary.vstops

TODO try fit name and strand info into structure component if structure is wide enough
*/
var canvas = tkobj.canvas;
canvas.width=this.entire.spnum;
var ctx = canvas.getContext('2d');

var startRidx=this.dspBoundary.lwr;
var stopRidx=this.dspBoundary.rwr;
var startViewCoord=getPointCoord(this.regionLst, this.entire, this.dspBoundary.lwr, this.dspBoundary.lws);
var stopViewCoord=getPointCoord(this.regionLst, this.entire, this.dspBoundary.rwr, this.dspBoundary.rws);
var xoffset0=this.dspBoundary.lwrlpx;
var juxType=this.juxtaposition.type;

// item array index
var id_boxstart=0, id_boxwidth=1, id_id=2, 
id_name=3, id_strand=4, id_stackid=5,
id_stackstart=6, id_stackwidth=7, id_startcoord=8, 
id_stopcoord=9, id_namewidth=10,
id_mismatches=11, id_samflag=12, id_readstatus=13, id_readseq=14,
id_name2=15, id_struct=16, id_hasmate=17;

/* for stacking and plotting
for long-range tracks, will be replaced by mated pairs and also singletons
for sam tracks, complete read pair will be joined
*/
var Data=[];
/* for longrange arcs */
var Data2=[];

var isChiapet = (tkobj.ft==FT_lr_n||tkobj.ft==FT_lr_c);
var isSam = (tkobj.ft==FT_sam_c||tkobj.ft==FT_sam_n);
var drawTriheatmap = tkobj.mode==M_trihm;
var drawArc = tkobj.mode==M_arc;

/* both for arc and triangular heatmap:
if the on-canvas distance between two paired items is greater than hmSpan,
it will make the canvas too high, and the two items won't both show up
so limit it
*/
if(isSam) {
	/* sam read pre-processing */
	for(var i=0; i<startRidx; i++)
		Data.push(tkobj.data[i]);
	var pairedReads={};
	for(i=startRidx; i<=stopRidx; i++) {
		if(tkobj.data[i]==undefined || tkobj.data[i].length==0) {
			Data.push([]);
			continue;
		}
		tkobj.data[i].sort(gfSort2);
		var newarray=[];
		for(var j=0; j<tkobj.data[i].length; j++) {
			var item=tkobj.data[i][j];
			var f=item[id_samflag];
			if(((f>>2)&1)==1) {
				// it is umapped?
				continue;
			}
			if(item[id_hasmate]) {
				// already paired, perhaps before moving
				newarray.push(item);
				continue;
			}
			item[id_strand]=(((f>>4)&1)==1)?'<':'>';
			//item[id_hasmate]=false;
			if(((f>>0)&1)==1) {
				// paired
				if(item[id_id] in pairedReads) continue;
				if(((f>>3)&1)==1) {
					// mate is unmapped
					item[id_readstatus]='paired but mate is unmapped';
				} else {
					// mate is mapped
					var mateRidx=-1, mateDidx=-1;
					for(var k=j+1; k<=stopRidx; k++) {
						var it2=tkobj.data[i][k];
						if(tkobj.data[i][k][id_id]==item[id_id]) {
							mateRidx=i;
							mateDidx=k;
							break;
						}
					}
					if(mateRidx==-1) {
						// mate is not found in this region, look through the remainder
						for(var k=i+1; k<=stopRidx; k++) {
							if(mateRidx!=-1) break;
							for(var x=startRidx; x<=stopRidx; x++) {
								var it2=tkobj.data[k][x];
								if(tkobj.data[k][x][id_id]==item[id_id]) {
									mateRidx=k;
									mateDidx=x;
									break;
								}
							}
						}
					}
					if(mateRidx==-1) {
						item[id_readstatus]='paired but mate is not shown';
					} else {
						item[id_readstatus]='paired';
						item[id_hasmate]=true;
						pairedReads[item[id_id]]=1;
						var mate=tkobj.data[mateRidx][mateDidx];
						var Li=i,Ri=mateRidx, L=item, R=mate;
						var Ls=item[id_strand], Rs=(((f>>5)&1)==1)?'<':'>';
						if(mateRidx==i) {
							// query/mate in same region
							if(mate[id_startcoord]<item[id_startcoord]) {
								// mate is ahead of query
								L=mate; R=item;
								Li=mateRidx; Ri=i;
								var tt=Rs; Rs=Ls; Ls=tt;
							}
						}
						item[id_struct]=[,,,,[
							[Li,L[id_startcoord],L[id_stopcoord],Ls,L[id_mismatches],L[id_readseq]],
							[Ri,R[id_startcoord],R[id_stopcoord],Rs,R[id_mismatches],R[id_readseq]]]];
					}
				}
			} else {
				// single
				item[id_readstatus]='single';
			}
			newarray.push(item);
		}
		Data.push(newarray);
	}
	for(i=stopRidx+1; i<this.regionLst.length; i++)
		Data.push(tkobj.data[i]);
	tkobj.data=Data;
} else if(isChiapet) {
	/* long-range data pre-processing...
	a new Data object will be made containing:
	- complete pairs in displayed region that are joined
	- singleton pets
	this Data object mimics original data object, enters following plotting scheme
	but the plotting coordinates must be recovered in decorCanvasHash[gf].data
	so that clicking on track canvas can find the item with no trouble
	*/
	Data = tkobj.data;
	var newdata = [];

	for(var i=0; i<startRidx; i++)
		newdata.push([]);

	/* "item" means the from-item
	"mate" means the to-item
	*/
	var usedItems={}; // key: "mate chr start stop", val: "item chr start stop"

	/* sorting must be enabled, though expensive
	because during panning, new data is appended to the .data
	and it won't draw anything if not sorted...
	*/
	for(i=startRidx; i<=stopRidx; i++)
		Data[i].sort(gfSort2);

	for(i=startRidx; i<=stopRidx; i++) {
		var itemchr=this.regionLst[i][0];
		newdata.push([]);
		for(var j=0; j<Data[i].length; j++) {
			var item = Data[i][j];

			/* skip items outside the view and to the left */
			if(i == startRidx) {
				if(item[id_stopcoord]<=startViewCoord) continue;
			}
			/* quit searching if outside the view and to the right */
			if(i == stopRidx) {
				if(item[id_startcoord]>=stopViewCoord) break;
			}

			/* skip items with incorrect name */
			if(item[id_name].indexOf(',')==-1) continue;
			var tmp=item[id_name].split(',');

			/* skip item if it has already been paired */
			var tmp3=itemchr+':'+item[id_startcoord]+'-'+item[id_stopcoord];
			if(tmp3 in usedItems && usedItems[tmp3]==tmp[0])
				continue;

			var score=tmp[1];

			var tmp2=this.genome.parseCoordinate(tmp[0]);
			if(tmp2==null) continue;
			var matechr = tmp2[0];
			var matestart = tmp2[1];
			var matestop = tmp2[2];

			var mateRegionidx=-1;
			if(matechr==itemchr && matestop<=this.regionLst[i][3]) {
				/* do nothing, item will be unpaired in this rare case
				when running gsv, the item at left side will have its mate at
				upstream outside of the region, such item shall be unpaired */
			} else {
				var distoncanvas = 0; // curb by distance on canvas
				for(var k=i; k<=stopRidx; k++) {
					// for each region, see if mate fits in
					if(distoncanvas>=this.hmSpan) break;
					if(this.regionLst[k][0]==matechr) {
						if(Math.max(this.regionLst[k][3],matestart) < Math.min(this.regionLst[k][4],matestop)) {
							mateRegionidx=k;
							usedItems[tmp[0]]=tmp3;
							break;
						}
					}
					// increment dist on canvas
					if(k==i) {
						var d=this.regionLst[i][4]-item[id_stopcoord];
						distoncanvas += this.entire.atbplevel? d*this.entire.bpwidth : d/this.regionLst[i][7];
					} else {
						distoncanvas += this.regionLst[k][5]+regionSpacing.width;
					}
				}
			}
			var newitem = [];
			if(mateRegionidx == -1) {
				// mate not found for this item
				if(!drawArc && !drawTriheatmap) {
					// save singleton for stack mode, but not arc or triheamap
				newitem[id_id] = item[id_id];
				newitem[id_startcoord] = item[id_startcoord];
				newitem[id_stopcoord] = item[id_stopcoord];
				newitem[id_name] = item[id_name];
				newitem[id_strand] = item[id_strand];
				newitem[id_hasmate]=false;
				newdata[i].push(newitem);
				//print2console(stopRidx+' '+matechr+' '+matestart+' '+matestop,1);
				}
			} else {
				var L=[],R=[];
				if(i < mateRegionidx) {
					// item and its mate in separate region
					L=[i,item[id_startcoord],item[id_stopcoord]];
					R=[mateRegionidx,matestart,matestop];
				} else {
					// in same region
					if(item[id_startcoord] > matestart) {
						R=[i,item[id_startcoord],item[id_stopcoord]];
						L=[i,matestart,matestop];
					} else {
						L=[i,item[id_startcoord],item[id_stopcoord]];
						R=[i,matestart,matestop];
					}
				}
				// i can never be bigger than mateRegionidx...
				newitem[id_id] = item[id_id];
				newitem[id_startcoord] = L[1];
				newitem[id_stopcoord] = R[2];
				newitem[id_name] = parseFloat(score);
				newitem[id_struct] = [0,0,0,0,[L,R]];
				newitem[id_hasmate] = true;
				newdata[i].push(newitem);
			}
		}
	}
	if(drawArc || drawTriheatmap) {
		Data2 = newdata;
	} else {
		Data2 = null;
		Data = newdata;
	}
	tkobj.data_chiapet = newdata; // attach for clicking on canvas
} else {
	Data = tkobj.data;
	Data2 = null;
}

/* convert item coord into box start/width 
only do for items within lws and rws
those fit in will have valid id_boxstart/id_boxwidth computed,
else they will be left undefined
serve as a way to quickly tell if to process this item later

in case of paired read or long-range interaction,
id_startcoord will be start of query,
id_stopcoord will be stop of mate,
must detect if query/mate are in *separate* regions
*/
var longrangemaxspan = 0; // for both arcs and triheatmap, to determine/curb canvas height
var xoffset = xoffset0;
if(isSam) {
	/* sam reads, use Data */
	for(var i=startRidx; i<=stopRidx; i++) {
		var r = this.regionLst[i];
		if(Data[i]==undefined) {
			xoffset+=r[5]+regionSpacing.width;
			continue;
		}
		var rstart = r[3]; // region start coord
		var rstop = r[4]; // region stop coord

		for(var j=0; j<Data[i].length; j++) {
			var item = Data[i][j];
			item[id_stackid] = undefined; // by default
			if(item[id_hasmate]) {
				/** query/mate might be in *separate* regions **/
				var istart=Math.max(item[id_startcoord],rstart);
				item[id_boxstart] = xoffset+(this.entire.atbplevel?((istart-rstart)*this.entire.bpwidth):((istart-rstart)/r[7]));
				var materid = item[id_struct][4][1][0];
				var x2 = xoffset;
				for(var k=i; k<Data.length; k++) {
					var rr = this.regionLst[k];
					if(k == materid) {
						var istop=Math.min(item[id_struct][4][1][2],rr[4]);
						item[id_boxwidth] = x2+(this.entire.atbplevel?((istop-rr[3])*this.entire.bpwidth):((istop-rr[3])/rr[7])) - item[id_boxstart];
						break;
					}
					x2 += rr[5]+regionSpacing.width;
				}
				// however, item stop coord might be beyond this region, so just skip it?
			} else {
				// singleton,
				var pos=itemcoord2plotbox(item[id_startcoord],item[id_stopcoord],rstart,rstop,r[5]);
				item[id_boxstart] = xoffset+pos[0];
				item[id_boxwidth] = pos[1];
			}
		}
		xoffset += r[5]+regionSpacing.width;
	}
} else if(drawArc || drawTriheatmap) {
	/* long-range data,
	do it for Data2, set longrangemaxspan here */
	for(var i=startRidx; i<=stopRidx; i++) {
		var r = this.regionLst[i];
		var rstart = r[3]; // region start coord
		var rstop = r[4]; // region stop coord

		for(var j=0; j<Data2[i].length; j++) {
			var item = Data2[i][j];
			item[id_stackid] = undefined; // by default
			if(item[id_hasmate]) {
				/** item's mate might be in *separate* regions **/
				var istart=Math.max(item[id_startcoord],rstart);
				item[id_boxstart] = xoffset+(this.entire.atbplevel?((istart-rstart)*this.entire.bpwidth):((istart-rstart)/r[7]));
				var materid = item[id_struct][4][1][0];
				var x2 = xoffset;
				for(var k=i; k<=stopRidx; k++) {
					var rr = this.regionLst[k];
					if(k == materid) {
						var istop=Math.min(item[id_stopcoord],rr[4]);
						item[id_boxwidth] = x2+(this.entire.atbplevel?((istop-rr[3])*this.entire.bpwidth):((istop-rr[3])/rr[7])) - item[id_boxstart];
						/* dirty filter, to restrict track height */
						if(item[id_boxwidth]>this.hmSpan) item[id_boxstart]=item[id_boxwidth]=undefined;
						break;
					}
					x2 += rr[5]+regionSpacing.width;
				}
				// however, item stop coord might be beyond this region, so just skip it?
			} else {
				var pos=(item[id_startcoord],item[id_stopcoord],rstart,rstop,r[5]);
				item[id_boxstart] = xoffset+pos[0];
				item[id_boxwidth] = pos[1];
			}
			if(item[id_boxwidth] != undefined)
				longrangemaxspan=Math.max(longrangemaxspan, item[id_boxwidth]);
		}
		xoffset += r[5]+regionSpacing.width;
	}
} else {
	/* stack-style for regular bed or longrange items */
	for(var i=startRidx; i<=stopRidx; i++) {
		var r = this.regionLst[i];
		var rstart = r[3]; // region start coord
		var rstop = r[4]; // region stop coord

		for(var j=0; j<Data[i].length; j++) {
			var item = Data[i][j];
			item[id_stackid] = undefined; // by default
			if(isChiapet && item[id_hasmate]) {
				// assume start point must be in this region? check using item start
				item[id_boxstart] = xoffset+(this.entire.atbplevel?((Math.max(item[id_startcoord],rstart)-rstart)*this.entire.bpwidth):((Math.max(item[id_startcoord],rstart)-rstart)/r[7]));
				/** mate might be in *separate* regions **/
				var materid = item[id_struct][4][1][0];
				var rr = this.regionLst[materid];
				if(item[id_stopcoord]>=rr[3] && item[id_stopcoord]<=rr[4]) {
					var x2 = xoffset;
					for(var k=i; k<materid; k++) {
						x2 += this.regionLst[k][5]+regionSpacing.width;
					}
					item[id_boxwidth] = x2+(this.entire.atbplevel?((item[id_stopcoord]-rr[3])*this.entire.bpwidth):((item[id_stopcoord]-rr[3])/rr[7])) - item[id_boxstart];
				}
			} else {
				var pos=itemcoord2plotbox(item[id_startcoord],item[id_stopcoord],rstart,rstop,r[5]);
				item[id_boxstart] = xoffset+pos[0];
				item[id_boxwidth] = pos[1];
			}
		}
		xoffset += r[5]+regionSpacing.width;
	}
}

// for measuring name width during stacking
var isThin = tkobj.mode==M_thin;
var stackHeight = isThin ? thinStackHeight : fullStackHeight;

if(drawArc || drawTriheatmap) {
	if(drawArc && longrangemaxspan>0) {
		canvas.height = Math.max(10, longrangemaxspan*((1/Math.SQRT2) - 0.5)+2+yoffset);
	} else if(drawTriheatmap && longrangemaxspan>0) {
		canvas.height = Math.min(this.hmSpan/2, parseInt(longrangemaxspan*Math.tan(Math.PI*tkobj.qtc.anglescale/4)/2)+2+yoffset);
	} else {
		canvas.height = 10;
	}
} else {
	/*** stacking
	in thin mode, allow items sit right next to each other in one stack
	in full mode, there must be 1px spacing between items in same stack
	for each region between left/right wing:
	for each bed item:
		define stack start/width by full/thin, if item has name, name width, ...
		try stacking item
		if successfully stacked:
			set stack id
		else:
			left stack id unspecified
	don't cap number of items plotted in JS, that's capped in C
	TODO bam reads must be capped in C, so that excessive data won't be passed to client
	***/
	ctx.font = (tkobj.qtc.fontbold?'bold':'')+' '+tkobj.qtc.fontsize+' '+tkobj.qtc.fontfamily;
	/* to properly set canvas height,
	need to count max stack # within [dspBoundary.vstarts, dspBoundary.vstops]
	but need to know pixel position of .vstarts and .vstops
	*/
	var viewstart_px=-this.move.styleLeft;
	var viewstop_px=viewstart_px+this.hmSpan;
	var maxstack=0;
	var stack = [-1000];
	xoffset = xoffset0;
	for(i=startRidx; i<=stopRidx; i++) {
		if(Data[i]==undefined) {
			xoffset += this.regionLst[i][5]+regionSpacing.width;
			continue;
		}
		Data[i].sort(gfSort);
		for(var j=0; j<Data[i].length; j++) {
			var item = Data[i][j];
			if(item[id_boxstart]==undefined) // filtered by score
				continue;
			item[id_stackid] = undefined; // by default
			// make stack start/width for stacking
			var k = 0; // stack id iterator
			if(isThin) { // thin
				item[id_stackstart] = item[id_boxstart];
				item[id_stackwidth] = item[id_boxwidth];
				while(stack[k] > item[id_stackstart]) {
					k++;
					//if(k == stackNumberLimit) break;
					if(k == stack.length) stack.push(-1000);
				}
			} else { // full
				if(item[id_name]==undefined && item[id_name2]==undefined) { // no name
					item[id_stackstart] = item[id_boxstart];
					item[id_stackwidth] = item[id_boxwidth];
				} else {
					// increase name width by 1, do same for plotting
					item[id_namewidth] = ctx.measureText(item[id_name2]==undefined?item[id_name]:item[id_name2]).width+1; 
					if(item[id_struct] != undefined) {
						// has structure, name is outside box
						item[id_stackstart] = item[id_boxstart] - item[id_namewidth];
						item[id_stackwidth] = item[id_boxwidth] + item[id_namewidth];
					} else {
						if(item[id_namewidth] < item[id_boxwidth]) {
							item[id_stackstart] = item[id_boxstart];
							item[id_stackwidth] = item[id_boxwidth];
						} else {
							item[id_stackstart] = item[id_boxstart] - item[id_namewidth];
							item[id_stackwidth] = item[id_boxwidth] + item[id_namewidth];
						}
					}
				}
				// need items in same stack to have one pixel spacing,
				while(stack[k]+1 > item[id_stackstart]) {
					k++;
					//if(k == stackNumberLimit) break;
					// big negative value help process items with 0 or negative box start
					if(k == stack.length) stack.push(-10000);
				}
			}
			// this item is stacked
			stack[k] = item[id_stackstart]+item[id_stackwidth];
			item[id_stackid] = k;
			if(Math.max(viewstart_px, item[id_boxstart]) < Math.min(viewstop_px, item[id_boxstart]+item[id_boxwidth])) {
				if(maxstack < k) maxstack = k;
			}
		}
		xoffset += this.regionLst[i][5]+regionSpacing.width;
	}
	canvas.height = (stackHeight+1) * (maxstack+1) + yoffset;
	if(canvas.height < 10)
		canvas.height = 10;
	// need to set font again as canvas height has been changed
	ctx.font = (tkobj.qtc.fontbold?'bold':'')+' '+tkobj.qtc.fontsize+' '+tkobj.qtc.fontfamily;
}



/** canvas dimension is set **/
// draw top border line
ctx.fillStyle=colorCentral.foreground_faint_1;
ctx.fillRect(0,0,canvas.width,1);

/* add alternating background color for regions 
to distinguish regions
only do this if isn't in genome mode
*/
if(juxType!=RM_genome) {
	//ctx.fillStyle = "transparent"; ctx.fillRect(0, 0, canvas.width, canvas.height);
	xoffset = 0;
	ctx.fillStyle = colorCentral.background;
	for(i=0; i<this.regionLst.length; i++) {
		if(i % 2)
			ctx.fillRect(xoffset, 0, this.regionLst[i][5], canvas.height);
		xoffset += this.regionLst[i][5] + regionSpacing.width;
	}
}


/*******   plot   *******/
var svgdata=[];

var pcolor_original = isChiapet ? tkobj.qtc.pcolor : null;
var pcolorlst = isChiapet ? colorstr2int(pcolor_original).join(',') : null;
var ncolor_original = isChiapet ? tkobj.qtc.ncolor : null;
var ncolorlst = isChiapet ? colorstr2int(ncolor_original).join(',') : null;
var pcolorscore = isChiapet ? tkobj.qtc.pcolorscore : null;
var ncolorscore = isChiapet ? tkobj.qtc.ncolorscore : null;
/* in case of longrange track,
the color scale can be either auto-scale or fixed scale
*/
if(isChiapet && tkobj.qtc.thtype==0) {
	var _data;
	if(drawArc || drawTriheatmap) {
		_data=Data2;
	} else {
		_data=Data;
	}
	var s_max=s_min=0;
	for(i=startRidx; i<=stopRidx; i++) {
		for(var j=0; j<_data[i].length; j++) {
			var item = _data[i][j];
			if(item[id_struct]==undefined || item[id_boxstart]==undefined || item[id_boxwidth]==undefined) continue;
			var s=item[id_name];
			if(s>0 && s>s_max) s_max=s;
			else if(s<0 && s<s_min) s_min=s;
		}
	}
	pcolorscore=tkobj.qtc.pcolorscore=s_max;
	ncolorscore=tkobj.qtc.ncolorscore=s_min;
}
var bedcolor,textcolor;
// in case of drawing trihm in main panel, will measure highest dome within dsp to set track height
var canvasstart=0-this.move.styleLeft;
var canvasstop=canvasstart+this.hmSpan;
var trihmmaxh=0;
if(drawArc) {
	/*************
		  arc - long range
	 *************/
	var arcdata = [];
	/* store arc data for clicking on canvas
	each ele is for one arc/pair:
	[center x, center y, radius, region idx, array idx]
	canvas yoffset must be subtracted
	*/
	for(i=startRidx; i<=stopRidx; i++) {
		for(var j=0; j<Data2[i].length; j++) {
			var item = Data2[i][j];
			if(item[id_struct]==undefined || item[id_boxstart]==undefined || item[id_boxwidth]==undefined)
				continue;
			var thisscore = item[id_name];
			if(thisscore >= 0) {
				if(thisscore >= pcolorscore )
					bedcolor = pcolor_original;
				else
					bedcolor = 'rgba('+pcolorlst+','+(thisscore/pcolorscore).toFixed(2)+')';
			} else {
				if(thisscore <= ncolorscore)
					bedcolor = ncolor_original;
				else
					bedcolor = 'rgba('+ncolorlst+','+(thisscore/ncolorscore).toFixed(2)+')';
			}

			/* find item plot width, repetitive with trihm
			FIXME not perfect: leftw/rightw smaller one determines arc width
			*/
			var _w;
				{
				var e = item[id_struct][4][0];
				var _r=this.regionLst[e[0]];
				var pos=itemcoord2plotbox(e[1],e[2],_r[3],_r[4],_r[5]);
				if(pos[1] == -1) continue;
				var leftw = Math.max(pos[1],2);
				e = item[id_struct][4][1];
				_r=this.regionLst[e[0]];
				pos=itemcoord2plotbox(e[1],e[2],_r[3],_r[4],_r[5]);
				if(pos[1] == -1) continue;
				var rightw = Math.max(pos[1],2);
				//_w=Math.min(leftw,rightw);
				_w=Math.min(leftw,rightw)*.7;
				}

			var centerx = item[id_boxstart]+item[id_boxwidth]/2;
			var centery = yoffset-item[id_boxwidth]/2;

			var arcwidth=1; // temporarily give up this feature
			var radius = Math.max(0,item[id_boxwidth]/Math.SQRT2-arcwidth/2);
			ctx.strokeStyle = bedcolor;
			ctx.lineWidth=arcwidth;
			ctx.beginPath();
			ctx.arc(centerx, centery, radius, 0.25*Math.PI, 0.75*Math.PI, false);
			ctx.stroke();
			arcdata.push([centerx, centery, radius, i, j, arcwidth]);
			if(tosvg)
				svgdata.push([radius,item[id_boxstart],item[id_boxstart]+item[id_boxwidth], bedcolor, arcwidth]);
		}
	}
	tkobj.data_arc = arcdata;
} else if(drawTriheatmap) {
	/*************
	   triangular heatmap - long range
	 *************/
	// canvas yoffset must be subtracted
	var hmdata = []; // for mouse click detection
	for(i=startRidx; i<=stopRidx; i++) {
		for(var j=0; j<Data2[i].length; j++) {
			var item = Data2[i][j];
			if(item[id_struct]==undefined || item[id_boxstart]==undefined || item[id_boxwidth]==undefined) continue;
			if(item[id_boxstart]<0) {
				continue;
			}
			if(item[id_boxwidth]>=this.hmSpan*2) {
				/*** if the loci spans over 2 hmspan on canvas, skip
				***/
				continue;
			}
			
			/* horizontal width of two mates
			the width is used as horizontal side of a isosceles
			*/
			// mate on left
			var e = item[id_struct][4][0];
			var _r=this.regionLst[e[0]];
			var pos=itemcoord2plotbox(e[1],e[2],_r[3],_r[4],_r[5]);
			if(pos[1] == -1) continue;
			var leftw = Math.max(pos[1],2);
			// mate on right
			e = item[id_struct][4][1];
			_r=this.regionLst[e[0]];
			pos=itemcoord2plotbox(e[1],e[2],_r[3],_r[4],_r[5]);
			if(pos[1] == -1) continue;
			var rightw = Math.max(pos[1],2);

			/* both items are valid */

			var thisscore = item[id_name];
			if(thisscore >= 0) {
				if(thisscore >= pcolorscore )
					bedcolor = pcolor_original;
				else
					bedcolor = 'rgba('+pcolorlst+','+(thisscore/pcolorscore).toFixed(2)+')';
			} else {
				if(thisscore <= ncolorscore)
					bedcolor = ncolor_original;
				else
					bedcolor = 'rgba('+ncolorlst+','+(thisscore/ncolorscore).toFixed(2)+')';
			}

			// top corner point position
			var _tan=Math.tan(tkobj.qtc.anglescale*Math.PI/4);
			var top_x = item[id_boxstart]+item[id_boxwidth]/2;
			var top_y = yoffset+item[id_boxwidth]*_tan/2;
			ctx.fillStyle = bedcolor;
			ctx.beginPath();
			/*		p3
				p4		p2
					p1
			*/
			ctx.moveTo(top_x,top_y); // p1
			ctx.lineTo(top_x+leftw/2, top_y-leftw*_tan/2); // p2
			ctx.lineTo(top_x+leftw/2-rightw/2, top_y-leftw*_tan/2-rightw*_tan/2); // p3
			ctx.lineTo(top_x-rightw/2, top_y-rightw*_tan/2); // p4
			ctx.closePath();
			ctx.fill();
			hmdata.push([top_x, top_y, leftw, rightw, i, j]);
			if(top_x>=canvasstart && top_x<=canvasstop && trihmmaxh<top_y)
				trihmmaxh=top_y;
			if(tosvg)
				svgdata.push([[top_x,top_y], // p1
					[top_x+leftw/2,top_y-leftw*_tan/2], // p2
					[top_x+leftw/2-rightw/2, top_y-leftw*_tan/2-rightw*_tan/2], // p3
					[top_x-rightw/2,top_y-rightw*_tan/2], // p4
					bedcolor]);
		}
	}
	tkobj.data_trihm = hmdata;
	gflag.trihmmaxh=trihmmaxh; // for ??
} else {
	/*************
		stack - sam and bed
	 *************/
	xoffset = xoffset0;
	var originaltextcolor = tkobj.qtc.textcolor;
	var textcolorlst = colorstr2int(originaltextcolor).join(',');
	var originalbedcolor = isChiapet ? null : (isSam ? null : tkobj.qtc.bedcolor);
	var fcolor = isSam ? tkobj.qtc.forwardcolor : null;
	var rcolor = isSam ? tkobj.qtc.reversecolor : null;
	var mcolor = isSam ? tkobj.qtc.mismatchcolor : null;
	for(i=startRidx; i<=stopRidx; i++) {
		var r = this.regionLst[i];
		if(Data[i]==undefined) {
			xoffset += r[5]+regionSpacing.width;
			continue;
		}
		var regionstart = r[3];
		var regionstop = r[4];

		for(var j=0; j<Data[i].length; j++) {
			if(Data[i][j][id_stackid] == undefined)
				continue;
			var item = Data[i][j];

			// plotting will be curbed by start/stop of both item and region
			var curbstart = Math.max(regionstart, item[id_startcoord]);
			var curbstop = Math.min(regionstop, item[id_stopcoord]);

			var y = item[id_stackid]*(stackHeight+1) + yoffset;

			// plot box
			if(isSam) {
				/**************
					sam read 
				 **************/
				if(item[id_hasmate]) {
					/** paired read **/
					var rd1=item[id_struct][4][0];
					var rd2=item[id_struct][4][1];
					// plot width of each read
					var _r=this.regionLst[rd1[0]];
					var pos=itemcoord2plotbox(rd1[1],rd1[2],_r[3],_r[4],_r[5]);
					if(pos[1]==-1) continue;
					var r1width=pos[1];
					_r=this.regionLst[rd2[0]];
					pos=itemcoord2plotbox(rd2[1],rd2[2],_r[3],_r[4],_r[5]);
					if(pos[1]==-1) continue;
					var r2width=pos[1];
					// plot read 1
					ctx.fillStyle = rd1[3]=='>' ? fcolor : rcolor;
					ctx.fillRect(item[id_boxstart], y, Math.ceil(r1width), stackHeight);
					if(tosvg)
						svgdata.push([1,item[id_boxstart],y,Math.ceil(r1width),stackHeight, ctx.fillStyle]);
					// plot read 2
					ctx.fillStyle = rd2[3]=='>' ? fcolor : rcolor;
					ctx.fillRect(item[id_boxstart]+item[id_boxwidth]-r2width,
						y, Math.ceil(r2width), stackHeight);
					if(tosvg)
						svgdata.push([1,item[id_boxstart]+item[id_boxwidth]-r2width,y,Math.ceil(r2width),stackHeight, ctx.fillStyle]);
					// line joining the pair
					ctx.lineWidth = 1;
					ctx.strokeStyle = GRAY;
					ctx.beginPath();
					var y2 = isThin ? y+.5 : y+4.5;
					ctx.moveTo(item[id_boxstart]+r1width, y2);
					ctx.lineTo(item[id_boxstart]+item[id_boxwidth]-r2width, y2);
					ctx.stroke();
					if(tosvg) svgdata.push([1,item[id_boxstart]+r1width,y2,item[id_boxwidth]-r2width-r1width,1,GRAY]);
					// mismatch of both reads
					var tmplst=plotReadmismatch(ctx, rd1[4], rd1[2]-rd1[1], rd1[5], item[id_boxstart], y, r1width, stackHeight, isThin, mcolor, tosvg);
					if(tosvg) svgdata=svgdata.concat(tmplst);
					tmplst=plotReadmismatch(ctx, rd2[4], rd2[2]-rd2[1], rd2[5], item[id_boxstart]+item[id_boxwidth]-r2width, y, r2width, stackHeight, isThin, mcolor, tosvg);
					if(tosvg) svgdata=svgdata.concat(tmplst);
					continue;
				}
				/** single read **/
				ctx.fillStyle = item[id_strand]=='>' ? fcolor : rcolor;
				ctx.fillRect(item[id_boxstart], y, item[id_boxwidth], stackHeight);
				if(tosvg) svgdata.push([1,item[id_boxstart],y,item[id_boxwidth],stackHeight,ctx.fillStyle]);
				tmplst=plotReadmismatch(ctx, item[id_mismatches], item[id_stopcoord]-item[id_startcoord], item[id_readseq], item[id_boxstart], y, item[id_boxwidth], stackHeight, isThin, mcolor, tosvg);
				if(tosvg) svgdata=svgdata.concat(tmplst);
				continue;
			}

			// following deals bigBed/long-range track item plotting
			/* svg output [type, content]
			type 1: box or horizontal line
			type 2: text
			type 3: 3-point path to define 
			*/

			if(isChiapet) {
				/* using score only works for chiapet,
				TODO make generic for all bed tracks
				not for generic bigbed items
				if has mate, name is score
				else, name is coord plus score, joined by comma
				*/
				var thisscore = (item[id_struct]==undefined) ? parseFloat(item[id_name].split(',')[1]) : item[id_name];
				if(thisscore >= 0) {
					if(thisscore >= pcolorscore) {
						bedcolor = pcolor_original;
						textcolor = originaltextcolor;
					} else {
						var alpha = (thisscore/pcolorscore).toFixed(2);
						bedcolor = 'rgba('+pcolorlst+','+alpha+')';
						textcolor = 'rgba('+textcolorlst+','+alpha+')';
					}
				} else {
					if(thisscore <= ncolorscore) {
						bedcolor = ncolor_original;
						textcolor = originaltextcolor;
					} else {
						var alpha = (thisscore/ncolorscore).toFixed(2);
						bedcolor = 'rgba('+ncolorlst+','+alpha+')';
						textcolor = 'rgba('+textcolorlst+','+alpha+')';
					}
				}
			} else {
				bedcolor = originalbedcolor;
				textcolor = originaltextcolor;
			}

			if(isThin) {
				/***  plot thin feature and done ***/
				ctx.fillStyle = bedcolor;
				ctx.fillRect(item[id_boxstart], y, item[id_boxwidth], stackHeight);
				if(tosvg) svgdata.push([1,item[id_boxstart],y,item[id_boxwidth],stackHeight,bedcolor]);
				continue;
			}

			/* full mode */

			if(item[id_struct] == undefined) {
				/*****  full, no structure  *******/
				// plot box
				ctx.fillStyle = bedcolor;
				ctx.fillRect(item[id_boxstart], y, item[id_boxwidth], stackHeight);
				if(tosvg) svgdata.push([1,item[id_boxstart],y,item[id_boxwidth],stackHeight,bedcolor]);

				if(item[id_name2]!=undefined || item[id_name]!=undefined) { // with name
					if(item[id_namewidth] < item[id_boxwidth]) { // name goes into box
						ctx.fillStyle = colorCentral.background;
						ctx.fillText(item[id_name2]==undefined?item[id_name]:item[id_name2],
						item[id_boxstart]+(item[id_boxwidth]-item[id_namewidth])/2,
						y+8);
						if(tosvg) svgdata.push([2,
							item[id_boxstart]+(item[id_boxwidth]-item[id_namewidth])/2,
						y+8,item[id_name2]==undefined?item[id_name]:item[id_name2],
						colorCentral.background]);
						if(item[id_strand]!=undefined && item[id_strand]!='.') { // has strand
						ctx.strokeStyle = colorCentral.background;
						var thisw = (item[id_boxwidth]-item[id_namewidth])/2 - 4 - instack_arrowspacing*2;
						var tmplst=decoritem_strokeStrandarrow(ctx, item[id_strand], item[id_boxstart]+2, thisw, y, stackHeight, colorCentral.background, tosvg);
						if(tosvg) svgdata=svgdata.concat(tmplst);
						tmplst=decoritem_strokeStrandarrow(ctx, item[id_strand], 
							item[id_boxstart]+item[id_boxwidth]-2-thisw,
							thisw, y, stackHeight, colorCentral.background, tosvg);
						if(tosvg) svgdata=svgdata.concat(tmplst);
						}
					} else { // name won't go into box, see if enough space on left of box
						ctx.fillStyle = textcolor;
						ctx.fillText(item[id_name2]==undefined?item[id_name]:item[id_name2], item[id_boxstart]-item[id_namewidth], y+8);
						if(tosvg) svgdata.push([2,item[id_boxstart]-item[id_namewidth],y+8,
							item[id_name2]==undefined?item[id_name]:item[id_name2],textcolor]);
						if(item[id_strand]!=undefined && item[id_strand]!='.') { // strand in box
						ctx.strokeStyle = colorCentral.background;
						var tmplst=decoritem_strokeStrandarrow(ctx, item[id_strand], item[id_boxstart]+2, item[id_boxwidth]-4, y, stackHeight, colorCentral.background, tosvg);
						if(tosvg) svgdata=svgdata.concat(tmplst);
						}
					}
				} else { // no name
					if(item[id_strand]!=undefined && item[id_strand]!='.') { // strand in box
						ctx.strokeStyle = colorCentral.background;
						var tmplst=decoritem_strokeStrandarrow(ctx, item[id_strand], item[id_boxstart]+2, item[id_boxwidth]-4, y, stackHeight, colorCentral.background, tosvg);
						if(tosvg) svgdata=svgdata.concat(tmplst);
					}
				}
				continue;
			}
			/* full, has structure
			name is always on the left of the box
			both gene and chiapet pair will have the backbone line
			TODO this section might be separated out as a routine to draw gene structure
			*/
			var middleY = stackHeight/2+y;
			// name
			if(item[id_name2]!=undefined || item[id_name]!=undefined) { // with name
				ctx.fillStyle = textcolor;
				ctx.fillText(item[id_name2]==undefined?item[id_name]:item[id_name2], item[id_boxstart]-item[id_namewidth], y+8);
				if(tosvg) svgdata.push([2,item[id_boxstart]-item[id_namewidth],y+8,item[id_name2]==undefined?item[id_name]:item[id_name2],textcolor]);
			}
			if(isChiapet) {
				ctx.strokeStyle = bedcolor;
				ctx.beginPath();
				ctx.moveTo(item[id_boxstart], middleY);
				ctx.lineTo(item[id_boxstart]+item[id_boxwidth], middleY); // backbone
				ctx.stroke();
				if(tosvg) svgdata.push([1,item[id_boxstart],middleY-.5,item[id_boxwidth],1,bedcolor]);
				/*** chiapet mate pair plotting
				   awkward special case...
				   mate is sneaked in as exons, but it might be in different region
				   so cannot use exon plotting code
				   mate pairs are always at both ends of item, just plot them out directly
				 */
				// mate on left
				ctx.fillStyle=bedcolor;
				var exonlst = item[id_struct][4];
				var e = exonlst[0];
				var _r=this.regionLst[e[0]];
				var pos=itemcoord2plotbox(e[1],e[2],_r[3],_r[4],_r[5]);
				if(pos[1] != -1) {
					ctx.fillRect(item[id_boxstart], y, pos[1], stackHeight);
					if(tosvg) svgdata.push([1,item[id_boxstart],y,pos[1],stackHeight,bedcolor]);
				}
				// mate on right
				e = exonlst[1];
				_r=this.regionLst[e[0]];
				pos=itemcoord2plotbox(e[1], e[2], _r[3],_r[4],_r[5]);
				if(pos[1] != -1) {
					ctx.fillRect(item[id_boxstart]+item[id_boxwidth]-pos[1], y, pos[1], stackHeight);
					if(tosvg) svgdata.push([1,item[id_boxstart]+item[id_boxwidth]-pos[1], y, pos[1], stackHeight,bedcolor]);
				}
			} else {
				var _sd=plotGene(ctx,bedcolor,item[id_struct],item[id_strand],item[id_boxstart],y,item[id_boxwidth],stackHeight,Math.max(this.regionLst[i][3],item[id_startcoord]),Math.min(this.regionLst[i][4],item[id_stopcoord]),tosvg);
				if(tosvg) svgdata=svgdata.concat(_sd);
			}
		}
		xoffset += r[5]+regionSpacing.width;
	}
}



/* always redraw .atC
as the .atC height must be same as .canvas and it would be shown in ghm */
this.drawMcm_onetrack(tkobj);


if(tosvg) return svgdata;
/* over */
}

function plotGene(ctx,color,genedata,strand,x,y,w,h,startcoord,stopcoord,tosvg)
{
/* args:
ctx
color
genedata - an array from item[16], always contains complete structure
	thus must be constrained by the box coord
	[utr5start,utr5length,utr3start,utr3length,[[e1start,e1stop],[e2start,e2stop],...]]
	the utr length is used to tell whether the gene has that utr or not
strand - '>', '<'
x/y/w/h - defines the plot box
startcoord/stopcoord - the start/stop coordinate of the plot box
tosvg
*/
var svgdata=[];
// backbone and strand arrows
ctx.strokeStyle = color;
ctx.beginPath();
var y2=y+h/2;
ctx.moveTo(x,y2);
ctx.lineTo(x+w,y2);
ctx.stroke();
if(tosvg) svgdata.push([1,x,y2-.5,w,1,color]);
var tmplst=decoritem_strokeStrandarrow(ctx, strand, x, w, y, h, color, tosvg);
if(tosvg) svgdata=svgdata.concat(tmplst);
ctx.fillStyle = color;
// 5' UTR
var uL = genedata[1];
if(uL > 0) {
	var pos = itemcoord2plotbox(genedata[0],genedata[0]+uL, startcoord, stopcoord, w);
	if(pos[0] != -1) {
		ctx.fillRect(x+pos[0], y+instack_padding, pos[1], h-instack_padding*2);
		if(tosvg) svgdata.push([1,x+pos[0],y+instack_padding,pos[1],h-instack_padding*2,color]);
	}
}
// 3' utr
uL = genedata[3];
if(uL > 0) {
	var pos = itemcoord2plotbox(genedata[2],genedata[2]+uL, startcoord, stopcoord, w);
	if(pos[0] != -1) {
		ctx.fillRect(x+pos[0], y+instack_padding, pos[1], h-instack_padding*2);
		if(tosvg) svgdata.push([1,x+pos[0], y+instack_padding, pos[1], h-instack_padding*2,color]);
	}
}
var exonlst = genedata[4];
// exons
for(var k=0; k<exonlst.length; k++) {
	var pos = itemcoord2plotbox(exonlst[k][0], exonlst[k][1], startcoord, stopcoord, w);
	if(pos[0] != -1) {
		ctx.fillRect(x+pos[0], y, pos[1], h);
		if(tosvg) svgdata.push([1,x+pos[0], y, pos[1], h, color]);
		ctx.strokeStyle = colorCentral.background;
		var tmplst=decoritem_strokeStrandarrow(ctx, strand, x+pos[0]+2, pos[1]-4, y, h, colorCentral.background, tosvg);
		if(tosvg) svgdata=svgdata.concat(tmplst);
	}
}
if(tosvg) return svgdata;
}

function itemcoord2plotbox(itemstart,itemstop,boxstart,boxstop,boxpw)
{
/*
itemstart/itemstop: coord of item
boxstart/boxstop: coord of box
boxwidth: plot width of box
returns [xpos, plotwidth] in pixel
*/
if(itemstart>=boxstop || itemstop<=boxstart) return [-1,-1];
var sf=boxpw/(boxstop-boxstart); // px per bp
var _start=Math.max(itemstart,boxstart);
return [(_start-boxstart)*sf, Math.ceil((Math.min(itemstop,boxstop)-_start)*sf)];
}


function gfSort(a,b)
{
/* for genomic feature items in decor drawing
using on-canvas coord
item boxstart/boxwidth could be undefined
*/
if(a[0] == undefined) {
	if(b[0] == undefined)
	return 0;
else
	return -1;
}
if(b[0] == undefined)
	return 1;
if(a[0] != b[0]) {
	return a[0]-b[0];
} else if(a[1] != b[1]) {
	return b[1]-a[1];
}
return 0;
}

function decoritem_strokeStrandarrow(ctx, strand, x, w, y, h, color, tosvg)
{
/* only for items in full decor track?
must already set strokeStyle
args:
ctx: 2d context, all path must already been closed
strand: '>' '<'
x: absolute x start on canvas
w: width to plot with
y: absolute y start
color: string, only to be used in svg output
tosvg: boolean
*/
if(w < instack_arrowwidth) return [];
var thisx = 0;
var num = 0;
while(thisx+instack_arrowwidth <= w) {
	thisx += instack_arrowwidth+instack_arrowspacing;
	num++;
}
if(num == 0) return [];
thisx = (w-instack_arrowwidth*num-instack_arrowspacing*(num-1))/2;
ctx.beginPath();
var svgdata=[];
for(var i=0; i<num; i++) {
	if(strand == '>') {
		ctx.moveTo(x+thisx, y+instack_padding);
		ctx.lineTo(x+thisx+instack_arrowwidth, y+h/2);
		ctx.lineTo(x+thisx, y+h-instack_padding);
		if(tosvg) svgdata.push([3,[x+thisx, y+instack_padding],[x+thisx+instack_arrowwidth, y+h/2],[x+thisx, y+h-instack_padding], color]);
	} else {
		ctx.moveTo(x+thisx+instack_arrowwidth, y+instack_padding);
		ctx.lineTo(x+thisx, y+h/2);
		ctx.lineTo(x+thisx+instack_arrowwidth, y+h-instack_padding);
		if(tosvg) svgdata.push([3,[x+thisx+instack_arrowwidth, y+instack_padding],[x+thisx, y+h/2],[x+thisx+instack_arrowwidth, y+h-instack_padding],color]);
	}
	thisx += instack_arrowwidth+instack_arrowspacing;
}
// don't do closePath or will mess up
ctx.stroke();
if(tosvg) return svgdata;
}

function toggle20(event) {
// show/hide children decors by clicking on button
	var hook = event.target;
	var bait = event.target.parentNode.parentNode.nextSibling;
	if(bait.style.display == "none") {
		bait.style.display = "table-row";
		//hook.className = "shortcutbutMD";
		hook.style.transform=
		hook.style.mozTransform=
		hook.style.webkitTransform='rotate(-90deg)';
	} else {
		bait.style.display = "none";
		//hook.className = "shortcutbut";
		hook.style.transform=
		hook.style.mozTransform=
		hook.style.webkitTransform='rotate(90deg)';
	}
}
function mdterm_requesttooltip(event) {
// by clicking (i) for a leaf metadata term, pop up tooltip
	//mdterm_showtooltip(event.target.getAttribute('termidx'), event.clientX, event.clientY);
}



function cpmoveMD(event)
{
/* generic moving panel */
if(event.button != 0) return;
var tab = event.target;
while(tab.getAttribute('holderid')==null) tab=tab.parentNode;
event.preventDefault();
gflag.cpmove.dom = document.getElementById(tab.getAttribute('holderid'));
gflag.cpmove.oldx = event.clientX;
gflag.cpmove.oldy = event.clientY;
document.body.addEventListener('mousemove', cpmoveM, false);
document.body.addEventListener('mouseup', cpmoveMU, false);
}
function cpmoveM(event)
{
var d = gflag.cpmove.dom;
d.style.left = parseInt(d.style.left) + event.clientX - gflag.cpmove.oldx;
d.style.top = parseInt(d.style.top) + event.clientY - gflag.cpmove.oldy;
gflag.cpmove.oldx = event.clientX;
gflag.cpmove.oldy = event.clientY;
}
function cpmoveMU(event)
{
gflag.cpmove.dom = null;
document.body.removeEventListener('mousemove', cpmoveM, false);
document.body.removeEventListener('mouseup', cpmoveMU, false);
}
function placeIndicator3(x,y,w,h) {
// place indicator3 at a place (x,y) with resizing (w,h)
	indicator3.style.left = x;
	indicator3.style.top = y;
	var d = indicator3.firstChild;
	d.style.width = w;
	d.style.height = h;
	var dd = d.firstChild;
	dd.style.width = w;
	dd.style.height = h;
	dd = d.childNodes[1];
	dd.style.width = w;
	dd.style.height = h;
	dd = d.childNodes[2];
	dd.style.width = w;
	dd.style.height = h;
	dd = d.childNodes[3];
	dd.style.width = w;
	dd.style.height = h;
	indicator3.style.display = "block";
}

Browser.prototype.getTrackdetail=function(tkname)
{
gflag.hmtkunderfocus = tkname;
this.ajax("tkname="+tkname+'&dbName='+this.genome.name+"&gettrackdetails=on", function(data) {
menu.tkdetailwrapper.style.display = "block";
var trlst = [];
trlst[0] = document.getElementById('hmtkdetailtr_general');
trlst[0].style.display = 'table-row';
trlst[1] = document.getElementById('hmtkdetailtr_processing');
trlst[1].style.display = 'none';
trlst[2] = document.getElementById('hmtkdetailtr_other');
trlst[2].style.display = 'none';
trlst[3] = document.getElementById('hmtkdetailtr_geo');
trlst[3].style.display = 'none';
trlst[4] = document.getElementById('hmtkdetailtr_bam');
trlst[4].style.display = 'none';

// 0 general
var holder = trlst[0].firstChild;
stripChild(holder, 0);
trackInfo_filluptable(holder, data.general);

// 1 processing
holder = trlst[1].firstChild;
stripChild(holder, 0);
trackInfo_filluptable(holder, data.processing);

// 2 other version
holder = trlst[2].firstChild;
stripChild(holder, 0);
if(data.other.length > 1) {
	var div = document.createElement('div');
	var table = document.createElement('table');
	table.cellSpacing=1;
	var color = "#f2f2f2";
	for(var i=0; i<data.other.length; i++) {
		var thisitem = data.other[i];
	if(thisitem[0] == gflag.hmtkunderfocus) continue;
	var tr = table.insertRow(-1);
	color = color=="white" ? "#f2f2f2" : "white";
	tr.style.backgroundColor = color;
	tr.insertCell(0).innerHTML = thisitem[2]+'<div style="color:#858585;">'+thisitem[1]+'</div>';
	var td = tr.insertCell(1);
	td.vAlign = 'middle';
	td.innerHTML = '<button onclick=hmtk_mightAddOne("'+thisitem[0]+'")>use</button>';
	}
	div.appendChild(table);
	div.style.width = 320;
	holder.appendChild(div);
	if(table.clientHeight > 200) {
	div.style.height = 200;
	div.style.overflowY = 'scroll';
	} else {
	div.style.height = 'auto';
	div.style.overflowY = 'auto';
	}
	div.style.overflowX = table.clientWidth>320 ? 'scroll' : 'auto';
} else {
	var s = document.createElement('span');
	s.innerHTML = "This track doesn't have other versions";
	holder.appendChild(s);
}

// 3 geo
holder = trlst[3].firstChild;
stripChild(holder, 0);
if(data.geo == 'NULL') {
	var s = document.createElement('span');
	s.innerHTML = "This track is not associated with a<br>GEO accession number";
	holder.appendChild(s);
} else {
	var div = document.createElement('div');
	div.style.textAlign = 'center';
	div.innerHTML = '';
	var lst = data.geo.split(',');
	for(var i=0; i<lst.length; i++)
		div.innerHTML += '<button onclick="window.open(\'http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc='+lst[i]+'\')"><img src=/browser/images/geo.png style="vertical-align:-5px;"> '+lst[i]+'</button><br>';
	div.innerHTML += '<br><span style="color:#858585;">click to view details in GEO database</span>';
	holder.appendChild(div);
}

// 4 bam
holder = trlst[4].firstChild;
stripChild(holder, 0);
if(data.bam.length == 0) {
	var s = document.createElement('span');
	s.innerHTML = "This track doesn't have read alignment data";
	holder.appendChild(s);
} else {
	var div = document.createElement('div');
	var table = document.createElement('table');
	table.cellSpacing=1;
	var color = "#f2f2f2";
	for(var i=0; i<data.bam.length; i++) {
		var thisitem = data.bam[i];
	var tr = table.insertRow(-1);
	color = color=="white" ? "#f2f2f2" : "white";
	tr.style.backgroundColor = color;
	tr.insertCell(0).innerHTML = thisitem[1];
	tr.insertCell(1).innerHTML = '<button tkname='+thisitem[0]+' onclick=ajaxAddOneServerbam(event)>show</button>';
	}
	div.appendChild(table);
	div.style.width = 320;
	holder.appendChild(div);
	if(table.clientHeight > 200) {
	div.style.height = 200;
	div.style.overflowY = 'scroll';
	} else {
	div.style.height = 'auto';
	div.style.overflowY = 'auto';
	}
	div.style.overflowX = table.clientWidth>320 ? 'scroll' : 'auto';
}
});
}
function hmtkdetailheader_click(event) {
	document.getElementById('hmtkdetailtr_general').style.display = 'none';
	document.getElementById('hmtkdetailtr_processing').style.display = 'none';
	document.getElementById('hmtkdetailtr_other').style.display = 'none';
	document.getElementById('hmtkdetailtr_geo').style.display = 'none';
	document.getElementById('hmtkdetailtr_bam').style.display = 'none';
	document.getElementById('hmtkdetailtr_'+event.target.getAttribute('foo')).style.display = 'block';
}
function trackInfo_filluptable(holder, text)
{
if(text == "NULL") {
	var span = document.createElement('span');
	span.innerHTML = 'No information available';
	holder.appendChild(span);
	return;
}
var div = document.createElement('div');
var table = document.createElement('table');
table.cellSpacing=1;
table.style.color='#545454';
var color = "#f2f2f2";
var lst = text.split('; ');
for(var i=0; i<lst.length; i++) {
	var idx=lst[i].indexOf('=');
	if(idx==-1) continue;
	color = color=="white" ? "#f2f2f2" : "white";
	trackdetailAddonerow(lst[i].substr(0,idx), lst[i].substr(idx+1), table, color);
}
div.appendChild(table);
div.style.width = 320;
holder.appendChild(div);
if(table.clientHeight > 200) {
	div.style.height = 200;
	div.style.overflowY = 'scroll';
} else {
	div.style.height = 'auto';
	div.style.overflowY = 'auto';
}
div.style.overflowX = table.clientWidth>320 ? 'scroll' : 'auto';
}
function trackdetailAddonerow(text1, text2, holder, color) {
// make a row to hold text1 and text2 in two <td>
	var tr = holder.insertRow(-1);
	var td = tr.insertCell(0);
	td.style.fontSize = "12px";
	td.style.backgroundColor = color;
	// attribute name uses underscore in place of space, replace that
	td.innerHTML = text1.replace(/\_/g, " ");
	tr.appendChild(td);
	td = tr.insertCell(1);
	td.style.fontSize = "12px";
	td.style.backgroundColor = color;
	td.innerHTML = text2;
	tr.appendChild(td);
	holder.appendChild(tr);
}
function toggle26(doupdate) {
// change qtrack threshold type
	var v = getValue_by_radioName('qtc_thresholdradio');
	var d1 = document.getElementById('qtc_thresholdradio_fixdiv');
	var d2 = document.getElementById('qtc_rulerdiv');
	var s1 = document.getElementById('qtc_percentile_span');
	var s2 = document.getElementById('qtc_pth');
	var s3 = document.getElementById('qtc_nth');
	qtc.thtype = parseInt(v);
	if(v == 0) {
		// automatic scale
		d1.style.display = 'none';
		d2.style.display = 'none';
		s1.style.display = 'none';
		s2.style.display = 'none';
		s3.style.display = 'none';
		if(doupdate) {
			qtc.changed = 'thtype';
			qtc_update();
		}
	} else if(v == 1) {
		// fixed scale
		d1.style.display = 'block';
		d2.style.display = 'none';
		s1.style.display = 'none';
		s2.style.display = 'block';
		s3.style.display = 'block';
	} else if(v == 2) {
		// percentile
		d1.style.display = 'none';
		d2.style.display = 'block';
		s1.style.display = 'inline';
		s2.style.display = 'block';
		s3.style.display = 'block';
		if(doupdate) {
			qtc.changed = 'thtype';
			qtc.thpercentile = parseInt(document.getElementById('qtc_percentile').innerHTML);
			qtc_update();
		}
	}
}
function toggle29(doupdate) {
// toggle qtrack log checkbox
    var check = document.getElementById('hook29').checked;
    document.getElementById('bait29').style.display = check ? 'block' : 'none';
    qtc.changed = 'uselog';
    qtc.uselog = check;
    if(check) {
        qtc.logtype = parseInt(getValue_by_radioName('qtc_log'));
    }
	if(doupdate)
    	qtc_update();
}
function toggle30() {
// changing qtrack log radiobutton
//qtc.changed = 'logtype';
    qtc.changed = 'uselog';
    qtc.logtype = parseInt(getValue_by_radioName('qtc_log'));
    qtc_update();
}



/*** __qtc__ ***/

function qtc2json(q)
{
var lst = [];
for(var attr in q) {
	var v = q[attr];
	lst.push('"'+attr+'":'+(typeof(v)=='string'?'"'+v+'"':v));
}
return '{'+lst.join(',')+'}';
}

function qtc_paramCopyChange(to) {
/* 'to' is a qtc object
copy from qtc object to 'to' object for the changed 
also copy auxiliary params:
- pg, pb are with pr
- ng, nb are with nr
- thmin, thmax, thpercentile are with thtype
- logtype is with uselog
*/
	to[qtc.changed] = qtc[qtc.changed];
	if(qtc.changed == 'pr') {
		to.pg = qtc.pg;
		to.pb = qtc.pb;
	} else if(qtc.changed == 'nr') {
		to.ng = qtc.ng;
		to.nb = qtc.nb;
	} else if(qtc.changed == 'thtype') {
		if(qtc.thtype == 1) {
			to.thmin=qtc.thmin; to.thmax=qtc.thmax;
		} else if(qtc.thtype == 2) {
			to.thpercentile = qtc.thpercentile;
		}
	} else if(qtc.changed == 'uselog') {
		if(qtc.uselog) {
			to.logtype = qtc.logtype;
		}
	}
}
function qtc_pcolor_initiator(event) { // positive
	paletteshow(event.clientX, event.clientY, 30);
	palettegrove_paint(document.getElementById('qtc_pcolor').style.backgroundColor);
}
function qtc_pcolor() {
	var c = palette.output;
	document.getElementById("qtc_pcolor").style.backgroundColor = c;
	document.getElementById("qtc_pcolordiv").style.backgroundColor = c;
	var lst = colorstr2int(c);
	qtc.pr=lst[0]; qtc.pg=lst[1]; qtc.pb=lst[2];
	qtc.changed = 'pr';
	qtc_update();
}
function qtc_ncolor_initiator(event) { // negative
	paletteshow(event.clientX, event.clientY, 31);
	palettegrove_paint(document.getElementById('qtc_ncolor').style.backgroundColor);
}
function qtc_ncolor() {
	var c = palette.output;
	document.getElementById("qtc_ncolor").style.backgroundColor = c;
	document.getElementById("qtc_ncolordiv").style.backgroundColor = c;
	var lst = colorstr2int(c);
	qtc.nr=lst[0]; qtc.ng=lst[1]; qtc.nb=lst[2];
	qtc.changed = 'nr';
	qtc_update();
}
function qtc_pth_initiator(event) { // positive threshold
	paletteshow(event.clientX, event.clientY, 32);
	palettegrove_paint(document.getElementById('qtc_pth').style.backgroundColor);
}
function qtc_pth() {
	document.getElementById("qtc_pth").style.backgroundColor = palette.output;
	qtc.pth = palette.output;
	qtc.changed = 'pth';
	qtc_update();
}
function qtc_nth_initiator(event) { // negative threshold
	paletteshow(event.clientX, event.clientY, 33);
	palettegrove_paint(document.getElementById('qtc_nth').style.backgroundColor);
}
function qtc_nth(event) {
	document.getElementById("qtc_nth").style.backgroundColor = palette.output;
	qtc.nth = palette.output;
	qtc.changed = 'nth';
	qtc_update();
}

function toggle15(event)
{
/* called by changing "apply to all tracks" checkbox in qtc panel
when checking it, shall automatically apply style
*/
var usingall = event.target.checked;
if(qtc.which==1) {
	var m=gflag.menu;
	if(m.context==1 || m.context==2) {
		// on heatmap tracks
		if(usingall) {
			// all hm tracks
			var d=m.bbj.hmdiv.parentNode;
			var c = absolutePosition(d);
			placeIndicator3(c[0], c[1], d.clientWidth, d.clientHeight);
			if(m.bbj.hmdiv.childNodes.length>1) document.getElementById('menu_tkh_unifybutt').style.display='inline';
		} else {
			// only those selected by menu
			m.bbj.highlighttrack(m.tklst);
			document.getElementById('menu_tkh_unifybutt').style.display=gflag.menu.tklst.length>1?'inline':'none';
		}
	}
} else if(qtc.which == 8) {
	// on bev tracks
	if(usingall) {
		for(var vn in bev.data) {
			if(bev.data[vn].onshow)
				bev.data[vn].tr.childNodes[3].style.backgroundColor = colorCentral.iconbackground;
		}
	} else {
		for(var vn in bev.data) {
			if(bev.data[vn].onshow)
				bev.data[vn].tr.childNodes[3].style.backgroundColor = "transparent";
		}
		bev.data[bev.ongoing].tr.childNodes[3].style.backgroundColor = colorCentral.iconbackground;
	}
}
}

function qtc_update()
{
/* always from context menu */
var m=gflag.menu;
switch(m.context) {
case 1:
case 2:
	if(document.getElementById("qtc_alltrackcheckbox").checked) {
		for(var i=0; i<m.bbj.tklst.length; i++) {
			var t=m.bbj.tklst[i];
			if(t.where!=1) continue;
			qtc_paramCopyChange(t.qtc);
		}
		m.bbj.drawTrack_browser_all();
		m.bbj.drawMcm();
	} else {
		for(var i=0; i<m.tklst.length; i++) {
			var o=m.tklst[i];
			qtc_paramCopyChange(o.qtc);
			m.bbj.drawTrack_browser(o);
			m.bbj.drawMcm_onetrack(o, false);
		}
	}
	m.bbj.trackHeightChanged();
	for(var tag in m.bbj.splinters)
		m.bbj.splinters[tag].trackHeightChanged();
	break;
case 19:
	/* single wreath, numerical
	track idx identified in gflag.menu.wreathIdx
	*/
	var tkobj=hengeview.hash[gflag.menu.viewkey].wreath[gflag.menu.wreathIdx];
	qtc_paramCopyChange(tkobj.qtc);
	hengeview_draw(gflag.menu.viewkey);
	break;
case 20:
	// single bev track, numerical
	var tkobj=gflag.menu.bbj.genome.bev.tklst[gflag.menu.bevtkidx];
	qtc_paramCopyChange(tkobj.qtc);
	gflag.menu.bbj.genome.bev_draw_track(tkobj);
	break;
default:
	fatalError('qtc_update: unknown gflag.menu.context');
}
document.body.removeEventListener('mousedown', menu_hide,false);
}


function menu_tkh_change(event)
{
/* called by pushing buttons in menu: increase, decrease, unify
centralized place to process track height change, by .menu.context:
- browser track
- wreath track
- bev track
*/
var changetype=parseInt(event.target.getAttribute('changetype'));
var m=gflag.menu;
if(m.context==1 || m.context==2) {
	// configuring browser track
	var gooverlst=[];
	var entireghm=document.getElementById("qtc_alltrackcheckbox").checked; // if using all in the ghm
	if(entireghm) {
		for(var i=0; i<m.bbj.tklst.length; i++) {
			var tk=m.bbj.tklst[i];
			if(tk.where==1) gooverlst.push(tk);
		}
	} else {
		gooverlst=m.tklst;
	}
	var gooverlst2=null;
	var changeamount=null;
	if(changetype==1) {
		gooverlst2=gooverlst;
		changeamount=parseInt(event.target.getAttribute('amount'));
	} else if(changetype==2) {
		/* find a consensus height and set everybody to it
		for numerical and cat: find and use a height most commonly used
		if mixed numerical and lr, only do numerical
		for lr:
		*/
		var h_nc={}; // px height of numerical and cat
		var tklst_nc=[];
		var h_lr={}; // anglescale of lr
		var tklst_lr=[];
		for(var i=0; i<gooverlst.length; i++) {
			var tk=gooverlst[i];
			if(isNumerical(tk) || tk.ft==FT_cat_n || tk.ft==FT_cat_c) {
				tklst_nc.push(tk);
				var h=tk.qtc.height;
				if(h in h_nc) h_nc[h]++;
				else h_nc[h]=1;
			} else if(tk.ft==FT_lr_c || tk.ft==FT_lr_n) {
				tklst_lr.push(tk);
				var s=tk.qtc.anglescale;
				if(s in h_lr) h_lr[s]++;
				else h_lr[s]=1;
			}
		}
		if(tklst_nc.length>0) {
			var mcount=0, mheight=0;
			for(var h in h_nc) {
				if(h_nc[h]>mcount) {
					mcount=h_nc[h];
					/* 2013-3-20 confusing bug at vizbi
					when number is used as object attr, it is converted to string
					*/
					mheight=parseInt(h);
				}
			}
			gooverlst2=tklst_nc;
			changeamount=mheight;
		} else if(tklst_lr.length>0) {
			var mcount=0, mheight=0;
			for(var h in h_lr) {
				if(h_lr[h]>mcount) {
					mcount=h_lr[h];
					mheight=parseFloat(h);
				}
			}
			gooverlst2=tklst_lr;
			changeamount=mheight;
		}
	} else {
		return;
	}
	if(gooverlst2==null) return;
	if(gooverlst2.length==0) return;
	m.bbj.tkgrp_heightchange(gooverlst2, changetype, changeamount);
	// adjust holder height
	m.bbj.trackHeightChanged();
	// must adjust for splinters
	for(var tag in m.bbj.splinters) m.bbj.splinters[tag].trackHeightChanged();
	// adjust indicator3
	if(entireghm) {
		var p=absolutePosition(m.bbj.hmdiv.parentNode);
		placeIndicator3(p[0],p[1],m.bbj.hmSpan,m.bbj.hmdiv.clientHeight);
	} else {
		m.bbj.highlighttrack(m.tklst);
	}
} else if(m.context==19) {
	// wreath, for 1 track
	var obj=hengeview.hash[gflag.menu.viewkey].wreath[gflag.menu.wreathIdx];
	obj.qtc.height=Math.max(10,obj.qtc.height+parseInt(event.target.getAttribute('amount')));
	hengeview_draw(gflag.menu.viewkey);
} else if(m.context==20) {
	// bev, always only one
	var obj=gflag.menu.bbj.genome.bev.tklst[gflag.menu.bevtkidx];
	obj.qtc.height=Math.max(10,obj.qtc.height+parseInt(event.target.getAttribute('amount')));
	gflag.menu.bbj.genome.bev_draw_track(obj);
}
/*over*/
}

Browser.prototype.tkgrp_heightchange=function(_tklst,type,amount)
{
/* change height of a group of tracks
args:
_tklst
type:
	1 increase or reduce height by a given amount
	2 set all heights to the amount
*/
for(var i=0; i<_tklst.length; i++) {
	var tk=_tklst[i];
	if(isNumerical(tk) || tk.ft==FT_cat_n || tk.ft==FT_cat_c) {
		// set by .qtc.height
		if(type==1) {
			tk.qtc.height=Math.max(3,tk.qtc.height+amount);
		} else {
			tk.qtc.height=amount;
		}
	} else if(tk.ft==FT_lr_c || tk.ft==FT_lr_n) {
		// set by .qtc.anglescale
		if(type==1) {
			if(amount>=1 || amount<=-1) amount/=50;
			var v=tk.qtc.anglescale+amount;
			if(v<0.5) v=0.5;
			else if(v>1) v=1;
			tk.qtc.anglescale=v;
		} else {
			tk.qtc.anglescale=amount;
		}
	}
	this.drawTrack_browser(tk,false);
	this.drawMcm_onetrack(tk,false);
}
/*over*/
}

function qtc_sliderMD(event)
{
// selection of percentile
	event.preventDefault();
	qtc.slider.x = event.clientX;
	document.body.addEventListener("mousemove", qtc_sliderM, false);
	document.body.addEventListener("mouseup", qtc_sliderMU, false);
}
function qtc_sliderM(event) {
	var x = event.clientX;
	var oldx = qtc.slider.x;
	var l = parseInt(qtc.slider.style.left);
	if((x>oldx && l>=100) || (x<oldx && l<=0))
		return;
	qtc.slider.style.left = l + x-oldx;
	l = parseInt(qtc.slider.style.left);
	if(l > 100)
	qtc.slider.style.left = 100;
	else if(l<0)
	qtc.slider.style.left = 0;
	document.getElementById("qtc_percentile").innerHTML = parseInt(qtc.slider.style.left);
	qtc.slider.x = event.clientX;
}
function qtc_sliderMU() {
	document.body.removeEventListener("mousemove", qtc_sliderM, false);
	document.body.removeEventListener("mouseup", qtc_sliderMU, false);
	qtc.thpercentile = parseInt(document.getElementById("qtc_percentile").innerHTML);
	qtc.changed = 'thtype';
	qtc_update();
}
function qtc_slider_moveleft(howmany) {
// move qtc slider left by a number of percentile
	var n = parseInt(qtc.slider.style.left);
	var f = undefined;
	if(n >= howmany)
		f = n - howmany;
	else if(n > 0)
		f = 0;
	if(f != undefined) {
		qtc.slider.style.left = f;
		document.getElementById("qtc_percentile").innerHTML = f;
		qtc.thpercentile = f;
		qtc.changed = 'thtype';
		qtc_update();
	}
}
function qtc_slider_moveright(howmany) {
// move qtc slider left by a number of percentile
	var n = parseInt(qtc.slider.style.left);
	var f = undefined;
	if(n+howmany <= 100)
		f = n + howmany;
	else if(n < 100)
		f = 100;
	if(f != undefined) {
		qtc.slider.style.left = f;
		document.getElementById("qtc_percentile").innerHTML = f;
		qtc.thpercentile = f;
		qtc.changed = 'thtype';
		qtc_update();
	}
}
function qtc_setfixscale() {
	var t = document.getElementById('qtc_fix_min');
	if(t.value.length == 0) {
		print2console('Missing min value', 2);
		return;
	}
	var min = parseFloat(t.value);
	if(isNaN(min)) {
		print2console('Invalid min value', 2);
		return;
	}
	t = document.getElementById('qtc_fix_max');
	if(t.value.length == 0) {
		print2console('Missing max value', 2);
		return;
	}
	var max = parseFloat(t.value);
	if(isNaN(max)) {
		print2console('Invalid max value', 2);
		return;
	}
	if(min >= max) {
		print2console('Max must be greater than min',2);
		return;
	}
	qtc.thmin=min; qtc.thmax=max;
	qtc.changed = 'thtype';
	qtc_update();
}

/*** __qtc__ ends ***/



/*** _stc_ from menu ***/
function stc_fontfamily(event)
{
var tk=gflag.menu.tklst[0];
tk.qtc.fontfamily = event.target.options[event.target.selectedIndex].value;
gflag.menu.bbj.drawTrack_browser(tk);
}
function stc_fontsize(event)
{
var tk=gflag.menu.tklst[0];
tk.qtc.fontsize= event.target.options[event.target.selectedIndex].value;
gflag.menu.bbj.drawTrack_browser(tk);
}
function stc_fontbold(event)
{
var tk=gflag.menu.tklst[0];
tk.qtc.fontbold= event.target.checked;
gflag.menu.bbj.drawTrack_browser(tk);
}
function stc_longrange_pcolorscore_KU(event) { if(event.keyCode==13) stc_longrange_pcolorscore(); }
function stc_longrange_pfilterscore_KU(event) { if(event.keyCode==13) stc_longrange_pfilterscore(); }
function stc_longrange_ncolorscore_KU(event) { if(event.keyCode==13) stc_longrange_ncolorscore(); }
function stc_longrange_nfilterscore_KU(event) { if(event.keyCode==13) stc_longrange_nfilterscore(); }
/*** _stc_ ends ***/



/*** __palette__ ***
a pair of two functions, 
- xx_initiator()
 toggles on palette, register xx() for click event
- xx()
 capture color and do stuff, hide palette, remove event registry
 */
function paletteMover() {
document.body.removeEventListener('mousedown', palettehide, false)
document.body.removeEventListener('mousedown', menu_hide,false);
}
function paletteMout() {
document.body.addEventListener('mousedown', palettehide, false)
document.body.addEventListener('mousedown', menu_hide,false);
}
function palette_context_update() {
switch(palette.which) {
case 1: stc_textcolor();return;
case 2: stc_bedcolor(); return;
case 3: stc_forwardcolor();return;
case 4: stc_reversecolor();return;
case 5: stc_mismatchcolor();return;
case 6: stc_longrange_pcolor();return;
case 8: stc_longrange_ncolor();return;
case 10: hengeview_arcpcolor();return;
case 11: hengeview_arcncolor();return;
case 12: mcm_configcolor();return;
case 20: document.getElementById('geneplot_s4_pc').style.backgroundColor = palette.output; return;
case 21: document.getElementById('geneplot_s4_nc').style.backgroundColor = palette.output; return;
case 22: document.getElementById('geneplot_s1_lc').style.backgroundColor = palette.output; return;
case 23: document.getElementById('geneplot_s2_lc').style.backgroundColor = palette.output; return;
case 24: document.getElementById('geneplot_s3_promoterc').style.backgroundColor = palette.output; return;
case 25: document.getElementById('geneplot_s3_utr5c').style.backgroundColor = palette.output; return;
case 26: document.getElementById('geneplot_s3_utr3c').style.backgroundColor = palette.output; return;
case 27: document.getElementById('geneplot_s3_exonsc').style.backgroundColor = palette.output; return;
case 28: document.getElementById('geneplot_s3_intronsc').style.backgroundColor = palette.output; return;
case 30: qtc_pcolor(); return;
case 31: qtc_ncolor(); return;
case 32: qtc_pth(); return;
case 33: qtc_nth(); return;
//case 34: htest_clc(); return;
case 40: hengeview_wreathpcolor();return;
case 41: hengeview_wreathncolor();return;
case 42: cateTkitemcolor();return;
default:
fatalError("palette_context_update: unknown palette.which");
}
}
function palettehide() {
    palette.style.display = "none";
    document.body.removeEventListener("mousedown", palettehide, false);
}
function paletteshow(x,y, which) {
// x and y should be event.clientX/Y
// TODO automatic beak placement, ...
    palette.style.display = "block";
    palette.style.left = x-80;
    palette.style.top = y+5;
	palette.which=which;
	document.body.addEventListener('mousedown', palettehide,false);
    // clear grove color gradient
}
function palettedyeclick(event) {
    // clicking palette dye
    palettegrove_paint(event.target.style.backgroundColor);
    palette.output = event.target.style.backgroundColor;
    palette_context_update();
}
function palettegrove_paint(color) {
    palette.grove.color = color;
    var ctx = palette.grove.getContext('2d');
    var lingrad = ctx.createLinearGradient(0,0,100,0);
    lingrad.addColorStop(0,'black');
    lingrad.addColorStop(0.5, color);
    lingrad.addColorStop(1, 'white');
    ctx.fillStyle = lingrad;
    ctx.fillRect(0,0,100,20);
}
function palettesliderMD(event) {
    // palette slider md
    event.preventDefault();
    palette.slider.x = event.clientX;
    document.body.addEventListener("mousemove", palettesliderM, false);
    document.body.addEventListener("mouseup", palettesliderMU, false);
}
function palettesliderM(event) {
    var x = event.clientX;
    var oldx = palette.slider.x;
    var l = parseInt(palette.slider.style.left);
    if((x>oldx && l>=100) || (x<oldx && l<=0))
        return;
    palette.slider.style.left = l + x-oldx;
    l = parseInt(palette.slider.style.left);
    if(l > 100)
	palette.slider.style.left = 100;
    else if(l<0)
	palette.slider.style.left = 0;
    palette.slider.x = event.clientX;
}
function palettesliderMU() {
    document.body.removeEventListener("mousemove", palettesliderM, false);
    document.body.removeEventListener("mouseup", palettesliderMU, false);
    var x = parseInt(palette.slider.style.left);
    if(x == 50)
        palette.output = palette.grove.color;
    else if(x < 50)
        palette.output = darkencolor(colorstr2int(palette.grove.color), (100-x*2)/100);
    else
        palette.output = lightencolor(colorstr2int(palette.grove.color), (x-50)/50);
    palette_context_update();
}
function palettegrove_click(event) {
    // clicking on palette grove to pick up a color from the gradient
    var pos = absolutePosition(palette.grove);
    palette.slider.style.left = event.clientX - pos[0];
    var x = parseInt(palette.slider.style.left);
    if(x == 50)
        palette.output = palette.grove.color;
    else if(x < 50)
        palette.output = darkencolor(colorstr2int(palette.grove.color), (100-x*2)/100);
    else
        palette.output = lightencolor(colorstr2int(palette.grove.color), (x-50)/50);
    palette_context_update();
}


function stc_textcolor_initiator(event) {
	paletteshow(event.clientX, event.clientY, 1);
	palettegrove_paint(document.getElementById('stc_textcolor').style.backgroundColor);
}
function stc_textcolor() {
	var tk=gflag.menu.tklst[0];
	tk.qtc.textcolor=palette.output;
	gflag.menu.bbj.drawTrack_browser(tk);
}
function stc_bedcolor_initiator(event) {
	paletteshow(event.clientX, event.clientY, 2);
	palettegrove_paint(document.getElementById('stc_bedcolor').style.backgroundColor);
}
function stc_bedcolor(event) {
	var tk=gflag.menu.tklst[0];
	tk.qtc.bedcolor=palette.output;
	gflag.menu.bbj.drawTrack_browser(tk);
}
function stc_forwardcolor_initiator(event) {
	paletteshow(event.clientX, event.clientY, 3);
	palettegrove_paint(document.getElementById("stc_forwardcolor").style.backgroundColor);
}
function stc_forwardcolor() {
	var tk=gflag.menu.tklst[0];
	tk.qtc.forwardcolor=palette.output;
	gflag.menu.bbj.drawTrack_browser(tk);
}
function stc_reversecolor_initiator(event) {
	paletteshow(event.clientX, event.clientY, 4);
	palettegrove_paint(document.getElementById("stc_reversecolor").style.backgroundColor);
}
function stc_reversecolor() {
	var tk=gflag.menu.tklst[0];
	tk.qtc.reversecolor=palette.output;
	gflag.menu.bbj.drawTrack_browser(tk);
}
function stc_mismatchcolor_initiator(event) {
	paletteshow(event.clientX, event.clientY, 5);
	palettegrove_paint(document.getElementById("stc_mismatchcolor").style.backgroundColor);
}
function stc_mismatchcolor() {
	var tk=gflag.menu.tklst[0];
	tk.qtc.mismatchcolor=palette.output;
	gflag.menu.bbj.drawTrack_browser(tk);
}
function stc_longrange_pcolor_initiator(event) {
/* called by two cases:
- a browse track
- hengeview panel arcs
*/
	paletteshow(event.clientX, event.clientY, gflag.menu.context==1?6:10);
	palettegrove_paint(document.getElementById('stc_longrange_pcolor').style.backgroundColor);
}
function stc_longrange_pcolor(event) {
	var tk=gflag.menu.tklst[0];
	tk.qtc.pcolor=palette.output;
	gflag.menu.bbj.drawTrack_browser(tk);
	longrange_showplotcolor(palette.output,null);
}
function stc_longrange_ncolor_initiator(event) {
/* called by two cases:
- a browse track, context 1
- hengeview panel arcs, context 15
*/
	paletteshow(event.clientX, event.clientY, gflag.menu.context==1?8:11);
	palettegrove_paint(document.getElementById('stc_longrange_ncolor').style.backgroundColor);
}
function stc_longrange_ncolor(event) {
	var tk=gflag.menu.tklst[0];
	tk.qtc.ncolor=palette.output;
	gflag.menu.bbj.drawTrack_browser(tk);
	longrange_showplotcolor(null,palette.output);
}

function hengeview_arcpcolor_initiator(event) {
	paletteshow(event.clientX, event.clientY, 10);
	palettegrove_paint(event.target.style.backgroundColor);
}
function hengeview_arcpcolor() {
	var c=colorstr2int(palette.output);
	hengeview.hash[gflag.menu.viewkey].callingtk.pcolor=c.join(',');
	hengeview_draw(gflag.menu.viewkey);
	longrange_showplotcolor(palette.output,null);
}
function hengeview_arcncolor_initiator(event) {
	paletteshow(event.clientX, event.clientY, 11);
	palettegrove_paint(event.target.style.backgroundColor);
}
function hengeview_arcncolor() {
	var c=colorstr2int(palette.output);
	hengeview.hash[gflag.menu.viewkey].callingtk.ncolor=c.join(',');
	hengeview_draw(gflag.menu.viewkey);
	longrange_showplotcolor(null,palette.output);
}
function hengeview_wreathpcolor_initiator(event) {
	paletteshow(event.clientX, event.clientY, 40);
	palettegrove_paint(event.target.style.backgroundColor);
	palette.hook=event.target; // contains track name
}
function hengeview_wreathpcolor() {
	palette.hook.style.backgroundColor=palette.output;
	var c=colorstr2int(palette.output);
	var tkn=palette.hook.parentNode.parentNode.tkname;
	var lst=hengeview.hash[gflag.menu.viewkey].wreath;
	for(var i=0; i<lst.length; i++) {
		if(lst[i].name==tkn) {
			lst[i].qtc.pr=c[0];
			lst[i].qtc.pg=c[1];
			lst[i].qtc.pb=c[2];
			break;
		}
	}
	hengeview_draw(gflag.menu.viewkey);
}
function hengeview_wreathncolor_initiator(event) {
	paletteshow(event.clientX, event.clientY, 41);
	palettegrove_paint(event.target.style.backgroundColor);
	palette.hook=event.target; // contains track name
}
function hengeview_wreathncolor() {
	palette.hook.style.backgroundColor=palette.output;
	var c=colorstr2int(palette.output);
	var tkn=palette.hook.parentNode.parentNode.tkname;
	var lst=hengeview.hash[gflag.menu.viewkey].wreath;
	for(var i=0; i<lst.length; i++) {
		if(lst[i].name==tkn) {
			lst[i].qtc.nr=c[0];
			lst[i].qtc.ng=c[1];
			lst[i].qtc.nb=c[2];
			break;
		}
	}
	hengeview_draw(gflag.menu.viewkey);
}

function stc_longrange_autoscale()
{
// toggling checkbox
var c=document.getElementById('stc_longrange_autoscale');
var bbj=gflag.menu.bbj;
var tk=gflag.menu.tklst[0];
tk.qtc.thtype=c.checked?0:1;
bbj.drawTrack_browser(tk);
document.getElementById('stc_longrange_pcolorscore_div').style.display=
document.getElementById('stc_longrange_ncolorscore_div').style.display= c.checked?'none':'block';
}

function stc_longrange_pcolorscore()
{
/* apply score cutoff for positive color in long-range track
not yet generic for common bed track

called by two cases:
- a browse track, menu context 1
- hengeview panel arcs, menu context 15
*/
var score=parseFloat(document.getElementById('stc_longrange_pcolorscore').value);
if(isNaN(score)) {
	print2console('Invalid input for positive score cutoff', 2);
	return;
}
if(score < 0) {
	print2console('score cutoff must be positive',2);
	return;
}
if(gflag.menu.context==1) {
	var bbj=gflag.menu.bbj;
	var tk=gflag.menu.tklst[0];
	tk.qtc.pcolorscore=score;
	bbj.drawTrack_browser(tk);
} else {
	hengeview.hash[gflag.menu.viewkey].callingtk.pscore=score;
	hengeview_draw(gflag.menu.viewkey);
}
}
function stc_longrange_ncolorscore()
{
/* apply score cutoff for negative color in long-range track
not yet generic for common bed track
*/
var score = parseFloat(document.getElementById('stc_longrange_ncolorscore').value);
if(isNaN(score)) {
	print2console('Invalid input for negative score cutoff', 2);
	return;
}
if(score > 0) {
	print2console('score cutoff must be negative',2);
	return;
}
if(gflag.menu.context==1) {
	var tk=gflag.menu.tklst[0];
	tk.qtc.ncolorscore=score;
	gflag.menu.bbj.drawTrack_browser(tk);
} else {
	hengeview.hash[gflag.menu.viewkey].callingtk.nscore=score;
	hengeview_draw(gflag.menu.viewkey);
}
}
function stc_longrange_pfilterscore() {
/* apply positive score cutoff for filtering long-range items with positive scores
not yet generic for common bigbed track
will invoke ajax as the filtering is done on server side
*/
	var score = parseFloat(document.getElementById('stc_longrange_pfilterscore').value);
	if(isNaN(score)) {
		print2console('Invalid input for positive score cutoff', 2);
		return;
	}
	if(score < 0) {
		print2console('score cutoff must be positive',2);
		return;
	}
	var tk=gflag.menu.tklst[0];
	tk.qtc.pfilterscore=score;
	gflag.menu.bbj.ajax_addtracks([tk]);
}
function stc_longrange_nfilterscore() {
/* apply negative score cutoff for filtering long-range items with negative scores
not yet generic for common bigbed track
will invoke ajax as the filtering is done on server side
*/
	var score = parseFloat(document.getElementById('stc_longrange_nfilterscore').value);
	if(isNaN(score)) {
		print2console('Invalid input for negative score cutoff', 2);
		return;
	}
	if(score > 0) {
		print2console('score cutoff must be negative',2);
		return;
	}
	var tk=gflag.menu.tklst[0];
	tk.qtc.nfilterscore=score;
	gflag.menu.bbj.ajax_addtracks([tk]);
}

/*** __palette__ ends ***/






function toggle39() {
	var hook = document.getElementById('hook39');
	var bait = document.getElementById('bait39');
	if(bait.style.display == 'none') {
		bait.style.display = 'block';
		hook.innerHTML = '&#8863; hide';
	} else {
		bait.style.display = 'none';
		hook.innerHTML = '&#8862; show gene structure';
	}
}


function bubbleHide()
{
bubble.style.display='none';
document.body.removeEventListener('mousedown', bubbleHide, false);
}
function bubbleMover() {document.body.removeEventListener('mousedown', bubbleHide, false);};
function bubbleMout() {document.body.addEventListener('mousedown', bubbleHide, false);};

Browser.prototype.decorCanvasLeftclickGetInfo=function(tk, item, itemRidx, mX, mY)
{
/* called by left clicking on decor track canvas
retieves info with respect of decor type
might run ajax query to fetch additional info depending on decor type
in case of clicking genes, if on part of the gene is shown, draw this gene out
in the tooltip and mark the clicked position

args:
tk: track display object
item: an item in .data, or .data_chiapet
itemRidx: idx of the region in which the item is in
mX, mY: pos to show the bubble
*/
bubble.style.display = "block";
bubble.style.left = mX-13;
bubble.style.top = mY;
document.body.addEventListener("mousedown", bubbleHide, false);

bubble.sayajax.innerHTML = "";
bubble.sayajax.style.width = 'auto';
var text = "";
var currentcoord = this.regionLst[itemRidx][0]+':'+item[8]+'-'+item[9];

if(tk.ft==FT_lr_c || tk.ft==FT_lr_n) {
	/*** long-range item ***/
	text = '<div style="margin:10px;color:white;position:relative;">';
	if(item[17]) {
		// mate found
		var m1 = item[16][4][0];
		var m2 = item[16][4][1];
		var coord1=this.regionLst[m1[0]][0]+':'+m1[1]+'-'+m1[2];
		var coord2=this.regionLst[m2[0]][0]+':'+m2[1]+'-'+m2[2];
		text += 'Interacting regions:<br>'+coord1+
			' <button type=button onclick=\'gflag.browser.splinter("'+coord1+'")\'>focus</button><br>'+
			coord2+' <button type=button onclick=\'gflag.browser.splinter("'+coord2+'")\'>focus</button><br>'+
			'score: '+item[3];
	} else {
		// no mate, preliminary checking to make sure there's valid mate information
		if(item[3].indexOf(',')==-1 || item[3].indexOf(':')==-1 || item[3].indexOf('-')==-1) {
			bubble.style.display = 'none';
			print2console('Unexpected contents. Is this a valid Long range interaction track?', 2);
			return;
		}
		var tt = item[3].split(',');
		var t2 = tt[0].split(':');
		var t3 = t2[1].split('-');
		text += 'Interacting regions:<br>'+
			'current: '+currentcoord+' <button type=button onclick=\'gflag.browser.splinter("'+currentcoord+'")\'>focus</button><br>'+
			'remote: '+tt[0]+' <button type=button onclick=\'gflag.browser.splinter("'+tt[0]+'")\'>focus</button><br>'+
			'score: '+tt[1];
	}
	text+='</div>';
	bubble.says.innerHTML=text;
	return;
}
if(tk.ft==FT_bed_n) {
	/*** native bed ***/
	if(tk.qtc.isrmsk) {
		/* a repeatmasker track */
		this.rmsk_bubble_query(itemRidx,item[8],item[9],item[4],item[3]);
		return;
	}

	// variables used to draw gene in tooltip
	var willdrawgene = false;
	var curbstart, curbstop;
	var coordstrand = currentcoord +' '+ ((item[4]!=undefined && item[4]!='.') ? (item[4]=='>'?"forward":"reverse") : '');
	if(this.genome.decorIsGene(tk.name)) {
		/* need to determine if this track is only part of the gene (eg promoter track) */
		var genetype=tk.name;
		var robj=this.genome.decorInfo[genetype];
		var queryUrl=robj.queryUrl;
		if('parent' in robj) {
			// this one seem to be gene part, need to use its parent
			genetype = robj['parent'];
			queryUrl=this.genome.decorInfo[genetype].queryUrl;
		} else {
			/* track shows full gene
			if only part of the gene is visible, draw gene in tooltip
			*/
			var _dsp=this.getDspStat();
			var _r=this.regionLst[itemRidx];
			curbstart=Math.max(item[8], _r[0]==_dsp[0]?_dsp[1]:_r[3]);
			curbstop =Math.min(item[9], _r[0]==_dsp[2]?_dsp[3]:_r[4]);
			if(curbstart<curbstop && (curbstart>item[8] ||curbstop<item[9]))
				willdrawgene = true;
		}
		// need to use parent if current decor is gene part
		text = (willdrawgene?'<canvas id=tooltiptmpgenecanvas width='+tooltiptmpgene_width+
				' height='+tooltiptmpgene_height+
				' style="display:block;margin-top:10px;margin-left:auto;margin-right:auto;"></canvas>':'')
				+'<table cellspacing=0 cellpadding=0 style="width:100%;margin-top:10px;margin-bottom:10px;">'+
			'<tr><td style="color:white;padding-left:10px;padding-right:10px;font:italic bold 18px Georgia;">'+
			// symbol
			(item[15]==undefined?item[3]:item[15]) +
			'</td>'+
			// internal name
			'<td align=right style="color:white;padding-right:10px;">'+
			(item[15]==undefined?'':(item[3]+'&nbsp;&nbsp;'))+
			// link
			"<span class=clb3 onclick='window.open(\""+queryUrl+item[3]+"\")'>"+
			tk.label.split(' ')[0].split('/')[0]+'<span style="font-size:14px">&#8599;</span>'+
			'</span></td></tr>'+
			// coord
			'<tr><td colspan=2 style="color:white;padding:10px;padding-top:0px;">'+ coordstrand +'</td></tr>';
		if(item[16] != undefined) {
			// gene structure
			var ss = item[16];
			text += '<tr><td colspan=2 style="border-top:solid 1px #A46C96;border-bottom:solid 1px #8F5A82;">'+
				'<div id=hook39 onclick=toggle39() style="color:white;cursor:pointer;padding-left:20px;padding-right:10px;" onmouseover="this.style.backgroundColor=\'#814B74\'" onmouseout="this.style.backgroundColor=\'transparent\'">&#8862; show gene structure</div>'+
				'<div id=bait39 style="color:#D6B8CE;display:none;padding-left:20px;padding-right:10px;">'+
				'5\' UTR: '+(ss[1]>0 ? ss[1]+' bp, '+ss[0]+'-'+(ss[0]+ss[1]) : 'no') + '<br>'+
				'3\' UTR: '+(ss[3]>0 ? ss[3]+' bp, '+ss[2]+'-'+(ss[2]+ss[3]) : 'no') + '<br>';
			if(ss[4].length == 0) {
				text += 'No exon';
			} else {
				text += ss[4].length+' exon'+(ss[4].length==1 ? '' : 's')+
					(ss[4].length>8?'<div style="color:#D6B8CE;height:140px;overflow-y:scroll;">':'')+
					'<ol>';
				for(var i=0; i<ss[4].length; i++)
					text += '<li>'+(ss[4][i][1]-ss[4][i][0])+' bp, '+ss[4][i][0]+'-'+ss[4][i][1]+'</li>';
				text += '</ol>' +(ss[4].length>8?'</div>':'');
			}
		}
		text += '</table>';
		bubble.sayajax.innerHTML = 'loading description...';
		// gene related, fetch desc
		var param;
		this.ajax('getgenedesc=on&genetype='+genetype+'&itemid='+item[2]+'&dbName='+this.genome.name, function(data){
			// TODO gene ontology
			bubble.sayajax.innerHTML = data.desc;
			bubble.sayajax.style.width = data.desc.length>50 ? 300 : 'auto';
		});
	} else {
		text = '<div style="margin:10px;color:white;">'+(item[3]!=undefined?item[3]+'<br>':'')+coordstrand+'</div>';
	}
	bubble.says.innerHTML=text;

	if(willdrawgene) {
		// TODO make routine for drawing gene struct
		var c = document.getElementById('tooltiptmpgenecanvas');
		if(c != null) {
			var ctx = c.getContext('2d');
			var pL = 10; // left/right padding
			var pH=3; // top/bottom padding
			var w = tooltiptmpgene_width-pL*2; // actual plotable width
			plotGene(ctx,colorCentral.background,
				item[16], // gene struct
				item[4], // strand
				pL, pH, w, tooltiptmpgene_height-pH*2,
				item[8], item[9], // box coord is same as gene coord
				false);
			// highlight current region
			var sf = w/(item[9]-item[8]);
			ctx.strokeStyle = 'yellow';
			ctx.strokeRect(pL+parseInt((curbstart-item[8])*sf)+0.5, 0.5, parseInt((curbstop-curbstart)*sf), tooltiptmpgene_height-1);
		}
	}
	return;
}
if(tk.ft == FT_bed_c) {
	/*** custom bed
	the subfam bed track passed from rpbr are marked as "rmsk"
	***/
	if(tk.qtc.isrmsk) {
		/* a repeatmasker track */
		this.rmsk_bubble_query(itemRidx,item[8],item[9],item[4],item[3]);
		return;
	}
	text = '<div style="margin:10px;color:white;">';
	if(item[3] != undefined)
		text += item[3]+"<br>";
	if(item[4] != undefined)
		text += "strand: "+(item[4]=='>' ? "forward" : "reverse")+"<br>";
	bubble.says.innerHTML=text+currentcoord+'</div>';
	return;
}
if(tk.ft==FT_sam_c || tk.ft==FT_sam_n) {
	/***  native/custom sam  ***/
	text = '<div style="margin:10px;color:white;">'+
		'name: '+item[2] + '<br>('+item[13]+')<br><br>';
	bubble.sayajax.innerHTML = "<br>loading alignment...<br>";
	var param;
	if(item[17]) {
		var r=item[16][4][0];
		param='&read1='+this.regionLst[r[0]][0]+','+r[1]+','+r[2]+','+r[3];
		r=item[16][4][1];
		param+='&read2='+this.regionLst[r[0]][0]+','+r[1]+','+r[2]+','+r[3];
	} else {
		text+=this.regionLst[itemRidx][0]+':'+item[8]+'-'+item[9]+', '+(item[9]-item[8])+' bp, '+(item[4]=='>'?'forward':'reverse');
		param='&read1='+this.regionLst[itemRidx][0]+','+item[8]+','+item[9]+','+item[4];
	}
	gflag.samread.item=item;
	gflag.samread.rlst=this.regionLst;
	this.ajax('getsamreadinfo=on&dbName='+this.genome.name+param,function(data){
		var outtext='<table cellspacing=0 cellpadding=0>';
		if(gflag.samread[17]) {
			// paired-end
			if(!data.read1 || data.read1=='ERROR' || !data.read2 || data.read2=='ERROR') {
				bubble.sayajax.innerHTML='server error';
				return;
			}
			var r1=gflag.samread.item[16][4][0];
			var r2=gflag.samread.item[16][4][1];
			outtext+=
			'<tr><td colspan=2 style="border-top:solid 1px #AB7C9F;color:white;">read 1<br>'+
			gflag.samread.rlst[r1[0]][0]+':'+r1[1]+'-'+r1[2]+', '+(r1[2]-r1[1])+' bp, '+(r1[3]=='>'?'forward':'reverse')+
			'</td></tr>'+
			'<tr><td style="color:#AB7C9F">reference</td><td style="color:white;font:15px Courier,monospace">'+dye_seq(data.read1)+'</td></tr>'+
			'<tr><td style="color:#AB7C9F">read</td><td style="color:white;font:15px Courier,monospace">'+dye_seq(r1[5])+'</td></tr>'+
			'<tr><td colspan=2 style="border-top:solid 1px #AB7C9F;color:white">read 2:<br>'+
			gflag.samread.rlst[r2[0]][0]+':'+r2[1]+'-'+r2[2]+', '+(r2[2]-r2[1])+' bp, '+(r2[3]=='>'?'forward':'reverse')+
			'</td></tr>'+
			'<tr><td style="color:#AB7C9F">reference</td><td style="color:white;font:15px Courier,monospace;">'+dye_seq(data.read2)+'</td></tr>'+
			'<tr><td style="color:#AB7C9F">read</td><td style="color:white;font:15px Courier,monospace">'+dye_seq(r2[5])+'</td></tr>';
		} else {
			if(!data.read1 || data.read1=='ERROR') {
				bubble.sayajax.innerHTML='server error';
				return;
			}
			// single end
			var s=gflag.samread.item[14];
			outtext+='<tr><td style="color:#AB7C9F">reference</td><td style="color:white;font:15px Courier,monospace">'+dye_seq(data.read1)+'</td></tr><tr><td style="color:#AB7C9F">read</td><td style="color:white;font:15px Courier,monospace">'+dye_seq(s)+'</td></tr>';
		}
		bubble.sayajax.innerHTML=outtext+'</table>';
	});
	bubble.says.innerHTML=text;
	return;
}

print2console('decorCanvasLeftclickGetInfo: unknown ft', 2);

/* over */
}


Browser.prototype.rmsk_bubble_query=function(itemRidx, start, stop, strand, repName)
{
/* bubble is already shown in place
args:
itemRidx: regionLst idx
start/stop/strand:
repName: repeat name
*/
var chr=this.regionLst[itemRidx][0];
bubble.says.innerHTML='<div style="margin:10px;color:white;"><span style="font-size:16px;font-weight:bold;">'+repName+'</span><br>'+chr+':'+start+'-'+stop+(strand=='+'?' forward':' reverse')+'</div>';
bubble.sayajax.innerHTML = 'loading details...';
this.ajax('getrmskdesc=on&dbName='+this.genome.name+'&chr='+chr+'&start='+start+'&stop='+stop+'&repName='+repName, function(data) {
	bubble.sayajax.innerHTML = data.text;
});
}

function dye_seq(seq) {
// as if soaked into a magical urn
	var lst=[];
	for(var i=0; i<seq.length; i++) {
		var c=seq.charAt(i);
		lst.push('<span style="background-color:'+ntbcolor[c.toLowerCase()]+'">'+c+'</span>');
	}
	return lst.join('');
}


function findDecoritem_longrange_trihm(data, angle, mX, mY)
{
/* args:
data - .data_trihm
angle - .qtc.angle
mX/mY - cursor position relative to start of canvas

ascending lines:
A : tan
B : -1
C : b-a*tan
C2: b-a*tan-m*tan

descending lines:
A : -tan
B : -1
C : a*tan+b
C2: a*tan+b-n*tan

use formular to calculate point-to-line distance
*/
var tan=Math.tan(angle);
var sin=Math.sin(angle);
for(var i=0; i<data.length; i++) {
	var item = data[i];
	var a=item[0];
	var b=item[1];
	var m=item[2];
	var n=item[3];
	// distance to first ascending line
	if(Math.abs(tan*mX-mY+b-a*tan) > m*sin*Math.sqrt(tan*tan+1)) continue;
	// distance to second ascending line
	if(Math.abs(tan*mX-mY+b-a*tan-m*tan) > m*sin*Math.sqrt(tan*tan+1)) continue;
	// distance to first descending line
	if(Math.abs(-tan*mX-mY+a*tan+b) > n*sin*Math.sqrt(tan*tan+1)) continue;
	// distance to second descending line
	if(Math.abs(-tan*mX-mY+a*tan+b-n*tan) > n*sin*Math.sqrt(tan*tan+1)) continue;
	return item;
}
return null;
}
function findDecoritem_longrange_arc(data, x,y)
{
/* args:
data: .data_arc
*/
for(var i=0; i<data.length; i++) {
	var t=data[i];
	if(Math.abs(Math.sqrt(Math.pow(x-t[0],2)+Math.pow(y-t[1],2))-t[2])<=2) {
		return t;
	}
}
return null;
}


function decorCanvasLongrange_MO() {
// mouse out
	indicator.style.display=indicator6.style.display='none';
}


function mdshowhide(event)
{
/* called by clicking on <span> inside <li>, which is non-leaf metadata term
<li>'s next sibling must be <ul>, and will show/hide it
*/
var ul = event.target.parentNode.nextSibling;
if(ul==null)
	fatalError('mdshowhide: next sibling is null');
var icon;
if(ul.tagName == 'UL') {
	// clicked on text, ul found
	icon = event.target.firstChild;
} else {
	// clicked on icon
	icon = event.target;
	ul = event.target.parentNode.parentNode.nextSibling;
	if(ul.tagName != 'UL')
		fatalError('mdshowhide: <ul> not found');
}
if(ul.style.display == 'none') {
	ul.style.display = "block";
	icon.innerHTML = '&#8863;';
} else {
	ul.style.display = 'none';
	icon.innerHTML = '&#8862;';
}
}






/* __gss__ gene structure select */

function gssp_mover() {document.body.removeEventListener('mousedown', gssp_close, false);}
function gssp_mout() {document.body.addEventListener('mousedown', gssp_close, false);}
function gssp_close()
{
gsselect.main.style.display = 'none';
document.body.removeEventListener('mousedown', gssp_close, false);
}
function invokegssp(which,x,y)
{
// actually invoke gene struct selection panel
gsselect.sliderpanel.style.display=(getValue_by_radioName('gss_opt')=='custom')?'block':'none';
gsselect.which = which;
gsselect.main.style.display = 'block';
placePanel(gsselect.main, x, y);
}
function custgsv_invokegss(event)
{
// invoke gene struct selection panel for custom geneset input
var g=gflag.gsv.bbj.genesetview;
checkInputByvalue('gss_opt', g.gss_opt);
checkInputByvalue('gss_origin', g.gss_origin);
var pos=absolutePosition(event.target);
invokegssp(1, pos[0]+event.target.clientWidth, pos[1]);
document.body.addEventListener('mousedown', gssp_close, false);
}
function kegg_invokegss(event)
{
// invoke gene struct selection panel for kegg geneset input
var g=gflag.gsv.bbj.genesetview;
checkInputByvalue('gss_opt', g.gss_opt);
checkInputByvalue('gss_origin', g.gss_origin);
var pos=absolutePosition(event.target);
invokegssp(2, pos[0]+event.target.clientWidth,pos[1]);
document.body.addEventListener('mousedown', gssp_close, false);
}
function gsedit_invokegss(event)
{
// invoke gene struct selection panel for geneset edit
var g=gflag.gsv.bbj.genesetview;
checkInputByvalue('gss_opt', g.gss_opt);
checkInputByvalue('gss_origin', g.gss_origin);
var pos=absolutePosition(event.target);
invokegssp(3,pos[0]+event.target.clientWidth,pos[1]);
document.body.addEventListener('mousedown', gssp_close, false);
}
/*
function bbg_invokegss(event)
{
// invoke gene struct selection panel for bigbed generator
checkInputByvalue('gss_opt', document.getElementById('bbg_gss_opt').innerHTML);
checkInputByvalue('gss_origin', document.getElementById('bbg_gss_origin').innerHTML);
invokegssp(4, event.clientX+20, event.clientY);
document.body.addEventListener('mousedown', gssp_close, false);
}
*/
function gpStandalone_invokegss(event)
{
// invoke gss panel for geneplot standalone
checkInputByvalue('gss_opt', document.getElementById('gpStandalone_gss_opt').innerHTML);
checkInputByvalue('gss_origin', document.getElementById('gpStandalone_gss_origin').innerHTML);
var pos=absolutePosition(event.target);
invokegssp(5, pos[0]+event.target.clientWidth,pos[1]);
document.body.addEventListener('mousedown', gssp_close, false);
}

function ensureNonezerolengthregion(which)
{
/* if using custom region and spanning length is zero, return true
'which' is same as gsselect.which
*/
var bbj=gflag.gsv.bbj?gflag.gsv.bbj:gflag.browser;
var g=bbj.genesetview;
switch(which) {
case 1:
case 2:
case 3:
	if(g.gss_opt!="custom") return false;
	if(g.gss_up+g.gss_down==0) return true;
	return false;
default:
	fatalError('ensureNonezerolengthregion: unknown which');
}
}

function gss_param(which)
{
/* provide gene struct selector parameter for ajax call
argument is same as gsselect.which
*/
if(which==1||which==2||which==3) {
	/* FIXME unable to clearly decide the calling browser is potential bug
	*/
	var bbj=gflag.gsv.bbj?gflag.gsv.bbj:gflag.browser;
	var g=bbj.genesetview;
	return '&gss_opt='+g.gss_opt+'&gss_origin='+g.gss_origin+'&gss_up='+g.gss_up+'&gss_down='+g.gss_down;
}
var p_opt,p_origin,p_up,p_down;
if(which==4) {
	p_opt = 'bbg_gss_opt';
	p_origin = 'bbg_gss_origin';
	p_up = 'bbg_gss_up';
	p_down = 'bbg_gss_down';
} else if(which==5) {
	p_opt = 'gpStandalone_gss_opt';
	p_origin = 'gpStandalone_gss_origin';
	p_up = 'gpStandalone_gss_up';
	p_down = 'gpStandalone_gss_down';
} else {fatalError('gss_param: unknown which');}
return "&gss_opt="+document.getElementById(p_opt).innerHTML+
	"&gss_origin="+document.getElementById(p_origin).innerHTML+
	"&gss_up="+document.getElementById(p_up).innerHTML+
	"&gss_down="+document.getElementById(p_down).innerHTML;
}

function gsr_change()
{
// called by selecting genestruct radio button or sliding the slider
var v = getValue_by_radioName("gss_opt");
var says;
var uplen = gss_slider_uplength();
var downlen = gss_slider_downlength();
if(v == 'custom') {
	gsselect.sliderpanel.style.display = 'block';
	says = uplen+' bp upstream and '+downlen+' bp downstream surrounding '+getAlt_by_radioName('gss_origin');
} else {
	gsselect.sliderpanel.style.display = 'none';
	says = getAlt_by_radioName('gss_opt');
}

var w=gsselect.which;
if(w==1||w==2||w==3) {
	var g=gflag.gsv.bbj.genesetview;
	if(w==1)
		g.gss_submitcust_uisays.innerHTML=says;
	else if(w==2)
		g.gss_submitkegg_uisays.innerHTML=says;
	else if(w==3)
		g.gss_edit_uisays.innerHTML=says;
	g.gss_says=says;
	g.gss_opt=v;
	g.gss_origin= getValue_by_radioName('gss_origin');
	g.gss_up= uplen;
	g.gss_down= downlen;
} else if(w==5) {
	// standalone gene plot
	document.getElementById('gpStandalone_gss_says').innerHTML = says;
	document.getElementById('gpStandalone_gss_opt').innerHTML = v;
	document.getElementById('gpStandalone_gss_origin').innerHTML = getValue_by_radioName('gss_origin');
	document.getElementById('gpStandalone_gss_up').innerHTML = uplen;
	document.getElementById('gpStandalone_gss_down').innerHTML = downlen;
} else { fatalError('unknown gsselect.which'); }
}
function gss_slider_uplength() {
// upstream coordinate slider select length in base pair
	var len = 130 - parseInt(gsselect.upslider.style.left);
	if(len == 0) return 0;
	return parseInt((5000/130)*len);
}
function gss_slider_downlength() {
// downstream coordinate slider select length in base pair
	var len = parseInt(gsselect.downslider.style.left);
	if(len == 0) return 0;
	return parseInt((5000/130)*len);
}
function gss_us_MD(event) {
// gss upstream slider
	event.preventDefault();
	gsselect.upslider.x = event.clientX;
	document.body.addEventListener("mousemove", gss_us_M, false);
	document.body.addEventListener("mouseup", gss_us_MU, false);
}
function gss_us_M(event) {
	var x = event.clientX;
	var oldx = gsselect.upslider.x;
	var l = parseInt(gsselect.upslider.style.left);
	if((x>oldx && l>=130) || (x<oldx && l<=0)) return;
	gsselect.upslider.style.left = l + x-oldx;
	gsselect.uptrail.style.width = parseInt(gsselect.uptrail.style.width) - x+oldx;
	l = parseInt(gsselect.upslider.style.left);
	if(l > 130) {
		gsselect.upslider.style.left = 130;
		gsselect.uptrail.style.width = 0;
	} else if(l<0) {
		gsselect.upslider.style.left = 0;
		gsselect.uptrail.style.width = 130;
	}
	// set coord display
	l = parseInt(gsselect.upslider.style.left);
	document.getElementById("leftgliderlength").innerHTML = parseInt(5000/130 * (130-l));
	gsselect.upslider.x = event.clientX;
}
function gss_us_MU() {
	document.body.removeEventListener("mousemove", gss_us_M, false);
	document.body.removeEventListener("mouseup", gss_us_MU, false);
	gsr_change();
}
function gss_ds_MD(event) {
// ds: downstream slider
	event.preventDefault();
	gsselect.downslider.x = event.clientX;
	document.body.addEventListener("mousemove", gss_ds_M, false);
	document.body.addEventListener("mouseup", gss_ds_MU, false);
}
function gss_ds_M(event) {
	var x = event.clientX;
	var oldx = gsselect.downslider.x;
	var l = parseInt(gsselect.downslider.style.left);
	if((x>oldx && l>=130) || (x<oldx && l<=0)) return;
	gsselect.downslider.style.left = l + x-oldx;
	gsselect.downtrail.style.width = parseInt(gsselect.downtrail.style.width) + x-oldx;
	l = parseInt(gsselect.downslider.style.left);
	if(l > 130) {
		gsselect.downslider.style.left = 130;
		gsselect.downtrail.style.width = 130;
	} else if(l<0) {
		gsselect.downslider.style.left = 0;
		gsselect.downtrail.style.width = 0;
	}
	// set coord display
	l = parseInt(gsselect.downslider.style.left);
	document.getElementById("rightgliderlength").innerHTML = parseInt(5000/130 * l);
	gsselect.downslider.x = event.clientX;
}
function gss_ds_MU() {
	document.body.removeEventListener("mousemove", gss_ds_M, false);
	document.body.removeEventListener("mouseup", gss_ds_MU, false);
	gsr_change();
}

/* __gss__ */





/*** __dsp__ ***/

Browser.prototype.getDspStat=function()
{
// return array for saving status, see dbSchema.dia
var startr = this.regionLst[this.dspBoundary.vstartr];
var stopr = this.regionLst[this.dspBoundary.vstopr];
var tt = this.getViewRangeCoord();
if(this.is_gsv())
	return [startr[6], tt[0], stopr[6], tt[1]];
return [startr[0], tt[0], stopr[0], tt[1]];
}

Browser.prototype.getViewRangeCoord=function()
{
// return [start, stop] genomic coord of dspBoundary.vstarts/vstops
var r1 = this.regionLst[this.dspBoundary.vstartr];
var r2 = this.regionLst[this.dspBoundary.vstopr];
if(this.entire.atbplevel)
	return [r1[3]+this.dspBoundary.vstarts, r2[3]+this.dspBoundary.vstops];
else
	return [r1[3]+parseInt(r1[7]*this.dspBoundary.vstarts), r2[3]+parseInt(r2[7]*this.dspBoundary.vstops)];
}

function regionlst_spseekright(rlst, _entire, rid, spid, spnum)
{
/* on regionLst seek to right from given point by a number of summary points
- rlst: regionLst or similar
- _entire: to escape collision with global variable
- rid: index of start region, in regionLst
- spid: start point in this region, dspBoundary.vstarts or similar,
        if atbplevel, should be coordinate, else, sp number
- spnum: # of pixels to seek, must not be bp

count spacing between regions
return array of [region index, number]
if atbplevel, "number" is coordinate, else, is sp number
*/
if(rid<0 || spid<0) fatalError('regionlst_spseekright: negative param ('+rid+', '+spid+')');
if(spnum == 0) return [rid, spid];
if(_entire.atbplevel) {
	// spid is .vstarts, vstops, should be # of bp
	for(var i=rid; i<rlst.length; i++) {
		if(spnum <= 0) {
			if(i==0) fatalError("regionlst_spseekright: irregularity (atbplevel)...");
			return [i-1, rlst[i-1][4]-rlst[i-1][3]-1];
		}
		var start = (i==rid) ? spid : 0;
		var remain = (rlst[i][4]-rlst[i][3]-start) * _entire.bpwidth;
		if(remain >= spnum)
			return [i, start+parseInt(spnum/_entire.bpwidth)];
		spnum -= remain + regionSpacing.width;
	}
	i = rlst.length-1;
	return [i, rlst[i][4]-rlst[i][3]-1];
}
for(var i=rid; i<rlst.length; i++) {
	if(spnum <= 0) {
		if(i == 0) fatalError("regionlst_spseekright: irregularity...");
		return [i-1, rlst[i-1][5]-1];
	}
	var start = (i==rid) ? spid : 0;
	var remain = rlst[i][5] - start;
	if(remain >= spnum)
		return [i, start+spnum-1]; // FIXME patch of -1
	spnum -= remain + regionSpacing.width;
}
i = rlst.length-1;
return [i, rlst[i][5]-1];
}

function regionlst_spseekleft(rlst, _entire, rid, spid, spnum) {
/* on regionLst seek to left by a number of summary points */
	if(rid<0 || spid<0) fatalError('regionlst_spseekleft: negative param ('+rid+', '+spid+')');
	if(spnum == 0) return [rid, spid];
	if(_entire.atbplevel) {
		for(var i=rid; i>=0; i--) {
			if(spnum <= 0) {
				if(i == rlst.length-1)
					fatalError("regionlst_spseekleft: irregularity (atbplevel) ...");
				return [i+1, 0];
			}
			var stop = (i==rid) ? spid : (rlst[i][4]-rlst[i][3]-1);
			if(stop*_entire.bpwidth >= spnum)
				return [i, stop-parseInt(spnum/_entire.bpwidth)];
			spnum -= stop*_entire.bpwidth + regionSpacing.width;
		}
		return [0,0];
	}
	for(var i=rid; i>=0; i--) {
		if(spnum <= 0) {
			if(i == rlst.length-1)
				fatalError("regionlst_spseekleft: irregularity...");
			return [i+1, 0];
		}
		var stop = (i==rid) ? spid+1 : rlst[i][5];
		if(stop >= spnum)
			return [i, stop-spnum];
		spnum -= stop + regionSpacing.width;
	}
	// not exhausted, tolerate
	return [0, 0];
}
function getPointCoord(rlst, _entire, rid, spid) {
/* rid: regionLst index
spid: summary point, or pixel number, relative offset at this region start
based on info in regionLst and current zoom level, return coordinate (integer)
!Warning! spid can never be # of bp
*/
	if(_entire.atbplevel)
		return rlst[rid][3] + parseInt(spid/_entire.bpwidth);
	else
		return rlst[rid][3] + parseInt(rlst[rid][7]*spid);
}


Browser.prototype.atLeftBorder=function()
{
// see if leftmost point in regionLst is at left border
var b=this.genome.border;
var r=this.regionLst[0];
if(this.is_gsv())
	return (r[6]==b.lname) && (r[3]<=b.lpos);
return (r[0]==b.lname) && (r[3]<=b.lpos);
}

Browser.prototype.atRightBorder=function()
{
// see if rightmost point in regionLst is at right border
var b=this.genome.border;
var r = this.regionLst[this.regionLst.length-1];
if(this.is_gsv())
	return (r[6]==b.rname) && (r[4]>=b.rpos);
return (r[0]==b.rname) && (r[4]>=b.rpos);
}

Browser.prototype.jsonDsp=function(data)
{
/* update lots of stuff related with dsp:
- border
- move
- entire
- regionLst
- dspBoundary
*/
if('border' in data) {
	// XXX border should be browser attribute
	this.genome.border={
		lname:data.border[0],
		lpos:data.border[1],
		rname:data.border[2],
		rpos:data.border[3]};
}

var in_gsv = this.is_gsv();

this.entire.atbplevel = ('atbplevel' in data);
if(this.move.direction==null) {
	/** not panning **/
	this.regionLst = data.regionLst;
	if(this.entire.atbplevel) {
		/* atbplevel is solely decided by cgi
		entering bplevel must be in non-moving condition (moving cannot result in atbplevel)
		compute .bpwidth
		*/
		var totallen=0;
		for(var i=0; i<this.regionLst.length; i++) totallen+=(this.regionLst[i][4]-this.regionLst[i][3]);
		for(var i=1; i<MAXbpwidth_bold; i++) {
			if(totallen*i >= this.hmSpan*3)
				break;
		}
		this.entire.bpwidth = i;
		/* atbplevel special update:
		regionLst[i][5] to be region plotting width
		entire.spnum to be plotting width of everything...
		*/
		for(i=0; i<this.regionLst.length; i++) {
			var r=this.regionLst[i];
			r[5] = this.entire.bpwidth * (r[4]-r[3]);
		}
	}
	this.updateEntire();

	// compute .styleLeft for all movable components
	if(!('viewStart' in data)) fatalError("jsonDsp: viewStart missing when not moving");
	var startRegionIdx=data.viewStart[0];
	var startRegionCoord=data.viewStart[1];
	/* parameters defines start point of visible portion of tracks
	   anything on the left of this point will be hidden from display,
	   so need to compute their plot length, which is move.styleLeft
	 */
	var sr=this.regionLst[startRegionIdx];
	if(startRegionCoord < sr[3])
		fatalError('wrong startRegionCoord, beyond region start border');
	this.move.styleLeft = 0;
	if(this.entire.atbplevel) {
		for(var i=0; i<startRegionIdx; i++)
			this.move.styleLeft += this.entire.bpwidth*(this.regionLst[i][4]-this.regionLst[i][3])+regionSpacing.width;
		this.move.styleLeft += this.entire.bpwidth*(startRegionCoord-sr[3]);
	} else {
		// regions before start region
		for(var i=0; i<startRegionIdx; i++)
			this.move.styleLeft += this.regionLst[i][5] + regionSpacing.width;
		// add number of summary points in this region before point
		this.move.styleLeft += parseInt((startRegionCoord-sr[3])/sr[7]);
	}
	this.move.styleLeft = 0-this.move.styleLeft;
	this.updateDspBoundary();
	this.scalebarSlider_fill();
	this.drawNavigator();
	return;
}

/* panning
beware: atbplevel, region data passed from CGI have # of bp as [5], need to multiply by entire.bpwidth
entire.bpwidth must have already been determined as above, and won't change during moving
*/
if(this.entire.atbplevel) {
	for(var i=0; i<data.regionLst.length; i++)
		data.regionLst[i][5] *= this.entire.bpwidth;
}
// determine whether to merge regions
this.move.merge = false;
if(in_gsv) {
	if(this.move.direction == 'l') {
		var n = data.regionLst[data.regionLst.length-1]; // new
		var o = this.regionLst[0]; // old
		if(n[6] == o[6]) {
			this.move.merge = true;
			this.move.offsetShift = n[5];
		}
	} else {
		var n = data.regionLst[0]; // new
		var o = this.regionLst[this.regionLst.length-1]; // old
		if(n[6] == o[6]) {
			this.move.merge = true;
			this.move.offsetShift = o[5];
		}
	}
} else {
	if(this.move.direction == 'l') {
		var n = data.regionLst[data.regionLst.length-1]; // new
		var o = this.regionLst[0]; // old
		// only look at chr name and region bstart!
		if(n[0]==o[0] && n[1]==o[1]) {
			this.move.merge = true;
			// set move.offsetShift for shifting old bed items
			this.move.offsetShift = n[5];
		}
	} else {
		var n = data.regionLst[0]; // new
		var o = this.regionLst[this.regionLst.length-1]; // old
		// only look at chr name and region bstop!
		if(n[0]==o[0] && n[2]==o[2]) {
			this.move.merge = true;
			// set move.offsetShift for shifting new bed items
			this.move.offsetShift = o[5];
		}
	}
}
/* special attention --
move.styleLeft has been set to a new value during move,
where .style.left of all movable components were set to it.
If expose on right, .styleLeft won't need to be changed,
but if on left, it has to be changed to accommondate new data.

1. find current view region start by setting
dspBoundary.vstartr .vstarts using old regionLst
2. update regionLst
if .vstartr==0, and move to left, and merge: need to shift .vstartr .vstarts
3. build dspBoundary
*/
// make new start point
var tmpr = regionlst_spseekright(this.regionLst, this.entire, 0,0,-this.move.styleLeft);
this.dspBoundary.vstartr = tmpr[0];
this.dspBoundary.vstarts = tmpr[1];
// update regionLst
var newlst = data.regionLst;
if(this.move.direction == 'l') {
	if(this.move.merge) {
		var lastr = newlst[newlst.length-1];
		this.regionLst[0][3] = lastr[3]; // dstart
		this.regionLst[0][5] += lastr[5]; // # summary points
		if(this.dspBoundary.vstartr == 0) {
			// update .vstarts, beware the differential treatment
			this.dspBoundary.vstarts += this.entire.atbplevel?(lastr[4]-lastr[3]):lastr[5];
		}
		newlst.pop();
	}
	this.regionLst = newlst.concat(this.regionLst);
	// shift startRegionIdx
	this.dspBoundary.vstartr += newlst.length;
} else {
	if(this.move.merge) {
		var firstr = newlst[0];
		var lastr = this.regionLst[this.regionLst.length-1];
		lastr[4] = firstr[4]; // dstop
		lastr[5] += firstr[5]; // # summary points
		newlst.shift();
	}
	this.regionLst = this.regionLst.concat(newlst);
}

//  upon moving to left, need to re-compute new move.styleLeft  
this.move.styleLeft = 0;
for(var i=0; i<this.dspBoundary.vstartr; i++) {
	this.move.styleLeft += this.regionLst[i][5] + regionSpacing.width;
}
this.move.styleLeft += this.dspBoundary.vstarts*(this.entire.atbplevel?this.entire.bpwidth:1)+1;
this.move.styleLeft = 0-this.move.styleLeft;

this.updateEntire();
this.updateDspBoundary();
this.scalebarSlider_fill();
this.drawNavigator();
/* over */
}

Browser.prototype.updateDspBoundary=function()
{
/* call after zoom level might have been changed
updates .dspBoundary and .entire
requires:
move.styleLeft 
regionLst, where [5] region plot width must be ready
*/
var d=this.dspBoundary;
var t = regionlst_spseekright(this.regionLst, this.entire, 0, 0, -this.move.styleLeft);
d.vstartr = t[0];
d.vstarts = t[1];
t = regionlst_spseekright(this.regionLst, this.entire, d.vstartr, d.vstarts, this.hmSpan);
d.vstopr = t[0];
d.vstops = t[1];
t = regionlst_spseekright(this.regionLst, this.entire, d.vstopr, d.vstops, this.hmSpan);
d.rwr = t[0];
d.rws = t[1];
t = regionlst_spseekleft(this.regionLst, this.entire, d.vstartr, d.vstarts, this.hmSpan);
d.lwr = t[0];
d.lws = t[1];
d.lwidx = 0;
d.lwrlpx = 0;
for(var i=0; i<d.lwr; i++) {
	d.lwidx += this.regionLst[i][5] + regionSpacing.width;
	d.lwrlpx += this.regionLst[i][5] + regionSpacing.width;
}
d.lwidx += d.lws * (this.entire.atbplevel ? this.entire.bpwidth : 1);
this.updateDspstat();
}


Browser.prototype.updateEntire=function()
{
// call when dsp change (pan, zoom, ...)
this.entire.length = 0;
this.entire.spnum = 0;
for(var i=0; i<this.regionLst.length; i++) {
	var r=this.regionLst[i];
	this.entire.length += r[4]-r[3];
	this.entire.spnum += r[5];
}
this.entire.summarySize=this.entire.length/this.entire.spnum;
this.entire.spnum += this.regionLst.length-1; // spacing between regions
for(var i=0; i<this.regionLst.length; i++) {
	var r=this.regionLst[i];
	r[7] = (r[4]-r[3])/r[5]; // this is of no use at bplevel
}
}

function menuDecorJuxtapose()
{
var bbj=gflag.menu.bbj;
var tk=gflag.menu.tklst[0];
if(isCustom(tk.ft)) {
	bbj.juxtaposition.type=RM_jux_c;
	bbj.juxtaposition.what=tk.url;
	bbj.juxtaposition.note='custom bed track';
} else {
	bbj.juxtaposition.type=RM_jux_n;
	bbj.juxtaposition.what=tk.name;
	bbj.juxtaposition.note=tk.label;
}

bbj.cloak();
print2console("juxtaposing "+bbj.juxtaposition.note+"...", 0);
bbj.ajaxX(bbj.displayedRegionParam()+"&changeGF=on");
menu_hide();
}

function menuTurnoffJuxtapose() { gflag.menu.bbj.turnoffJuxtapose(true); }

Browser.prototype.turnoffJuxtapose=function(doajax)
{
/* argument is boolean, if true, will run ajax and show data over default region

never forget!!
in case of running gsv, .border must be updated back!!
*/
menu_hide();
if(this.juxtaposition.type == 0) return;
var oldjt = this.juxtaposition.type;
this.juxtaposition.note = 'genome';
this.juxtaposition.type = RM_genome;
this.juxtaposition.what = 'genome';
/*
document.getElementById("scaffoldnotinservice").style.display = "none";
document.getElementById("scaffoldinservice").style.display = "block";
*/
if(oldjt==RM_jux_n || oldjt==RM_jux_c) {
	if(doajax)
		this.ajaxX(this.displayedRegionParam()+"&changeGF=on");
} else if(oldjt==RM_gsv_c || oldjt==RM_gsv_kegg) {
	this.genesetviewTurnedoff();
	var b=gflag.gsv.bbj.__gsv_offbutt;
	if(b) {
		b.style.display='none';
	} else {
		b=gflag.browser.__gsv_offbutt;
		if(b) b.style.display='none';
	}
	if(doajax) {
		this.ajaxX('jump=on&jumppos2='+this.genome.defaultStuff.coord);
	}
} else {
	fatalError('turnoffJuxtapose: unknown juxtaposition.type '+oldjt);
}
}

Browser.prototype.cgiJump2coord=function(coord)
{
if(this.is_gsv()){
	print2console('Cannot jump in Gene Set View mode',2);
	return;
}
this.cloak();
print2console("jumping to coordinate...", 0);
this.ajaxX(this.displayedRegionParam()+"&jump=on&jumppos="+coord);
}

function menu_lstholder_jump(event)
{
var bbj=gflag.menu.bbj;
if(bbj.is_gsv()) {
	print2console('Cannot jump in Gene Set View mode', 2);
	return;
}
var tr=event.target;
while(tr.tagName!='TR') tr=tr.parentNode;
var g=gflag.genelst[tr.idx];
bbj.cgiJump2coord(g.chrom+':'+g.start+'-'+g.stop);
menu_hide();
}

function menu_lstholder_makesplinter(event)
{
var bbj=gflag.menu.bbj;
var tr=event.target;
while(tr.tagName!='TR') tr=tr.parentNode;
var g=gflag.genelst[tr.idx];
bbj.splinter(g.chrom+':'+g.start+'-'+g.stop);
menu_hide();
}

function menuJump()
{
/* called by pushing button, context specific:
1. relocate for trunk
2. relocate for splinter
3. make a splinter
*/
var bbj=gflag.menu.bbj;
var jtype=gflag.jump.type;
if(jtype!=3 && bbj.is_gsv()) {
	print2console('Cannot jump in Gene Set View mode', 2);
	return;
}
var param = document.getElementById('jumppos').value;
if(param.length!=0 && param!="enter coordinate") {
	var str = param.replace(/,/g, ''); // remove comma
	str = str.replace(/\t/g, ' '); // replace tab with space
	if(jtype==1 || jtype==2) {
		bbj.cgiJump2coord(str);
	} else if(jtype==3) {
		var c=bbj.genome.parseCoordinate(str);
		if(c==null) {
			print2console('Mangled coordinate string',2);
			return;
		}
		bbj.splinter(c.join(' '));
	} else {
		fatalError('menuJump: unknown jump.type');
	}
	return;
}
param = document.getElementById('jumpgene').value;
if(param.length!=0 && param!='enter gene name') {
	if(jtype==1 || jtype==2) {
		bbj.cloak();
		print2console("jumping to one gene...", 0);
		bbj.ajaxX(bbj.displayedRegionParam()+"&jump=on&jumpgene="+param);
	} else if(jtype==3) {
		// get coord for querying gene
		bbj.ajax('querygene=on&dbName='+bbj.genome.name+'&name='+param,function(data){
			if(!data.lst) {
				print2console('Error querying gene info, please try again',2);
				return;
			}
			if(data.lst.length==0) {
				print2console('No gene match your input',2);
				return;
			}
			var bbj=horcrux[data.horcrux];
			if(data.lst.length==1) {
				var g=data.lst[0];
				bbj.splinter(g.chrom+':'+g.start+'-'+g.stop);
				menu_hide();
			} else {
				var table=document.getElementById('jumplstholder');
				table.style.display='block';
				genelist2selectiontable(data.lst, table, menu_lstholder_makesplinter);
				placePanel(menu);
				if('newscaffold' in data)
					bbj.ajax_scfdruntimesync();
			}
		});
	} else {
		fatalError('menuJump: unknown jump.type');
	}
	return;
}
print2console("neither gene nor coordinate given", 2);
}

function menuJump_coord_KU(event) { if(event.keyCode==13) menuJump(); }

function menuJump_gene_KU(event)
{
if(event.keyCode==13) {
	menuJump();
	menu2_hide();
	return;
}
document.getElementById('jumplstholder').style.display='none';
var ss=event.target.value;
if(ss.length<=1) {
	menu2_hide();
	return;
}
var bbj=gflag.menu.bbj;
bbj.ajax('findgenebypartialname=on&dbName='+bbj.genome.name+'&query='+ss,function(data){
	if(!data.lst || data.lst.length==0) {
		menu2_hide();
		menu2.style.display='none';
		return;
	}
	menu2_show();
	var p=absolutePosition(document.getElementById('jumpgene'));
	menu2.style.left=p[0];
	menu2.style.top=p[1]+20;
	stripChild(menu2,0);
	// returned gene names could be identical
	var s={};
	for(var i=0; i<data.lst.length; i++) s[data.lst[i]]=1;
	// put genes whose name start with the query to front
	var lst=[];
	var query=data.query.toLowerCase();
	for(var n in s) {
		var sn=n.toLowerCase();
		if(sn.indexOf(query)==0) {
			lst.push(n);
			delete s[n];
		}
	}
	for(n in s) lst.push(n);
	for(var i=0; i<Math.min(20,lst.length); i++) {
		var d=document.createElement('div');
		d.className='menu2ele';
		d.innerHTML=d.genename=lst[i];
		d.addEventListener('click',menu2ele_click,false);
		menu2.appendChild(d);
	}
});
}

/*** __dsp__ ends ***/




/*** __track__ general func for all track types ***/

function track_Mout(event)
{
var bbj=gflag.browser;
var tk=bbj.findTrack(event.target.tkname);
if(tk==undefined) {
	// this is the case for alethiometer splinter
	return;
}
tk.header.style.backgroundColor='transparent';
pica_hide();
if(tk.ft==FT_lr_n||tk.ft==FT_lr_c)
	indicator.style.display=indicator6.style.display='none';
}
function track_Mmove(event)
{
/* moving cursor over track canvas
show data of the point under the cursor
must tell if this track is from a splinter
*/
var bbj=gflag.browser;
var sbj;
if(event.target.splinterTag==undefined)
	sbj=bbj;
else
	sbj=bbj.splinters[event.target.splinterTag];
var tk=sbj.findTrack(event.target.tkname);
tk.header.style.backgroundColor=colorCentral.tkentryfill;
var pos=absolutePosition(sbj.hmdiv.parentNode);
if(tk.ft==FT_cat_n||tk.ft==FT_cat_c) {
	var tmp=regionlst_spseekright(sbj.regionLst, sbj.entire, sbj.dspBoundary.vstartr, sbj.dspBoundary.vstarts, event.clientX+document.body.scrollLeft-pos[0]);
	var r=sbj.regionLst[tmp[0]];
	pica_go(event.clientX,event.clientY);
	var inf=tk.cateInfo[tk.data[tmp[0]][tmp[1]]];
	picasays.innerHTML= '<div style="padding:5px;font-size:16px;color:white">'+
		'<div class=squarecell style="display:inline-block;background-color:'+inf[1]+'"></div> '+inf[0]+
		'<div style="padding-top:5px;font-size:12px;color:#C5D5D5">'+
		tk.label+'<br>'+r[0]+' '+
		(r[3]+parseInt(tmp[1]*(sbj.entire.atbplevel?1:sbj.entire.summarySize)))+
		'</div></div>';
	return;
}
if(isHmtk(tk.ft) || tk.mode==M_show || tk.mode==M_den) {
	// no matter whether the track is in ghm or decor, the x is same
	var tmp=regionlst_spseekright(sbj.regionLst, sbj.entire, sbj.dspBoundary.vstartr, sbj.dspBoundary.vstarts, event.clientX+document.body.scrollLeft-pos[0]);
	var r=sbj.regionLst[tmp[0]];
	pica_go(event.clientX,event.clientY);
	picasays.innerHTML= '<div style="padding:5px;font-size:16px;color:white">'+
		tk.data[tmp[0]][tmp[1]]+
		'<div style="padding-top:5px;font-size:12px;color:#C5D5D5">'+
		tk.label+'<br>'+r[0]+' '+
		(r[3]+parseInt(tmp[1]*(sbj.entire.atbplevel?1:sbj.entire.summarySize)))+
		'</div></div>';
	return;
}
if(tk.mode==M_arc) {
	var mX = event.clientX+document.body.scrollLeft-sbj.move.styleLeft-bbj.leftColumnWidth;
	var mY = event.clientY+document.body.scrollTop-absolutePosition(event.target)[1];
	var item=findDecoritem_longrange_arc(tk.data_arc, mX, mY);
	if(item==null) {
		pica_hide();
		return;
	}
	picasays.innerHTML='score: '+tk.data_chiapet[item[3]][item[4]][3];
	pica_go(event.clientX,event.clientY);
}
if(tk.mode==M_trihm) {
	pica_hide();
	indicator.style.display=indicator6.style.display='none';
	var mX, mY, hx, hy;
	mX = event.clientX+document.body.scrollLeft-sbj.move.styleLeft-bbj.leftColumnWidth;
	mY = event.clientY+document.body.scrollTop-absolutePosition(event.target)[1];
	hx=bbj.leftColumnWidth;
	hy=pos[1];
	hh=sbj.hmdiv.clientHeight+sbj.decordiv.clientHeight+sbj.ideogram.canvas.height;
	var item=findDecoritem_longrange_trihm(tk.data_trihm, tk.qtc.anglescale*Math.PI/4, mX, mY);
	if(item==null)
		return;
	var item2=tk.data_chiapet[item[4]][item[5]];
	if(item2[16][4][0][0]==item2[16][4][1][0] && item2[16][4][0][2]>=item2[16][4][1][1])
		return;
	// left beam
	var x=item2[0]+sbj.move.styleLeft;
	if(x+item[2]>0) {
		indicator.style.display='block';
		indicator.style.height=hh;
		indicator.style.top=hy;
		indicator.style.left=Math.max(hx,x+hx);
		indicator.style.width=Math.min(x+item[2],item[2]);
	} else {
		indicator.style.display='none';
	}
	// right beam
	x=item2[0]+item2[1]+sbj.move.styleLeft-item[3];
	if(x<sbj.hmSpan) {
		indicator6.style.display='block';
		indicator6.style.height=hh;
		indicator6.style.top=hy;
		indicator6.style.left=x+hx;
		indicator6.style.width=Math.min(sbj.hmSpan-x,item[3]);
	} else {
		indicator6.style.display='none';
	}
	picasays.innerHTML='score: '+tk.data_chiapet[item[4]][item[5]][3];
	pica_go(event.clientX,event.clientY);
}
/* over */
}

function duplicateTkobj(o)
{
var o2={name:o.name,
	label:o.label,
	ft:o.ft,
	url:o.url,
	qtc:{},
	mode:isHmtk(o.ft)?M_show:M_den,
};
qtc_paramCopy(o.qtc, o2.qtc);
if(o.ft==FT_cat_n||o.ft==FT_cat_c) {
	o2.cateInfo={};
	cateInfo_copy(o.cateInfo,o2.cateInfo);
}
return o2;
}
function grandaddtracks(event) {
    // select one for gene set sort
	if(apps.bev.style.display!='none'||
	apps.custtk.style.display!='none'||
	apps.gplot.style.display!='none'||
	apps.gsv.style.display!='none'||
	apps.hmtk.style.display!='none'||
	apps.session.style.display!='none'||
	apps.svg.style.display!='none') return;
	if(gflag.browser==null) return;
	if(gflag.browser.genome==null) return;
    var pos = absolutePosition(event.target);
	menu_shutup();
	menu_show(12, pos[0]-8,pos[1]-8+event.target.clientHeight);
	menu.grandadd.style.display='block';
}

Browser.prototype.highlighttrack=function(lst)
{
/* put indicator over some tracks
the tracks must be next to each other
first element in the list is assumed to be the one on top (determines box position)
*/
var pos=absolutePosition(lst[0].canvas);
var h=0;
for(var i=0; i<lst.length; i++)
	h+=lst[i].canvas.height;
placeIndicator3(pos[0]-this.move.styleLeft, pos[1], this.hmSpan, h);
}

function trackParam(_tklst) {
/* for composing url param of all sorts of tracks
argument is list of track display object with following attributes
.name .label .mode .url .ft
.qtc.pfilterscore .qtc.nfilterscore
*/
var ft2=[],ft3=[],ft12=[],ft13=[],ft14=[],ft15=[],
	decor0=[], decor1=[], decor8=[], decor4=[], decor5=[], decor9=[], decor10=[];
for(var i=0; i<_tklst.length; i++) {
	var name=_tklst[i].name;
	var mode=_tklst[i].mode;
	var url=_tklst[i].url;
	var label=_tklst[i].label;
	switch(_tklst[i].ft) {
	case FT_bedgraph_c:
		ft3.push(name+','+label+','+url+','+mode);
		break;
	case FT_bigwighmtk_c:
		ft15.push(name+','+label+','+url+','+mode);
		break;
	case FT_cat_c:
		ft13.push(name+','+label+','+url+','+mode);
		break;
	case FT_bedgraph_n:
		ft2.push(name+','+mode);
		break;
	case FT_bigwighmtk_n:
		ft14.push(name+','+mode);
		break;
	case FT_cat_n:
		ft12.push(name+','+mode);
		break;
	case FT_bed_n:
		decor0.push(name+','+mode);
		break;
	case FT_bed_c:
		decor1.push(name+','+label+','+url+','+mode);
		break;
	case FT_qdecor_n:
		decor8.push(name+','+mode);
		break;
	case FT_sam_n:
		decor4.push(name+','+mode);
		break;
	case FT_sam_c:
		decor5.push(name+','+label+','+url+','+mode);
		break;
	case FT_lr_n:
		decor9.push(name+','+mode+','+_tklst[i].qtc.pfilterscore+','+_tklst[i].qtc.nfilterscore);
		break;
	case FT_lr_c:
		decor10.push(name+','+label+','+url+','+mode+','+_tklst[i].qtc.pfilterscore+','+_tklst[i].qtc.nfilterscore);
		break;
	default: fatalError('trackParam: unknown ft ('+name+' '+mode+' '+url+' '+label+')');
	}
}
return (ft2.length>0 ? '&hmtk2='+ft2.join(',') : '')+
	(ft3.length>0 ? '&hmtk3='+ft3.join(",") : '')+
	(ft14.length>0 ? '&hmtk14='+ft14.join(',') : '')+
	(ft15.length>0 ? '&hmtk15='+ft15.join(',') : '')+
	(ft12.length>0 ? '&hmtk12='+ft12.join(',') : '')+
	(ft13.length>0 ? '&hmtk13='+ft13.join(",") : '')+
	(decor0.length>0 ? '&decor0='+decor0.join(',') : '') +
	(decor1.length>0 ? '&decor1='+decor1.join(',') : '') +
	(decor9.length>0 ? '&decor9='+decor9.join(',') : '') +
	(decor10.length>0 ? '&decor10='+decor10.join(',') : '') +
	(decor8.length>0 ? '&decor8='+decor8.join(',') : '') +
	(decor4.length>0 ? '&decor4='+decor4.join(',') : '') +
	(decor5.length>0 ? '&decor5='+decor5.join(',') : '');
}

Browser.prototype.findTrack=function(tkname)
{
// display object
for(var i=0; i<this.tklst.length; i++) {
	if(this.tklst[i].name==tkname)
		return this.tklst[i];
}
return null;
}
Browser.prototype.removeTrack=function(namelst)
{
var hashmtk=false;
for(var i=0; i<namelst.length; i++) {
	var tk=this.findTrack(namelst[i]);
	if(tk==null) continue;
	if(tk.where==1) {
		if(this.hmheaderdiv!=null)
			this.hmheaderdiv.removeChild(tk.header);
		this.hmdiv.removeChild(tk.canvas);
		if(this.mcm!=null)
			this.mcm.tkholder.removeChild(tk.atC);
		hashmtk=true;
	} else {
		if(this.decorheaderdiv!=null)
			this.decorheaderdiv.removeChild(tk.header);
		this.decordiv.removeChild(tk.canvas);
	}
	for(var j=0; j<this.tklst.length; j++) {
		if(this.tklst[j].name==namelst[i]) {
			this.tklst.splice(j,1);
			break;
		}
	}
}
if(hashmtk) {
	this.prepareMcm();
	this.drawMcm();
}
this.trackHeightChanged();

if(this.splinterTag==null) {
	// this is trunk
	// to solve the problem that trihm pillars don't hide
	indicator.style.display=indicator6.style.display='none';
	// regenerate facet when needed
	if(gflag.tsp.invoke.type==1 || gflag.tsp.invoke.type==2) {
		this.facetclickedcell_remake();
	} else {
		for(var i=0; i<namelst.length; i++) {
			var o=this.genome.hmtk[namelst[i]];
			if(o!=undefined && !isCustom(o.ft)) {
				this.generateTrackselectionLayout();
				break;
			}
		}
	}
	for(var tag in this.splinters)
		this.splinters[tag].removeTrack(namelst);
}
/* over */
}




Browser.prototype.makeTrackDisplayobj=function(name,ft)
{
/* create display object
unified for all types
registry object must already exist, no matter native or custom
make doms for display

TODO pwc, htest track special cases
even bev tracks?
*/

// registry object
var oobj=this.genome.hmtk[name];
if(oobj==undefined) oobj=this.genome.decorInfo[name];
if(oobj==undefined) {
	oobj=__request_tk_registryobj(name,ft);
	if(oobj==undefined)
		fatalError('makeTrackDisplayobj: registry object not found for "'+name+'","'+ft+'"');
}

// display object
var obj={name:name, ft:ft, label:oobj.label, attrhash:{}, custmd:{}};

obj.attrhash={};
obj.attrlst=[];
obj.attrcoloridxlst=[];
obj.custmd={};
if('md' in oobj) {
	for(var i=0; i<oobj.md.length; i++)
		obj.attrhash[oobj.md[i]]=1;
}
if('custmd' in oobj) {
	for(var m in oobj.custmd)
		obj.custmd[m]=oobj.custmd[m];
}

// decide where (ghm or under) this track should appear initially
if((ft==FT_bed_n||ft==FT_bed_c||ft==FT_lr_n||ft==FT_lr_c||ft==FT_qdecor_n||ft==FT_sam_n||ft==FT_sam_c) || (name in this.genome.decorInfo)){
	obj.where=2;
	obj.grp=oobj.grp;
	obj.hasStruct=oobj.hasStruct;
	obj.skipped=0;
} else {
	obj.where=1;
}

// initial mode, should make into track2Style
if(isHmtk(ft)) {
	obj.mode=M_show;
} else {
	obj.mode=oobj.mode;
}
if(isCustom(ft)) obj.url=oobj.url;

/* track canvas
attach splinterid in case this is a splinter
*/
var c = document.createElement('canvas');
if(this.splinterTag!=null)
	c.splinterTag=this.splinterTag;
c.height=c.width=1;
c.style.display='block';
c.tkname=name;
obj.canvas=c;

c.addEventListener('mousemove', track_Mmove, false);
c.addEventListener('mouseout', track_Mout, false);
c.oncontextmenu=menu_track_browser;

// TODO clicking on categorical tracks
if(ft==FT_bed_n||ft==FT_bed_c||ft==FT_sam_n||ft==FT_sam_c||ft==FT_lr_n||ft==FT_lr_c)
	c.addEventListener('click', track_click, false);

// mcm canvas
// this is not shown in splinters
c = document.createElement('canvas');
c.style.display = "block";
c.tkname=name;
c.width=c.height=1;
c.addEventListener('mousedown',mcm_Mdown,false);
c.addEventListener('mouseover',mcm_Mover,false);
c.addEventListener('mousemove',mcm_tooltipmove,false);
c.addEventListener('mouseout',mcm_Mout,false);
c.oncontextmenu=menu_track_mcm;
obj.atC = c;

// header canvas
// not used in splinters
c = document.createElement('canvas');
c.style.display = 'block';
c.width=c.height=1;
c.tkname=name;
c.oncontextmenu=menu_track_browser;
c.addEventListener('mouseover',trackheader_Mover,false);
c.addEventListener('mouseout',trackheader_Mout,false);
c.addEventListener('mousedown',trackheader_MD,false);
obj.header=c;


/* apply style
in case of custom track, custom style can be defined with datahub
the user-chosen style is in registry object

in solving the issue of syncing style between trunk and splinters
splinter track will share .qtc with trunk track so style are always in sync
this requires all rendering attributes and score thresholds to be inside .qtc
*/
obj.qtc = {};

switch(ft) {
case FT_bed_n:
case FT_sam_n:
case FT_lr_n:
	qtc_paramCopy(defaultQtcStyle.density, obj.qtc);
	var style=this.genome.trackDefaultparam[name];
	if(style!=undefined) {
		/* track2Style table contains additional directives, which are passed on to tk.qtc
		currently in use: 'isrmsk'
		*/
		for(var n in style)
			obj.qtc[n] = style[n];
	}
	obj.qtc.anglescale=1;
	break;
case FT_bed_c:
	qtc_paramCopy(defaultQtcStyle.density, obj.qtc);
	var ss=defaultQtcStyle.ft1;
	obj.qtc.textcolor='style_textcolor' in oobj ? oobj.style_textcolor : ss.textcolor;
	obj.qtc.fontsize=ss.fontsize;
	obj.qtc.fontfamily=ss.fontfamily;
	obj.qtc.fontbold = ss.fontbold;
	obj.qtc.bedcolor = 'style_bedcolor' in oobj ? oobj.style_bedcolor : ss.bedcolor;
	break;
case FT_bedgraph_n:
	qtc_paramCopy(defaultQtcStyle.heatmap, obj.qtc);
	// 'custom default' override
	var ox= this.genome.trackDefaultparam[name];
	if(ox!=undefined) {
		for(var v in ox)
			obj.qtc[v]=ox[v];
	}
	break;
case FT_bedgraph_c:
	qtc_paramCopy(defaultQtcStyle.ft3, obj.qtc);
	if('style_pr' in oobj) obj.qtc.pr=oobj.style_pr;
	if('style_pg' in oobj) obj.qtc.pg=oobj.style_pg;
	if('style_pb' in oobj) obj.qtc.pb=oobj.style_pb;
	if('style_nr' in oobj) obj.qtc.nr=oobj.style_nr;
	if('style_ng' in oobj) obj.qtc.ng=oobj.style_ng;
	if('style_nb' in oobj) obj.qtc.nb=oobj.style_nb;
	if('style_height' in oobj) obj.qtc.height=oobj.style_height;
	break;
case FT_sam_c:
	qtc_paramCopy(defaultQtcStyle.density, obj.qtc);
	var ss=defaultQtcStyle.ft5;
	obj.qtc.textcolor=ss.textcolor;
	obj.qtc.fontsize=ss.fontsize;
	obj.qtc.fontfamily = ss.fontfamily;
	obj.qtc.fontbold = ss.fontbold;
	obj.qtc.forwardcolor= 'style_forwardcolor' in oobj ? oobj.style_forwardcolor : ss.forwardcolor;
	obj.qtc.reversecolor = 'style_reversecolor' in oobj ? oobj.style_reversecolor : ss.reversecolor;
	obj.qtc.mismatchcolor = 'style_mismatchcolor' in oobj ? oobj.style_mismatchcolor : ss.mismatchcolor;
	break;
case FT_qdecor_n:
	qtc_paramCopy(defaultQtcStyle.ft8, obj.qtc);
	break;
case FT_lr_c:
	qtc_paramCopy(defaultQtcStyle.density, obj.qtc);
	var ss=defaultQtcStyle.ft10;
	obj.qtc.textcolor= ss.textcolor;
	obj.qtc.fontsize= ss.fontsize;
	obj.qtc.fontfamily = ss.fontfamily;
	obj.qtc.fontbold = ss.fontbold;
	obj.qtc.pcolor= 'style_pr' in oobj ? 'rgb('+oobj.style_pr+','+oobj.style_pg+','+oobj.style_pb+')' : ss.pcolor;
	obj.qtc.ncolor= 'style_nr' in oobj ? 'rgb('+oobj.style_nr+','+oobj.style_ng+','+oobj.style_nb+')' : ss.ncolor;
	obj.qtc.pcolorscore = ss.pcolorscore;
	obj.qtc.ncolorscore = ss.ncolorscore;
	obj.qtc.pfilterscore = oobj.pfilterscore;
	obj.qtc.nfilterscore = oobj.nfilterscore;
	obj.qtc.anglescale=1;
	break;
case FT_cat_n:
	obj.cateInfo={};
	cateInfo_copy(oobj.cateInfo, obj.cateInfo);
	qtc_paramCopy(defaultQtcStyle.ft12, obj.qtc);
	break;
case FT_cat_c:
	obj.cateInfo={};
	cateInfo_copy(oobj.cateInfo, obj.cateInfo);
	qtc_paramCopy(defaultQtcStyle.ft13, obj.qtc);
	break;
case FT_bigwighmtk_n:
	// track could be qdecor but as bigwig
	if(name in this.genome.decorInfo)
		qtc_paramCopy(defaultQtcStyle.ft8, obj.qtc);
	else
		qtc_paramCopy(defaultQtcStyle.heatmap, obj.qtc);
	// 'custom default' override
	var ox= this.genome.trackDefaultparam[name];
	if(ox!=undefined) {
		for(var v in ox)
			obj.qtc[v]=ox[v];
	}
	break;
case FT_bigwighmtk_c:
	qtc_paramCopy(defaultQtcStyle.ft3, obj.qtc);
	if('style_pr' in oobj) obj.qtc.pr=oobj.style_pr;
	if('style_pg' in oobj) obj.qtc.pg=oobj.style_pg;
	if('style_pb' in oobj) obj.qtc.pb=oobj.style_pb;
	if('style_nr' in oobj) obj.qtc.nr=oobj.style_nr;
	if('style_ng' in oobj) obj.qtc.ng=oobj.style_ng;
	if('style_nb' in oobj) obj.qtc.nb=oobj.style_nb;
	if('style_height' in oobj) obj.qtc.height=oobj.style_height;
	break;
default:
	fatalError('trying to assign default style but got unknown tk ft');
}

return obj;
}


Browser.prototype.jsonTrackdata=function(data)
{
/* parse track data from json object
will create display object if the track is new
handles *panning*
but do not render
*/
var lst=[];
if(data.hmtkData!=undefined) {
	for(var i=0; i<data.hmtkData.length; i++)
		lst.push(data.hmtkData[i]);
}
if(data.decorData!=undefined) {
	for(var i=0; i<data.decorData.length; i++)
		lst.push(data.decorData[i]);
}
var tknames=[];
if(lst.length==0) return;
for(var i=0; i<lst.length; i++) {
	var obj=this.findTrack(lst[i].name);
	if(obj==null) {
		obj=this.makeTrackDisplayobj(lst[i].name, lst[i].ft);
		this.tklst.push(obj);
		tknames.push([lst[i].name,true]);
	} else {
		tknames.push([lst[i].name,false]);
	}

	/* a few attributes of display object need to be recovered from the data object 
	e.g. decor track mode, long range track filtering scores
	*/
	if(!isHmtk(obj.ft)) {
		// decor track's stuff
		obj.mode=lst[i].mode;
		if(obj.ft==FT_lr_c) {
			obj.qtc.pfilterscore=lst[i].pfilterscore;
			obj.qtc.nfilterscore=lst[i].nfilterscore;
		}
	}

	// work out the data
	var dj=lst[i].data; // data from json
	if(isHmtk(obj.ft) || (obj.mode==M_den || obj.mode==M_show)) {
		// atomic data
		if(this.move.direction == null) {
			obj.data=dj;
		} else {
			if(this.move.direction == 'l') {
				if(this.move.merge) {
					obj.data[0] = dj[dj.length-1].concat(obj.data[0]);
					dj.pop();
				}
				obj.data = dj.concat(obj.data);
			} else {
				if(this.move.merge) {
					var idx=obj.data.length-1;
					obj.data[idx] = obj.data[idx].concat(dj[0]);
					dj.shift();
				}
				obj.data = obj.data.concat(dj);
			}
		}
	} else if(obj.mode==M_thin || obj.mode==M_full || obj.mode==M_arc || obj.mode==M_trihm) {
		// stack data
		if(this.move.direction == null) {
			obj.data = dj;
			if(lst[i].skipped==undefined)
				obj.skipped=0;
			else
				obj.skipped=lst[i].skipped;
		} else {
			if(this.move.direction == 'l') {
				if(this.move.merge) {
					mergeStackdecor(obj.data[0], dj[dj.length-1], obj.ft, this.move.direction, this.move.offsetShift);
					dj.pop();
				}
				obj.data = dj.concat(obj.data);
			} else {
				if(this.move.merge) {
					mergeStackdecor(obj.data[obj.data.length-1], dj[0], obj.ft, this.move.direction, this.move.offsetShift);
					dj.shift();
				}
				obj.data = obj.data.concat(dj);
			}
			obj.skipped += (lst[i].skipped!=undefined) ? lst[i].skipped : 0;
		}
	} else {
		fatalError('jsonTrackdata: unknown display mode');
	}
}

this.trackdom2holder();
return tknames;
/* over */
}

Browser.prototype.trackdom2holder=function()
{
/* track dom elements (canvas or labels) insert to holder
*/
for(var i=0; i<this.tklst.length; i++) {
	var tk=this.tklst[i];
	if(tk.where==1) {
		// to ghm
		this.hmdiv.appendChild(tk.canvas);
		if(this.mcm!=null) {
			tk.atC.style.display='block';
			this.mcm.tkholder.appendChild(tk.atC);
		}
		if(this.hmheaderdiv!=null)
			this.hmheaderdiv.appendChild(tk.header);
	} else {
		// to decor div (value supposedly 2)
		this.decordiv.appendChild(tk.canvas);
		tk.atC.style.display='none';
		if(this.decorheaderdiv!=null)
			this.decorheaderdiv.appendChild(tk.header);
	}
}
this.trackHeightChanged();
}


function mergeStackdecor(sink, source, ft, direction, offsetShift) {
/* if is sam file:
merge sink/source reads that have same id (make them a paired end)
else, if source item also exists in sink (tell by item id), skip
else, push it into sink

args:
- sink: array of bed items of "sink" region
- source: array of bed items of "source" region
- direction, offsetShift: from Browser.move

** beware **
if move left, need to shift sink box start using move.offsetShift
if move right, need to shift source box start using sink region length
*/
	if(direction!='l' && direction!='r')
		fatalError("mergeStackdecor: move direction error");

	if(direction == 'l') {
		// shift sink
		for(var i=0; i<sink.length; i++)
			sink[i][0] += offsetShift;
	} else {
		// shift source
		for(var i=0; i<source.length; i++)
			source[i][0] += offsetShift;
	}

	// make lookup table for items in sink
	var lookup = {}; // key: item id, val: item array
	for(var i=0; i<sink.length; i++)
		lookup[sink[i][2]] = sink[i];
	var isSam=(ft==FT_sam_c || ft==FT_sam_n);
	for(var i=0; i<source.length; i++) {
		if(source[i][2] in lookup) {
			if(isSam) {
				if(!lookup[source[i][2]][17]) {
					// the sink read is not paired yet
					sink.push(source[i]);
				}
			}
		} else {
			sink.push(source[i]);
		}
	}
}



function track_click(event)
{
/* clicking on bed/sam/longrange track, show bubble
*/
var bbj=gflag.browser;
var sbj=bbj;
if(event.target.splinterTag!=undefined)
	sbj=bbj.splinters[event.target.splinterTag];
/* must escape the case of panning
.move.oldpos is set to old position when mousedown
*/
if(sbj.move.oldpos!=sbj.move.styleLeft)
	return;
var tk=sbj.findTrack(event.target.tkname);
if(tk.mode==M_den) return;
var pos= tk.where==1 ? absolutePosition(sbj.hmdiv.parentNode) : absolutePosition(sbj.decordiv.parentNode);
// clicked position relative to viewbox
var px=event.clientX+document.body.scrollLeft;
var py=event.clientY+document.body.scrollTop;
var mX=px-pos[0]-sbj.move.styleLeft;
var mY=py-absolutePosition(event.target)[1];
if(tk.mode==M_trihm) {
	var item=findDecoritem_longrange_trihm(tk.data_trihm, tk.qtc.anglescale*Math.PI/4, mX, mY);
	if(item!=null)
		sbj.decorCanvasLeftclickGetInfo(tk, tk.data_chiapet[item[4]][item[5]], item[4], px, py);
	return;
}
if(tk.mode==M_arc) {
	// arcs, use distance to circle center to find hit
	var item=findDecoritem_longrange_arc(tk.data_arc,mX,mY);
	if(item!=null)
		sbj.decorCanvasLeftclickGetInfo(tk, tk.data_chiapet[item[3]][item[4]], item[3], px, py);
	return;
}
// remaining mode should be stack decor, thin or full
// compute stack id of mouse click (there is 1px spacing between stacks)
var stkh = tk.mode==M_full ? fullStackHeight+1 : thinStackHeight+1;
var clickstack = parseInt(mY / stkh);
var _data=(tk.ft==FT_lr_n||tk.ft==FT_lr_c) ? tk.data_chiapet : tk.data;
for(var i=0; i<_data.length; i++) {
	for(var j=0; j<_data[i].length; j++) {
		var item = _data[i][j];
		if(item[5]==undefined) continue;
		if(item[5]!=clickstack) continue;
		if(item[6]<=mX && item[6]+item[7]>=mX) {
			// item matched, place tooltip over it
			sbj.decorCanvasLeftclickGetInfo(tk, item, i, px, py);
			return;
		}
	}
}
/*over*/
}


Browser.prototype.ajax_addtracks=function(_tklst)
{
/* notable issues and pitfalls

.qtc sync between trunk and splinters
*/
document.body.style.cursor='wait';
this.cloak();
this.ajax('addtracks=on&dbName='+this.genome.name+'&'+this.displayedRegionParamPrecise()+trackParam(_tklst),function(data){
	var bbj=horcrux[data.horcrux];
	var tknamelst=bbj.jsonTrackdata(data);
	var _olst=[]; // for splinter adding
	for(var i=0; i<tknamelst.length; i++) {
		var o=bbj.findTrack(tknamelst[i][0]);
		if(bbj.trunk!=null) {
			// means this is a splinter
			o.qtc=bbj.trunk.findTrack(tknamelst[i][0]).qtc;
		}
		bbj.drawTrack_browser(o);
		_olst.push(o);
	}
	/* mcm_sort is disabled here due to following issue
	a decor tk is manually moved inside ghm
	change its mode, it calls ajax_addtracks() to renew itself
	if doing mcm_sort, this tk will be moved according to its md anno, or if it is md-less, it will be moved to bottom
	thus unintuitive
	*/
	bbj.prepareMcm();
	bbj.drawMcm();
	bbj.trackHeightChanged();
	/* generating facet table is expensive
	only do so if native hmtk tracks are added
	*/
	var hascustom=false;
	var hasnativehmtk=false;
	for(i=0; i<tknamelst.length; i++) {
		if(tknamelst[i][1]) {
			var o=bbj.genome.hmtk[tknamelst[i][0]];
			if(o!=undefined) {
				if(isCustom(o.ft)) {
					hascustom=true;
				} else {
					hasnativehmtk=true;
				}
			}
		}
	}
	if(hasnativehmtk) {
		var type=gflag.tsp.invoke.type;
		if(type==-1) {
			bbj.generateTrackselectionLayout();
		} else if(type==1 || type==2) {
			// clicked a grid cell, or a list cell
			bbj.facetclickedcell_remake();
		} else if(type==3) {
			// clicked "select all" option
			bbj.generateTrackselectionLayout();
		} else if(type==4) {
			// kw search for native
			bbj.generateTrackselectionLayout();
			nativetk_kwsearch();
		} else {
			fatalError('unknown gflag.tsp.invoke.type value');
		}
	}
	if(hascustom)
		bbj.cfacet_generategrid();
	bbj.unveil();
	document.body.style.cursor='auto';
	// splinters
	for(var tag in bbj.splinters)
		bbj.splinters[tag].ajax_addtracks(_olst);
});
}

/*** __track__ ends ***/



/*** __metadata__ ***/

function mdspanel_mout() {document.body.addEventListener('mousedown', mds_close, false);}
function mdspanel_mover() {document.body.removeEventListener('mousedown', mds_close, false);}
function mds_close()
{
document.body.removeEventListener('mousedown', mds_close, false);
gflag.mdp.bbj.genome.mdselect.main.style.display = 'none';
}


function menu_mcm_invokemds() {gflag.menu.bbj.mcm_invokemds();};
function button_mcm_invokemds() {gflag.browser.mcm_invokemds();};
Browser.prototype.mcm_invokemds=function()
{
/* select terms to be displayed in metadata colormap
*/
// show all <input> for native terms and check those that are on display
for(var t in this.genome.mdv2checkbox)
	this.genome.mdv2checkbox[t].checked=false;
for(t in this.genome.mdv2checkbox_custom)
	this.genome.mdv2checkbox_custom[t][0].checked=false;
for(var i=0; i<this.mcm.lst.length; i++) {
	var t=this.mcm.lst[i];
	if(t[1]) {
		// custom term
		this.genome.mdv2checkbox_custom[t[0]][0].checked=true;
	} else {
		// native
		this.genome.mdv2checkbox[t[0]].checked=true;
	}
}
var hd=this.mcm.tkholder;
var pos=absolutePosition(hd);
if(pos[0]+hd.clientWidth+300>document.body.clientWidth+document.body.scrollLeft) {
	// place panel on left of mcm
	this.genome.invokemds(1, pos[0]-200, pos[1]);
} else {
	// place panel on right of mcm
	this.genome.invokemds(1, pos[0]+hd.clientWidth+5,pos[1]);
}
menu_hide();
}

Genome.prototype.mdvGetallchild=function(what, lst)
{
if(what in this.mdvp2c) {
	for(var i=0; i<this.mdvp2c[what].length; i++) {
		var c = this.mdvp2c[what][i];
		lst.push(c);
		this.mdvGetallchild(c, lst);
	}
}
}
Genome.prototype.makeMetadataSelectorPanel=function()
{
/* only call once
make metadata selector panel...
*/
for(var i=0; i<this.mdvroot.length; i++)
	this.makeMetatreeRecursive(this.mdvroot[i], this.mdselect.nativeholder);
}
Genome.prototype.makeMetatreeRecursive=function(which, ul)
{
/* for native metadata panel
arg:
- a native term, create and insert an <li> for it, make recursive call for all its children
- <ul> dom
leaf nodes are not expandable
non-leaf nodes can be clicked to show/hide its children
*/
var li=document.createElement('li');
ul.appendChild(li);
var cb=document.createElement('input');
cb.type='checkbox';
cb.termidx=which;
cb.addEventListener('change', mdCheckboxchange, false);
this.mdv2checkbox[which]=cb;
if(which in this.mdvp2c) {
	// not leaf
	var s=document.createElement('span');
	s.className='clb';
	s.addEventListener('click', mdshowhide, false);
	s.innerHTML='<span>&#8862;</span> '+which;
	li.appendChild(s);
	li.appendChild(cb);
	var ul2=document.createElement('ul');
	ul2.style.display='none';
	ul.appendChild(ul2);
	for(var i=0; i<this.mdvp2c[which].length; i++)
		this.makeMetatreeRecursive(this.mdvp2c[which][i], ul2);
} else {
	// is leaf
	var s=document.createElement('span');
	s.innerHTML=this.mdvidx2attr[which];
	li.appendChild(s);
	li.appendChild(cb);
	cb.termparent=this.mdvc2p[which];
}
}

Genome.prototype.custmd_checkbox_togglevisibility=function()
{
/* in case of choosing terms to be displayed in mcm
custom term attributes have to hide their checkbox
*/
switch(this.mdselect.which) {
case 1:
	// select term name for mcm
	for(var t in this.mdv2checkbox)
		this.mdv2checkbox[t].style.display='inline';
	for(var t in this.mdv2checkbox_custom) {
		var v=this.mdv2checkbox_custom[t];
		v[0].style.display='inline';
		for(var t2 in v[1])
			v[1][t2].style.display='none';
	}
	break;
case 2:
case 3:
case 4:
case 5:
case 6:
case 7:
	for(var t in this.mdv2checkbox_custom) {
		var v=this.mdv2checkbox_custom[t];
		v[0].style.display='none';
		for(var t2 in v[1])
			v[1][t2].style.display='inline';
	}
	break;
default:
	fatalError('custmd_checkbox_togglevisibility: unknown mdselect.which value');
}
}

function mdCheckboxchange(event)
{
/* on changing a checkbox in metadata selector panel
need to tell which genome this checkbox belongs to
and which browser to place the effect
gflag.mdp.bbj
*/
var term = event.target.termidx;
var iscustom = event.target.custom!=null;
var parentterm = event.target.termparent;
var bbj=gflag.mdp.bbj;
switch(bbj.genome.mdselect.which) {
case 1: // add to mcm in main browser panel
	if(event.target.checked) {
		bbj.mcm.lst.push([term, iscustom]);
	} else {
		for(var i=0; i<bbj.mcm.lst.length; i++) {
			var s=bbj.mcm.lst[i];
			if(s[1]==iscustom && s[0]==term) {
				bbj.mcm.lst.splice(i,1);
				break;
			}
		}
	}
	bbj.initiateMdcOnshowCanvas();
	bbj.mcmPlaceheader();
	bbj.prepareMcm();
	bbj.drawMcm();
	bbj.__mcm_termchange();
	break;
case 2: // custom bedgraph prior to submission
	if(event.target.checked) {
		/* to insert <tr> in table to be used in annotation
		   term must be leaf, and could be server or custom
		   need to imprint both term and parent info on the <tr>
		 */
		// different treatment for server/custom terms...
		bbj.genome.custmd_tableinsert(bbj.genome.mdselect.custpriortable3, term, iscustom, parentterm, custtkmdanno_prior_removeterm);
		bbj.genome.mdselect.custpriortable3.style.display='block';
	} else {
		custtkmdanno_prior_removeterm(term, bbj.genome.mdselect.custpriortable3);
	}
	break;
case 7: // custom bigwig prior to submission
	if(event.target.checked) {
		bbj.genome.custmd_tableinsert(bbj.genome.mdselect.custpriortable15, term, iscustom, parentterm, custtkmdanno_prior_removeterm);
	} else {
		custtkmdanno_prior_removeterm(term, bbj.genome.mdselect.custpriortable15);
	}
	break;
case 4: // custom bed prior to submission
	if(event.target.checked) {
		bbj.genome.custmd_tableinsert(bbj.genome.mdselect.custpriortable1, term, iscustom, parentterm, custtkmdanno_prior_removeterm);
	} else {
		custtkmdanno_prior_removeterm(term, bbj.genome.mdselect.custpriortable1);
	}
	break;
case 5: // custom sam prior to submission
	if(event.target.checked) {
		bbj.genome.custmd_tableinsert(bbj.genome.mdselect.custpriortable5, term, iscustom, parentterm, custtkmdanno_prior_removeterm);
	} else {
		custtkmdanno_prior_removeterm(term, bbj.genome.mdselect.custpriortable5);
	}
	break;
case 6: // custom longrange prior to submission
	if(event.target.checked) {
		bbj.genome.custmd_tableinsert(bbj.genome.mdselect.custpriortable10, term, iscustom, parentterm, custtkmdanno_prior_removeterm);
	} else {
		custtkmdanno_prior_removeterm(term, bbj.genome.mdselect.custpriortable10);
	}
	break;
case 3: // editing custom track anno after submission!
	if(event.target.checked) {
		/* adding annotation
		to insert <tr> in table to be used in annotation
		term must be leaf, and could be native or custom
		need to imprint both term and parent info on the <tr>
		*/
		document.getElementById('custtkmdanno_editsaysno').style.display = 'none';
		var showtable=document.getElementById('custtkmdanno_showholder');
		showtable.style.display = 'table';
		bbj.genome.custmd_tableinsert(showtable, term, iscustom, parentterm, custtkmdannoedit_removeTerm);
		// add annotation to track object
		// almost reverse operation as custtkmdannoedit_removeTerm()
		var ft=gflag.ctmae.ft;
		var tkname=gflag.ctmae.tkname;
		// 1: registry object
		var obj = gflag.ctmae.bbj.genome.hmtk[tkname];
		if(iscustom)
			obj.custmd[parentterm] = term;
		else
			obj.md.push(term);
		// 2: display object
		obj=gflag.ctmae.bbj.findTrack(tkname);
		if(obj!=null) {
			if(iscustom)
				obj.custmd[parentterm] = term;
			else
				obj.attrhash[term] = 1;
			gflag.ctmae.bbj.prepareMcm();
			gflag.ctmae.bbj.drawMcm();
		}
	} else {
		custtkmdannoedit_removeTerm(term);
	}
	break;
default:
	fatalError('mdCheckboxchange: unknown mdselect.which');
}
}

Genome.prototype.custmd_example=function()
{
this.mdselect.newcust.name_input.value = 'my friends';
this.mdselect.newcust.vnum_select.selectedIndex=1;
this.newcustmd_setattrvalue();
var lst=this.mdselect.newcust.inputdoms;
lst[0].value = 'Sanborn';
lst[1].value = 'Eldridge';
lst[2].value = 'James';
this.submitCustommdterm();
}
Genome.prototype.newcustmd_setattrvalue=function()
{
/* called by changing <select>
see how many values are chosen for new attribute, and make that number of inputs
*/
var s=this.mdselect.newcust.vnum_select;
var n = parseInt(s.options[s.selectedIndex].value);
stripChild(this.mdselect.newcust.inputdiv, 0);
this.mdselect.newcust.inputdoms=[];
for(var i=1; i<=n; i++) {
	var d = document.createElement("div");
	d.style.margin = "4px";
	d.style.display = "inline-block";
	var d2=document.createElement('div');
	d2.innerHTML='attr. '+i;
	d.appendChild(d2);
	var d3=document.createElement('input');
	d3.type='text';
	d3.size=3;
	d.appendChild(d3);
	this.mdselect.newcust.inputdoms.push(d3);
	this.mdselect.newcust.inputdiv.appendChild(d);
}
}
Genome.prototype.resetCustommdterm=function()
{
this.mdselect.newcust.name_input.value='';
this.mdselect.newcust.vnum_select.selectedIndex = 1;
this.newcustmd_setattrvalue();
}

Genome.prototype.submitCustommdterm=function()
{
/* called by clicking "add new attr" button
beware restoring status won't invoke this!!
*/
// input: attr name
var name=this.mdselect.newcust.name_input.value;
if(name == "") {
	print2console("please specify term name", 2);
	return;
}
if(name.indexOf(',') != -1) {
	print2console("comma not allowed in term name", 2);
	return;
}
if(name.indexOf('|') != -1) {
	print2console("vertical bar not allowed in term name", 2);
return;
}
if(name in this.custmdhash) {
	print2console('Term name already in use', 2);
	return;
}
var nlst = [];
var lst=this.mdselect.newcust.inputdoms;
for(var i=0; i<lst.length; i++) {
	var t = lst[i].value;
	if(t == "") continue;
	if(t.indexOf(',') != -1) {
		print2console("comma not allowed in attribute value", 2);
		return;
	}
	if(t.indexOf('|') != -1) {
		print2console("vertical bar not allowed in attribute value", 2);
		return;
	}
	if(thinginlist(t, nlst)) continue;
	nlst.push(t);
}
if(nlst.length == 0) {
	print2console('no valid attributes.', 2);
	return;
}
// push this new attribute into custmdhash
this.custmdhash[name] = nlst;
this.displayCustmdterm(name);
this.custmd_checkbox_togglevisibility();
this.resetCustommdterm();
simulateEvent(this.mdv2checkbox_custom[name][0],'change');
}

Genome.prototype.displayCustmdterm=function(termname)
{
/* display one custom metadata term in:
- metadata selection panel
- custom track registry table (selection grid organized by custom metadata terms)

call this when a new term is added
argument: custom term name

this term must already be inserted in custmdhash
*/
if(!(termname in this.custmdhash)) fatalError('displayCustmdterm: unknown term name');

// but need to make sure if term of same name is already in md panel
// in case when user submits same hub for twice
if(termname in this.mdv2checkbox_custom) return;

var li=document.createElement('li');
var s=document.createElement('span');
s.className='clb';
s.addEventListener('click', mdshowhide,false);
s.innerHTML='<span>&#8862;</span> '+termname;
li.appendChild(s);
var cb=document.createElement('input');
cb.type='checkbox';
cb.custom=1;
cb.termidx=termname;
cb.addEventListener('change', mdCheckboxchange, false);
cb.checked=true;
li.appendChild(cb);
this.mdselect.cust.appendChild(li);
this.mdv2checkbox_custom[termname]=[cb,{}];

var ul=document.createElement('ul');
ul.style.display='none';
this.mdselect.cust.appendChild(ul);

for(var i=0; i<this.custmdhash[termname].length; i++) {
	var attr = this.custmdhash[termname][i];
	li=document.createElement('li');
	s=document.createElement('span');
	s.innerHTML=attr;
	li.appendChild(s);
	cb=document.createElement('input');
	cb.type='checkbox';
	cb.custom=1;
	cb.termparent=termname;
	cb.termidx=attr;
	cb.addEventListener('change', mdCheckboxchange, false);
	li.appendChild(cb);
	ul.appendChild(li);
	this.mdv2checkbox_custom[termname][1][attr]=cb;
}

/* append this custom md term to the two <select> */
this.spread_custmdterm(termname);
}


Browser.prototype.recursivegettrack=function(what, tkset)
{
// search for any tracks annotated by an attribute, store in hash, key is track name
if(what in this.genome.mdvp2c) {
	// not leaf
	var lst=this.genome.mdvp2c[what];
	for(var i=0; i<lst.length; i++)
		this.recursivegettrack(lst[i], tkset);
} else {
	// is leaf
	for(var tk in this.genome.hmtk) {
		var md=this.genome.hmtk[tk].md;
		if(md==undefined) continue;
		if(thinginlist(what,md))
			tkset[tk] = 1;
	}
}
}
Browser.prototype.drawMcm_onetrack=function(tkobj,tosvg)
{
if(this.mcm==null) return;
var svgdata=[];
var c = tkobj.atC;
var h = tkobj.canvas.height;
if(!c.alethiometer) {
	c.height = h;
	c.width = this.mcm.lst.length * tkAttrColumnWidth;
}
var ctx = c.getContext('2d');
var clen = colorCentral.longlst.length-1;
for(var j=0; j<this.mcm.lst.length; j++) {
	var v = tkobj.attrcoloridxlst[j];
	if(v<0) {
		ctx.fillStyle = GRAY;
		if(tosvg) svgdata.push(GRAY);
	} else {
		if(v > clen) {
			var f = parseInt(v/clen);
			ctx.fillStyle = darkencolor(colorstr2int(colorCentral.longlst[v%clen]), f<10?f/10:1);
		} else {
			ctx.fillStyle = colorCentral.longlst[v];
		}
		if(tosvg) svgdata.push(ctx.fillStyle);
	}
	ctx.fillRect(j*tkAttrColumnWidth,0,tkAttrColumnWidth-1,h);
}
c.attr = tkobj.attrlst;
if(tosvg) return svgdata;
}

Browser.prototype.recursiveFetchTrackAttr=function(which, mdcidx, tkobj)
{
/* args:
- which: an attribute, index for leaf, string for non-leaf
- mdcidx: bbj.mcm.lst array idx
- tkobj: tklst array element
sets tkobj.attrlst[mdcidx] using the attr value in .attrhash.....
only works for native metadata
*/
if(which in this.genome.mdvidx2attr) {
	// leaf
	if(which in tkobj.attrhash)
		tkobj.attrlst[mdcidx] = which;
	return;
} else {
	if(!(which in this.genome.mdvp2c))
		throw('recursiveFetchTrackAttr("'+which+'")');
	for(var i=0; i<this.genome.mdvp2c[which].length; i++)
		this.recursiveFetchTrackAttr(this.genome.mdvp2c[which][i], mdcidx, tkobj);
}
}
Browser.prototype.mdcFromNativeTerms=function(termlst)
{
/* native md terms only, for:
- browser init
- change genome
- restore session
*/
this.mcm.lst=[];
for(var i=0; i<termlst.length; i++)
	this.mcm.lst.push([termlst[i], false]);
this.initiateMdcOnshowCanvas();
}
Browser.prototype.initiateMdcOnshowCanvas=function()
{
/* make or re-make mcm holder table according to contents in _browser.mcm.lst
write metadata categories vertically, check metadata voc tree checkboxes, only do once
*/
var holder=this.mcm.holder;
stripChild(holder.firstChild.firstChild, 0); // table-tbody-tr
var terms=this.mcm.lst;
if(terms.length==0) {
	// okay there's no terms, leave a blank to allow clicking
	var c=makecanvas_verticalstring('add metadata...', colorCentral.foreground,false,true);
	c.className='tkattrnamevcanvas';
	c.addEventListener('click', button_mcm_invokemds,false);
	holder.firstChild.firstChild.insertCell(-1).appendChild(c);
	this.mcmPlaceheader();
	return;
}
var mdvidx2attr=this.genome.mdvidx2attr;
holder.style.width = tkAttrColumnWidth * terms.length;
for(var i=0; i<terms.length; i++) {
	var s=terms[i];
	var c = makecanvas_verticalstring(
		s[1] ? s[0] : (s[0] in mdvidx2attr ? mdvidx2attr[s[0]] : s[0]),
		colorCentral.foreground, false, true);
	c.className='tkattrnamevcanvas';
	c.termname=s[0];
	c.iscustom=s[1];
	c.addEventListener('click', mcm_termname_click, false);
	c.addEventListener('mousedown', mcm_termname_MD, false);
	c.oncontextmenu=menu_mcm_header;
	holder.firstChild.firstChild.insertCell(-1).appendChild(c);
}
this.mcmPlaceheader();
}

function mcm_termname_click(event)
{
/* clicking on mcm term name canvas
canvas dom has attributes to tell the term
*/
var bbj=gflag.browser;
var idx=-1;
for(var i=0; i<bbj.mcm.lst.length; i++) {
	var s=bbj.mcm.lst[i];
	if(s[1]==event.target.iscustom && s[0]==event.target.termname) {
		idx=i;
		break;
	}
}
if(idx==-1) return;
bbj.mcm.sortidx=idx;
/* for reverting
if(bbj.mcm.revertbutton!=undefined) {
	var old=[];
	for(i=0; i<bbj.hmdiv.childNodes.length; i++)
		old.push(bbj.hmdiv.childNodes[i].tkname);
	bbj.mcm.previousorder=old;
	document.getElementById('hmtkorderRevertButton').style.display = 'block';
}
*/
bbj.mcm_sort();
}
function mcm_termname_MD(event) {
// for rearranging terms in mcm
	if(event.button!=0) return;
	event.preventDefault();
	var lst=gflag.browser.mcm.lst;
	for(var i=0; i<lst.length; i++) {
		if(lst[i][1]==event.target.iscustom && lst[i][0]==event.target.termname)
			break;
	}
	gflag.mcmtermmove={
		idx:i,
		mx:event.clientX };
	document.body.addEventListener('mousemove', mcm_termname_M, false);
	document.body.addEventListener('mouseup', mcm_termname_MU, false);
}
function mcm_termname_M(event) {
	event.preventDefault();
	var m=gflag.mcmtermmove;
	var bbj=gflag.browser;
	var mdlst=bbj.mcm.lst;
	if(event.clientX>m.mx) {
		// to right
		if(m.idx==mdlst.length-1) return;
		if(event.clientX-m.mx >= tkAttrColumnWidth) {
			var ss=mdlst[m.idx+1];
			mdlst[m.idx+1]=mdlst[m.idx];
			mdlst[m.idx]=ss;
			bbj.initiateMdcOnshowCanvas();
			bbj.prepareMcm();
			bbj.drawMcm();
			m.mx=event.clientX;
			m.idx++;
		}
	} else if(event.clientX<m.mx) {
		// to left
		if(m.idx==0) return;
		if(m.mx-event.clientX >= tkAttrColumnWidth) {
			var ss=mdlst[m.idx-1];
			mdlst[m.idx-1]=mdlst[m.idx];
			mdlst[m.idx]=ss;
			bbj.initiateMdcOnshowCanvas();
			bbj.prepareMcm();
			bbj.drawMcm();
			m.mx=event.clientX;
			m.idx--;
		}
	}
}
function mcm_termname_MU() {
	document.body.removeEventListener('mousemove', mcm_termname_M, false);
	document.body.removeEventListener('mouseup', mcm_termname_MU, false);
}

Browser.prototype.mcm_sort=function()
{
/* sort but not stuffing doms!
should call this to separate tracks in and out of ghm
so that .where 1 and 2 are not mixed
even when .mcm.lst is empty, can still run
*/
if(this.mcm==null) return;

var hmlst=[], nhlst=[];
for(var i=0; i<this.tklst.length; i++) {
	var tk=this.tklst[i];
	if(tk.where==1) hmlst.push(tk);
	else nhlst.push(tk);
}

if(this.mcm.lst.length==0) {
	this.tklst=hmlst.concat(nhlst);
	// quit here when nothing's in mcm
	return;
}

if(this.mcm.sortidx >= this.mcm.lst.length) this.mcm.sortidx=0;

var m2tk={_empty_:[]};
for(var i=0; i<hmlst.length; i++) {
	var tk=hmlst[i];
	var av=tk.attrlst[this.mcm.sortidx];
	if(av==undefined) {
		m2tk._empty_.push(tk.name);
	} else {
		if(av in m2tk) {
			m2tk[av].push(tk.name);
		} else {
			m2tk[av]=[tk.name];
		}
	}
}
var newlst=[];
for(var av in m2tk) {
	if(av=='_empty_') continue;
	for(var i=0; i<m2tk[av].length; i++) {
		var obj=this.findTrack(m2tk[av][i]);
		newlst.push(obj);
	}
}
if('_empty_' in m2tk) {
	for(var i=0; i<m2tk._empty_.length; i++) {
		var obj=this.findTrack(m2tk._empty_[i]);
		newlst.push(obj);
	}
}
this.tklst=newlst.concat(nhlst);
this.track2holder();
}

Browser.prototype.prepareMcm=function()
{
/* requires:
bbj.mcm.lst and tklst[x].attrhash
make .attrlst and .attrcoloridxlst for each track
*/
// wipe out old data
if(this.mcm==null) return;
for(var i=0; i<this.tklst.length; i++) {
	var tk=this.tklst[i];
	if(tk.attrlst==undefined)
		tk.attrlst=[];
	for(var j=0; j<this.mcm.lst.length; j++)
		tk.attrlst[j] = undefined;
}
for(i=0; i<this.mcm.lst.length; i++) {
	this.prepareMcM_oneterm(i);
}
}

Browser.prototype.prepareMcM_oneterm=function(mdcidx)
{
/* arg: bbj.mcm.lst array index
make tk.attrlst[mdcidx] for each track
different treatment for native/custom metadata
*/
for(var i=0; i<this.tklst.length; i++) {
	if(this.tklst[i].attrcoloridxlst==undefined)
		this.tklst[i].attrcoloridxlst=[];
}
var thism = this.mcm.lst[mdcidx][0];
var termiscustom = this.mcm.lst[mdcidx][1];
if(termiscustom) {
	// custom term
	var attrvalues = {};
	// is custom metadata
	for(var i=0; i<this.tklst.length; i++) {
		// only operate on tracks with .custmd hash
		var t=this.tklst[i];
		if(t.custmd!=undefined && thism in t.custmd) {
			var value=t.custmd[thism];
			t.attrlst[mdcidx] = value;
			attrvalues[value] = 1;
		}
	}
	var lst = [];
	for(var v in attrvalues)
		lst.push(v);
	// make .attrcoloridxlst[mdcidx] for those tracks with custmdhash
	for(i=0; i<this.tklst.length; i++) {
		var t=this.tklst[i];
		if(t.custmd == undefined)
			t.attrcoloridxlst[mdcidx] = -1;
		else
			t.attrcoloridxlst[mdcidx] = getArrIdx(t.attrlst[mdcidx], lst);
	}
	return;
}
// native term
var attrvalues = {};
for(var i=0; i<this.tklst.length; i++) {
	this.recursiveFetchTrackAttr(thism, mdcidx, this.tklst[i]);
	var thing = this.tklst[i].attrlst[mdcidx];
	if(thing != undefined) 
		attrvalues[thing]=1;
}
var lst = [];
for(var v in attrvalues)
	lst.push(v);
// make .attrcoloridxlst[mdcidx] for each track
for(i=0; i<this.tklst.length; i++) {
	var t=this.tklst[i];
	if(t.attrlst[mdcidx] == undefined)
		t.attrcoloridxlst[mdcidx] = -2;
	else
		t.attrcoloridxlst[mdcidx] = getArrIdx(t.attrlst[mdcidx], lst);
}
}

Browser.prototype.getHmtkIdxlst_mcmCell=function(mcidx, tkname)
{
/* args:
mcidx: bbj.mcm.lst array idx
tkname: hmtk name
return null if clicked on an area with no annotation data
*/
var tkidx=-1;
for(var i=0; i<this.tklst.length; i++) {
	if(this.tklst[i].name==tkname) {
		tkidx=i; break;
	}
}
if(tkidx==-1) return null;
var m=this.tklst[tkidx].attrlst[mcidx];
if(m==undefined)
	return null;
// all tracks in the same color block
var tkarr=[tkidx];
for(i=tkidx-1; i>=0; i--) {
	if(this.tklst[i].attrlst[mcidx]==m)
		tkarr.unshift(i);
	else
		break;
}
for(i=tkidx+1; i<this.tklst.length; i++) {
	if(this.tklst[i].where!=1) break;
	if(this.tklst[i].attrlst[mcidx]==m)
		tkarr.push(i);
	else
		break;
}
return tkarr;
}

Browser.prototype.movetk_hmtk=function(tkidxlst, up)
{
/* a group of them can be moved at same time
but only move up/down for one track at each move
this is not supposed to be called on splinters
*/
var hmlst=[], nhlst=[];
for(var i=0; i<this.tklst.length; i++) {
	if(this.tklst[i].where==1)
		hmlst.push(this.tklst[i]);
	else
		nhlst.push(this.tklst[i]);
}
if(up) {
	var el=hmlst.splice(tkidxlst[0]-1,1)[0];
	hmlst.splice(tkidxlst[tkidxlst.length-1],0,el);
} else {
	var el=hmlst.splice(tkidxlst[tkidxlst.length-1]+1,1)[0];
	hmlst.splice(tkidxlst[0],0,el);
}
var d1=this.hmdiv;
var d2=this.mcm.tkholder;
var d3=this.hmheaderdiv;
for(var i=0; i<hmlst.length; i++) {
	d1.appendChild(hmlst[i].canvas);
	d2.appendChild(hmlst[i].atC);
	d3.appendChild(hmlst[i].header);
}
this.tklst=hmlst.concat(nhlst);
this.splinterSynctkorder();
}

function hmtkorderRevert() {
/* *alert* must take care of added/removed tracks before reverting */
	var bbj=gflag.browser;
	var tp = bbj.mcm.previousorder;
	var newlst = []; // new sequence
	// from tp select existing tracks, skip removed ones
	for(var i=0; i<tp.length; i++) {
		var tk=bbj.findTrack(tp[i]);
		if(tk!=null)
			newlst.push(tk);
	}
	// from hmdiv add ones that are not in tp
	for(i=0; i<bbj.hmdiv.childNodes.length; i++) {
		if(!thinginlist(bbj.hmdiv.childNodes[i].tkname, tp))
			newlst.push(bbj.tklst[i]);
	}
	// remaining decors
	for(i=0; i<bbj.decordiv.childNodes.length; i++)
		newlst.push(bbj.findTrack(bbj.decordiv.childNodes[i].tkname));
	bbj.tklst=newlst;
	bbj.track2holder();
	bbj.prepareMcm();
	bbj.drawMcm();
	//bbj.mcm.revertbutton.style.display = 'none';
	print2console("heatmap track order reverted", 0);
}


function menuCusttkmdedit()
{
// called by clicking "Edit metadata" option, over a custom track
if(gflag.menu.context!=1) return;
var tkobj=gflag.menu.tklst[0];
if(tkobj==null) return;
gflag.ctmae={bbj:gflag.menu.bbj, tkname:tkobj.name, ft:tkobj.ft};
custtkmd_showeditpanel(tkobj.name, tkobj.ft);
menu_hide();
}

function custtkmd_showeditpanel(tkname, ft) {
/*  called by pushing "edit" button in cust tk registry panel
show edit panel for custom track metadata annotation, all track types
only registration objects will be used, but not display objects
because a custom track can be not on display, but its metadata can still be edited
in case if the track is on display,
the modification must be applied to display object as well
*/
	gflag.ctmae.bbj=gflag.tsp.bbj;
	gflag.ctmae.ft=ft;
	gflag.ctmae.tkname=tkname;
	document.getElementById('custtkmdanno_editholder').style.display='block';
	var termtable=document.getElementById('custtkmdanno_showholder');
	stripChild(termtable.firstChild, 1);

	/* all custom tracks are supposed to be registered in genome.hmtk */
	var _genome=gflag.tsp.bbj.genome;
	var obj = _genome.hmtk[tkname];
	if(obj == undefined)
		fatalError("custtkmd_showeditpanel: registry object not found");
	var count = 0; // # of terms
	if('md' in obj) {
		count=obj.md.length;
	}
	if('custmd' in obj) {
		for(var attr in obj.custmd) count++;
	}
	if(count == 0) {
		document.getElementById('custtkmdanno_editsaysno').style.display = 'block';
		termtable.style.display = 'none';
		return;
	}
	document.getElementById('custtkmdanno_editsaysno').style.display = 'none';
	termtable.style.display = 'table';
	// server metadata
	if('md' in obj) {
		for(var i=0; i<obj.md.length; i++) {
			var attr=obj.md[i];
			_genome.custmd_tableinsert(termtable, attr, false, _genome.mdvc2p[attr], custtkmdannoedit_removeTerm);
		}
	}
	// custom metadata
	if('custmd' in obj) {
		for(var name in obj.custmd)
			_genome.custmd_tableinsert(termtable, obj.custmd[name], true, name, custtkmdannoedit_removeTerm);
	}
}

function custtkmdanno_prior_removeterm() {
/* prior to custom track submission,
remove a term from the list
variable argument:
- if only one argument, is event object issued by clicking <td>X</td>
- if two arguments, 1 - term idx, 2 - holder
*/
	if(arguments.length == 1) {
		arguments[0].target.parentNode.parentNode.removeChild(arguments[0].target.parentNode);
	} else if (arguments.length == 2) {
		var lst = arguments[1].firstChild.childNodes;
		for(var i=0; i<lst.length; i++) {
			if(arguments[0] == lst[i].getAttribute('termidx')) {
				arguments[1].firstChild.removeChild(lst[i]);
				break;
			}
		}
	} else {
		fatalError('custtkmdanno_prior_removeterm: unknown arguments');
	}
}
function custtkmdannoedit_removeTerm() {
/* doing what custtkmdanno_prior_removeterm does but with extra work
here has to actually remove attribute and redraw track attribute canvas...
variable argument:
	- event, called by clicking on <td>X</td> in the shitty table
	- string, md term
important: 
	- obtain track filetype and name from gflag.ctmae
	- term and term parent are attributes of tr of the clicked <td>
*/
	var termiscustom;
	var term;
	var termparent;
	var termtable=document.getElementById('custtkmdanno_showholder');
	if(typeof(arguments[0])=='string') {
		var lst = termtable.firstChild.childNodes;
		for(var i=0; i<lst.length; i++) {
			if(arguments[0] == lst[i].getAttribute('termidx')) {
				term = lst[i].getAttribute('termidx');
				termparent = lst[i].getAttribute('termparent');
				termiscustom = lst[i].getAttribute('custom')!=null;
				termtable.firstChild.removeChild(lst[i]);
				break;
			}
		}
	} else {
		// it is event on the <td> object
		var trobj = arguments[0].target.parentNode;
		term = trobj.getAttribute('termidx');
		termparent = trobj.getAttribute('termparent');
		termiscustom = trobj.getAttribute('custom')!=null;
		termtable.firstChild.removeChild(trobj);
	}
	// toggle display of wordy
	if(termtable.firstChild.childNodes.length > 1) {
		termtable.style.display = 'table';
		document.getElementById('custtkmdanno_editsaysno').style.display = 'none';
	} else {
		termtable.style.display = 'none';
		document.getElementById('custtkmdanno_editsaysno').style.display = 'block';
	}
	var tkname = gflag.ctmae.tkname;
	var ft = gflag.ctmae.ft;
	var _bbj=gflag.ctmae.bbj;
	// remove 1: from registration object
	var obj= _bbj.genome.hmtk[tkname];
	if(termiscustom) {
		delete obj.custmd[termparent];
	} else {
		for(var i=0; i<obj.md.length; i++) {
			if(obj.md[i]==term) {
				obj.md.splice(i,1);
				break;
			}
		}
	}
	// remove 2: from display object
	obj=_bbj.findTrack(tkname);
	if(obj!=null) {
		if(termiscustom)
			delete obj.custmd[termparent];
		else
			delete obj.attrhash[term];
		_bbj.prepareMcm();
		_bbj.drawMcm(false);
	}
}

function custtkmdannoedit_invokemds(event) {
// edit metadata annotation for custom tracks (are they are submitted)
	var bbj=gflag.ctmae.bbj;
	var lst = custmdtable_getTermlist(document.getElementById('custtkmdanno_showholder'));
	bbj.genome.toggleMdtermcheckbox4tkanno(lst[0], lst[1]);
	bbj.genome.invokemds(3, event.clientX+20+document.body.scrollLeft, event.clientY-40+document.body.scrollTop);
}

Browser.prototype.mcmPlaceheader=function()
{
var m=this.mcm;
if(m==null) return;
/* this is to escape for alethiometer
*/
var lst=m.holder.firstChild.firstChild.childNodes;
if(m.holder.attop==undefined) {
	for(var i=0; i<lst.length; i++)
		lst[i].vAlign='bottom';
	return;
}
var pos=absolutePosition(m.tkholder);
m.holder.style.left=pos[0];
if(m.holder.attop) {
	m.holder.style.top=pos[1]-m.holder.clientHeight;
} else {
	m.holder.style.top=pos[1]+m.tkholder.clientHeight;
}
for(var i=0; i<lst.length; i++)
	lst[i].vAlign=m.holder.attop?'bottom':'top';
}

function custmdinput_show(event)
{
event.target.nextSibling.style.display='block';
event.target.style.display='none';
}
function custmdinput_hide(event)
{
event.target.parentNode.style.display='none';
event.target.parentNode.previousSibling.style.display='block';
}
function custmdinput_selectchange()
{
gflag.mdp.bbj.genome.newcustmd_setattrvalue();
}

function show_mcmColorConfig()
{
// called by clicking menu.c9
menu_shutup();
menu.style.left=Math.min(parseInt(menu.style.left),document.body.clientWidth-300);
var holder=menu.c9.nextSibling;
holder.style.display='block';
stripChild(holder,0);
var tr=holder.insertRow(0);
var td=tr.insertCell(0);
td.colSpan=3;
td.innerHTML='Change color setting<div style="color:#858585;font-size:60%;">These colors are used to paint metadata color map</div>';
for(var i=0; i<3; i++) {
	tr=holder.insertRow(-1);
	for(var j=0; j<3; j++) {
		var sid=i*3+j;
		td=tr.insertCell(-1);
		td.innerHTML='&nbsp;';
		td.style.backgroundColor=colorCentral.longlst[sid];
		td.sid=sid;
		td.addEventListener('click',mcm_configcolor_initiate,false);
	}
}
td=holder.insertRow(-1).insertCell(0);
td.colSpan=3;
td.innerHTML='<button type=button onclick=mcm_configcolor_restore()>Restore default settings</button>';
}

function mcm_configcolor_restore()
{
var lst=[];
for(var i=0; i<colorCentral.longlst_bk.length; i++) lst.push(colorCentral.longlst_bk[i]);
colorCentral.longlst=lst;
show_mcmColorConfig();
gflag.menu.bbj.drawMcm(false);
}


function mcm_configcolor_initiate(event)
{
paletteshow(event.clientX, event.clientY, 12);
palettegrove_paint(event.target.style.backgroundColor);
menu.colorlonglstcell=event.target;
}
function mcm_configcolor()
{
var c=menu.colorlonglstcell;
c.style.backgroundColor=
colorCentral.longlst[c.sid]= palette.output;
gflag.menu.bbj.drawMcm(false);
}

/*** __metadata__ over ***/



/*** __cfacet__ facet for custom tracks
custom track and mdterm info belongs to genome
but tk display info, cfacet belongs to browser
***/

function cfacet_selectchange(event) {
// changing <select> holding cust terms
	var bbj=gflag.tsp.bbj;
	var v1=bbj.cfacet.md1.options[bbj.cfacet.md1.selectedIndex].value;
	var v2=bbj.cfacet.md2.options[bbj.cfacet.md2.selectedIndex].value;
	var lst=bbj.cfacet.md2.options;
	for(var i=1; i<lst.length; i++)
		lst[i].disabled=lst[i].value==v1;
	if(v2==v1)
		bbj.cfacet.md2.selectedIndex=0;
	bbj.cfacet_generategrid();
}

Browser.prototype.cfacet_generategrid=function()
{
// this is the case of not yet having any custom terms
if(this.cfacet==null) return;
var table = this.cfacet.holder;
stripChild(table.firstChild, 0);
if(this.cfacet.md1.selectedIndex==-1)
	return;

var rowname = this.cfacet.md1.options[this.cfacet.md1.selectedIndex].value;
var rowattrlst = this.genome.custmdhash[rowname];
var s2 = this.cfacet.md2;
if(s2.selectedIndex == 0) {
	// one criteron
	for(var i=0; i<rowattrlst.length; i++) {
		var tr = table.insertRow(-1);
		var td = tr.insertCell(0);
		td.align = 'right';
		td.innerHTML = rowattrlst[i];
		tmp = custtk_numpair2str(this.custtkCount_onecustmd(rowname,rowattrlst[i]));
		tr.insertCell(-1).innerHTML = tmp[0] ? '<div class=tscell onclick="showcusttkchoice(\''+rowname+'\',\''+rowattrlst[i]+'\')">'+tmp[1]+'</div>' : tmp[1];
	}
	return;
}
// two criteria
var colname = s2.options[s2.selectedIndex].value;
var colattrlst = this.genome.custmdhash[colname];
var tr = table.insertRow(0);
tr.insertCell(0);
tr.insertCell(-1);
var td = tr.insertCell(-1);
td.style.border='solid 1px #ccc';
td.align='center';
td.innerHTML = colname;
td.colSpan = colattrlst.length;
// second row, vertical names
tr = table.insertRow(-1);
tr.insertCell(0);
tr.insertCell(-1);
for(var i=0; i<colattrlst.length; i++) {
	td = tr.insertCell(-1);
	td.vAlign = 'bottom';
	td.appendChild(makecanvas_verticalstring(colattrlst[i], colorCentral.foreground, false, true));
}
// first row of rowattrlst
for(i=0; i<rowattrlst.length; i++) {
	tr=table.insertRow(-1);
	if(i==0) {
		// make vertical header of rows
		td = tr.insertCell(0);
		td.style.border='solid 1px #ccc';
		td.vAlign = "middle";
		td.appendChild(makecanvas_verticalstring(rowname, colorCentral.foreground, false, true));
		td.rowSpan = rowattrlst.length;
	}
	td = tr.insertCell(-1);
	td.align = 'right';
	td.innerHTML = rowattrlst[i];
	for(var j=0; j<colattrlst.length; j++) {
		var tmp = custtk_numpair2str(this.custtkCount_twocustmd(rowname,rowattrlst[i],colname,colattrlst[j]));
		tr.insertCell(-1).innerHTML = tmp[0] ? '<div class=tscell onclick="showcusttkchoice(\''+rowname+'\',\''+rowattrlst[i]+'\',\''+colname+'\',\''+colattrlst[j]+'\')">'+tmp[1]+'</div>' : tmp[1];
	}
}
}

Browser.prototype.custtkCount_onecustmd=function(term, attr)
{
// give two number of cust tracks on a custom metadata term
var nall=0, nuse=0;
for(var tk in this.genome.hmtk) {
	var o=this.genome.hmtk[tk];
	if(!isCustom(o.ft)) continue;
	var h = o.custmd;
	if(h == undefined) continue;
	if(term in h && h[term]==attr) {
		nall++;
		if(this.findTrack(tk) != null)
			nuse++;
	}
}
return [nall, nuse];
}

Browser.prototype.custtkCount_twocustmd=function(term1, attr1, term2, attr2)
{
// give two number of cust tracks on two custom metadata term
var nall=0, nuse=0;
for(var tk in this.genome.hmtk) {
	var o=this.genome.hmtk[tk];
	if(!isCustom(o.ft)) continue;
	var h = o.custmd;
	if(h == undefined) continue;
	if(term1 in h && h[term1]==attr1 && term2 in h && h[term2]==attr2) {
		nall++;
		if(this.findTrack(tk) != null)
			nuse++;
	}
}
return [nall, nuse];
}

function custtk_numpair2str(numpair) {
/* takes input from custtkCount_onecustmd or two
return print string with link
but have to wrap it into <div class=tscell></div> with onclick attached to it
*/
	if(numpair[0] == 0)
		return [false, '<span style="color:#ccc;">n/a</span>'];
	return [true, '<span class=g>'+numpair[0]+'</span>'+(numpair[1]==0 ? '/0' : '/<span class=r>'+numpair[1]+'</span>')];
}

function showcusttkchoice() {
/* called by clicking on tscell in custom track grid
variable argument
- if length 2, will be term, attr
- if length 4, will be two pairs of term/attr

big difference with native facet, will highlight rows in registry table to show the tracks
*/
	var bbj=gflag.tsp.bbj;
	var t1 = arguments[0];
	var a1 = arguments[1];
	var t2 = arguments[2]; // optional
	var a2 = arguments[3]; // optional
	var tklst = [];
	for(var tk in bbj.genome.hmtk) {
		var o=bbj.genome.hmtk[tk];
		if(!isCustom(o.ft)) continue;
		var hash = o.custmd;
		if(t1 in hash && hash[t1]==a1) {
			if(t2 == undefined) {
				o.registrytr.style.backgroundColor=colorCentral.hl;
				continue;
			} else {
				if(t2 in hash && hash[t2]==a2) {
					o.registrytr.style.backgroundColor=colorCentral.hl;
					continue;
				}
			}
		}
		o.registrytr.style.backgroundColor='transparent';
	}
}

/*** __cfacet__ over ***/




/*** __hmtk__ ***/
function hmtkentry_click(event)
{
/* clicking on a track item
the item (list) should always be hosted in one of the panels in menu:
- facet tklst table
- general purpose track selection panel, for all types of tracks that are currently on show
  including hmtk and decor
*/
var bbj=gflag.menu.bbj;
var add = false;
if(event.target.style.backgroundColor == 'transparent') {
	event.target.style.backgroundColor = colorCentral.tkentryfill;
	add = true;
} else {
	event.target.style.backgroundColor = 'transparent';
}
var tkname = event.target.tkname;
var tkobj=bbj.findTrack(tkname);
var ft, tknameurl;
/* notice: display object can be missing
in case of facet track selection
*/
if(tkobj!=null) {
	ft=tkobj.ft;
	tknameurl=isCustom(ft) ? tkobj.url : tkname;
}
switch(gflag.menu.context) {
case 10: // facet tk selection
	var s=menu.selecttk4add_count;
	var butt=menu.selecttk4add_butt;
	if(add) {
		// try to add, if it's already pending, do nothing
		s.innerHTML=parseInt(s.innerHTML)+1;
		butt.style.backgroundColor='green';
	} else {
		// remove
		var count= parseInt(s.innerHTML)-1;
		s.innerHTML=count;
		if(count==0) butt.style.backgroundColor='white';
	}
	break;
/*
case 5: // pwc
	if(ft==FT_cat_c||ft==FT_cat_n) {
		print2console("categorical tracks cannot be used for pairwise comparison", 2);
		event.target.style.backgroundColor = 'transparent';
		return;
	}
	if(add) {
		pwc_assigngrp(tkname, tkselect.grp);
	} else {
		var d = document.getElementById(tkname+'inpwcgrp');
		d.parentNode.removeChild(d);
	}
	break;
case 4: // htest
	if(ft==FT_cat_c||ft==FT_cat_n) {
		print2console("categorical tracks cannot be used for hypothesis test", 2);
		event.target.style.backgroundColor = 'transparent';
		return;
	}
	if(add) {
		htest_assigngrp(tkname, tkselect.grp);
	} else {
		var d = document.getElementById(tkname+'inhtestgrp');
		d.parentNode.removeChild(d);
	}
	break;
case 3: // hm corr
	if(ft==FT_cat_c||ft==FT_cat_n) {
		print2console("categorical tracks cannot be used for correlation", 2);
		event.target.style.backgroundColor = 'transparent';
		return;
	}
	correlation.targetname = tkname;
	correlation.targetft = ft;
	correlation.where = 0; // from heatmap...
	correlation.inuse = true;
	runCorrelation();
	tkspanel_close();
	break;
	*/
case 13: // gene plot
	if(ft!=FT_bedgraph_c&&ft!=FT_bedgraph_n&&ft!=FT_bigwighmtk_c&&ft!=FT_bigwighmtk_n&&ft!=FT_qdecor_n) {
		print2console("Only quantitative tracks can be used for Gene Plot", 2);
		event.target.style.backgroundColor = 'transparent';
		return;
	}
	document.getElementById('geneplot_tklabel').innerHTML = tkobj.label;
	gflag.gplot.tk=tkobj;
	//document.getElementById('geneplot_tk').innerHTML = tknameurl;
	//document.getElementById('geneplot_tkft').innerHTML = ft;
	menu_hide();
	break;
case 14: // hengeview wreath track
	if(ft==FT_lr_n||ft==FT_lr_c||ft==FT_sam_c||ft==FT_sam_n) {
		print2console('This type of track cannot be used here',2);
		event.target.style.backgroundColor = 'transparent';
		return;
	}
	var wreath=hengeview.hash[gflag.menu.viewkey].wreath;
	// see if already exists
	var exist=false;
	for(var i=0; i<wreath.length; i++) {
		if(wreath[i].name==tkname) {
			exist=true;break;
		}
	}
	if(exist) break;
	var obj2=duplicateTkobj(tkobj);
	obj2.data={}; // data is hash, not array!
	obj2.qtc.height=(ft==FT_cat_n||ft==FT_cat_c)?10:20;
	wreath.push(obj2);
	hengeview_wreath_addone(gflag.menu.viewkey);
	break;
case 16: // gene set sort
	if(ft!=FT_bedgraph_c&&ft!=FT_bedgraph_n&&ft!=FT_bigwighmtk_c&&ft!=FT_bigwighmtk_n&&ft!=FT_qdecor_n) {
		print2console('only quantitative tracks can be used for sorting', 2);
		event.target.style.backgroundColor = 'transparent';
		return;
	}
	bbj.genesetview.sort_tklabel.innerHTML = tkobj.label;
	bbj.genesetview.tk4sort=tkobj;
	menu_hide();
	break;
case 18: // bev
	if(ft==FT_lr_n||ft==FT_lr_c) {
		print2console('Sorry but long-range interaction track cannot yet be used for this purpose',2);
		event.target.style.backgroundColor = 'transparent';
		return;
	}
	if(ft==FT_sam_n||ft==FT_sam_c) {
		print2console('Sorry but SAM track cannot yet be used for this purpose',2);
		event.target.style.backgroundColor = 'transparent';
		return;
	}
	bbj.bev_mayaddtrack(tkname);
	break;
default:
	fatalError('hmtkentry_click: unknown gflag.menu.context');
}
/* over */
}

Browser.prototype.toggle8=function(which)
{
// tabpage in hmtk panel
document.getElementById('tabpage_hmtk_tab1').className='tabpageOff';
document.getElementById('tabpage_hmtk_tab2').className='tabpageOff';
//document.getElementById('tabpage_hmtk_tab3').className='tabpageOff';
document.getElementById('tabpage_hmtk_tab4').className='tabpageOff';
document.getElementById('tabpage_hmtk_content1').style.display='none';
document.getElementById('tabpage_hmtk_content2').style.display='none';
//document.getElementById('tabpage_hmtk_content3').style.display='none';
document.getElementById('tabpage_hmtk_content4').style.display='none';
document.getElementById('tabpage_hmtk_tab'+which).className='tabpageOn';
document.getElementById('tabpage_hmtk_content'+which).style.display='block';
}

Browser.prototype.track2holder=function() {
// put dom objects to holders by order of .tklst
for(var i=0; i<this.tklst.length; i++) {
	var tk=this.tklst[i];
	if(tk.where==1) {
		this.hmheaderdiv.appendChild(tk.header);
		this.hmdiv.appendChild(tk.canvas);
		tk.atC.style.display='block';
		this.mcm.tkholder.appendChild(tk.atC);
	} else {
		this.decorheaderdiv.appendChild(tk.header);
		this.decordiv.appendChild(tk.canvas);
		tk.atC.style.display='none';
	}
}
this.trackHeightChanged();
}

function removeallnativehmtk()
{
// called by pushing butt in facet panel
var bbj=gflag.tsp.bbj;
var lst=[];
for(var i=0; i<bbj.tklst.length; i++) {
	var ft=bbj.tklst[i].ft;
	if(!isCustom(ft) && (isHmtk(ft) || ft==FT_lr_n))
		lst.push(bbj.tklst[i].name);
}
if(lst.length==0)
	print2console('Not removing: no native assay tracks in display',2);
bbj.removeTrack(lst);
}

Genome.prototype.toggleDataset=function()
{
// flip indicator by .currentDatasets;
for(var i=0; i<this.datasetLst.length; i++) {
	var n=this.datasetLst[i];
	this.datasetStat[n].innerHTML= (thinginlist(n, this.currentDatasets)) ?
		'<span class=g>in use</span> <button type=button onclick="gflag.tsp.bbj.removedataset(\''+n+'\')">&nbsp;drop&nbsp;</button>' :
		'<span class=r>not in use</span> <button type=button onclick="gflag.tsp.bbj.importdataset(\''+n+'\')">import</button>';
}
}

Browser.prototype.importdataset=function(name)
{
/* called by pushing button
because only browser can issue ajax so browser will retrieve the data
then push the data to genome
*/
if(!thinginlist(name, this.genome.datasetLst)) fatalError('importdataset: illegal name');
this.genome.datasetStat[name].innerHTML='importing ...';
this.ajax('dbName='+this.genome.name+'&importdataset='+name,function(data){
	var bbj=horcrux[data.horcrux];
	for(var tk in data.hmtkinfo)
		bbj.genome.hmtk[tk]=data.hmtkinfo[tk];
	for(var i=0; i<data.dsnames.length; i++)
		bbj.genome.currentDatasets.push(data.dsnames[i]);
	bbj.genome.toggleDataset();
	bbj.generateTrackselectionLayout();
});
}

Browser.prototype.removedataset=function(name)
{
/* called by pushing button
because tk-ds info is not kept, so need to re-request it
*/
if(!thinginlist(name, this.genome.datasetLst)) fatalError('importdataset: illegal name');
this.genome.datasetStat[name].innerHTML='dropping ...';
this.ajax('dbName='+this.genome.name+'&loaddataset_tkname='+name,function(data){
	var bbj=horcrux[data.horcrux];
	var tkinuse=[];
	for(var i=0; i<data.tknames.length; i++) {
		var n=data.tknames[i];
		delete bbj.genome.hmtk[n];
		if(bbj.findTrack(n)!=null)
			tkinuse.push(n);
	}
	if(tkinuse.length > 0)
		bbj.removeTrack(tkinuse);
	var Lst=bbj.genome.currentDatasets;
	for(i=0; i<data.dsnames.length; i++) {
		for(var j=0; j<Lst.length; j++) {
			if(Lst[j]==data.dsnames[i]) {
				Lst.splice(j,1);
				break;
			}
		}
	}
	bbj.genome.toggleDataset();
	bbj.generateTrackselectionLayout();
});
}

Browser.prototype.findHmtkbyGeo=function()
{
if(this.facet.geolist4hmtk.value.length==0) return;
var lst=this.facet.geolist4hmtk.value.split('\n');
if(lst.length==0) return;
this.facet.hmtkbygeobutt.disabled=true;
this.facet.hmtkbygeobutt.innerHTML='Searching...';
this.ajax('dbName='+this.genome.name+'&geofindhmtk=on&lst='+lst.join(','),function(data){
	var bbj=horcrux[data.horcrux];
	// first, see if covered data sets have already been deposited
	var missing=[];
	for(var i=0; i<data.datasets.length; i++) {
		if(!thinginlist(data.datasets[i],bbj.genome.currentDatasets))
			missing.push(data.datasets[i]);
	}
	if(missing.length>0) {
		print2console('loading new datasets...',1);
		gflag.hmtkbygeo=data.result;
		bbj.ajax('dbName='+bbj.genome.name+'&importdataset='+missing.join(','),function(data){
			var bbj=horcrux[data.horcrux];

			// repetitve code to add genome
			for(var tk in data.hmtkinfo)
				bbj.genome.hmtk[tk]=data.hmtkinfo[tk];
			for(var i=0; i<data.dsnames.length; i++)
				bbj.genome.currentDatasets.push(data.dsnames[i]);
			bbj.genome.toggleDataset();
			bbj.generateTrackselectionLayout();

			var butt=bbj.facet.hmtkbygeobutt;
			var pos=absolutePosition(butt);
			var nlst=[];
			for(var i=0; i<gflag.hmtkbygeo.length; i+=2)
				nlst.push(gflag.hmtkbygeo[i+1]);
			bbj.showhmtkchoice(nlst, false, pos[0]-document.body.scrollLeft, pos[1]+butt.clientHeight-document.body.scrollTop);
			butt.disabled=false;
			butt.innerHTML='Search';
		});
	} else {
		// not loading new datasets
		var nlst=[];
		for(var i=0; i<data.result.length; i+=2)
			nlst.push(data.result[i+1]);
		var butt=bbj.facet.hmtkbygeobutt;
		var pos=absolutePosition(butt);
		bbj.showhmtkchoice(nlst, false, pos[0]-document.body.scrollLeft, pos[1]+butt.clientHeight-document.body.scrollTop);
		butt.disabled=false;
		butt.innerHTML='Search';
	}
});
}

/*** __hmtk__ over ***/



function kwsearch_tipover(event)
{
picasays.innerHTML='Keywords are case insensititve<br><br>join multiple keywords by <b>AND</b><br><br>e.g. "brain AND h3k4me3"';
pica_go(event.clientX,event.clientY);
}
function nativetk_kwsearch_ku(event) { if(event.keyCode==13) nativetk_kwsearch(); }

function nativetk_kwsearch()
{
var bbj=gflag.tsp.bbj;
var ip=bbj.facet.kwsearch_input;
if(ip.value.length==0) {
	print2console('Please enter keyword to search',2);
	return;
}
if(ip.value.indexOf(',')!=-1) {
	print2console('Comma not allowed for keywords',2);
	return;
}
var lst=ip.value.split(' AND ');
var lst2=[];
for(var i=0; i<lst.length; i++) {
	if(lst[i].length>0) {
		if(lst[i].search(/\S/)!=-1) {
			var b=lst[i].replace(/\s/g,'');
			if(b.length==1) {
				print2console('Keyword can\'t be just one character',2);
				return;
			}
			lst2.push(lst[i]);
		}
	}
}
if(lst2.length==0) {
	print2console('No valid keyword',2);
	return;
}
// make sql clause (too hard for cgi to do that)
var clauselabel=[], clausedesc=[], clausegeo=[];
for(i=0; i<lst2.length; i++) {
	clauselabel.push('label like "%'+lst2[i]+'%"');
	clausedesc.push('detail like "%'+lst2[i]+'%"');
	clausegeo.push('geo="'+lst2[i]+'"');
}
invisible_shield(bbj.facet.div2);
var pos=absolutePosition(ip);
menu_shutup();
menu.c1.style.display='block';
menu.c1.innerHTML='Searching for tracks by keyword...';
menu_show(0,pos[0]-document.body.scrollLeft-10,pos[1]-document.body.scrollTop+20);
bbj.ajax('tkkwsearch=on&clauselabel='+escape(clauselabel.join(' and '))+'&clausedesc='+escape(clausedesc.join(' and '))+'&clausegeo='+escape(clausegeo.join(' and '))+'&dbName='+bbj.genome.name,function(data){
	var bbj=horcrux[data.horcrux];
	if(data.error) {
		print2console('Error: '+data.error,2);
		return;
	}
	if(data.lst.length==0) {
		menu.c1.innerHTML='No hits found';
		print2console('No tracks found by your keyword',1);
		return;
	}
	// only show those in current dataset
	var lst2=bbj.__tkfind_applicationspecific(data.lst);
	if(lst2.length==0) {
		menu.c1.innerHTML='No hits found';
		print2console('No tracks found by your keyword',1);
		return;
	}
	gflag.menu.context=10; // must
	print2console(lst2.length+' track(s) found',1);
	gflag.tsp.invoke.type=4;
	bbj.showhmtkchoice(lst2,false);
});
}

/*** __facet__ for native tracks ***/

function nativefacet_tabclick(event)
{
var f=gflag.tsp.bbj.facet;
f.content_facet.style.display= f.content_dataset.style.display='none';
f.tab_facet.className=f.tab_dataset.className='tabpageOff';
if(event.target.which=='facet') {
	f.tab_facet.className='tabpageOn';
	f.content_facet.style.display='block';
} else {
	f.tab_dataset.className='tabpageOn';
	f.content_dataset.style.display='block';
	f.content_dataset.appendChild(gflag.tsp.bbj.genome.datasetHolder);
}
}
Browser.prototype.generateTrackselectionLayout=function()
{
/* called upon:
- initiation
- pushing button generatehmtksgridbutt

all metadata hashes should be stationed with browser object
*/
if(this.facet==null) return;
if(this.facet.md1.selectedIndex==-1) {
	// this is the case when md1 does not have any options
	return;
}
this.facet.div3.style.display='none';
this.facet.banner.style.display='block';
var v1=this.facet.md1.options[this.facet.md1.selectedIndex].value;
var v2=this.facet.md2.options[this.facet.md2.selectedIndex].value;
this.facet.rowlst=[];
this.facet.collst=[];
this.facet.v1=v1;
if(v2 == this.facet._no_term) {
	// only one criterion applies, make a text tree
	this.facet.v2=null;
	this.facet.div2.style.display = "none";
	this.facet.div1.style.display = "block";
	var lst = [];
	for(var i=0; i<this.genome.mdvp2c[v1].length; i++)
		lst.push(this.trackselectionoption_onecriteria(this.genome.mdvp2c[v1][i]));
	this.facet.div1.innerHTML = "<ul>"+lst.join('')+"</ul>";
	return;
}
// two criteria
this.facet.v2=v2;
this.facet.div2.style.display = "block";
this.facet.div1.style.display = "none";
var lst=this.genome.mdvp2c[v1];
for(var i=0; i<lst.length; i++)
	this.facet.rowlst.push([lst[i], 0, '&#8862;']);
lst=this.genome.mdvp2c[v2];
for(i=0; i<lst.length; i++)
	this.facet.collst.push([lst[i], 0, '&#8862;']);
this.generateTrackselectionGrid();
/* expand table to show one more level
   but it is disabled because it slows down response (the grid is too big)
for(i=0; i<mdvp2c[v1].length; i++) {
	var t = mdvp2c[v1][i];
	if(t in mdvp2c)
		simulateEvent(document.getElementById(t+"td"),'click');
}
for(i=0; i<mdvp2c[v2].length; i++) {
	var t = mdvp2c[v2][i];
	if(t in mdvp2c)
		simulateEvent(document.getElementById(t+"td"),'click');
}
*/
}

Browser.prototype.generateTrackselectionGrid=function()
{
/* for two criteria case
make grid for track selection, each cell corresponds to metadata categories
rerun when criteria changed
*/
this.facet.rowlst_td=[];
this.facet.collst_td=[];
// for childrens of v1/v2, recursively make set of tracks
var attr2tkset = {};
// key: attr, val: set of track
for(var i=0; i<this.facet.rowlst.length; i++) {
	// skip expanded parent term
	var t=this.facet.rowlst[i];
	if(t[2] == '&#8863;') continue;
	var s = {};
	this.recursivegettrack(t[0], s);
	attr2tkset[t[0]] = s;
}
for(i=0; i<this.facet.collst.length; i++) {
	var t=this.facet.collst[i];
	if(t[2] == '&#8863;') continue;
	var s = {};
	this.recursivegettrack(t[0], s);
	attr2tkset[t[0]] = s;
}
var table = this.facet.div2;
if(table.firstChild)
	stripChild(table.firstChild, 0);

/** first row **/
var tr = table.insertRow(0);
// one cell for each attribute in facet.collst, vertical canvas
for(var i=0; i<this.facet.collst.length; i++) {
	var colt=this.facet.collst[i];
	/* column header */
	var td = tr.insertCell(-1);
	td.className='facet_colh';
	td.align='center';
	td.vAlign='bottom';
	td.style.paddingBottom = colt[1];
	td.idx=i;
	var color;
	if(colt[0] in this.genome.mdvidx2attr) {
		// is leaf
		td.style.paddingTop = colt[1] + 17;
		color=colorCentral.foreground;
	} else {
		// not leaf
		td.style.cursor='pointer';
		td.iscolumn=true;
		td.addEventListener("click", facettermclick_grid, false);
		if(colt[2]=='&#8862;') {
			// collapsed
			color=colorCentral.foreground;
		} else {
			color='#858585';
			td.style.borderColor='transparent';
		}
	}
	td.addEventListener("mouseover", tksverticalmouseover, false);
	td.addEventListener("mouseout", tksverticalmouseout, false);

	var c = makecanvas_verticalstring(
		(colt[0] in this.genome.mdvidx2attr) ? this.genome.mdvidx2attr[colt[0]] : colt[0],
		color, false, true);
	td.appendChild(c);

	var d=document.createElement('div');
	if(colt[0] in this.genome.mdvidx2attr) {
		d.style.width=d.style.height=15;
	} else {
		d.innerHTML=colt[2];
		d.style.color=color;
	}
	td.appendChild(d);

	this.facet.collst_td.push(td); // for highlight
}
var td = tr.insertCell(-1);
td.align='left';
td.vAlign='bottom';
td.className='facet_cell';
td.style.padding='10px';
td.addEventListener('mouseover', menu_hide, false);
td.innerHTML='<button type=button style="font-size:20px" onclick=facet_grid_swap()>&#10529;</button>';
/*
td = tr.insertCell(-1);
td.colSpan = this.facet.collst.length;
td.align='center';
td.style.border='solid 1px #C0B497';
td.style.borderBottomWidth=0;
td.appendChild(this.facet.md2);
tr = table.insertRow(-1);
td = tr.insertCell(0);
td.colSpan = 2;
td.vAlign = "top";
td.align = "left";
*/

// remaining rows, one for each attribute in facet.rowlst
for(i=0; i<this.facet.rowlst.length; i++) {
	// make first cell, the row header
	var rowt=this.facet.rowlst[i];
	tr = table.insertRow(-1);
	/*** make cells containing number pairs ***/
	for(var j=0; j<this.facet.collst.length; j++) {
		td = tr.insertCell(-1);
		var what2 = this.facet.collst[j][0];
		if(!(rowt[0] in attr2tkset) || !(what2 in attr2tkset)) {
			// to skip expanded row and column
			continue;
		}
		var intersection = {};
		for(var tk in attr2tkset[rowt[0]]) {
			if(tk in attr2tkset[what2])
				intersection[tk] = 1;
		}
		td.className='facet_cell';
		td.ridx=i;
		td.cidx=j;
		var num = this.tracksetTwonumbers(intersection);
		if(num[0] == 0) {
			td.innerHTML = '<span style="color:#ccc;">n/a</span>';
		} else {
			td.innerHTML = '<div class=tscell style="display:inline-block;"'+
				' onmouseover="tksNumbercellMouseover('+i+','+j+')"'+
				' onmouseout="tksNumbercellMouseout('+i+','+j+')"'+
				' term1="'+rowt[0]+'" '+
				' term2="'+what2+'" '+
				' onclick="facetcell_click(event)"'+
				' title="click to show tracks"'+
				'><span class=g>'+ num[0] + '</span>' +
				((num[1]==0) ? '/0' : '/<span class=r>'+num[1]+'</span>') +
				'</div>';
		}
	}
	/* row header */
	td = tr.insertCell(-1);
	td.style.paddingLeft = rowt[1];
	td.className='facet_rowh';
	td.idx=i;
	var tns = (rowt[0] in this.genome.mdvidx2attr) ? this.genome.mdvidx2attr[rowt[0]] : rowt[0];
	if(rowt[0] in this.genome.mdvidx2attr) {
		// is leaf
		td.innerHTML=tns;
		td.style.paddingLeft = rowt[1] + 17;
	} else {
		// not leaf
		td.innerHTML=rowt[2]+' '+tns;
		td.iscolumn=false;
		td.addEventListener("click", facettermclick_grid, false);
		td.style.cursor='pointer';
		if(rowt[2]!='&#8862;') {
			// expanded
			td.style.borderColor='transparent';
			td.style.color='#858585';
		}
	}
	td.addEventListener("mouseover", tkshorizontalmouseover, false);
	td.addEventListener("mouseout", tkshorizontalmouseout, false);
	this.facet.rowlst_td.push(td);
}
/*
tr = table.insertRow(-1);
td = tr.insertCell(0);
td.rowSpan = this.facet.rowlst.length;
td.vAlign = "middle";
td.style.border='solid 1px #C0B497';
td.style.borderRightWidth=0;
var d=document.createElement('div');
d.style.position='relative';
d.style.width=d.style.height=30;
// display md1 and obtain width
document.body.appendChild(this.facet.md1);
var w=this.facet.md1.clientWidth;
d.appendChild(this.facet.md1);
this.facet.md1.style.left=15-w/2;
td.appendChild(d);
*/
}

function facet_grid_swap() {
// swap two criteria over the grid
	var bbj=gflag.tsp.bbj;
	if(bbj.facet.v2==null) return;
	var lst=bbj.facet.md1.options;
	for(var i=0; i<lst.length; i++) {
		if(lst[i].value==bbj.facet.v2) {
			bbj.facet.md1.selectedIndex=i;
			break;
		}
	}
	lst=bbj.facet.md2.options;
	for(i=0; i<lst.length; i++) {
		if(lst[i].value==bbj.facet.v1) {
			bbj.facet.md2.selectedIndex=i;
			break;
		}
	}
	bbj.generateTrackselectionLayout();
}


Browser.prototype.tracksetTwonumbers=function(tkset)
{
// takes in a hash of track names
// return a list [total number, number displayed now]
var numall = 0; // # tracks in tkset
var numinuse = 0; // # tracks in tkset in display
for(var tk in tkset) {
	numall++;
	if(this.findTrack(tk)!=null) numinuse++;
}
return [numall, numinuse];
}
Browser.prototype.trackselectionoption_onecriteria=function(what)
{
// use when only one criterion is used to determine track selection layout
// return string for one metadata term, which is one <li>
var isLeaf = what in this.genome.mdvidx2attr;
// count tracks annotated to this term
var tkset = {};
this.recursivegettrack(what, tkset);
var num = this.tracksetTwonumbers(tkset);
if(isLeaf)
	return '<li>'+this.genome.mdvidx2attr[what]+' '+
		maketrackselectioncell_onecriteria(what, num[0], num[1]) +'</li>';
else
	return '<li><span class=clb onclick=toggle32(event) term="'+what+'"'+
		' title="click to show/hide details"><span>&#8862;</span> '+
		what+'</span> '+
		maketrackselectioncell_onecriteria(what, num[0], num[1]) +'</li>' +
		'<ul id="'+what+'ul" style="display:none;"></ul>';
}
function maketrackselectioncell_onecriteria(attr, numall, numinuse)
{
if(numall == 0) {
	return '<span style="color:#ccc;">n/a</span>';
} else {
	return '<div class=tscell style="display:inline-block;"'+
   ' term1="'+attr+'"'+
   ' onclick="facetcell_click(event)"'+
   ' title="click to show tracks"'+
   '><span class=g>'+ numall + '</span>' +
   ((numinuse==0) ? '/0' : '/<span class=r>'+numinuse+'</span>') +
   '</div>';
}
}
function toggle32(event) {
/* called by clicking on <span> within <li>
for hmtk facet browsing panel (one criterion state)
<li> should have <ul> as its next sibling
*/
	var span = event.target;
	var ul = span.parentNode.nextSibling;
	if(ul.tagName != 'UL') {
		span = event.target.parentNode;
		ul = span.parentNode.nextSibling;
		if(ul.tagName != 'UL')
			fatalError('toggle32: could not find UL as next sibling');
	}
	var hidden = ul.style.display == 'none';
	var term = span.getAttribute('term');
	var mdv=gflag.tsp.bbj.genome.mdvp2c;
	if(hidden) {
		var wlst = [];
		for(var i=0; i<mdv[term].length; i++)
			wlst.push(gflag.tsp.bbj.trackselectionoption_onecriteria(mdv[term][i]));
		ul.innerHTML = wlst.join('');
		ul.style.display = "block";
		span.firstChild.innerHTML = '&#8863;';
	} else {
		stripChild(ul, 0);
		ul.style.display = "none";
		span.firstChild.innerHTML = '&#8862;';
	}
}
function tksNumbercellMouseover(i,j)
{
// supplies array idx to facet.rowlst, facet.collst
var f=gflag.tsp.bbj.facet;
var t = f.rowlst_td[i];
t.style.backgroundColor = colorCentral.hl;
//t.style.borderBottomColor = "#009e00";
t = f.collst_td[j];
t.style.backgroundColor=colorCentral.hl;
//t.style.borderRightColor = "#009e00";
menu.style.display='none';
}
function tksNumbercellMouseout(i,j) {
	var f=gflag.tsp.bbj.facet;
	var t = f.rowlst_td[i];
	t.style.backgroundColor="transparent";
	t = f.collst_td[j];
	t.style.backgroundColor="transparent";
}
function tksverticalmouseover(event) {
	var td=event.target;
	if(td.tagName!='TD') td=td.parentNode;
	td.style.backgroundColor = colorCentral.hl;
	menu_shutup();
	menu.facetm.style.display='block';
	var p = absolutePosition(td);
	menu_show(9, p[0]-10-document.body.scrollLeft, p[1]+td.clientHeight-15-document.body.scrollTop);
	gflag.menu.termname = gflag.tsp.bbj.facet.collst[td.idx][0];
	gflag.menu.currentaspect='vertical';
}
function tksverticalmouseout(event) {
	var td=event.target;
	if(td.tagName!='TD') td=td.parentNode;
	td.style.backgroundColor="transparent";
	// don't call menu_hide(), can't let cursor move from td to menu
}
function tkshorizontalmouseover(event) {
	var td=event.target;
	if(td.tagName!='TD') td=td.parentNode;
	td.style.backgroundColor=colorCentral.hl;
	menu_shutup();
	menu.facetm.style.display='block';
	var p = absolutePosition(td);
	menu_show(9, p[0]+td.clientWidth-15-document.body.scrollLeft, p[1]-8-document.body.scrollTop);
	gflag.menu.termname = gflag.tsp.bbj.facet.rowlst[td.idx][0];
	gflag.menu.currentaspect='horizontal';
}
function tkshorizontalmouseout(event) {
	var td=event.target;
	if(td.tagName!='TD') td=td.parentNode;
	td.style.backgroundColor="transparent";
}
function facettermclick_grid(event) {
	var bbj=gflag.tsp.bbj;
	var td=event.target;
	if(td.tagName!='TD') td=td.parentNode;
	var termarray= td.iscolumn ? bbj.facet.collst : bbj.facet.rowlst;
	var term=termarray[td.idx];
	if(term[2] == '&#8862;') {
		// expand details, insert child terms into array
		term[2] = '&#8863;';
		var lst=bbj.genome.mdvp2c[term[0]];
		for(var j=0; j<lst.length; j++)
			termarray.splice(td.idx+1+j, 0, [lst[j], term[1]+20, '&#8862;']);
	} else {
		// hide details, remove child terms from array
		term[2] = '&#8862;';
		var lst = [];
		bbj.genome.mdvGetallchild(term[0], lst);
		var i=0;
		while(true) {
			if(thinginlist(termarray[i][0], lst)) {
				termarray.splice(i, 1);
			} else {
				i++;
			}
			if(i==termarray.length) break;
		}
	}
	bbj.generateTrackselectionGrid();
}

function facet_selectchange(event) {
// facet <select> onchange
	var bbj=gflag.tsp.bbj;
	var v=event.target.options[event.target.selectedIndex].value;
	if(event.target.which=='md1') {
		// disable corresponding option in md2
		var lst=bbj.facet.md2.options;
		for(var i=1; i<lst.length; i++)
			lst[i].disabled=lst[i].value==v;
		if(bbj.facet.v2==v) {
			bbj.facet.md2.selectedIndex=0;
		}
	}
	bbj.generateTrackselectionLayout();
}

function facet_subtable(swap)
{
/* make sub table with a term
beware the table can only be constructed by leaf terms
arg?
*/
var bbj=gflag.tsp.bbj;
var term=gflag.menu.termname;

var rowallchild=[];
if(term in bbj.genome.mdvp2c) {
	/* show children leaf terms, not including this one
	only leaf terms can be used, never non-leaf terms */
	bbj.genome.mdvGetallchild(term, rowallchild);
} else {
	rowallchild=[term];
}
var tkset={};
bbj.recursivegettrack(term, tkset);
// need to know the other aspect
var colroot=gflag.menu.currentaspect=='vertical' ? bbj.facet.v1 : bbj.facet.v2;
if(colroot==null) {
	colroot= bbj.facet.v1==literal_sample ? literal_assay : literal_sample;
}
var colallchild=[];
bbj.genome.mdvGetallchild(colroot, colallchild);

var colterms={};
var rowterms={};
for(var tk in tkset) {
	var lst=bbj.genome.hmtk[tk].md;
	for(var i=0; i<lst.length; i++) {
		if(thinginlist(lst[i], colallchild)) {
			colterms[lst[i]]=1;
		} else if(thinginlist(lst[i], rowallchild)) {
			rowterms[lst[i]]=1;
		}
	}
}
var col_terms=[], row_terms=[];
if(swap=='1') {
	for(var t in colterms) row_terms.push(t);
	for(t in rowterms) col_terms.push(t);
} else {
	for(var t in colterms) col_terms.push(t);
	for(t in rowterms) row_terms.push(t);
}

// generating grid (duplicative)
var attr2tkset = {};
for(var i=0; i<row_terms.length; i++) {
	var s = {};
	bbj.recursivegettrack(row_terms[i], s);
	attr2tkset[row_terms[i]]=s;
}
for(i=0; i<col_terms.length; i++) {
	var s = {};
	bbj.recursivegettrack(col_terms[i], s);
	attr2tkset[col_terms[i]]=s;
}

bbj.facet.div1.style.display=
bbj.facet.div2.style.display=
bbj.facet.banner.style.display='none';
bbj.facet.div3.style.display='block';

var table=bbj.facet.div3.childNodes[1];
stripChild(table.firstChild,0);
var tr = table.insertRow(0);
var mdv=bbj.genome.mdvidx2attr;
for(var k=0; k<col_terms.length; k++) {
	var ct=col_terms[k];
	var td = tr.insertCell(-1);
	td.vAlign = 'bottom';
	td.className='facet_colh';
	var c = makecanvas_verticalstring( (ct in mdv? mdv[ct] : ct),
		colorCentral.foreground, false, true);
	td.appendChild(c);
}
td=tr.insertCell(-1);
td.align='left';
td.vAlign='bottom';
td.className='facet_cell';
td.style.padding='10px';
td.innerHTML='<button type=button swap='+swap+' onclick="facet_subtable_swap(event)" style="font-size:20px;">&#10529;</button>';
for(k=0; k<row_terms.length; k++) {
	var rt=row_terms[k];
	tr = table.insertRow(-1);
	for(var m=0; m<col_terms.length; m++) {
		var ct=col_terms[m];
		td = tr.insertCell(-1);
		td.className='facet_cell';
		var intersection = {};
		for(var tk in attr2tkset[rt]) {
			if(tk in attr2tkset[ct])
				intersection[tk] = 1;
		}
		var num = bbj.tracksetTwonumbers(intersection);
		if(num[0] == 0) {
			td.innerHTML = '<span style="color:#ccc;">n/a</span>';
		} else {
			td.innerHTML = '<div class=tscell style="display:inline-block;"'+
				' term1="'+rt+'" '+
				' term2="'+ct+'" '+
				' onclick="facetcell_click(event)"'+
				' title="click to show tracks"'+
				'><span class=g>'+ num[0] + '</span>' +
				((num[1]==0) ? '/0' : '/<span class=r>'+num[1]+'</span>') +
				'</div>';
		}
	}
	td = tr.insertCell(-1);
	td.className='facet_rowh';
	td.innerHTML = rt in mdv ? mdv[rt] : rt;
}
menu_hide();
/* over */
}

function facet_subtable_swap(event) {
	var s=event.target.getAttribute('swap');
	s=s=='0'?'1':'0';
	facet_subtable(s);
	event.target.setAttribute('swap', s);
}
function facet_subtable_cancel() {
	var bbj=gflag.tsp.bbj;
	if(bbj.facet.v2==null) {
		bbj.facet.div1.style.display='block';
		bbj.facet.div2.style.display='none';
	} else {
		bbj.facet.div1.style.display='none';
		bbj.facet.div2.style.display='block';
	}
	bbj.facet.banner.style.display='block';
	bbj.facet.div3.style.display='none';
}

function facetcell_click(event)
{
/* called by clicking on a number pair g/r in facet list or grid
and show the list of tracks in menu.facettklsttable
*/
var div=event.target;
if(div.tagName!='DIV') div=div.parentNode;
var term1=div.getAttribute('term1');
var term2=div.getAttribute('term2');
if(term1==null) return;
var bbj=gflag.tsp.bbj;
var tkset1 = {};
bbj.recursivegettrack(term1, tkset1);
if(term2) {
	// second term available, from double criteria
	// can both be big grid, or sub-table which is also a grid
	gflag.tsp.invoke={type:1,cell:event.target};
	var tkset2 = {};
	bbj.recursivegettrack(term2, tkset2);
	var intersection = {};
	for(var tk in tkset1) {
		if(tk in tkset2)
			intersection[tk] = 1;
	}
	tkset1 = intersection;
} else {
	//  only one term, from single criteria
	gflag.tsp.invoke={type:2,cell:event.target};
}
var tkselectionlst = [];
for(var tk in tkset1) 
	tkselectionlst.push(tk);
if(tkselectionlst.length == 0) 
	return;
var pos=absolutePosition(div);
bbj.showhmtkchoice(tkselectionlst, false, pos[0]+div.clientWidth-6-document.body.scrollLeft, pos[1]-10-document.body.scrollTop);
}

function invisible_shield(dom)
{
var pos=absolutePosition(dom);
if(pos[0]+pos[1]<=0) return;
// means div2 is visible
invisibleBlanket.style.display='block';
invisibleBlanket.style.left=pos[0];
invisibleBlanket.style.top=pos[1];
invisibleBlanket.style.width=dom.clientWidth;
invisibleBlanket.style.height=dom.clientHeight;
}


Browser.prototype.showhmtkchoice=function(tkselectionlst, allSelected, x, y)
{
/* to show a list of tracks in menu panel
tracks already in display as inactive entries
tracks not displayed are active entries
arg:
- list of tk name
- boolean, if true, all entries are selected by default
- optional x/y position to show menu (no scroll offset!)

TODO not sure if works on custom tracks??
*/

/* in case of open facet panel,
the facet panel need to be hidden so user won't trigger some action to hide the panel
*/

if(this.facet) invisible_shield(this.facet.div2);

menu.selecttk4add_count.innerHTML=0;
menu.selecttk4add_butt.style.backgroundColor='white';
// adjust list order, put tk first that are on show
var lst1=[], lst2=[];
for(var i=0; i<tkselectionlst.length; i++) {
	var t=tkselectionlst[i];
	if(this.findTrack(t)==null) lst2.push(t);
	else lst1.push(t);
}
tkselectionlst=lst1.concat(lst2);

menu_shutup();
menu.facettklstdiv.style.display='block';
if(x!=undefined)
	menu_show(10, x, y);
var table=menu.facettklsttable;
stripChild(table, 0);
if(tkselectionlst.length <= 8) {
	table.parentNode.style.height = "auto";
	table.parentNode.style.overflowY = "auto";
} else {
	table.parentNode.style.height = "200px";
	table.parentNode.style.overflowY = "scroll";
}
var showremovebutt=false;
for(var i=0; i<tkselectionlst.length; i++) {
	var tkn = tkselectionlst[i];
	var obj=this.genome.hmtk[tkn];
	// error
	if(obj==undefined) print2console(tkn, 2);

	var tr = table.insertRow(-1);
	var td = tr.insertCell(0);
	td.className='tkentrytype';
	td.innerHTML=FT2verbal[obj.ft];
	td=tr.insertCell(-1);
	td.tkname=tkn;
	if(this.findTrack(tkn)==null) {
		td.className='tkentry';
		td.style.backgroundColor = 'transparent';
		td.addEventListener('click', hmtkentry_click, false);
		if(allSelected)
			simulateEvent(td, 'click');
	} else {
		td.style.color='#FF9999';
		showremovebutt=true;
	}
	td.innerHTML=obj.label;
	td=tr.insertCell(-1);
	td.innerHTML='<span class=clb onclick="gflag.tsp.bbj.getTrackdetail(\''+tkn+'\')">&nbsp;&#9432;&nbsp;</span>';
}
table.style.display = "block";
menu.facetremovebutt.style.display=showremovebutt?'inline':'none';
}

function facet_tklst_toggleall(event)
{
/* called by clicking all/none buttons in facet/menu/tklst panel
arg: boolean to tell if check/uncheck all tracks
*/
var tofill=event.target.tofill;
var bbj=gflag.tsp.bbj;
var lst=menu.facettklsttable.firstChild.childNodes;
for(var i=0; i<lst.length; i++) {
	var td=lst[i].childNodes[1];
	if(td.className!='tkentry') continue;
	if(td.style.backgroundColor=='transparent') {
		// not checked
		if(tofill) simulateEvent(td, 'click');
	} else {
		// checked
		if(!tofill) simulateEvent(td, 'click');
	}
}
}


function facet_tklst_addSelected()
{
// called by clicking big green butt
if(parseInt(menu.selecttk4add_count.innerHTML)==0) return;
var bbj=gflag.tsp.bbj;
var lst=menu.facettklsttable.firstChild.childNodes;
var alst=[];
for(var i=0; i<lst.length; i++) {
	var td=lst[i].childNodes[1];
	if(td.className=='tkentry' && td.style.backgroundColor!='transparent')
		alst.push(td.tkname);
}
if(alst.length==0) return;
bbj.ajax_addtracks_names(alst);
}

function facet_tklst_removeall()
{
// called by clicking button in facet-menu-tklst panel
var bbj=gflag.tsp.bbj;
var lst=menu.facettklsttable.firstChild.childNodes;
var rlst=[];
for(var i=0; i<lst.length; i++) {
	var td=lst[i].childNodes[1];
	if(td.className=='tkentry') continue;
	rlst.push(td.tkname);
}
if(rlst.length==0) return;
bbj.removeTrack(rlst);
menu_hide();
}

function facet_term_selectall()
{
/* called by clicking 'select all' option in menu
to select all tracks annotated by the underlining term
TODO
*/
	var bbj=gflag.tsp.bbj;
	var s = {};
	bbj.recursivegettrack(gflag.menu.termname, s);
	var newlst = [];
	for(var n in s) {
		if(browser.findTrack(n) == null)
			newlst.push(n);
	}
	if(newlst.length==0) return;
	gflag.menu.context=10;
	bbj.showhmtkchoice(newlst, true);
}
function facet_term_removeall() {
// called by clicking 'remove all' option in menu
	var bbj=gflag.tsp.bbj;
	var s = {};
	bbj.recursivegettrack(gflag.menu.termname, s);
	var lst=[];
	for(var tk in s) {
		if(bbj.findTrack(tk)!=null)
			lst.push(tk);
	}
	if(lst.length==0) return;
	bbj.removeTrack(lst);
	menu_hide();
}

Browser.prototype.facetclickedcell_remake=function()
{
/* remake a facet cell after updating
tell which cell and context by gflag.tsp.invoke
*/
var div=gflag.tsp.invoke.cell;
while(div.tagName!='DIV') div=div.parentNode;
var s1={};
this.recursivegettrack(div.getAttribute('term1'),s1)
var intersection={};
if(gflag.tsp.invoke.type==1) {
	var s2={};
	this.recursivegettrack(div.getAttribute('term2'),s2)
	for(var tk in s1) {
		if(tk in s2) intersection[tk] = 1;
	}
} else {
	intersection=s1;
}
var num=this.tracksetTwonumbers(intersection);
div.innerHTML='<span class=g>'+num[0]+'</span>'+((num[1]==0)?'/0':'/<span class=r>'+num[1]+'</span>');
simulateEvent(div,'click');
}

/*** __facet__ ends ***/




/*** __scalebar__ ***/
function scalebarMout(event) {
// mouse out to hide beam, global_browser
	var bbj=gflag.browser;
	var ctx = bbj.scalebar.arrow.getContext('2d');
	ctx.strokeStyle = colorCentral.foreground;
	bbj.scalebararrowStroke();
	scalebarbeam.style.display = 'none';
}
function scalebarMover(event) {
// mouse over to show beam, global_browser
	var bbj=gflag.browser;
	var ctx = bbj.scalebar.arrow.getContext('2d');
	ctx.strokeStyle = '#f00';
	gflag.browser.scalebararrowStroke();
	scalebarbeam.style.display = 'block';
	scalebarbeam.style.width=bbj.scalebar.slider.width;
	var pos=absolutePosition(bbj.scalebar.slider);
	scalebarbeam.style.left=pos[0];
	scalebarbeam.style.top=pos[1]+bbj.scalebar.slider.height;
	scalebarbeam.style.height=bbj.tkpanelheight();
}
Browser.prototype.scalebararrowStroke=function()
{
var x = 6;
var ctx = this.scalebar.arrow.getContext('2d');
ctx.clearRect(0,0,20,16);
ctx.beginPath();
ctx.moveTo(x,2);
ctx.lineTo(x,15);
ctx.lineTo(1,12);
ctx.moveTo(x,15);
ctx.lineTo(x*2-1,12);
ctx.stroke();
}
function scalebarSliderMD(event) {
	if(event.button != 0) return;
	event.preventDefault();
	gflag.browser.scalebar.slider.xstart = event.clientX + document.body.scrollLeft;
	document.body.addEventListener('mousemove', scalebarSliderM, false);
	document.body.addEventListener('mouseup', scalebarSliderMU, false);
	scalebarbeam.style.display='block';
}
function scalebarSliderM(event) {
	var bbj=gflag.browser;
	var s=bbj.scalebar;
	var thisx = event.clientX + document.body.scrollLeft;
	var oldleft = parseInt(s.slider.style.left);
	var newleft = oldleft + thisx - s.slider.xstart;
	if(newleft > oldleft) {
		if(newleft > bbj.hmSpan-s.slider.width) {
			newleft = bbj.hmSpan-s.slider.width;
		}
	} else if(newleft < oldleft) {
		if(newleft < 0) {
			newleft = 0;
		}
	}
	s.slider.style.left = newleft;
	s.slider.xstart = thisx;
	s.says.style.left = newleft - s.says.clientWidth - 3;
	s.arrow.style.left = newleft + s.slider.width - 6;
	scalebarbeam.style.left = parseInt(scalebarbeam.style.left)+newleft-oldleft;
	scalebarbeam.style.display='block';
}
function scalebarSliderMU(event) {
	document.body.removeEventListener('mousemove', scalebarSliderM, false);
	document.body.removeEventListener('mouseup', scalebarSliderMU, false);
	scalebarbeam.style.display='none';
}
function scalebarArrowMD(event) {
	if(event.button != 0) return;
	event.preventDefault();
	gflag.browser.scalebar.arrow.xstart = event.clientX + document.body.scrollLeft;
	document.body.addEventListener('mousemove', scalebarArrowM, false);
	document.body.addEventListener('mouseup', scalebarArrowMU, false);
	scalebarbeam.style.display='block';
}
function scalebarArrowM(event) {
	var bbj=gflag.browser;
	var s=bbj.scalebar;
	var thisx = event.clientX + document.body.scrollLeft;
	var oldleft = parseInt(s.arrow.style.left);
	var newleft = oldleft + thisx - s.arrow.xstart;
	var oldleft2 = parseInt(s.slider.style.left);
	if(newleft > oldleft) {
		if(oldleft2 + s.slider.width + newleft-oldleft > bbj.hmSpan) {
			newleft = bbj.hmSpan;
		}
	} else if(newleft < oldleft) {
		if(s.slider.width < oldleft-newleft) {
			newleft = oldleft;
		}
	}
	s.arrow.style.left = newleft;
	s.arrow.xstart = thisx;
	s.slider.width += newleft - oldleft;
	bbj.drawScalebarSlider();
	bbj.scalebarSlider_fill();
	scalebarbeam.style.width = s.slider.width;
	scalebarbeam.style.display='block';
}
function scalebarArrowMU(event) {
	document.body.removeEventListener('mousemove', scalebarArrowM, false);
	document.body.removeEventListener('mouseup', scalebarArrowMU, false);
	scalebarbeam.style.display='none';
}
Browser.prototype.drawScalebarSlider=function()
{
var ctx = this.scalebar.slider.getContext('2d');
ctx.fillRect(0,3,1,this.scalebar.slider.height-5);
ctx.fillRect(0,8,this.scalebar.slider.width,1);
}
Browser.prototype.scalebarSlider_fill=function()
{
if(this.scalebar==null) return;
var bp=this.pixelwidth2bp(this.scalebar.slider.width);
this.scalebar.says.innerHTML = bp>10 ? parseInt(bp) : bp.toFixed(1);
this.scalebar.says.style.left = parseInt(this.scalebar.slider.style.left) - this.scalebar.says.clientWidth - 3;
}
/*** __scalebar__ ends ***/



/* __pan__  */

Browser.prototype.updateDspstat=function()
{
// updates information about heatmap view (dsp, tracks)
if(this.dspstatsays!=null) {
	var tmp1=regionlst_spseekright(this.regionLst, this.entire, 0, 0, -this.move.styleLeft);
	var tmp2=regionlst_spseekright(this.regionLst, this.entire, 0, 0, this.hmSpan-this.move.styleLeft);
	var r1 = this.regionLst[tmp1[0]];
	var r2 = this.regionLst[tmp2[0]];
	if(this.is_gsv()){
		this.dspstatsays.innerHTML = r1[6]==r2[6] ? 'within '+r1[6] : 'from '+r1[6]+' to '+r2[6];
	} else {
		var c1=r1[3]+parseInt(tmp1[1]*(this.entire.atbplevel?1:this.entire.summarySize));
		var c2=r2[3]+parseInt(tmp2[1]*(this.entire.atbplevel?1:this.entire.summarySize));
		this.dspstatsays.innerHTML='<span class=header_b style="padding:2px" onclick="menu_relocate_scfd(event)">'+
			((r1[0]==r2[0]) ? r1[0]+':'+c1+'-'+c2 : 'from '+r1[0]+', '+c1+' to '+r2[0]+', '+c2)+'</span>';
	}
}
if(this.resolutionsays!=null) {
	this.resolutionsays.innerHTML= this.entire.atbplevel ? 
		"One base pair spans "+this.entire.bpwidth+" pixels" :
		("One pixel spans "+
			(this.entire.summarySize>5 ?
				Math.floor(this.entire.summarySize) : this.entire.summarySize.toPrecision(2))+
		" base pairs");
	}
}

Browser.prototype.placeMovable=function(cleft)
{
/* when running gsv with a small number of items
entire.spnum will be smaller than hmspan
*/
if(cleft > 0)
	cleft = 0;
else if(cleft<0 && (cleft<this.hmSpan-this.entire.spnum))
	cleft = this.hmSpan - this.entire.spnum;
this.move.styleLeft=
this.decordiv.style.left=
this.hmdiv.style.left=
this.ideogram.canvas.parentNode.style.left=cleft;
if(this.rulercanvas!=null)
	this.rulercanvas.style.left = cleft;
}

function viewboxMD(event)
{
if(event.button != 0) return;
event.preventDefault();
var bbj=gflag.browser;
if(event.target.splinterTag!=undefined)
	bbj=gflag.browser.splinters[event.target.splinterTag];
if(bbj.entire.spnum <= bbj.hmSpan) {
	/* don't move if entire.spnum is smaller than hmspan
	this is the case of running gsv with small # of items
	but need to issue 'clicking' event
	*/
	track_click(event);
	return;
}
document.body.addEventListener("mousemove", viewboxM, false);
document.body.addEventListener("mouseup", viewboxMU, false);
gflag.movebbj=bbj;
bbj.move.oldpos = bbj.move.styleLeft;
bbj.move.oldx=
bbj.move.mousex = event.clientX;
}

function viewboxM(event)
{
var bbj=gflag.movebbj;
if(bbj.entire.atbplevel) {
	// escape move distance that is smaller than bpwidth
	var moved = event.clientX - bbj.move.mousex;
	if(Math.abs(moved) >= bbj.entire.bpwidth) {
		bbj.placeMovable(bbj.move.styleLeft + parseInt(moved/bbj.entire.bpwidth)*bbj.entire.bpwidth);
		bbj.move.mousex = event.clientX;
		bbj.updateDspstat();
	}
	return;
}
bbj.placeMovable(bbj.move.styleLeft + event.clientX - bbj.move.mousex);
bbj.move.mousex = event.clientX;
bbj.updateDspstat();
}

function viewboxMU()
{
/*
move left: scroll to right, newly exposed regions on left
move right: scroll to left, newly exposed regions on right
*/
var bbj=gflag.movebbj;
if(bbj.move.mousex==bbj.move.oldx) {
	document.body.removeEventListener("mousemove", viewboxM, false);
	document.body.removeEventListener("mouseup", viewboxMU, false);
	return;
}
bbj.move.direction = null;
if(bbj.atLeftBorder() && bbj.atRightBorder()) {
	// simplest case
	bbj.updateDspBoundary();
	bbj.drawTrack_browser_all();
	bbj.drawIdeogram_browser();
	bbj.drawNavigator();
} else if(bbj.move.styleLeft > bbj.move.oldpos) {
	/*** drag canvas to right ***/
	/* see if number of summary points beyond move.styleLeft is below hmSpan */
	if(-bbj.move.styleLeft <= bbj.hmSpan) {
		if(bbj.atLeftBorder()) {
			bbj.updateDspBoundary();
			bbj.drawTrack_browser_all();
			bbj.drawIdeogram_browser();
			bbj.drawNavigator();
		} else {
			// request data
			bbj.move.direction = 'l';
			var moveSize = bbj.move.styleLeft - bbj.move.oldpos;
			var moveDist;
			if(bbj.entire.atbplevel)
				moveDist = parseInt(moveSize/bbj.entire.bpwidth);
			else
				moveDist = parseInt(moveSize * bbj.entire.summarySize);
			bbj.cloak();
			bbj.ajaxX(bbj.displayedRegionParamMove()+'&summarySize='+moveSize+'&distance='+moveDist+'&move='+bbj.move.direction+(bbj.entire.atbplevel?'&atbplevel=on':'')+bbj.mayShowDsp());
		}
	} else {
		// at leisure, there's still spare space on left, no ajax
		bbj.updateDspBoundary();
		bbj.drawTrack_browser_all();
		bbj.drawIdeogram_browser();
		bbj.drawNavigator();
	}
} else if(bbj.move.styleLeft < bbj.move.oldpos) {
	/*** drag canvas to left ***/
	/* see if number of summary points beyond hmSpan-move.styleLeft is below hmSpan */
	if(bbj.entire.spnum-(bbj.hmSpan-bbj.move.styleLeft) <= bbj.hmSpan) {
		if(bbj.atRightBorder()) {
			bbj.updateDspBoundary();
			bbj.drawTrack_browser_all();
			bbj.drawIdeogram_browser();
			bbj.drawNavigator();
		} else {
			// request data
			bbj.move.direction = 'r';
			var moveSize = bbj.move.oldpos - bbj.move.styleLeft;
			var moveDist;
			if(bbj.entire.atbplevel)
				moveDist = parseInt(moveSize/bbj.entire.bpwidth);
			else
				moveDist = parseInt(moveSize*bbj.entire.summarySize);
			bbj.cloak();
			bbj.ajaxX(bbj.displayedRegionParamMove()+'&summarySize='+moveSize+'&distance='+moveDist+'&move='+bbj.move.direction+(bbj.entire.atbplevel?'&atbplevel=on':'')+bbj.mayShowDsp());
		}
	} else {
		// at leisure, no ajax
		bbj.updateDspBoundary();
		bbj.drawTrack_browser_all();
		bbj.drawIdeogram_browser();
		bbj.drawNavigator();
	}
}
document.body.removeEventListener("mousemove", viewboxM, false);
document.body.removeEventListener("mouseup", viewboxMU, false);
}

Browser.prototype.mayShowDsp=function()
{
/* at thin/full mode, must not do dsp filtering
*/
var show=false;
for(var i=0; i<this.tklst.length; i++) {
	var t=this.tklst[i];
	if((t.ft==FT_lr_c||t.ft==FT_lr_n) && (t.mode==M_trihm||t.mode==M_arc)) {
		show=true;break;
	}
}
if(!show) return '';
var lst=[];
for(i=this.dspBoundary.vstartr; i<=this.dspBoundary.vstopr; i++) {
	var r=this.regionLst[i];
	lst.push(r[0]);
	lst.push(r[3]);
	lst.push(r[4]);
}
return '&existingDsp='+lst.join(',');
}

Browser.prototype.arrowPan=function(direction, fold)
{
// pan over cached region by clicking arrow button
var sp2pan=parseInt(fold*this.hmSpan);
if(direction=='l') {
	sp2pan=Math.min(-this.move.styleLeft, sp2pan);
} else {
	sp2pan=Math.min(sp2pan, this.entire.spnum+this.move.styleLeft-this.hmSpan);
}
if(sp2pan<=0) return;
this.move.direction=direction;
// don't call simulate viewboxMD(event) as cursor x will disrupt
gflag.movebbj=this;
this.move.oldpos=this.move.styleLeft;
this.move.oldx= this.move.mousex =500;
gflag.arrowpan={bbj:this,span:sp2pan,dir:direction};
arrowPan_do();
// cloak entire page
pagecloak2.style.display='block';
pagecloak2.firstChild.style.display='none';
pagecloak2.style.left=pagecloak2.style.top=0;
pagecloak2.style.width=document.body.clientWidth;
pagecloak2.style.height=document.body.clientHeight;
}
function arrowPan_do()
{
var a=gflag.arrowpan;
if(a.span<=0) {
	viewboxMU();
	pagecloak2.style.display='none';
	return;
}
a.bbj.move.styleLeft+=a.dir=='l'?3:-3;
a.bbj.move.mousex=600;
a.bbj.placeMovable(a.bbj.move.styleLeft);
a.span-=3;
setTimeout(arrowPan_do, 1);
}

/* __pan__ ends */

/* __zoom__ */

function zoomin_MD(event)
{
if(event.button != 0) return; // only process left click
// mouse down
event.preventDefault();
document.body.addEventListener("mousemove", zoomin_M, false);
document.body.addEventListener("mouseup", zoomin_MU, false);
indicator2.style.display = "block";
indicator2.leftarrow.style.display = "block";
indicator2.rightarrow.style.display = "block";
var bbj=gflag.browser;
if(event.target.splinterTag!=undefined)
	bbj=bbj.splinters[event.target.splinterTag];
var pos=absolutePosition(bbj.hmdiv.parentNode);
indicator2.style.left = event.clientX+document.body.scrollLeft;
indicator2.style.top = pos[1];
var th = bbj.tkpanelheight();
indicator2.style.height = th;
indicator2.leftarrow.style.top = th/2-indicator2.leftarrow.height/2;
indicator2.rightarrow.style.top = indicator2.leftarrow.style.top;
indicator2.style.width=0;
gflag.zoomin={
	oldx:event.clientX,
	x:event.clientX+document.body.scrollLeft,
	holderx:pos[0],
	beyondfinest:false,
	bbj:bbj,
	};
}
function zoomin_M(event)
{
// mouse move, only process horizontal move
var z=gflag.zoomin;
var currx = event.clientX + document.body.scrollLeft;
var bpw=0;
if(currx > z.x) {
	if(currx < z.holderx+z.bbj.hmSpan) {
		var pxw=currx - z.x;
		indicator2.style.width=pxw;
		bpw=z.bbj.pixelwidth2bp(pxw);
		if(bpw<z.bbj.hmSpan/MAXbpwidth_bold){
			indicator2.veil.style.backgroundColor='red';
			z.beyondfinest=true;
		} else {
			indicator2.veil.style.backgroundColor='blue';
			z.beyondfinest=false;
		}
	}
} else {
	if(currx > z.holderx) {
		var pxw = z.x - currx;
		indicator2.style.width = pxw;
		indicator2.style.left = currx;
		bpw=z.bbj.pixelwidth2bp(pxw);
		if(bpw<z.bbj.hmSpan/MAXbpwidth_bold) {
			indicator2.veil.style.backgroundColor='red';
			z.beyondfinest=true;
		} else {
			indicator2.veil.style.backgroundColor='blue';
			z.beyondfinest=false;
		}
	}
}
indicator2.veil.firstChild.firstChild.firstChild.innerHTML='';
if(bpw!=0) {
	var str=parseInt(bpw)+' bp';
	if(parseInt(indicator2.style.width)>(str.length*15))
		indicator2.veil.firstChild.firstChild.firstChild.innerHTML=str;
}
}
function zoomin_MU(event)
{
indicator2.style.display = "none";
indicator2.leftarrow.style.display = "none";
indicator2.rightarrow.style.display = "none";
document.body.removeEventListener("mousemove", zoomin_M, false);
document.body.removeEventListener("mouseup", zoomin_MU, false);
var z=gflag.zoomin;
if(event.clientX==z.oldx) return;
if(z.beyondfinest) return;
var x1=parseInt(indicator2.style.left)-z.holderx;
var x2=x1+parseInt(indicator2.style.width);
indicator2.veil.firstChild.firstChild.firstChild.innerHTML='';
z.bbj.ajaxZoomin(x1, x2);
}

function start_animate_zoom()
{
var z=gflag.animate_zoom;
z.xzoom=1;
z.xleft=z.bbj.move.styleLeft;
// total # of frame in the little film
z.count=Math.min(Math.ceil(z.bbj.hmSpan/(z.x2-z.x1)),10)*10;
// change scale in each frame
if(z.zoomin) {
	z.foldchange=z.bbj.hmSpan/(z.x2-z.x1)-1;
} else {
	z.foldchange=(z.x2-z.x1)/z.bbj.hmSpan-1;
}
z.foldchange/=z.count;

// x offset adjustment
var c0=(z.x2+z.x1)/2-z.bbj.move.styleLeft;
var c1=z.bbj.entire.spnum/2;
z.x_shift=(c1-c0)*z.foldchange+((z.bbj.hmSpan-z.x1-z.x2)/2)/z.count;

invisible_shield(z.bbj.main);

// TODO .style.left
run_animate_zoom();
}

function run_animate_zoom()
{
var z=gflag.animate_zoom;
if(z.count<=0) {
	may_drawbrowser_afterzoom();
	return;
}
z.bbj.zoom_dom_movable(z.xzoom,z.xleft);
z.xzoom+=z.foldchange;
z.xleft+=z.x_shift;
z.count--;
setTimeout(run_animate_zoom,5);
}

Browser.prototype.zoom_dom_movable=function(v,x)
{
// for animated zoom
var r=this.rulercanvas;
if(r!=null) {
	r.style.webkitTransform=
	r.style.mozTransform=
	r.style.transform= 'scale('+v+',1)';
	r.style.left=x;
}
/* do not change ideogram, not fixed yet
var d1=this.ideogram.canvas.parentNode.parentNode;
d1.style.webkitTransform=
d1.style.mozTransform=
d1.style.transform=
*/
var d2=this.hmdiv;
var d3=this.decordiv;
d2.style.webkitTransform=
d2.style.mozTransform=
d2.style.transform=
d3.style.webkitTransform=
d3.style.mozTransform=
d3.style.transform= 'scale('+v+',1)';
d2.style.left=d3.style.left=x;
}

function may_drawbrowser_afterzoom()
{
var bbj=gflag.animate_zoom.bbj;
if(bbj.animate_zoom_stat==1) {
	// data from ajax not ready yet
	setTimeout(may_drawbrowser_afterzoom,10);
	return;
}
bbj.zoom_dom_movable(1,bbj.move.styleLeft);
bbj.drawRuler_browser(false);
bbj.drawTrack_browser_all();
bbj.drawIdeogram_browser(false);
//bbj.unveil();
}


Browser.prototype.cgiZoomin=function(howmuch)
{
/* push button zoomin
	hmSpan divided by howmuch to get region to zoom into
*/
var sp = parseInt((this.hmSpan - this.hmSpan/howmuch)/2);
if(sp >= this.hmSpan/2)
	return;
this.ajaxZoomin(sp, this.hmSpan-sp);
}

Browser.prototype.ajaxZoomin=function(x1, x2)
{
/* for dragging on ideogram and clicking zoomin button
x1/x2 are start,stop of selected horizontal position on ideogram, offset to hmdiv left position
but not only chr1:start-stop
 */
if(x1 >= x2) return;

// safeguard not to zoom beyond finest level
if(this.pixelwidth2bp(x2-x1)<this.hmSpan/MAXbpwidth_bold) {
	print2console('At finest level, cannot zoom in',2);
	return;
}

// seek dsp boundary by user selection
var tmp = regionlst_spseekright(this.regionLst, this.entire, this.dspBoundary.vstartr, this.dspBoundary.vstarts, x1);
this.dspBoundary.vstartr = tmp[0];
this.dspBoundary.vstarts = tmp[1];
tmp = regionlst_spseekleft(this.regionLst, this.entire, this.dspBoundary.vstopr, this.dspBoundary.vstops, this.hmSpan-x2);
this.dspBoundary.vstopr = tmp[0];
this.dspBoundary.vstops = tmp[1];

this.animate_zoom_stat=1;
gflag.animate_zoom={bbj:this,
x1:x1,
x2:x2,
zoomin:true,
};
start_animate_zoom();

this.ajaxX(this.displayedRegionParam()+'&imgAreaSelect=on');
}


Browser.prototype.cgiZoomout=function(howmuch,enforce)
{
/* called by "zoom out" button, so if already meets borders, disable zoom out button
argument: 0.5 for zoom out by 1.5 fold
*/
/* this is not in use as the flanking can hit border..
if(this.atLeftBorder() && this.atRightBorder()) {
	print2console('Cannot zoom out: showing entire range',2);
	return;
}
*/
// a step of alert as required by our dear reviewer
if(!enforce) {
	var tcount=0;
	for(var i=0; i<this.tklst.length; i++) {
		var tk=this.tklst[i];
		if(!isNumerical(tk) && tk.ft!=FT_cat_n && tk.ft!=FT_cat_c) {
			for(var j=0; j<tk.data.length; j++)
				tcount+=tk.data[j].length;
		}
	}
	if(tcount*(howmuch+1)>10000) {
		gflag.zoomout.fold=howmuch;
		menu_shutup();
		menu.zoomoutwarning.style.display='block';
		document.getElementById('zoomout_warning_fold').innerHTML=howmuch+1;
		document.getElementById('zoomout_warning_itemcount').innerHTML=tcount;
		if(this.splinterTag==null) {
			// trunk, menu cover buttons in ftb
			menu_show(0,parseInt(floatingtoolbox.style.left)-10,parseInt(floatingtoolbox.style.top)-10);
		} else {
			// splinter
			var pos=absolutePosition(this.hmdiv.parentNode);
			menu_show(0,pos[0]-document.body.scrollLeft,pos[1]-document.body.scrollTop);
			// as menu_show will attach trunk to gflag.menu.bbj, need to override it
			gflag.menu.bbj=this;
		}
		return;
	}
}
print2console("zooming out...", 0);
//this.cloak();
howmuch=parseFloat(howmuch);
this.animate_zoom_stat=1;
var w=this.hmSpan/(1+howmuch);
gflag.animate_zoom={bbj:this,
x1:(this.hmSpan-w)/2,
x2:(this.hmSpan+w)/2,
zoomin:false,
};
start_animate_zoom();
this.ajaxX(this.displayedRegionParam()+"&zoom="+(howmuch/2));
}

function risky_zoomout()
{
// despite warning, user still takes risky move
gflag.menu.bbj.cgiZoomout(gflag.zoomout.fold,true);
menu_hide();
}


/*** __zoom__ ends ***/








/*** __tks__ track select panel ***/

Browser.prototype.decor_invoketksp=function()
{
/* called by clicking grandadd > add decor option, to add decor into main panel
the menu must have already been shown
*/
this.genome.tkspanel_gfbleach();
// highlight decors already in collection
for(var i=0; i<this.tklst.length; i++) {
	var tk=this.tklst[i];
	if(tk.name in this.genome.decorInfo)
		this.genome.tkspanel_gftoggle(tk.name);
}
menu_shutup();
menu.decorcatalog.style.display='block';
gflag.menu.context=12;
var d=document.getElementById('decorcatalog_grpholder');
var d2=document.getElementById('decorcatalog_tkholder');
stripChild(d,0);
stripChild(d2,1);
for(i=0; i<this.genome.decorGrouping.length; i++) {
	d.appendChild(this.genome.decorcatalog[i][0]);
	d2.appendChild(this.genome.decorcatalog[i][1]);
}
simulateEvent(d.firstChild, 'click');
}

Genome.prototype.tkspanel_gfbleach=function()
{
// highlight off all gf track entries in tkspanel
for(var n in this.decorInfo) {
	if('tksentry' in this.decorInfo[n])
		this.decorInfo[n].tksentry.style.backgroundColor = 'transparent';
}
}
Genome.prototype.tkspanel_gftoggle=function(tkname)
{
/* toggle highlight for a decor track, use hook to the td element
but for exp assay tracks they don't have .tksentry attribute
*/
var entrytd = this.decorInfo[tkname].tksentry;
if(entrytd == null) return;
if(entrytd.style.backgroundColor == 'transparent')
	entrytd.style.backgroundColor = colorCentral.tkentryfill;
else
	entrytd.style.backgroundColor = 'transparent';
}

function decorgrp_click(event)
{
/* clicking decor group tab in tkspanel
event.target is <div> that tab, will switch decor child panels
try to evade use of global_browser
*/
// turn off all grp tabs
var lst=event.target.parentNode.childNodes;
for(var i=0; i<lst.length; i++)
	lst[i].className='degrpt';
// turn off all children panels
lst=event.target.parentNode.parentNode.nextSibling.childNodes;
for(i=1; i<lst.length; i++)
	lst[i].style.display='none';
// turn on the one clicked
event.target.className='degrpt2';
var grp = event.target.getAttribute('grpname');
for(i=1; i<lst.length; i++) {
	if(lst[i].getAttribute('grpname')==grp) {
		lst[i].style.display='block';
		return;
	}
}
}

function decortkentry_click(event)
{
/* clicking on a decor track entry in decor catalog
it is only called by grandadd
FIXME this should be unified with hmtkentry_click into a tkentry_click
*/
var add = false;
if(event.target.style.backgroundColor == 'transparent') {
	event.target.style.backgroundColor = colorCentral.tkentryfill;
	add = true;
} else {
	event.target.style.backgroundColor = 'transparent';
}
var bbj=gflag.menu.bbj;
var tkname = event.target.tkname;
var robj=bbj.genome.decorInfo[tkname];
if(add) {
	var tmpobj={name:tkname,ft:robj.ft,mode:tkdefaultMode(robj, bbj.genome.mdvattr2idx),qtc:{}};
	if(robj.ft==FT_lr_c||robj.ft==FT_lr_n) {
		tmpobj.qtc.pfilterscore=bbj.genome.trackDefaultparam[tkname].pfilterscore;
		tmpobj.qtc.nfilterscore=bbj.genome.trackDefaultparam[tkname].nfilterscore;
	}
	bbj.ajax_addtracks([tmpobj]);
} else {
	bbj.removeTrack([tkname]);
}
}
function hmtkgrp_clear(event) {
    /* clear a heatmap track group holder
       called by pushing button associated with a group holder
       event.target should be a button
       works for htest and pwc, and to be expanded
       attribute 'holderid' gives id of holder
     */
    stripChild(document.getElementById(event.target.getAttribute('holderid')),0);
}
function tkspanel_hmtoggle(tkname) {
    // toggle highlight for a hmtk todo use hook
    var lst = tkselect.hmholder.firstChild.childNodes;
    for(var i=0; i<lst.length; i++) {
        if(lst[i].getAttribute('tkname') == tkname) {
            if(lst[i].firstChild.style.backgroundColor=='transparent') {
	        lst[i].firstChild.style.backgroundColor = '#CCCCFF';
	    } else {
	        lst[i].firstChild.style.backgroundColor = 'transparent';
	    }
	    return;
	}
    }
}
function hmtkgrp_invoketksp(event) {
/* called by pushing button, only works for htest and pwc
invoke tkselectpanel for pwc/htest track group assignment
check the button attributes to tell which grp holder to place the track
TODO
*/
	var bbj=gflag.browser;
	if(bbj.tklst.length == 0) {
		print2console('no track in display', 2);
		return;
	}
	var type = event.target.getAttribute('ttype');
	var which;
	if(type == 'pwc') {
		which=14;
	} else if(type == 'htest') {
		which=15;
	} else {
		fatalError('hmtkgrp_invoketksp: unknown ttype '+type);
	}
	menu_shutup();
	menu_show(which, event.clientX, event.clientY);
	gflag.menu.bbj=bbj;
	//gflag.menu.togrp:parseInt(event.target.getAttribute('grp')),
	gflag.menu.toholder=document.getElementById(event.target.getAttribute('holderid'));
	bbj.showcurrenttrack4select();
}

Browser.prototype.showcurrenttrack4select=function()
{
/* to invoke the menu.ctkselectpanel
display all tracks that are on display in main browser panel
so they can be chosen for other purposes
menu_show must already been called
*/
menu.ctkselectpanel.style.display='block';
var table=menu.ctkselectpanel.firstChild.firstChild;
stripChild(table.firstChild,0);
// repetitive with showhmtkchoice()
if(this.tklst.length <= 8) {
	table.parentNode.style.height = "auto";
	table.parentNode.style.overflowY = "auto";
} else {
	table.parentNode.style.height = "200px";
	table.parentNode.style.overflowY = "scroll";
}
for(var i=0; i<this.tklst.length; i++) {
	var o=this.tklst[i];
	var tr = table.insertRow(-1);
	var td = tr.insertCell(0);
	td.className='tkentrytype';
	td.innerHTML=FT2verbal[o.ft];
	td=tr.insertCell(-1);
	td.tkname=o.name;
	td.className='tkentry';
	td.style.backgroundColor = 'transparent';
	td.addEventListener('click', hmtkentry_click, false);
	td.innerHTML=o.label;
	//td=tr.insertCell(-1);
	//td.innerHTML='<span class=clb onclick="gflag.tsp.bbj.getTrackdetail(\''+tkn+'\')">&nbsp;&#9432;&nbsp;</span>';
}
placePanel(menu, parseInt(menu.style.left), parseInt(menu.style.top));
}

/*** __tks__ ends ***/



/*** __menu__ context menu ***/
function menu_mover() {document.body.removeEventListener("mousedown",menu_hide,false);}
function menu_mout() {document.body.addEventListener("mousedown",menu_hide,false);}

function menu_addoption(type)
{
/* make a new menu option, types:
1 - menuactivechoice with optional icon, label, callback
2 - plain div with 8px padding
3 - plain div
4 - plain table

last arg must always be dom holder
*/
if(type==2) {
	var d=document.createElement('div');
	arguments[1].appendChild(d);
	d.style.padding=8;
	return d;
}
if(type==3) {
	var d=document.createElement('div');
	arguments[1].appendChild(d);
	return d;
}
if(type==4) {
	var t=document.createElement('table');
	t.style.margin=8;
	arguments[1].appendChild(t);
	return t;
}
// type 1
var d=document.createElement('div');
d.className='menuactivechoice';
var icon=arguments[1];
if(icon) {
	var d2=document.createElement('div');
	d2.className='iconholder';
	d2.innerHTML=icon;
	d.appendChild(d2);
}
var label=arguments[2];
if(label) {
	var s=document.createElement('span');
	s.innerHTML=label;
	s.style.whiteSpace='nowrap';
	s.style.marginLeft=10;
	d.appendChild(s);
}
var callfunc=arguments[3];
if(callfunc)
	d.addEventListener('click', callfunc, false);
arguments[4].appendChild(d);
return d;
}

function menu_shutup() {
	for(var i=0; i<menu.childNodes.length; i++) {
		var n=menu.childNodes[i];
		if(n.nodeType==1)
			n.style.display='none';
	}
}
function menu_show(ctxt,x,y) {
/* x/y are optional,
must not contain body.scroll offset
set to -1 for not changing position
*/
	pica.style.display='none';
	menu.style.display='block';
	if(x==undefined) {
		x=parseInt(menu.style.left)-10;
		y=parseInt(menu.style.top)-10;
	}
	setTimeout('placePanel(menu,'+x+'+10+document.body.scrollLeft,'+y+'+10+document.body.scrollTop)',1);
	document.body.addEventListener('mousedown', menu_hide,false);
	gflag.menu.bbj=gflag.browser; // in case of splinter, must be replaced after calling menu_show()
	gflag.menu.context=ctxt;
}
function menu_hide()
{
indicator3.style.display=
indicator7.style.display=
invisibleBlanket.style.display=
menu.style.display='none';
document.body.removeEventListener('mousedown', menu_hide,false);
gflag.tsp.invoke.type=-1; // to turn off single-cell response
}
function menu_mcm_header(event) {
// over a mcm header term
	menu_shutup();
	menu_show(8, event.clientX, event.clientY);
	menu.c4.style.display=menu.c25.style.display='block';
	if(menu.c23)
		menu.c23.style.display='block';
	gflag.menu.bbj=gflag.browser;
	gflag.menu.idx=parseInt((event.clientX-absolutePosition(gflag.browser.mcm.holder)[0])/tkAttrColumnWidth);
	return false;
}



function menuConfig()
{
var m=gflag.menu;
var bbj=m.bbj;
if(m.context==1) {
	// single track from main browser panel
	var tk=m.tklst[0];
	if(isHmtk(tk.ft) || tk.ft==FT_qdecor_n) {
		switch(tk.ft) {
			case FT_bedgraph_c:
			case FT_bedgraph_n:
			case FT_bigwighmtk_c:
			case FT_bigwighmtk_n:
			case FT_qdecor_n:
				qtcpanel_setdisplay({qtc:tk.qtc,
				pcolor:true,
				ncolor:true,
				scale:true,
				log:true,
				tkh:true,
				alltk:true,
				which:1,pcname:'positive value',ncname:'negative value'});
				break;
			case FT_cat_n:
			case FT_cat_c:
				cateCfg_show(tk);
				break;
			default: fatalError("menuConfig: unknown hmtk ft");
		}
	} else if(tk.ft==FT_htest) {
		// TODO
		qtcpanel_setdisplay({qtc:htest.qtc,
		ncolor:true,
		pvcut:true,
		tkh:true,
		which:1,ncname:'P-value bar color'});
	} else if(tk.ft==FT_pwc) {
		qtcpanel_setdisplay({qtc:pwc.qtc,
		pcolor:true,
		ncolor:true,
		scale:true,
		tkh:true,
		which:6,
		pcname:'grp1 &gt; grp2',ncname:'grp1 &lt; grp2'});
	} else if(tk.mode==M_den) {
		qtcpanel_setdisplay({qtc:tk.qtc,
		pcolor:true,
		scale:true,
		tkh:true,
		which:1,
		pcname:(tk.ft==FT_sam_c||tk.ft==FT_sam_n)?'read density':'item density'});
	} else {
		// remaining possibilities can only be bed/sam/longrange in non-density modes
		menu_shutup();
		menu.tkcfg_bed.style.display='block';
		document.getElementById('stc_bed').style.display=
		document.getElementById('stc_sam').style.display=
		document.getElementById('stc_font').style.display=
		document.getElementById('stc_longrange').style.display='none';
		if(tk.ft==FT_sam_n||tk.ft==FT_sam_c) {
			// sam don't have font configure
			document.getElementById('stc_sam').style.display='block';
			document.getElementById('stc_forwardcolor').style.backgroundColor = tk.qtc.forwardcolor;
			document.getElementById('stc_reversecolor').style.backgroundColor = tk.qtc.reversecolor;
			document.getElementById('stc_mismatchcolor').style.backgroundColor = tk.qtc.mismatchcolor;
		} else {
			// bed or longrange
			if(tk.mode==M_full) {
				// only in full mode will the text be shown
				document.getElementById('stc_font').style.display='block';
				changeSelectByValue('stc_fontfamily', tk.qtc.fontfamily);
				document.getElementById('stc_fontbold').checked = tk.qtc.fontbold;
				changeSelectByValue('stc_fontsize', tk.qtc.fontsize);
				document.getElementById('stc_textcolor').style.backgroundColor = tk.qtc.textcolor;
			} else {
				document.getElementById('stc_font').style.display='none';
			}
			if(tk.ft==FT_bed_c || tk.ft==FT_bed_n) {
				document.getElementById('stc_bed').style.display = 'block';
				document.getElementById('stc_bedcolor').style.backgroundColor = tk.qtc.bedcolor;
			} else if(tk.ft==FT_lr_n || tk.ft==FT_lr_c) {
				document.getElementById('stc_longrange').style.display = 'block';
				longrange_showplotcolor(tk.qtc.pcolor,tk.qtc.ncolor);
				document.getElementById('stc_longrange_autoscale_div').style.display='block';
				document.getElementById('stc_longrange_autoscale').checked=tk.qtc.thtype==0;
				document.getElementById('stc_longrange_pcolorscore_div').style.display=
				document.getElementById('stc_longrange_ncolorscore_div').style.display=tk.qtc.thtype==0?'none':'block';
				document.getElementById('stc_longrange_pcolorscore').value = tk.qtc.pcolorscore;
				document.getElementById('stc_longrange_ncolorscore').value = tk.qtc.ncolorscore;
				document.getElementById('stc_longrange_pfilterscore').value = tk.qtc.pfilterscore;
				document.getElementById('stc_longrange_nfilterscore').value = tk.qtc.nfilterscore;
				document.getElementById('longrange_pfilterscore_div').style.display=
				document.getElementById('longrange_nfilterscore_div').style.display='block';
				menu.c14.style.display=tk.mode==M_trihm?'block':'none';
				document.getElementById('menu_tkh_unifybutt').style.display='none';
			}
		}
	}
} else if(m.context==2) {
	// right click on mcm block for tracks in ghm, confusing as any tracks can be here
	if(m.tklst.length==1) {
		m.context=1;
		menuConfig();
	} else {
		var hasqual=false;
		var hascat=false;
		var hasstack=false;
		for(var i=0; i<m.tklst.length; i++) {
			var ft=m.tklst[i].ft;
			if(ft==FT_bedgraph_n||ft==FT_bedgraph_c||ft==FT_bigwighmtk_n||ft==FT_bigwighmtk_c)
				hasqual=true;
			else if(ft==FT_cat_n||ft==FT_cat_c)
				hascat=true;
			else
				hasstack=true;
		}
		if(!hasstack && !hasqual && hascat) {
			menu_shutup();
			menu.c14.style.display='block';
			document.getElementById('menu_tkh_unifybutt').style.display='inline';
		} else if(hasqual) {
			qtcpanel_setdisplay({
			pcolor:true,
			ncolor:true,
			scale:true,
			log:true,
			tkh:true,
			alltk:true,
			which:1,
			pcname:'positive value', ncname:'negative value'});
		} else {
			menu_hide();
		}
	}
} else {
	fatalError("menuConfig: unknown menu context id");
}
placePanel(menu, parseInt(menu.style.left), parseInt(menu.style.top));
/*over*/
}

function menuGetonetrackdetails() {
	menu_shutup();
	gflag.menu.bbj.getTrackdetail(gflag.menu.tklst[0].name);
}


function menuMcmflip() {
	var m=gflag.menu.bbj.mcm;
	m.holder.attop=!m.holder.attop;
	gflag.menu.bbj.mcmPlaceheader();
	menu_hide();
}

function menuRemove()
{
// remove/hide/turnoff things depend on context
menu_hide();
var bbj=gflag.menu.bbj;
switch(gflag.menu.context) {
case 1:
case 2:
	var lst=[];
	for(var i=0; i<gflag.menu.tklst.length; i++)
		lst.push(gflag.menu.tklst[i].name);
	bbj.removeTrack(lst);
	return;
case 8:
	if(gflag.menu.idx >= bbj.mcm.lst.length) return;
	bbj.mcm.lst.splice(gflag.menu.idx,1);
	bbj.initiateMdcOnshowCanvas();
	bbj.prepareMcm();
	bbj.drawMcm();
	bbj.__mcm_termchange();
	return;
case 19:
	// single wreath tk
	hengeview.hash[gflag.menu.viewkey].wreath.splice(gflag.menu.wreathIdx,1);
	hengeview_draw(gflag.menu.viewkey);
	return;
case 20:
	// single bev tk
	var cc=gflag.menu.bbj.genome.bev.tklst[gflag.menu.bevtkidx].chrcanvas;
	for(var chr in cc)
		cc[chr].parentNode.removeChild(cc[chr]);
	gflag.menu.bbj.genome.bev.tklst.splice(gflag.menu.bevtkidx,1);
	return;
default:
	fatalError("menuRemove: unknown menu context id");
}
}

function menu_overallconfig() {
	menu_shutup();
	document.getElementById('overallconfig').style.display='block';
}
function page_brightdim(gobright) {
var bb=document.getElementById('bbbb');
var v=parseFloat(bb.style.opacity);
if(gobright)
	v*=1.15;
else
	v*=0.85;
if(v>1) v=1;
bb.style.opacity=
apps.gsv.firstChild.firstChild.style.opacity=
apps.bev.firstChild.firstChild.style.opacity=
apps.hengeview.firstChild.firstChild.style.opacity=
apps.svg.firstChild.firstChild.style.opacity=
apps.gplot.firstChild.firstChild.style.opacity=
apps.custtk.firstChild.firstChild.style.opacity=
apps.hmtk.firstChild.firstChild.style.opacity=
apps.session.firstChild.firstChild.style.opacity=v;
document.getElementById('page_brightness').innerHTML=parseInt(v*100)+'%';
//document.body.style.backgroundColor=darkencolor(colorstr2int(colorCentral.pagebg),1-v);
}


function menu_track_browser(event)
{
/* over a track in main browser panel
or a splinter
TODO pwc htest
*/
menu_shutup();
menu.c10.style.display=
menu.c11.style.display=
menu.c6.style.display=
menu.c7.style.display=
menu.c8.style.display='none';

menu_show(1, event.clientX, event.clientY);
var bbj=gflag.browser;
if(event.target.splinterTag!=undefined) {
	// this is splinter
	bbj=gflag.browser.splinters[event.target.splinterTag];
	// must replace gflag.menu.bbj with splinter
	gflag.menu.bbj=bbj;
}
var tk=bbj.findTrack(event.target.tkname);
if(tk==null) return;
gflag.menu.tklst=[tk];
bbj.highlighttrack([tk]);
menu.c5.style.display=
menu.c4.style.display=
menu.c16.style.display='block';
if(menu.c20) menu.c20.style.display= 'block';
// edit md
if(isCustom(tk.ft))
	menu.c19.style.display='block';
switch(tk.ft) {
case FT_htest:
	alert('dumb');
	break;
case FT_pwc:
	alert('dumb');
	break;
case FT_bed_c:
case FT_bed_n:
	if(menu.c3) menu.c3.style.display='none';
	menu.decorwrapper.style.display='block';
	menu.c6.style.display=menu.c7.style.display=menu.c8.style.display='inline-block';
	menu.c6.disabled=tk.mode==M_thin;
	menu.c7.disabled=tk.mode==M_full;
	menu.c8.disabled=tk.mode==M_den;
	if(bbj.juxtaposition.type==RM_genome) {
		menu.c12.style.display='block';
		menu.c2.style.display='none';
	} else {
		menu.c2.style.display='block';
		menu.c12.style.display='none';
	}
	break;
case FT_sam_c:
case FT_sam_n:
	if(menu.c3) menu.c3.style.display='none';
	menu.c12.style.display='none';
	if(menu.c20) menu.c20.style.display='none';
	menu.decorwrapper.style.display='block';
	menu.c6.style.display=menu.c7.style.display=menu.c8.style.display='inline-block';
	menu.c6.disabled=tk.mode==M_thin;
	menu.c7.disabled=tk.mode==M_full;
	menu.c8.disabled=tk.mode==M_den;
	if(bbj.juxtaposition.type==RM_genome) {
		menu.c2.style.display='none';
	} else {
		menu.c2.style.display='block';
	}
	break;
case FT_lr_n:
case FT_lr_c:
	menu.decorwrapper.style.display='block';
	if(menu.c3) menu.c3.style.display=tk.mode==M_den?'none':'block';
	menu.c12.style.display='none';
	if(menu.c20) menu.c20.style.display='none';
	menu.c6.style.display=menu.c7.style.display=menu.c8.style.display=menu.c10.style.display=menu.c11.style.display='inline-block';
	menu.c6.disabled=tk.mode==M_thin;
	menu.c7.disabled=tk.mode==M_full;
	menu.c8.disabled=tk.mode==M_den;
	menu.c10.disabled=tk.mode==M_trihm;
	menu.c11.disabled=tk.mode==M_arc;
	if(bbj.juxtaposition.type==RM_genome) {
		menu.c2.style.display='none';
	} else {
		menu.c2.style.display='block';
	}
	break;
}

// any associated regions?
var tk=bbj.genome.hmtk[event.target.tkname];
if(tk!=undefined && tk.regions!=undefined) {
	var opt=menu.tk2region_showlst;
	opt.style.display='block';
	opt.childNodes[1].innerHTML=tk.regions[0];
}
return false;
}


/*** __menu__ ends ***/




/*** __note__ ***/

function menu_coordnote(event)
{
// right click on main panel ideogram canvas, show option related to coordnote
menu_shutup();
menu.stickynote.style.display='block';
if(event.target.tagName=='IMG') {
	// clicked on note
	menu.stickynote.firstChild.style.display=
	menu.stickynote.childNodes[1].style.display='none';
	menu.stickynote.childNodes[2].style.display='block';
	menu_show(0,event.clientX,event.clientY);
	var pos=absolutePosition(event.target);
	placeIndicator3(pos[0],pos[1],event.target.clientWidth,event.target.clientHeight);
	gflag.note={
		bbj:gflag.browser,
		chrom:event.target.chrom,
		coord:event.target.coord,
		update:true,
		};
} else {
	menu.stickynote.firstChild.style.display='block';
	menu.stickynote.childNodes[1].style.display=
	menu.stickynote.childNodes[2].style.display= 'none';
	menu_show(0,event.clientX,event.clientY);
	var pos=absolutePosition(event.target);
	var x=event.clientX+document.body.scrollLeft;
	placeIndicator3(x,pos[1],1,event.target.height);
	var bbj=gflag.browser;
	if(event.target.splinterTag!=undefined)
		bbj=bbj.splinters[event.target.splinterTag];
	pos=absolutePosition(bbj.hmdiv.parentNode);
	var r=regionlst_spseekright(bbj.regionLst, bbj.entire, bbj.dspBoundary.vstartr, bbj.dspBoundary.vstarts, x-pos[0]);
	var rr=getPointCoord(bbj.regionLst, bbj.entire, r[0], r[1]*(bbj.entire.atbplevel?bbj.entire.bpwidth:1));
	gflag.note={
		bbj:(event.target.splinterTag==undefined)?bbj:bbj.trunk,
		chrom:bbj.regionLst[r[0]][0],
		coord:rr,
		update:false,
		};
}
return false;
}

function coordnote_showinputpanel(doedit)
{
// show input panel
// for new entry or updating
menu.stickynote.firstChild.style.display=
menu.stickynote.childNodes[2].style.display='none';
menu.stickynote.childNodes[1].style.display='block';
document.getElementById('coordnote_says').innerHTML=gflag.note.chrom+', '+gflag.note.coord;
var text='';
if(doedit) {
	var lst=gflag.note.bbj.notes;
	for(var i=0; i<lst.length; i++) {
		if(lst[i].chrom==gflag.note.chrom && lst[i].coord==gflag.note.coord) {
			text=lst[i].text;
			break;
		}
	}
}
document.getElementById('coordnote_textarea').value=text;
}

function coordnote_submit()
{
var text=document.getElementById('coordnote_textarea').value;
if(text.length==0) {
	print2console('Cannot make note: no text written',2);
	return;
}
var bbj=gflag.note.bbj;
if(gflag.note.update) {
	var lst=bbj.notes;
	for(var i=0; i<lst.length; i++) {
		if(lst[i].chrom==gflag.note.chrom && lst[i].coord==gflag.note.coord) {
			lst[i].text=text;
			break;
		}
	}
} else {
	bbj.notes.push({
		chrom:gflag.note.chrom,
		coord:gflag.note.coord,
		text:text,
	});
}
bbj.drawIdeogram_browser(false);
for(var s in bbj.splinters)
	bbj.splinters[s].drawIdeogram_browser(false);
menu_hide();
}

Browser.prototype.draw_coordnote=function()
{
/* draw/make coordnote after ideogram is drawn
called by drawIdeogram_browser()
*/
var holder=this.ideogram.canvas.parentNode;
stripChild(holder,1);
// first of all, remove all notes there
if(this.notes.length==0) return;

// insert notes
var xoffset=0;
for(var i=0; i<this.regionLst.length; i++) {
	var r=this.regionLst[i];
	for(var j=0; j<this.notes.length; j++) {
		var n=this.notes[j];
		if(n.chrom!=r[0] || r[3]>n.coord || r[4]<n.coord) continue;
		// insert this note
		var img=document.createElement('img');
		img.src='images/stickyNote.png';
		img.className='coordnote';
		img.oncontextmenu=menu_coordnote;
		img.addEventListener('mouseover',coordnote_mover,false);
		img.addEventListener('mouseout',pica_hide,false);
		img.chrom=n.chrom;
		img.coord=n.coord;
		holder.appendChild(img);
		img.style.left=xoffset+
			(this.entire.atbplevel?((n.coord-r[3])*this.entire.bpwidth):((n.coord-r[3])/r[7]));
	}
	xoffset+=r[5]+regionSpacing.width;
}
}

function coordnote_mover(event) {
// pica shows note text
var lst=gflag.browser.notes;
var pos=absolutePosition(event.target);
for(var i=0; i<lst.length; i++) {
	var n=lst[i];
	if(n.chrom==event.target.chrom && n.coord==event.target.coord) {
		picasays.innerHTML='At '+n.chrom+', '+n.coord+':<pre>'+n.text+'</pre>';
		pica_go(pos[0]+20,pos[1]+20);
		return;
	}
}
}

function coordnote_delete() {
	var bbj=gflag.note.bbj;
	var lst=bbj.notes;
	for(var i=0; i<lst.length; i++) {
		if(lst[i].chrom==gflag.note.chrom && lst[i].coord==gflag.note.coord) {
			//bbj.ideogram.canvas.parentNode.removeChild(lst[i].img);
			lst.splice(i,1);
			break;
		}
	}
	bbj.drawIdeogram_browser(false);
	for(var s in bbj.splinters)
		bbj.splinters[s].drawIdeogram_browser(false);
	menu_hide();
}

/*** __note__ ends ***/




/*** __lr__ longrange specific ***/

function longrange_showplotcolor(pcolor,ncolor) {
// plot the two color stripe in the menu config panel
	if(pcolor!=null) {
		var c= document.getElementById('stc_longrange_pcolor');
		c.style.backgroundColor=pcolor;
		var ctx=c.getContext('2d');
    	var lingrad = ctx.createLinearGradient(0,0,c.width,0);
		lingrad.addColorStop(0,'white');
		lingrad.addColorStop(1, pcolor);
    	ctx.fillStyle = lingrad;
    	ctx.fillRect(0,0,c.width,c.height);
	}
	if(ncolor!=null) {
		var c= document.getElementById('stc_longrange_ncolor');
		c.style.backgroundColor=ncolor;
		var ctx=c.getContext('2d');
    	var lingrad = ctx.createLinearGradient(0,0,c.width,0);
		lingrad.addColorStop(0,'white');
		lingrad.addColorStop(1, ncolor);
    	ctx.fillStyle = lingrad;
    	ctx.fillRect(0,0,c.width,c.height);
	}
}

function menu_showtk2region() {
/* called through menu option
???
*/
var tk=gflag.menu.bbj.genome.hmtk[gflag.menu.tklst[0].name];
if(tk==undefined || tk.regions==undefined) {
	menu_hide();return;
}
var lst=tk.regions[1];
var lst2=[];
for(var i=0; i<lst.length; i++) {
	lst2.push('<a class=a2 href="javascript:void(0)" onclick="document.getElementById(\'jumppos\').value=\''+lst[i]+'\';gflag.jump.type=1;menuJump();menu_hide();">'+lst[i]+'</a>');
}
menu_shutup();
var h=menu.tk2region_showlst.nextSibling;
h.style.display='block';
h.innerHTML=lst2.join('<br>');
}

/*** __lr__ ends ***/



/*** __gsv__ gene set view ***/

function customgsv_submit_pushbutt()
{
var j=gflag.gsv.bbj.juxtaposition;
j.type=RM_gsv_c;
j.what=j.note='custom gene set';
gflag.gsv.bbj.submitGeneset_custom();
}
function customgsv_clear_pushbutt() {gflag.gsv.bbj.genesetview.submit_textarea.value='';}
function gsedit_changepart_pushbutt() {gflag.gsv.bbj.gsv_update_changepart();}
function gsv_turnoff() {
gflag.gsv.bbj.turnoffJuxtapose(true);
}
function gsvedit_addnew_pushbutt() {gflag.gsv.bbj.gsv_addnewitems();}

Browser.prototype.is_gsv=function() {
var t=this.juxtaposition.type;
return t==RM_gsv_c || t==RM_gsv_kegg;
}


Browser.prototype.toggle9=function(which)
{
// gsv various submission methods
this.genesetview.wrapper_custom.style.display=which==1?'block':'none';
this.genesetview.wrapper_kegg.style.display=which==2?'block':'none';
}

Browser.prototype.submitGeneset_custom=function(optionalParam)
{
/* called by pushing button, for submiting new gene list
also handles the case for parsing url parameter when initiating browser
argument: optional param string for .ajax

cgi returns entire gene set to be contained in .regionLst
this raw .regionLst will be trimmed in .jsonDsp()

will not set .juxtaposition, as submiting kegg will also call this
.jux must be set before calling
*/
var t = this.genesetview.submit_textarea.value;
if(t.length == 0) {
	print2console("no gene list found in text area", 2);
	return;
}
if(ensureNonezerolengthregion(1)) {
	print2console("custom region selector defined zero length", 2);
	return;
}
this.cloak();
print2console("Running Gene Set View...", 0);
var b=this.genesetview.submitbutt_cust;
b.disabled = true;
b.innerHTML = 'Running...';
this.ajax('new=on&itemlist='+t.split('\n').join(',')+gss_param(1)+'&gss_says='+this.genesetview.gss_says+
	this.houseParam()+'&dbName='+this.genome.name+
	(this.genesetview.custgsv_allinterval.checked?'&intervalonly=on':'')+
	(optionalParam==undefined?'':'&'+optionalParam), function(data){
	var bbj=horcrux[data.horcrux];
	bbj.unveil();
	if('abort' in data) {
		print2console(data.abort, 2);
		var b=bbj.genesetview.submitbutt_cust;
		b.disabled = false; b.innerHTML = 'SUBMIT';
		bbj.juxtaposition.type=RM_genome;
		bbj.juxtaposition.note=bbj.juxtaposition.what='genome';
		return;
	}

	// copy entire lst before making dsp (which is .regionLst)
	if(!data.entirelst) fatalError('entirelst missing');
	bbj.genesetview.lst=data.entirelst;

	if('newscaffold' in data)
		bbj.ajax_scfdruntimesync();

	bbj.jsonDsp(data);
	bbj.jsonTrackdata(data);
	bbj.genesetSubmitted(data);

	bbj.render_browser();
	print2console(data.alert, 1);
	bbj.update_gssedit(data.gssparam);

	// sukn only...
	if(gflag.urlparam.willcontinue)
		urlparam_handleTriggers();
});
}

Browser.prototype.update_gssedit=function(dat)
{
// only for gsv
var g=this.genesetview;
g.gss_edit_uisays.innerHTML=g.gss_says=g.gss_says_ghost=dat.gss_says;
g.gss_opt= dat.gss_opt;
g.gss_origin= dat.gss_origin;
g.gss_up= dat.gss_up;
g.gss_down= dat.gss_down;
g.gss_opt_ghost= dat.gss_opt;
g.gss_origin_ghost= dat.gss_origin;
g.gss_up_ghost= dat.gss_up;
g.gss_down_ghost= dat.gss_down;
}

function genesetsortbyChangeoption()
{
// called by changing option on genesetsortby <select>
// will toggle display of track selection <select>
var v = getValue_by_radioName("genesetsortby");
gflag.gsv.bbj.genesetview.tksortselectdiv.style.display = (v=="tkmeanAsc"||v=="tkmeanDesc") ? 'block' : 'none';
}


Browser.prototype.gsv_updatefromlstholder=function()
{
/* call this to update for:
1. user might marked some items for removal
2. manual reordering
*/
var oldlst = [];
for(var i=0; i<this.genesetview.showcount; i++)
	oldlst.push(this.genesetview.lst[i].name);
var newlst = [];
var trlst = this.genesetview.lstholder.firstChild.childNodes;
for(var i=0; i<trlst.length; i++) {
	if(trlst[i].style.backgroundColor=='transparent')
		newlst.push(trlst[i].itemname);
}
if(stringLstIsIdentical(oldlst, newlst)) {
	print2console("nothing changed, won't update", 2);
	return;
}
if(newlst.length == 0) {
	this.turnoffJuxtapose(true);
	return;
}
this.ajaxX('itemlist=on&update=on&lstholderupdate='+newlst.join(','));
}

Browser.prototype.gsv_addnewitems=function()
{
/* adding new items to existing gene set
will not update dsp
*/
var v = this.genesetview.edit_textarea.value;
if(v.length == 0) {
	print2console("no new gene supplied", 2);
	return;
}
this.ajaxX('itemlist='+v+'&new=on&add2existing=on&gss_says=xx'+gss_param(3));
}

Browser.prototype.gsv_update_changepart=function()
{
/* in geneset editing panel, called by pushing Update button for changing part
*/
if(ensureNonezerolengthregion(3)) {
	print2console("flanking region selector spans 0 bp", 2);
	return;
}
print2console("applying changes...", 0);
this.cloak();
this.ajaxX("itemlist=on&update=on&changepart=on&gss_says=xx"+gss_param(3));
}


Browser.prototype.gsv_update_sort=function()
{
/* in geneset editing panel, called by pushing Apply button for sorting
sorting does not require gss param,
the list will be recovered from db
*/
var sortby = getValue_by_radioName("genesetsortby");
if(sortby==null) return;
var tkselectparam = "";
if(sortby=="tkmeanAsc" || sortby=="tkmeanDesc") {
	var t=this.genesetview.tk4sort;
	tkselectparam = '&datatk='+(isCustom(t.ft)?t.url:t.name)+'&datatkft='+t.ft;
}
print2console("updating gene set...", 0);
this.cloak();
this.ajaxX('itemlist=on&update=on&sortby='+sortby+tkselectparam+'&gss_says=xx'+gss_param(3));
}


Browser.prototype.genesetSubmitted=function(data)
{
/* call after:
- submitting new itemlist
- updating itemlist
- restoring gsv session

turns ui into editing mode
handles .entirelst
TODO but not flanking, that's related to dsp
*/
if(this.__gsv_offbutt) this.__gsv_offbutt.style.display='inline';

this.genesetview.runningonwhat.innerHTML=this.juxtaposition.note;

if(data.gsvflankinglst) {
	this.genesetview.flanking={};
	// but not in the case of restoring session
	var lst=data.gsvflankinglst;
	for(var i=0; i<lst.length; i++)
		this.genesetview.flanking[this.genesetview.lst[i].name]=lst[i];
}

var count=this.genesetview.lst.length;

var d=this.genesetview.gsv_says_toomany;
this.genesetview.showcount=count;
if(count > 250) {
	d.style.display='block';
	d.innerHTML='Showing 200 items from top of the list, '+(count-200)+
	' not shown&nbsp;&nbsp;<span class=clb onclick="this.parentNode.style.display=\'none\'">Dismiss</span>';
	this.genesetview.showcount=200;
} else {
	d.style.display='none';
}

var genenamelst=[]; // save a gene name list for querying
for(var i=0; i<count; i++) {
	var g=this.genesetview.lst[i];
	if(g.isgene) genenamelst.push(g.name);
}

var b=this.genesetview.submitbutt_cust;
b.disabled=false;
b.innerHTML='SUBMIT';
this.genesetview.wrapper_custom.style.display=
this.genesetview.wrapper_kegg.style.display=
this.genesetview.wrapper_buttons.style.display='none';
this.genesetview.wrapper_operation.style.display=
this.genesetview.wrapper_cancel.style.display='block';
/* if the set contains too many items, disable editing
var a=document.getElementById('genesetedit_reorder');
var b=document.getElementById('genesetedit_add');
var c=document.getElementById('genesetedit_sort');
var d=document.getElementById('genesetedit_disable');
if(this.genesetview.lst.length>1000) {
	a.style.display= b.style.display= c.style.display='none';
	d.style.display='block';
	document.getElementById('genesetedit_itemcount').innerHTML=this.genesetview.lst.length;
} else {
	a.style.display='block';
	b.style.display=c.style.display='inline-block';
	d.style.display='none';
}
*/
if(genenamelst.length>0) {
	// gene name must not contain comma or it will fail
	this.ajax('getdesc4genelst=on&dbName='+this.genome.name+'&lst='+genenamelst.join(','),function(data) {
		var bbj=horcrux[data.horcrux];
		bbj.gsv_itemgo2holder(data.desc);
	});
} else {
	this.gsv_itemgo2holder({});
}
/* over */
}

Browser.prototype.gsv_itemgo2holder=function(deschash)
{
/* show a number of items on top of the list
nobody's gonna read a list of hundreds
arg is hash of gene desc, maybe empty
*/
var lst=this.genesetview.lst;
var table=this.genesetview.lstholder;
stripChild(table.firstChild, 0);
var maxbp=0;
var maxpx=0; // fit to longest string
for(var i=0; i<this.genesetview.showcount; i++) {
	maxbp=Math.max(maxbp,lst[i].stop-lst[i].start);
	maxpx=Math.max(maxpx, lst[i].name.length);
}
maxpx=maxpx*9+20;
var sf=maxpx/maxbp;
for(var i=0; i<this.genesetview.showcount; i++) {
	// content in a row: button, symbol, refseq name, desc, link
	var item=lst[i];
	var gi;
	if(item.isgene) gi=deschash[item.name];
	var tr = table.insertRow(-1);
	tr.itemname=item.name;
	tr.style.backgroundColor='transparent';
	var td = tr.insertCell(0);
	td.className='numbull';
	td.innerHTML=i+1;
	td=tr.insertCell(-1);
	td.style.width=maxpx;
	td.innerHTML='<div style="position:relative;border-radius:3px;-moz-border-radius:3px;overflow:hidden;">'+
	'<div style="z-index:0;position:absolute;top:0px;left:0px;height:100%;background-color:#3C78B4;width:'+(sf*(item.stop-item.start))+'px;"></div>'+
	'<div class=header_b2 onmousedown=genesetview_itemreorder_Md(event)>'+item.name+'</div>'+
	'</div>';
	td = tr.insertCell(-1);
	td.className='header_r';
	td.innerHTML='&#10005;';
	td.addEventListener('click', gsvitemclick, false);
	// if is gene, show button for switching model
	td = tr.insertCell(-1);
	if(item.isgene) {
		td.className='header_g';
		td.innerHTML='&#8644;';
		td.genename=item.name;
		td.addEventListener('click', gsv_showgenemodellst, false);
	}
	td = tr.insertCell(-1);
	td.style.fontSize = "10px";
	td.style.color = '#5c5c5c';
	td.innerHTML = item.isgene ? gi[1]+'/'+item.strand+'/'+(gi[0].length>120?gi[0].substr(0,120)+'...':gi[0]) : (item.strand=='.'?'':(item.strand=='+'?'forward,':'reverse,'))+' no desc';
	td = tr.insertCell(-1);
	if(item.isgene)
		td.innerHTML = "<a href="+this.genome.decorInfo[gi[1]].queryUrl+item.name+" target=_blank>&#8599;</a>";
}
var pn=table.parentNode;
if(lst.length<=20) {
	pn.style.height='auto';
	pn.style.overflowY='auto';
} else {
	pn.style.height='300px';
	pn.style.overflowY='scroll';
}
}

function gsv_showgenemodellst(event)
{
gflag.gsv.x=event.clientX;
gflag.gsv.y=event.clientY;
gflag.gsv.bbj.ajax('querygene=on&dbName='+gflag.gsv.bbj.genome.name+'&name='+event.target.genename,function(data){
	menu_shutup();
	var table=menu.gsv_genemodellstholder;
	table.style.display='block';
	genelist2selectiontable(data.lst, table, gsv_switchgenemodel);
	menu_show(0,gflag.gsv.x,gflag.gsv.y);
});
}

function gsv_switchgenemodel(event)
{
var tr=event.target;
while(tr.tagName!='TR') tr=tr.parentNode;
var b=gflag.gsv.bbj;
var g=gflag.genelst[tr.idx];
b.ajaxX('itemlist=on&update=on&switchgenemodel=on&dbName='+b.genome.name+
'&session='+b.sessionId+'&statusId='+b.statusId+
'&queryname='+g.name+'&genetype='+g.type+'&targetid='+g.id+'&gss_says=xx'+gss_param(3));
}



function gsvitemclick(event) {
// click <td> of gsv items in lstholder
	var tr = event.target.parentNode;
	tr.style.backgroundColor= tr.style.backgroundColor=='transparent' ? '#a8a8a8' : 'transparent';
}
Browser.prototype.genesetviewTurnedoff=function()
{
this.genesetview.wrapper_buttons.style.display='block';
this.genesetview.wrapper_custom.style.display='block';
this.genesetview.wrapper_kegg.style.display=
this.genesetview.wrapper_operation.style.display=
this.genesetview.wrapper_cancel.style.display='none';
var s=this.genome.scaffold.current;
/** in case of running gsv, .border must be updated back!!
**/
this.genome.border={lname:s[0],lpos:0,rname:s[s.length-1],rpos:this.genome.scaffold.len[s[s.length-1]]};
}
function genesetview_itemreorder_Md(event)
{
// to reorder items in gsv
event.preventDefault();
var td=event.target;
while(td.tagName!='TD') td=td.parentNode;
var item=td.parentNode.itemname;
var lst=gflag.browser.genesetview.lstholder.firstChild.childNodes;
for(var i=0; i<lst.length; i++) {
	if(lst[i].itemname==item) break;
}
gflag.gsvreorder={
	bbj:gflag.browser,
	target:td,
	idx:i,
	total:lst.length,
	y:event.clientY};
document.body.addEventListener('mousemove', genesetview_itemreorder_Mm, false);
document.body.addEventListener('mouseup', genesetview_itemreorder_Mu, false);
}
function genesetview_itemreorder_Mm(event) {
	var m=gflag.gsvreorder;
	var tbody=m.bbj.genesetview.lstholder.firstChild;
	if(event.clientY<m.y) {
		if(m.idx==0) return;
		if(m.y-event.clientY>=20) {
			tbody.appendChild(tbody.childNodes[m.idx]);
			var lst=[];
			for(var i=m.idx-1; i<m.total-1; i++) lst.push(tbody.childNodes[i]);
			for(var i=0; i<lst.length; i++) tbody.appendChild(lst[i]);
			m.idx--;
			m.y=event.clientY;
		}
	} else if(event.clientY>m.y) {
		if(m.idx==m.total-1) return;
		if(event.clientY-m.y>=20) {
			tbody.appendChild(tbody.childNodes[m.idx+1]);
			var lst=[];
			for(var i=m.idx; i<m.total-1; i++) lst.push(tbody.childNodes[i]);
			for(var i=0; i<lst.length; i++) tbody.appendChild(lst[i]);
			m.idx++;
			m.y=event.clientY;
		}
	}
}
function genesetview_itemreorder_Mu(event) {
	document.body.removeEventListener('mousemove',genesetview_itemreorder_Mm, false);
	document.body.removeEventListener('mouseup',genesetview_itemreorder_Mu, false);
}

function genesetsort_invoketkselect(event)
{
/* called by clicking button */
menu_shutup();
menu_show(16,event.clientX,event.clientY);
gflag.gsv.bbj.showcurrenttrack4select();
}
/*** __gsv__ ends ***/



/*** __kegg__ start ***/
/*
function queryKegg(command, callback)
{
var xmlhttp;
if(window.XMLHttpRequest)
	xmlhttp = new XMLHttpRequest();
else
	xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
xmlhttp.onreadystatechange = function() {
if(xmlhttp.readyState==4 && xmlhttp.status==200) {
	try {var data = eval('('+xmlhttp.responseText+')');}
	catch(err) {
		fatalError(err+" (sorry... try refreshing page)");
		return;
	}
	callback(data);
}
}
xmlhttp.open("GET", 'http://rest.kegg.jp'+command, true);
xmlhttp.send();
}
*/

function gsvkegg_input_focus(event) { if(event.target.value=='enter keywords') event.target.value=''; }
function gsvkegg_input_blur(event) {if(event.target.value.length==0) event.target.value='enter keywords';}
function keggpathwaykeywordlookup_ku(event) {if(event.keyCode==13) keggpathwaykeywordlookup();}
function keggpathwaykeywordlookup()
{
// called by push butt
var bbj=gflag.gsv.bbj;
var w = bbj.genesetview.keggkwinput.value;
if(w.length==0 || w=="enter keywords") {
	print2console("no keyword given", 2);
	return;
}
bbj.genesetview.keggkwsearchbutt.disabled=true;
print2console("querying for KEGG pathway by keyword...", 0);
// get entire list of pathways
bbj.ajax('listkeggpathway=on&speciescode='+bbj.genome.keggSpeciesCode,function(data){
	var bbj=horcrux[data.horcrux];
	if(data.error) {
		print2console('Error querying kegg database',2);
		bbj.genesetview.keggkwsearchbutt.disabled=false;
		return;
	}
	var lowerkeyword=bbj.genesetview.keggkwinput.value.toLowerCase();
	// find matching
	var matching=[];
	for(var i=0; i<data.lst.length-1; i++) {
		var lower=data.lst[i][0].toLowerCase();
		if(lower==lowerkeyword) {
			matching.push(i);
		} else if(lower.split(':')[1]==lowerkeyword) {
			matching.push(i);
			break;
		} else {
			lower=data.lst[i][1].toLowerCase();
			if(lower.indexOf(lowerkeyword)!=-1)
				matching.push(i);
		}
	}
	if(matching.length==0) {
		print2console('No match found',2);
		bbj.genesetview.keggkwsearchbutt.disabled=false;
		return;
	}

	var wrapper=bbj.genesetview.wrapper_pathwaytable;
	wrapper.style.display='block';
	var table = bbj.genesetview.pathwaytable;
	stripChild(table, 0);
	if(matching.length <= 10) {
		wrapper.style.height = "auto";
		wrapper.style.overflowY = "auto";
	} else {
		wrapper.style.height = "200px";
		wrapper.style.overflowY = "scroll";
	}
	for(var i=0; i<matching.length; i++) {
		var v=data.lst[matching[i]];
		var tr=table.insertRow(-1);
		var td=tr.insertCell(0);
		td.className='header_g';
		var pname=v[0].split(':')[1];
		td.wayname=pname;
		td.innerHTML=pname;
		td.addEventListener('click',submitGeneset_kegg,false);
		td=tr.insertCell(1);
		td.innerHTML=v[1];
	}
	print2console(matching.length+' matches found',1);
	bbj.genesetview.keggkwsearchbutt.disabled=false;
});
}
function submitGeneset_kegg(event)
{
/* run gene set view on a kegg pathway by clicking <td>
*/
var bbj=gflag.gsv.bbj;
if(ensureNonezerolengthregion(2)) {
	print2console("custom region selector spans 0 bp", 2);
	return;
}
var pathwayname=event.target.wayname;
bbj.juxtaposition.note = "KEGG "+pathwayname;
bbj.cloak();
// calling soak.py to fetch kegg genes
print2console("querying KEGG for pathway genes...", 0);
bbj.ajax('getgenebykeggpathway=on&dbName='+bbj.genome.name+'&speciescode='+bbj.genome.keggSpeciesCode+'&pathway='+pathwayname,function(data){
	if(data.error) {
		print2console('Error querying genes from kegg, please try again',2);
		return;
	}
	if(data.lststring.length==0) {
		print2console('Error: no genes retrieved, please contact admin with this pathway id',2);
		return;
	}
	// cgi returns list of refgene name, run custom gsv with this list
	var bbj=horcrux[data.horcrux];
	bbj.genesetview.submit_textarea.value=data.lststring;
	bbj.genesetview.custgsv_allinterval.checked=false;
	var j=bbj.juxtaposition;
	j.type=RM_gsv_kegg;
	j.note=j.what='KEGG pathway';
	bbj.submitGeneset_custom();
});
}


/*** __kegg__ ends ***/




/* __cate__ categorical track */

function cateInfo_copy(fromobj, toobj) {
/* args are cateInfo hash */
	for(var k in fromobj)
		toobj[k]=[fromobj[k][0], fromobj[k][1]];
	toobj[-1]=['no information', 'transparent'];
}
function cateTk_wreath_config(tkn) {
/* wrapper, configuring a wreath track, viewidx is given by chiapet.viewidx */
	gflag.cateTk.which=4;
	gflag.cateTk.chiapetvidx=chiapet.viewidx;
	var lst=chiapet.datalst[chiapet.viewidx].wreath;
	for(var i=0; i<lst.length; i++) {
		if(lst[i].name==tkn) {
			gflag.cateTk.wreathidx=i;
			cateCfg_show({ft:lst[i].filetype, name:tkn, label:lst[i].label, cateInfo:lst[i].cateInfo});
			return;
		}
	}
	fatalError('cateTk_wreath_config: track not found '+tkn);
}
function cateCfg_show(tkobj)
{
/* show config panel for single cate track
with second thought, the categorical tracks are configured separately, but not in groups

argument is an object with attributes: 
	{'ft', 'name', 'label', 'cateInfo'}
it is naturall tkLst element, but can be synthesized
so that ideogramwiggle or others can be configured as well

which: see "data structure.dia"
*/
if(tkobj.ft!=FT_cat_n && tkobj.ft!=FT_cat_c) {
	print2console('cateCfg_show: but track is not categorical',2);
	return;
}
var lst=['<table cellspacing=3>'];
for(var i in tkobj.cateInfo) {
	if(i==-1) continue;
	var t=tkobj.cateInfo[i];
	lst.push('<tr><td class=squarecell itemidx='+i+' onclick="cateTkitemcolor_initiate(event)" style="background-color:'+t[1]+';"></td><td>'+t[0]+'</td></tr>');
}
// restore button is only shown for native hmtk
if(tkobj.ft==FT_cat_n)
	lst.push('<tr><td colspan=2 style="padding-left:20px"><button type=button onclick=cateCfg_restore("'+tkobj.name+'")>Restore color settings</button></td></tr>');
lst.push('</table>');
document.getElementById('cateCfgfill').innerHTML=lst.join('');
menu_shutup();
menu.c13.style.display=
menu.c14.style.display='block';
document.getElementById('menu_tkh_unifybutt').style.display='none';
}

function cateCfg_tkh(event)
{
/* use <select> to change track h pointed by menu
XXX
*/
if(event.target.selectedIndex==0) return;
var h= parseInt(event.target.options[event.target.selectedIndex].value);
switch(gflag.menu.context) {
case 1:
	// single tk
	var bbj=gflag.menu.bbj;
	var obj=gflag.menu.tklst[0];
	if(obj==undefined) return;
	obj.qtc.height=h;
	bbj.drawTrack_browser(obj);
	bbj.drawMcm_onetrack(obj,false);
	bbj.trackHeightChanged();
	bbj.highlighttrack([obj]);
	return;
case 19:
	// wreath
	var obj=hengeview.hash[gflag.menu.viewkey].wreath[gflag.menu.wreathIdx];
	obj.qtc.height=h;
	hengeview_draw(gflag.menu.viewkey);
	return;
case 20:
	var obj=gflag.menu.bbj.genome.bev.tklst[gflag.menu.bevtkidx];
	obj.qtc.height=h;
	gflag.menu.bbj.genome.bev_draw_track(obj);
	return;
default: fatalError('cateCfg_tkh: unknown menu.context');
}
}

function cateCfg_restore(tkname) {
/* argument is tk name
only works for native tracks
*/
	var bbj=gflag.menu.bbj;
	var oobj=bbj.genome.hmtk[tkname];
	if(oobj==undefined) {
		oobj=bbj.genome.decorInfo[tkname];
		if(oobj==undefined) {
			print2console('Error: cannot restore, registry object missing',2);
			return;
		}
	}
	switch(gflag.menu.context) {
	case 1:
		var obj=bbj.findTrack(tkname);
		if(obj==null) fatalError('cateCfg_restore: display object not found');
		if(obj.ft!=FT_cat_n) return;
		cateInfo_copy(oobj.cateInfo, obj.cateInfo);
		cateCfg_show(obj);
		bbj.drawTrack_browser(obj);
		return;
	case 19:
		// wreath
		var obj=hengeview.hash[gflag.menu.viewkey].wreath[gflag.menu.wreathIdx];
		cateInfo_copy(oobj.cateInfo,obj.cateInfo);
		cateCfg_show(obj);
		hengeview_draw(gflag.menu.viewkey);
		return;
	case 20:
		var obj=gflag.menu.bbj.genome.bev.tklst[gflag.menu.bevtkidx];
		cateInfo_copy(oobj.cateInfo,obj.cateInfo);
		cateCfg_show(obj);
		gflag.menu.bbj.genome.bev_draw_track(obj);
		return;
	default:
		fatalError("cateCfg_restore: unknown menu.context");
	}
}
function cateTkitemcolor_initiate(event) {
/* invoking color palette for categorical track from the configuration menu
track is identified by gflag.menu
*/
	paletteshow(event.clientX, event.clientY, 42);
	palettegrove_paint(event.target.style.backgroundColor);
	gflag.menu.catetk.itemidx=parseInt(event.target.getAttribute('itemidx'));
	gflag.menu.catetk.item=event.target;
}
function cateTkitemcolor() {
/* change item color */
	var sto=gflag.menu.catetk;
	sto.item.style.backgroundColor=palette.output;
	switch(gflag.menu.context) {
	case 1:
		var obj=gflag.menu.tklst[0];
		if(obj==undefined) return;
		obj.cateInfo[sto.itemidx][1]=palette.output;
		gflag.menu.bbj.drawTrack_browser(obj);
		break;
	case 19:
		// wreath
		var tkobj=hengeview.hash[gflag.menu.viewkey].wreath[gflag.menu.wreathIdx];
		tkobj.cateInfo[sto.itemidx][1]=palette.output;
		hengeview_draw(gflag.menu.viewkey);
		break;
	case 20:
		// bev
		var tkobj=gflag.menu.bbj.genome.bev.tklst[gflag.menu.bevtkidx];
		tkobj.cateInfo[sto.itemidx][1]=palette.output;
		gflag.menu.bbj.genome.bev_draw_track(tkobj);
		break;
	default: fatalError('cateTkitemcolor: unknown gflag.menu.context');
	}
}

/* __cate__ ends */


/*** __custtk__ custom track submission and management ***/
function samplecusttkurl(ft) {
var info=gflag.tsp.bbj.genome.defaultStuff.custtk;
switch(ft) {
	case FT_bed_c:
		document.getElementById('newcustomtkurl_1').value=info[ft];
		document.getElementById('newcustomtkname_1').value='sample bed';
		return;
	case FT_bedgraph_c:
		document.getElementById('newcustomtkurl_3').value=info[ft];
		document.getElementById('newcustomtkname_3').value='sample bedGraph';
		return;
	case FT_sam_c:
		document.getElementById('newcustomtkurl_5').value=info[ft];
		document.getElementById('newcustomtkname_5').value='sample read-alignment';
		return;
	case FT_lr_c:
		document.getElementById('newcustomtkurl_10').value=info[ft];
		document.getElementById('newcustomtkname_10').value='sample long-range interaction';
		return;
	case FT_bigwighmtk_c:
		document.getElementById('newcustomtkurl_15').value=info[ft];
		document.getElementById('newcustomtkname_15').value='sample bigWig';
		return;
	case FT_huburl:
		document.getElementById('datahuburl').value=info[ft];
		return;
	default: fatalError('samplecusttkurl: unknown ft');
}
}
function custtkpanel_show(event) {
	var w=parseInt(event.target.getAttribute('which'));
	var c=gflag.tsp.bbj.genome.custtk;
	c.wrapper_bed.style.display=w==FT_bed_c?'block':'none';
	c.wrapper_bedgraph.style.display=w==FT_bedgraph_c?'block':'none';
	c.wrapper_sam.style.display=w==FT_sam_c?'block':'none';
	c.wrapper_lr.style.display=w==FT_lr_c?'block':'none';
	c.wrapper_bigwig.style.display=w==FT_bigwighmtk_c?'block':'none';
	c.wrapper_hub.style.display=w==FT_huburl?'block':'none';
	c.wrapper_registry.style.display=w==101?'block':'none';
	c.wrapper_launch.style.display='none';
	c.wrapper_goback.style.display='block';
}
function custtkpanel_back2control() {
	var c=gflag.tsp.bbj.genome.custtk;
	c.wrapper_bed.style.display=
	c.wrapper_bedgraph.style.display=
	c.wrapper_sam.style.display=
	c.wrapper_lr.style.display=
	c.wrapper_bigwig.style.display=
	c.wrapper_hub.style.display=
	c.wrapper_registry.style.display=
	c.wrapper_goback.style.display='none';
	c.wrapper_launch.style.display='block';
}

function registerCustomtrack(hash) {
/* deals with all types of custom tracks 
called by:
- manually adding custom tracks
- from restoring session
- datahub
- urlparam

will create registry object, as well as insert row in HTML registry table

will only be called when the custom track is newly added
but not showing the track when it's already added

argument is gflag.customtmp or similar
*/
	if(!isCustom(hash.ft))
		fatalError("registerCustomtrack: not custom track filetype");

	var bbj=gflag.tsp.bbj;
	var tkishmtk=isHmtk(hash.ft);

	// insert row in HTML custom track registration table
	// bedgraph, bigwig and categorical go to same holder
	var holder = document.getElementById('custHolder'+(tkishmtk?'Hmtk':hash.ft));
	if(holder == null) fatalError("registerCustomtrack: custHolder not found");
	var tr = holder.insertRow(-1);
	// 1. label
	var td = tr.insertCell(0);
	td.innerHTML = hash.label;
	// 2. url
	td = tr.insertCell(-1);
	td.style.color = '#858585';
	if(hash.url.length >= 50) {
		td.innerHTML = hash.url.substr(0,45)+'...';
		td.title = hash.url;
	} else {
		td.innerHTML = hash.url;
	}

	// 3. utility buttons, one td for each button
	// show/hide button
	var sbutt = document.createElement('button');
	sbutt.innerHTML = 'show';
	sbutt.className = 's';
	sbutt.setAttribute('tkname', hash.name);
	sbutt.addEventListener('click', customtrack_showbuttclick, false);
	tr.insertCell(-1).appendChild(sbutt);

	// metdata editing button
	tr.insertCell(-1).innerHTML='<button type=button class=s style="white-space:nowrap;" onclick=custtkmd_showeditpanel("'+hash.name+'",'+hash.ft+')>&#9998;metadata</button>';

	// delete button
	tr.insertCell(-1).innerHTML='<button type=button class=s onclick=removeCustomtrack_pushDel("'+hash.name+'")>delete</button>';

	// increment count
	bbj.genome.custtk.totalcount.innerHTML=
	bbj.genome.custtk.totalcount2.innerHTML=parseInt(bbj.genome.custtk.totalcount.innerHTML)+1;
	if(tkishmtk)
		s = document.getElementById('custHmtkhowmany');
	else
		s = document.getElementById('cust'+hash.ft+'howmany');
	var num = parseInt(s.innerHTML) +1;
	s.innerHTML = parseInt(s.innerHTML)+1;
	var pa = holder.parentNode;
	if(num > 10) {
		pa.style.height = 200;
		pa.style.overflowY = 'scroll';
	} else {
		pa.style.height = 'auto';
		pa.style.overflowY = 'auto';
	}

	/*** create registry object ***
	all custom tracks are registered in genome.hmtk
	in case of longrange, must save score threshold in registry object
	*/
	var o={ label:hash.label,
		url:hash.url,
		ft:hash.ft,
		md:hash.md,
		custmd:hash.custmd,
		registrytr:tr,
		showbutt:sbutt,
		mode:hash.mode,
	};
	if(o.ft==FT_lr_c) {
		o.pfilterscore=hash.pfilterscore;
		o.nfilterscore=hash.nfilterscore;
	}
	bbj.genome.hmtk[hash.name]=o;
}

Genome.prototype.newcustomtrackname=function()
{
var n = Math.random().toString().split('.')[1];
while((n in this.hmtk) || (n in this.decorInfo))
	n = Math.random().toString().split('.')[1];
return n;
}

Genome.prototype.tkurlInUse=function(url)
{
for(var t in this.hmtk) {
	var tk=this.hmtk[t];
	if(isCustom(tk.ft) && tk.url==url) return true;
}
return false;
}

function submitCustomtrack(ft)
{
/* called only by pushing button, works for all types
real tracks, not datahub
20130326 big old bug of not adding track for splinters
TODO categorical
*/
if(!isCustom(ft))
	fatalError('submitCustomtrack: unsupported ft ('+ft+')');
/* sita discovered that running on two identical custtk will cause trouble
so prevent it
*/
var bbj=gflag.tsp.bbj;
var url=document.getElementById('newcustomtkurl_'+ft).value;
if(bbj.genome.tkurlInUse(url)) {
	print2console('This track has already been submitted',2);
	document.getElementById('submitCustomtkbutt'+ft).style.backgroundColor='#FF6666';
	setTimeout('document.getElementById("submitCustomtkbutt'+ft+'").style.backgroundColor=""',500);
	return;
}

if(ft==FT_cat_c) fatalError('submitCustomtrack: not there yet');
var _tmp=gflag.customtmp;
_tmp.name=bbj.genome.newcustomtrackname();
_tmp.label=document.getElementById('newcustomtkname_'+ft).value;
_tmp.url=url;
_tmp.ft=ft;
if(newCustomTrack_isInvalid())
	return;
if(document.getElementById('newcustomtkmode_'+ft))
	_tmp.mode=parseInt(getSelectValueById('newcustomtkmode_'+ft));
else
	_tmp.mode=M_show;

// all metadata annotation
var table;
if(ft==FT_bedgraph_c)
	table=bbj.genome.mdselect.custpriortable3;
else if(ft==FT_bigwighmtk_c)
	table=bbj.genome.mdselect.custpriortable15;
else if(ft==FT_bed_c)
	table=bbj.genome.mdselect.custpriortable1;
else if(ft==FT_lr_c)
	table=bbj.genome.mdselect.custpriortable10;
else if(ft==FT_sam_c)
	table=bbj.genome.mdselect.custpriortable5;
var lst = custmdtable_getTermlist(table);
_tmp.md=lst[0];
_tmp.custmd=lst[1];

// TODO all configuring score threshold for all tracks
if(ft==FT_lr_c) {
	var score1=parseInt(document.getElementById('newcustomtkscore1_10').value);
	if(isNaN(score1)) {
		print2console('Invalid positive threshold value',2);
		return;
	}
	if(score1<0) {
		print2console('Positive threshold value must be >=0',2);
		return;
	}
	var score2=parseInt(document.getElementById('newcustomtkscore2_10').value);
	if(isNaN(score2)) {
		print2console('Invalid negative threshold value',2);
		return;
	}
	if(score2>0) {
		print2console('Negative threshold value must be <=0',2);
		return;
	}
	_tmp.qtc={pfilterscore:score1,nfilterscore:score2};
}

bbj.cloak();
print2console("adding custom track...", 0);
document.getElementById('submitCustomtkbutt'+ft).disabled=true;
document.body.style.cursor = 'wait';
bbj.ajax('addtracks=on&'+bbj.displayedRegionParamPrecise()+trackParam([_tmp]),function(data){
	var _tmp=gflag.customtmp;
	var bbj=horcrux[data.horcrux];
	document.getElementById('submitCustomtkbutt'+_tmp.ft).disabled=false;
	registerCustomtrack(_tmp);
	bbj.genome.hmtk[_tmp.name].showbutt.innerHTML='hide';
	bbj.jsonTrackdata(data);

	var table;
	if(_tmp.ft==FT_bedgraph_c)
		table=bbj.genome.mdselect.custpriortable3;
	else if(_tmp.ft==FT_bigwighmtk_c)
		table=bbj.genome.mdselect.custpriortable15;
	else if(_tmp.ft==FT_bed_c)
		table=bbj.genome.mdselect.custpriortable1;
	else if(_tmp.ft==FT_lr_c)
		table=bbj.genome.mdselect.custpriortable10;
	else if(_tmp.ft==FT_sam_c)
		table=bbj.genome.mdselect.custpriortable5;
	stripChild(table.firstChild,0);
	table.style.display='none';

	bbj.drawTrack_browser(bbj.findTrack(_tmp.name));
	bbj.track2holder();
	bbj.prepareMcm();
	bbj.drawMcm();

	document.body.style.cursor = 'auto';
	bbj.unveil();
	print2console("custom track added", 1);

	for(var tag in bbj.splinters)
		bbj.splinters[tag].ajax_addtracks([_tmp]);
});
}

function newCustomTrack_isInvalid() {
/* first fetch url and name of custom track into global variables, 
then call the validation routine
*/
	var url = gflag.customtmp.url;
	if(url.length <= 0) {
		print2console("no URL given for custom track", 3);
		return true;
	}
	if(url.length <= 8) {
		print2console("URL looks invalid", 3);
		return true;
	}
	if(url.substr(0,4).toLowerCase()!='http' && url.substr(0,3).toLowerCase()!='ftp') {
		print2console("shouldn't URL start with 'http' or 'ftp'?", 3);
		return true;
	}
	var label = gflag.customtmp.label;
	if(label.length == 0) {
		print2console("no track name entered", 3);
		return true;
	}
	if(label.indexOf(',') != -1) {
		print2console("no comma allowed for track name", 2);
		return true;
	}
	if(label.indexOf('|') != -1) {
		print2console("no vertical line allowed for track name", 2);
		return true;
	}
	return false;
}

function custmdtable_getTermlist(table) {
/* argument: <table> dom object
e.g. mdselect.custpriortable1

retrieve terms from table
each <tr> is one term (leaf nodes only!)
have attributes "termidx" and "termparent"
custom terms will have "custom" attribute

returns an array of two elements
[1] [native term idx1, idx2, ...] to be used as .md attribute of track objects
[2] {custTermName : custTermValue} to be used as .custmd attribute of track objects
*/
	var lst = table.firstChild.childNodes;
	var slst = []; // native term idx
	var clst = {}; // custom term (name, attr)
	for(var i=0; i<lst.length; i++) {
		if(lst[i].getAttribute('termidx')==null) continue;
		if(lst[i].getAttribute('custom') == null)
			slst.push(lst[i].getAttribute('termidx'));
		else
			clst[lst[i].getAttribute('termparent')] = lst[i].getAttribute('termidx');
	}
	return [slst, clst];
}

Genome.prototype.toggleMdtermcheckbox4tkanno=function(nativelst, custhash)
{
/* toggle metadata panel checkboxes for purpose of annotating tracks
will hide checkboxes for none-leaf terms
and check those leaves already selected for annotation
args are returned value of custmdtable_getTermlist()

FIXME
toggle mdcb check/uncheck and visibility should be separated
*/
	// native terms
	for(var t in this.mdv2checkbox) {
		var c=this.mdv2checkbox[t];
		c.checked=false;
		c.style.display=(t in this.mdvp2c)?'none':'inline';
	}
	for(var i=0; i<nativelst.length; i++)
		this.mdv2checkbox[nativelst[i]].checked=true;
	// custom term
	for(t in this.mdv2checkbox_custom) {
		this.mdv2checkbox_custom[t][0].checked=false;
		this.mdv2checkbox_custom[t][0].style.display='none';
		var lst=this.mdv2checkbox_custom[t][1];
		if(t in custhash) {
			for(var t2 in lst)
				lst[t2].checked=t2==custhash[t];
		} else {
			for(var t2 in lst) lst[t2].checked=false;
		}
	}
}

function invokemds_custtkpriorsubmission(event)
{
// annotate custom track prior to submission, called by pushing button
var ft=parseInt(event.target.getAttribute('ft'));
var g=gflag.tsp.bbj.genome;
var table, which;
switch(ft) {
	case FT_bedgraph_c:
		table=g.mdselect.custpriortable3;
		which=2; break;
	case FT_bigwighmtk_c:
		table=g.mdselect.custpriortable15;
		which=7; break;
	case FT_bed_c:
		table=g.mdselect.custpriortable1;
		which=4; break;
	case FT_lr_c:
		table=g.mdselect.custpriortable10;
		which=6; break;
	case FT_sam_c:
		table=g.mdselect.custpriortable5;
		which=5; break;
	default: fatalError('ahahhhh');
}
var lst = custmdtable_getTermlist(table);
g.toggleMdtermcheckbox4tkanno(lst[0], lst[1]);
g.invokemds(which, event.clientX+20+document.body.scrollLeft, event.clientY-40+document.body.scrollTop, true);
}

Genome.prototype.custmd_tableinsert=function(table, term, iscustom, parentterm, removecallback)
{
/* insert a row to table showing metadata annotation for custom bigwig file
args:
table: <table> dom object
term: leaf term index, or attribute name of custom term
iscustom: boolean
parentterm: name of term
*/
var tr = table.insertRow(-1);
tr.setAttribute('termidx', term);
tr.setAttribute('termparent', parentterm);
if(iscustom) {
	tr.setAttribute('custom', 1);
}
// attribute name
var td = tr.insertCell(0);
td.style.backgroundColor = 'white';
if(iscustom) {
	td.innerHTML = term+' <span style="color:#858585;">of '+parentterm+'</span>';
} else {
	// only leaf terms will be used
	if(bbj.splinterTag!=null) continue;
	td.innerHTML = this.mdvidx2attr[term]+' <span style="color:#858585;">of '+(parentterm in this.mdvidx2attr ? this.mdvidx2attr[parentterm] : parentterm);
}
/* info icon
if(!iscustom) {
	td = tr.insertCell(-1);
	td.style.backgroundColor = 'white';
	td.align = 'center';
	td.innerHTML = '<a termidx="'+term+'" style="cursor:pointer;" onclick=mdterm_requesttooltip(event)>&#9432;</a>';
}
*/
// removal icon
td = tr.insertCell(-1);
td.style.backgroundColor = 'white';
td.style.cursor = 'pointer';
td.align = 'center';
td.innerHTML = '&#10005;';
td.addEventListener('click', removecallback, false);
}


function loaddatahub(content)
{
/* called by:
- pushing 'load' button
- url parameter

arg is datahub file text, optional

cgi returns a list of objects, tracks and custommd
they are identified by obj.ft
obj.ft==-1 is a special case here to indicate it is custmd, it doesn't apply elsewhere

20130326 big old bug of not adding datahub for splinters
*/
var param;
if(content==undefined) {
	var url = document.getElementById('datahuburl').value;
	if(url.length==0 || url=='Enter URL of hub descriptor file') {
		print2console('URL to hub descriptor file required', 2);
		return;
	}
	param='&url='+url;
} else {
	param='text='+content;
}
var bbj=gflag.tsp.bbj;
bbj.cloak();
document.body.style.cursor = 'wait';
print2console('loading data hub...', 0);
document.getElementById('loadhubbutt').disabled = true;
bbj.ajax(bbj.displayedRegionParamPrecise()+'&loaddatahub=on&'+param, function(data){
	var bbj=horcrux[data.horcrux];
	if(!('hubdata' in data)) {
		bbj.unveil();
		document.body.style.cursor = 'auto';
		document.getElementById('loadhubbutt').disabled = false;
		print2console('Something\'s wrong with your datahub, please check again.',3);
		return;
	}
	if(data.hubdata.length == 0) {
		print2console('data hub has no content', 2);
		document.getElementById('loadhubbutt').disabled = false;
		document.body.style.cursor = 'auto';
		bbj.unveil();
		return;
	}
	// load metadata first
	var hascustmd = false;
	var newterms = {};
	for(var i=0; i<data.hubdata.length; i++) {
		var item = data.hubdata[i];
		if(item.ft == -1) {
			bbj.genome.custmdhash[item.name] = item.values.split(',');
			bbj.genome.displayCustmdterm(item.name);
			newterms[item.name] = 1;
			hascustmd = true;
		}
	}
	if(hascustmd) {
		// show new terms in mcm
		bbj.genome.mdselect.which = 1;
		gflag.mdp.bbj=bbj;
		for(var name in newterms) {
			// only show those that are not in mcm
			var shown=false;
			for(var i=0; i<bbj.mcm.lst.length; i++) {
				var t=bbj.mcm.lst[i];
				if(t[1] && t[0]==name) {
					shown=true;break;
				}
			}
			if(shown) continue;
			var cb=bbj.genome.mdv2checkbox_custom[name][0];
			cb.checked=true;
			simulateEvent(cb, 'change');
		}
	}

	var tknum=[0,0]; // total, onshow
	data.decorData=[];
	data.hmtkData=[];
	gflag.tsp.bbj=bbj;
	// preload tracks, register
	for(i=0; i<data.hubdata.length; i++) {
		var item = data.hubdata[i];
		var ft=item.ft;
		if(ft==FT_bigwighmtk_c||ft==FT_bedgraph_c) {
			tknum[0]++;
			// set custom md anno
			var custmd = {};
			if(item.custmdraw != undefined) {
				var lst = item.custmdraw.split(',');
				for(var j=0; j<lst.length; j++) {
					var lst2 = lst[j].split(':');
					custmd[lst2[0]] = lst2[1];
				}
			}
			item.custmd=custmd;
			item.md=[];
			registerCustomtrack(item);
			if('data' in item) {
				// if this track's mode is "show", it will have .data, else, don't display it
				tknum[1]++;
				bbj.genome.hmtk[item.name].showbutt.innerHTML='hide';
				data.hmtkData.push(item);
			}
		} else if(ft==FT_bed_c || ft==FT_lr_c || ft==FT_sam_c) {
			tknum[0]++;
			var custmd = {};
			if(item.custmdraw != undefined) {
				var lst = item.custmdraw.split(',');
				for(var j=0; j<lst.length; j++) {
					var lst2 = lst[j].split(':');
					custmd[lst2[0]] = lst2[1];
				}
			}
			item.custmd=custmd;
			item.md=[];
			registerCustomtrack(item);
			if(item.mode!=M_hide) {
				tknum[1]++;
				bbj.genome.hmtk[item.name].showbutt.innerHTML='hide';
				data.decorData.push(item);
			}
		}
	}

	/* apply custom style
	this must be done after registering, and before creating display object
	custom style attributes will be attached to registry object
	attribute name has prefix 'style_' so as not to confuse with anything
	*/
	for(i=0; i<data.hubdata.length; i++) {
		var item=data.hubdata[i];
		if(item.ft==-1) continue;
		var obj=browser.genome.hmtk[item.name];
		if('styleraw' in item) {
			var lst=item.styleraw.split(',');
			for(var j=0; j<lst.length; j++) {
				var tt=lst[j].split(':');
				if(tt.length!=2) continue;
				if(tt[0]=='height') {
					var x=parseInt(tt[1]);
					if(!isNaN(x))
						obj.style_height=x;
				} else if(tt[0]=='boxcolor') {
					if(!isNaN(colorstr2int(tt[1])[0]))
						obj.style_bedcolor=tt[1];
				} else if(tt[0]=='textcolor') {
					if(!isNaN(colorstr2int(tt[1])[0]))
						obj.style_textcolor=tt[1];
				} else if(tt[0]=='colorforward') {
					if(!isNaN(colorstr2int(tt[1])[0]))
						obj.style_forwardcolor=tt[1];
				} else if(tt[0]=='colorreverse') {
					if(!isNaN(colorstr2int(tt[1])[0]))
						obj.style_reversecolor=tt[1];
				} else if(tt[0]=='colormismatch') {
					if(!isNaN(colorstr2int(tt[1])[0]))
						obj.style_mismatchcolor=tt[1];
				} else if(tt[0]=='colorpositive') {
					var c=colorstr2int(tt[1]);
					if(!isNaN(c[0]) && !isNaN(c[1]) && !isNaN(c[2])) {
						obj.style_pr=c[0];
						obj.style_pg=c[1];
						obj.style_pb=c[2];
					}
				} else if(tt[0]=='colornegative') {
					var c=colorstr2int(tt[1]);
					if(!isNaN(c[0]) && !isNaN(c[1]) && !isNaN(c[2])) {
						obj.style_nr=c[0];
						obj.style_ng=c[1];
						obj.style_nb=c[2];
					}
				}
			}
		}
	}

	/* load tracks
	*/
	if(data.hmtkData.length>0 || data.decorData.length>0) {
		var nlst=bbj.jsonTrackdata(data);
		for(var i=0; i<nlst.length; i++)
			bbj.drawTrack_browser(bbj.findTrack(nlst[i][0]));
		bbj.mcm_sort(bbj.mcm.sortidx);
		bbj.prepareMcm();
		bbj.drawMcm();
		bbj.trackHeightChanged();
	}

	bbj.cfacet_generategrid();
	document.body.style.cursor = 'auto';
	document.getElementById('loadhubbutt').disabled = false;
	bbj.unveil();
	print2console(tknum[0]+' tracks loaded, '+tknum[1]+' shown by default', 1);

	// sukn only...
	if(gflag.urlparam.willcontinue)
		urlparam_handleTriggers();
	for(var tag in bbj.splinters)
		bbj.splinters[tag].ajax_addtracks(bbj.tklst);
});
/* over */
}

function removeCustomtrack_pushDel(tkname) {
/* should only be called by pushing delete button in custom track registry
permanent removal
*/
	var bbj=gflag.tsp.bbj;
	if(!(tkname in bbj.genome.hmtk)) fatalError('removeCustomtrack_pushDel: track not found in {hmtk}');
	if(bbj.findTrack(tkname)!=null) {
		bbj.removeTrack([tkname]);
	}
	var o=bbj.genome.hmtk[tkname];
	o.registrytr.parentNode.removeChild(o.registrytr);
	delete bbj.genome.hmtk[tkname];
	if(isHmtk(o.ft))
		document.getElementById('custHmtkhowmany').innerHTML=parseInt(document.getElementById('custHmtkhowmany').innerHTML)-1;
	else if(o.ft==FT_bed_c)
		document.getElementById('cust1howmany').innerHTML=parseInt(document.getElementById('cust1howmany').innerHTML)-1;
	else if(o.ft==FT_lr_c)
		document.getElementById('cust10howmany').innerHTML=parseInt(document.getElementById('cust10howmany').innerHTML)-1;
	else
		document.getElementById('cust5howmany').innerHTML=parseInt(document.getElementById('cust5howmany').innerHTML)-1;
	bbj.genome.custtk.totalcount.innerHTML=
	bbj.genome.custtk.totalcount2.innerHTML=parseInt(bbj.genome.custtk.totalcount.innerHTML)-1;
	bbj.cfacet_generategrid();
}
function customtrack_showbuttclick(event)
{
/* called by clicking on show/hide button to toggle the display of custom track

must use event on button clicking as will toggle show/hide

but beware the button might come from two places:
- custom track registry table in control panel
- custom track selection list in ftb
*/
var bbj=gflag.tsp.bbj;
var name = event.target.getAttribute('tkname');
var oobj=bbj.genome.hmtk[name];
if(oobj==undefined)
	fatalError('customtrack_showbuttclick: track not in {hmtk}');
gflag.tsp.invoke.type=-1;
if(bbj.findTrack(name)==null) {
	// show the track
	event.target.innerHTML = 'hide';
	bbj.ajax_addtracks_names([name]);
} else {
	// hide the track
	bbj.removeTrack([name]);
	event.target.innerHTML = 'show';
}
bbj.cfacet_generategrid();
}




/*** __custtk__ ends ***/




/*** __scaffold__ ***/

Browser.prototype.ajax_scfdruntimesync=function()
{
/* big trap!!
in case of gsv, border name is itemname, but not chrom name
so adding new chrom in case of gsv need to preserve old right border!!
*/
this.ajax('scfdruntimesync=on&dbName='+this.genome.name+'&session='+this.sessionId+'&status='+this.statusId,function(data){
	if(data.error) fatalError('Error syncing scfdruntime!');
	var bbj=horcrux[data.horcrux];
	var right=[];
	if(bbj.is_gsv()) {
		right[0]=bbj.genome.border.rname;
		right[1]=bbj.genome.border.rpos;
	}
	for(var i=0; i<data.lst.length; i++) {
		if(!thinginlist(data.lst[i],bbj.genome.scaffold.current))
			bbj.genome.addnewscaffold([data.lst[i]]);
	}
	if(bbj.is_gsv()) {
		// flip it back...
		bbj.genome.border.rname=right[0];
		bbj.genome.border.rpos=right[1];
	}
});
}

function toggle6()
{
// inside menu, show/hide scaffold display panel
var bait1=document.getElementById('bait6_1');
var bait2=document.getElementById('bait6_2');
document.getElementById('jumplstholder').style.display='none'; // always hide it
if(bait1.style.display=='block') {
	bait1.style.display='none';
	bait2.style.display='block';
	stripChild(menu.scfd_holder,0);
	menu.scfd_holder.appendChild(gflag.menu.bbj.genome.scaffold.overview.holder);
	scfd_cancelconfigure();
	placePanel(menu);
} else {
	bait1.style.display='block';
	bait2.style.display='none';
}
}

function app_splinter()
{
gflag.jump.type=3;
gflag.jump.positiondom=null;
show_jump_ui();
}
function menu_relocate_scfd(event)
{
/* called by clicking on location banner, show the relocate-scfd panel inside menu
see whether is trunk or splinter
*/
var tag=event.target.getAttribute('splinterTag');
var pos=absolutePosition(event.target);
menu_show(11, pos[0]-document.body.scrollLeft-230, pos[1]+event.target.clientHeight-document.body.scrollTop+10);
if(tag==null) {
	// trunk
	gflag.jump.type=1;
} else {
	// splinter
	gflag.menu.bbj=gflag.browser.splinters[tag];
	gflag.jump.type=2;
}
gflag.jump.positiondom=event.target;
show_jump_ui();
}
function show_jump_ui()
{
// show the jump ui in menu with context
document.getElementById('jumplstholder').style.display='none';
menu_shutup();
menu.relocatediv.style.display='block';
var spnc=document.getElementById('menu_splinternavigator');
var type=gflag.jump.type;
if(type==1) {
	// trunk jump
	spnc.style.display='none';
} else if(type==2) {
	// splinter jump
	spnc.style.display='block';
	var bbj=gflag.menu.bbj;
	spnc.splinterTag=bbj.splinterTag;
	// fake a navigator for splinter
	bbj.navigator={canvas:spnc,
		chrbarheight:14,
		rulerheight:0,
		hlspacing:2,
	};
	bbj.drawNavigator();
	bbj.navigator=null;
} else if(type==3) {
	// trunk splintering
	menu_show(11);
	spnc.style.display='none';
} else {
	fatalError('unknown gflag.jump.type');
}
document.getElementById('bait6_1').style.display='block';
document.getElementById('bait6_2').style.display='none';
}

Genome.prototype.addnewscaffold=function(lst)
{
for(var i=0; i<lst.length; i++) {
	if(lst[i] in this.scaffold.len)
		this.scaffold.current.push(lst[i])
}
this.scfdoverview_makepanel();
this.scfd_cancelconfigure();
var lastone=this.scaffold.current[this.scaffold.current.length-1];
this.border.rname=lastone;
this.border.rpos=this.scaffold.len[lastone];
}

Genome.prototype.scfdoverview_makepanel=function()
{
/* make overview panel 
by the content and order of scaffold.current
*/
var maxlen=0;
for(var i=0; i<this.scaffold.current.length; i++) {
	var c=this.scaffold.current[i];
	maxlen=Math.max(maxlen, this.scaffold.len[c]);
}
var table=this.scaffold.overview.holder;
if(table.firstChild)
	stripChild(table.firstChild,0);
this.scaffold.overview.trlst=[];
var sf=maxlen/this.scaffold.overview.maxw;
for(i=0; i<this.scaffold.current.length; i++) {
	var chr=this.scaffold.current[i];
	var w=Math.ceil(this.scaffold.len[chr]/sf);
	var tr=this.scaffold.overview.holder.insertRow(-1);
	tr.style.backgroundColor='transparent';
	tr.chr=chr;
	var td=tr.insertCell(0);
	td.style.width=100;
	td.align='right';
	td.innerHTML='<div style="color:#b3b3b3;font-size:12px;">'+chr+'</div>'+
		'<div class=header_b style="margin-right:5px" onmousedown="scfd_movebutt_md(event)">'+chr+'</div>'+
		'<span class=header_r onclick="scfd_hidebutt_click(event)">&#10005;</span>';
	var c=document.createElement('canvas');
	c.chr=chr;
	c.width=w+1;
	c.height=this.scaffold.overview.barheight+1;
	c.className='opacity5';
	c.addEventListener('mousemove', scfdoverview_Hmove, false);
	c.addEventListener('mouseout', pica_hide, false);
	c.addEventListener('mousedown', scfdoverview_zoomin_Md, false);
	drawIdeogramSegment_simple(
		this.getcytoband4region2plot(chr, 0, this.scaffold.len[chr], w),
		c.getContext('2d'), 0, 0, w, ideoHeight, false);
	td=tr.insertCell(-1);
	td.appendChild(c);
	this.scaffold.overview.pwidth[c]=w;
	this.scaffold.overview.trlst.push(tr);
}
this.scaffold.overview.sf=sf;
// last row for items not in .current and can be added
var addlst=[];
for(var n in this.scaffold.len) {
	if(!thinginlist(n, this.scaffold.current)) addlst.push(n);
}
if(addlst.length>0) {
	var tr=table.insertRow(-1);
	var td=tr.insertCell(0);
	td.colSpan=2;
	div=document.createElement('div');
	div.innerHTML=addlst.length+' additional items available';
	div.className='gplot_header_clb';
	div.style.fontSize='12px';
	div.style.padding=4;
	div.addEventListener('click', toggle2, false);
	td.appendChild(div);
	div=document.createElement('div');
	div.style.display='none';
	td.appendChild(div);
	var d2=document.createElement('div');
	d2.style.width=100+this.scaffold.overview.maxw;
	div.appendChild(d2);
	for(i=0; i<addlst.length; i++) {
		var ent=document.createElement('span');
		ent.className='header_g';
		ent.style.display='inline-block';
		ent.style.margin=2;
		ent.innerHTML=addlst[i];
		ent.chr=addlst[i];
		ent.addEventListener('click', scfd_toadd_entryclick, false);
		d2.appendChild(ent);
	}
	this.scaffold.overview.newtr=tr;
}
/* over */
}

function toggle2(event) {
	event.target.style.display='none';
	event.target.nextSibling.style.display='block';
}

function scfd_toadd_entryclick(event) {
// click an entry and add it to overview table, pending for submission
	var lst=gflag.menu.bbj.genome.scaffold.toadd;
	if(event.target.className=='header_g') {
		lst.push(event.target.chr);
		event.target.className='header_b';
	} else {
		for(var i=0; i<lst.length; i++) {
			if(lst[i]==event.target.chr) {
				lst.splice(i,1);break;
			}
		}
		event.target.className='header_g';
	}
}

function scfdoverview_Hmove(event)
{
var genome=gflag.menu.bbj.genome;
var pos=absolutePosition(event.target);
picasays.innerHTML=event.target.chr+', '+parseInt((event.clientX+document.body.scrollLeft-pos[0])*genome.scaffold.overview.sf);
pica_go(event.clientX,pos[1]+event.target.clientHeight);
}
function scfdoverview_zoomin_Md(event)
{
// press down
if(event.button != 0) return; // only process left click
event.preventDefault();
var pos = absolutePosition(event.target);
indicator.style.display = "block";
indicator.style.left = event.clientX + document.body.scrollLeft;
indicator.style.top = pos[1];
indicator.style.width = 0;
indicator.style.height = event.target.clientHeight;
gflag.navigator={
	bbj:gflag.menu.bbj,
	x:event.clientX+document.body.scrollLeft,
	xcurb:pos[0],
	chr:event.target.chr,
	canvas:event.target,
	};
document.body.addEventListener("mousemove", scfdoverview_zoomin_Mm, false);
document.body.addEventListener("mouseup", scfdoverview_zoomin_Mu, false);
}
function scfdoverview_zoomin_Mm(event)
{
var currx = event.clientX + document.body.scrollLeft;
var n=gflag.navigator;
if(currx > n.x) {
	if(currx < n.xcurb+n.canvas.width) {
		indicator.style.width = currx - n.x;
	}
} else {
	if(currx >= n.xcurb) {
		indicator.style.width = n.x - currx;
		indicator.style.left = currx;
	}
}
}
function scfdoverview_zoomin_Mu(event)
{
document.body.removeEventListener("mousemove", scfdoverview_zoomin_Mm, false);
document.body.removeEventListener("mouseup", scfdoverview_zoomin_Mu, false);
indicator.style.display = "none";
var n=gflag.navigator;
var x = parseInt(indicator.style.left)-n.xcurb; // relative to minichr canvas div
var w = parseInt(indicator.style.width);
if(w==0) return;
var coord1=parseInt(n.bbj.genome.scaffold.overview.sf*x);
var coord2=coord1+parseInt(n.bbj.genome.scaffold.overview.sf*w);
if(coord1>n.bbj.genome.scaffold.len[n.chr]) return;
coord2=Math.max(coord2, coord1+n.bbj.hmSpan/MAXbpwidth_bold);
if(coord2>n.bbj.genome.scaffold.len[n.chr]) return;
menu_hide();
if(gflag.jump.type==3) {
	// making splinter
	n.bbj.splinter(n.chr+' '+coord1+' '+coord2);
} else {
	// relocating
	n.bbj.cloak();
	n.bbj.ajaxX('imgAreaSelect=on&'+n.bbj.gftype_param()+'&startChr='+n.chr+'&startCoord='+coord1+'&stopChr='+n.chr+'&stopCoord='+coord2);
}
}

function scfd_invokeconfigure() {
// invoke scaffold configure UI
	if(gflag.menu.bbj.juxtaposition.type!=RM_genome) {
		print2console('Customizing scaffold sequences is only possible under genome mode, please quit juxtaposition/GeneSetView first.',2);
		return;
	}
	document.getElementById('scfd_foo').style.display='none';
	document.getElementById('scfd_bar').style.display='block';
	var ov=gflag.menu.bbj.genome.scaffold.overview;
	for(var i=0; i<ov.holder.firstChild.childNodes.length; i++) {
		// rows containing chromosome canvas contain two cell
		// need to escape ov.newtr which contain 1 cell
		var tr=ov.holder.firstChild.childNodes[i];
		if(tr.childNodes.length==2) {
			var lst=tr.firstChild.childNodes;
			lst[0].style.display='none';
			lst[1].style.display=lst[2].style.display='inline';
		}
	}
	if(ov.newtr) {
		ov.newtr.style.display='table-row';
		ov.newtr.firstChild.firstChild.style.display='block';
		ov.newtr.firstChild.childNodes[1].style.display='none';
	}
}
function scfd_cancelconfigure() {
// called by pushing button
	gflag.menu.bbj.genome.scfd_cancelconfigure();
}

Genome.prototype.scfd_cancelconfigure=function()
{
// cancel scaffold configure UI and reset everything
document.getElementById('scfd_foo').style.display='block';
document.getElementById('scfd_bar').style.display='none';
var ov=gflag.menu.bbj.genome.scaffold.overview;
var tbody=ov.holder.firstChild;
for(var i=0; i<ov.trlst.length; i++) {
	var tr=ov.trlst[i];
	tr.style.backgroundColor='transparent';
	tbody.appendChild(tr);
	var lst=tr.firstChild.childNodes;
	lst[0].style.display='block';
	lst[1].style.display=lst[2].style.display='none';
}
if(ov.newtr) {
	tbody.appendChild(ov.newtr);
	ov.newtr.style.display='none';
}
}
function scfd_movebutt_md(event) {
// must not use scaffold.current to determine idx
	event.preventDefault();
	var chr=event.target.parentNode.parentNode.chr;
	var lst=gflag.menu.bbj.genome.scaffold.overview.holder.firstChild.childNodes;
	for(var i=0; i<lst.length; i++) {
		if(lst[i].chr==chr) break;
	}
	event.target.className='header_g';
	gflag.menu.bbj.genome.scaffold.move={
		target:event.target,
		idx:i,
		total:lst.length,
		y:event.clientY};
	document.body.addEventListener('mousemove',scfd_movebutt_mm, false);
	document.body.addEventListener('mouseup',scfd_movebutt_mu, false);
}
function scfd_movebutt_mm(event) {
	var m=gflag.menu.bbj.genome.scaffold.move;
	var tbody=gflag.menu.bbj.genome.scaffold.overview.holder.firstChild;
	if(event.clientY<m.y) {
		if(m.idx==0) return;
		if(m.y-event.clientY>=20) {
			tbody.appendChild(tbody.childNodes[m.idx]);
			var lst=[];
			for(var i=m.idx-1; i<m.total-1; i++) lst.push(tbody.childNodes[i]);
			for(var i=0; i<lst.length; i++) tbody.appendChild(lst[i]);
			m.idx--;
			m.y=event.clientY;
		}
	} else if(event.clientY>m.y) {
		if(m.idx==m.total-1) return;
		if(event.clientY-m.y>=20) {
			tbody.appendChild(tbody.childNodes[m.idx+1]);
			var lst=[];
			for(var i=m.idx; i<m.total-1; i++) lst.push(tbody.childNodes[i]);
			for(var i=0; i<lst.length; i++) tbody.appendChild(lst[i]);
			m.idx++;
			m.y=event.clientY;
		}
	}
}
function scfd_movebutt_mu(event) {
	document.body.removeEventListener('mousemove',scfd_movebutt_mm, false);
	document.body.removeEventListener('mouseup',scfd_movebutt_mu, false);
	gflag.menu.bbj.genome.scaffold.move.target.className='header_b';
}
function scfd_hidebutt_click(event) {
	var tr=event.target.parentNode.parentNode;
	tr.style.backgroundColor=tr.style.backgroundColor=='transparent'?'#858585':'transparent';
}
function scfd_updateconfigure() {
	var newlst=[];
	var bbj=gflag.menu.bbj;
	var trlst=bbj.genome.scaffold.overview.holder.firstChild.childNodes;
	for(var i=0; i<trlst.length; i++) {
		if(trlst[i].style.backgroundColor=='transparent')
			newlst.push(trlst[i].chr);
	}
	newlst=newlst.concat(bbj.genome.scaffold.toadd);
	bbj.genome.scaffold.toadd=[];
	if(stringLstIsIdentical(newlst, bbj.genome.scaffold.current)) {
		scfd_cancelconfigure();
		return;
	}
	// now determine dsp
	var dspParam = '';
	if(bbj.dspBoundary.vstartr==bbj.dspBoundary.vstopr && thinginlist(bbj.regionLst[bbj.dspBoundary.vstartr][0], newlst)) {
		// very well, currently only showing single region and that region is still in use
		dspParam = '&'+bbj.displayedRegionParam();
	} else {
		var preservedRegions = [];
		var oldlookregion = [];
		for(i=bbj.dspBoundary.vstartr; i<=bbj.dspBoundary.vstopr; i++)
			oldlookregion.push(bbj.regionLst[i][0]);
		for(i=0; i<newlst.length; i++) {
			if(thinginlist(newlst[i], oldlookregion))
				preservedRegions.push(newlst[i]);
		}
		var dspSeq = null;
		if(preservedRegions.length > 0) {
			dspSeq = preservedRegions[0];
		} else {
			dspSeq = newlst[0];
		}
		// just use first sequence but need to make sure not to display too long region
		var totalLength = 0;
		for(i=0; i<newlst.length; i++)
			totalLength += bbj.genome.scaffold.len[newlst[i]];
		var allowed = parseInt(totalLength/3);
		if(allowed <= 80) {
			print2console("Sorry cannot carry out this operation, please try again by including more scaffold sequences", 2);
			return;
		}
		allowed = allowed>bbj.genome.scaffold.len[dspSeq] ? bbj.genome.scaffold.len[dspSeq] : allowed;
		dspParam = '&gftype=genome&startChr='+dspSeq+'&startCoord=0&stopChr='+dspSeq+'&stopCoord='+(allowed>10000?10000:allowed);
	}
	bbj.genome.scaffold.current=newlst;
	bbj.genome.scfdoverview_makepanel();
	scfd_cancelconfigure();
	// make some new param strings
	var tmp = [];
	for(i=0; i<newlst.length; i++) {
		tmp.push(newlst[i]);
		tmp.push(bbj.genome.scaffold.len[newlst[i]]);
	}
	bbj.ajaxX('scaffoldUpdate=on&scaffoldNames='+tmp.join(',')+',&scaffoldCount='+newlst.length+dspParam);
}
/*** __scaffold__ ends ***/


/*** __spread__ spreading info from genome to all browser objects  ***/

Genome.prototype.spread_custmdterm=function(termname)
{
/* skip splinters */
for(var n in horcrux) {
	var bbj=horcrux[n];
	if(bbj.splinterTag!=null) continue;
	if(bbj.genome.name!=this.name) continue;
	var opt = document.createElement('option');
	opt.value = termname;
	opt.innerHTML = termname;
	bbj.cfacet.md1.add(opt);
	opt = document.createElement('option');
	opt.value = termname;
	opt.innerHTML = termname;
	bbj.cfacet.md2.add(opt);
	gflag.tsp.bbj=bbj;
	simulateEvent(bbj.cfacet.md1,'change');
}
}

/*** __spread__ ends ***/





/*** __sess__ session ***/
function toggle12()
{
if(apps.session.style.display == "none") {
	cloakPage();
	panelFadein(apps.session, 100+document.body.scrollLeft, 100+document.body.scrollTop);
	menu_hide();
	gflag.sess.bbj=browser;
} else {
	pagecloak.style.display = "none";
	panelFadeout(apps.session);
}
}

Browser.prototype.saveStateParams=function()
{
/* collects client control directives that does not need to be processed by cgi
*/
// tracks on display, resides in ghm or outside?
var tkwhere=[]; // also carries tk order
for(i=0; i<this.tklst.length; i++) {
	var tk = this.tklst[i];
	tkwhere.push(tk.name+','+tk.where);
}
var directives=[];
if(tkwhere.length>0)
	directives.push('"trackwhere":"'+tkwhere.join(',')+'"');
var spt=[];
for(var tag in this.splinters) {
	var c=this.splinters[tag].getViewRangeCoord();
	spt.push(this.splinters[tag].regionLst[0][0]+':'+c[0]+'-'+c[1]);
}
if(spt.length>0)
	directives.push('"splinters":"'+spt.join(',')+'"');

// coordnote
if(this.notes.length>0) {
	var s=[];
	for(var i=0; i<this.notes.length; i++) {
		var n=this.notes[i];
		s.push(n.chrom+','+n.coord+','+escape(n.text));
	}
	directives.push('"coordnote":"'+s.join(',')+'"');
}


/* information on all custom tracks (name:[ft, label, url, native md, custmd])
note: this is all of them, which might not be on display */
var wlst = [];
for(var tn in this.genome.hmtk) {
	var obj = this.genome.hmtk[tn];
	if(!isCustom(obj.ft)) continue;
	var lst2=[]; // native md
	if(obj.md!=undefined) {
		for(var i=0; i<obj.md.length; i++)
			lst2.push('"'+obj.md[i]+'"');
	}
	var lst3 = []; // custom md
	if(obj.custmd!=undefined) {
		for(var attr in obj.custmd)
			lst3.push('"'+attr+'":"'+obj.custmd[attr]+'"');
	}
	wlst.push('"'+tn+'":{"name":"'+tn+'","ft":'+obj.ft+',"label":"'+obj.label+'","url":"'+obj.url+'","md":['+lst2.join(',')+'],"custmd":{'+lst3.join(',')+'}}');
}
var ssp_3='';
if(wlst.length>0) ssp_3 = '&customTrackAttr='+wlst.join(',');

// dsp status string
var ssp_4='&dspStat='+this.getDspStat().join(',');

// track rendering params (apart from qtc)
var ssp_5='';
lst=[];
for(var i=0; i<this.tklst.length; i++) {
	var tk=this.tklst[i];
	// TODO categorical
	if(isHmtk(tk.ft)) continue;
	var stylestr='"'+tk.name+'":{'+
		'"textcolor":"'+tk.qtc.textcolor+'",'+
		'"fontsize":"'+tk.qtc.fontsize+'",'+
		'"fontfamily":"'+tk.qtc.fontfamily+'",'+
		'"fontbold":'+tk.qtc.fontbold+','+
		'"bedcolor":"'+tk.qtc.bedcolor+'"';
	if(tk.ft==FT_lr_n||tk.ft==FT_lr_c) {
		stylestr+= ',"pcolor":"'+tk.qtc.pcolor+'","ncolor":"'+tk.qtc.ncolor+'",'+
			'"pcolorscore":'+tk.qtc.pcolorscore+',"ncolorscore":'+tk.qtc.ncolorscore+','+
			'"pfilterscore":'+tk.qtc.pfilterscore+',"nfilterscore":'+tk.qtc.nfilterscore;
	} else if(tk.ft==FT_sam_n||tk.ft==FT_sam_c) {
		stylestr+=',"forwardcolor":"'+tk.qtc.forwardcolor+'",'+
			'"reversecolor":"'+tk.qtc.reversecolor+'",'+
			'"mismatchcolor":"'+tk.qtc.mismatchcolor;
	}
	lst.push(stylestr+'}');
}
if(lst.length>0)
	ssp_5='&decorRenderingParams='+lst.join(',');

// custom metadata
var ssp_7='';
lst = [];
for(var attr in this.genome.custmdhash) {
	lst2 = [];
	var t=this.genome.custmdhash[attr];
	for(var i=0; i<t.length; i++)
		lst2.push('"'+t[i]+'"');
	lst.push('"'+attr+'":['+lst2.join(',')+']');
}
if(lst.length>0) ssp_7='&custmd='+lst.join(',');

// correlation
var ssp_6= '';
/*
if(correlation.inuse) {
	var tft = correlation.targetft;
	var where = correlation.where;
	ssp_6= "&corrStat="+tft+","+where+","+correlation.targetname;
}
*/

// mcm terms
var ssp_8='';
lst = [];
for(i=0; i<this.mcm.lst.length; i++) {
	lst.push('"'+this.mcm.lst[i][0]+'",'+this.mcm.lst[i][1]);
}
if(lst.length>0) ssp_8='&mdconshow='+lst.join(',');
// must be quoted as some name have &

// pairwise comparison
lst=[]; lst2=[];
var ssp_9= '';
/*
if(pwc.inuse) {
	for(i=0; i<pwc.gtn1.length; i++)
		lst.push('"'+pwc.gtn1[i]+'"');
	for(i=0; i<pwc.gtn2.length; i++)
		lst2.push('"'+pwc.gtn2[i]+'"');
	ssp_9= '&pairwisecomp=[['+lst.join(',')+'],['+lst2.join(',')+']]';
}
*/

// TODO htest

// qtc (but no bevs...)
lst = [];
lst.push('"htest":'+qtc2json(this.htest.qtc)+',');
lst.push('"pwc":'+qtc2json(this.pwc.qtc)+',');
//lst.push('"correlation":'+qtc2json(correlation.qtc)+',');
lst.push('"tracks":{');
for(i=0; i<this.tklst.length; i++) {
	lst.push('"'+this.tklst[i].name+'":'+qtc2json(this.tklst[i].qtc)+',');
}
lst.push('}');
var ssp_10 = '&qtc={'+lst.join('')+'}';

// gssparam, only for gsv
var ssp_11= '';
if(this.is_gsv()) {
	var g=this.genesetview;
	ssp_11= '&gssparam={'+
	'"gss_says":"'+g.gss_says_ghost+'",'+
	'"gss_opt":"'+g.gss_opt_ghost+'",'+
	'"gss_origin":"'+g.gss_origin_ghost+'",'+
	'"gss_up":"'+g.gss_up_ghost+'",'+
	'"gss_down":"'+g.gss_down_ghost+'"}';
}

// sticky notes from previous implementation
var ssp_12= "";
/* working but not in use
lst=[];
lst2=document.getElementsByClassName("stickynote"); // very bad idea
if(lst2.length > 0) {
	for(i=0; i<lst2.length; i++) {
		var thissn = lst2[i];
		var value = thissn.firstChild.value;
		if(value != "") {
			value = value.replace(/\|/g, "-verBar-");
			value = value.replace(/\n/g, "-newline-");
			lst.push(parseInt(thissn.style.left)+"|"+parseInt(thissn.style.top)+"|"+value);
		}
	}
	if(lst.length > 0)
		ssp_12= "&stickynote="+lst.join("|");
}
*/

return "&juxType="+this.juxtaposition.type+
	"&juxWhat="+this.juxtaposition.what+
	"&juxNote="+this.juxtaposition.note+
	trackParam(this.tklst)+
	(directives.length>0 ? '&clientCtrl='+directives.join(',') : '')+
	ssp_3+ssp_4+ssp_5+ssp_6+ssp_7+ssp_8+ssp_9+ssp_10+ssp_11+ssp_12+
	'&dataset='+this.genome.currentDatasets.join(',');
}

Browser.prototype.saveStatus=function()
{
/* save current status
cgi will allocate a new statusid for the saved entry
bbj will update with this statusid
*/
var note = document.getElementById('statusNote').value;
if(note.length>0 && note!='make a note')
	note = '&statusNote='+note;
if(note.length > 200)
	note = note.substr(0,200);
print2console("saving status...", 0);
this.ajax('saveStatus=on'+note+this.saveStateParams()+'&dbName='+this.genome.name,function(data){
	if(!('statusTicket' in data)) fatalError("jsonkey statusTicket missing");
	var bbj=horcrux[data.horcrux];
	bbj.statusId = data.statusTicket[0];
	var statusnote=data.statusTicket[1];
	var dspstr=data.statusTicket[2];
	addRow4newStatus(document.getElementById('statusHolder'), 
		bbj.statusId,
		statusnote,
		dspstr,
		bbj.tklst.length,
		bbj.juxtaposition.note, true);
	document.getElementById('statusNote').value = 'make a note';
	done();
});
}

Browser.prototype.retrieveSession=function()
{
/* current session ID will be replaced by the previous session
so need to update runtime tables...
handles urlparam and normal case
*/
var param;
if(gflag.urlparam.usingsession) {
	param = 'pastSession='+gflag.urlparam.hash.session+'&dbName='+this.genome.name;
} else {
	var s = document.getElementById('oldSessionId').value;
	if(s=='enter session ID') {
		print2console("Please enter session ID", 2);
		return;
	}
	param = 'updateRuntimetable=on&pastSession='+s+'&juxType='+this.juxtaposition.type+'&dbName='+this.genome.name;
}
print2console("retrieving status...", 0);
this.ajax(param, function(data) {
	var bbj=horcrux[data.horcrux];
	if(!('statusLst' in data)) fatalError("retrieveSession: statusLst missing");
	var v = data.statusLst;
	if(v.length==1) {
		// no status retrieve, empty session
		if(gflag.urlparam.usingsession) {
			oneshotDialog(1, 'No status retrieved with given session');
			gflag.urlparam.usingsession=false;
		} else {
			print2console('No status retrieved with given session', 2);
		}
		return;
	}
	/* first element is previous session
	each element: 
	0. status id
	1. note
	2. dsp string
	3. total track number
	4. juxtaposition note
	*/
	var holder = document.getElementById('statusHolder');
	stripChild(holder, 0);
	document.getElementById('oldSessionId').value = 'enter session ID';
	bbj.sessionId = v[0];
	document.getElementById('sessionId').innerHTML = bbj.sessionId;
	for(var i=1; i<v.length; i++) {
		addRow4newStatus(holder, v[i][0],v[i][1],v[i][2], v[i][3],v[i][4], true);
	}
	print2console((data.statusLst.length-1)+" retrieved", 0, false);
});
}

Browser.prototype.deleteStatus=function(event)
{
// remove <tr>
var stid=event.target.getAttribute('statusid');
document.getElementById('statusHolder').firstChild.removeChild(event.target.parentNode.parentNode);
this.ajax("deleteStatus="+stid+"&dbName="+this.genome.name, function(data){return;});
}

Browser.prototype.restoreStatus=function(stid)
{
/* browser.sessionId must be updated
*/

/* additional steps in case called by clicking an entry from oneshot panel
maybe sukn specific?
*/
floatingtoolbox.style.display='block';
apps.session.style.display=
pagecloak.style.display=
document.getElementById('oneshot').style.display='none';
document.getElementById('sessionId').innerHTML=this.sessionId;

this.statusId=stid;
this.cleanuphtmlholder();
this.cloak();
print2console("restoring status...", 0);
this.ajax('restoreStatus=on&dbName='+this.genome.name, function(data){
	var bbj=horcrux[data.horcrux];

	/*** follow strict order... ***/

	// as facet.md1/md2 has been cleared, refill again
	bbj.migratedatafromgenome();

	bbj.juxtaposition=data.juxtaposition;

	// current scaffold
    if(!('scaffoldOrder' in data)) fatalError("restoreStatus: scaffoldOrder missing");
	bbj.genome.scaffold.current=data.scaffoldOrder;
	bbj.genome.scfdoverview_makepanel();

	// dataset, hmtk
	if(data.dataset) {
		//if(!("dataset" in data)) fatalError("restoreStatus: dataset missing");
		bbj.genome.currentDatasets=data.dataset;
		bbj.genome.hmtk={};
		for(var tk in data.hmtkinfo)
			bbj.genome.hmtk[tk]=data.hmtkinfo[tk];
		bbj.genome.toggleDataset();
	}

	/*
	var voidcustomtrack;
	if('voidcustomtrack' in data) {
		voidcustomtrack = data['voidcustomtrack'];
		alert(voidcustomtrack);
	}
	*/

	/* md */
	if('custmd' in data) {
		bbj.genome.custmdhash = data.custmd;
		for(var attr in data.custmd) {
			bbj.genome.displayCustmdterm(attr);
		}
	}
	if('mdconshow' in data) {
		for(var i=0; i<data.mdconshow.length; i+=2)
			bbj.mcm.lst.push([data.mdconshow[i],data.mdconshow[i+1]]);
	}


	/* qtrack config */
	if(!('qtc' in data)) fatalError('restoreStatus: qtc missing');
	qtc_paramCopy(data.qtc.htest, bbj.htest.qtc);
	qtc_paramCopy(data.qtc.pwc, bbj.pwc.qtc);
	qtc_paramCopy(data.qtc.correlation, bbj.correlation.qtc);

	/* custom track */
	if('customTrackAttr' in data) {
		gflag.tsp.bbj=bbj;
		for(var name in data.customTrackAttr)
			registerCustomtrack(data.customTrackAttr[name])
	}

	/* pairwise comparison
	pwc.inuse = false;
	if('pairwisecomp' in data) {
		pwc.gtn1 = data['pairwisecomp'][0];
		pwc.gtn2 = data['pairwisecomp'][1];
		for(i=0; i<pwc.gtn1.length; i++) {
			pwc_assigngrp(pwc.gtn1[i], 1);
		}
		for(i=0; i<pwc.gtn2.length; i++) {
			pwc_assigngrp(pwc.gtn2[i], 2);
		}
		pwc.inuse = true;
		pwc_run();
	}
	if("correlation" in data) {
		correlation.inuse = true;
		correlation.targetft = data["correlation"][0];
		correlation.where = data["correlation"][1];
		correlation.targetname = data["correlation"][2];
		runCorrelation();
	}
	if(htest.inuse) ajaxHtest();
	*/

	if(bbj.is_gsv()) {
		if(!data.entireItemlist) fatalError('restoreStatus: entireItemlist missing');
		bbj.genesetview.lst=data.entireItemlist;
		if(!data.gsvflankinghash) fatalError('restoreStatus: gsvflankinghash missing');
		bbj.genesetview.flanking=data.gsvflankinghash;
		if('gssparam' in data)
			bbj.update_gssedit(data.gssparam);
		bbj.genesetSubmitted(data);
	}

	bbj.jsonDsp(data);
	bbj.jsonTrackdata(data);

	/* restore track position and order */
	if('trackwhere' in data) {
		var lst=data.trackwhere.split(',');
		var newlst=[];
		for(var i=0; i<lst.length; i+=2) {
			var o=bbj.findTrack(lst[i]);
			o.where=parseInt(lst[i+1]);
			newlst.push(o);
			if(isCustom(o.ft))
				bbj.genome.hmtk[lst[i]].showbutt.innerHTML='hide';
		}
		bbj.tklst=newlst;
		bbj.trackdom2holder();
	}
	/* restore track style
	can only render tracks after this is done
	*/
	if('decorRenderingParams' in data) {
		// this is only about "decors" that are on shown
		for(var name in data.decorRenderingParams) {
			var decp=data.decorRenderingParams[name];
			var obj=bbj.findTrack(name);
			for(var k in decp) 
				obj[k] = decp[k];
		}
	}
	if('tracks' in data.qtc) {
		// qtc of all the tracks that are on shown
		for(var name in data.qtc.tracks)
			qtc_paramCopy(data.qtc.tracks[name], bbj.findTrack(name).qtc);
	}

	/* restore coordnote before drawing ideogram */
	if('coordnote' in data) {
		var lst=data.coordnote.split(',');
		for(var i=0; i<lst.length; i+=3) {
			bbj.notes.push({chrom:lst[i],coord:parseInt(lst[i+1]),text:unescape(lst[i+2])});
		}
	}

	bbj.initiateMdcOnshowCanvas();
	bbj.prepareMcm();
	bbj.render_browser();
	bbj.generateTrackselectionLayout();

	print2console(data['alert'], 1);

	// sticky notes...
	if("stickynote" in data) {
		for(i=0; i<data["stickynote"].length; i++) {
			var sndata = data["stickynote"][i];
			var note = makestickynote();
		note.style.left = sndata[0];
		note.style.top = sndata[1];
		var tmpstring = sndata[2].replace(/-verBar-/g, "|");
		tmpstring = tmpstring.replace(/-newline-/g, "\n");
		note.firstChild.value = tmpstring;
		}
	}

	bbj.unveil();

	if('splinters' in data) {
		bbj.splinterFromcoordlst(data.splinters.split(','));
	}

	document.getElementById('oldSessionId').value=bbj.sessionId;
	bbj.retrieveSession();

	print2console("status restored", 1);
});
/* over */
}

function addRow4newStatus(holder, _statusId, _statusNote, dspstring, tkcount, juxWhat, showRemovebutt)
{
/* add a row in statusHolder for a status
called by:
saving a new status under session (where information will be gathered from objects)
retrieving statuses using a session ID, where all arguments will be supplied

global_browser
sukn only?

args:
- holder (table dom object)
- status id
- note
- dsp string
- # of track
- jux note
- boolean, if to show remove butt

if arguments 3,4,5 are missing, implies that it is saving current state
*/
var tr = holder.insertRow(-1);
tr.id = "stid"+_statusId; // global id, for delete status
// (1) note, also show status id in small font
var td = tr.insertCell(0);
//td.style.borderTop='solid 1px white';
td.align = 'right';
td.innerHTML = '<span class=header_g onclick="browser.restoreStatus('+_statusId+')">'+_statusNote+'</span><br><span style="color:#858585;font-size:10px;">id: '+_statusId+'</span>';
// (2) jux on what
td=tr.insertCell(-1);
td.innerHTML = 'viewing '+juxWhat;
//td.style.borderTop='solid 1px white';
// (3) dsp stat
td = tr.insertCell(-1);
td.innerHTML = dspstring;
td.style.color = '#858585';
//td.style.borderTop='solid 1px white';
// (4) # of tracks
td=tr.insertCell(-1);
td.innerHTML = tkcount==0 ? 'no track' : tkcount+' track'+(tkcount==1?'':'s');
//td.style.borderTop='solid 1px white';

// (5) removal icon
if(showRemovebutt) {
	td=tr.insertCell(-1);
	td.innerHTML = '<span statusid='+_statusId+' class=header_r onclick="browser.deleteStatus(event)" title="delete status">&#10005;</span>';
	//td.style.borderTop='solid 1px white';
}
}

/*** __sess__ ends ***/


/*** __splinter__ long range, splinter view in general ***/

Browser.prototype.newLongrangeview=function(tkname,c1, c2)
{
/* args
tkname: tk name, to be flipped into full mode
c1: [] current coordinate
c2: string, remote coordinate
*/
this.findTrack(tkname).mode=M_full;
bubbleHide();
this.splinter(c2[0]+':'+c2[1]+'-'+c2[2], c1);
}

Browser.prototype.splinter=function(splinterCoord, trunkCoord)
{
/* only to be called on trunk, not on any splinters
args:
1. coord where splinter will be landed, can be gene name
2. trunk coord can be null for not changing

Note: both trunk and new splinter need to fire ajax
but simultaneous calling can sometimes run into error with large # of tracks
so trunk.ajaxX first, then splinter
*/

bubble.style.display='none';

// max splinter width is 400
var splinterWidth=Math.min(parseInt(this.hmSpan/2),400);
this.hmSpan-=splinterWidth;

if(this.scalebar) {
	// move scale bar
	var s=this.scalebar;
	var newleft=this.hmSpan/2;
	s.slider.style.left = newleft;
	s.says.style.left = newleft - s.says.clientWidth - 3;
	s.arrow.style.left = newleft + s.slider.width - 6;
	scalebarbeam.style.left = newleft+this.leftColumnWidth;
}

gflag.splinter=[splinterWidth, splinterCoord];

// trunk ajax
if(trunkCoord!=undefined) {
	if(this.genome.parseCoordinate(trunkCoord)==null) {
		print2console('splinter: wrong input coordinate 2',2);
		return;
	}
	// relocate trunk to desired position
	var param=null;
	if(this.is_gsv()) {
		// find the item that contains that position
		for(var i=0; i<this.genesetview.lst.length; i++) {
			var r=this.genesetview.lst[i];
			if(r.chrom==trunkCoord[0] && (Math.max(r.start,trunkCoord[1])<Math.min(r.stop,trunkCoord[2]))) {
				param='itemlist=on'+gss_param(1)+'&startChr='+r.name+'&stopChr='+r.name+'&startCoord='+trunkCoord[1]+'&stopCoord='+trunkCoord[2];
				break;
			}
		}
		if(param==null)
			fatalError('ohhhhh no');
		this.ajaxX(param+'&imgAreaSelect=on');
	} else {
		this.ajaxX(this.gftype_param()+'&imgAreaSelect=on&startChr='+trunkCoord[0]+'&stopChr='+trunkCoord[0]+'&startCoord='+trunkCoord[1]+'&stopCoord='+trunkCoord[2]);
	}
} else {
	// preserve original position, shrink
	this.ajaxX(this.displayedRegionParam()+'&imgAreaSelect=on');
}
/*over*/
}

function splinter_zoomout(tag) {
	gflag.browser.splinters[tag].cgiZoomout(1,false);
}
function splinter_zoomin(tag) {
	gflag.browser.splinters[tag].cgiZoomin(2);
}
function splinter_pan(tag, direction) {
	gflag.browser.splinters[tag].arrowPan(direction,1);
}

function splinter_delete(tag)
{
var bbj=gflag.browser;
bbj.hmSpan+=bbj.splinters[tag].hmSpan;
// splinter has a custom enclosure...
bbj.splinterHolder.firstChild.firstChild.removeChild(bbj.splinters[tag].main.parentNode.parentNode.parentNode);
delete bbj.splinters[tag];
bbj.applyHmspan2holders();
bbj.ajaxX(bbj.displayedRegionParam()+'&imgAreaSelect=on');
}

Browser.prototype.splinterFromcoordlst=function(coordlst)
{
gflag.splinter_todolst=coordlst;
this.splinter(coordlst[0]);
gflag.splinter_todolst.splice(0,1);
}

/*** __splinter__ ends ***/




/*** __henge__ long range henge circlet wreath ***/

function toggle11()
{
if(hengeview.panel.style.display == 'none') {
	panelFadein(hengeview.panel, 100+document.body.scrollLeft, 100+document.body.scrollTop);
} else {
	panelFadeout(hengeview.panel);
}
}
function menu_circletview()
{
gflag.menu.bbj.hengeview_lrtk(gflag.menu.tklst[0].name);
menu_hide();
}

Browser.prototype.hengeview_lrtk=function(callingtkname)
{
/* make henge view for a longrange track
using the data under view
make a new panel (object) add to hengeview.hash

.regions is a fixed list, each is {}
.regionorder contains .regions array idx to point to which ones are shown and in what order

items are identified by *regions*
each region has name and coordinate
in case of plain chrhenge, name is chr name and coordinate is 0 to length
else in case of gsv, region corresponds to genes
*/
var callingtkobj=this.findTrack(callingtkname);
if(callingtkobj==null) return;
if(callingtkobj.ft!=FT_lr_c && callingtkobj.ft!=FT_lr_n) {
	print2console('hengeview: wrong track ft',2);
	return;
}

if(hengeview.panel.style.display=='none') toggle11();

var viewkey=Math.random().toString();
var viewobj = {
	key:viewkey,
	bbj:this,
	callingtk:{
		name:callingtkname,
		pcolor:colorstr2int(callingtkobj.qtc.pcolor).join(','),
		ncolor:colorstr2int(callingtkobj.qtc.ncolor).join(','),
		pscore:callingtkobj.qtc.pcolorscore,
		nscore:callingtkobj.qtc.ncolorscore,
	},
	ideogramwidth:14,
	showscalebar:true,
	radius:250,
	spacing:0.015, // radian spancing between adjacent regions in the henge
	wreath:[],
};

// before inserting new view, hide all previous views
var logocoloridx=1;
for(var k in hengeview.hash) {
	var o= hengeview.hash[k];
	o.main.style.display='none';
	hengeview.handleholder.appendChild(o.handle);
	hengeview.handleholder.style.display='table-cell';
	if(logocoloridx==o.logocoloridx)
		logocoloridx++;
}
hengeview.hash[viewkey]=viewobj;
viewobj.logocoloridx=logocoloridx;

// make view panel
var d = document.createElement('div');
d.style.display = 'table-cell';
viewobj.main = d;
hengeview.holder.appendChild(d);

// handle
d=document.createElement('div');
d.style.marginLeft=5;
d.style.display='inline-block';
d.style.backgroundColor=lightencolor(colorstr2int(colorCentral.longlst[logocoloridx]),.8);
d.style.border='solid 1px '+colorCentral.longlst[logocoloridx];
d.style.cursor='pointer';
d.style.boxShadow='1px 1px 1px #44566A';
d.style.mozBoxShadow='1px 1px 1px #44566A';
d.style.webkitBoxShadow='1px 1px 1px #44566A';
d.addEventListener('click', hengeview_show,false);
d.innerHTML='&nbsp;&nbsp;&nbsp;';
d.viewkey=viewkey;
viewobj.handle=d;

// banner
var table=document.createElement('table');
table.cellSpacing=0;
table.style.backgroundColor=lightencolor(colorstr2int(colorCentral.longlst[logocoloridx]),.8);
table.style.borderTop=table.style.borderBottom='solid 1px '+colorCentral.longlst[logocoloridx];
table.style.width='100%';
var tr=table.insertRow(0);
var td=tr.insertCell(0);
td.vAlign='middle';
td.style.fontSize='12px';
td.innerHTML='<span id=hengeview_'+viewkey+'></span> arcs from "'+this.genome.hmtk[callingtkname].label+'"';
td=tr.insertCell(1);
td.align='right';
td.innerHTML='<button type=button class=s viewkey='+viewkey+' onclick=menu_hengeview_configrender(event)>graph</button>'+
'<button type=button class=s viewkey='+viewkey+' onclick=menu_hengeview_configregions(event)>chrom</button>'+
'<button type=button class=s viewkey='+viewkey+' onclick=hengeview_invoketkselect(event)>addTrack</button>'+
'<button type=button class=s onclick=hengeview_hide("'+viewkey+'")>hide</button>'+
'<button type=button class=s onclick=hengeview_delete("'+viewkey+'")>delete</button>';
viewobj.buttonholder=td;
viewobj.main.appendChild(table);

/* main drawing canvas */
var canvas = document.createElement('canvas');
canvas.viewkey=viewkey;
canvas.addEventListener('click', hengeview_canvasclick,false);
canvas.addEventListener('mousemove',hengeview_tp_mmove,false);
canvas.addEventListener('mouseout',pica_hide,false);
canvas.addEventListener('mousedown',hengeview_canvas_md,false);
canvas.oncontextmenu=menu_hengeview;
viewobj.canvas = canvas;
viewobj.main.appendChild(canvas);
canvas.width=canvas.height=300;
	{
	var ctx=canvas.getContext('2d');
	ctx.fillStyle='#ccc';
	ctx.font='italic 30px Calibri';
	ctx.fillText('Requesting data',50,50);
	ctx.fillText('please wait...',50,90);
	}

/*** footer ***/
var footer = document.createElement('div');
footer.style.height=10;

viewobj.main.appendChild(footer);

/* issue ajax to query complete longrange track data
as the data in track object is dsp-filtered and incomplete
*/
this.ajax('hengekey='+viewkey+'&dbName='+this.genome.name+this.displayedRegionParam_narrow()+trackParam([callingtkobj]),function(data){
	var bbj=horcrux[data.horcrux];
	var viewobj=hengeview.hash[data.hengekey];

	/* sort out the data
	data are everything between dspBoundary.vstarts to .vstops
	*/
	var regions=[]; // {.name,.chrom,.bstart,.bstop,.dstart,.dstop,.onshow,.arcnum}
	//var sourceregions=[]; // ele: [chr,dstart,dstop] not in use
	var viewdata = []; // ele: [region1id,start1,stop1, region2id,start2,stop2, score]
	var rawdata=data.decorData[0].data;
	for(var i=bbj.dspBoundary.vstartr;i<=bbj.dspBoundary.vstopr;i++) {
		var start = i==bbj.dspBoundary.vstartr ? getPointCoord(bbj.regionLst, bbj.entire, i, bbj.dspBoundary.vstarts) : bbj.regionLst[i][3];
		var stop = i==bbj.dspBoundary.vstopr ? getPointCoord(bbj.regionLst, bbj.entire, i, bbj.dspBoundary.vstops) : bbj.regionLst[i][4];
		//sourceregions.push([bbj.regionLst[i][0],start,stop]);
		var data2=rawdata[i];
		var thischr=bbj.regionLst[i][0];
		var r1id=null;
		for(var j=0; j<regions.length; j++) {
			if(regions[j].chrom==thischr) {r1id=j;break;}
		}
		if(r1id==null) {
			r1id=regions.length;
			var s=bbj.genome.scaffold.len[thischr];
			regions.push({name:thischr,chrom:thischr,bstart:0,dstart:0,bstop:s,dstop:s,onshow:true,arcnum:0});
			// .onshow might be irrelevant
		}
		for(j=0; j<data2.length; j++) {
			var item=data2[j];
			if(item[8]>=stop || item[9]<=start) continue;
			var lst = item[3].split(',');
			var c=bbj.genome.parseCoordinate(lst[0]);
			if(c==null) continue;
			/** blasted alien chromosome: chr20 in GSE35519/mm9 on 2013/2/16
			but won't check if c[0] is in .scaffold.len to minimize load
			*/
			var r2id=null;
			for(var k=0; k<regions.length; k++) {
				if(regions[k].chrom==c[0]) {r2id=k;break;}
			}
			if(r2id==null) {
				r2id=regions.length;
				var s=bbj.genome.scaffold.len[c[0]];
				regions.push({name:c[0],chrom:c[0],bstart:0,dstart:0,bstop:s,dstop:s,onshow:true,arcnum:0});
			}
			viewdata.push([r1id,item[8],item[9], r2id,c[1],c[2], parseFloat(lst[1])]);
			// increment arc number
			regions[r1id].arcnum++;
			if(r1id!=r2id) regions[r2id].arcnum++;
		}
	}
	var order=[];
	for(i=0; i<regions.length; i++) order.push(i);

	viewobj.data=viewdata;
	viewobj.regions=regions;
	//viewobj.sourceregions=sourceregions;
	viewobj.regionorder=order;

	hengeview_computeRegionRadian(data.hengekey);
	hengeview_draw(data.hengekey);
});
/* over */
}

function hengeview_canvasxy2stuff(hvobj,x,y)
{
/* x/y are event.clientX/Y
to find the stuff under cursor
return an array: [identifier,   ]
identifiers:
	-1 exception
	0 outer space
	1 chr bar: region idx, data array idx
	2 wreath: regionidx, dataarray idx, wreath track idx
	3 arc: arc_data idx
	4 inside henge but not on arc
*/
var pos = absolutePosition(hvobj.canvas);
var x=x+document.body.scrollLeft-pos[0];
var y=y+document.body.scrollTop-pos[1];
var wreathheight=0;
for(var i=0;i<hvobj.wreath.length;i++)
	wreathheight+=hvobj.wreath[i].qtc.height;
// distance to center
var dc=Math.sqrt(Math.pow(hvobj.centerx-x,2)+Math.pow(hvobj.centery-y,2));
// outer space
if(dc>=hvobj.radius+3+hvobj.ideogramwidth/2+wreathheight) return [0];

if(dc>=hvobj.radius-hvobj.ideogramwidth/2) {
	/* over chromosome ideogram
	show region idx, data array idx, track name
	*/
	var xp=x-hvobj.centerx;
	var yp=y-hvobj.centery;
	var ra=Math.atan(Math.abs(yp)/Math.abs(xp));
	if(yp>0) {
		if(xp<0) ra=Math.PI-ra;
	} else {
		ra= xp>0 ? Math.PI*2-ra : Math.PI+ra;
	}
	// check which point
	var ridx=-1; // region idx
	var rradian=0; // radian within the region
	var order=hvobj.regionorder;
	var radianoffset=hvobj.regionradianoffset;
	for(i=0; i<order.length; i++) {
		ridx=order[i];
		if(ra>=radianoffset[ridx] && ra<=radianoffset[ridx]+hvobj.regionradianspan[ridx]) {
			rradian=ra-radianoffset[ridx];
			break;
		}
	}
	if(ridx==-1) return [-1];
	var didx=parseInt(hvobj.radius*rradian); // data array idx of that region
	if(dc>=hvobj.radius+3+hvobj.ideogramwidth/2) {
		// beyond chr bar
		if(hvobj.wreath.length>0) {
			// over wreath, see which track
			var h=0;
			dc-=hvobj.radius+3+hvobj.ideogramwidth/2;
			for(var j=0; j<hvobj.wreath.length; j++) {
				if(dc>=h && dc<=h+hvobj.wreath[j].qtc.height) {
					return [2, ridx, didx, j];
				}
				h+= hvobj.wreath[j].qtc.height;
			}
			return [-1];
		} else {
			// no wreath track
			return [0];
		}
	} else {
		// over chr bar
		return [1, ridx, didx];
	}
}
/* arc */
var arcdata = hvobj.arcdata;
for(var i=0; i<arcdata.length; i++) {
	var d = Math.sqrt(Math.pow(arcdata[i][0]-x,2)+Math.pow(arcdata[i][1]-y,2));
	if(d<=arcdata[i][2]+1 && d>=arcdata[i][2]-1) {
		return [3, i];
	}
}
return [4];
}

function menu_hengeview(event)
{
// right click on canvas
var hvobj = hengeview.hash[event.target.viewkey];
var stuff=hengeview_canvasxy2stuff(hvobj,event.clientX,event.clientY);
if(stuff[0]==-1) return;
/* if on chr, show config func for chrs
if on wreath, show config func for that track
else, show graph config
*/
menu_shutup();
menu.hengeviewoptions.style.display='block';
gflag.menu.viewkey=event.target.viewkey;
var c=menu.hengeviewoptions.firstChild;
if(stuff[0]==1) {
	// chr bar
	simulateEvent(hvobj.buttonholder.childNodes[1],'click');
	menu_show(15,event.clientX-10,event.clientY-10);
} else if(stuff[0]==2) {
	// one wreath track
	// wreath track array idx is stuff[3]
	var tkobj=hvobj.wreath[stuff[3]];
	var ft=tkobj.ft;
	if(ft==FT_cat_c||ft==FT_cat_n) {
		cateCfg_show(tkobj);
	} else {
		var isden=ft==FT_bed_n||ft==FT_bed_c;
		qtcpanel_setdisplay({qtc:tkobj.qtc,
		pcolor:true,
		ncolor:!isden,
		tkh:true,
		which:1,
		pcname:isden?'item density':'positive value',
		ncname:'negative value'});
		menu.c1.style.display='block';
		menu.c1.innerHTML='min: '+tkobj.min+' max: '+tkobj.max;
	}
	menu.c4.style.display='block';
	menu_show(19,event.clientX-10,event.clientY-10);
	gflag.menu.wreathIdx=stuff[3];
} else {
	// graph
	simulateEvent(hvobj.buttonholder.firstChild,'click');
	menu_show(15,event.clientX-10,event.clientY-10);
}
return false;
}

function hengeview_canvasclick(event)
{
/* clicking on the canvas
do not show bubble on wreath track for the moment
*/
var hvobj = hengeview.hash[event.target.viewkey];
var regions = hvobj.regions;
var stuff=hengeview_canvasxy2stuff(hvobj,event.clientX,event.clientY);
if(stuff[0]==-1 || stuff[0]==0 || stuff[0]==2 || stuff[0]==4) return;
var ridx=stuff[1];
bubble.style.display = "block";
bubble.style.left = event.clientX+document.body.scrollLeft-11;
bubble.style.top = event.clientY+document.body.scrollTop-3;
document.body.addEventListener("mousedown", bubbleHide, false);
bubble.sayajax.innerHTML = '';
bubble.sayajax.style.width = 'auto';
if(stuff[0]==1) {
	var a=regions[ridx].dstart+stuff[2]*hvobj.bpperpx;
	var coord= regions[ridx].chrom+':'+a+'-'+(a+hvobj.bpperpx);
	bubble.says.innerHTML='<div style="margin:10px;color:white;position:relative;">'+coord+
		'<br><button type=button onclick=\'hengeview.hash["'+hvobj.key+'"].bbj.splinter("'+coord+'")\'>focus over this region</button>';
	return;
}
// arcs
var data = hvobj.data;
var arcdata = hvobj.arcdata;
var item=data[arcdata[ridx][3]];
var c1=regions[item[0]].chrom+':'+item[1]+'-'+item[2];
var c2=regions[item[3]].chrom+':'+item[4]+'-'+item[5];
bubble.says.innerHTML='<div style="margin:10px;color:white;position:relative;">'+
	'Long range interaction occurs between the locations:<br>'+c1+
	' <button type=button onclick=\'hengeview.hash["'+hvobj.key+'"].bbj.splinter("'+c1+'")\'>focus</button><br>'+
	c2+' <button type=button onclick=\'hengeview.hash["'+hvobj.key+'"].bbj.splinter("'+c2+'")\'>focus</button><br>'+
	'score: '+item[6]+'</div>';
}
function hengeview_tp_mmove(event)
{
// pica over canvas
var hvobj = hengeview.hash[event.target.viewkey];
var stuff=hengeview_canvasxy2stuff(hvobj,event.clientX,event.clientY);
if(stuff[0]==-1||stuff[0]==0||stuff[0]==4) {
	pica.style.display='none';
	return;
}
var r=hvobj.regions[stuff[1]];
if(stuff[0]==1) {
	var a=r.dstart+parseInt(stuff[2]*hvobj.bpperpx);
	var chr=r.chrom;
	var clen=hvobj.bbj.genome.scaffold.len[chr];
	if(a>clen) return;
	pica_go(event.clientX,event.clientY);
	picasays.innerHTML=r.chrom+':'+a+'-'+Math.min(a+hvobj.bpperpx,clen);
	return;
}
if(stuff[0]==2) {
	var a=r.dstart+parseInt(stuff[2]*hvobj.bpperpx); // coord
	var chr=r.chrom;
	var clen=hvobj.bbj.genome.scaffold.len[chr];
	if(a>clen) return;
	var regioncoord=r.chrom+':'+a+'-'+Math.min(a+hvobj.bpperpx,clen); // coord string
	pica_go(event.clientX,event.clientY);
	var tk=hvobj.wreath[stuff[3]];
	var text='<div style="padding:5px;font-size:16px;color:white;">';
	if(tk.ft==FT_cat_c||tk.ft==FT_cat_n) {
		var v=tk.cateInfo[tk.data[r.name][stuff[2]]];
		text+='<div class=squarecell style="display:inline-block;background-color:'+v[1]+';"></div> '+v[0];
	} else {
		text+=tk.data[r.name][stuff[2]];
	}
	picasays.innerHTML=text+'<div style="padding-top:5px;font-size:12px;color:#c5d5d5;">'+tk.label+'<br>'+regioncoord+'</div>';
	return;
}
if(stuff[0]==3) {
	var data = hvobj.data;
	var arcdata = hvobj.arcdata;
	var item=data[arcdata[stuff[1]][3]];
	var c1=hvobj.regions[item[0]].chrom;
	var c2=hvobj.regions[item[3]].chrom;
	var text=(c1==c2)?'Interaction within '+c1:'Interaction between '+c1+' and '+c2;
	pica_go(event.clientX,event.clientY);
	picasays.innerHTML='<div style="padding:5px;font-size:14px;color:white;">'+text+'<br>score: '+item[6]+'</div>';
}
}


function hengeview_computeRegionRadian(vkey)
{
/* call this before making the first hengeview or regions are added/removed
changing radius won't affect the radian
this must be called prior to running ajax to fetch data for wreath track
*/
var hvobj=hengeview.hash[vkey];
if(hvobj==undefined) return;
var regions=hvobj.regions;
var regionorder=hvobj.regionorder;
/* these two arrays are addressed by .regions array index */
var showtotallen=0;
var shownum=0;
for(var i=0; i<regions.length; i++) {
	if(regionorder.indexOf(i)!=-1) {
		showtotallen+=regions[i].dstop-regions[i].dstart;
		shownum++;
	}
}
if(showtotallen==0) return;
hvobj.sf = (Math.PI*2-hvobj.spacing*shownum)/showtotallen; // radian per bp

hvobj.regionradianspan=[]; // radian spanned by each region
for(i=0; i<regions.length; i++) {
	/* FIXME about dummy value 0
	to keep .regionradianspan in same length as .region
	despite some regions might be hidden
	*/
	hvobj.regionradianspan[i] = (regionorder.indexOf(i)!=-1) ? hvobj.sf*(regions[i].dstop-regions[i].dstart) : 0;
}
hvobj.bpperpx=parseInt(showtotallen/((Math.PI*2-hvobj.spacing*shownum)*hvobj.radius));
}

function hengeview_draw(vkey)
{
var hvobj = hengeview.hash[vkey];
if(hvobj==undefined) return;
var regions = hvobj.regions;
var regionorder=hvobj.regionorder;
var pcolor = hvobj.callingtk.pcolor;
var ncolor = hvobj.callingtk.ncolor;
var pscore = hvobj.callingtk.pscore;
var nscore = hvobj.callingtk.nscore;
// draw main canvas
var canvas = hvobj.canvas;
ctx = canvas.getContext('2d');
var radius=hvobj.radius;
var ideogramWidth=hvobj.ideogramwidth;

// make a face if none of the regions are in use
var makeface=true;
if(hvobj.regionradianspan.length>0) {
	for(var i=0; i<regions.length; i++) {
		if(regionorder.indexOf(i)!=-1)
			makeface=false;
	}
}
if(makeface) {
	var c='#FFFFB3';
	canvas.width=30+radius*2;
	canvas.height=30+radius*2;
	var centerx = parseInt(canvas.width/2);
	var centery = centerx; 
	hvobj.centerx=centerx;
	hvobj.centery=centery;
	ctx.strokeStyle=c;
	ctx.lineWidth=radius/9;
	radius*=.7;
	ctx.beginPath(); ctx.arc(centerx,centery,radius,0,Math.PI*2,false); ctx.stroke();

	ctx.beginPath();
	var x=centerx+radius*Math.cos(Math.PI*1.07),y=centery+radius*Math.sin(Math.PI*1.07);ctx.moveTo(x,y);
	x=centerx+radius*Math.cos(Math.PI*1.93),y=centery+radius*Math.sin(Math.PI*1.93);
	ctx.lineTo(x+radius/2,y);ctx.stroke();

	radius*=.8;
	ctx.fillStyle=c;
	ctx.beginPath(); ctx.arc(centerx,centery,radius,Math.PI/9,Math.PI*8/9,false); ctx.fill();
	ctx.fillStyle='#FFFDEB';
	ctx.beginPath(); ctx.arc(centerx,centery,radius*.8,Math.PI/5,Math.PI*4/5,false); ctx.fill();

	ctx.lineWidth=10;
	var oldr=hvobj.radius;
	ctx.beginPath();ctx.arc(centerx-oldr*.3,centery+oldr/8,oldr/8,Math.PI*1.2,Math.PI*1.8,false);ctx.stroke();
	ctx.beginPath();ctx.arc(centerx+oldr*.3,centery+oldr/8,oldr/8,Math.PI*1.2,Math.PI*1.8,false);ctx.stroke();
	/*
	ctx.beginPath(); ctx.arc(centerx,centery,radius,0,Math.PI*2,false); ctx.stroke();
	ctx.beginPath(); ctx.arc(centerx,centery-radius,radius*1.5,Math.PI/2-0.4,Math.PI/2+0.4,false); ctx.stroke();
	ctx.fillStyle='white';
	ctx.fillRect(centerx-radius/2,centery-radius/3,25,25);
	ctx.fillRect(centerx+radius/2,centery-radius/3,25,25);
	*/
	hvobj.arcdata=[];
	return;
}

var sf=hvobj.sf;
var circlespacing=3; // spacing between circles
var labelheight=50; // radius increment by the labels
var wreathlst=hvobj.wreath;
var wreathheight=0; // sum of wreath track height
for(i=0; i<wreathlst.length; i++)
	wreathheight+=wreathlst[i].qtc.height;
if(wreathheight>0)
	wreathheight+=circlespacing;
canvas.width=(wreathheight+radius+labelheight+circlespacing)*2+ideogramWidth;
canvas.height=canvas.width+10;
var centerx = parseInt(canvas.width/2);
var centery = parseInt(canvas.height/2);
hvobj.centerx=centerx;
hvobj.centery=centery;

ctx.font = "10pt Sans-serif";

// draw curved ruler, will draw 3 segments
if(hvobj.showscalebar) {
	i=10; // bp
	while(i*sf < 0.5) i*=10;
	i/=10;
	var unitw=null;
	if(i==10) unitw='30 bp';
	else if(i==100) unitw='300 bp';
	else if(i==1000) unitw='3 kb';
	else if(i==10000) unitw='30 kb';
	else if(i==100000) unitw='300 kb';
	else if(i==1000000) unitw='3 mb';
	else if(i==10000000) unitw='30 mb';
	else if(i==100000000) unitw='300 mb';
	else if(i==1000000000) unitw='3 gb';
	if(unitw != null) {
		var r2=ideogramWidth/2+wreathheight+circlespacing+30; // radius increment
		ctx.strokeStyle=colorCentral.foreground;
		var j=i*sf;
		ctx.beginPath();
		ctx.arc(centerx,centery,radius+r2,Math.PI*1.5-j*1.5,Math.PI*1.5+j*1.5,false);
		// tick 1
		var x0=centerx+(radius+r2+4)*Math.cos(Math.PI*1.5-j*1.5);
		var y0=centery+(radius+r2+4)*Math.sin(Math.PI*1.5-j*1.5);
		ctx.moveTo(x0,y0);
		ctx.lineTo(centerx+(radius+r2)*Math.cos(Math.PI*1.5-j*1.5),centery+(radius+r2)*Math.sin(Math.PI*1.5-j*1.5));
		// tick 2
		ctx.moveTo(centerx+(radius+r2+4)*Math.cos(Math.PI*1.5-j*.5),centery+(radius+r2+4)*Math.sin(Math.PI*1.5-j*.5));
		ctx.lineTo(centerx+(radius+r2)*Math.cos(Math.PI*1.5-j*.5),centery+(radius+r2)*Math.sin(Math.PI*1.5-j*.5));
		// tick 3
		ctx.moveTo(centerx+(radius+r2+4)*Math.cos(Math.PI*1.5+j*.5),centery+(radius+r2+4)*Math.sin(Math.PI*1.5+j*.5));
		ctx.lineTo(centerx+(radius+r2)*Math.cos(Math.PI*1.5+j*.5),centery+(radius+r2)*Math.sin(Math.PI*1.5+j*.5));
		// tick 4
		var x1=centerx+(radius+r2+4)*Math.cos(Math.PI*1.5+j*1.5);
		var y1=centery+(radius+r2+4)*Math.sin(Math.PI*1.5+j*1.5);
		ctx.moveTo(x1,y1);
		ctx.lineTo(centerx+(radius+r2)*Math.cos(Math.PI*1.5+j*1.5),centery+(radius+r2)*Math.sin(Math.PI*1.5+j*1.5));
		ctx.stroke();
		ctx.fillText('0',x0-10,y0);
		ctx.fillText(unitw, x1+5,y1);
	}
}

// most inner circle: chr ideogram
var r=0; // cumulative radian offset
hvobj.regionradianoffset=[]; // radian offset of each region
for(i=0; i<regionorder.length; i++) {
	var ridx=regionorder[i];
	hvobj.regionradianoffset[ridx] = r;

	var rstartc=regions[ridx].dstart;
	var rstopc=regions[ridx].dstop;

	ctx.lineWidth=1;
	ctx.strokeStyle='#9E9E9E';
	ctx.beginPath();
	ctx.moveTo(centerx+(radius+ideogramWidth/2)*Math.cos(r),centery+(radius+ideogramWidth/2)*Math.sin(r));
	var x=centerx+(radius+ideogramWidth/2+circlespacing+wreathheight+10)*Math.cos(r);
	var y=centery+(radius+ideogramWidth/2+circlespacing+wreathheight+10)*Math.sin(r);
	ctx.lineTo(x,y);
	var rname=regions[ridx].name;
	var w=ctx.measureText(rname).width;
	if(r<=Math.PI/2) {
		ctx.lineTo(x+w,y);ctx.stroke();
		ctx.fillText(rname,x+1,y-2);
	} else if(r<=Math.PI) {
		ctx.lineTo(x-w,y);ctx.stroke();
		ctx.fillText(rname,x-w,y-2);
	} else if(r<=Math.PI*1.5) {
		ctx.lineTo(x-w,y);ctx.stroke();
		ctx.fillText(rname,x-w,y-2);
	} else {
		ctx.lineTo(x+w,y);ctx.stroke();
		ctx.fillText(rname,x+1,y-2);
	}

	ctx.lineWidth = ideogramWidth;

	{ // cytoband
	var c=hvobj.bbj.genome.cytoband;
	if(regions[ridx].chrom in c) {
		var bandlst=c[regions[ridx].chrom];
		for(var j=0; j<bandlst.length; j++) {
			var band = bandlst[j];
			if(band[0]>=rstopc) break;
			if(band[1]<=rstartc) continue;
			ctx.strokeStyle = band[2]<0 ? centromereColor : 'rgb('+cytoBandColor[band[2]]+','+cytoBandColor[band[2]]+','+cytoBandColor[band[2]]+')';
			ctx.beginPath(); 
			ctx.arc(centerx,centery,radius,r+(Math.max(band[0],rstartc)-rstartc)*sf,r+(Math.min(band[1],rstopc)-rstartc)*sf,false);
			ctx.stroke();
		}
	}
	}

	var rr=hvobj.regionradianspan[ridx]; // radian spanned by this region
	// region bar span encloser
	ctx.lineWidth = 1;
	ctx.strokeStyle = 'black';
	ctx.beginPath();ctx.arc(centerx,centery,radius+ideogramWidth/2,r,r+rr,false);ctx.stroke();
	ctx.beginPath();ctx.arc(centerx,centery,radius-ideogramWidth/2,r,r+rr,false);ctx.stroke();
	// region bar ends encloser
	ctx.beginPath();
	ctx.moveTo(centerx+(radius+ideogramWidth/2)*Math.cos(r),centery+(radius+ideogramWidth/2)*Math.sin(r));
	ctx.lineTo(centerx+(radius-ideogramWidth/2)*Math.cos(r),centery+(radius-ideogramWidth/2)*Math.sin(r));
	ctx.moveTo(centerx+(radius+ideogramWidth/2)*Math.cos(r+rr),centery+(radius+ideogramWidth/2)*Math.sin(r+rr));
	ctx.lineTo(centerx+(radius-ideogramWidth/2)*Math.cos(r+rr),centery+(radius-ideogramWidth/2)*Math.sin(r+rr));
	ctx.stroke();

	r+=rr+hvobj.spacing;
}

/* draw interaction arcs */
var arcdata = [];
for(i=0; i<hvobj.data.length; i++) {
	// r1id, start1,stop1, r2id, start2,stop2, score
	var item=hvobj.data[i];
	var r1id=item[0];
	var r2id=item[3];
	if(regionorder.indexOf(r1id)==-1 || regionorder.indexOf(r2id)==-1) continue;
	ctx.strokeStyle = item[6]>0 ? 'rgba('+pcolor+','+((item[6]>=pscore)?1:(item[6]/pscore).toFixed(3))+')' : 
			'rgba('+ncolor+','+((item[6]<=nscore)?1:(item[6]/nscore).toFixed(3))+')';
	// arc start point
	var r1 = hvobj.regionradianoffset[r1id]+(item[1]-regions[r1id].dstart)*sf;
	var x1=centerx+(radius-ideogramWidth/2)*Math.cos(r1);
	var y1=centery+(radius-ideogramWidth/2)*Math.sin(r1);
	// arc stop point
	var r2 = hvobj.regionradianoffset[r2id]+(item[4]-regions[r2id].dstart)*sf;
	var x2=centerx+(radius-ideogramWidth/2)*Math.cos(r2);
	var y2=centery+(radius-ideogramWidth/2)*Math.sin(r2);
	var dist = Math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
	// compute arc center
	var rdiff = Math.abs(r2-r1);
	if(rdiff == Math.PI) {
		ctx.beginPath();ctx.lineTo(x1,y1);ctx.lineTo(x2,y2);ctx.stroke();
	} else {
		// arc
		// radian of the center line between r1 and r2
		var r3 = rdiff/2+Math.min(r1,r2);
		// relative radian spanned between r1 and r2
		var rtrue=rdiff;
		if(rtrue>Math.PI) {
			rtrue=Math.PI*2-rdiff;
			r3+=Math.PI;
		if(r3>Math.PI*2) r3-=Math.PI*2;
		}
		// radian spanned by the arc
		var arc_radian = (Math.PI-rtrue)/2;
		var dist2 = (dist/2)/Math.tan(arc_radian/2); // incremental distance from circle radius
		// incremented circle radius
		var radius2 = dist2+Math.sqrt(Math.pow(radius-ideogramWidth/2,2)-Math.pow(dist/2,2));
		// arc center point
		var xc=centerx+radius2*Math.cos(r3);
		var yc=centery+radius2*Math.sin(r3);
		// radian of arc's center line
		var r5 = r3>Math.PI ? r3-Math.PI : r3+Math.PI;
		ctx.beginPath();
		var arcradius=Math.sqrt(dist*dist/4+dist2*dist2);
		ctx.arc(xc,yc,arcradius,r5-arc_radian/2,r5+arc_radian/2,false);
		ctx.stroke();

		// store arc data
		arcdata.push([xc,yc,arcradius,i]);
	}
}
hvobj.arcdata = arcdata;
document.getElementById('hengeview_'+hvobj.key).innerHTML=arcdata.length;

/* plot wreath tracks */
// all tracks have same amount of data points, so radian of each point is same
if(wreathlst.length>0) {
	var pointnum=0;
	for(var n in wreathlst[0].data)
		pointnum+=wreathlst[0].data[n].length;
	var pointradian=(Math.PI*2-hvobj.regionorder.length*hvobj.spacing)/pointnum;
	var radiusbase=radius+ideogramWidth/2+circlespacing;
	// for each wreath track
	for(i=0; i<wreathlst.length; i++) {
		var wtk=wreathlst[i];
		var tkh=wtk.qtc.height;
		if(wtk.ft==FT_cat_c||wtk.ft==FT_cat_n) {
			var r=0; // radian offset
			for(var j=0; j<regionorder.length; j++) {
				var ridx=regionorder[j];
				var wdata=wtk.data[regions[ridx].name];
				for(var k=0; k<wdata.length; k++) {
					ctx.strokeStyle=wtk.cateInfo[wdata[k]][1];
					ctx.lineWidth=tkh;
					ctx.beginPath();
					ctx.arc(centerx,centery,
						radiusbase+tkh/2,
						r+k*pointradian, r+(k+1)*pointradian,false);
					ctx.stroke();
				}
				r+=hvobj.spacing+hvobj.regionradianspan[ridx];
			}
		} else {
			// must be numerical
			// figure out max/min of this track
			var max=0,min=0;
			for(var n in wtk.data) {
				var wdata=wtk.data[n];
				for(var k=0; k<wdata.length; k++) {
					if(wdata[k]>max) max=wdata[k];
					else if(wdata[k]<min) min=wdata[k];
				}
			}
			wtk.min=min;
			wtk.max=max;
			var baseline=(max>0 && min<0);
			var baselineh = baseline ? tkh*(0-min)/(max-min) : 0;
			var pcolor='rgb('+wtk.qtc.pr+','+wtk.qtc.pg+','+wtk.qtc.pb+')';
			var ncolor='rgb('+wtk.qtc.nr+','+wtk.qtc.ng+','+wtk.qtc.nb+')';
			// plot track
			var r=0; // radian offset
			for(var j=0; j<regionorder.length; j++) {
				// the json data is in same order as .regionorder, so must use j
				var ridx=regionorder[j];
				var wdata=wtk.data[regions[ridx].name];
				for(var k=0; k<wdata.length; k++) {
					if(baseline) {
						// use baseline
						if(wdata[k]>0) {
							var linewidth=Math.min(wdata[k],max)*(tkh-baselineh)/max;
							ctx.strokeStyle=pcolor;
							ctx.lineWidth=linewidth;
							ctx.beginPath();
							ctx.arc(centerx,centery,
							radiusbase+baselineh+linewidth/2,
							r+k*pointradian, r+(k+1)*pointradian,false);
							ctx.stroke();
						} else if(wdata[k]<0) {
							var linewidth=Math.max(wdata[k],min)*baselineh/min;
							ctx.strokeStyle=ncolor;
							ctx.lineWidth=linewidth;
							ctx.beginPath();
							ctx.arc(centerx,centery,
							radiusbase+(baselineh-linewidth/2),
							r+k*pointradian, r+(k+1)*pointradian,false);
							ctx.stroke();
						}
					} else {
						// no baseline
						if(min==0) {
							if(wdata[k]>0) {
								var linewidth=Math.min(wdata[k],max)*tkh/max;
								ctx.strokeStyle=pcolor;
								ctx.lineWidth=linewidth;
								ctx.beginPath();
								ctx.arc(centerx,centery,
									radiusbase+linewidth/2,
									r+k*pointradian, r+(k+1)*pointradian,false);
								ctx.stroke();
							}
						} else {
							if(wdata[k]<0) {
								var linewidth=Math.max(wdata[k],min)*tkh/min;
								ctx.strokeStyle=ncolor;
								ctx.lineWidth=linewidth;
								ctx.beginPath();
								ctx.arc(centerx,centery,
									radiusbase+tkh-linewidth/2,
									r+k*pointradian, r+(k+1)*pointradian,false);
								ctx.stroke();
							}
						}
					}
				}
				r+=hvobj.spacing+hvobj.regionradianspan[ridx];
			}
		}
		radiusbase += tkh;
	}
}
/* highlight region within the dsp, from which all the arcs originates
ctx.strokeStyle='rgba(255,255,0,0.5)';
ctx.lineWidth=ideogramWidth;
for(i=0; i<dataobj.sourceregions.length; i++) {
	var s=dataobj.sourceregions[i];
	for(var j=0; j<regions.length; j++) {
		if(regions[j][1]==s[0] && s[1]>=regions[j][2] && s[2]<=regions[j][3]) {
			ctx.beginPath();
			ctx.arc(centerx,centery,radius+1,
				dataobj.regionradianoffset[j]+(s[1]-regions[j][2])*sf,
				dataobj.regionradianoffset[j]+(s[2]-regions[j][2])*sf,
				false);
			ctx.stroke();
			break;
		}
	}
}
*/
ctx.fillStyle='#858585';
var w='Right click for options';
ctx.fillText(w, canvas.width-ctx.measureText(w).width-5,10);
if(wreathlst.length>=2) {
	ctx.fillText('Drag a track towards/away from center to reorder', 5,10);
}
/* over */
}

function hengeview_coordjump(vkey, coord)
{
hengeview.hash[vkey].bbj.cgiJump2coord(coord);
}

function hengeview_setradius(event)
{
// set hengeview graph size, called by changing <select>
if(event.target.selectedIndex==0) return;
var vkey=gflag.menu.viewkey;
hengeview.hash[vkey].radius = parseInt(event.target.options[event.target.selectedIndex].value);
hengeview_computeRegionRadian(vkey);
hengeview_ajaxupdatepanel(vkey);
}

function hengeview_ajaxupdatepanel(vkey)
{
/* update entire panel, called by:
- adding/removing region
- changing henge graph radius
no matter it has wreath tracks or not
*/
var hvobj=hengeview.hash[vkey];
hvobj.wreathajaxidx=-1; // -1 means all the wreath tracks
hengeview_ajaxwreath(hvobj, hvobj.wreath);
}

function hengeview_ajaxwreath(hvobj, _tklst)
{
/* called by updating entire panel
or adding wreath tracks
*/
// region spnum = region radian x henge radius
if(_tklst.length==0) {
	hengeview_draw(hvobj.key);
	return;
}
var regions=hvobj.regions;
var regionorder=hvobj.regionorder;
var regionparam=[];
for(var i=0; i<regionorder.length; i++) {
	var ridx=regionorder[i];
	var r=regions[ridx];
	regionparam.push(r.chrom+','+r.dstart+','+r.dstop+','+parseInt(hvobj.regionradianspan[ridx]*hvobj.radius));
}
if(regionparam.length==0) {
	hengeview_draw(vkey);
	return;
}
hengeview_cloak(hvobj.key);
hvobj.bbj.ajax('hengekey='+hvobj.key+'&longrangewreath=on&dbName='+hvobj.bbj.genome.name+'&regionlst='+regionparam.join(',')+trackParam(_tklst),function(data){
	var hvobj=hengeview.hash[data.hengekey];
	var _l=hvobj.regionorder.length;
	var wreath=hvobj.wreath;
	if(hvobj.wreathajaxidx==-1) {
		// fetched data for all tracks
		if(wreath.length!=data.data.length)
			fatalError('hengeview_ajaxwreath: wreath and data not same length');
		for(var i=0; i<wreath.length; i++) {
			for(var j=0; j<data.data.length; j++) {
				if(wreath[i].name==data.data[j].name) {
					wreath[i].data={};
					var _d=data.data[j].data;
					if(_l!=_d.length) fatalError('hengeview_ajaxwreath: _l!=_d.length');
					for(var k=0; k<_l; k++) {
						wreath[i].data[hvobj.regions[hvobj.regionorder[k]].name]=_d[k];
					}
					break;
				}
			}
		}
	} else {
		// fetched data for one track
		var _d=data.data[0].data;
		if(_d.length!=_l) fatalError('hengeview_ajaxwreath: _d.length != _l');
		for(var i=0; i<_l; i++) {
			wreath[wreath.length-1].data[hvobj.regions[hvobj.regionorder[i]].name]=_d[i];
		}
	}
	hengeview_draw(hvobj.key);
	pagecloak2.style.display='none';
});
/*over*/
}

function hengeview_chrbarsize(event)
{
if(event.target.selectedIndex==0) return;
var vkey=gflag.menu.viewkey;
hengeview.hash[vkey].ideogramwidth=parseInt(event.target.options[event.target.selectedIndex].value);
hengeview_draw(vkey);
}
function hengeview_showhidescale(event)
{
var vkey=gflag.menu.viewkey;
hengeview.hash[vkey].showscalebar=event.target.checked;
hengeview_draw(vkey);
}

function hengeview_updateregionorderfromMenu(vkey)
{
/* update .regionorder according to menu items
when a region is added/removed or the order was changed
*/
var neworder=[];
var lst=hengeview.hash[vkey].regions;
var lst2=document.getElementById('hengeview_chrholder').firstChild.childNodes;
for(i=0; i<lst2.length; i++) {
	if(lst2[i].firstChild.firstChild.checked) {
		for(var j=0; j<lst.length; j++) {
			if(lst[j].name==lst2[i].region) {
				neworder.push(j);
				break;
			}
		}
	}
}
hengeview.hash[vkey].regionorder=neworder;
}

function hengeview_addremoveregion(event)
{
// called by toggling checkbox of a chromosome
var vkey=gflag.menu.viewkey;
hengeview_updateregionorderfromMenu(vkey);
hengeview_computeRegionRadian(vkey);
hengeview_ajaxupdatepanel(vkey);
}

function hengeview_regiontoggleall(event)
{
var vkey=gflag.menu.viewkey;
var allon=event.target.getAttribute('turnon')=='1';
var lst = document.getElementById('hengeview_chrholder').firstChild.childNodes;
for(var i=0; i<lst.length; i++)
	lst[i].firstChild.firstChild.checked=allon;
hengeview_updateregionorderfromMenu(vkey);
hengeview_computeRegionRadian(vkey);
if(allon) {
	hengeview_ajaxupdatepanel(vkey);
} else {
	hengeview_draw(vkey);
}
}

function menu_hengeview_configrender(event)
{
gflag.menu.viewkey=event.target.getAttribute('viewkey');
var hvobj=hengeview.hash[gflag.menu.viewkey];
var pos=absolutePosition(event.target);
menu_shutup();
menu.tkcfg_bed.style.display=
menu.hengeviewoptions.style.display=
document.getElementById('stc_longrange_pcolorscore_div').style.display=
document.getElementById('stc_longrange_ncolorscore_div').style.display=
document.getElementById('stc_longrange').style.display='block';
document.getElementById('stc_bed').style.display=
document.getElementById('stc_sam').style.display=
document.getElementById('stc_font').style.display=
document.getElementById('longrange_pfilterscore_div').style.display=
document.getElementById('longrange_nfilterscore_div').style.display=
document.getElementById('stc_longrange_autoscale_div').style.display='none';

document.getElementById('stc_longrange_pcolorscore').value=hvobj.callingtk.pscore;
document.getElementById('stc_longrange_ncolorscore').value=hvobj.callingtk.nscore;

longrange_showplotcolor('rgb('+hvobj.callingtk.pcolor+')', 'rgb('+hvobj.callingtk.ncolor+')');
menu_show(15,pos[0]-document.body.scrollLeft-10,pos[1]-document.body.scrollTop+event.target.clientHeight);
var c=menu.hengeviewoptions.firstChild;
c.style.display='block';
c.nextSibling.style.display='none';
changeSelectByValue('hengeview_z_2',hvobj.radius.toString());
changeSelectByValue('hengeview_z_3',hvobj.ideogramwidth.toString());
document.getElementById('hengeview_z_1').checked=hvobj.showscalebar;
}

function menu_hengeview_configregions(event)
{
/* config .regions
will insert all regions on the fly for display and management
*/
gflag.menu.viewkey=event.target.getAttribute('viewkey');
var hvobj=hengeview.hash[gflag.menu.viewkey];
var pos=absolutePosition(event.target);
menu_shutup();
menu.hengeviewoptions.style.display='block';
menu_show(15,pos[0]-document.body.scrollLeft-10,pos[1]-document.body.scrollTop+event.target.clientHeight);
var c=menu.hengeviewoptions.firstChild;
c.style.display='none';
c.nextSibling.style.display='block';
var table=document.getElementById('hengeview_chrholder');
stripChild(table.firstChild,0);
var regions = hvobj.regions;
var regionorder = hvobj.regionorder;
for(var i=0; i<regionorder.length; i++) {
	var r=regions[regionorder[i]];
	var tr=table.insertRow(-1);
	tr.region=r.name;
	tr.insertCell(0).innerHTML='<input type=checkbox onchange=hengeview_addremoveregion(event) checked>';
	tr.insertCell(-1).innerHTML='<span class=header_b onmousedown=hengeview_itemreorder_Md(event)>'+r.name+'</span>';
	var td=tr.insertCell(-1);
	td.style.color='#858585';
	td.innerHTML=r.arcnum+' arcs';
}
// insert those that are not shown
for(i=0; i<regions.length; i++) {
	if(regionorder.indexOf(i)==-1) {
		var tr=table.insertRow(-1);
		tr.region=regions[i].name;
		tr.insertCell(0).innerHTML='<input type=checkbox onchange=hengeview_addremoveregion(event)>';
		tr.insertCell(-1).innerHTML='<span class=header_b onmousedown=hengeview_itemreorder_Md(event)>'+regions[i].name+'</span>';
		var td=tr.insertCell(-1);
		td.style.color='#858585';
		td.innerHTML=regions[i].arcnum+' arcs';
	}
}
}

function hengeview_invoketkselect(event)
{
/* called by clicking button in menu
a change of menu role occurs here
*/
gflag.menu.viewkey=event.target.getAttribute('viewkey');
menu_shutup();
var pos=absolutePosition(event.target);
menu_show(14,pos[0]-document.body.scrollLeft-10,pos[1]-document.body.scrollTop+event.target.clientHeight);
hengeview.hash[event.target.getAttribute('viewkey')].bbj.showcurrenttrack4select();
}

function hengeview_itemreorder_Md(event)
{
event.preventDefault();
var item=event.target.parentNode.parentNode.region;
var lst=document.getElementById('hengeview_chrholder').firstChild.childNodes;
for(var i=0; i<lst.length; i++) {
	if(lst[i].region==item) break;
}
if(i==lst.length) return;
event.target.className='header_g';
gflag.hvreorder={
	target:event.target,
	idx:i,
	total:lst.length,
	y:event.clientY};
document.body.addEventListener('mousemove', hengeview_itemreorder_Mm, false);
document.body.addEventListener('mouseup', hengeview_itemreorder_Mu, false);
}
function hengeview_itemreorder_Mm(event)
{
var m=gflag.hvreorder;
var tbody=document.getElementById('hengeview_chrholder').firstChild;
var moved=false;
var hvobj=hengeview.hash[gflag.menu.viewkey];
var roidx=hvobj.regionorder.indexOf(m.idx);
if(event.clientY<m.y) {
	if(m.idx==0) return;
	if(m.y-event.clientY>=20) { // up
		tbody.appendChild(tbody.childNodes[m.idx]);
		var lst=[];
		for(var i=m.idx-1; i<m.total-1; i++) lst.push(tbody.childNodes[i]);
		for(var i=0; i<lst.length; i++) tbody.appendChild(lst[i]);
		m.idx--;
		m.y=event.clientY;
		moved=true;
	}
} else if(event.clientY>m.y) { // down
	if(m.idx==m.total-1) return;
	if(event.clientY-m.y>=20) {
		tbody.appendChild(tbody.childNodes[m.idx+1]);
		var lst=[];
		for(var i=m.idx; i<m.total-1; i++) lst.push(tbody.childNodes[i]);
		for(var i=0; i<lst.length; i++) tbody.appendChild(lst[i]);
		m.idx++;
		m.y=event.clientY;
		moved=true;
	}
}
if(moved) {
	hengeview_updateregionorderfromMenu(gflag.menu.viewkey);
	hengeview_draw(gflag.menu.viewkey);
}
}
function hengeview_itemreorder_Mu(event)
{
document.body.removeEventListener('mousemove',hengeview_itemreorder_Mm, false);
document.body.removeEventListener('mouseup',hengeview_itemreorder_Mu, false);
gflag.hvreorder.target.className='header_b';
}

function hengeview_wreath_addone(vkey)
{
/* adding one single wreath track of any type
the track is always the last object in hvobj.wreath
issue ajax
*/
var hvobj=hengeview.hash[gflag.menu.viewkey];
if(hvobj.wreath.length==0) return;
var tkobj=hvobj.wreath[hvobj.wreath.length-1];
hvobj.wreathajaxidx=hvobj.wreath.length-1; // remember the track object index
hengeview_ajaxwreath(hvobj,[tkobj]);
}

function hengeview_cloak(vkey)
{
var c=hengeview.hash[vkey].canvas;
var pos=absolutePosition(c);
pagecloak2.style.display='block';
pagecloak2.style.left=pos[0];
pagecloak2.style.top=pos[1];
var w=c.width;
var h=c.height;
pagecloak2.style.width=w;
pagecloak2.style.height=h;
// roller
pagecloak2.firstChild.style.display='block';
pagecloak2.firstChild.style.marginTop = (h-128)/2;
pagecloak2.firstChild.style.marginLeft = (w-128)/2;
}

function hengeview_splinter(vkey, coord)
{
hengeview.hash[vkey].bbj.splinter(coord);
bubble.style.display='none';
}

function hengeview_hide(vkey)
{
var o=hengeview.hash[vkey];
hengeview.handleholder.style.display='table-cell';
hengeview.handleholder.appendChild(o.handle);
indicator4fly(o.main,o.handle,false);
o.main.style.display='none';
}

function hengeview_delete(vkey)
{
var o=hengeview.hash[vkey];
if(o.handle.parentNode!=undefined)
	hengeview.handleholder.removeChild(o.handle);
hengeview.holder.removeChild(o.main);
delete hengeview.hash[vkey];
}

function hengeview_show(event)
{
// clicking on a handle, show a cached view
var o=hengeview.hash[event.target.viewkey];
o.main.style.display='table-cell';
hengeview.holder.appendChild(o.main);
indicator4fly(o.handle,o.main,false);
hengeview.handleholder.removeChild(o.handle);
}

function hengeview_canvas_md(event)
{
/* mouse down on canvas
if pressing on wreath, will re-order a wreath track
if pressing on chr bar, TODO re-order chrom
*/
event.preventDefault();
var hvobj=hengeview.hash[event.target.viewkey];
var stuff=hengeview_canvasxy2stuff(hvobj,event.clientX,event.clientY);
if(stuff[0]==2) {
	var wlst=hvobj.wreath;
	if(wlst.length<=1) return;
	var tkname=hvobj.wreath[stuff[3]].name;
	for(var i=0; i<wlst.length; i++) {
		if(wlst[i].name==tkname) break;
	}
	if(i>=wlst.length) return;
	gflag.hvreorder={
		hvobj:hvobj,
		tkh:hvobj.wreath[i].qtc.height,
		idx:i};
	document.body.addEventListener('mousemove', hengeview_wreathreorder_Mm, false);
	document.body.addEventListener('mouseup', hengeview_wreathreorder_Mu, false);
}
}

function hengeview_wreathreorder_Mm(event)
{
var m=gflag.hvreorder;
var stuff=hengeview_canvasxy2stuff(m.hvobj,event.clientX,event.clientY);
if(stuff[0]!=2) return;
var newidx=stuff[3];
if(newidx==m.idx) return;
/* if the tk been moved has height smaller than neighbour
the hengeview_wreathreorder_Mm() must be terminated after the two are swapped
to prevent flashing
*/
var quitnow=m.hvobj.wreath[newidx].qtc.height>m.tkh;
if(newidx>m.idx) {
	// move away from center
	var tk=m.hvobj.wreath.splice(m.idx,1)[0];
	m.hvobj.wreath.splice(m.idx+1,0,tk);
	hengeview_draw(m.hvobj.key);
	if(quitnow) {
		hengeview_wreathreorder_Mu();
		return;
	} else {
		m.idx++;
	}
} else {
	// move track towards center
	var tk=m.hvobj.wreath.splice(m.idx,1)[0];
	m.hvobj.wreath.splice(m.idx-1,0,tk);
	hengeview_draw(m.hvobj.key);
	if(quitnow) {
		hengeview_wreathreorder_Mu();
		return;
	} else {
		m.idx--;
	}
}
}

function hengeview_wreathreorder_Mu()
{
document.body.removeEventListener('mousemove',hengeview_wreathreorder_Mm, false);
document.body.removeEventListener('mouseup',hengeview_wreathreorder_Mu, false);
}

/*** __henge__ ends ***/




/*** __bev__ ***/
function toggle18()
{
// bev panel
var bait = document.getElementById("bait18");
if(bait.style.display == "none") {
	var d=document.getElementById('bev_showholder');
	stripChild(d,0);
	d.appendChild(browser.genome.bev.main);
	cloakPage();
	panelFadein(bait, 100+document.body.scrollLeft, 100+document.body.scrollTop);
	menu_hide();
	gflag.bev.bbj=browser;
} else {
	pagecloak.style.display = "none";
	panelFadeout(bait);
}
}
Genome.prototype.bev_prepare=function()
{
/* compute chr drawing width, set canvas width
if canvas is missing, create
called by:
- initializing bev panel
- changing width
*/
var maxbplen = 0;
for(var i=0; i<this.bev.chrlst.length; i++)
	maxbplen=Math.max(this.scaffold.len[this.bev.chrlst[i][0]], maxbplen);
var maxlength = this.bev.config.maxpxwidth;
var sf = maxlength / maxbplen;
this.bev.sf=sf;
for(var i=0; i<this.bev.chrlst.length; i++) {
	var c=this.bev.chrlst[i];
	c[1]=Math.ceil(sf*this.scaffold.len[c[0]]);
	if(c[2]==null) {
		/* initialize this chr */
		c[2]=document.createElement('canvas');
		c[2].style.opacity=.5;
		c[2].chrom=c[0];
		c[2].addEventListener('mousedown', bev_zoomin_Md);
		var tr=this.bev.viewtable.insertRow(-1);
		var td=tr.insertCell(0);
		td.rowSpan=2;
		td.vAlign='bottom';
		td.align='right';
		td.style.paddingLeft=20;
		td.innerHTML=c[0]; // chr name
		td=tr.insertCell(1);
		c[3]=td; // tk canvas holder
		tr=this.bev.viewtable.insertRow(-1);
		td=tr.insertCell(0); // chr bar holder
		td.appendChild(c[2]);
	}
	c[2].width=c[1]+1;
	c[2].height=this.bev.config.chrbarheight;
}
}


Genome.prototype.bev_draw=function()
{
/* draw chrs and tracks, all
*/
this.bev_draw_chrs();
for(var i=0; i<this.bev.tklst.length; i++) {
	this.bev_draw_track(this.bev.tklst[i]);
	this.bev_trackcanvas2holder(this.bev.tklst[i]);
}
}

Genome.prototype.bev_trackcanvas2holder=function(tkobj)
{
var lst=this.bev.chrlst;
for(var i=0; i<lst.length; i++)
	lst[i][3].appendChild(tkobj.chrcanvas[lst[i][0]]);
}

Genome.prototype.bev_draw_chrs=function()
{
// draw chromosomes
for(var i=0; i<this.bev.chrlst.length; i++) {
	var c=this.bev.chrlst[i];
	drawIdeogramSegment_simple(
		this.getcytoband4region2plot(c[0], 0, this.scaffold.len[c[0]], c[1]),
		c[2].getContext('2d'),
		0, 0, c[1], this.bev.config.chrbarheight-1, false);
}
}

Genome.prototype.bev_draw_track=function(tkobj)
{
/* draw one track, data must be ready
track is different with browser track object
it has one canvas for each chr
in .chrcanvas, a hash
*/
if(tkobj.chrcanvas==undefined) {
	tkobj.chrcanvas={};
	for(var i=0; i<this.bev.chrlst.length; i++) {
		var c=document.createElement('canvas');
		c.style.display='block';
		c.addEventListener('mousemove',bev_tkcanvas_mmove,false);
		c.addEventListener('mouseout',pica_hide,false);
		c.addEventListener('mousedown',bev_zoomin_Md,false);
		c.oncontextmenu=menu_bevTrack;
		c.chrom=this.bev.chrlst[i][0];
		c.tkname=tkobj.name;
		tkobj.chrcanvas[c.chrom]=c;
	}
}
if(tkobj.ft==FT_cat_n||tkobj.ft==FT_cat_c) {
	for(var i=0; i<this.bev.chrlst.length; i++) {
		var citem=this.bev.chrlst[i];
		var canvas=tkobj.chrcanvas[citem[0]];
		canvas.width=citem[1];
		canvas.height=tkobj.qtc.height;
		categoricalTk_plot_base(tkobj.data[citem[0]], tkobj.cateInfo, 0, citem[1]-1, canvas.getContext('2d'), tkobj.qtc,
		0,0,1,canvas.height,false)
	}
	return;
}
// quantitiative data
// data is chr:[], gather into a nested array
var data=[];
for(var i=0; i<this.bev.chrlst.length; i++)
	data.push(tkobj.data[this.bev.chrlst[i][0]]);
// min max
var exvalue=qtrack_getthreshold(data, tkobj.qtc, 0, data.length-1, 0, data[data.length-1].length-1);
tkobj.max=exvalue[0];
tkobj.min=exvalue[1];

for(var i=0; i<this.bev.chrlst.length; i++) {
	var citem=this.bev.chrlst[i];
	var canvas=tkobj.chrcanvas[citem[0]];
	canvas.width=citem[1];
	canvas.height=tkobj.qtc.height;
	qtrack_plotwiggle_base(data[i], 0, data[i].length-1, canvas.getContext('2d'), tkobj.qtc, exvalue[0], exvalue[1], 
		0,0,1,tkobj.qtc.height,
		true, false);
}
}

Browser.prototype.bev_ajax=function(_tklst)
{
/* arg is optional, if missing, will update all tracks
only do ajax when there's track
*/
if(_tklst==undefined) {
	if(this.genome.bev.tklst.length==0) {
		this.genome.bev_draw();
		return;
	}
	_tklst=this.genome.bev.tklst;
}
var lst=this.genome.bev.chrlst;
var param=[];
for(var i=0; i<lst.length; i++)
	param.push(lst[i][0]+','+lst[i][1]+','+this.genome.scaffold.len[lst[i][0]]);

var d=document.getElementById('bait18');
var pos=absolutePosition(d);
pagecloak2.style.display='block';
pagecloak2.style.left=pos[0];
pagecloak2.style.top=pos[1];
var w=d.clientWidth;
var h=d.clientHeight;
pagecloak2.style.width=w;
pagecloak2.style.height=h;
// roller
pagecloak2.firstChild.style.display='block';
pagecloak2.firstChild.style.marginTop = (h-128)/2;
pagecloak2.firstChild.style.marginLeft = (w-128)/2;
this.ajax('birdseyeview=on&plotwidth='+param.join(',')+'&runtype=1&dbName='+this.genome.name+trackParam(_tklst),function(data){
	var bbj=horcrux[data.horcrux];
	var _tklst=bbj.genome.bev.tklst;
	for(var tkname in data.tkdata) {
		for(var i=0; i<_tklst.length; i++) {
			if(_tklst[i].name==tkname) {
				_tklst[i].data=data.tkdata[tkname];
				bbj.genome.bev_draw_track(_tklst[i]);
				break;
			}
		}
	}
	// in the case of resizing width, chr bar must be redrawn
	bbj.genome.bev_draw_chrs();
	for(var i=0; i<bbj.genome.bev.tklst.length; i++)
		bbj.genome.bev_trackcanvas2holder(bbj.genome.bev.tklst[i]);
	pagecloak2.style.display='none';
});
}

function bev_addtrack_invoketkselect(event) {
	menu_shutup();
	var pos=absolutePosition(event.target);
	menu_show(18,pos[0]-document.body.scrollLeft-10,pos[1]-5-document.body.scrollTop+event.target.clientHeight);
	gflag.bev.bbj.showcurrenttrack4select();
}

function bev_tkcanvas_mmove(event) {
var bev=gflag.bev.bbj.genome.bev;
for(var i=0; i<bev.tklst.length; i++) {
	var tk=bev.tklst[i];
	if(tk.name!=event.target.tkname) continue;

	var x=event.clientX+document.body.scrollLeft-absolutePosition(event.target)[0];

	var text='<div style="padding:5px;font-size:16px;color:white;">';
	if(tk.ft==FT_cat_n||tk.ft==FT_cat_c) {
		var v=tk.cateInfo[tk.data[event.target.chrom][x]];
		text+='<div class=squarecell style="display:inline-block;background-color:'+v[1]+';"></div> '+v[0];
	} else {
		// numerical
		text+=tk.data[event.target.chrom][x];
	}
	picasays.innerHTML=text+'<div style="padding-top:5px;font-size:12px;color:#c5d5d5;">'+tk.label+'<br>'+
		event.target.chrom+' '+parseInt(x/bev.sf)+'</div>';
	pica_go(event.clientX, event.clientY);
	return;
}
}

function menuBirdeyeview() {
// over a browser track
	gflag.menu.bbj.bev_mayaddtrack(gflag.menu.tklst[0].name);
	menu_hide();
}

function bev_zoomin_Md(event) {
/* pressing on canvas of chr bar, or any of the tracks
canvas must have .chrom for identification
*/
	if(event.button != 0) return;
	event.preventDefault();
	// whole holder of tracks belonging to this chr
	var bev=gflag.bev.bbj.genome.bev;
	var holder=null;
	for(var i=0; i<bev.chrlst.length; i++) {
		if(bev.chrlst[i][0]==event.target.chrom) {
			holder=bev.chrlst[i][3];
			break;
		}
	}
	if(holder==null) fatalError('bev_zoomin_Md: unknown chr name');
	var pos = absolutePosition(holder);
	indicator.style.display="block";
	indicator.style.left = event.clientX + document.body.scrollLeft;
	indicator.style.top = pos[1]-bev.viewtable.parentNode.scrollTop;
	indicator.style.width = 0;
	indicator.style.height = holder.clientHeight+bev.config.chrbarheight+4;
	gflag.zoomin={
		x:event.clientX+document.body.scrollLeft,
		xcurb:pos[0],
		chr:event.target.chrom,
		canvas:event.target,
		};
	document.body.addEventListener("mousemove", bev_zoomin_Mm, false);
	document.body.addEventListener("mouseup", bev_zoomin_Mu, false);
}

function bev_zoomin_Mm(event)
{
var currx = event.clientX + document.body.scrollLeft;
var n=gflag.zoomin;
if(currx > n.x) {
	if(currx < n.xcurb+n.canvas.width) {
		indicator.style.width = currx - n.x;
	}
} else {
	if(currx >= n.xcurb) {
		indicator.style.width = n.x - currx;
		indicator.style.left = currx;
	}
}
}

function bev_zoomin_Mu(event)
{
document.body.removeEventListener("mousemove", bev_zoomin_Mm, false);
document.body.removeEventListener("mouseup", bev_zoomin_Mu, false);
indicator.style.display = "none";
var bbj=gflag.bev.bbj;
if(bbj.is_gsv()){
	print2console('Cannot relocate when running Gene Set View',2);
	return;
}
var n=gflag.zoomin;
var x = parseInt(indicator.style.left)-n.xcurb; // relative to minichr canvas div
var w = parseInt(indicator.style.width);
if(w==0) return;
var coord1=x/bbj.genome.bev.sf;
var coord2=coord1+w/bbj.genome.bev.sf;
if(coord1>bbj.genome.scaffold.len[n.chr]) return;
coord2=Math.max(coord2, coord1+bbj.hmSpan/MAXbpwidth_bold);
if(coord2>bbj.genome.scaffold.len[n.chr]) return;
bbj.cloak();
bbj.ajaxX('imgAreaSelect=on&'+bbj.gftype_param()+'&startChr='+n.chr+'&startCoord='+coord1+'&stopChr='+n.chr+'&stopCoord='+coord2);
}

Browser.prototype.bev_mayaddtrack=function(tkname)
{
var lst=this.genome.bev.tklst;
for(var i=0; i<lst.length; i++) {
	if(lst[i].name==tkname) {
		// already there
		if(document.getElementById('bait18').style.display!='block')
			toggle18();
		return;
	}
}
var obj=this.findTrack(tkname);
var obj2=duplicateTkobj(obj);
obj2.qtc.height=(obj.ft==FT_cat_n||obj.ft==FT_cat_c)?15:30;
this.genome.bev.tklst.push(obj2);
if(document.getElementById('bait18').style.display=='block') {
	// add now
	this.bev_ajax([obj2]);
} else {
	toggle18();
	gflag.bev.bbj=this;
	setTimeout(bev_delayedTkadd,500);
}
}

function bev_delayedTkadd() {
/* delayed tk add for bev
gflag.bev.bbj must be set
add last track in .tklst
*/
var lst=gflag.bev.bbj.genome.bev.tklst;
if(lst.length==0) return;
gflag.bev.bbj.bev_ajax([lst[lst.length-1]]);
}

function menu_bevTrack(event)
{
// right click on a track in bev
var tkname=event.target.tkname;
var lst=gflag.menu.bbj.genome.bev.tklst;
for(var i=0; i<lst.length; i++) {
	if(lst[i].name!=tkname) continue;
	menu_shutup();
	var ft=lst[i].ft;
	if(ft==FT_cat_c||ft==FT_cat_n) {
		cateCfg_show(lst[i]);
	} else {
		var isden=ft==FT_bed_n||ft==FT_bed_c;
		qtcpanel_setdisplay({qtc:lst[i].qtc,
		pcolor:true,
		ncolor:!isden,
		scale:true,
		tkh:true,
		which:1,
		pcname:isden?'item density':'positive value',
		ncname:'negative value'});
		menu.c1.style.display='block';
		menu.c1.innerHTML='min: '+lst[i].min+' max: '+lst[i].max;
	}
	menu.c4.style.display='block';
	menu_show(20,event.clientX-10,event.clientY-10);
	gflag.menu.bevtkidx=i;
}
return false;
}

function bev_chrwidthselectmouseover(event)
{
picasays.innerHTML='Set plot width of longest chromosome to selected value<br>Width of shorter chromosomes will adjust accordingly<br>This also determines track data resolution';
var p=absolutePosition(event.target);
pica_go(p[0]-10-document.body.scrollLeft,p[1]+event.target.clientHeight-5-document.body.scrollTop);
}
function bev_setpanelheight(event)
{
var s=event.target;
gflag.bev.bbj.genome.bev.viewtable.parentNode.style.height=parseInt(s.options[s.selectedIndex].value);
}
function bev_setchrmaxwidth(event)
{
var bbj=gflag.bev.bbj;
bbj.genome.bev.config.maxpxwidth=parseInt(event.target.options[event.target.selectedIndex].value);
bbj.genome.bev_prepare();
bbj.bev_ajax(bbj.genome.bev.tklst);
}

/*** __bev__ ends ***/




/*** __svg__ ***/
function svgpanelhide()
{
pagecloak.style.display = "none";
panelFadeout(document.getElementById('bait33'));
}
function svgpanelshow(which)
{
cloakPage();
document.getElementById('bait33_1').style.display= // browser
document.getElementById('bait33_2').style.display= // bev?
document.getElementById('bait33_3').style.display='none'; // hengeview?
document.getElementById('bait33_'+which).style.display='table';
panelFadein(document.getElementById('bait33'),100+document.body.scrollLeft,100+document.body.scrollTop);
menu_hide();
}

Browser.prototype.svg_wiggle_main=function(data,x,y,h,squeeze)
{
/* data: [0] the actual data vector, as made by qtrack_plotwiggle()
             each ele: y, height, color of the bar!
         [1] max/min of the scale
x,y: plot start point
h: plot height
squeeze: boolean, true for hm, false for decor
*/
var cellwidth=this.entire.atbplevel?this.entire.bpwidth:1;
var arrstartoffset;
if(this.dspBoundary.lwr==this.dspBoundary.vstartr) {
	arrstartoffset=this.dspBoundary.vstarts-this.dspBoundary.lws;
} else {
	arrstartoffset=this.regionLst[this.dspBoundary.lwr][5]-this.dspBoundary.lws+this.dspBoundary.vstarts;
	for(var i=this.dspBoundary.lwr+1; i<this.dspBoundary.vstartr; i++) {
		arrstartoffset+=this.regionLst[i][5]+1;
	}
}
var arrlookwidth=this.entire.atbpleve?this.hmSpan/this.entire.bpwidth:this.hmSpan;
var lst=[];
var oldx=x;
for(var j=0; j<arrlookwidth; j++) {
	var it=data[0][j+arrstartoffset];
	if(it==undefined) break;
	if(it[3]) {
		// is region spacing
		lst.push('<rect x="'+x+'" y="'+y+'" width="'+regionSpacing.width+'" height="'+h+'" fill="'+regionSpacing.color+'"/>');
		x+=regionSpacing.width;
	} else {
		if(x-oldx>this.hmSpan) break;
		var w=Math.min(cellwidth,this.hmSpan-x+oldx);
		lst.push('<rect x="'+x+'" y="'+(y+it[0])+'" width="'+w+'" height="'+it[1]+'" fill="'+it[2]+'"/>');
		x+=w;
	}
}

// wiggle scale
y+=densitydecorpaddingtop;
var tick=4, padd=3, fontheight=8;
var c=colorCentral.foreground;
oldx+=5;
// top tick
lst.push('<line x1="'+oldx+'" y1="'+y+'" x2="'+(oldx+tick)+'" y2="'+y+'" stroke="'+c+'" stroke-width="1"/>');
// bottom tick
lst.push('<line x1="'+oldx+'" y1="'+(y+h)+'" x2="'+(oldx+tick)+'" y2="'+(y+h)+'" stroke="'+c+'" stroke-width="1"/>');
// vertical line
lst.push('<line x1="'+oldx+'" y1="'+y+'" x2="'+oldx+'" y2="'+(y+h)+'" stroke="'+c+'" stroke-width="1"/>');
// if to mark out zero
var topvalue=data[1][0], bottomvalue=data[1][1];
if((topvalue>0 && bottomvalue<0) || (topvalue<0 || bottomvalue>0)) {
	var h2=Math.abs(topvalue)*h/(Math.abs(topvalue)+Math.abs(bottomvalue));
	lst.push('<line x1="'+oldx+'" y1="'+(y+h2)+'" x2="'+(oldx+tick)+'" y2="'+(y+h2)+'" stroke="'+c+'" stroke-width="1"/>');
}
// labels
lst.push('<text font-size="10" font-family="arial" x="'+(oldx+tick+padd)+'" y="'+(y+fontheight-(squeeze?0:padd))+'" fill="'+c+'">'+(topvalue==0?0:topvalue.toFixed(2))+'</text>'+
'<text font-size="10" font-family="arial" x="'+(oldx+tick+padd)+'" y="'+(y+h+(squeeze?0:padd))+'" fill="'+c+'">'+(bottomvalue==0?0:bottomvalue.toFixed(2))+'</text>');
return lst.join('');
}

function makesvg_browserpanel_pushbutt(event)
{
/* called by pushing "generate graph" buttons
called with trunk browser, but not splinter
*/
event.target.disabled=true;
document.getElementById('svgfilelink_1').innerHTML='working...';

/* dimension of entire graph
for safety reason, tk label height is included for all tracks to estimate height
*/
var bbj=gflag.browser;
var gwidth=bbj.hmSpan+(tkAttrColumnWidth+1)*bbj.mcm.lst.length;
for(var k in bbj.splinters)
	gwidth+=bbj.splinters[k].hmSpan;
var gheight=bbj.main.clientHeight+bbj.tklst.length*svg_tklabelheight;
for(var k in bbj.splinters) {
	var s=bbj.splinters[k];
	gheight=Math.max(gheight,s.main.clientHeight+s.tklst.length*svg_tklabelheight);
}

/* graph size is now determined */

var content=['<svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="'+
	gwidth+'" height="'+gheight+'">'];

// some constants used only in svg output
var splinterspacing=4;

content=content.concat(bbj.makesvg_specific(0));
var offset=bbj.hmSpan;
for(var k in bbj.splinters) {
	var s=bbj.splinters[k];
	content=content.concat(s.makesvg_specific(offset));
	offset+=s.hmSpan+splinterspacing;
}
content.push('</svg>');

gflag.svg=1;
ajaxSvg(content.join(''),function(text){
	if(text=='ERROR') {
		print2console('Error sending the svg file to server, please try later or tell the admin.',2);
		return;
	}
	document.getElementById('svgbutt_'+gflag.svg).disabled=false;
	document.getElementById('svgfilelink_'+gflag.svg).innerHTML='<a href=t/'+text+'.svg target=_blank>Link to the svg file</a>';
});
}


Browser.prototype.makesvg_specific=function(xoffset)
{
/* to be called on a browser object, either trunk or splinter
*/
// global offset
var gx=xoffset;
var gy=0;
var msleft=this.move.styleLeft;

var content=[];

{ /* ruler on top */
	var data=this.drawRuler_browser(true);
	var rulerheight=this.rulercanvas.height;
	if(data.length>0) {
		for(var i=0; i<data.length; i++) {
			if(data[i][0]>-msleft && data[i][0]<this.hmSpan-msleft) {
				var x=data[i][0]+msleft;
				content.push('<line x1="'+(gx+x)+'" y1="'+gy+'" x2="'+(gx+x)+'" y2="'+(gy+rulerheight)+'" stroke="black" stroke-width="1"/>'+
			'<text font-size="10" font-family="arial" fill="black" x="'+(gx+x+3)+'" y="'+(gy+10)+'">'+data[i][1]+'</text>');
			}
		}
	}
	gy+=rulerheight;
}

/* metadata color map */
var mcm_y=gy; // mcm lower offset, used for drawing mcm vertical names and ideogram
for(var i=0; i<this.tklst.length; i++) {
	var tk=this.tklst[i];
	if(tk.where!=1) continue;
	mcm_y+=tk.canvas.height+((tk.mode==M_thin||tk.mode==M_full||tk.mode==M_arc||tk.mode==M_trihm)?svg_tklabelheight:0);
}

if(this.mcm!=null) {
	/* only plot for trunk, need to include width of splinters
	height: for non-numerical track will have a label
	*/
	var x=gx+this.hmSpan;
	for(var k in this.splinters) x+=this.splinters[k].hmSpan;

	var y=gy;
	for(var i=0; i<this.tklst.length; i++) {
		var tk=this.tklst[i];
		if(tk.where!=1) continue;
		var hh=tk.canvas.height+((tk.mode==M_thin||tk.mode==M_full||tk.mode==M_arc||tk.mode==M_trihm)?svg_tklabelheight:0);
		var data=this.drawMcm_onetrack(tk,true);
		for(var j=0; j<data.length; j++)
			content.push('<rect x="'+(x+(tkAttrColumnWidth+1)*j)+'" y="'+y+'" width="'+tkAttrColumnWidth+'" height="'+hh+'" fill="'+data[j]+'"/>');
		y+=hh;
	}
	// mcm vertical names on the bottom
	// a white blank to mask something...
	content.push('<rect x="'+x+'" y="'+mcm_y+'" width="'+(this.mcm.lst.length*(tkAttrColumnWidth+1))+'" height="300" fill="white"/>');
	for(var i=0; i<this.mcm.lst.length; i++) {
		var t=this.mcm.lst[i];
		var xx=x+(tkAttrColumnWidth+1)*i;
		content.push('<text font-size="12" font-family="arial" transform="rotate(90 0 0)" y="'+(0-xx-4)+
			'" x="'+mcm_y+'" fill="'+colorCentral.foreground+'">'+
			(t[1] ? t[0] : (t[0] in this.genome.mdvp2c ? t[0] : this.genome.mdvidx2attr[t[0]]))+'</text>');
	}
}

/* all the tracks
on plotting offset:
main panel plot starts at lwr,lws
and svg starts at vstartr,vstarts
the difference in between will be arrrstartoffset
*/
{
	var svgcellwidth=this.entire.atbplevel?this.entire.bpwidth:1;
	var arrstartoffset;
	if(this.dspBoundary.lwr==this.dspBoundary.vstartr) {
		arrstartoffset=this.dspBoundary.vstarts-this.dspBoundary.lws;
	} else {
		arrstartoffset=this.regionLst[this.dspBoundary.lwr][5]-this.dspBoundary.lws+this.dspBoundary.vstarts;
		for(var i=this.dspBoundary.lwr+1; i<this.dspBoundary.vstartr; i++)
			arrstartoffset+=this.regionLst[i][5]+1;
	}
	var arrlookwidth=this.hmSpan/svgcellwidth;
	// 
	var nlst=[];
	for(var i=0; i<this.hmdiv.childNodes.length; i++) nlst.push(this.hmdiv.childNodes[i].tkname);
	for(var i=0; i<this.decordiv.childNodes.length; i++) nlst.push(this.decordiv.childNodes[i].tkname);
	for(var i=0; i<nlst.length; i++) {
		var tk=this.findTrack(nlst[i]);
		var tkh=tk.canvas.height;

		// tracks outside ghm will have additional y offset
		var ggy=gy+(tk.where==2?this.ideogram.canvas.height:0);

		var data=this.drawTrack_browser(tk,true);

		if(isNumerical(tk) || (tk.ft==FT_cat_n||tk.ft==FT_cat_c)) {
			/* numerical or categorical */
			if('hm' in data) {
				// hm cells, [color,boolean] true if it is spacing
				var x=gx;
				for(var j=0; j<arrlookwidth; j++) {
					var it=data.hm[j+arrstartoffset];
					if(it==undefined) break;
					if(it[1]) {
						// is region spacing
						content.push('<rect x="'+x+'" y="'+ggy+'" width="'+regionSpacing.width+'" height="'+tkh+'" fill="'+it[0]+'"/>');
						x+=regionSpacing.width;
					} else {
						if(x>this.hmSpan+gx) break;
						var w=Math.min(svgcellwidth,this.hmSpan+gx-x);
						content.push('<rect x="'+x+'" y="'+ggy+'" width="'+w+'" height="'+tkh+'" fill="'+it[0]+'"/>');
						x+=w;
					}
				}
			} else {
				// wiggle
				content.push(this.svg_wiggle_main(data.wig,gx,ggy,tk.qtc.height,true));
				/* add track name on top, has to guess xpos
				TODO problem is densitydecorpaddingtop is too thin, and label overlaps with plot bars
				content.push('<text font-size="10" font-family="arial" x="'+(gx+110)+'" y="'+(ggy+10)+'">'+tk.label+'</text>');
				*/
			}
			gy+=tkh;
			continue;
		}
		// non-quantitative track, bed or longrange
		content.push('<text font-size="10" font-family="arial" x="'+(gx+10)+'" y="'+(ggy+12)+'">'+tk.label+'</text>');
		content.push('<line x1="'+gx+'" y1="'+(ggy+2)+'" x2="'+(gx+this.hmSpan)+'" y2="'+(ggy+2)+'" stroke="'+colorCentral.foregroundDim+'" stroke-width=".5"/>');
		ggy+=svg_tklabelheight;
		gy+=svg_tklabelheight;
		if(tk.mode==M_thin||tk.mode==M_full) {
			// bed and box
			for(var j=0; j<data.length; j++) {
				var it=data[j];
				switch(it[0]) {
				case 1: // box, including horizontal line
					// [, x,y,w,h,color]
					var x=it[1]+msleft;
					if(x>this.hmSpan) break;
					if(x+it[3]<0) break;
					var x2=x+it[3];
					if(x2>this.hmSpan) x2=this.hmSpan;
					if(x<0) x=0;
					var w=x2-x;
					content.push('<rect x="'+(x+gx)+'" y="'+(ggy+it[2])+'" width="'+w+'" height="'+it[4]+'" fill="'+it[5]+'"/>');
					break;
				case 2: // text
					// [, x,y,text,color]
					var x=it[1]+msleft;
					if(x>this.hmSpan) break;
					if(x<0) break;
					content.push('<text font-size="9" font-family="arial" x="'+(x+gx)+'" y="'+(ggy+it[2])+'" fill="'+it[4]+'">'+it[3]+'</text>');
					break;
				case 3: // >< strand
					// [,[x1,y1],[x2,y2],[x3,y3],color]
					if(it[1][0]+msleft<0) break;
					if(it[1][0]+msleft>this.hmSpan) break;
					content.push('<path d="M'+(gx+it[1][0]+msleft)+' '+(ggy+it[1][1])+
						' L'+(gx+it[2][0]+msleft)+' '+(ggy+it[2][1])+
						' L'+(gx+it[3][0]+msleft)+' '+(ggy+it[3][1])+
						'" stroke="'+it[4]+'" stroke-width="1" fill="transparent"/>');
					break;
				}
			}
		} else if(tk.mode==M_arc) {
			for(var j=0; j<data.length; j++) {
				// [radius, startx, stopx, color, arcwidth]
				var t=data[j];
				var x1=t[1]+msleft;
				var x2=t[2]+msleft;
				if(x1>this.hmSpan) continue;
				if(x2<0) continue;
				content.push('<path d="M'+(x1+gx)+' '+ggy+
				' A '+t[0]+' '+t[0]+' 1 0 0 '+(x2+gx)+' '+ggy+
				'" fill="transparent" stroke="'+t[3]+'" stroke-width="'+t[4]+'"/>');
			}
		} else if(tk.mode==M_trihm) {
			for(var j=0; j<data.length; j++) {
				var p1=data[j][0], p2=data[j][1], p3=data[j][2], p4=data[j][3];
				/*       p3
					 p4      p2
						 p1
				*/
				if(p4[0]+msleft>this.hmSpan) continue;
				if(p2[0]+msleft<0) continue;
				content.push('<path d="M'+(p1[0]+msleft+gx)+' '+(ggy+Math.max(0,p1[1]))+
				' L'+(p2[0]+msleft+gx)+' '+(ggy+Math.max(0,p2[1]))+
				' L'+(p3[0]+msleft+gx)+' '+(ggy+Math.max(0,p3[1]))+
				' L'+(p4[0]+msleft+gx)+' '+(ggy+Math.max(0,p4[1]))+
				' Z" fill="'+data[j][4]+'"/>');
			}
		} else {
			fatalError('makesvg: unknown tk mode '+tk.mode);
		}
		gy+=tkh; // never be qtc.height as this is not numerical
	}
}


/* chr ideogram below ghm */
{
	var h=this.ideogram.canvas.height;
	if(this.entire.atbplevel) {
		// filled blocks
		for(var i=0; i<gflag.chrideobarsvg[0].length; i++) {
			// x plot coord, color
			var it=gflag.chrideobarsvg[0][i];
			var x=it[0]+msleft;
			if(x<0) continue;
			if(x>this.hmSpan) break;
			content.push('<rect x="'+(gx+x)+'" y="'+mcm_y+'" width="'+Math.min(this.entire.bpwidth,this.hmSpan-x)+'" height="'+ideoHeight+'" fill="'+it[1]+'"/>');
		}
		// letters
		for(i=0; i<gflag.chrideobarsvg[1].length; i++) {
			// x plot coord, letter
			var it=gflag.chrideobarsvg[1][i];
			var x=it[0]+msleft;
			if(x<0) continue;
			if(x>this.hmSpan) break;
			content.push('<text font-size="14" font-family="arial" font-weight="bold" x="'+(x+gx)+'" y="'+(mcm_y+ideoHeight-2)+'" fill="white">'+it[1]+'</text>');
		}
	} else if(this.is_gsv()) {
		// gsv boxes with flanking and name
		var data=this.drawIdeogram_browser(true);
		// each item: [5 flank],[3 flank],[bigbox],[text]
		for(var i=0; i<data.length; i++) {
			var box=data[i][2];
			if(box[0]+box[2]+msleft<0) continue;
			if(box[0]+msleft>this.hmSpan) break;
			if(data[i][0]!=undefined) { // 5 flank
				var it=data[i][0];
				var x=it[0]+msleft;
				content.push('<rect x="'+(x+gx)+'" y="'+(it[1]+mcm_y)+'" width="'+Math.min(it[2],this.hmSpan-x)+'" height="'+it[3]+'" fill="'+this.genesetview.ideogram_fill5+'"/>');
			}
			if(data[i][1]!=undefined) { // 3 flank
				var it=data[i][1];
				var x=it[0]+msleft;
				content.push('<rect x="'+(x+gx)+'" y="'+(it[1]+mcm_y)+'" width="'+Math.min(it[2],this.hmSpan-x)+'" height="'+it[3]+'" fill="'+this.genesetview.ideogram_fill3+'"/>');
			}
			// bigbox
			var x=box[0]+msleft;
			content.push('<rect x="'+(x+gx)+'" y="'+(box[1]+mcm_y)+'" width="'+Math.min(box[2],this.hmSpan-x)+'" height="'+box[3]+'" fill="transparent" stroke="'+this.genesetview.ideogram_stroke+'" stroke-width="1"/>');
			// text
			var it=data[i][3];
			if(it!=undefined) {
				var x=it[0]+msleft;
				if(x<this.hmSpan)
					content.push('<text font-size="10" font-family="arial" x="'+(gx+x)+'" y="'+(it[1]+mcm_y+1)+'" fill="'+this.genesetview.ideogram_stroke+'">'+it[2]+'</text>');
			}
		}
	} else {
		// actual chr ideogram
		var data=this.drawIdeogram_browser(true);
		for(var i=0; i<data.length; i++) {
			// x,y,w,h,fill,stroke,textx,texty,text,textcolor
			var it=data[i];
			var x=it[0]+msleft;
			if(x+it[2]<0) continue;
			if(x>this.hmSpan) continue;
			if(x<0) x=0;
			content.push('<rect x="'+(x+gx)+'" y="'+(mcm_y+it[1])+'" width="'+Math.min(it[2],this.hmSpan-x)+'" height="'+it[3]+'" fill="'+it[4]+'" stroke="'+it[5]+'" stroke-width="1"/>');
			if(it[6]!=undefined) {
				x=it[6]+msleft;
				if(x<0) continue;
				if(x>this.hmSpan) continue;
				if(this.hmSpan-x<30) continue; // need to measure string length
				content.push('<text font-size="10" font-family="arial" x="'+(gx+x)+'" y="'+(mcm_y+it[7])+'" fill="'+it[9]+'">'+it[8]+'</text>');
			}
		}
	}
}


/* htest
if(htest.inuse) {
	content.push('<text font-size="10" font-family="arial" x="'+(gx+10)+'" y="'+(gy+12)+'">Hypothesis test P-values</text>');
	content.push('<line x1="'+gx+'" y1="'+(gy+2)+'" x2="'+(gx+hmSpan)+'" y2="'+(gy+2)+'" stroke="'+colorCentral.foregroundDim+'" stroke-width=".5"/>');
	gy+=svg_tklabelheight;
	var data=drawHtestCanvas(true);
	content.push(svg_wiggle_main(data,gx,gy,htest.qtc.height,false));
	if(data[2]!=null) {
		// draw cutoff line
		content.push('<line x1="'+gx+'" y1="'+(gy+data[2])+'" x2="'+(gx+hmSpan)+'" y2="'+(gy+data[2])+'" stroke="'+htest.qtc.pvccolor+'" stroke-width="1"/>');
	}
	gy+=htest.header.height;
}
*/

/* pwc
if(pwc.inuse) {
	content.push('<text font-size="10" font-family="arial" x="'+(gx+10)+'" y="'+(gy+12)+'">Pairwise comparison log ratio</text>');
	content.push('<line x1="'+gx+'" y1="'+(gy+2)+'" x2="'+(gx+hmSpan)+'" y2="'+(gy+2)+'" stroke="'+colorCentral.foregroundDim+'" stroke-width=".5"/>');
	gy+=svg_tklabelheight;
	var data=pwc_draw(true);
	content.push(svg_wiggle_main(data,gx,gy,pwc.qtc.height,false));
	gy+=pwc.header.height;
}
*/

return content;

}

/*** __svg__ ends ***/
